(*
%Copyright   (c) Polak Computer System
%Author      23.12.1997 14:49:10 GINA
%Purpose     ᮡ   ॢ
%Type        library
%Specific    LOC
%Modified    25.09.2014 13:40:20 LDA
%Environment
*)

 MODULE E_Way [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 PUBLIC CONST
  dtlRCD_RepairWithOutDriver = 250;

  dtlRCD_OutageWithOutDriver = 351;
  dtlRCD_OutageWithOutEngine = 352;
  dtlRCD_OutageWithOutTransm = 353;
  dtlRCD_OutageWithOutFrAxle = 354;
  dtlRCD_OutageWithOutBkAxle = 355;
  dtlRCD_OutageBreakDown     = 356;
  dtlRCD_OutageWithOutAccum  = 357;
  dtlRCD_OutageWithOutTyre   = 358;
  dtlRCD_OutageWithOutSpares = 359;

  re_TO1             = 01;
  re_TO2             = 02;
  re_rprEngine       = 03;
  re_rprTransm       = 04;
  re_rprFrontAxle    = 05;
  re_rprBackAxle     = 06;
  re_BreakDown       = 07;
  re_rprAccumulator  = 08;
  re_SeasonService   = 09;
  re_Repair          = 10;
  re_Overhaul        = 11;
  re_Repair_woDrv    = 12;
  re_rprTyre         = 13;
  re_OilReplace      = 14;
  re_Sinchronisation = 15;
  re_HMT_OilReplace  = 16; (* - ஬堭᪠ ।*)
  re_VTMStrapReplace = 17; (*valve timing mechanism,  *)
  re_Capsulation     = 18;
  re_Diagnostic1     = 19;
  re_Diagnostic2     = 20;
  re_Body            = 21;
  re_Diagnostic3     = 22;
  re_Diagnostic4     = 24;
  re_TO_R_X          = 25;
  re_TO_S            = 26;
  re_TO_X            = 27;
  re_TO_M            = 28;

  trawc_Msk = 0; (* TckRcS.AsWhoCnd = 稪  ᪢ *)
  trawc_Htk = 1; (* TckRcS.AsWhoCnd = 稪  쪮 *)
  trawc_Ctl = 2; (* TckRcS.AsWhoCnd = 稪 ஫묨 ⠬ *)

  mgt_BusOrGAZel = 200;

  markg_Bus   = 126;
  markg_GAZel = 127;

 IMPORT L_Way, L_DatTim, Str, L_BegRWS, L_General, L_Car, D_CarTb, Math, L_Str,
        L_BarCode, L_TRS, P_OwnData, L_OTx, L_XDoc, L_APWI;

 PUBLIC CONST
  ipc_Chopper_Msk = L_Way.ipc_UserDefined;
  ipc_Chopper_Htk = ipc_Chopper_Msk + 1;

  rwjp_GuardFctInc     = 00; (*窠  *)
  rwjp_CasFctInc       = 01; (*窠  *)
  rwjp_DriverFctInc    = 02; (*窠 ⥫*)
  rwjp_PsgFct          = 04; (*ᠦ*)
  rwjp_CasPsgFct       = 05; (*ᠦ  *)
  rwjp_Chopper_Msk     = 07; (*窠 1- 稪 (᪢)*)
  rwjp_Chopper_Htk     = 08; (*窠 2- 稪 (쪮)*)
  rwjp_TKPrepayment    = 09; (*ਥ । ⥫*)
  rwjp_GuardPrepayment = 10; (*ਥ । *)
  rwjp_SGuardFctInc    = 11; (*窠 ண *)
  rwjp_SGuardPsgFct    = 14; (*ᠦ ண *)
  rwjp_DriverAddTrip   = 16; (*⥫ ३ ⥫*)
  rwjp_GuardAddTrip    = 17; (*⥫ ३ *)
  rwjp_TermPassPlan    = 18; (*ନ ᠦ ()*)
  rwjp_MoscowTime      = 20; (*६  ᪢*)
  rwjp_OrdFctInc       = 40; (*窠  *)

  ipc_TermPlanDrv = L_Way.ipc_UserDefined + 2;
  ipc_TermPlanGrd = ipc_TermPlanDrv + 1;

  ipc_IncPlanLeftDrv = L_Way.ipc_UserDefined + 4; (* *)

 PUBLIC PROCEDURE MarkGT2GroupT(): LIKE(GroupT.GroupT);
  VAR
   Result: LIKE(GroupT.GroupT);
 BEGIN
  IF    MarkGT.MarkGT = mgt_BusOrGAZel THEN
   Result:=10;
  ELSE
   SETEMPTY(Result);
  END;
  RETURN Result;
 END {MarkGT2GroupT};

 PUBLIC PROCEDURE GetStandartPZVTotalTime(D: DATE; _Who: L_Way.tRWSWho): NUMERIC[3];
 BEGIN
  IF    _Who = L_Way.rwswho_Driver THEN
   RETURN 36/60;
  ELSIF _Who = L_Way.rwswho_Guard THEN
   RETURN 18/60;
  ELSIF _Who = L_Way.rwswho_Chopper THEN
   RETURN 18/60;
  ELSE
   RETURN 0;
  END;
 END {GetStandartPZVTotalTime};

 PUBLIC PROCEDURE GetPzvTotalTime(_Who: L_Way.tRWSWho): NUMERIC[3];
  VAR
   fbt : NUMERIC[3];
 BEGIN
  IF    _Who = L_Way.rwswho_Driver THEN
   IF (RWayS.Date >= 01\06\2004) &
      (Staff.TSN # RWayS.TSN) & ~L_Way.IsFirstWLMRec(0) THEN (*ன ⥫*)
    RETURN 0;
   END;
   RETURN GetStandartPZVTotalTime(RWayS.Date, _Who);
  ELSIF _Who = L_Way.rwswho_Guard THEN
   IF ~L_Way.E_IsGuardIdleExit(RWayS.Date, RWayS.Exit) THEN
    IF RWayS.Date >= 29\06\2003 THEN
     IF L_Way.IsFirstWLMRecByTckRcS() THEN
      RETURN GetStandartPZVTotalTime(RWayS.Date, _Who);
     ELSE
      RETURN 0;
     END;
    ELSE
     fbt:=L_Way.FullBegTime(WayLMen.Day, WayLMen.StartT);
     SAVE(WayLMen);
     CHANGESEL(WayLMen, TSN, , WayLMen.TSN, WayLMen.RWayDate);
     FIRST(WayLMen);
     WHILE OCCURE(WayLMen) DO
      fbt:=Math.Min(fbt, L_Way.FullBegTime(WayLMen.Day, WayLMen.StartT));
      NEXT(WayLMen);
     END; (* WHILE OCCURE(WayLMen) ... *)
     RESTORE(WayLMen);
     IF fbt # L_Way.FullBegTime(WayLMen.Day, WayLMen.StartT) THEN
      RETURN 0;
     END;
    END;
    RETURN GetStandartPZVTotalTime(RWayS.Date, _Who);
   ELSE
    RETURN 0;
   END;
  ELSIF _Who = L_Way.rwswho_Chopper THEN
   RETURN GetStandartPZVTotalTime(RWayS.Date, _Who);
  ELSE
   RETURN 0;
  END;
 END {GetPzvTotalTime};

 PUBLIC PROCEDURE BegRWSLev(D: DATE): L_Way.tBegRWSLev;
 BEGIN
  IF D >= 12\05\2003 THEN
   RETURN L_Way.brwsl_Active;
  ELSE
   RETURN L_Way.brwsl_NoBeg;
  END;
 END {BegRWSLev};

 PUBLIC PROCEDURE Fill_asRWayS(_Date: DATE): SCAL[2];
 BEGIN
  RETURN 0;
 END {Fill_asRWayS};

 PRIVATE PROCEDURE Who_Error(Who: L_Way.tRWSWho);
 BEGIN
  L_General.Error("E_WAY: ⨬ 祭 ''  ᮭ - " +
                  L_Str.PoolItem(L_Way.rwswho_Pool, Who));
 END {Who_Error};

 PUBLIC PROCEDURE GetIncRWJPName(Who: L_Way.tRWSWho; Idx: SCAL[5]): STRING[10];
 BEGIN
  IF    Who = L_Way.rwswho_Driver THEN
   RETURN L_Str.PoolItem("..|..|||ଏ", Idx);
  ELSIF Who = L_Way.rwswho_Guard THEN
   RETURN L_Str.PoolItem("||ଏ| | | ", Idx);
  ELSE
   Who_Error(Who);
  END;
 END {GetIncRWJPName};

 PUBLIC PROCEDURE GetIncRWJP(Who: L_Way.tRWSWho; _Number: LIKE(WayLMen.Number); Idx: NUMERIC[0]): LIKE(RWJPro.RWJPro);
 BEGIN
  IF    Who = L_Way.rwswho_Driver THEN
   IF    Idx = 00 THEN RETURN rwjp_DriverFctInc;
   ELSIF Idx = 01 THEN RETURN rwjp_GuardFctInc;
   ELSIF Idx = 11 THEN RETURN rwjp_SGuardFctInc;
   ELSIF Idx = 02 THEN RETURN rwjp_CasFctInc;
   ELSIF Idx = 03 THEN RETURN rwjp_Chopper_Msk;
   ELSIF Idx = 13 THEN RETURN rwjp_Chopper_Htk;
   ELSIF Idx = 04 THEN RETURN L_Way.GetVldPsgRWJPro(L_Way.vpk_OtherSocial,  Who, _Number);
   ELSIF Idx = 14 THEN RETURN L_Way.GetVldPsgRWJPro(L_Way.vpk_MoscowRegion, Who, _Number);
   ELSIF Idx = 24 THEN RETURN L_Way.GetVldPsgRWJPro(L_Way.vpk_Moscow,       Who, _Number);
   ELSIF Idx = 34 THEN RETURN L_Way.GetVldPsgRWJPro(L_Way.vpk_Paid,         Who, _Number);
   ELSE
    RETURN 99;
   END;
  ELSIF Who = L_Way.rwswho_Guard THEN
   IF    Idx = 00 THEN
    IF _Number = 1 THEN RETURN rwjp_GuardFctInc;
    ELSE                RETURN rwjp_SGuardFctInc;
    END;
   ELSIF Idx = 01 THEN
    IF _Number = 1 THEN RETURN rwjp_CasFctInc;
    ELSE                RETURN rwjp_CasFctInc;
    END;
   ELSIF Idx = 02 THEN RETURN L_Way.GetVldPsgRWJPro(L_Way.vpk_OtherSocial,  Who, _Number);
   ELSIF Idx = 12 THEN RETURN L_Way.GetVldPsgRWJPro(L_Way.vpk_MoscowRegion, Who, _Number);
   ELSIF Idx = 22 THEN RETURN L_Way.GetVldPsgRWJPro(L_Way.vpk_Moscow,       Who, _Number);
   ELSIF Idx = 32 THEN RETURN L_Way.GetVldPsgRWJPro(L_Way.vpk_Paid,         Who, _Number);
   ELSE
    RETURN 99;
   END;
  ELSIF Who = L_Way.rwswho_Chopper THEN
   IF    Idx = 00 THEN
    IF    TckRcS.AsWhoCnd = trawc_Msk THEN RETURN rwjp_Chopper_Msk;
    ELSIF TckRcS.AsWhoCnd = trawc_Htk THEN RETURN rwjp_Chopper_Htk;
    ELSIF TckRcS.AsWhoCnd = trawc_Ctl THEN RETURN 99;
    END;
   ELSIF Idx = 02 THEN RETURN L_Way.GetVldPsgRWJPro(L_Way.vpk_OtherSocial,  Who, 1);
   ELSIF Idx = 12 THEN RETURN L_Way.GetVldPsgRWJPro(L_Way.vpk_MoscowRegion, Who, 1);
   ELSIF Idx = 22 THEN RETURN L_Way.GetVldPsgRWJPro(L_Way.vpk_Moscow,       Who, 1);
   ELSIF Idx = 32 THEN RETURN L_Way.GetVldPsgRWJPro(L_Way.vpk_Paid,         Who, 1);
   ELSE                RETURN 99;
   END;
  ELSE
   Who_Error(Who);
  END;
 END {GetIncRWJP};

 PUBLIC PROCEDURE TrIncFct(_Who: L_Way.tRWSWho; _Number: LIKE(WayLMen.Number); _RWJPro: LIKE(RWayJP.RWJPro)): SCAL[2];
 BEGIN
  IF    _Who = L_Way.rwswho_Driver THEN
   RETURN (_RWJPro = rwjp_CasFctInc) | (_RWJPro = rwjp_DriverFctInc) |
          (_RWJPro = rwjp_Chopper_Msk) | (_RWJPro = rwjp_Chopper_Htk);
  ELSIF _Who = L_Way.rwswho_Guard THEN
   IF _Number = 1 THEN
    RETURN (_RWJPro = rwjp_GuardFctInc) | (_RWJPro = rwjp_CasFctInc);
   ELSE
    RETURN (_RWJPro = rwjp_SGuardFctInc) | (_RWJPro = rwjp_CasFctInc);
   END;
  ELSIF _Who = L_Way.rwswho_Chopper THEN
   IF    TckRcS.AsWhoCnd = trawc_Msk THEN
    RETURN (_RWJPro = rwjp_Chopper_Msk);
   ELSIF TckRcS.AsWhoCnd = trawc_Htk THEN
    RETURN (_RWJPro = rwjp_Chopper_Htk);
   ELSIF TckRcS.AsWhoCnd = trawc_Ctl THEN
    RETURN 0;
   END;
  END;
 END {TrIncFct};

 PUBLIC PROCEDURE TrTkMFct(_Who: L_Way.tRWSWho; _Number: LIKE(WayLMen.Number); _RWJPro: LIKE(RWayJP.RWJPro); Idx: SCAL[2]): SCAL[2];
 BEGIN
  RETURN 0;
 END {TrTkMFct};

 PUBLIC PROCEDURE TrCasFct(_Who: L_Way.tRWSWho; _Number: LIKE(WayLMen.Number); _RWJPro: LIKE(RWayJP.RWJPro)): SCAL[2];
 BEGIN
  RETURN (_RWJPro = rwjp_CasFctInc);
 END {TrCasFct};

 PUBLIC PROCEDURE TrOrdFct(_Who: L_Way.tRWSWho; _Number: LIKE(WayLMen.Number); _RWJPro: LIKE(RWayJP.RWJPro)): SCAL[2];
 BEGIN
  RETURN _RWJPro = rwjp_OrdFctInc;
 END {TrOrdFct};

 PUBLIC PROCEDURE TrPsgFct(_Who: L_Way.tRWSWho; _Number: LIKE(WayLMen.Number); _RWJPro: LIKE(RWayJP.RWJPro)): SCAL[2];
 BEGIN
  RETURN (_RWJPro = rwjp_PsgFct)|(_RWJPro = rwjp_CasPsgFct);
 END {TrPsgFct};

 PUBLIC PROCEDURE CarTbLevel(D: DATE): NUMERIC[0];
 BEGIN
  RETURN L_Way.ctbl_EveryRoute;
 END {CarTbLevel};

 PUBLIC PROCEDURE DtlRCarDay(_BoxNbr: LIKE(Car.BoxNbr); _Date: DATE): D_CarTb.DtlRCDType;
 BEGIN
  IF    D_CarTb.CarTb_GetTimWJT(_BoxNbr, _Date, L_Way.WJType_Work) > 0 THEN
   RETURN D_CarTb.CarTb_BuildDtlRCarDay(D_CarTb.rcd_Line);
  ELSIF D_CarTb.CarTb_GetTimWJC(_BoxNbr, _Date, "31") > 0 THEN
   RETURN D_CarTb.dtlRCD_TO2;
  ELSIF D_CarTb.CarTb_GetTimWJT(_BoxNbr, _Date, L_Way.WJType_Repair) > 0 THEN
   IF    D_CarTb.CarTb_GetTimQlt(_BoxNbr, _Date, 100) > 0 THEN
    RETURN D_CarTb.dtlRCD_Overhaul;
   ELSIF D_CarTb.CarTb_GetTimQlt(_BoxNbr, _Date, 110) > 0 THEN
    RETURN dtlRCD_RepairWithOutDriver;
   ELSE
    RETURN D_CarTb.CarTb_BuildDtlRCarDay(D_CarTb.rcd_Repair);
   END;
  ELSIF D_CarTb.CarTb_GetTimWJT(_BoxNbr, _Date, L_Way.WJType_Stand) > 0 THEN
   IF     D_CarTb.CarTb_GetTimQlt(_BoxNbr, _Date, 102) > 0 THEN
    RETURN dtlRCD_OutageWithOutEngine;
   ELSIF  D_CarTb.CarTb_GetTimQlt(_BoxNbr, _Date, 103) > 0 THEN
    RETURN dtlRCD_OutageWithOutTransm;
   ELSIF  D_CarTb.CarTb_GetTimQlt(_BoxNbr, _Date, 104) > 0 THEN
    RETURN dtlRCD_OutageWithOutFrAxle;
   ELSIF  D_CarTb.CarTb_GetTimQlt(_BoxNbr, _Date, 105) > 0 THEN
    RETURN dtlRCD_OutageWithOutBkAxle;
   ELSIF  D_CarTb.CarTb_GetTimQlt(_BoxNbr, _Date, 106) > 0 THEN
    RETURN dtlRCD_OutageBreakDown;
   ELSIF  D_CarTb.CarTb_GetTimQlt(_BoxNbr, _Date, 107) > 0 THEN
    RETURN dtlRCD_OutageWithOutAccum;
   ELSIF  D_CarTb.CarTb_GetTimQlt(_BoxNbr, _Date, 108) > 0 THEN
    RETURN dtlRCD_OutageWithOutSpares;
   ELSIF  D_CarTb.CarTb_GetTimQlt(_BoxNbr, _Date, 109) > 0 THEN
    RETURN dtlRCD_OutageWithOutTyre;
   ELSE
    RETURN D_CarTb.CarTb_BuildDtlRCarDay(D_CarTb.rcd_Outage);
   END;
  ELSE
   RETURN D_CarTb.rcd_Nothing;
  END;
 END {DtlRCarDay};

 PUBLIC PROCEDURE GetRepEventOnCarTbReflection(D        : DATE;
                                               _RepEvent: LIKE(RepEvent.RepEvent);
                                               VAR _WJCode  : LIKE(WJMode.WJCode);
                                               VAR _Route   : LIKE(Route.Route);
                                               VAR _Quality : LIKE(Quality.Quality);
                                               VAR RETime   : NUMERIC[3]);
  CONST
   standartRETime = 8;
 BEGIN
  IF    _RepEvent = L_Car.E_RE_Overhaul(D) THEN
   _WJCode:="36"; _Route:="1005"; _Quality:=100; RETime:=standartRETime;
  ELSIF _RepEvent = re_TO2 THEN
   _WJCode:="31"; _Route:="1509"; _Quality:=101; RETime:=standartRETime;
  ELSIF _RepEvent = re_rprEngine THEN
   _WJCode:="52"; _Route:="1030"; _Quality:=102; RETime:=standartRETime;
  ELSIF _RepEvent = re_rprTransm THEN
   _WJCode:="52"; _Route:="1030"; _Quality:=103; RETime:=standartRETime;
  ELSIF _RepEvent = re_rprFrontAxle THEN
   _WJCode:="52"; _Route:="1030"; _Quality:=104; RETime:=standartRETime;
  ELSIF _RepEvent = re_rprBackAxle THEN
   _WJCode:="52"; _Route:="1030"; _Quality:=105; RETime:=standartRETime;
  ELSIF _RepEvent = re_BreakDown THEN
   _WJCode:="52"; _Route:="1030"; _Quality:=106; RETime:=standartRETime;
  ELSIF _RepEvent = re_rprAccumulator THEN
   _WJCode:="52"; _Route:="1030"; _Quality:=107; RETime:=standartRETime;
(*
  ELSIF _RepEvent = re_AbsenceSpares THEN
   _WJCode:="52"; _Route:="1030"; _Quality:=108; RETime:=standartRETime;
*)
  ELSIF _RepEvent = re_rprTyre THEN
   _WJCode:="52"; _Route:="1030"; _Quality:=109; RETime:=standartRETime;
  ELSIF _RepEvent = re_Repair_woDrv THEN
   _WJCode:="36"; _Route:="1005"; _Quality:=110; RETime:=standartRETime;
  ELSIF _RepEvent = re_Repair THEN
   _WJCode:="30"; _Route:="1005"; _Quality:=110; RETime:=standartRETime;
  ELSE
   SETEMPTY(_WJCode);
  END;
 END {GetRepEventOnCarTbReflection};

 PUBLIC PROCEDURE UD_DtlRCDName(DtlRCarDay: SCAL[1000]): STRING[];
 BEGIN
  RETURN L_Str.PoolItem("⢨ ⥫|⥫||_|_|਩|||⢨ /|騩 ६", DtlRCarDay-351);
 END {UD_DtlRCDName};

 PUBLIC PROCEDURE PasVolGrp(D: DATE; VAR VolGrp: NUMERIC[0][]);
 BEGIN
  VolGrp[0]:=040;
  VolGrp[1]:=110;
  VolGrp[2]:=140;
 END {PasVolGrp};

 PUBLIC PROCEDURE DefinePasVol(D: DATE; _PasVol: NUMERIC[0]): NUMERIC[0];
  VAR
   VolGrp: NUMERIC[0][3];
 BEGIN
  PasVolGrp(D, VolGrp);
  IF    _PasVol <=  50 THEN RETURN VolGrp[0];
(*
  ELSE                      RETURN VolGrp[1];
*)
  ELSIF _PasVol <= 110 THEN RETURN VolGrp[1];
  ELSE                      RETURN VolGrp[2];
  END;
 END {DefinePasVol};

 PUBLIC PROCEDURE PasVolGrpSit(D: DATE; VAR VolGrp: NUMERIC[0][]);
 BEGIN
  IF D >= 18\09\2010 THEN
   VolGrp[0]:=13;
   VolGrp[1]:=15;
   VolGrp[2]:=18;
   VolGrp[3]:=19;
  ELSE
   VolGrp[0]:=13;
   VolGrp[1]:=15;
   VolGrp[2]:=28;
  END;
 END {PasVolGrpSit};

 PUBLIC PROCEDURE DefinePasVolSit(D: DATE; _PasVol: NUMERIC[0]): NUMERIC[0];
  VAR
   VolGrp: NUMERIC[0][16];
   i     : NUMERIC[0];
 BEGIN
  SETEMPTY(VolGrp);
  PasVolGrpSit(D, VolGrp);
  IF D >= 18\09\2010 THEN
   i:=0;
   WHILE i <= HIGH(VolGrp) DO
    IF _PasVol = VolGrp[i] THEN
     RETURN VolGrp[i];
    END;
    INC(i);
   END;
   i:=HIGH(VolGrp);
   WHILE i >= 0 DO
    IF ~!VolGrp[i] & (_PasVol >= VolGrp[i]) THEN
     RETURN VolGrp[i];
    END;
    DEC(i);
   END;
  ELSE
   IF    _PasVol = VolGrp[0] THEN RETURN VolGrp[0];
   ELSIF _PasVol >=VolGrp[1] THEN RETURN VolGrp[1];
   END;
  END;
  RETURN EMPTYOF(NUMERIC[0]);
 END {DefinePasVolSit};

 PUBLIC PROCEDURE NeedCrankyWayIPLInterpretation(D: DATE; tcpi: L_Way.ttcpi): SCAL[2];
 BEGIN
  IF    (D >= 01\04\2011) THEN
   RETURN ((tcpi = L_Way.tcpi_FromRoute) & (Str.Match(Route.Route, "06*") | Str.Match(Route.Route, "07*"))) |
          ((tcpi = L_Way.tcpi_FromExit)  & (Str.Match(StExit.Exit, "749*") | Str.Match(StExit.Exit, "755*")));
  ELSIF (D >= 01\10\2010) & (tcpi = L_Way.tcpi_FromRoute) & (Str.Match(Route.Route, "06*")) THEN
   RETURN 1;
  ELSE
   RETURN 0;
  END;
 END {NeedCrankyWayIPLInterpretation};

 PUBLIC PROCEDURE PasVolGrpCranky(D: DATE; VAR VolGrp: NUMERIC[0][]);
 BEGIN
  VolGrp[0]:=13;
  VolGrp[1]:=15;
  VolGrp[2]:=18;
  VolGrp[3]:=19;
 END {PasVolGrpCranky};

 PUBLIC PROCEDURE DefinePasVolCranky(D: DATE; _PasVol: NUMERIC[0]): NUMERIC[0];
  VAR
   VolGrp: NUMERIC[0][16];
   i     : NUMERIC[0];
 BEGIN
  SETEMPTY(VolGrp);
  PasVolGrpCranky(D, VolGrp);
  i:=3;
  WHILE i >= 0 DO
   IF _PasVol >= VolGrp[i] THEN
    RETURN i;
   END;
   DEC(i);
  END;
  L_General.Error(" । 㯯, ⨬ "+L_Str.IntStr(_PasVol));
 END {DefinePasVolCranky};

 PRIVATE PROCEDURE IsCommerceTKind(D: DATE): SCAL[2];
  VAR
   curJRegime: LIKE(Route.JRegime);
 BEGIN
  curJRegime:=L_Way.GetRouteJRegime(D, 1);
  RETURN (curJRegime=13(* த*)) | (curJRegime=14(* ਣத*));
 END {IsCommerceTKind};

 PUBLIC PROCEDURE CalcPlIncBySittingPV(D: DATE): SCAL[2];
  CONST
   pkfv_MarkG_ᮡ = 0038;
  VAR
   VolGrp: NUMERIC[0][3];
   Idx   : NUMERIC[0];
 BEGIN
  IF D >= 01\06\2005 THEN
   RETURN IsCommerceTKind(D);
  ELSE
   IF ACCESS(Mark) THEN
    RETURN L_Way.GetMarkG(Mark.Mark, L_Way.mgt_TEP) =  pkfv_MarkG_ᮡ;
   ELSE
    (*"" *)
    L_General.Assert(ACCESS(StExit), " ⠭ 室");
    SETEMPTY(VolGrp);
    PasVolGrpSit(D, VolGrp);
    Idx:=0;
    WHILE (Idx<=HIGH(VolGrp)) & ~!VolGrp[Idx] DO
     IF StExit.MaxPV <= VolGrp[Idx] THEN
      RETURN 1;
     END;
     INC(Idx);
    END;
    RETURN 0;
   END;
  END;
 END {CalcPlIncBySittingPV};

 PRIVATE PROCEDURE IsLeftDrv(D: DATE): SCAL[2];
  VAR
   Result: SCAL[2];
 BEGIN
  IF ~OCCURE(StaffLog) THEN
   SAVE(StaffLog);
   HISTCONF(D, Staff, StaffLog);
   Result:=StaffLog.Sort = 122;
   RESTORE(StaffLog);
  ELSE
   Result:=StaffLog.Sort = 122;
  END;
  RETURN Result;
 END {IsLeftDrv};

 PUBLIC PROCEDURE rwsWho2IPC(Mode: L_APWI.tWho2IPCMode; _Who: L_Way.tRWSWho; Amount: NUMERIC[2]; default: L_Way.tIncPlanCondition): L_Way.tIncPlanCondition;
  VAR
   LeftDrv: SCAL[2];
 BEGIN
  LeftDrv:=0;
  IF    (Mode = L_APWI.w2im_toSetInRWayJ) THEN
   IF Route.Route = "0388" THEN
    default:=L_Way.ipc_Total;
   END;
   IF default=L_Way.ipc_Driver THEN
    SAVE(Staff);
    IF ~OCCURE(Staff) THEN
     CONFORM(RWayS, Staff);
    END;
    LeftDrv:=IsLeftDrv(RWayS.Date);
    RESTORE(Staff);
   END;
  ELSIF (Mode = L_APWI.w2im_toPrintInTckRcS) THEN
   IF Str.Slice(RWayS.Exit, 0, 3) = "388" THEN
    default:=L_Way.ipc_Driver;
   END;
   IF default=L_Way.ipc_Driver THEN
    SAVE(Staff);
    IF ~OCCURE(Staff) THEN
     CONFORM(TckRcS, Staff);
    END;
    LeftDrv:=IsLeftDrv(TckRcS.Date);
    RESTORE(Staff);
   END;
  ELSIF (Mode = L_APWI.w2im_toAnalyze) THEN
   LeftDrv:=StaffLog.Sort = 122;
  ELSIF (Mode = L_APWI.w2im_toPrintInRWayS) THEN
   IF default=L_Way.ipc_Driver THEN
    SAVE(Staff);
    IF ~OCCURE(Staff) THEN
     CONFORM(RWayS, Staff);
    END;
    LeftDrv:=IsLeftDrv(RWayS.Date);
    RESTORE(Staff);
   END;
  END;
  IF (default=L_Way.ipc_Driver) & LeftDrv THEN
   default:=ipc_IncPlanLeftDrv;
  END;
  RETURN default;
 END {rwsWho2IPC};

 PUBLIC PROCEDURE int_GetChopperPlanIncome(_TSN: LIKE(Staff.TSN)): NUMERIC[2];
 BEGIN
  L_General.CallUs(L_Way.AccessTckRcS_byRWayJ(_TSN, L_Way.trs_Chopper));
  IF    TckRcS.PlAsFc THEN
   RETURN TckRcJ.Sum - TckRcJ.RSum;
  ELSIF TckRcS.AsWhoCnd = trawc_Ctl THEN
   RETURN 0;
  ELSE
   RETURN L_APWI.E_GetPlanIncomeScope(L_APWI.piScope_RWTaxed, RWayS.Date, L_APWI.E_trsWho2IPC());
  END;
 END {int_GetChopperPlanIncome};

 PUBLIC PROCEDURE FillIncPlanFromIncPlanG(D: DATE): SCAL[2];
 BEGIN
  IF    OCCURE(StExit) THEN
   IF Str.Slice(StExit.Exit, 0, 3) = "388" THEN
    RETURN 0;
   END;
  ELSE
   IF Route.Route = "0388" THEN
    RETURN 0;
   END;
  END;
  RETURN 1;
 END {FillIncPlanFromIncPlanG};

 PUBLIC PROCEDURE TSN_Inc_PlanPerTrip(D: DATE): SCAL[2];
 BEGIN
  RETURN 1;
 END {TSN_Inc_PlanPerTrip};

 PUBLIC PROCEDURE CalcPlIncByTime(D: DATE; curIPCondition: L_Way.tIncPlanCondition): NUMERIC[0];
 BEGIN
  RETURN L_Way.cpit_ByTrip;
 END {CalcPlIncByTime};

 PUBLIC PROCEDURE GettingRouteFuelNormManner(D: DATE): SCAL[2];
 BEGIN
  RETURN (D < 01\04\2004) | (D >= 01\04\2011);
 END {GettingRouteFuelNormManner};

 PUBLIC PROCEDURE MaxDayDuration(D: DATE;CurWho: L_Way.tRWSWho): NUMERIC[3];
 BEGIN
  IF CurWho = 1 (*  *) THEN
   RETURN 18;
  ELSE
   IF Officer.Union = 06 (*⥫ ᪮ன *) THEN
    RETURN 25;
   ELSE
    RETURN 18;
   END;
  END;
 END {MaxDayDuration};

 PUBLIC PROCEDURE TripForFuelChainBreak(D: DATE): LIKE(SEJobs.Trip);
 BEGIN
  RETURN 00000102001;
 END {TripForFuelChainBreak};

 PUBLIC PROCEDURE TripForSMChainBreak(D: DATE): LIKE(SEJobs.Trip);
 BEGIN
  RETURN 00000102002;
 END {TripForSMChainBreak};

 PUBLIC PROCEDURE NeedRound_IncPlan(D: DATE): SCAL[2];
 BEGIN
  IF D >= 01\02\2007 THEN
   RETURN 0;
  ELSE
   RETURN 1;
  END;
 END {NeedRound_IncPlan};

 PRIVATE PROCEDURE GetClientPlIncCorr(D: DATE): NUMERIC[4];
 BEGIN
  RETURN 0.8064;
 END {GetClientPlIncCorr};

 PRIVATE PROCEDURE NeedClientPlIncCorr(D: DATE): SCAL[2];
 BEGIN
  RETURN ((Mark.Mark = 0010) | (Mark.Mark = 0047)(**)) & (Route.Route="0549");
 END {NeedClientPlIncCorr};

 PUBLIC PROCEDURE _IncPlanClientCorr(D: DATE; WDWay: L_DatTim.tWeekday; Cnd: L_Way.tIncPlanCondition): NUMERIC[4];
  VAR
   Coeff: FLOAT;
 BEGIN
  IF (Route.Route = "0388") & (Mark.Mark = 0128) & (Cnd = L_Way.ipc_Driver) THEN
   IF    D >= 20\04\2013 THEN
    (*⬥ 襭. 0097306*)
   ELSIF D >= 01\05\2012 THEN
    IF WDWay <= L_DatTim.wd_Fri THEN
     RETURN 1.0581;
    ELSE
     RETURN 1.0548;
    END;
   ELSIF D >= 01\04\2012 THEN
    IF WDWay <= L_DatTim.wd_Fri THEN
     RETURN 1.05157; (*7175+370/7175*)
    ELSE
     RETURN 1.04786; (*6895+330/6895*)
    END;
   ELSIF D >= 01\05\2011 THEN
    IF WDWay <= L_DatTim.wd_Fri THEN
     RETURN 1.03177; (*6610+210/6610*)
    ELSE
     RETURN 1.02685; (*6330+170/6330*)
    END;
   END;
  END; (*IF ... Mark.Mark = 0128 ...*)

  IF    (Route.Route = "0388") & (Mark.Mark = 0051) & (Cnd = L_Way.ipc_Total) THEN
   IF    D >= 01\02\2011 THEN
    Coeff:=0.80;
   ELSIF D >= 01\05\2009 THEN
    Coeff:=0.95;
   ELSE
    Coeff:=1;
   END;
  ELSIF (Route.Route = "0388") & ((Mark.Mark = 0093) | (Mark.Mark = 0106)) &
        (D >= 01\12\2010) & (D < 01\02\2011) THEN
   Coeff:=1.07;
  ELSE
   Coeff:=1;
  END;
  IF D = 08\03\2004 THEN
   Coeff:=0.9;
  END;
  IF NeedClientPlIncCorr(D) THEN
   RETURN Coeff * GetClientPlIncCorr(D);
  END;
  RETURN Coeff;
 END {_IncPlanClientCorr};

 PUBLIC PROCEDURE TckRcLevel(D: DATE): NUMERIC[0];
 BEGIN
  IF    D >= 31\03\2006 THEN
   RETURN L_TRS.il_Full;
  ELSIF D >= 23\01\2005 THEN
   RETURN L_TRS.il_offLine;
  ELSIF D >= 01\03\2003 THEN
   RETURN L_TRS.il_woBeg;
  ELSE
   RETURN L_TRS.il_None;
  END;
 END {TckRcLevel};

 PUBLIC PROCEDURE TckRcS_GetRWJProForIncome(D       : DATE;
                                            _TckKind: LIKE(TckKind.TckKind);
                                            _Who    : LIKE(TckRcS.AsWho);
                                            _Number : LIKE(WayLMen.Number)): LIKE(RWJPro.RWJPro);
 BEGIN
  L_General.CallUs(SEARCH(TckKind, TckKind, _TckKind));
  IF (_TckKind = 0008) | ((D >= 13\08\2009) & (_TckKind = 0803(*  த  *))) THEN
   RETURN 01;
  ELSIF TckKind.InCash & (TckKind.InSale = L_TRS.tks_Prepayment) THEN
   IF _Who = L_Way.trs_Driver THEN
    RETURN rwjp_TKPrepayment;
   ELSIF (_Who = L_Way.trs_Guard) & (_Number = 1) THEN
    RETURN rwjp_GuardPrepayment;
   ELSE
    L_General.Error(" ஥   祭 ।.  " + TckRcS.TckRcS);
   END;
  ELSE
   IF _Who = L_Way.trs_Driver THEN
    RETURN rwjp_DriverFctInc;
   ELSIF _Who = L_Way.trs_Guard THEN
    IF _Number = 1 THEN
     RETURN rwjp_GuardFctInc;
    ELSE
     RETURN rwjp_SGuardFctInc;
    END;
   ELSIF _Who = L_Way.trs_Chopper THEN
    IF    TckRcS.AsWhoCnd = trawc_Msk THEN
     RETURN rwjp_Chopper_Msk;
    ELSIF TckRcS.AsWhoCnd = trawc_Htk THEN
     RETURN rwjp_Chopper_Htk;
    ELSIF TckRcS.AsWhoCnd = trawc_Ctl THEN
     L_General.Error("⨬ 稥 窨  '稪'");
    ELSE
     L_General.Error("୮ ଫ  " + TckRcS.TckRcS);
    END;
   END;
  END;
 END {TckRcS_GetRWJProForIncome};

 PUBLIC PROCEDURE TckRcS_GetRWJProForPsg(D       : DATE;
                                         _TckKind: LIKE(TckKind.TckKind);
                                         _Who    : LIKE(TckRcS.AsWho);
                                         _Number : LIKE(WayLMen.Number)): LIKE(RWJPro.RWJPro);
 BEGIN
  RETURN rwjp_PsgFct;
 END {TckRcS_GetRWJProForPsg};

 PUBLIC PROCEDURE TckRcS_MaxDelta(D: DATE): NUMERIC[3];
 BEGIN
  CONFORM(TckRcJ, Route);
  IF    (D >= 01\05\2009) & (Route.Route = "0028") THEN
   RETURN 25/60;
  ELSIF (D >= 01\05\2009) & (Route.Route = "0046") THEN
   RETURN 20/60;
  ELSIF (D >= 01\05\2009) & (Route.Route = "0055") THEN
   RETURN 60/60;
  ELSIF (D >= 01\05\2009) & (Route.Route = "0056") THEN
   RETURN 40/60;
  ELSIF (D >= 01\05\2009) & (Route.Route = "0057") THEN
   RETURN 40/60;
  ELSIF ((D < 01\01\2005) & (Route.Route = "0388")) |
        IsCommerceTKind(D) THEN
   RETURN 3.00;
  ELSE
   RETURN 15/60;
  END;
 END {TckRcS_MaxDelta};

 PUBLIC PROCEDURE E_IPConditionPool(D: DATE): STRING[];
 BEGIN
  RETURN "稪 ()|稪 ()|ଏ ()|ଏ ()| ";
 END {E_IPConditionPool};

 PUBLIC PROCEDURE TckRcS_AsWhoCnd_GetPool(default: STRING[];
                                          D      : DATE;
                                          _AsWho : LIKE(TckRcS.AsWho)): STRING[];
 BEGIN
  IF _AsWho = L_Way.trs_Chopper THEN
   RETURN "1- (᪢)|2- (쪮)|稪";
  ELSE
   RETURN default;
  END;
 END {TckRcS_AsWhoCnd_GetPool};

 PUBLIC PROCEDURE RE_Overhaul(D: DATE): L_Car.tRepEvent;
 BEGIN
  RETURN 11;
 END {RE_Overhaul};

 PUBLIC PROCEDURE MedicalSertLevel(D: DATE): SCAL[2];
 BEGIN
  IF D >= 23\04\2003 THEN
   RETURN 1;
  END;
  RETURN 0;
 END {MedicalSertLevel};

 PUBLIC CONST
  PlEqFc_TotalOnly  = 1;
  PlEqFc_DriverOnly = 2;
  PlEqFc_All        = 3;

 PUBLIC PROCEDURE PlEqFcRWayJP(D: DATE; VAR List: STRING[]);
 BEGIN
  List:="0  ⥫|1 騩  ࠢ 䠪|2   ࠢ 䠪|3 騩    ࠢ 䠪";
 END {PlEqFcRWayJP};

 PRIVATE PROCEDURE SpecialPlanEqualFact(): SCAL[2];
  VAR
   _TKind: LIKE(TKind.TKind);
 BEGIN
  IF    L_DatTim.Per(RWayS.Date) = 01\08\2005 THEN
   RETURN (Route.Route = "0116") | (Route.Route = "0122");
  ELSIF L_DatTim.Per(RWayS.Date) = 01\02\2005 THEN
   RETURN (Route.Route # "0388") & ~Str.Match(Route.Route, "06**");
  ELSIF L_DatTim.Per(RWayS.Date) = 01\01\2005 THEN
   _TKind:=L_Way.GetRouteTKind(RWayS.Date, 1);
   RETURN (_TKind = 01) | (_TKind = 02) |
          (Route.Route = "0118") | (Route.Route = "0523");
  ELSE
   RETURN 0;
  END;
 END {SpecialPlanEqualFact};

 PUBLIC PROCEDURE RWayJPlanIsEqualFact(_Date: DATE; _Object: L_APWI.tObjectP; default: SCAL[2]): SCAL[2];
 BEGIN
  IF (_Date >= 01\09\2008) & (_Object = L_APWI.ObjectP_VldPsg) THEN
   RETURN 0;
  ELSIF P_OwnData.IsPlanEqualFactDay(RWayS.Date) | L_Way.CalcIncPlanIsCancelled(RWayS.Date) |
        SEARCH(RWayJP, RWayS, RWayJ.RWayS, RWayJ.Day, RWayJ.StartT, L_Way.rwjp_PlanIsEqualFact) &
        ((RWayJP.Value = PlEqFc_TotalOnly) | (RWayJP.Value = PlEqFc_All)) THEN
   RETURN 1;
  ELSE
   SAVE(Route);
   SAVE(SEJobs);
   CONFORM(RWayJ, SEJobs);
   CONFORM(SEJobs, Route);
   default:=SpecialPlanEqualFact();
   RESTORE(SEJobs);
   RESTORE(Route);
   RETURN default;
  END;
 END {RWayJPlanIsEqualFact};

 PUBLIC PROCEDURE CarEvn_IsAllowedInteractiveModification(): SCAL[2];
 BEGIN
  IF (CarEvn.RepEvent = re_TO1)             |
     (CarEvn.RepEvent = re_TO2)             |
     (CarEvn.RepEvent = re_OilReplace)      |
     (CarEvn.RepEvent = re_Sinchronisation) THEN
   RETURN L_General.IsAdmin()              |
          L_General.IsMemberOf("MainRPRS") |
          L_General.IsMemberOf("RPRS_2");
  ELSE
   RETURN 1;
  END;
 END {CarEvn_IsAllowedInteractiveModification};

 PUBLIC PROCEDURE IsCoveringEvent(D: DATE; trgRepEvent: LIKE(RepEvent.RepEvent)): SCAL[2];
  VAR
   mg: LIKE(MarkG.MarkG);
 BEGIN
  IF    trgRepEvent = re_TO1 THEN
   RETURN (CarEvn.RepEvent = re_TO2) |
          (CarEvn.RepEvent = L_Car.E_RE_Overhaul(D));
  ELSIF trgRepEvent = re_TO2 THEN
   RETURN (CarEvn.RepEvent = L_Car.E_RE_Overhaul(D));
  ELSIF trgRepEvent = re_HMT_OilReplace THEN
   RETURN (CarEvn.RepEvent = L_Car.E_RE_Overhaul(D));
  ELSIF trgRepEvent = re_VTMStrapReplace THEN
   RETURN (CarEvn.RepEvent = L_Car.E_RE_Overhaul(D));
  ELSIF trgRepEvent = re_OilReplace THEN
   IF (CarEvn.RepEvent = re_TO2) | (CarEvn.RepEvent = L_Car.E_RE_Overhaul(D)) THEN
    L_Car.AccessMark(CarEvn.BoxNbr, D);
    mg:=L_Way.GetMarkG_Soft(Mark.Mark, L_Way.mgt_REPlan);
    IF D >= 01\05\2012 THEN
     RETURN (mg = 0153);
    ELSE
     RETURN (mg = 0212) | (mg = 0153);
    END;
   END;
  ELSIF trgRepEvent = re_Diagnostic1 THEN
   RETURN (CarEvn.RepEvent = re_TO1) |
          (CarEvn.RepEvent = re_TO2) |
          (CarEvn.RepEvent = L_Car.E_RE_Overhaul(D));
  END;
  RETURN 0;
 END {IsCoveringEvent};

 PUBLIC PROCEDURE ConvertBnfType(P: DATE; _BnfType: NUMERIC[0]): NUMERIC[0];
 BEGIN
  IF (P >= 01\01\2007) & (_BnfType = L_OTx.bnft_Medic) THEN
   RETURN L_OTx.bnft_None;
  END;
  RETURN _BnfType;
 END {ConvertBnfType};

 PUBLIC PROCEDURE GetStopInPark(): LIKE(Stop.Stop);
 BEGIN
  RETURN 065;
 END {GetStopInPark};

 PUBLIC PROCEDURE FuelMoveNormCfcAsSum(D: DATE): SCAL[2];
 BEGIN
  IF D >= 01\04\2011 THEN
   RETURN 1;
  ELSE
   RETURN 0;
  END;
 END {FuelMoveNormCfcAsSum};

 PUBLIC PROCEDURE UsingBarCodeScannerLevel(D      : DATE;
                                           Role   : NUMERIC[0];
                                           default: L_BarCode.tBCScannerLevel): L_BarCode.tBCScannerLevel;
 BEGIN
  IF    D >= 29\01\2009 THEN
   IF    (Role = L_BegRWS.ubcr_Dispatcher) |
         (Role = L_BegRWS.ubcr_Outpost)    |
         (Role = L_BegRWS.ubcr_Mechanic)   |
         (Role = L_BegRWS.ubcr_Medic)      THEN
    RETURN L_BarCode.bcsl_Normal;
   END;
  ELSIF D >= 24\06\2004 THEN
   IF    (Role = L_BegRWS.ubcr_Dispatcher) |
         (Role = L_BegRWS.ubcr_Outpost)    |
         (Role = L_BegRWS.ubcr_Mechanic)   THEN
    RETURN L_BarCode.bcsl_Normal;
   ELSIF (Role = L_BegRWS.ubcr_Medic)      THEN
    RETURN L_BarCode.bcsl_Introduction;
   END;
  ELSIF D >= 16\06\2004 THEN
   IF    (Role = L_BegRWS.ubcr_Dispatcher) THEN
    RETURN L_BarCode.bcsl_Introduction;
   ELSIF (Role = L_BegRWS.ubcr_Outpost)    THEN
    RETURN L_BarCode.bcsl_Normal;
   ELSIF (Role = L_BegRWS.ubcr_Mechanic)   THEN
    RETURN L_BarCode.bcsl_Introduction;
   END;
  ELSIF D >= 25\05\2004 THEN
   IF    (Role = L_BegRWS.ubcr_Dispatcher) |
         (Role = L_BegRWS.ubcr_Outpost)    |
         (Role = L_BegRWS.ubcr_Mechanic)   THEN
    RETURN L_BarCode.bcsl_Introduction;
   END;
  ELSIF D >= 18\05\2004 THEN
   IF L_General.IsAdmin() THEN
    RETURN L_BarCode.bcsl_Introduction;
   END;
  END;
  RETURN L_BarCode.bcsl_None;
 END {UsingBarCodeScannerLevel};

 PUBLIC PROCEDURE cffe_UserDefinedCheck(    _Date    : DATE;
                                            DrvTSN   : LIKE(Staff.TSN);
                                            GrdTSN   : LIKE(Staff.TSN)[];
                                            _BoxNbr  : LIKE(Car.BoxNbr);
                                            _Exit    : LIKE(StExit.Exit);
                                        VAR Default  : L_BegRWS.tCrewFitnessForExit;
                                        VAR ReasonStr: STRING[];
                                            Action   : L_XDoc.tAction);
  VAR
   Dummy: NUMERIC[3];
 BEGIN
  IF ((Action = L_XDoc.action_begInsert) | (Action = L_XDoc.action_begEdit)) &
     ~!_BoxNbr & SEARCH(CarEvn, BoxNbr, _BoxNbr, _Date+1, re_TO2) THEN
   ReasonStr:=" " + L_DatTim.DateStr(_Date+1) + " ஢ -2";
   Default  :=L_BegRWS.cffe_wInform;
  END;
 END {cffe_UserDefinedCheck};

 PUBLIC PROCEDURE IsRepInLine(D: DATE): SCAL[2];
 BEGIN
  RETURN (WJMode.WJCode = "33");
 END {IsRepInLine};
 
 PUBLIC PROCEDURE IsRepInPark(D: DATE): SCAL[2];
 BEGIN
  RETURN (WJMode.WJType = L_Way.WJType_Repair) &
         (WJMode.WJCode # "36") & ~IsRepInLine(D);
 END {IsRepInPark};

 PUBLIC PROCEDURE Xomn7_BnfCancelRequired(_BnfType: L_OTx.tBnfType): SCAL[2];
 BEGIN
  RETURN _BnfType # L_OTx.bnft_Medic;
 END {Xomn7_BnfCancelRequired};

 PUBLIC PROCEDURE HasTckAtStorage(D: DATE): SCAL[2];
 BEGIN
  RETURN D >= 25\07\2006;
 END {HasTckAtStorage};

 PUBLIC PROCEDURE VldPsgPlanLev(D: DATE): SCAL[2];
 BEGIN
  IF D >= 01\02\2008 THEN
   RETURN 1;
  ELSE
   RETURN 0;
  END;
 END {VldPsgPlanLev};

 PUBLIC PROCEDURE FillVldPsgPlanFromVldPsgPlanG(D: DATE): SCAL[2];
 BEGIN
  RETURN FillIncPlanFromIncPlanG(D);
 END {FillVldPsgPlanFromVldPsgPlanG};

 PUBLIC PROCEDURE TrVldPsgFact(Default: L_APWI.tVldPsgAmnt;
                               _Date: DATE; _Who: L_Way.tRWSWho; _Number: LIKE(WayLMen.Number);
                               trgTripNbr: L_RWayS.tTripAmount): L_APWI.tVldPsgAmnt;
 BEGIN
  IF _Who = L_Way.rwswho_Driver THEN
   RETURN Default+L_APWI.TrVldPsgFact(_Date, L_Way.rwswho_Chopper, 1, trgTripNbr);
  ELSE
   RETURN Default;
  END;
 END {TrVldPsgFact};

 PUBLIC PROCEDURE ConvWith2Gu_to_IPCForVldPsg(_Date: DATE): L_Way.tIncPlanCondition;
 BEGIN
  RETURN ipc_TermPlanGrd;
 END {ConvWith2Gu_to_IPCForVldPsg};

 PUBLIC PROCEDURE VldPsgPlanMultiplier(Cnt: NUMERIC[0]): NUMERIC[6];
  VAR
   Result: NUMERIC[6];
 BEGIN
  IF (RWayS.Date >= 01\05\2008) & (WayLMen.Who = L_Way.wlmwho_Guard) THEN
   L_General.Assert(Cnt = 2, "࠭ ⢮ ࠡ⭨  ࠬ");
   IF L_Way.rwswhoWithSale(L_Way.rwswho_Guard) THEN
    Result:=0.3;
   ELSE
    Result:=0.7;
   END;
  ELSE
   Result:=1/Cnt;
  END;
  RETURN Result;
 END {VldPsgPlanMultiplier};

 PUBLIC PROCEDURE ASCPLev(D: DATE): SCAL[2];
 BEGIN
  RETURN D >= 01\06\2009;
 END {ASCPLev};

 PUBLIC PROCEDURE AccountVldPsg(D: DATE): SCAL[2];
 BEGIN
  RETURN ~L_Way.E_CarASCPLev(RWayS.Date, RWayS.BoxNbr, SEJobs.Route, SEJobs.Exit);
 END {AccountVldPsg};

 PUBLIC PROCEDURE VPKInFactMethod(D: DATE): NUMERIC[0];
 BEGIN
  IF D >= 01\05\2010 THEN
   RETURN L_APWI.vif_AllCard;
  ELSE
   RETURN L_APWI.vif_SocOthr;
  END;
 END {VPKInFactMethod};

 PUBLIC PROCEDURE ExecuteArchaicCodeDateForTariffAndAddPayment(D: DATE): DATE;
 BEGIN
  RETURN MINOF(DATE);
 END {ExecuteArchaicCodeDateForTariffAndAddPayment};

 PUBLIC PROCEDURE ShowPlnIncForStExit(D: DATE): SCAL[2];
 BEGIN
  IF D >= 01\12\2010 THEN
   RETURN 0;
  ELSE
   RETURN 1;
  END;
 END {ShowPlnIncForStExit};

 PUBLIC PROCEDURE cffe_Correct(    trgDate  : DATE;
                                   trgTSN   : LIKE(Staff.TSN);
                                   trgBoxNbr: LIKE(Car.BoxNbr);
                                   trgExit  : LIKE(StExit.Exit);
                               VAR Default  : L_BegRWS.tCrewFitnessForExit;
                               VAR Reason   : STRING[];
                               VAR ReasonStr: STRING[];
                                   Action   : L_XDoc.tAction);
 BEGIN
  IF    Reason = L_BegRWS.cffeR_BadCarCLIO THEN
   IF (Action = L_XDoc.action_begDst) & L_Car.CarIsInOperation(trgBoxNbr, trgDate) THEN
    Default:=L_BegRWS.cffe_No;
   ELSE
    Default:=L_BegRWS.cffe_wChoice;
   END;
  ELSIF (Reason = L_BegRWS.cffeR_BadRestTime) & (Action = L_XDoc.action_begDst) & ~!ReasonStr THEN
   CONFORM(RWayS, Staff);
   HISTCONF(RWayS.Date, Staff, StaffLog, Officer);
   IF (Officer.Union = 04) | (Officer.Union = 05) | (Officer.Union = 07) THEN
    Default:=L_BegRWS.cffe_wCrucialChoice;
   END;
  END;
 END {cffe_Correct};

END.
