(*
%Copyright   (c) Polak Computer System
%Author      GINA
%Purpose      ᮡ 
%Type        library
%Specific    LOC
%Modified    23.04.2014 15:12:13 POLAK\Gina
*)

 MODULE L_Env [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 PUBLIC CONST
  fictTSN    = 0000;
  fictMan    = 0000;

  aptm_Start = 01\01\2003;
  kaa_Start  = 01\01\2003;

 IMPORT L_Fuel, L_MathR, L_Car, P_Firm, L_Russia, L_Rpr;

 PUBLIC CONST
  Region = L_Russia.reg_50;

 PUBLIC PROCEDURE IsDriver(): SCAL[2];
 BEGIN
  RETURN ((Officer.Union >= 04) & (Officer.Union <= 13)) | (Officer.Union = 26) | (Officer.Union = 31) |
         (Officer.Post=099(*⥫ ண.- ॣ*)) | (Officer.Post=097(*ࠪ*));
 END {IsDriver};

 PUBLIC PROCEDURE IsRouteDriver(): SCAL[2];
 BEGIN
  RETURN (Officer.Union = 04) | IsMTDriver();
 END {IsRouteDriver};

 PUBLIC PROCEDURE IsMTDriver(): SCAL[2]; (*.⠪-*)
 BEGIN
  RETURN (Officer.Union = 05);
 END {IsMTDriver};

 PUBLIC PROCEDURE IsDriverPupil(): SCAL[2];
 BEGIN
  RETURN 0;
 END {IsDriverPupil};

 PUBLIC PROCEDURE IsGuard(): SCAL[2];
 BEGIN
  RETURN (Officer.Union = 17);
 END {IsGuard};

 PUBLIC PROCEDURE RealTSN(_TSN: LIKE(Staff.TSN)): SCAL[2];
 BEGIN
  RETURN _TSN # fictTSN;
 END {RealTSN};

 PUBLIC PROCEDURE RealMan(_Man: LIKE(Man.Man)): SCAL[2];
 BEGIN
  RETURN _Man # fictMan;
 END {RealMan};

 PUBLIC PROCEDURE RealBoxNbr(_BoxNbr: LIKE(Car.BoxNbr)): SCAL[2];
 BEGIN
  RETURN _BoxNbr # L_Car.E_GetFictiveBoxNbr(P_Firm.mf_Own);
 END {RealBoxNbr};

 PUBLIC PROCEDURE FlAcntLev(D: DATE): L_Fuel.tfal;
 BEGIN
  IF    D >= 01\05\2009 THEN
   RETURN L_Fuel.fal_RefuelOperator;
  ELSIF D >= 01\08\2003 THEN
   RETURN L_Fuel.fal_Dispatcher;
  ELSE
   RETURN L_Fuel.fal_RWOP;
  END;
 END {FlAcntLev};

 PUBLIC PROCEDURE MathAcntLev(D: DATE): L_MathR.tMathAcntLev;
 BEGIN
  IF D >= 01\07\2004 THEN
   RETURN L_MathR.mal_Recount_ActiveSMMove;
  ELSE
   RETURN L_MathR.mal_NoStock;
  END;
 END {MathAcntLev};

 PUBLIC PROCEDURE KeyAssAcntLev(D: DATE): SCAL[4];
 BEGIN
  IF D >= kaa_Start THEN
   RETURN L_MathR.kaal_WithActProcess;
  ELSE
   RETURN L_MathR.kaal_NoKeyAssets;
  END;
 END {KeyAssAcntLev};

 PUBLIC PROCEDURE CarServiceLev(D: DATE): SCAL[2];
 BEGIN
  IF D >= 26\09\2002 THEN
   RETURN L_Car.csl_Active;
  ELSE
   RETURN L_Car.csl_None;
  END;
 END {CarServiceLev};

 PUBLIC PROCEDURE RWayCPLevel(D: DATE): SCAL[2];
 BEGIN
  IF D >= 01\09\2011 THEN
   RETURN 0;
  ELSE
   RETURN 1;
  END;
 END {RWayCPLevel};

 PUBLIC PROCEDURE MarkCategoryLevel(D: DATE): SCAL[2];
 BEGIN
  RETURN D >= 20\10\2003;
 END {MarkCategoryLevel};

 PUBLIC PROCEDURE RprLev(D: DATE): L_Rpr.tRprLev;
 BEGIN
  RETURN L_Rpr.rprl_Active;
 END {RprLev};

END.
