(*
%Copyright   (c) Polak IT
%Author      16.06.2011 13:51:11 POLAK\LDA
%Purpose      ࠡ 
%Type        report
%Specific    AP
%Modified    10.04.2012 13:19:15 ROBOT by POLAK\LDA
%Environment
*)

 IMPORT Memo, L_General, L_DatTim, L_MDoc, L_Basis, FIO, L_Car, Str, P_MDoc, L_bp, L_Stock, L_Str;

 CONST
  csv_Nozzle             = 4;
  csv_DTS                = 1;
  csv_ORPAK_StateNbr     = 11;
  csv_ORPAK_BoxNbr       = 12;
  csv_ORPAK_Run          = 13;
  csv_ORPAK_EngineWrkTim = 14;

 PRIVATE PROCEDURE MakeHeader(F: STRING[]);
 BEGIN
  L_Basis.wb_WrInQM(F, "ࠦ");
  L_Basis.wb_WrInQM(F, "᭮");
  L_Basis.wb_WrInQM(F, "ઠ");
  L_Basis.wb_WrInQM(F, "ઠ");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "஡");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "६ ࠢ");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "⢮");
  L_Basis.wb_WrInQM(F, "_᭮");
  L_Basis.wb_WrInQM(F, "_ࠦ");
  L_Basis.wb_WrInQM(F, "_஡");
  L_Basis.wb_WrInQM(F, "_");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "⮫");
  L_Basis.wb_TermLine(F);
 END {MakeHeader};

 PRIVATE PROCEDURE GetStrCSV(s: STRING[]; i: NUMERIC[0]): STRING[];
 BEGIN
  s:=Str.Item(s, ",", i);
  s:=Str.Item(Str.Condense(s), '"', 0);
  RETURN s;
 END {GeStrCSV};

 PRIVATE PROCEDURE GetMDocServiceNote(): STRING[];
  CONST
   ServiceNoteIdent = "殮   ";
  VAR
   ServiceNote: STRING[];
 BEGIN
  ServiceNote:=P_MDoc.GetMDocProSoft(MDoc.MDocKind, MDoc.MDoc, P_MDoc.P_ServiceNote);
  IF Str.Item(ServiceNote, ";", 0) = ServiceNoteIdent THEN
   RETURN Str.Item(ServiceNote, ";", 1);
  ELSE
   RETURN "";
  END;
 END {GetMDocServiceNote};

 PRIVATE PROCEDURE wb_Wr_ORPAK(F, Value: STRING[]);
 BEGIN
  IF ~!Value THEN
   L_Basis.wb_WrStr(F, Value);
  ELSE
   L_Basis.wb_WrStr(F, "---");
  END;
 END {wb_Wr_ORPAK};

 PRIVATE PROCEDURE MakePart(F: STRING[]);
  VAR
   MDocServiceNote: STRING[];
   DTS_asStr,
   ORPAK_StateNbr,
   ORPAK_BoxNbr,
   ORPAK_Run,
   ORPAK_EngineWrkTim: STRING[];
 BEGIN
  L_Car.StandOnCarLog(MDoc.BoxNbr, MDoc.Date);
  CONFORM(CarLog, Mark);
  CONFORM(CarLog, Column);
  L_Basis.wb_WrScl(F, MDoc.BoxNbr);
  L_Basis.wb_WrStr(F, CarLog.StateNbr);
  L_Basis.wb_WrScl(F, Mark.Mark);
  L_Basis.wb_WrStr(F, Mark.Name);
  L_Basis.wb_WrScl(F, Column.Column);
  L_Basis.wb_WrStr(F, Column.Name);
  L_Basis.wb_WrNum(F, L_Car.GetGlobalRun(CarLog.BoxNbr, MDoc.Date + 1), 0);
  L_Basis.wb_WrScl(F, MDoc.MDoc);
  L_Basis.wb_WrDat(F, MDoc.Date);
  MDocServiceNote:=GetMDocServiceNote();

  DTS_asStr         :=GetStrCSV(MDocServiceNote, csv_DTS);
  ORPAK_StateNbr    :=GetStrCSV(MDocServiceNote, csv_ORPAK_StateNbr);
  ORPAK_BoxNbr      :=GetStrCSV(MDocServiceNote, csv_ORPAK_BoxNbr);
  ORPAK_Run         :=GetStrCSV(MDocServiceNote, csv_ORPAK_Run);
  ORPAK_EngineWrkTim:=GetStrCSV(MDocServiceNote, csv_ORPAK_EngineWrkTim);
  IF ~!DTS_asStr THEN
   L_Basis.wb_WrTim(F, L_DatTim.GetTimeOfTIMESTAMP(STRTOFLD(DTS_asStr, TIMESTAMP, "D.N.y H:M:S")));
  ELSE
   L_Basis.wb_WrStr(F, "---");
  END;
  L_Basis.wb_WrScl(F, Math.Math);
  L_Basis.wb_WrStr(F, Math.Name);
  L_Basis.wb_WrNum(F, MDocList.Qnt, 2);
  wb_Wr_ORPAK(F, ORPAK_StateNbr);
  wb_Wr_ORPAK(F, ORPAK_BoxNbr);
  wb_Wr_ORPAK(F, ORPAK_Run);
  wb_Wr_ORPAK(F, ORPAK_EngineWrkTim);
  L_Basis.wb_WrStr(F, L_Str.PoolItem("-|+", ~!ORPAK_StateNbr | ~!ORPAK_BoxNbr | ~!ORPAK_Run | ~!ORPAK_EngineWrkTim));
  L_Basis.wb_WrStr(F, GetStrCSV(MDocServiceNote, csv_Nozzle));
  L_Basis.wb_TermLine(F);
 END {MakePart};

 PRIVATE PROCEDURE OR001();
  CONST
   bpId    = "OR001";
   RepName = bpId;
 BEGIN
  SE_ACCESSDATAMODE(AccessDataMode_SOFT);
  L_bp.Begin(bpId, " ࠡ ", L_bp.t_Basis, L_General.timeCond_InIntvl);
  FIO.Open(R, L_General.NameConnection(RepName), "REP", Create);
  MakeHeader("R");
  SELECT(MDoc, MDKDate, , L_MDoc.md_NOV);
  SRCINSEL(MDoc, GE, , Memo.ud_fr());
  WHILE OCCURE(MDoc) & (MDoc.Date <= Memo.ud_ut()) DO
   PROMPT(L_MDoc.MDocStr(MDoc.MDocKind, MDoc.MDoc) + "  " + L_DatTim.DateStr(MDoc.Date));
   IF (MDoc.Status # L_MDoc.st_Canceled) & L_Stock.IsFuelStationMDoc() THEN
    CONFORM(MDoc, MDocList);
    CONFORM(MDocList, Math);
    MakePart("R");
    L_General.CallUs(~NEXT(MDocList));
   END;
   NEXT(MDoc);
  END; (* WHILE OCCURE(MDoc) ... *)
  FIO.Close(R);
  L_bp.End();
 END {OR001};

END.
