(*
%Copyright   (c) Polak IT
%Author      08.02.2010 10:27:13 POLAK\LDA
%Purpose
%Type        control,report,temporary,convertor,operation,library,to paste
%Specific    AP,AP_PC,AP_PT,SYS,TOOL,LOC
%Modified    10.04.2012 13:22:40 ROBOT by POLAK\LDA
%Environment
*)

 IMPORT L_General, L_Basis, FIO, L_Rpr, Memo, L_DatTim, P_Firm, P_Rpr, L_Car, L_Str, DBD, L_lsStore, L_ctc, L_bp;

 PRIVATE PROCEDURE MakeHeader(F: STRING[]);
 BEGIN
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, ".");
  L_Basis.wb_WrInQM(F, "ઠ");
  L_Basis.wb_WrInQM(F, "ઠ");
  L_Basis.wb_WrInQM(F, "ࠣ");
  L_Basis.wb_WrInQM(F, "ࠣ");
  L_Basis.wb_WrInQM(F, "䮭");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "ॣ_");
  L_Basis.wb_WrInQM(F, "ॣ_");
  L_Basis.wb_WrInQM(F, "⠊");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, " ");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, " ஢ન");
  L_Basis.wb_WrInQM(F, "஢ઠ");
  L_Basis.wb_TermLine(F);
 END {MakeHeader};

 PRIVATE PROCEDURE MakePart(F: STRING[]; wRprJ, wRprP: SCAL[2]);
  VAR
   Phone,
   ClrPhone,
   CheckQualityRepairResult: STRING[];
 BEGIN
  L_Basis.wb_WrScl(F, RprS.RprS);
  L_Basis.wb_WrDat(F, RprS.OrdDate);
  L_Basis.wb_WrStr(F, L_Rpr.GetRprSStatus_AsStr(RprS.Status));

  IF    L_Rpr.IsRprS_w_Car() THEN
   L_Car.StandOnCarLog(Car.BoxNbr, RprS.OrdDate);
   L_Basis.wb_WrStr(F, CarLog.StateNbr);
   L_Basis.wb_WrScl(F, Mark.Mark);
   L_Basis.wb_WrStr(F, Mark.Name);
   L_Basis.wb_WrStr(F, "---");
   L_Basis.wb_WrStr(F, "---");
   L_Basis.wb_WrStr(F, "---");
   L_Basis.wb_WrStr(F, "---");
  ELSIF L_Rpr.IsRprS_w_OutCar() THEN
   L_Basis.wb_WrStr(F, OutCar.StateNbr);
   L_Basis.wb_WrScl(F, Mark.Mark);
   L_Basis.wb_WrStr(F, Mark.Name);
   CONFORM(OutCar, Firm);
   L_Basis.wb_WrScl(F, Firm.Firm);
   L_Basis.wb_WrStr(F, Firm.Name);

   SETEMPTY(Phone, ClrPhone);
   Phone   :=P_Firm.gfcv_cc_Common(0, Firm.Firm, RprS.OrdDate, L_ctc.cvt_PhonePST);
   ClrPhone:=P_Firm.FP_ClrPhone(Firm.Firm, RprS.OrdDate);
   IF ~!ClrPhone THEN
    ClrPhone:=" " + ClrPhone;
   END;

   IF    ~!Phone & ~!ClrPhone THEN
    Phone:=Phone + " " + ClrPhone;
   ELSIF !Phone  & ~!ClrPhone THEN
    Phone:=ClrPhone;
   ELSIF ~!Phone & !ClrPhone THEN
    Phone:=Phone;
   END;

   IF ~!Phone THEN
    L_Basis.wb_WrStr(F, Phone);
   ELSE
    L_Basis.wb_WrStr(F, "---");
   END;
  END;

  IF wRprJ THEN
   CONFORM(RprJ, RprJob);
   CONFORM(RprJob, CarBlock);
   L_Basis.wb_WrScl(F, RprJ.RprJ);
   L_Basis.wb_WrScl(F, RprJob.CarBlock);
   L_Basis.wb_WrStr(F, CarBlock.Name);
   L_Basis.wb_WrScl(F, RprJ.RprJob);
   L_Basis.wb_WrStr(F, RprJob.Name);
  ELSE
   L_Basis.wb_WrStr(F, "---");
   L_Basis.wb_WrStr(F, "---");
   L_Basis.wb_WrStr(F, "---");
   L_Basis.wb_WrStr(F, "---");
   L_Basis.wb_WrStr(F, "---");
  END;

  IF wRprP THEN
   CONFORM(RprP, Staff);
   CONFORM(Staff, Man);
   L_Basis.wb_WrScl(F, RprP.TSN);
   L_Basis.wb_WrStr(F, Man.Name);
  ELSE
   L_Basis.wb_WrStr(F, "---");
   L_Basis.wb_WrStr(F, "---");
  END;

  SETEMPTY(CheckQualityRepairResult);
  IF SELECT(Message, RecordId, DBD.FileNameToId("RprS"), RprS.RECORDID) THEN
   WHILE OCCURE(Message) DO
    CheckQualityRepairResult:=CheckQualityRepairResult + L_lsStore.Get(Message.Text) + L_Str.CRLF;
    NEXT(Message);
   END; (* WHILE OCCURE(Message) ... *)
   L_Basis.wb_WrStr(F, CheckQualityRepairResult);
  ELSE
   L_Basis.wb_WrStr(F, "---");
  END;
  L_Basis.wb_WrStr(F, L_Str.PoolItem("-|+", ~!CheckQualityRepairResult));
  L_Basis.wb_TermLine(F);
 END {MakePart};

 PRIVATE PROCEDURE MakeSingleRprPLevel(F: STRING[]; _RprT: LIKE(RprT.RprT); _RprJ: LIKE(RprJ.RprJ));
 BEGIN
  SELECT(RprP, RprJ, , RprS.RprS, _RprT, _RprJ, L_Rpr.rprpwho_Executor);
  WHILE OCCURE(RprP) DO
   IF (!_RprT  & !_RprJ  & SELECT(RprJ, RprS, RprS.RprS))        |
      (~!_RprT & !_RprJ  & SELECT(RprJ, RprS, RprS.RprS, _RprT)) |
      (~!_RprT & ~!_RprJ & SELECT(RprJ, RprS, RprS.RprS, _RprT, _RprJ)) THEN
    WHILE OCCURE(RprJ) DO
     MakePart(F, 1, 1);
     NEXT(RprJ);
    END; (* WHILE OCCURE(RprJ) ... *)
   ELSE
    MakePart(F, 0, 1);
   END;
   NEXT(RprP);
  END; (* WHILE OCCURE(RprP) ... *)
 END {MakeSingleRprPLevel};

 PRIVATE PROCEDURE MakeOneRprS(F: STRING[]);
 BEGIN
  L_Rpr.AccessMark(RprS.OrdDate);
  IF    SELECT(RprP, RprS, RprS.RprS, L_Rpr.rprpwho_Executor) THEN
   MakeSingleRprPLevel(F, L_General.EMPTY_NUMBER(), L_General.EMPTY_NUMBER());
   CONFORM(RprS, RprT);
   WHILE OCCURE(RprT) DO
    MakeSingleRprPLevel(F, RprT.RprT, L_General.EMPTY_NUMBER());
    CONFORM(RprT, RprJ);
    WHILE OCCURE(RprJ) DO
     SAVE(RprJ);
     MakeSingleRprPLevel(F, RprT.RprT, RprJ.RprJ);
     RESTORE(RprJ);
     NEXT(RprJ);
    END; (* WHILE OCCURE(RprJ) ... *)
    NEXT(RprT);
   END; (* WHILE OCCURE(RprT) ... *)
  ELSIF SELECT(RprJ, RprS, RprS.RprS) THEN
   WHILE OCCURE(RprJ) DO
    MakePart(F, 1, 0);
    NEXT(RprJ);
   END; (* WHILE OCCURE(RprJ) ... *)
  ELSE
   MakePart(F, 0, 0);
  END;
 END {MakeOneRprS};

 PUBLIC PROCEDURE Rpr18();
  CONST
   bpId = "Rpr18";
 BEGIN
  SE_ACCESSDATAMODE(AccessDataMode_SOFT);
  L_bp.Begin(bpId, "஢ઠ ⢠ ६⮢", L_bp.t_Basis, L_General.timeCond_InIntvl);
  FIO.Open(R, L_General.NameConnection(bpId), "REP", Create);
  MakeHeader("R");
  SELECT(RprS, OrdDate);
  SRCINSEL(RprS, GE, , Memo.ud_fr());
  WHILE OCCURE(RprS) & (RprS.OrdDate <= Memo.ud_ut()) DO
   PROMPT(RprS.RprS + " " + L_DatTim.DateStr(RprS.OrdDate));
   IF RprS.Location = L_Rpr.rprl_ServiceCenter THEN
    MakeOneRprS("R");
   END;
   NEXT(RprS);
  END; (* WHILE OCCURE(RprS) ... *)
  FIO.Close(R);
  L_bp.End();
 END {Rpr18};

END.
