(*
%Copyright   (c) Polak IT
%Author      23.06.2004 15:02:01 POLAK\LDA
%Purpose      ६⭮ ᮭ
%Type        report
%Specific    AP
%Modified    12.09.2012 12:57:53 POLAK\LDA
%Environment
*)

 MODULE Rpr27 [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT L_General, L_Car, L_Basis, FIO, L_Str, L_Rpr, Memo, P_Rpr, Math, L_DatTim, L_bp;

 PRIVATE VAR
  RprJExecutorAmount: NUMERIC[0];

 PRIVATE PROCEDURE MakeHeader(F: STRING[]);
 BEGIN
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, " ᯮ⥫");
  L_Basis.wb_WrInQM(F, "䭠 ⪠");
  L_Basis.wb_WrInQM(F, "䭠 ⪠");
  L_Basis.wb_WrInQM(F, "䭠 ⠢");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, " ");
  L_Basis.wb_WrInQM(F, " ");
  L_Basis.wb_WrInQM(F, " ꥪ ६");
  L_Basis.wb_WrInQM(F, "ꥪ ६");
  L_Basis.wb_WrInQM(F, "室");
  L_Basis.wb_WrInQM(F, "ઠ");
  L_Basis.wb_WrInQM(F, "ઠ");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "ࠣ");
  L_Basis.wb_WrInQM(F, "ࠣ");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "᪮ ");
  L_Basis.wb_WrInQM(F, "ॣ");
  L_Basis.wb_WrInQM(F, "ॣ");
  L_Basis.wb_WrInQM(F, "⠊");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "ॡ㥬 ࠧ  ࠡ");
  L_Basis.wb_WrInQM(F, "ଠ⨢ 㤮");
  L_Basis.wb_WrInQM(F, "⠍砫");
  L_Basis.wb_WrInQM(F, "⠎砭");
  L_Basis.wb_WrInQM(F, "筠 㤮");
  L_Basis.wb_TermLine(F);
 END {MakeHeader};

 PRIVATE PROCEDURE MakePart(F               : STRING[];
                            D               : DATE;
                            Coef            : FLOAT;
                            IsFailureOutput,
                            wRprT,
                            wRprJ           : SCAL[2]);
  CONST
   EmptyVal = "---";
  VAR
   RprJobClass : LIKE(RprJMG.Class);
   normBaseTime: LIKE(RprJ.BaseTime);
   dummySource : LIKE(RprJ.Source);
 BEGIN
  CONFORM(RprP, Staff);
  CONFORM(Staff, Man);
  HISTCONF(D, Staff, StaffLog);
  CONFORM(StaffLog, Sort);
  CONFORM(StaffLog, Officer);
  CONFORM(Officer,  WagePay);
  HISTCONF(D, WagePay, WagePayL);
  CONFORM(Officer, Post);
  SETEMPTY(RprJobClass, normBaseTime);
  IF wRprJ THEN
   L_Rpr.extGetRprJobBaseTime(RprJ.RprJob, RprJ.BDate, 1, normBaseTime, dummySource, RprJobClass);
  END;
  IF !RprJobClass THEN
   RprJobClass:=StaffLog.Class;
  END;
  L_Basis.wb_WrDat(F, D);
  L_Basis.wb_WrScl(F, Sort.Sort);
  L_Basis.wb_WrStr(F, Sort.Name);
  L_Basis.wb_WrScl(F, Post.Post);
  L_Basis.wb_WrStr(F, Post.Name);
  L_Basis.wb_WrScl(F, StaffLog.Class);
  L_Basis.wb_WrScl(F, WagePay.WagePay);
  L_Basis.wb_WrStr(F, WagePay.Name);
  L_Basis.wb_WrNum(F, WagePayL.Pay[Math.Max(StaffLog.Class, RprJobClass)], 2);
  L_Basis.wb_WrScl(F, RprP.TSN);
  L_Basis.wb_WrStr(F, Man.Name);
  IF wRprT THEN
   L_Basis.wb_WrStr(F, L_Str.PoolItem(L_Rpr.rpr_TaskKind_Pool, RprT.TaskKind));
  ELSE
   L_Basis.wb_WrStr(F, EmptyVal);
  END;
  L_Basis.wb_WrScl(F, RprS.RprS);
  L_Basis.wb_WrDat(F, RprS.OrdDate);
  L_Basis.wb_WrStr(F, L_Rpr.GetRprObjT_AsStr());
  L_Basis.wb_WrScl(F, RprS.RprObjId);
  IF    L_Rpr.IsRprS_w_Car() THEN
   L_Basis.wb_WrStr(F, L_Str.PoolItem("-|+", IsFailureOutput));
   L_Basis.wb_WrScl(F, Mark.Mark);
   L_Basis.wb_WrStr(F, Mark.Name);
   L_Basis.wb_WrStr(F, CarLog.Column);
   L_Basis.wb_WrStr(F, EmptyVal);
   L_Basis.wb_WrStr(F, EmptyVal);
   L_Basis.wb_WrStr(F, EmptyVal);
   L_Basis.wb_WrStr(F, EmptyVal);
   L_Basis.wb_WrStr(F, EmptyVal);
  ELSIF L_Rpr.IsRprS_w_OutCar() THEN
   L_Basis.wb_WrStr(F, EmptyVal);
   L_Basis.wb_WrScl(F, Mark.Mark);
   L_Basis.wb_WrStr(F, Mark.Name);
   L_Basis.wb_WrStr(F, EmptyVal);
   L_Basis.wb_WrScl(F, Firm.Firm);
   L_Basis.wb_WrStr(F, Firm.Name);
   L_Basis.wb_WrStr(F, EmptyVal);
   L_Basis.wb_WrStr(F, EmptyVal);
   L_Basis.wb_WrStr(F, EmptyVal);
  ELSIF L_Rpr.IsRprS_w_CarBlock() THEN
   L_Basis.wb_WrStr(F, EmptyVal);
   L_Basis.wb_WrStr(F, EmptyVal);
   L_Basis.wb_WrStr(F, EmptyVal);
   L_Basis.wb_WrStr(F, EmptyVal);
   L_Basis.wb_WrStr(F, EmptyVal);
   L_Basis.wb_WrStr(F, EmptyVal);
   L_Basis.wb_WrScl(F, Math.Math);
   L_Basis.wb_WrStr(F, Math.Name);
   L_Basis.wb_WrStr(F, CUCopy.Serial);
  ELSIF L_Rpr.IsRprS_w_OutCBlc() THEN
   L_Basis.wb_WrStr(F, EmptyVal);
   L_Basis.wb_WrStr(F, EmptyVal);
   L_Basis.wb_WrStr(F, EmptyVal);
   L_Basis.wb_WrStr(F, EmptyVal);
   L_Basis.wb_WrScl(F, Firm.Firm);
   L_Basis.wb_WrStr(F, Firm.Name);
   L_Basis.wb_WrScl(F, Math.Math);
   L_Basis.wb_WrStr(F, Math.Name);
   L_Basis.wb_WrStr(F, CUCopy.Serial);
  ELSIF L_Rpr.IsRprS_w_Math() THEN
   L_Basis.wb_WrStr(F, EmptyVal);
   L_Basis.wb_WrStr(F, EmptyVal);
   L_Basis.wb_WrStr(F, EmptyVal);
   L_Basis.wb_WrStr(F, EmptyVal);
   L_Basis.wb_WrStr(F, EmptyVal);
   L_Basis.wb_WrStr(F, EmptyVal);
   L_Basis.wb_WrScl(F, Math.Math);
   L_Basis.wb_WrStr(F, Math.Name);
   L_Basis.wb_WrStr(F, EmptyVal);
  ELSE
   L_General.CallUs(0);
  END;

  IF wRprJ THEN
   L_Basis.wb_WrScl(F, CarBlock.CarBlock);
   L_Basis.wb_WrStr(F, CarBlock.Name);
   L_Basis.wb_WrScl(F, RprJ.RprJob);
   L_Basis.wb_WrStr(F, RprJob.Name);
   L_Basis.wb_WrScl(F, RprJobClass);
(*
   IF ~!normBaseTime THEN
    normBaseTime:=(normBaseTime * RprJ.ComplCfc * RprJ.Quantity)/RprJExecutorAmount;
   END;
*)
   IF !normBaseTime THEN
    SETZERO(normBaseTime);
   END;
   L_Basis.wb_WrNum(F, normBaseTime, 3);
   IF ~!RprP.BDate THEN
    L_Basis.wb_WrDat(F, RprP.BDate);
    IF ~!RprP.EDate THEN
     L_Basis.wb_WrDat(F, RprP.EDate);
    ELSE
     L_Basis.wb_WrStr(F, EmptyVal);
    END;
   ELSE
    L_Basis.wb_WrDat(F, RprJ.BDate);
    IF ~!RprJ.EDate THEN
     L_Basis.wb_WrDat(F, RprJ.EDate);
    ELSE
     L_Basis.wb_WrStr(F, EmptyVal);
    END;
   END;
   IF ~!RprJ.BaseTime THEN
    L_Basis.wb_WrNum(F, (RprJ.BaseTime * RprJ.ComplCfc * RprJ.Quantity * Coef) / RprJExecutorAmount, 6);
   ELSE
    L_Basis.wb_WrNum(F, 0, 0);
   END;
  ELSE
   L_Basis.wb_WrStr(F, EmptyVal);
   L_Basis.wb_WrStr(F, EmptyVal);
   L_Basis.wb_WrStr(F, EmptyVal);
   L_Basis.wb_WrStr(F, EmptyVal);
   L_Basis.wb_WrNum(F, 0, 0);
   L_Basis.wb_WrStr(F, EmptyVal);
   L_Basis.wb_WrStr(F, EmptyVal);
   L_Basis.wb_WrNum(F, 0, 0);
  END;
  L_Basis.wb_TermLine(F);
 END {MakePart};

 PRIVATE PROCEDURE IsAcceptableRprP(trgRprT: LIKE(RprT.RprT); trgRprJ: LIKE(RprJ.RprJ)): SCAL[2];
 BEGIN
  RETURN !RprP.RprT |
         ((RprP.RprT = trgRprT) & (!RprP.RprJ)) |
         ((RprP.RprT = trgRprT) & (RprP.RprJ = trgRprJ))
 END {IsAcceptableRprP};

 PRIVATE PROCEDURE CalcRprJExecutorAmount(): NUMERIC[0];
  VAR
   ExecutorAmount: NUMERIC[0];
 BEGIN
  SETZERO(ExecutorAmount);
  IF SELECT(RprP, RprS, RprS.RprS, L_Rpr.rprpwho_Executor) THEN
   WHILE OCCURE(RprP) DO
    IF IsAcceptableRprP(RprJ.RprT, RprJ.RprJ) THEN
     INC(ExecutorAmount);
    END;
    NEXT(RprP);
   END; (* WHILE OCCURE(RprP) ... *)
  END;
  RETURN Math.Max(ExecutorAmount, 1);
 END {CalcRprJExecutorAmount};

 PUBLIC PROCEDURE Rpr27();
  CONST
   bpId = "Rpr27";
  VAR
   D                       : DATE;
   RprJLength,
   RprJDayLength           : FLOAT;
   IsFailureOutput         : SCAL[2];
   DayBDTS, DayEDTS,
   RprJBDTS, RprJEDTS,
   RprPWrkBDTS, RprPWrkEDTS: TIMESTAMP;
 BEGIN
  L_bp.Begin(bpId, " ࠡ ᯮ⥫", L_bp.t_Basis, L_General.tc_inIntvl);
  RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
  FIO.Open(R, L_General.NameConnection(bpId), "REP", Create);
  MakeHeader("R");

  SELECT(RprS, EDate);
  SRCINSEL(RprS, GE, , Memo.ud_fr());
  WHILE OCCURE(RprS) DO
   PROMPT(RprS.RprS);
   IF (RprS.Status # L_Rpr.ms_Cancel) & (RprS.OrdDate <= Memo.ud_ut()) THEN
    L_Rpr.AccessOrigin();
    IF    L_Rpr.IsRprS_w_Car() THEN
     L_Car.StandOnCarLog(Car.BoxNbr, RprS.OrdDate);
     CONFORM(CarLog, Mark);
    ELSIF L_Rpr.IsRprS_w_OutCar() THEN
     CONFORM(OutCar, Mark);
     CONFORM(OutCar, Firm);
    ELSIF L_Rpr.IsRprS_w_CarBlock() | L_Rpr.IsRprS_w_Math() THEN
     (*祣  *)
    ELSIF L_Rpr.IsRprS_w_OutCBlc() THEN
     CONFORM(OutCBlc, Math);
     CONFORM(OutCBlc, Firm);
    ELSE
     L_General.CallUs(0);
    END;

    IsFailureOutput:=P_Rpr.HasRprSPro(RprS.RprS, P_Rpr.P_FailureOutput);

    IF SELECT(RprT, RprS, RprS.RprS) THEN
     WHILE OCCURE(RprT) DO
      IF SELECT(RprJ, RprS, RprS.RprS, RprT.RprT) THEN
       WHILE OCCURE(RprJ) DO
        IF L_DatTim.IsActiveInIntvl_Inc(Memo.ud_fr(), Memo.ud_ut(), RprJ.BDate, RprJ.EDate) THEN
         CONFORM(RprJ, RprJob);
         CONFORM(RprJob, CarBlock);
         RprJExecutorAmount:=CalcRprJExecutorAmount();
         RprJBDTS          :=L_DatTim.GetTIMESTAMP(RprJ.BDate, RprJ.BTime);
         IF !RprJ.EDate THEN
          RprJEDTS :=L_DatTim.GetTIMESTAMP(Memo.ud_ut()+1, 00:00);
         ELSE
          RprJEDTS :=L_DatTim.GetTIMESTAMP(RprJ.EDate, RprJ.ETime);
         END;
         RprJLength:=(RprJEDTS - RprJBDTS) * 24;
  
         SELECT(RprP, RprS, , RprS.RprS, L_Rpr.rprpwho_Executor);
         WHILE OCCURE(RprP) DO
          IF IsAcceptableRprP(RprJ.RprT, RprJ.RprJ) THEN
           D:=Memo.ud_fr();
           WHILE (D <= Memo.ud_ut()) DO
            IF L_DatTim.IsActive_Inc(D, RprJ.BDate, RprJ.EDate) THEN
             IF !RprP.BDate | L_DatTim.IsActive_Inc(D, RprP.BDate, RprP.EDate) THEN
              DayBDTS:=L_DatTim.GetTIMESTAMP(D,   00:00);
              DayEDTS:=L_DatTim.GetTIMESTAMP(D+1, 00:00);
              IF ~!RprP.BDate THEN
               RprPWrkBDTS:=L_DatTim.GetTIMESTAMP(RprP.BDate, RprP.BTime);
               IF ~!RprP.EDate THEN
                RprPWrkEDTS:=L_DatTim.GetTIMESTAMP(RprP.EDate, RprP.ETime);
               ELSE
                RprPWrkEDTS:=RprJEDTS
               END;
              ELSE
               RprPWrkBDTS:=RprJBDTS;
               RprPWrkEDTS:=RprJEDTS
              END;
              RprJDayLength:=(Math.Min(DayEDTS, RprPWrkEDTS) - Math.Max(DayBDTS, RprPWrkBDTS)) * 24;
              L_General.Assert(RprJLength # 0, "㫥 த⥫쭮 ࠡ " + RprJ.RprJ + ",  " + RprJ.RprT);
              MakePart("R", D, RprJDayLength / RprJLength, IsFailureOutput, 1, 1);
             END;
            END;
            INC(D);
           END;
          END;
          NEXT(RprP);
         END; (* WHILE OCCURE(RprP) ... *)
        END;
        NEXT(RprJ);
       END; (* WHILE OCCURE(RprJ) ... *)
      ELSE
       SELECT(RprP, RprT, , RprS.RprS, RprT.RprT, L_Rpr.rprpwho_Executor);
       WHILE OCCURE(RprP) DO
        D:=Memo.ud_fr();
        WHILE (D <= Memo.ud_ut()) DO
         IF L_DatTim.IsActive_Inc(D, RprT.BDate, RprT.EDate) THEN
          MakePart("R", D, 0, IsFailureOutput, 1, 0);
         END;
         INC(D);
        END;
        NEXT(RprP);
       END; (* WHILE OCCURE(RprP) ... *)
      END;
      NEXT(RprT);
     END; (* WHILE OCCURE(RprT) ... *)
    ELSE
     SELECT(RprP, RprS, , RprS.RprS, L_Rpr.rprpwho_Executor);
     WHILE OCCURE(RprP) DO
      D:=Memo.ud_fr();
      WHILE (D <= Memo.ud_ut()) DO
       IF L_DatTim.IsActive_Inc(D, RprS.OrdDate, RprS.EDate) THEN
        MakePart("R", D, 0, IsFailureOutput, 0, 0);
       END;
       INC(D);
      END;
      NEXT(RprP);
     END; (* WHILE OCCURE(RprP) ... *)
    END;
   END;
   NEXT(RprS);
  END; (* WHILE OCCURE(RprS) ... *)
  FIO.Close(R);
  L_bp.End();
 END {Rpr27};

END.
