(*
%Copyright   (c) Polak Computer System
%Author      20.12.1996 19:29:03 GINA
%Purpose       ਣ   
%Type        operation
%Specific    sp
%Modified    19.08.2013 16:58:57 POLAK\MLB
%Environment
*)
 MODULE StMnthly [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT L_DatTim, L_Staff, L_PRoll, L_General, L_Str, L_OwnData, L_Math,
        L_AFM, Math, E_Utils, Memo, P_MCList, L_StdFrm;

 CONST
  _MCode     = 012;
  _MCodeCorr = 230;
  KTUMtyIdx  = 90;

 VAR
  _MainSalary: NUMERIC[2][2];

(*
$P{ TopSort:
L_OwnData.ODFirmName(SYSDATE()), L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
Memo.ud_mb(), L, "N.y"
SrMnthly.Sort, L, ""
Sort.Name, L, ""
L_Staff.getSortDprt(Sort.Sort), L, ""
L_Staff.getSortDprtName(Sort.Sort), L, ""
?, R, "2."
@
##################################################################################### ########## #####
------------------------------------------------------------------------------------------------------
|                  ⮪  ६  ⮤ ਣ 鸞  #######                   |
|====================================================================================================|
| ### ###########################(### ###############################)       ६ ##########%|
|----------------------------------------------------------------------------------------------------|
|. |                     ||  ६|.㬬|  | 㬬 ६|ਢ.६|६.  . |
|-----|------------------------|-|-------|---------|-----|-------------|-------------|---------------|
}
*)

(*
$P{ LineSort:
StaffLog.TSN, L, ""
L_Str.ShortName(Man.Name), L, ""
StaffLog.Class, L, ""
SLSrt._Tim, R, "1."
SLSrt._Mon, R, "2-"
SLSrt._Ktu, R, "3."
?, R, "2-"
?, R, "2-"
?, R, "2-"
@
|#####|########################|#|#######|#########|#####|#############|#############|###############|
}
*)

(*
$P{ BotSort:
?, R, "1."
?, R, "2-"
?, R, "2-"
?, R, "2-"
?, R, "2-"
@
|--------------------------------|-------|---------|-----|-------------|-------------|---------------|
|⮣                           |#######|#########|     |#############|#############|###############|
|----------------------------------------------------------------------------------------------------|
|                                                         㪮⥫ ࠧ.................|
|                                                                                                    |
|                                                                          .................|
|                                                                                                    |
|                                                         騪                 .................|
|                                                                                                    |
=(c) Polak============================================================================================
}
*)

 PRIVATE PROCEDURE _NoPayBecauseIsLeave(VAR _EndDate: LIKE(Staff.EndDate)): SCAL[2];
  VAR
   NoPay: SCAL[2];
 BEGIN
  SETEMPTY(_EndDate);
  NoPay:=0;
  SAVE(StaffLog);
  SAVE(SLKind);
  CHANGESEL(StaffLog, TSN, , StaffLog.TSN);
  WHILE OCCURE(StaffLog) & (StaffLog.Date <= Memo.ud_me()) DO
   IF L_Staff.IsDischargeStaffLog() THEN
    CONFORM(StaffLog, SLKind);
    _EndDate:=StaffLog.Date - 1;
    NoPay   :=SLKind.IsGodRsn = 0;
    LAST(StaffLog);
   END;
   NEXT(StaffLog);
  END; (* WHILE OCCURE(StaffLog) ... *)
  RESTORE(SLKind);
  RESTORE(StaffLog);
  RETURN NoPay;
 END {_NoPayBecauseIsLeave};

 PRIVATE PROCEDURE NoPayBecauseIsLeave(): SCAL[2];
  VAR
   _EndDate: LIKE(Staff.EndDate);
 BEGIN
  RETURN _NoPayBecauseIsLeave(_EndDate);
 END {NoPayBecauseIsLeave};

 PRIVATE PROCEDURE MainSalary(_Bonus: LIKE(SrMnthly.Bonus));
  VAR
   _Mon      : LIKE(Money.Sum);
   _Tim      : LIKE(Money.Tim);
   _Ktu      : LIKE(Monthly.Proof);
   NeedPay   : SCAL[2];
 BEGIN
  SETZERO(_MainSalary);
  SELECT(StaffLog, Sort, , SrMnthly.Sort);
  WHILE OCCURE(StaffLog) DO
   IF L_Staff.OrderInMonth(Memo.ud_mb()) & ~L_Staff.IsDischargeStaffLog() THEN
    CONFORM(StaffLog, Officer);
    IF E_Utils.TypeKTU_NeedOfficer(Memo.ud_me()) THEN
     CONFORM(StaffLog, Staff);
     IF ~L_PRoll.IsShtD() THEN
      L_PRoll.StaffCountUp(Staff.TSN, Memo.tmp_mb());
     END;
     SELECT(Money, PayFor, , StaffLog.TSN, Memo.ud_mb());
     SETZERO(_Mon, _Tim);
     WHILE OCCURE(Money) DO
      IF (Money.ODate = StaffLog.Date)  THEN
       CONFORM(Money,MCList);
       IF P_MCList.inBonus(MCList.MCode, Money.Period, 4) THEN
        INC(_Mon, Money.Sum);
        IF MCList.TimeType = 2 (*ந.*) THEN
         INC(_Tim, Money.Tim);
        END;
       END;
      END;
      NEXT(Money);
     END; (* WHILE OCCURE(Money)... *)
     NeedPay:=~NoPayBecauseIsLeave();
     SEARCH(Monthly, TSN, , StaffLog.TSN, Memo.ud_mb(), StaffLog.Date, 4(*ࠡ⭨*), 0(**), KTUMtyIdx);
     L_General.Assert(OCCURE(Monthly), "    "+L_DatTim.PeriodStr(Memo.ud_mb())+" : ࠡ⭨ "+StaffLog.TSN);
     _Ktu:=Monthly.Proof;
     IF NeedPay THEN
      INC(_MainSalary[0], _Mon*_Bonus/100     ); (*㬬 ६*)
      INC(_MainSalary[1], _Mon*_Ktu*_Bonus/100); (*ਢ 㬬 ६*)
     END;
     SLSrt._Sort:=StaffLog.Sort;
     SLSrt._TSN :=StaffLog.TSN;
     SLSrt._Date:=StaffLog.Date;
     SLSrt._Mon :=_Mon;
     SLSrt._Tim :=_Tim;
     SLSrt._Ktu :=_Ktu;
     SLSrt._Need:=NeedPay;
     INSERT(SLSrt);
    END;
   END;
   NEXT(StaffLog);
  END; (* WHILE OCCURE(StaffLog)... *)
 END {MainSalary};

 PRIVATE PROCEDURE SpreadAddSalary(_Bonus: LIKE(SrMnthly.Bonus));
  VAR
   tMon,
   _Bas, tBas, _BasCorr,
   _Pay, tPay,
   _wKtu,
   twKtu     : NUMERIC[2];
   tTim      : NUMERIC[3];
   _Prc      : NUMERIC[6];
 BEGIN
  MAKEPART(R, TopSort,  _Bonus);
  IF _MainSalary[1] # 0 THEN
   _Prc:=_MainSalary[0]/_MainSalary[1];
  ELSE
   L_StdFrm.Choice("㫥 㬬 ६  ⮬   ਣ " + SrMnthly.Sort);
   _Prc:=0;
  END;
  SETZERO(tMon, tBas, tTim, tPay, twKtu);
  SELECT(SLSrt, SLSrt, , SrMnthly.Sort);
  WHILE OCCURE(SLSrt) DO
   SEARCH(StaffLog, TSN, , SLSrt._TSN, SLSrt._Date);
   CONFORM(StaffLog, Staff, Man);
   _Bas :=SLSrt._Mon*SLSrt._Need*_Bonus/100;
   _wKtu:=_Bas * SLSrt._Ktu;
   _Pay :=_wKtu * _Prc;
   IF (Memo.ud_mb()>=01\09\2009) & (SLSrt._Ktu # 1.000) THEN
    L_PRoll.SaveMoney(+1, _MCode,     Memo.ud_mb(), L_PRoll.src_KTU,     _Bas, SLSrt._Tim);
    _BasCorr:=_Pay-_Bas;
    L_PRoll.SaveMoney(+1, _MCodeCorr, Memo.ud_mb(), L_PRoll.src_KTU, _BasCorr, SLSrt._Tim);
   ELSE
    L_PRoll.SaveMoney(+1, _MCode, Memo.ud_mb(), L_PRoll.src_KTU, _Pay, SLSrt._Tim);
   END;
   MAKEPART(R, LineSort, _Bas, _wKtu, _Pay);
   INC(tMon, SLSrt._Mon);
   INC(tTim, SLSrt._Tim);
   INC(tBas, _Bas);
   INC(tPay, _Pay);
   INC(twKtu, _wKtu);
   NEXT(SLSrt);
  END;
  MAKEPART(R, BotSort, tTim, tMon, tBas, twKtu, tPay);
  FORMFEED(R);
 END {SpreadAddSalary};

 PRIVATE PROCEDURE SetAllShtDoneToZero();
 BEGIN
  SELECT(SrMnthly, Period, , Memo.ud_mb());
  WHILE OCCURE(SrMnthly) DO
   SELECT(SLSrt, SLSrt, , SrMnthly.Sort);
   WHILE OCCURE(SLSrt) DO
    PROMPT(SLSrt._Sort + " " + SLSrt._TSN);
    SEARCH(Staff, TSN, , SLSrt._TSN);
    L_PRoll.ShtDone(0);
    NEXT(SLSrt);
   END;
   NEXT(SrMnthly);
  END; (* WHILE OCCURE(SrMnthly) ... *)
 END {SetAllShtDoneToZero};

 PRIVATE PROCEDURE NeedClear(_Source: LIKE(Money.Source)): SCAL[2];
 BEGIN
  SELECT(Money, TSN, , Staff.TSN);
  SRCINSEL(Money, GE, , Memo.gl_mb());
  WHILE OCCURE(Money) DO
   IF (Money.WFPeriod >= Memo.gl_mb()) & (Money.Source = _Source) THEN
    RETURN 1;
   END;
   NEXT(Money);
  END; (* WHILE OCCURE(Money) ... *)
  RETURN 0;
 END {NeedClear};

 PRIVATE PROCEDURE AccessMCList(_MCode: LIKE(Money.MCode));
 BEGIN
  L_General.Assert(SEARCH(MCList, MCode, _MCode) &
                   L_DatTim.InPatIntvl(MCList.Begin, MCList.Till, Memo.gl_mb(), Memo.gl_me()),
                   "  "+_MCode+"    "+L_DatTim.PeriodStr(Memo.ud_mb()));
 END {AccessMCList};

 PUBLIC PROCEDURE Calc();
 BEGIN
  L_StdFrm.JustQuestion("  ਣ   "+L_DatTim.PeriodStr(Memo.ud_mb()));
  AccessMCList(_MCode);
  IF Memo.ud_mb()>=01\09\2009 THEN
   AccessMCList(_MCodeCorr);
  END;
  SELECT(SrMnthly, Period, , Memo.ud_mb());
  WHILE OCCURE(SrMnthly) DO
   L_General.Assert(~SrMnthly.Done, "室 믮 ' १⮢' ");
   NEXT(SrMnthly);
  END; (* WHILE OCCURE(SrMnthly) ... *)

  OPENREP(R, L_General.NameMonth("SRM"), Create);
  L_AFM.MakeIndex("SLSrt", "_Sort  : LIKE(Sort.Sort);"+
                              "_TSN   : LIKE(StaffLog.TSN);"+
                              "_Date  : DATE;"+
                              "_Mon   : LIKE(Money.Sum);"+
                              "_Tim   : LIKE(Money.Tim);"+
                              "_Ktu   : NUMERIC[3];"+
                              "_Need  : SCAL[2]");
 
  SELECT(SrMnthly, Period, , Memo.ud_mb());
  WHILE OCCURE(SrMnthly) DO
   PROMPT(" "+SrMnthly.Sort);
   CONFORM(SrMnthly, Sort);
   MainSalary(SrMnthly.Bonus);
   SpreadAddSalary(SrMnthly.Bonus);
   SrMnthly.Done:=1;
   REPLACE(SrMnthly);
   NEXT(SrMnthly);
  END; (* WHILE OCCURE(SrMnthly ... *)

  SetAllShtDoneToZero();
  L_AFM.AF_PurgeTemp("SLSrt");
  CLOSEREP(R);
  LIKEMENU(Survey, "");
 END {Calc};

 PUBLIC PROCEDURE Clear();
 BEGIN
  L_StdFrm.Choice(" १⮢  ਣ   "+ L_DatTim.PeriodStr(Memo.ud_mb()));
  L_PRoll.Salary_CheckClcPer();

  SELECT(Staff, TSN);
  WHILE OCCURE(Staff) DO
   PROMPT("⪠ "+Staff.TSN);
   IF NeedClear(L_PRoll.src_KTU) THEN
    L_PRoll.ShtDone(0);
   END;
   L_PRoll.ClearMoney(L_PRoll.src_KTU);
   NEXT(Staff);
  END; (* WHILE OCCURE(Staff)... *)

  SELECT(SrMnthly, Period, , Memo.ud_mb());
  WHILE OCCURE(SrMnthly) DO
   SrMnthly.Done:=0;
   REPLACE(SrMnthly);
   NEXT(SrMnthly);
  END; (* WHILE OCCURE(SrMnthly) ... *)
 END {Clear};

END.
