(*
%Copyright   (c) Polak IT
%Author      24.04.2003 12:26:08 POLAK\RSN
%Purpose     Excel (ole)   楫  a/
%Type        report
%Specific    AP_PC
%Modified    15.02.2013 09:59:07 POLAK\MLB
%Environment
*)

 MODULE x_CD001 [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT L_General, L_DatTim, L_OLE, L_AFM, D_CarTb, L_Car, E_Way;

 CONST
  prm_Mark    = "ઠ";
  prm_CDay    = "";
  prm_WD      = "썥";
  prm_Purpose = "祭";
  prm_Column  = "";
  MaxKey   = 128;

 VAR
  IntvlB,
  IntvlE : DATE;

  v_Mark,
  v_WD,
  v_DtlRCD,
  v_Purpose,
  v_Column  : L_OLE.tKeyValue[MaxKey];

 PRIVATE PROCEDURE Create_CD001();
 BEGIN
  CreateFILE(CD001, "", "設-  ઠ", "");

  CreateFIELD(CD001, Mark,    SCAL[1E4],          "", "", "", "ઠ", "");
  CreateFIELD(CD001, BoxNbr,  SCAL[1E4],          "", "",  "", "ࠦ", "");
  CreateFIELD(CD001, Purpose, SCAL[5],            "", "",  "", "祭", "");
  CreateFIELD(CD001, Column,  SCAL[100],          "", "",  "", "", "");
  CreateFIELD(CD001, WD,      SCAL[2],            "", "",  "", "  ", "0-㤭, 1 -室");
  CreateFIELD(CD001, DtlRCD,  D_CarTb.DtlRCDType, "", "", "", " 設-", "");
  CreateFIELD(CD001, Days,    NUMERIC[12, 0],     "", "", "", "⢮ 設-", "");
  CreateFIELD(CD001, Run,     NUMERIC[12, 2],     "", "", "", "஡", "");

  CreateINDEXandLINK(CD001, Mark, UNIQUE, Mark, Mark, USER, "", "", Mark, BoxNbr, DtlRCD, WD, Purpose, Column);
  SetVersionOfFILE(CD001, 0002);
 END {Create_D001};

 PRIVATE PROCEDURE FillParams(Heap: STRING[]);
  VAR
   Params     : STRING[][32];
 BEGIN
  L_OLE.SliceBySingle(Heap, Params);
  L_OLE.FillByKeyWord(Params, prm_Mark,    v_Mark);
  L_OLE.FillByKeyWord(Params, prm_CDay,    v_DtlRCD);
  L_OLE.FillByKeyWord(Params, prm_WD,      v_WD);
  L_OLE.FillByKeyWord(Params, prm_Purpose, v_Purpose);
  L_OLE.FillByKeyWord(Params, prm_Column,  v_Column);
 END {FillParams};

 PRIVATE PROCEDURE PutToCD001(_DtlRCD: D_CarTb.DtlRCDType;
                      _Days  : NUMERIC[4];
                      _Run   : NUMERIC[2]);
 BEGIN
  ADD(CD001, Mark, , Mark.Mark, Car.BoxNbr, _DtlRCD, Calendar.WDWay > L_DatTim.wd_Fri, CarLog.Purpose,
                     CarLog.Column,
             CD001.Days, _Days,
             CD001.Run, _Run);
 END {PutToCD001};

 PRIVATE PROCEDURE Prepare_CD001(ForceRebuild: SCAL[2]);
 BEGIN
  Create_CD001();
  L_AFM.NewReusableFile("CD001", "CD001", L_General.timeCond_InIntvl, IntvlB, IntvlE);
  IF ForceRebuild | ~L_AFM.CanReuseFile("CD001", 1) THEN
   L_AFM.CreateReusableFile("CD001");
   D_CarTb.extPrepare_CarTb(IntvlB, IntvlE, 0, ~ForceRebuild);
   SELECT(Car, BoxNbr);
   WHILE OCCURE(Car) DO
    SELECT(Calendar, Date);
    SRCINSEL(Calendar, GE, , IntvlB);
    WHILE OCCURE(Calendar) & (Calendar.Date <= IntvlE) DO
     PROMPT(": " + Car.BoxNbr + ", " + L_DatTim.DateStr(Calendar.Date));
     IF L_Car.CarIsInOperation(Car.BoxNbr, Calendar.Date) THEN
      CONFORM(CarLog, Mark);
      PutToCD001(D_CarTb.dtlRCD_InState, 1, 0);
      PutToCD001(D_CarTb.dtlRCD_Inventory, 1/(IntvlE-IntvlB+1), 0);
      IF SELECT(CarTb, BoxNbr, Car.BoxNbr, Calendar.Date) THEN
       PutToCD001(E_Way.DtlRCarDay(Car.BoxNbr, Calendar.Date),
                  1,
                  D_CarTb.CarTb_GetRunTot(Car.BoxNbr, Calendar.Date));
      ELSE
       PutToCD001(D_CarTb.dtlRCD_NoData, 1, 0);
      END;
     ELSE
(*
      L_General.Assert(~OCCURE(CarTb),
                       "㤠 ଠ  ᯨᠭ ");
*)
     END; (* IF L_DatTim.IsActive ... *)
     NEXT(Calendar);
    END; (* WHILE OCCURE(Calendar) ... *)
    NEXT(Car);
   END; (* WHILE OCCURE(Car) ... *)

   L_AFM.ReAttachReusableFile("CD001");
  END; (* IF ~CanReuseFile ... *)
 END {Prepare_CD001};

 PUBLIC PROCEDURE CD001_GetCarAmnt(Heap: STRING[]):  NUMERIC[0];
  VAR
   Amnt, i: NUMERIC[0];
 BEGIN
  FillParams(Heap);
  SETZERO(Amnt);
  IF L_OLE.HasCondition(v_Mark) THEN
   i:=0;
   WHILE ~!v_Mark[i] DO
    IF SELECT(CD001, Mark, v_Mark[i]) THEN
     WHILE OCCURE(CD001) DO
      NARROWSEL(CD001, BoxNbr);
      LAST(CD001);
      IF L_OLE.Check(CD001.Purpose, v_Purpose) &
         L_OLE.Check(CD001.Column,  v_Column) THEN
       INC(Amnt);
      END;
      NEXTINEXTENDEDSEL(CD001, BoxNbr);
     END (*WHILE OCCURE(CD001...*);
    END;
    INC(i);
   END;
  END;
  RETURN Amnt;
 END {CD001_GetCarAmnt};

 PUBLIC PROCEDURE CD001_GetDaysCount(Heap: STRING[]):  NUMERIC[0];
  VAR
   Amnt,
   i    : NUMERIC[0];
 BEGIN
  FillParams(Heap);
  SETZERO(Amnt);
  IF L_OLE.HasCondition(v_Mark) THEN
   i:=0;
   WHILE ~!v_Mark[i] DO
    IF SELECT(CD001, Mark, v_Mark[i]) THEN
     WHILE OCCURE(CD001) DO
      IF L_OLE.Check(CD001.DtlRCD,  v_DtlRCD) &
         L_OLE.Check(CD001.WD,      v_WD) &
         L_OLE.Check(CD001.Purpose, v_Purpose) &
         L_OLE.Check(CD001.Column,  v_Column) THEN
       INC(Amnt, CD001.Days);
      END;
      NEXT(CD001);
     END (*WHILE OCCURE(CD001...*);
    END;
    INC(i);
   END;
  END;
  RETURN Amnt;
 END {CD001_GetDaysCount};

 PUBLIC PROCEDURE CD001_GetMarkRun(Heap: STRING[]): NUMERIC[2];
  VAR
   _Run: NUMERIC[2];
   i   : NUMERIC[0];
 BEGIN
  FillParams(Heap);
  SETZERO(_Run);
  IF L_OLE.HasCondition(v_Mark) THEN
   i:=0;
   WHILE ~!v_Mark[i] DO
    IF SELECT(CD001, Mark, v_Mark[i]) THEN
     WHILE OCCURE(CD001) DO
      IF L_OLE.Check(CD001.WD,      v_WD) &
         L_OLE.Check(CD001.Purpose, v_Purpose) &
         L_OLE.Check(CD001.Column,  v_Column) THEN
       INC(_Run, CD001.Run);
      END;
      NEXT(CD001);
     END (*WHILE OCCURE(CD001...*);
    END;
    INC(i);
   END;
  END;
  RETURN _Run;
 END {CD001_GetMarkRun};

 PUBLIC PROCEDURE oleInit(_IntvlB, _IntvlE: DATE);
 BEGIN
  IntvlB:=_IntvlB;
  IntvlE:=_IntvlE;
  Prepare_CD001(0);
 END {oleInit};

 PUBLIC PROCEDURE oleDeInit();
 BEGIN
  DetachFILE(CD001, Purge);
 END {oleDeInit};

 PUBLIC PROCEDURE oleInit_wRebuild(_IntvlB, _IntvlE: DATE);
 BEGIN
  IntvlB:=_IntvlB;
  IntvlE:=_IntvlE;
  Prepare_CD001(1);
 END {oleInit};

BEGIN
 SE_ACCESSDATAMODE(AccessDataMode_SOFT);
END.
