(*
%Copyright   (c) Polak IT
%Author      31.07.2003 18:07:51 POLAK\RSN
%Purpose        ࠦ
%Type        report
%Specific    LOC
%Modified    18.02.2013 10:02:58 POLAK\LDA
%Environment
*)

 MODULE Car03 [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT Memo, L_General, L_DatTim, L_Car, L_Env, FIO, L_Basis, L_bp;

 PRIVATE VAR
  _Date    : DATE;
  _VPNbr   : LIKE(VehPasp.VPNbr);
  _ChassNum: LIKE(VehPasp.ChassNum);
  _EnginMod: LIKE(VehPasp.EnginMod);
  _EnginNum: LIKE(VehPasp.EnginNum);
  _VIN     : LIKE(VehPasp.VIN);

 PRIVATE PROCEDURE MakeHeader(F: STRING[]);
 BEGIN
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "᭮");
  L_Basis.wb_WrInQM(F, "ઠ");
  L_Basis.wb_WrInQM(F, "ઠ");
  L_Basis.wb_WrInQM(F, " ");
  L_Basis.wb_WrInQM(F, "  ");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, " ");
  L_Basis.wb_WrInQM(F, " ");
  L_Basis.wb_WrInQM(F, "VIN");
  L_Basis.wb_TermLine(F);
 END {MakeHeader};

 PRIVATE PROCEDURE MakePart(F: STRING[]);
 BEGIN
  L_Basis.wb_WrScl(F, CarLog.BoxNbr);
  L_Basis.wb_WrStr(F, CarLog.StateNbr);
  L_Basis.wb_WrScl(F, CarLog.Mark);
  L_Basis.wb_WrStr(F, Mark.Name);
  L_Basis.wb_WrStr(F, FLDTOSTR(_Date, "y"));
  L_Basis.wb_WrStr(F, _VPNbr);
  L_Basis.wb_WrStr(F, _ChassNum);
  L_Basis.wb_WrStr(F, _EnginMod);
  L_Basis.wb_WrStr(F, _EnginNum);
  L_Basis.wb_WrStr(F, _VIN);
  L_Basis.wb_TermLine(F);
 END {MakePart};

 PUBLIC PROCEDURE Car03();
  CONST
   bpId = "Car03";
 BEGIN
  RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
  L_bp.Begin(bpId, "⠢ ઠ", L_bp.t_Basis, L_General.timeCond_OnDate);
  FIO.Open(R, L_General.NameConnection(bpId), "REP", Create);
 
  MakeHeader("R");
 
  SELECT(Car, BoxNbr);
  WHILE OCCURE(Car) DO
   PROMPT(Car.BoxNbr);
   IF L_Env.RealBoxNbr(Car.BoxNbr) &
      L_DatTim.IsActive(Memo.ud_cd(), Car.BegDate, Car.EndDate) THEN
    L_Car.StandOnCarLog(Car.BoxNbr, Memo.ud_cd());
    CONFORM(CarLog, Mark);
    CONFORM(CarLog, VehPasp);
    IF OCCURE(VehPasp) THEN
     _VPNbr   :=VehPasp.VPNbr;
     _ChassNum:=VehPasp.ChassNum;
     _EnginMod:=VehPasp.EnginMod;
     _EnginNum:=VehPasp.EnginNum;
     _VIN     :=VehPasp.VIN;
    ELSE
     SETEMPTY(_VPNbr, _ChassNum, _EnginMod, _EnginNum, _VIN);
    END;
    _Date:=L_Car.GetCarProdDate(Car.BoxNbr, Memo.ud_cd());
    MakePart("R");
   END;
   NEXT(Car);
  END; (* WHILE OCCURE(Car) ... *)
  FIO.Close(R);
  L_bp.End();
 END {Car03};

END.
