(*
%Copyright   (c) Polak Computer System
%Author      21.11.2002 15:38:56 POLAK\RSN
%Purpose     । 䮭 ਣ
%Type        operation
%Specific    SP
%Modified    23.10.2012 13:45:31 POLAK\San
%Environment
*)

 IMPORT Memo, L_General, L_DatTim, L_AFM, L_Staff, P_Sort, E_Prop, L_AP, L_OwnData,
        L_Str, L_EDO;

 PRIVATE CONST
  KTUMtyIdx = 90;
  RepName   = "DrBon";

 PRIVATE VAR
  _MainSalary: NUMERIC[2][2];
  _HPay      : NUMERIC[2];
  Basic      : SCAL[2];

(*
$P{ Top:
L_OwnData.ODFirmName(SYSDATE()), L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
RepName, L, ""
Memo.ud_mb(), L, "N.y"
L_EDO.FOrderName()+" ( "+FOrder.FOrder+")", C, ""
" ᫥ "+MCList.MCode+" "+MCList.Name, C, ""
@
############################################################# ########## #####
=#####========================================================================
|            ⮪  ६  䮭 ਣ  #######           |
|############################################################################|
|############################################################################|
}
*)

(*
$P{ TopSort:
Sort.Sort, L, ""
Sort.Name, L, ""
?, R, "2-"
@
|============================================================================|
| ### ############################################## 㬬   ######|
|----------------------------------------------------------------------------|
|. |                 |    ६|  |      |    |     ६|
|-----|--------------------|---------|-----|----------|----------|-----------|
}
*)

(*
$P{ LineSort:
StaffLog.TSN, L, ""
L_Str.ShortName(Man.Name), L, ""
?, R, "3."
?, R, "3."
?, R, "2-"
?, R, "2-"
?, R, "2-"
@
|#####|####################|#########|#####|##########|##########|###########|
}
*)

(*
$P{ BotSort:
?, R, "3."
?, R, "2-"
?, R, "2-"
?, R, "2-"
@
|--------------------------|---------|-----|----------|----------|-----------|
|⮣                     |#########|     |##########|##########|###########|
|----------------------------------------------------------------------------|
|                                                                            |
|          㪮⥫ ࠧ ___________________ /................./|
=(c) Polak====================================================================
}
*)

 PRIVATE PROCEDURE AcsDrMonthly(_MtyIdx: LIKE(Monthly.MtyIdx)): LIKE(Monthly.Proof);
 BEGIN
  RETURN L_AP.AcsMonthly(L_AP.mthlWho_Driver, L_AP.mthlSrc_RWayS, _MtyIdx);
 END {AcsDrMonthly};

 PRIVATE PROCEDURE MainSalary(_Pay: NUMERIC[2]);
  VAR
   _Mon      : LIKE(Money.Sum);
   _Tim      : LIKE(Money.Tim);
   _Ktu      : LIKE(Monthly.Proof);
 BEGIN
  SETZERO(_MainSalary);
  SELECT(StaffLog, Sort, , Sort.Sort);
  WHILE OCCURE(StaffLog) DO
   IF L_Staff.OrderInMonth(Memo.ud_mb()) & ~L_Staff.IsDischargeStaffLog() THEN
    CONFORM(StaffLog, Staff);
    SETZERO(_Mon, _Tim);
    INC(_Tim, (AcsDrMonthly(09) + AcsDrMonthly(13) + AcsDrMonthly(23)));
    INC(_Mon, _Tim*_Pay);
    SEARCH(Monthly, TSN, , StaffLog.TSN, Memo.ud_mb(), StaffLog.Date, 4(*ࠡ⭨*), 0(**), KTUMtyIdx);
    L_General.Assert(OCCURE(Monthly), "    "+L_DatTim.PeriodStr(Memo.ud_mb())+" : ࠡ⭨ "+StaffLog.TSN);
    _Ktu:=Monthly.Proof;
    INC(_MainSalary[0], _Mon     );
    INC(_MainSalary[1], _Mon*_Ktu);
    SLSrt._Sort:=StaffLog.Sort;
    SLSrt._TSN :=StaffLog.TSN;
    SLSrt._Date:=StaffLog.Date;
    SLSrt._Mon :=_Mon;
    SLSrt._Tim :=_Tim;
    SLSrt._Ktu :=_Ktu;
    INSERT(SLSrt);
   END;
   NEXT(StaffLog);
  END; (* WHILE OCCURE(StaffLog)... *)
 END {MainSalary};

 PRIVATE PROCEDURE SpreadAddSalary(_Pay: NUMERIC[2]);
  VAR
   tMon, tBas,
   tSum, _Bas,
   _Sum      : NUMERIC[2];
   tTim      : NUMERIC[3];
   _Prc      : NUMERIC[6];
 BEGIN
  L_General.Assert(_MainSalary[1]#0, "㫥 㬬 ᭮ ௫  ਣ "+Sort.Sort);
  MAKEPART(R, TopSort, _Pay);
  SETZERO(tMon, tBas, tTim, tSum);
  _Prc:=_MainSalary[0]/_MainSalary[1];
  SELECT(SLSrt, SLSrt, , Sort.Sort);
  WHILE OCCURE(SLSrt) DO
   IF SLSrt._Mon > 0 THEN
    _Bas:=SLSrt._Mon*SLSrt._Ktu;
    _Sum:=_Bas * _Prc;
    IF SLSrt._Ktu # 1.000 THEN
     IF Basic THEN
      _Sum:=SLSrt._Mon;
     ELSE
      _Sum:=_Sum-SLSrt._Mon;
     END;
    ELSE
     IF ~Basic THEN
      _Sum:=0;
     END;
    END;
    SEARCH(StaffLog, TSN, , SLSrt._TSN, SLSrt._Date);
    CONFORM(StaffLog, Staff, Man);
    IF _Sum # 0 THEN
     L_EDO.AppendFOrderL(SLSrt._Tim, _Sum);
    END;
    IF Basic | (_Sum#0) THEN
     MAKEPART(R, LineSort, SLSrt._Tim, SLSrt._Ktu, SLSrt._Mon, _Bas, _Sum);
    END;
    INC(tMon, SLSrt._Mon);
    INC(tTim, SLSrt._Tim);
    INC(tBas, _Bas);
    INC(tSum, _Sum);
   END;
   NEXT(SLSrt);
  END;
  MAKEPART(R, BotSort, tTim, tMon, tBas, tSum);
 END {SpreadAddSalary};

 PRIVATE PROCEDURE CheckRWayS();
 BEGIN
  IF SELECT(RWayS, sDate, 2) & SRCINSEL(RWayS, LE, Memo.ud_me()) &
     L_DatTim.IsActive_Inc(RWayS.Date, Memo.ud_mb(), Memo.ud_me()) THEN
   L_General.Error(" ⠪஢   " + L_DatTim.PeriodStr(Memo.ud_mb()) + ", ਬ "+RWayS.RWayS);
  END;
 
  SETSEL(RWayS, Done, 0);
  IF SRCINSEL(RWayS, GE, Memo.ud_mb()) & (RWayS.Date<=Memo.ud_me()) THEN
   L_General.Error(" ࠡ⠭   " + L_DatTim.PeriodStr(Memo.ud_mb()) + ", ਬ "+RWayS.RWayS);
  END;
 END {CheckRWayS};

 PUBLIC PROCEDURE FO_DrBon();
 BEGIN
  RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
  L_EDO.InitPrepareFOrder();
 
  Basic:=FOrder.MCode=034;
  STDFORM("|᫥ ६ ⥫  ⮬    "+FOrder.MCode+
          "||%<४஢  | 稭>I"+
          "||%< {}믮 >DB   %< {}⬥ >X",
          "ନ஢ ਪ", , -1, Basic);

  L_General.Assert(FOrder.Closed = Memo.ud_mb(), "᫥    " + L_DatTim.PeriodStr(Memo.ud_mb()));
  L_General.Assert(FOrder.Period = Memo.ud_mb(), "᫥    ⥪騩 ");
 
  FOrder.Sum:=0;
 
  CheckRWayS();
  OPENREP(R, L_General.NameConnection(RepName), Create);
  CONFORM(FOrder, MCList);
  MAKEPART(R, Top);
  L_AFM.MakeIndex("SLSrt", "_Sort  : LIKE(Sort.Sort);"+
                           "_TSN   : LIKE(StaffLog.TSN);"+
                           "_Date  : DATE;"+
                           "_Mon   : LIKE(Money.Sum);"+
                           "_Tim   : LIKE(Money.Tim);"+
                           "_Ktu   : NUMERIC[3]");
 
  SELECT(Sort, Sort);
  WHILE OCCURE(Sort) DO
   PROMPT(" "+Sort.Sort);
   IF P_Sort.HasActualPro(Sort.Sort, Memo.ud_mb(), E_Prop.P_DrBrigadeBonus) THEN
    _HPay:=STRTOFLD(SortPro.Value, NUMERIC);
    MainSalary(_HPay);
    SpreadAddSalary(_HPay);
   END;
   NEXT(Sort);
  END; (* WHILE OCCURE(Sort ... *)
 
  REPLACE(FOrder);
  L_AFM.AF_PurgeTemp("SLSrt");
  CLOSEREP(R);
  L_General.SurveyLastReport();
 END {FO_DrBon};

END.
