(*
%Copyright   (c) Polak IT
%Author      18.06.2004 12:28:04 POLAK\LDA
%Purpose      訥     ᥣ
%Type        report
%Specific    LOC
%Modified    10.04.2012 13:22:25 ROBOT by POLAK\LDA
%Environment
*)

 IMPORT L_General, L_OwnData, L_BegRWS, L_Car, L_Way, L_AFM, L_Str, L_XDoc,
        L_DatTim, L_RT;

 CONST
  RepName = "LostC";

(*
$P{ Top:
L_OwnData.ODFirmName(SYSDATE()), L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
RepName, L, ""
?, L, "D.N.y"
?, L, "H:M"
@
############################################################# ########## #####
=#####========================================================================
|                 訥     ########## #####                |
|----------------------------------------------------------------------------|
||     |室    |.|ઠ            |⥫            || |
|-|-------|---------|----|-----------------|--------------------|-----|------|
}
*)

(*
$P{ Line:
L_RT.IsCarInPark(), L, " |+"
TmpRW.RWayS, L, ""
RWayS.Exit, L, ""
RWayS.BoxNbr, L, ""
Mark.Mark, L, ""
Mark.Name, L, ""
RWayS.TSN, L, ""
L_Str.ShortName(Man.Name), L, ""
TmpRW.EnterTim, L, "H:M"
TmpRW.Delay, R, "0"
@
|#|#######|#########|####|#### ############|##### ##############|#####|######|
}
*)

(*
$P{ Bot:
@
=(c) Polak====================================================================
}
*)

 PRIVATE PROCEDURE Create_TmpRW();
 BEGIN
  CreateFILE(TmpRW, "", "⥫ ", "");

  CreateFIELD(TmpRW, RWayS,    LIKE(RWayS.RWayS),    "", "", "", "", "");
  CreateFIELD(TmpRW, EnterTim, TIME, "", "", "", "६ ", "");
  CreateFIELD(TmpRW, Delay,    NUMERIC[0], "", "", "", "", "");

  CreateINDEXandLINK(TmpRW, RWayS,  PLURAL, RWayS,  RWayS,  USER, "", "", RWayS);

  CreateINDEX(TmpRW, Delay, PLURAL, "", "", Delay);

  SetVersionOfFILE(TmpRW, 0);
  L_AFM.AF_CreateTemp("TmpRW", "TmpRW");
 END {Create_TmpRW};

 PRIVATE PROCEDURE StandOnPair(): SCAL[2];
 BEGIN
  CHANGESEL(RWayS, BoxNbr, , RWayS.BoxNbr);
  IF NEXT(RWayS) & (RWayS.Date = SYSDATE()) & (RWayS.Change = 2) THEN
   CONFORM(RWayS, StExit);
   IF StExit.OutBox = 1(* *) THEN
    RETURN 1;
   END;
  END; (* IF NEXT(RWayS) ... *)
  RETURN 0;
 END {StandOnPair};

 PRIVATE PROCEDURE GetRWaySEnterTime(): TIME;
  VAR
   _EnterTime  : TIME;
   SecondChange: SCAL[2];
 BEGIN
  SETEMPTY(_EnterTime);
  SecondChange:=0;
  SAVE(RWayS);
  SAVE(StExit);
  IF    (RWayS.Change = 1) & StandOnPair() THEN
   _EnterTime  :=L_BegRWS.GetRWaySEnterTime(1);
   SecondChange:=1;
  END;
  RESTORE(StExit);
  RESTORE(RWayS);
  IF SecondChange THEN
   RETURN _EnterTime;
  ELSE
   RETURN L_BegRWS.GetRWaySEnterTime(1);
  END;
 END {GetRWaySEnterTime};

 PRIVATE PROCEDURE MakeIndex(onDate: DATE;
                     onTime: TIME);
  CONST
   AllowedDelay = 29;
  VAR
   _Delay    : NUMERIC[0];
   ExitTime,
   EnterTime : TIME;
   crTime,
   dlTime    : FLOAT;
 BEGIN
  Create_TmpRW();
  SELECT(RWayS, sDate, , L_Way.rwsStat_Given);
  WHILE OCCURE(RWayS) DO
   PROMPT("ࠡ⪠ " + RWayS.RWayS);

   CONFORM(RWayS, StExit);
   ExitTime :=L_BegRWS.GetRWaySExitTime(1);
   EnterTime:=GetRWaySEnterTime();
   IF ~!EnterTime THEN
    PackVARIANTDATE(crTime, onDate,                              onTime);
    PackVARIANTDATE(dlTime, RWayS.Date + (EnterTime < ExitTime), EnterTime);
    _Delay:=(crTime-dlTime) * 24 * 60;
    IF _Delay > AllowedDelay THEN
     TmpRW.RWayS   :=RWayS.RWayS;
     TmpRW.EnterTim:=EnterTime;
     TmpRW.Delay   :=_Delay;
     INSERT(TmpRW);
    END;
   END;
   NEXT(RWayS);
  END; (* WHILE OCCURE(RWayS) ... *)
 END {MakeIndex};

 PRIVATE PROCEDURE MakeRep(OnDate: DATE;
                   OnTime: TIME);
 BEGIN
  L_XDoc.sl_Init(" 訥   ");
  OPENREP(R, L_General.NameConnection(RepName), Create);
  MAKEPART(R, Top, OnDate, OnTime);
  SELECT(TmpRW, Delay);
  LAST(TmpRW);
  WHILE OCCURE(TmpRW) DO
   PROMPT(" " + TmpRW.RWayS);
   CONFORM(TmpRW, RWayS);
   CONFORM(RWayS, Staff);
   CONFORM(Staff, Man);
   L_Car.AccessMark(RWayS.BoxNbr, RWayS.Date);
   L_XDoc.sl_AddItem(L_XDoc.XDocId(L_XDoc.xdt_RWayS, L_XDoc.EmptyXDocKind, RWayS.RWayS),
                     RWayS.RWayS + " " +
                     L_DatTim.DateStr(RWayS.Date));
   MAKEPART(R, Line);
   PREV(TmpRW);
  END; (* WHILE OCCURE(TmpRW) ... *)
  MAKEPART(R, Bot);
  CLOSEREP(R);
  L_AFM.AF_PurgeTemp("TmpRW");
  L_XDoc.sl_Done();
 END {MakeRep};

BEGIN
 IF MODE = 100 THEN
  MakeIndex(SYSDATE(), SYSTIME());
  MakeRep(SYSDATE(), SYSTIME());
 ELSE
  L_General.BadMode(MODE);
 END;
END.
