(*
%Copyright   (c) Polak Computer System
%Author      28.04.2004 09:33:29 POLAK\LDA
%Purpose      ⥢ 
%Type        report
%Specific    LOC
%Modified    17.10.2013 17:44:08 POLAK\GAV
%Environment
*)   

 IMPORT P_Car, L_Way, L_BegRWS, L_DatTim, Str, L_Str, P_Man, P_Mark,
        L_Prop, E_Prop, P_Staff, P_OwnData, E_Way, L_Car, L_Print,
        L_RWSP, L_Fuel, L_AFM, L_General, L_FIO;

 PRIVATE PROCEDURE TypeS(X, Y: NUMERIC[1]; S: STRING[]; P: TEXTSTYLE);
 BEGIN
  L_RWSP.intTypeS(X, Y, S, P, L_Print.cp_OEM_Russian);
 END {TypeS};

 PRIVATE PROCEDURE GetPrevStopName(): STRING[];
 BEGIN
  IF OCCURE(SEJobs) & PREV(SEJobs) THEN
   CONFORM(SEJobs, WJMode);
   WHILE OCCURE(SEJobs) & (WJMode.RunSel=L_Way.runsel_None) DO
    PREV(SEJobs);
    CONFORM(SEJobs, WJMode);
   END; (* WHILE OCCURE(SEJobs) ... *)
   IF OCCURE(SEJobs) & SELECT(RtMStop, Route, SEJobs.Route, SEJobs.Modif) THEN
    IF SEJobs.Dir = L_Way.dir_Forward THEN
     LAST(RtMStop);
    END;
    CONFORM(RtMStop, Stop);
    RETURN Stop.Name;
   ELSE
    RETURN "";
   END;
  ELSE
   RETURN ".";
  END;
 END {GetPrevStopName};

 PRIVATE PROCEDURE RepEventCastsStr(): STRING[];
  VAR
   Result: STRING[];
   D     : DATE;
 BEGIN
  L_AFM.MakeIndex("tmp", "D: DATE; RepEvent: LIKE(RepEvent.RepEvent)");

  SELECT(CarEvn, BoxNbr, , RWayS.BoxNbr);
  SRCINSEL(CarEvn, GE, , RWayS.Date);
  WHILE OCCURE(CarEvn) & (CarEvn.StartD < RWayS.Date + 4) DO
   IF (CarEvn.Source = L_Car.src_FrCast) THEN
    ADD(tmp, tmp, , CarEvn.StartD, CarEvn.RepEvent);
    IF CarEvn.RepEvent = E_Way.re_TO2 THEN
     ADD(tmp, tmp, , CarEvn.StartD - 1, E_Way.re_Diagnostic2);
    END;
   END;
   NEXT(CarEvn);
  END; (* WHILE OCCURE(CarEvn) ... *)

  SETEMPTY(Result, D);
  SELECT(tmp, tmp);
  SRCINSEL(tmp, GE, , RWayS.Date);
  WHILE OCCURE(tmp) DO
   IF ~!Result THEN
    Result:=Result + ", ";
   END;
   IF    tmp.D # D THEN
    IF tmp.D = RWayS.Date THEN
     Result:=Result + "";
    ELSE
     Result:=Result + L_DatTim.DateStr(tmp.D);
    END;
    D:=tmp.D;
   END;
   SEARCH(RepEvent, RepEvent, , tmp.RepEvent);
   Result:=Result + " " + RepEvent.Name;
   NEXT(tmp);
  END; (* WHILE OCCURE(tmp) ... *)
  L_AFM.AF_PurgeTemp("tmp");
  IF ~!Result THEN
   Result:=Result + ".";
  END;
  RETURN Result;
 END {RepEventCastsStr};

 PRIVATE PROCEDURE PrintWayLMen(Pt10B, Pt12B: TEXTSTYLE);
  VAR
   i      : NUMERIC[0];
   _StartT,
   _StopT : STRING[];
 BEGIN
  i:=0;
  SELECT(WayLMen, RWayS, , RWayS.RWayS);
  WHILE OCCURE(WayLMen) & (i < 3) DO
   CONFORM(WayLMen, Staff);
   CONFORM(Staff, Man);
   TypeS(013, 081 + i*6, L_Str.PoolItem(L_Way.wlmwho_Pool, WayLMen.Who), Pt12B);
   TypeS(043, 081 + i*6, WayLMen.TSN, Pt12B);
   TypeS(060, 081 + i*6, L_Str.ShortName(Man.Name), Pt12B);
   SETEMPTY(_StartT, _StopT);
   IF ~!WayLMen.StartT THEN
    _StartT:=L_DatTim.TimeStr(WayLMen.StartT);
   END;
   IF ~!WayLMen.StopT THEN
    _StopT:=L_DatTim.TimeStr(WayLMen.StopT);
   END;
   TypeS(126, 081 + i*6, _StartT, Pt12B);
   TypeS(141, 081 + i*6, _StopT, Pt12B);

   IF (WayLMen.Who = L_Way.wlmwho_DrPupil) | (WayLMen.Who = L_Way.wlmwho_SDriver) THEN
    TypeS(157, 081 + i*6, L_RWSP.GetManDocNum(P_Man.P_DriveSertification), Pt10B);
   END;
   NEXT(WayLMen);
   INC(i);
  END; (* WHILE OCCURE(WayLMen) ... *)
  CONFORM(RWayS, Staff);
  CONFORM(Staff, Man);
 END {PrintWayLMen};

 PRIVATE PROCEDURE GetCarTechInf(): STRING[];
 BEGIN
  IF OCCURE(VehType) THEN
   IF    (VehType.IRC_VehT = L_Car.ircvt_Truck_wUL_UpTo5Year) |
         (VehType.IRC_VehT = L_Car.ircvt_Truck_wUL_Over5Year) THEN
    L_Car.AccessVehPasp(RWayS.BoxNbr, RWayS.Date);
    IF OCCURE(VehPasp) & ~!VehPasp.MaxWeigh & ~!VehPasp.NetWeigh THEN
     RETURN "৯. " + FLDTOSTR((VehPasp.MaxWeigh - VehPasp.NetWeigh)/1000, "1.") + " .";
    END;
   ELSIF P_Mark.HasActualMarkPro(Mark.Mark, RWayS.Date, P_Mark.P_PasVolume) THEN
    RETURN ". " + FLDTOSTR(P_Mark.GetP_PVLim(Mark.Mark, RWayS.Date), "0") + " 祫." ;
   END;
  END;
  RETURN "";
 END {GetCarTechInf};

 PRIVATE PROCEDURE ConditionalTypeMessage(VAR LineY: NUMERIC[1]; Cond: SCAL[2]; Message: STRING[]; Pt: TEXTSTYLE);
 BEGIN
  IF Cond THEN
   TypeS(101, LineY, Message, Pt);
   INC(LineY, 3.5);
  END;
 END {ConditionalTypeMessage};

 PRIVATE PROCEDURE TestCarPro(VAR LineY    : NUMERIC[1];
                          _Property: LIKE(CarPro.Property);
                          MinDays  : NUMERIC[0];
                          Name     : STRING[];
                          Pt       : TEXTSTYLE);
  VAR
   _DocExpD: LIKE(CarPro.DocExpD);
 BEGIN
  IF P_Car.HasActualCarPro(RWayS.BoxNbr, RWayS.Date, _Property) THEN
   REPEAT
    _DocExpD:=CarPro.DocExpD;
   UNTIL ~P_Car.HasActualCarPro(RWayS.BoxNbr, _DocExpD, _Property) | !_DocExpD;
   ConditionalTypeMessage(LineY, _DocExpD < (RWayS.Date + MinDays),
                          "! ப ⢨ " + Name + " ⥪ " + L_DatTim.DateStr(_DocExpD), Pt);
  END;
 END {TestCarPro};

 PUBLIC PROCEDURE PrintBlankBackground(pj      : PRINTJOB;
                                       FileName: STRING[]);
  VAR
   picWidth,
   picHeight: NUMERIC[0];
   Ext      : STRING[];
 BEGIN
  IF FIO.Exists(L_FIO.rf_GetFullFileName(FileName)) THEN
   pj.LoadAndDrawPicture(pj, 0, 0, 210, 297, L_FIO.rf_GetFullFileName(FileName));
  END;
 END {PrintBlankBackground};

 PRIVATE PROCEDURE print_Form_6();
  VAR
   i                       : NUMERIC[0];
   _Text,
   _MsgText,
   AddInf,
   SpecialNote,
   LastStopName            : STRING[];
   RECastStr               : STRING[][2];
   _BTime,
   _ETime,
   EndChangeTime           : TIME;
   DateOfRepEventCast,
   _SP_DriveSertification,
   _SP_MedicalSertification: DATE;
   Pt05, Pt09B,
   Pt09, Pt10B,
   Pt12B, Pt14B            : TEXTSTYLE;
   FNorm, FOver            : LIKE(RWayS.FuelNorm);
   _Math                   : LIKE(Math.Math);
   LineY                   : NUMERIC[1];
   DrvCertProperty         : LIKE(Property.Property);
 BEGIN
  Pt09 :=L_Print.ts_Create(09, "Times New Roman");
  Pt05 :=L_Print.ts_Resize(Pt09, 05);
  Pt09B:=L_Print.ts_Create(09, "Times New Roman");
  Pt09B.Font.Weight:=FONT.Weight_Bold;
  Pt10B:=L_Print.ts_Resize(Pt09, 10);
  Pt10B.Font.Weight:=FONT.Weight_Bold;
  Pt12B:=L_Print.ts_Resize(Pt10B, 12);
  Pt14B:=L_Print.ts_Resize(Pt10B, 15);

  L_RWSP.DefaultConforms();
  L_RWSP.RWSPrt.StartPage();

(*
  IF L_General.IsOurEngineeringCopy() THEN
   L_RWSP.RWSPrt.LoadAndDrawPicture(0, 0, 210, 297, L_FIO.rf_GetFullFileName("DEBUG\RWS_F6_F.jpg"));
  END;
*)

  _BTime:=L_BegRWS.GetRWaySExitTime(1);
  _ETime:=L_BegRWS.GetRWaySEnterTime(1);

  _SP_MedicalSertification:=L_RWSP.GetManDocExpDate(P_Man.P_MedicalSertification);
  IF L_Car.IsSelfPropelledCar(RWayS.BoxNbr, RWayS.Date) THEN
   DrvCertProperty:=P_Man.P_TractorDriverSertification;
  ELSE
   DrvCertProperty:=P_Man.P_DriveSertification;
  END;
  _SP_DriveSertification  :=L_RWSP.GetManDocExpDate(DrvCertProperty);

  TypeS(060, 028,   RWayS.RWayS, Pt14B);
  TypeS(079, 028,  "(" + RWayS.CopyCnt + ")", Pt10B);

  SETEMPTY(_Text);
  IF ~!Mark.VehType THEN
   CONFORM(Mark, VehType);
   IF    VehType.Tax_VehT = 0 THEN
    IF    (VehType.IRC_VehT = L_Car.ircvt_Bus_wUL_UpTo5Year) |
          (VehType.IRC_VehT = L_Car.ircvt_Bus_wUL_Over5Year) THEN
     _Text:="⮡";
    ELSIF VehType.IRC_VehT = L_Car.ircvt_PassengerCar THEN
     _Text:=" ⮬";
    ELSIF (VehType.IRC_VehT = L_Car.ircvt_Truck_wUL_UpTo5Year) |
          (VehType.IRC_VehT = L_Car.ircvt_Truck_wUL_Over5Year) THEN
     _Text:="㧮 ⮬";
    END;
   ELSIF (VehType.Tax_VehT = 42) | (VehType.Tax_VehT = 43) THEN
    _Text:="⮡";
   ELSIF (VehType.Tax_VehT = 32) | (VehType.Tax_VehT = 34) THEN
    _Text:=" ⮬";
   ELSIF VehType.Tax_VehT = 35 THEN
    _Text:="㧮 ⮬";
   ELSIF (VehType.Tax_VehT = 33) | (VehType.Tax_VehT = 41) THEN
    _Text:="᪮ன ";
   END;
  END;
  TypeS(088, 028, _Text, Pt14B);

  TypeS(143, 031, L_DatTim.DateStr(RWayS.Date), Pt10B);
  TypeS(163, 031, L_DatTim.TimeStr(SYSTIME()), Pt10B);

  TypeS(015, 052, RWayS.BoxNbr, Pt14B);
  TypeS(031, 052, Car.StateNbr, Pt12B);
  TypeS(053, 052, Mark.Name,    Pt14B);
  TypeS(105, 052, GetCarTechInf(), Pt09);
  IF P_Car.HasActualCarPro(RWayS.BoxNbr, RWayS.Date, P_Car.P_CarLicenCard) THEN
   TypeS(146, 052, CarPro.Value, Pt12B);
   TypeS(172, 052, CarPro.DocNum, Pt12B);
  END;

  TypeS(015, 066, RWayS.TSN, Pt14B);
  TypeS(033, 066, Man.Name, Pt14B);
  TypeS(127, 066, L_RWSP.GetManDocNum(P_Man.P_DriveSertification), Pt10B);
  TypeS(162, 066, " "+L_RWSP._NumStr(L_Way.GetExitPlan(), "2-", 8), Pt10B);

  PrintWayLMen(Pt10B, Pt12B);

  TypeS(012, 117.5, RWayS.Exit, Pt14B);
  TypeS(042, 117.5, StExit.Name, Pt14B);
  TypeS(170, 117.5, Str.Item("+|-", "|", RWayS.Gap), Pt14B);
  TypeS(188, 117.5, RWayS.Change, Pt14B);

  IF P_Car.HasActualCarPro(RWayS.BoxNbr, RWayS.Date, P_Car.P_NavigationSystem) THEN
   TypeS(125, 127, "", Pt09);
   TypeS(150, 127, "⥫", Pt09);
   TypeS(175, 127, "堭", Pt09);
   TypeS(125, 132, "륧", Pt09);
   TypeS(150, 132, "___________", Pt09);
   TypeS(175, 132, "___________", Pt09);
   TypeS(125, 137, "饭", Pt09);
   TypeS(150, 137, "___________", Pt09);
   TypeS(175, 137, "___________", Pt09);
  END;

  TypeS(037, 164, L_Str.ShortName(P_Man.GetFullNameOfCurrentUser(SYSDATE())), Pt09);
  TypeS(130, 164, L_RWSP._NumStr(RWayS.SMBef, "0", 0),   Pt14B);
  TypeS(173, 164, L_RWSP._NumStr(RWayS.RemExit, "0", 0), Pt14B);

  TypeS(035, 175.5, L_DatTim.TimeStr(_BTime), Pt14B);
  TypeS(035, 192.5, L_DatTim.TimeStr(_ETime), Pt14B);
  _Math:=L_Fuel.GetMainFuelSoft(RWayS.Date, Mark.Mark);
  IF ~!_Math THEN
   SEARCH(Math, Math, , _Math);
   TypeS(032, 209, Math.Name, Pt05);
  END;

(*ᮡ ⬥⪨*)
  IF L_DatTim.IsBirthDay(Man.Birth, RWayS.Date) THEN
   TypeS(013, 237, "  ஦!", Pt09);
  END;

  SETEMPTY(SpecialNote);
  IF    _SP_MedicalSertification < (RWayS.Date + 40) THEN
   SpecialNote:="ன ᬮ  " + L_DatTim.DateStr(_SP_MedicalSertification) + "! ";
  ELSIF _SP_DriveSertification < (RWayS.Date + 20) THEN
   SEARCH(Property, Property, , DrvCertProperty);
   SpecialNote:=Property.Name + ": cப ⥪ " + L_DatTim.DateStr(_SP_DriveSertification) + "! ";
  END;

  IF L_DatTim.IsBirthDay(Man.Birth, RWayS.Date) THEN
   SpecialNote:=SpecialNote + "  ஦!";
  END;
  TypeS(013, 242, SpecialNote, Pt09);
  IF L_BegRWS.RWayTxtIsValid() THEN
   TypeS(013, 247, RWayTxt.Message, Pt09);
  END;
  IF P_Man.HasActualManPro(Man.Man, RWayS.Date, P_Man.P_MedicalSertification) &
    (L_Prop.GetProValueAsScal(P_Man.GetManProPool(P_Man.P_MedicalSertification),
                                                  ManPro.Value) = 0 (* 窨 *)) THEN
   TypeS(013, 252, " 易⥫쭮  窠", Pt14B);
  END;

  AddInf:="";
  SELECT(SEJobs, Exit, , RWayS.Exit);
  WHILE OCCURE(SEJobs) DO
   CONFORM(SEJobs, WJMode, RoutMod);
   IF WJMode.WJCode = "50" (* , ⮩ *) THEN
    SAVE(SEJobs);
    LastStopName:="";
    WHILE !LastStopName DO
     LastStopName:=GetPrevStopName();
    END; (* WHILE !LastStopName...*)
    RESTORE(SEJobs);
    AddInf:=AddInf + RoutMod.Name + "  " + L_DatTim.TimeStr(SEJobs.StartT) +
                     "  " + L_DatTim.TimeStr(SEJobs.StopT) + " " + LastStopName + ";";
   END;
   NEXT(SEJobs);
  END; (* WHILE OCCURE(SEJobs) ... *)

  i:=0;
  WHILE ~!Str.Item(AddInf, ";", i) DO
   TypeS(013, 257 + i*5, Str.Item(AddInf, ";", i), Pt09);
   INC(i);
  END; (* WHILE ~!Str.Item(AddInf, ";", i)...*)

  IF RWayS.Change = 1 THEN
   SELECT(SEJobs, Exit, , RWayS.Exit);
   LAST(SEJobs);
   EndChangeTime:=SEJobs.StopT;
   LastStopName:="";
   WHILE !LastStopName DO
    LastStopName:=GetPrevStopName();
   END; (* WHILE !LastStopName...*)
   TypeS(013, 257 + i*5, "ᬥ  " + L_DatTim.TimeStr(EndChangeTime) + "  " + LastStopName,  Pt09);
  END;

  SELECT(SEJobs, Exit, , RWayS.Exit);
  IF (SEJobs.Route = "0388") | (SEJobs.Route = "0688") | (SEJobs.Route = "0788") THEN
   TypeS(013, 240, "䮭 ६ ᯥ᪮ 㭪  樨 ⮢ ", Pt09);
   TypeS(111, 240, "8-985-380-0591, 8-915-399-0545", Pt09B);
  ELSIF L_Way.GetMarkG(Mark.Mark, 200) = 0126 THEN
   TypeS(013, 240, "䮭 ६ ᯥ᪮ 㭪  樨 ⮢ ", Pt09);
   TypeS(111, 240, "8-915-399-0545", Pt09B);
  ELSIF L_Way.GetMarkG(Mark.Mark, 200) = 0127 THEN
   TypeS(013, 240, "䮭 ६ ᯥ᪮ 㭪  樨 ⮢ ", Pt09);
   TypeS(111, 240, "8-915-399-1446", Pt09B);
  END;

  L_Way.PrepareFuelInf(FNorm, FOver);
  LineY:=243;
  ConditionalTypeMessage(LineY, 1, "ଠ ⮯ " +  L_RWSP._NumStr(FNorm, "3.", 7), Pt09);

  Str.Format(RECastStr, RepEventCastsStr(), 50, LEFT);
  ConditionalTypeMessage(LineY, ~!RECastStr[0], RECastStr[0], Pt09);
  ConditionalTypeMessage(LineY, ~!RECastStr[1], RECastStr[1], Pt09);
  INC(LineY, 1);

  IF P_Man.HasManPro(Man.Man, RWayS.Date, E_Prop.P_CivilLiabilityInsurance) &
     (ManPro.DocExpD < (RWayS.Date + 20)) THEN
   ConditionalTypeMessage(LineY, 1, L_Str.PoolItem("⥪|⥪", ManPro.DocExpD <= RWayS.Date)+
                          " ப ⢨ ,   ", Pt09);
  END;
  SETEMPTY(_Text);
  IF P_Staff.HasActualStaffPro(RWayS.TSN, RWayS.Date, E_Prop.P_SelfControl) THEN
   _Text:=". ";
  END;
  _Text:=_Text+P_OwnData.MessageToDriver(RWayS.Date);
  i:=0;
  LOOP
   _MsgText:=Str.Item(_Text, CHR(13)+CHR(10), i);
   IF ~!_MsgText THEN
    ConditionalTypeMessage(LineY, 1, _MsgText, Pt09);
   ELSE
    EXIT;
   END;
   INC(i);
  END;
  TestCarPro(LineY, P_Car.P_CLI_Obligatory, 10, " ",             Pt09);
  TestCarPro(LineY, P_Car.P_CarLicenCard,   10, "業 窨",    Pt09);
  TestCarPro(LineY, P_Car.P_SpecialSignals, 10, "ࠧ襭  ᯥᨣ", Pt09);

  L_RWSP.TypeRWSBarCode(143, 223);
  L_RWSP.PrintPhoto(170, 242);
  L_RWSP.RWSPrt.EndPage();
 END {print_Form_6};

 PUBLIC PROCEDURE Print();
 BEGIN
  ACCESS(RWayS);
  L_RWSP.CreateNotTypicalPrintJob(L_Print.o_Portrait, 0);
  print_Form_6();
  L_RWSP.RWSPrt.Close();
 END {Print};

END.
