(*
%Copyright   (c) Polak IT
%Author      24.10.2003 18:16:02 POLAK\LDA
%Purpose     㥬 ६ 室   ६
%Type        report
%Specific    AP
%Modified    10.04.2012 13:22:35 ROBOT by POLAK\LDA
%Environment
*)

 IMPORT L_General, L_OwnData, L_Rpr, L_Str, L_DatTim, L_StdFrm, Str, L_XDoc,
        L_AFM, L_Car, Math, E_Rpr, Memo, L_CUC, P_Rpr;

 VAR
  RepName : STRING[];

(*
$P{ Top:
L_OwnData.ODFirmName(SYSDATE()), L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
RepName, L, ""
?, C, ""
?, C, ""
@
############################################################# ########## #####
=#####========================================================================
|############################################################################|
|############################################################################|
|----------------------------------------------------------------------------|
|       |   ⨥ |ꥪ ६                    |  . ⨥|
}
*)

(*
$P{ Line_RprS:
?, L, " |!"
RprS.RprS, L, ""
RprS.OrdDate, L, "D.N.Y"
RprS.OrdTime, L, "H:M"
RprS.RprObjId, L, ""
RprS.RprObjT, L, L_Rpr.rot_Pool_Short
CUCopy.Serial, L ,""
?, L, " |+"
?, L, ""
@
|----------------------------------------------------------------------------|
|# #######|######## #####|####### # ########################|# ##############|
|----------------------------------------------------------------------------|
}
*)

(*
$P{ Line_RprDA:
?, L, ""
@
|############################################################################|
}
*)

(*
$P{ Line_RprT:
?, L, ""
@
| ###########################################################################|
}
*)

(*
$P{ Line_RprJ:
?, L, ""
@
|  ##########################################################################|
}
*)

(*
$P{ Bot:
@
=(c) Polak====================================================================
}
*)

 PRIVATE PROCEDURE _PrintLine(Value    : STRING[];
                      StrLength: NUMERIC[0];
                      PartName : STRING[]);
  VAR
   i: NUMERIC[0];
   StrArr: STRING[][10];
 BEGIN
  Str.Format(StrArr,
             Value,
             StrLength,
             LEFT);
  MAKEPART(R, ^PartName, StrArr[0]);
  i:=1;
  WHILE ~!StrArr[i] DO
   MAKEPART(R, ^(PartName), StrArr[i]);
   INC(i);
  END; (* WHILE ~!StrArr[i]...*)
 END {_PrintLine};

 PRIVATE PROCEDURE PrintRprP(IndexValue: SCAL[1E4];
                     PartName  : STRING[]);
 BEGIN
  SELECT(RprP, RprJ, , RprS.RprS, RprT.RprT, IndexValue);
  WHILE OCCURE(RprP) DO
   CONFORM(RprP, Staff);
   CONFORM(Staff, Man);
   MAKEPART(R, ^(PartName), L_Str.PoolItem(L_Rpr.rprpwho_Pool, RprP.Who) + " " + Staff.TSN + " " + Man.Name);
   NEXT(RprP);
  END; (* WHILE OCCURE(RprP) ... *)
 END {PrintRprP};

 PRIVATE PROCEDURE PrintLine();
  VAR
   i             : NUMERIC[0];
   MaxPlnEDate   : DATE;
   MaxPlnETime   : TIME;
   EDateTimeAsStr: STRING[];
 BEGIN
  L_Rpr.GetMaxPlnEDateTime(MaxPlnEDate, MaxPlnETime);
  IF ~!MaxPlnEDate THEN
   EDateTimeAsStr:=FLDTOSTR(MaxPlnEDate, "D.N.Y") + " " + L_DatTim.TimeStr(MaxPlnETime);
  ELSE
   EDateTimeAsStr:=" ";
  END;
  IF ~RSMode() THEN
   L_XDoc.sl_AddItem(L_XDoc.XDocId(L_XDoc.xdt_RprS, L_XDoc.EmptyXDocKind, RprS.RprS),
                     RprS.RprS + " " +
                     L_DatTim.DateStr(RprS.OrdDate) + " " +
                     L_DatTim.DateStr(RprS.EDate) + " " +
                     L_Str.PoolItem("-|", RprS.Closed));
  END;
  MAKEPART(R, Line_RprS, L_Rpr.IsFailureOutput(),
                         ~!RprS.EDate,
                         EDateTimeAsStr);
  SELECT(RprDA, RprS, , RprS.RprS);
  WHILE OCCURE(RprDA) DO
   _PrintLine(L_Rpr.GetRprDA_AsStr(), 76, "Line_RprDA");
   NEXT(RprDA);
  END; (* WHILE OCCURE(RprDA) ... *)
 
  SELECT(RprT, RprS, , RprS.RprS);
  WHILE OCCURE(RprT) DO
   _PrintLine(L_Rpr.GetRprT_AsStr(0) + "  ६ 砭: " + L_Rpr.GetRprTPlanETimes_AsStr(), 75, "Line_RprT");
   PrintRprP(L_Rpr.v_EmptyIndexValue, "Line_RprT");
   SELECT(RprJ, RprS, , RprS.RprS, RprT.RprT);
   WHILE OCCURE(RprJ) DO
    _PrintLine(L_Rpr.GetRprJ_AsStr(), 74, "Line_RprJ");
    PrintRprP(RprJ.RprJ, "Line_RprJ");
    NEXT(RprJ);
   END; (* WHILE OCCURE(RprJ) ... *)
   NEXT(RprT);
  END; (* WHILE OCCURE(RprT)...*)
 END {PrintLine};

 PRIVATE PROCEDURE MakeRep(OnlyFailureOutput,
                   MakeRepOnSysDate: SCAL[2]);
  VAR
   Title : STRING[];
   OnDate: DATE;
 BEGIN
  SE_ACCESSDATAMODE(AccessDataMode_SOFT);
  IF ~RSMode() THEN
   L_XDoc.sl_Init(" ६⮢");
  END;

  IF OnlyFailureOutput THEN
   RepName:="FrOut";
   Title  :="祭   , 뢠騬 ";
  ELSE
   RepName:="PlnEx";
   Title  :="㥬 ६ 室   ६";
  END;

  IF MakeRepOnSysDate THEN
   OnDate:=SYSDATE();
  ELSE
   OnDate:=Memo.ud_cd();
  END;

  OPENREP(R, L_General.NameConnection(RepName), Create);
  MAKEPART(R, Top, Title, " " + L_DatTim.DateStr(OnDate));

  IF MakeRepOnSysDate THEN
   SELECT(RprS, cOrdDate, , 0, OnDate);
  ELSE
   SELECT(RprS, OrdDate, , OnDate);
  END;

  WHILE OCCURE(RprS) DO
   PROMPT(RprS.RprS);
   IF RprS.Status # L_Rpr.ms_Cancel THEN
    CONFORM(RprS, CUCopy);
    L_CUC.AccessOrigin();
    IF ~OnlyFailureOutput |
       (L_Rpr.IsRprS_w_Car() & SELECT(RWayS, BoxNbr, Car.BoxNbr, RprS.OrdDate) & L_Rpr.IsFailureOutput()) THEN
     PrintLine();
    END;
   END;
   NEXT(RprS);
  END; (* WHILE OCCURE(RprS) ... *)
  MAKEPART(R, Bot);
  CLOSEREP(R);
  IF ~RSMode() THEN
   L_XDoc.sl_Done();
  END;
 END {MakeRep};

 PRIVATE PROCEDURE RSMode(): SCAL[2];
 BEGIN
  RETURN MODE = 102;
 END {RSMode};

BEGIN
 IF     MODE = 100 THEN
  MakeRep(0, 1);
 ELSIF (MODE = 101) | RSMode() THEN
  MakeRep(1, 1);
 ELSIF  MODE = 103 THEN
  MakeRep(1, 0);
 ELSE
  L_General.BadMode(MODE);
 END;
END.
