(*
%Copyright   (c) Polak IT
%Author      04.09.2009 16:24:11 POLAK\LDA
%Purpose     । ⮪ ࠢ  ६ ⮪
%Type        report
%Specific    LOC
%Modified    18.07.2013 18:15:45 LDA
%Environment
*)

 IMPORT L_Excel, L_MDoc, L_XDoc, Memo, P_Storage, L_Stock, L_General, FIO, L_MathR, L_DatTim, Str;

 PRIVATE PROCEDURE RoundHours(Time: TIME): TIME;
 BEGIN
  RETURN STRTOFLD(Str.Slice(L_DatTim.TimeStr(Time), 0, 3) + "00", TIME);
 END {RoundHours};

 VAR
  objXL,
  objWB,
  objWS  : OBJECT;

BEGIN
 L_General.Assert(L_Excel.ExcelInstalled(), " ⠭ MS Excel");
 objXL:=CreateOBJECT("Excel.Application");
 TRY
  objWB:=L_Excel.NewWorkbook(objXL, 1);
  objWS:=objWB.Sheets(1);
  L_Excel.ws_Init(objWS);
  objWS.Cells(1,  1).ColumnWidth:=10;
  objWS.Cells(1,  4).ColumnWidth:=10;

  L_Excel.ws_WrStr(objWS, "। ⮪ ࠢ  ६ ⮪  ਮ  " + L_DatTim.DateStr(Memo.ud_fr()) + "  " + L_DatTim.DateStr(Memo.ud_ut()));
  L_Excel.ws_SetCurPos(objWS, 3, 1);

  L_Excel.ws_WrStr(objWS, "");
  L_Excel.ws_WrStr(objWS, "६");
  L_Excel.ws_WrStr(objWS, "");
  L_Excel.ws_WrStr(objWS, "ࠦ");
  L_Excel.ws_TermLine(objWS);

  SELECT(XDocJrn, UserIdx, , L_XDoc.xdt_MDoc);
  WHILE OCCURE(XDocJrn) DO
   NARROWSEL(XDocJrn, AcsObj);
   SRCINSEL(XDocJrn, GE, , Memo.ud_fr());
   WHILE OCCURE(XDocJrn) & (XDocJrn.Date <= Memo.ud_ut()) DO
    PROMPT(XDocJrn.AcsObj + " " + L_DatTim.DateStr(XDocJrn.Date) + " " + XDocJrn.XDoc);
    IF (XDocJrn.XDocKind = L_MDoc.md_NOV) & (XDocJrn.Action = L_XDoc.action_AutoBuild) THEN
     SEARCH(MDoc, MDoc, , L_MDoc.md_NOV, XDocJrn.XDoc);
     IF P_Storage.IsFuelStation(MDoc.Storage) & (L_MathR.E_GetSingleRefToXDocType(SYSDATE(), MDoc.MDocKind, MDoc.Storage) = L_XDoc.xdt_RWayS) THEN
      L_Excel.ws_WrDat(objWS, XDocJrn.Date);
      L_Excel.ws_WrStr(objWS, L_DatTim.TimeStr(XDocJrn.BegTime));
      L_Excel.ws_WrStr(objWS, L_DatTim.TimeStr(RoundHours(XDocJrn.BegTime)));
      L_Excel.ws_WrScl(objWS, MDoc.BoxNbr);
      L_Excel.ws_TermLine(objWS);
 
     END;
    END;
    NEXT(XDocJrn);
   END; (* WHILE OCCURE(XDocJrn) ... *)
   NEXTINEXTENDEDSEL(XDocJrn, AcsObj);
  END; (* WHILE OCCURE(XDocJrn) ... *)

  TRY
   objWB.SaveAs(FIO.BuildPath("g7298_"+L_DatTim.SysDateTimeStamp(), "xls",
                              FIO.MakePath("TXT", , FIO.AsbSpecialFolders("ClientProjectRoot"))));
  EXCEPT
  ELSE
  END;
  objWS.Visible:=1;
  objWS.Application.Visible:=1;
 EXCEPT
 ELSE
  L_Excel.CloseExcel(objXL, objWB);
  RAISE();
 END;

END.
