(*
%Copyright   (c) Polak IT
%Author      10.09.2007 11:02:43 POLAK\GAV
%Purpose
%Type        report,temporary
%Specific    LOC
%Modified    13.05.2013 13:15:10 POLAK\GAV
%Environment
*)

 IMPORT P_Man, L_Env, L_Staff, Memo, L_General, L_Man, L_OwnData, L_DatTim,
        Str, L_Str, L_Excel, FIO, L_BegRWS;

 VAR
  Count: NUMERIC[0];
  objXL,
  objWB,
  objWS      : OBJECT;

 PRIVATE PROCEDURE GetDrvStage(): STRING[];
  VAR
   _BegDate       : DATE;
   DaysOfStage,
   MonthsOfStage,
   YearsOfStage   : NUMERIC[0][L_Man.ins_Size];
   CntStageDate   : DATE      [L_Man.ins_Size];
   D, M, Y        : NUMERIC[0];
 BEGIN
  L_Man.FillStages(Memo.ud_cd(), DaysOfStage, MonthsOfStage, YearsOfStage, CntStageDate, _BegDate);
  L_DatTim.GetDatesDifferenceIn3Part(CntStageDate[L_Man.ins_Post], Memo.ud_cd(), D, M, Y);
  L_DatTim.NormalizeDMY(D, M, Y);
  RETURN L_Str.IntStr(Y) + Str.EnumObject(Y, "  |  |  ") +
         L_Str.IntStr(M) + Str.EnumObject(M, "  |  | 楢 ") +
         L_Str.IntStr(D) + Str.EnumObject(D, " | | ");
 END {GetDrvStage};
 
 PRIVATE PROCEDURE GetMedicalSertificationDate(): DATE;
 BEGIN
  IF P_Man.HasActualManPro(Staff.Man, Memo.ud_cd(), P_Man.P_MedicalSertification) THEN
   RETURN ManPro.DocGiveD;
  ELSE
   RETURN L_General.EMPTY_DATE();
  END;
 END {GetMedicalSertificationDate};
 
 PRIVATE PROCEDURE GetMedicalSertificationEndDate(): DATE;
 BEGIN
  IF P_Man.HasActualManPro(Staff.Man, Memo.ud_cd(), P_Man.P_MedicalSertification) THEN
   RETURN ManPro.DocExpD;
  ELSE
   RETURN L_General.EMPTY_DATE();
  END;
 END {GetMedicalSertificationEndDate};
 
 PRIVATE PROCEDURE GetProbationDate(): DATE;
 BEGIN
  IF SELECT(MCFix, TSN, Staff.TSN) THEN
   LAST(MCFix);
   RETURN MCFix.Begin;
  ELSE
   RETURN L_General.EMPTY_DATE();
  END;
 END {GetProbationDate};
 
 PRIVATE PROCEDURE GetPermittedRoutes(): STRING[];
  VAR
   AllRoute: SCAL[2];
 BEGIN
  RETURN L_BegRWS.GetPermitToRouteList(Memo.ud_cd(), Staff.TSN, AllRoute);
 END {GetPermittedRoutes};
 
 PRIVATE PROCEDURE SetMergedCell(row1, col1, row2, col2: NUMERIC[0]; text: STRING[]);
  CONST
   xlCenter = -4108;
  VAR
   r: OBJECT;
 BEGIN
  r:=objWS.Range(objWS.Cells(row1, col1), objWS.Cells(row2, col2));
  r.Merge();
  r.Value:=text;
  r.HorizontalAlignment:=xlCenter;
  r.VerticalAlignment:=xlCenter;
 END {SetMergedCell};

BEGIN
 L_General.Assert(L_Excel.ExcelInstalled(), " ⠭ MS Excel");
 TRY
  objXL:=CreateOBJECT("Excel.Application");
  objWB:=L_Excel.NewWorkbook(objXL, 1);
  objWS:=objWB.Sheets(1);
  L_Excel.ws_Init(objWS);
  SetMergedCell(1, 1, 1, 9, "  ⥫ ࠭ᯮ ।");
  SetMergedCell(2, 1, 4, 1, "");
  SetMergedCell(2, 2, 4, 2, "  樠");
  SetMergedCell(2, 3, 2, 5, "।騥   ।⠢ ଠ樨");
  SetMergedCell(3, 3, 3, 4, "  ");
  SetMergedCell(4, 3, 4, 3, "2006");
  SetMergedCell(4, 4, 4, 4, "2007");
  SetMergedCell(3, 5, 4, 5, ". ᢨ⥫⢮");
  SetMergedCell(2, 6, 4, 6, "ப ⢨ ࠢ");
  SetMergedCell(2, 7, 4, 7, " ஢ ⠦஢   ९ ⨯ ");
  SetMergedCell(2, 8, 4, 8, "⠦ ࠡ ⥫  (⥣ )");
  SetMergedCell(2, 9, 4, 9, "饭  ࠡ  ");
  objWS.UsedRange.WrapText:=L_Excel.xlTrue;
  L_Excel.ws_TermLine(objWS);
  L_Excel.ws_TermLine(objWS);
  L_Excel.ws_TermLine(objWS);
  L_Excel.ws_TermLine(objWS);
 
  Count:=0;
  SELECT(Staff, TSN);
  WHILE OCCURE(Staff) DO
   PROMPT(Staff.TSN);
   IF L_Staff.rInState(Memo.ud_cd()) THEN
    CONFORM(StaffLog, Officer);
    IF L_Env.IsDriver() THEN
     INC(Count);
     CONFORM(Staff, Man);
     L_Excel.ws_WrNum(objWS, Count);
     L_Excel.ws_WrStr(objWS, L_Str.ShortName(Man.Name));
     L_Excel.ws_SkipCols(objWS, 2);
     L_Excel.ws_WrDat(objWS, GetMedicalSertificationDate());
     L_Excel.ws_WrDat(objWS, GetMedicalSertificationEndDate());
     L_Excel.ws_WrDat(objWS, GetProbationDate());
     L_Excel.ws_WrStr(objWS, GetDrvStage());
     L_Excel.ws_WrStr(objWS, GetPermittedRoutes());
     L_Excel.ws_TermLine(objWS);
    END;
   END;
   NEXT(Staff);
  END; (* WHILE OCCURE(Staff) ... *)
  objWS.UsedRange.EntireColumn.AutoFit();
  objWS.UsedRange.WrapText:=L_Excel.xlTrue;
  objWS.UsedRange.Borders.LineStyle:=1;
  objWS.Visible:=L_Excel.xlTrue;
  objWS.Application.Visible:=L_Excel.xlTrue;
  objWB.SaveAs(FIO.MakePath("tDrCm", "XLS", FIO.AsbSpecialFolders("ASBTemp")));
 EXCEPT
 ELSE
  IF ~!objXL THEN
   L_Excel.CloseExcel(objXL, objWB);
  END;
  RAISE();
 END;
END.