(*
%Copyright   (c) Polak IT
%Author      24.01.2006 18:34:07 POLAK\LDA
%Purpose
%Type        report
%Specific    LOC
%Modified    10.04.2012 13:21:15 ROBOT by POLAK\LDA
%Environment
*)

 IMPORT Memo, P_Man, L_General, L_Env, Math, L_Staff, L_DatTim, L_Excel, L_Man, FIO, L_OwnData, L_Russia;

 PRIVATE PROCEDURE DrStage(D: DATE): NUMERIC[1];
  VAR
   Stage: FLOAT;
 BEGIN
  Stage:=0;
  SELECT(StaffLog, TSN, , Staff.TSN);
  SRCINSEL(StaffLog, LE, , D);
  WHILE OCCURE(StaffLog) DO
   CONFORM(StaffLog, Officer);
   IF L_Env.IsDriver() THEN
    INC(Stage, L_DatTim.YearsInIntvl(StaffLog.Date, Math.Min(D, StaffLog.DateE)));
   END;
   PREV(StaffLog);
  END; (* WHILE OCCURE(StaffLog) ... *)
  RETURN Stage;
 END {DrStage};

 PRIVATE PROCEDURE DrCond(D: DATE): SCAL[2];
 BEGIN
  IF (Staff.BegDate <= D) & L_Staff.rInState(D) THEN
   CONFORM(StaffLog, Officer);
   RETURN L_Env.IsDriver();
  ELSE
   RETURN 0;
  END;
 END {DrCond};

 PRIVATE PROCEDURE wrInPos(objWS: OBJECT; row, column: NUMERIC[0]; Str: STRING[]);
 BEGIN
  L_Excel.ws_SetCurPos(objWS, row, column);
  L_Excel.ws_WrStr(objWS, Str)
 END {wrInPos};

 PRIVATE PROCEDURE DecorRange(range: OBJECT; text: STRING[]);
 BEGIN
  range.MergeCells :=L_Excel.xlTrue;
  range.WrapText   :=L_Excel.xlTrue;
  range.Value      :=text;
  range.Borders.Weight:=2;
 END {DecorRange};

 PRIVATE PROCEDURE InitOneSheet(objWS: OBJECT);
  CONST
   xlCenter = -4108;
  VAR
   Idx: NUMERIC[0];
 BEGIN
  PROMPT("ଫ ...");
  L_Excel.ws_Init(objWS);
  objWS.Cells(2, 1).RowHeight:=30;
  DecorRange(objWS.Range(objWS.Cells(1, 1), objWS.Cells(1, 7)), "  " + L_OwnData.ODFirmName(SYSDATE()));
  DecorRange(objWS.Range(objWS.Cells(2, 1), objWS.Cells(2, 1)), " ");
  DecorRange(objWS.Range(objWS.Cells(2, 2), objWS.Cells(2, 2)), "");
  DecorRange(objWS.Range(objWS.Cells(2, 3), objWS.Cells(2, 3)), "ࠦ⢮");
  DecorRange(objWS.Range(objWS.Cells(2, 4), objWS.Cells(2, 4)), "ﭭ  ⥫⢠");
  DecorRange(objWS.Range(objWS.Cells(2, 5), objWS.Cells(2, 5)), " .ᬮ");
  DecorRange(objWS.Range(objWS.Cells(2, 6), objWS.Cells(2, 6)), "⠦ ⥫ ⮡");
  DecorRange(objWS.Range(objWS.Cells(2, 7), objWS.Cells(2, 7)), " ஦");
  objWS.Range(objWS.Cells(1, 1), objWS.Cells(1, 22)).EntireColumn.NumberFormat:="@";
  L_Excel.ws_SetCurPos(objWS, 3, 1);
 END {InitOneSheet};

 PRIVATE PROCEDURE GetManAddr(D: DATE): STRING[];
 BEGIN
  IF ~L_Man.AccessManAdr(Man.Man, D, L_Russia.at_DwMA) THEN
   L_Man.AccessRgManAdr(Man.Man, D);
  END;
  RETURN L_Man.GetPostAdr_asStr(1);
 END {GetManAddr};

 PRIVATE PROCEDURE UploadToExcel(D: DATE);
  VAR
   objXL,
   objWB,
   objWS: OBJECT;
   Amount: NUMERIC[0];
 BEGIN
  L_General.Assert(L_Excel.ExcelInstalled(), " ⠭ MS Excel");
  objXL:=CreateOBJECT("Excel.Application");
  TRY
   objWB:=L_Excel.NewWorkbook(objXL, 1);
   objWS:=objWB.Sheets(1);
   InitOneSheet(objWS);
   SETZERO(Amount);

   SELECT(Staff, TSN);
   WHILE OCCURE(Staff) DO
    PROMPT(Staff.TSN);
    IF DrCond(D) THEN
     CONFORM(Staff, Man);
     L_Excel.ws_WrStr(objWS, Staff.TSN);
     L_Excel.ws_WrStr(objWS, Man.Name);
     L_Excel.ws_WrStr(objWS, L_Man.CitizenAsStr(Man.Man, D));
     L_Excel.ws_WrStr(objWS, GetManAddr(D));
     IF P_Man.HasManPro(Man.Man, D, P_Man.P_MedicalSertification) THEN
      L_Excel.ws_WrStr(objWS, L_DatTim.DateStr(ManPro.DocGiveD));
     ELSE
      L_Excel.ws_WrStr(objWS, "");
     END;
     L_Excel.ws_WrNum(objWS, DrStage(D));
     L_Excel.ws_WrNum(objWS, L_DatTim.YEAR(Man.Birth));
     L_Excel.ws_TermLine(objWS);
     INC(Amount);
    END;

    NEXT(Staff);
   END; (* WHILE OCCURE(Staff) ... *)

   objWS.Cells(2, 7).Select();
   objWS.UsedRange.EntireColumn.AutoFit();
   objWS.Range(objWS.Cells(3, 1), objWS.Cells(Amount+2, 7)).Borders.Weight:=2;

   TRY
    objWB.SaveAs(FIO.BuildPath("T_Drv_"+FLDTOSTR(D, "DNy"), "xls", FIO.MakePath("TXT", , FIO.AsbSpecialFolders("ClientProjectRoot"))));
   EXCEPT
   ELSE
   END;
   objWS.Visible            :=1;
   objWS.Application.Visible:=1;
  EXCEPT
  ELSE
   L_Excel.CloseExcel(objXL, objWB);
   RAISE();
  END;
 END {UploadToExcel};

BEGIN
 IF MODE = 100 THEN
  UploadToExcel(Memo.ud_cd());
 ELSE
  L_General.BadMode(MODE);
 END;
END.
