(*
%Copyright   (c) Polak IT
%Author      19.07.2005 11:30:52 POLAK\San
%Purpose      
%Type        operation
%Specific    LOC
%Modified    10.04.2012 13:23:10 ROBOT by POLAK\LDA
%Environment
*)

 IMPORT L_General, L_Print, L_TRSP, L_DatTim, L_TRS, P_Man, Str, L_lsStore, L_Car, L_Money, L_Str,
        L_Way, L_BegRWS, L_APWI, P_OwnData;

 PRIVATE PROCEDURE TypeS(X, Y: NUMERIC[1]; S: STRING[]; P: TEXTSTYLE);
 BEGIN
  L_TRSP.TypeS(X, Y, S, P);
 END {TypeS};

 PRIVATE PROCEDURE rs_TckRcS();
  CONST
   TckRcTRowsAmount = 14;
  VAR
   i,
   VldPsgPlan: NUMERIC[0];
   carY,
   extY,
   step,
   x,
   y         : FLOAT;
   bigTS,
   ts14,
   ts12,
   ts11,
   ts09,
   ts08,
   tsBarCode : TEXTSTYLE;
   Message   : STRING[][10];
 BEGIN
  ts14     :=L_Print.ts_Create(14, "Tahoma");
  ts12     :=L_Print.ts_Resize(ts14, 12);
  ts11     :=L_Print.ts_Resize(ts14, 11);
  ts09     :=L_Print.ts_Resize(ts14, 09);
  ts08     :=L_Print.ts_Resize(ts09, 08);
  tsBarCode:=L_Print.ts_Create(18, "IntP36DlTt");
  tsBarCode.Font.Charset:=FONT.Charset_ANSI;
  L_TRSP.TRSPrt.StartPage();
  L_Print.PrintBlankBackground(L_TRSP.TRSPrt, "TckRcS_F.BMP");
  CONFORM(TckRcS, Staff);
  CONFORM(Staff, Man);
  L_TRSP.PrintStdProportionPhoto(173, 17, 30.0);
  TypeS(049, 029, TckRcS.TckRcS, ts12);
  TypeS(067, 029, "(" + TckRcS.CopyCnt + ")", ts08);
  TypeS(085, 029, L_DatTim.DateStr(TckRcS.Date), ts12);
  L_TRSP.extTypeS(118, 025, L_TRS.GetBarCode_bck_IdIn20(), tsBarCode, L_Print.cp_ISO_8859_1_Latin_I);

  TypeS(013, 047, L_Str.PoolItem(L_Way.trs_Pool, TckRcS.AsWho), ts09);
  TypeS(034, 047, TckRcS.TSN, ts14);
  TypeS(052, 047, Man.Name, ts12);
  IF P_Man.HasActualManPro(Man.Man, TckRcS.Date, P_Man.P_EmploymentCertificate) THEN
   TypeS(132, 047, ManPro.DocNum, ts09);
  END;
  CONFORM(TckRcS, Storage);
  TypeS(152, 047, TckRcS.Storage, ts12);

  carY:=62;
  extY:=80.5;
  step :=3;
  bigTS:=ts11;
  i:=0;
  WHILE i < 3 DO
   IF !TckRcS.asRWayS[i] | ~SEARCH(RWayS, RWayS, TckRcS.asRWayS[i]) THEN
    IF step = 3 THEN
     step :=4;
     bigTS:=ts14;
     INC(carY, 1.5);
     INC(extY, 1.5);
    ELSE
     INC(carY, 2);
     INC(extY, 2);
    END;
   END;
   INC(i);
  END;
  SAVE(Staff);
  SAVE(Man);
  i:=0;
  WHILE i < 3 DO
   IF ~!TckRcS.asRWayS[i] & SEARCH(RWayS, RWayS, TckRcS.asRWayS[i]) THEN
    CONFORM(RWayS, Staff);
    CONFORM(Staff, Man);
    L_Car.StandOnCarLog(RWayS.BoxNbr, RWayS.Date);
    CONFORM(CarLog, Mark);
    TypeS(016, carY, RWayS.BoxNbr, bigTS);
    TypeS(035, carY, CarLog.StateNbr, bigTS);
    TypeS(062, carY, Mark.Mark + " " + Mark.Name, ts09);
    IF TckRcS.TSN # RWayS.TSN THEN
     TypeS(112, carY, RWayS.TSN, ts11);
     TypeS(131, carY, Man.Name, ts09);
    END;
    L_APWI.StandOnRWaySExit();
    TypeS(015, extY, StExit.Exit, bigTS);
    TypeS(055, extY, StExit.Name, ts09);
    TypeS(125, extY, L_DatTim.TimeStr(L_TRSP.GetRWaySExitTime(TckRcS.AsWho)), bigTS);
    TypeS(148, extY, L_DatTim.TimeStr(L_TRSP.GetRWaySEnterTime(TckRcS.AsWho)), bigTS);
    TypeS(175, extY, L_Money.MoneyToStr(RWayS.Date, "", L_Way.GetIncomePlanForTRS()), bigTS);
    INC(carY, step);
    INC(extY, step);
   END;
   INC(i);
  END;
  RESTORE(Staff);
  RESTORE(Man);
  i:=0;
  CONFORM(TckRcS, TckRcT);
  WHILE OCCURE(TckRcT) & (i < TckRcTRowsAmount) DO
   y:=104 + 5.75 * i;
   CONFORM(TckRcT, TckKind);
   TypeS(011, y, Str.Slice(TckRcT.TckRcT + " " + TckKind.Name, 0, 2 + 1 + 18), ts08);
   TypeS(042, y, "(" + TckRcT.TckKind + ")", ts08);
   TypeS(054, y, TckRcT.Series,              ts08);
   TypeS(086, y, L_TRSP.PrintTckRcTBefNbr(), ts08);
   INC(i);
   NEXT(TckRcT);
  END; (* WHILE OCCURE(TckRcT) ... *)

  TypeS(041, 185.5, L_TRSP.E_trsp_PrintSubsidiaryMoney(TckRcS.Date), ts08);
  TypeS(020, 193, L_DatTim.DateTimeStr(SYSDATE(), SYSTIME()), ts08);
  TypeS(091, 193, L_Str.ShortName(P_Man.GetFullNameOfCurrentUser(SYSDATE())), ts09);

  Str.Format(Message, L_lsStore.Get(TckRcS.Message), 100, LEFT);
  i:=0;
  WHILE (i <= HIGH(Message)) & ~!Message[i] DO
   TypeS(011, 205 + i * 4, Message[i], ts09);
   INC(i);
  END; (* WHILE (i <= HIGH(Message)) &... *)

  Str.Format(Message, P_OwnData.MessageToGuard(TckRcS.Date), 100, LEFT);
  WHILE (i <= HIGH(Message)) & ~!Message[i] DO
   TypeS(011, 205 + i * 4, Message[i], ts09);
   INC(i);
  END; (* WHILE (i <= HIGH(Message)) &... *)

  L_TRSP.TRSPrt.EndPage();
 END {rs_TckRcS};

BEGIN
 L_General.Assert(ACCESS(TckRcS), " ⠭ ");
 L_TRSP.CreatePrintJob(L_Print.pt_BlankAndDoc, L_Print.o_Portrait);
 rs_TckRcS();
 L_TRSP.TRSPrt.Close();
END.