(*
%Copyright   (c) Polak IT
%Author      01.02.2011 08:02:31 POLAK\LDA
%Purpose
%Type        control,report,temporary,convertor,operation,library,to paste
%Specific    AP,AP_PC,AP_PT,SYS,TOOL,LOC
%Modified    18.07.2013 18:02:07 POLAK\LDA
%Environment
*)

 MODULE u_RprMZ [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT L_General, L_Rpr, L_Excel, L_DatTim, FIO, L_MDoc, Memo, L_XDoc, P_Firm, L_CUC, L_Car, L_Str,
        L_MathR, L_Acnt, L_XObj, L_PDoc;

 PRIVATE CONST
  xlCenter = -4108;
  xlLeft   = -4131;
  xlRight  = -4152;
  xlLandscape = 2;

  lk_RprJob = 0;
  lk_Math   = 1;

 PRIVATE VAR
  curVIN,
  curStateNbr,
  OwnMTACode  : STRING[];
  curRun,
  curProdYear : NUMERIC[0];
  RprJobMath  : LIKE(Math.Math);

 PRIVATE PROCEDURE GetFileName(trgFrom, trgUpTo: DATE): STRING[];
  VAR
   Result: STRING[];
 BEGIN
  IF L_DatTim.Per(trgFrom) = L_DatTim.Per(trgUpTo) THEN
   IF (trgFrom = L_DatTim.MonthBeg(trgFrom)) &
      (trgUpTo = L_DatTim.MonthEnd(trgUpTo)) THEN
    Result:=FLDTOSTR(trgFrom, "yN", 6);
   ELSE
    Result:=FLDTOSTR(trgFrom, "yN", 6)+"_"+
            FLDTOSTR(trgFrom, "D",  2)+"_"+
            FLDTOSTR(trgUpTo, "D",  2);
   END;
  ELSE
   IF (trgFrom = L_DatTim.MonthBeg(trgFrom)) &
      (trgUpTo = L_DatTim.MonthEnd(trgUpTo)) THEN
    Result:=FLDTOSTR(trgFrom, "yN", 6)+"_"+
            FLDTOSTR(trgUpTo, "yN", 6);
   ELSE
    Result:=FLDTOSTR(trgFrom, "yND", 8)+"_"+
            FLDTOSTR(trgUpTo, "yND", 8);
   END;
  END;
  RETURN "RprMZ_" + Result;
 END {GetFileName};

 PRIVATE PROCEDURE MakeHeaderColumn(objWS: OBJECT; Column: NUMERIC[0]; Text: STRING[]; Width: NUMERIC[0]);
 BEGIN
  objWS.Cells(1, Column).ColumnWidth:=Width;
  objWS.Cells(1, Column).Value:=Text;
 END {MakeHeaderColumn};

 PRIVATE PROCEDURE InitOneSheet(objWS, objXL: OBJECT);
 BEGIN
  PROMPT("ଫ ...");

  L_Excel.ws_Init(objWS);
  objWS.Columns(1).RowHeight :=17.25;
  MakeHeaderColumn(objWS, 01, "稪",       17);
  MakeHeaderColumn(objWS, 02, "稪",          28);
  MakeHeaderColumn(objWS, 03, "ᯮ⥫슮",    21);
  MakeHeaderColumn(objWS, 04, "ᯮ⥫",       30);
  MakeHeaderColumn(objWS, 05, "᭮",          13);
  MakeHeaderColumn(objWS, 06, "ઠ",             30);
  MakeHeaderColumn(objWS, 07, "VIN",               21);
  MakeHeaderColumn(objWS, 08, " ᪠",       16);
  MakeHeaderColumn(objWS, 09, "஡",            11);
  MakeHeaderColumn(objWS, 10, "-",       16);
  MakeHeaderColumn(objWS, 11, " 砫",       16);
  MakeHeaderColumn(objWS, 12, "६ 砫",      16);
  MakeHeaderColumn(objWS, 13, "६ 砭",   16);
  MakeHeaderColumn(objWS, 14, " ६",       16);
  MakeHeaderColumn(objWS, 15, "",               08);
  MakeHeaderColumn(objWS, 16, "  ⠫",   25);
  MakeHeaderColumn(objWS, 17, "",      50);
  MakeHeaderColumn(objWS, 18, " ७", 24);
  MakeHeaderColumn(objWS, 19, "-",            10);
  MakeHeaderColumn(objWS, 20, "",              10);
  MakeHeaderColumn(objWS, 21, "㬬",             10);
  MakeHeaderColumn(objWS, 22, "",               10);

  objWS.Cells.Font.Name                                                :="Times New Roman";
  objWS.Cells.Font.Size                                                :=09;
  objWS.Cells.Font.Bold                                                :=L_Excel.xlFalse;
  objWS.Cells.EntireColumn.NumberFormat                                :="@";
  objWS.Range(objWS.Columns(1), objWS.Columns(22)).VerticalAlignment   :=xlCenter;
  objWS.Range(objWS.Columns(1), objWS.Columns(8)).HorizontalAlignment  :=xlLeft;
  objWS.Range(objWS.Columns(9), objWS.Columns(9)).HorizontalAlignment  :=xlRight;
  objWS.Range(objWS.Columns(10), objWS.Columns(17)).HorizontalAlignment:=xlLeft;

  objWS.Range(objWS.Columns(19), objWS.Columns(22)).HorizontalAlignment:=xlRight;
  objWS.Range(objWS.Columns(19), objWS.Columns(23)).EntireColumn.NumberFormat:="0,00";

  objWS.PageSetup.Orientation       :=xlLandscape;
  objWS.PageSetup.LeftMargin        :=objXL.CentimetersToPoints(1);
  objWS.PageSetup.TopMargin         :=objXL.CentimetersToPoints(1);
  objWS.PageSetup.RightMargin       :=objXL.CentimetersToPoints(1);
  objWS.PageSetup.BottomMargin      :=objXL.CentimetersToPoints(1);
  objWS.PageSetup.HeaderMargin      :=objXL.CentimetersToPoints(0.5);
  objWS.PageSetup.FooterMargin      :=objXL.CentimetersToPoints(0.5);
  objWS.PageSetup.CenterHorizontally:=L_Excel.xlTrue;

  L_Excel.ws_SetCurPos(objWS, 2, 1);
 END {InitOneSheet};

 PRIVATE PROCEDURE MakeSingleLine(objWS: OBJECT; LineKind: SCAL[2]);
  VAR
   VAT: L_XObj.tSum;
 BEGIN
  IF L_PDoc.IsOneHeadFirmBranch(P_Firm.mf_Own, MDoc.Firm, MDoc.Date) THEN
   L_Excel.ws_WrStr(objWS, P_Firm.GetFirmProStrong(MDoc.Firm, MDoc.Date, P_Firm.P_Depart));
  ELSE
   L_Excel.ws_WrStr(objWS, P_Firm.GetFirmProSoft(MDoc.Firm, MDoc.Date, P_Firm.P_Depart));
  END;
  L_Excel.ws_WrStr(objWS, P_Firm.FP_ContractorBriefName(MDoc.Firm, MDoc.Date));
  L_Excel.ws_WrStr(objWS, OwnMTACode);
  L_Excel.ws_WrStr(objWS, P_Firm.FP_ContractorBriefName(P_Firm.OWN_FIRM, MDoc.Date));
  L_Excel.ws_WrStr(objWS, curStateNbr);
  L_Excel.ws_WrStr(objWS, Mark.Name);
  L_Excel.ws_WrStr(objWS, curVIN);
  L_Excel.ws_WrNum(objWS, curProdYear);
  L_Excel.ws_WrNum(objWS, curRun);
  L_Excel.ws_WrScl(objWS, RprS.RprS);
  L_Excel.ws_WrDat(objWS, RprS.OrdDate);
  L_Excel.ws_WrStr(objWS, FLDTOSTR(L_DatTim.GetTIMESTAMP(RprS.OrdDate, RprS.OrdTime), "D.N.y H:M"));
  IF ~!RprS.EDate THEN
   L_Excel.ws_WrStr(objWS, FLDTOSTR(L_DatTim.GetTIMESTAMP(RprS.EDate, RprS.ETime), "D.N.y H:M"));
  ELSE
   L_Excel.ws_WrStr(objWS, "");
  END;
  CONFORM(RprS, RprT);
  IF OCCURE(RprT) THEN
   L_Excel.ws_WrStr(objWS, L_Str.PoolItem(L_Rpr.rpr_TaskKind_Pool, RprT.TaskKind));
  ELSE
   L_Excel.ws_WrStr(objWS, "---");
  END;
  L_Excel.ws_WrStr(objWS, L_Str.PoolItem("|", LineKind));
  IF LineKind = lk_Math THEN
   L_Excel.ws_WrStr(objWS, Math.UnitedC);
   L_Excel.ws_WrStr(objWS, Math.Name);
   L_Excel.ws_WrStr(objWS, L_MathR.DefaultMUnitSign(Math.Math));
   L_Excel.ws_WrNum(objWS, MDocList.Qnt);
   L_Excel.ws_WrNum(objWS, (MDocList.Sum + MDocList.VAT) / MDocList.Qnt);
   L_Excel.ws_WrNum(objWS, MDocList.Sum + MDocList.VAT);
   L_Excel.ws_WrNum(objWS, MDocList.VAT);
  ELSE
   L_Excel.ws_WrStr(objWS, RprJob.UnitedC);
   L_Excel.ws_WrStr(objWS, RprJob.Name);
   L_Excel.ws_WrStr(objWS, "ମ");
   L_Excel.ws_WrNum(objWS, RprJ.BaseTime * RprJ.Quantity);
   L_Excel.ws_WrNum(objWS, RprJ.Price);

   IF ~!RprJobMath THEN
    VAT:=L_Acnt.GetInclMathVAT(RprJobMath, RprS.OrdDate, RprJ.Sum);
   ELSE
    VAT:=L_Acnt.GetInclVAT(RprS.OrdDate, RprJ.Sum);
   END;
   L_Excel.ws_WrNum(objWS, RprJ.Sum);
   L_Excel.ws_WrNum(objWS, VAT);
  END;
  L_Excel.ws_TermLine(objWS);
 END {MakeSingleLine};

 PRIVATE PROCEDURE MakeOneSheet(objWS, objXL: OBJECT; name: STRING[]);
  CONST
   ColumnAmount = 22;
  VAR
   XDC         : L_XDoc.tXDocCollection;
   curXDocId   : L_XDoc.tXDocId;
   i,
   RprSAmnt    : NUMERIC[0];
 BEGIN
  TRY
   objWS.Name:=name;
  EXCEPT
  ELSE
  END;
  OwnMTACode:=P_Firm.GetFirmProStrong(P_Firm.FP_HeadFirm(P_Firm.OWN_FIRM, Memo.ud_ut()), Memo.ud_ut(), P_Firm.P_OurCode);
  InitOneSheet(objWS, objXL);
  SELECT(MDoc, MDKDate, , L_MDoc.md_IAS);
  SRCINSEL(MDoc, GE, , Memo.ud_fr());
  WHILE OCCURE(MDoc) & (MDoc.Date <= Memo.ud_ut()) DO
   IF MDoc.Status = L_MDoc.st_Passed THEN
    PROMPT(L_MDoc.MDocStr(MDoc.MDocKind, MDoc.MDoc));
    XDC:=L_XDoc.GetRefToXDC_Transitively(L_XDoc.curXDocId(L_XDoc.xdt_MDoc), L_XDoc.xdt_RprS);
    SETZERO(i, RprSAmnt);
    LOOP
     curXDocId:=L_XDoc.xdc_Item(XDC, i);
     IF !curXDocId THEN
      EXIT;
     END;
     IF L_XDoc.ExtractXDocType(curXDocId) = L_XDoc.xdt_RprS THEN
      L_General.ConsultToUs(RprSAmnt < 2, "㬥 ନ஢  ᪮쪨 ");
      L_XDoc.PositionOnXDoc(curXDocId);
      IF RprS.Location = L_Rpr.rprl_MaintenanceZone THEN
       RprJobMath:=L_Rpr.E_GetRprJobMath(MDoc.Date);
  
       CONFORM(RprS, CUCopy);
       L_CUC.AccessOrigin();
       IF    L_Rpr.IsRprS_w_Car() THEN
        L_Car.StandOnCarLog(Car.BoxNbr, RprS.OrdDate);
        CONFORM(CarLog, Mark);
        curStateNbr:=CarLog.StateNbr;
        curProdYear:=L_DatTim.YEAR(L_Car.GetCarProdDate(Car.BoxNbr, RprS.OrdDate));
        L_Car.AccessVehPasp(Car.BoxNbr, RprS.OrdDate);
        IF OCCURE(VehPasp) THEN
         curVIN:=VehPasp.VIN;
        ELSE
         SETEMPTY(curVIN);
        END;
        curRun     :=L_Car.GetGlobalRun(Car.BoxNbr, RprS.OrdDate);
       ELSIF L_Rpr.IsRprS_w_OutCar() THEN
        CONFORM(OutCar, Mark);
        curStateNbr:=OutCar.StateNbr;
        curProdYear:=OutCar.ProdYear;
        curVIN     :=OutCar.VIN;
        curRun     :=RprS.SMBef;
       ELSE
        L_General.CallUs(0);
       END;
       CONFORM(RprS, RprJ);
       WHILE OCCURE(RprJ) DO
        PROMPT(RprS.RprS + " " + RprJ.RprJ);
        CONFORM(RprJ, RprJob);
        MakeSingleLine(objWS, lk_RprJob);
        NEXT(RprJ);
       END; (* WHILE OCCURE(RprJ) ... *)
  
       CONFORM(MDoc, MDocList);
       WHILE OCCURE(MDocList) DO
        PROMPT(L_MDoc.MDocStr(MDoc.MDocKind, MDoc.MDoc) + " " + MDocList.MDLNbr);
        IF L_MathR.IsInventories(MDocList.Math) THEN
         CONFORM(MDocList, Math);
         MakeSingleLine(objWS, lk_Math);
        END;
        NEXT(MDocList);
       END; (* WHILE OCCURE(MDocList) ... *)
       INC(RprSAmnt);
      END;
     END;
     INC(i);
    END; (* LOOP *)
   END;
   NEXT(MDoc);
  END; (* WHILE OCCURE(MDoc) ... *)

  i:=1;
  WHILE i <= ColumnAmount DO
   objWS.Columns(i).EntireColumn.AutoFit();
   INC(i);
  END;
  objWS.Range(objWS.Rows(1), objWS.Rows(1)).AutoFilter();
  objWS.Range(objWS.Rows(1), objWS.Rows(1)).Interior.Color:=16764057;
  objWS.Cells(2, 3).Select();
  objXL.ActiveWindow.FreezePanes:=L_Excel.xlTrue;
 END {MakeOneSheet};

 PUBLIC PROCEDURE u_RprMZ();
  VAR
   objXL,
   objWB,
   objWS  : OBJECT;
 BEGIN
  SE_ACCESSDATAMODE(AccessDataMode_SOFT);
  L_General.Assert(L_Excel.ExcelInstalled(), " ⠭ MS Excel");
  objXL:=CreateOBJECT("Excel.Application");
  TRY
   objWB:=L_Excel.NewWorkbook(objXL, 1);
   objWS:=objWB.Sheets(1);
   MakeOneSheet(objWS, objXL, "");

   TRY
    objWB.SaveAs(FIO.BuildPath(GetFileName(Memo.ud_fr(), Memo.ud_ut()), "xls", FIO.MakePath("TXT", , FIO.AsbSpecialFolders("ClientProjectRoot"))));
   EXCEPT
   ELSE
   END;
   objWS.Visible            :=L_Excel.xlTrue;
   objWS.Application.Visible:=L_Excel.xlTrue;
  EXCEPT
  ELSE
   L_Excel.CloseExcelAfterCrash(objXL, objWB);
   RAISE();
  END;
 END {u_RprMZ};

END.
