(*
%Copyright   (c) Polak Computer System
%Author      28.11.1997 15:31:06 SAN
%Purpose     ⥪  ६
%Type        library
%Specific    AP
%Modified    24.09.2014 15:13:48 ?
%Environment
*)

 MODULE L_Rpr [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 PUBLIC TYPE
  tMirrorStatus = SCAL[11];
  tRprSLocation = SCAL[100];
  tRepairZone   = SCAL[9];
  tRprLev       = SCAL[3];

 PUBLIC CONST
  tr_InProgress      = 0;
  tr_Done            = 1;
  tr_RequiredAnother = 2;
  tr_PutOff          = 3;

  daf_ThereIs      = 0;
  daf_Done         = 1;
  daf_PutOff       = 2;
  daf_Invalidate   = 3;
  daf_Transference = 9;

  ms_Open                  = 0;
  ms_Ready                 = 1;
  ms_Waiting               = 2;
  ms_Done                  = 3;
  ms_WaitTechAid           = 4;
  ms_WaitRetriever         = 5;
  ms_Return                = 6;
  ms_PutOff                = 7;
  ms_NeedRate              = 8;
  ms_Cancel                = 9;
  ms_IndependentRepair     = 10;

  rpk_Real      = 0;
  rpk_TechAid   = 1;
  rpk_Retriever = 2;
  rpk_Zone      = 3;

  rpk_Pool      = '|寮||. ';

  rprda_Exploitation = 0;
  rprda_Diagnostics  = 1;
  rprda_Repair       = 2;

  rprpwho_AnyDeclarant     = 0;
  rprpwho_DrvDeclarant     = 1;
  rprpwho_TechAidDrv       = 2;
  rprpwho_RepairGroupChief = 3;
  rprpwho_Executor         = 4;
  rprpwho_RetrieverDrv     = 5;
  rprpwho_Driver           = 6;

  rprpwho_Pool      =  "⥫ (稥)"+
                      "|⥫ ( )"+
                      "|ᯮ⥫ (寮)"+
                      "|㪮⥫ ६.㯯"+
                      "|ᯮ⥫" +
                      "|⥫ " +
                      "|⥫ ";

  tk_Servicing2              = 0;
  tk_Request                 = 1;
  tk_Line                    = 2;
  tk_Overhaul                = 3;
  tk_Retire                  = 4;
  tk_Servicing1              = 5;
  tk_MidLifeRepair           = 6;
  tk_BreakDownRepair         = 7;
  tk_OtherRoutineMaintenance = 8;
  tk_Diagnostics             = 9;
  tk_IndependentRepair       = 10;
  tk_WarrantyRepair          = 11;

  rpr_TaskKind_Pool = " - 2|| |६|ᠭ| - 1|।. ६|. ६|稥 ࠡ|⨪|.६|࠭.६";

  rpe_None     = 0;
  rpe_Elevator = 1;
  rpe_Jack     = 2;
  rpe_Pool = "|ꥬ||";

  rps_Normal   = 0;
  rps_Extended = 1;

  rprl_Amount  = 8;

  rprl_ControllerOffice = 0;
  rprl_Gate             = 1;
  rprl_RepairZone       = 2;
  rprl_MaintenanceZone  = 3;
  rprl_ServiceCenter    = 4;
  rprl_RZ_Part1         = 5;
  rprl_Workshop         = 6;
  rprl_MathWorkshop     = 7;

  fict_CarBlock = 00;
  fict_RprDfApr = 0000;

  rprjbts_Default  = 0;
  rprjbts_Select   = 1;
  rprjbts_Operator = 2;

  rot_Car        = 0;
  rot_OutCar     = 1;
  rot_CarBlock   = 2;
  rot_OutCBlc    = 3;
  rot_Math       = 4;

  rot_Pool       = "࠭ᯮ⭮ ।⢮|஭ |ॣ|஭ ॣ|";
  rot_Pool_Short = " |*|#|+|=";

  rz_Amount = 3;

  rprl_None   = 0;
  rprl_Intro  = 1;
  rprl_Active = 2;

  fictMarkG = 0000;

  rjd_None      = 0;
  rjd_FlowSheet = 1;
  rjd_RprJobSet = 2;

  rjd_Pool       = "| 孮᪮ ⮩|祭 ࠡ";
  rjd_Pool_Short = " ||";

  are_lev_RprDA = 0; (*Add_RepEv.Level*)
  are_lev_RprT  = 1;
  are_lev_RprJ  = 2;

  rprpl_RprS = 0;
  rprpl_RprT = 1;
  rprpl_RprJ = 2;

 PUBLIC PERMANENT VAR
  v_EmptyIndexValue: SCAL[1E2];
  v_rprs_BegDate   : DATE;
  v_rprs_Shift     : LIKE(RprStaff.RprShift);

 PRIVATE CONST
  exc_NormalTryExit = " ଠ 室   ஢ 02.06.2004 18:59:40 POLAK\LDA";

 IMPORT L_General, E_Rpr, Math, Str, L_StdFrm, L_Str, L_AFM, L_XDoc, L_Way, L_MathR, L_Acnt, P_Firm,
        L_DatTim, L_Env, L_Car, L_EC, Memo, L_BegRWS, L_CUC, P_Rpr, L_Pmnt, L_MDoc, L_XObj, L_PDoc,
        L_lsStore, L_MSO, L_SES, P_Cntr, P_Storage, L_Stock, L_ctc, L_AcCut, L_AR, L_OwnData, P_Man,
        FIO;

 PUBLIC PROCEDURE GetRprPLevel(trgRprS : LIKE(RprS.RprS);
                               trgRprT : LIKE(RprT.RprT);
                               trgRprJ : LIKE(RprJ.RprJ)): SCAL[3];
 BEGIN
  IF    ~!trgRprS &  !trgRprT &  !trgRprJ THEN
   RETURN rprpl_RprS;
  ELSIF ~!trgRprS & ~!trgRprT &  !trgRprJ THEN
   RETURN rprpl_RprT;
  ELSIF ~!trgRprS & ~!trgRprT & ~!trgRprJ THEN
   RETURN rprpl_RprJ;
  ELSE
   L_General.CallUs(0);
  END;
 END {GetRprPLevel};

 PRIVATE PROCEDURE E_GetReturnDateTime(VAR RDate: DATE;
                                       VAR RTime: TIME);
  VAR
   Local: PROC;
 BEGIN
  Local:=PROCREF(E_Rpr.GetReturnDateTime);
  IF ~!Local THEN
   Local(RDate, RTime);
  ELSE
   RDate:=RprS.OrdDate;
   RTime:=RprS.OrdTime;
  END;
 END {E_GetReturnDateTime};

 PRIVATE PROCEDURE E_AcceptableLocation_ForReturnRprS(): SCAL[2];
 BEGIN
  RETURN L_EC.ExecE_Func_Scal2(SYSDATE(), PROCREF(E_Rpr.AcceptableLocation_ForReturnRprS), RprS.Location = rprl_ControllerOffice);
 END {E_AcceptableLocation_ForReturnRprS};

 PRIVATE PROCEDURE E_AcceptableLocation_ForDoneRprS(): SCAL[2];
 BEGIN
  RETURN L_EC.ExecE_Func_Scal2(SYSDATE(), PROCREF(E_Rpr.AcceptableLocation_ForDoneRprS),   RprS.Location = rprl_RepairZone);
 END {E_AcceptableLocation_ForDoneRprS};

 PUBLIC PROCEDURE E_GetDefaultTechAidSort(_Kind: LIKE(RprPlace.Kind)): LIKE(Sort.Sort);
  VAR
   Local: PROC;
 BEGIN
  Local:=PROCREF(E_Rpr.GetDefaultTechAidSort);
  IF ~!Local THEN
   RETURN Local(_Kind);
  ELSE
   RETURN "";
  END;
 END {E_GetDefaultTechAidSort};

 PUBLIC PROCEDURE E_IsTechAidSort(_Kind: LIKE(RprPlace.Kind);
                                  _Sort: LIKE(Sort.Sort)): SCAL[2] ;
  VAR
   Local: PROC;
 BEGIN
  Local:=PROCREF(E_Rpr.IsTechAidSort);
  IF ~!Local THEN
   RETURN Local(_Kind, _Sort);
  ELSE
   RETURN E_GetDefaultTechAidSort(_Kind) = _Sort;
  END;
 END {E_IsTechAidSort};

 PUBLIC PROCEDURE E_Task_woJobSupport(): SCAL[2];
 BEGIN
  RETURN L_EC.ExecE_Func_Scal2(SYSDATE(), PROCREF(E_Rpr.Task_woJobSupport), 1);
 END {E_Task_woJobSupport};

 PUBLIC PROCEDURE E_GetOpenRprSGroup(): LIKE(RprSMirr.Group);
  VAR
   Local : PROC;
   _Group: LIKE(RprSMirr.Group);
 BEGIN
  Local:=PROCREF(E_Rpr.GetOpenRprSGroup);
  IF ~!Local THEN
   RETURN Local();
  ELSE
   RETURN EMPTYOF(RprSMirr.Group);
  END;
 END {E_GetOpenRprSGroup};

 PUBLIC PROCEDURE E_AllowedRprSLocation(rl: tRprSLocation): SCAL[2];
  VAR
   Local: PROC;
 BEGIN
  Local:=PROCREF(E_Rpr.AllowedRprSLocation);
  IF ~!Local THEN
   RETURN Local(rl);
  ELSE
   RETURN (rl = rprl_ControllerOffice) | (rl = rprl_Gate) | (rl = rprl_RepairZone);
  END;
 END {E_AllowedRprSLocation};

 PUBLIC PROCEDURE IsRepairZoneLocation(rl: tRprSLocation): SCAL[2];
 BEGIN
  RETURN (rl = rprl_ControllerOffice) |
         (rl = rprl_Gate)             |
         (rl = rprl_RepairZone)       |
         (rl = rprl_RZ_Part1)         ;
 END {IsRepairZoneLocation};

 PUBLIC PROCEDURE IsServiceCenterLocation(rl: tRprSLocation): SCAL[2];
 BEGIN
  RETURN (rl = rprl_MaintenanceZone) | (rl = rprl_ServiceCenter);
 END {IsServiceCenterLocation};

 PUBLIC PROCEDURE IsWorkshopLocation(rl: tRprSLocation): SCAL[2];
 BEGIN
  RETURN (rl = rprl_Workshop) | (rl = rprl_MathWorkshop);
 END {IsWorkshopLocation};

 PRIVATE PROCEDURE GetRprZoneNumber(rl: tRprSLocation): tRepairZone;
 BEGIN
  IF    IsRepairZoneLocation(rl) THEN
   RETURN 0;
  ELSIF IsServiceCenterLocation(rl) THEN
   RETURN 1;
  ELSIF IsWorkshopLocation(rl) THEN
   RETURN 2;
  ELSE
   L_General.CallUs(0);
  END;
 END {GetRprZoneNumber};

 PUBLIC PROCEDURE IsRprS_w_Car(): SCAL[2];
 BEGIN
  RETURN RprS.RprObjT = rot_Car;
 END {IsRprS_w_Car};

 PUBLIC PROCEDURE IsRprS_w_OutCar(): SCAL[2];
 BEGIN
  RETURN RprS.RprObjT = rot_OutCar;
 END {IsRprS_w_OutCar};

 PUBLIC PROCEDURE IsRprS_w_CarBlock(): SCAL[2];
 BEGIN
  RETURN RprS.RprObjT = rot_CarBlock;
 END {IsRprS_w_CarBlock};

 PUBLIC PROCEDURE IsRprS_w_OutCBlc(): SCAL[2];
 BEGIN
  RETURN RprS.RprObjT = rot_OutCBlc;
 END {IsRprS_w_OutCBlc};

 PUBLIC PROCEDURE IsRprS_w_Math(): SCAL[2];
 BEGIN
  RETURN RprS.RprObjT = rot_Math;
 END {IsRprS_w_Math};

 PUBLIC PROCEDURE GetRprSGroupName(rl: tRprSLocation): STRING[];
 BEGIN
  IF    rl = rprl_ControllerOffice THEN RETURN "RPRS_0";
  ELSIF rl = rprl_Gate             THEN RETURN "RPRS_1";
  ELSIF rl = rprl_RepairZone       THEN RETURN "RPRS_2";
  ELSIF rl = rprl_MaintenanceZone  THEN RETURN "RPRS_3";
  ELSIF rl = rprl_ServiceCenter    THEN RETURN "RPRS_4";
  ELSIF rl = rprl_RZ_Part1         THEN RETURN "RPRS_5";
  ELSIF rl = rprl_Workshop         THEN RETURN "RPRS_6";
  ELSIF rl = rprl_MathWorkshop     THEN RETURN "RPRS_7";
  ELSE  L_General.CallUs(0);
  END;
 END {GetRprSGroupName};

 PUBLIC PROCEDURE IsMainRpr(): SCAL[2];
 BEGIN
  RETURN L_AR.IsManagerOfGroupN("RPRS_0") |
         L_AR.IsManagerOfGroupN("RPRS_1") |
         L_AR.IsManagerOfGroupN("RPRS_2") |
         L_AR.IsManagerOfGroupN("RPRS_3") |
         L_AR.IsManagerOfGroupN("RPRS_4") |
         L_AR.IsManagerOfGroupN("RPRS_5") |
         L_AR.IsManagerOfGroupN("RPRS_6") |
         L_AR.IsManagerOfGroupN("RPRS_7") |
         L_General.IsAdmin();
 END {IsMainRpr};

 PRIVATE PROCEDURE intCanModify(trgLocation: tRprSLocation; wCheckMainRpr: SCAL[2]): SCAL[2];
 BEGIN
  RETURN E_AllowedRprSLocation(trgLocation) &
         (wCheckMainRpr & IsMainRpr() | L_General.IsMemberOf(GetRprSGroupName(trgLocation)));
 END {intCanModify};

 PUBLIC PROCEDURE CanModify(trgLocation: tRprSLocation): SCAL[2];
 BEGIN
  RETURN intCanModify(trgLocation, 1);
 END {CanModify};

 PUBLIC PROCEDURE IsCarReadinessStatus(ms: tMirrorStatus): SCAL[2];
 BEGIN
  RETURN (ms = ms_Done) | (ms = ms_NeedRate) | (ms = ms_Ready);
 END {IsCarReadinessStatus};

 PRIVATE PROCEDURE IsAvailableStatus_byCurRprSStatus(ms: tMirrorStatus): SCAL[2];
 BEGIN
  IF    RprS.Status = ms_Ready THEN
   RETURN (ms = ms_Done) | (ms = ms_NeedRate);
  ELSIF RprS.Status = ms_NeedRate THEN
   RETURN ms = ms_Done;
  ELSIF RprS.Status = ms_Done THEN
   RETURN ms = ms_NeedRate;
  ELSIF ~IsCarReadinessStatus(RprS.Status) THEN
   RETURN (ms = ms_NeedRate) |  (ms = ms_Ready);
  ELSE
   RETURN 0;
  END;
 END {IsAvailableStatus_byCurRprSStatus};

 PUBLIC PROCEDURE E_MaySetMirrorStatus(ms: tMirrorStatus): SCAL[2];
  VAR
   Local  : PROC;
   default: SCAL[2];
 BEGIN
  default:=IsAvailableStatus_byCurRprSStatus(ms);
  IF    IsMainRpr() THEN
(* 祣   - ⠢塞 default *)
  ELSIF ~IsCarReadinessStatus(RprS.Status) &
        intCanModify(rprl_RepairZone, 0) THEN
   default:=ms = ms_Ready;
  ELSIF intCanModify(rprl_ControllerOffice, 0) |
        intCanModify(rprl_Gate, 0)             |
        intCanModify(rprl_MaintenanceZone, 0)  |
        intCanModify(rprl_ServiceCenter, 0)    |
        intCanModify(rprl_Workshop, 0)         |
        intCanModify(rprl_MathWorkshop, 0) THEN
(* 祣   - ⠢塞 default *)
  ELSE
   default:=0;
  END;

  Local:=PROCREF(E_Rpr.MaySetMirrorStatus);
  IF ~!Local THEN
   RETURN Local(ms, default);
  ELSE
   RETURN default;
  END;
 END {E_MaySetMirrorStatus};

 PRIVATE PROCEDURE GetNearestAllowedRprSLocation(trgLocation: tRprSLocation): tRprSLocation;
  VAR
   HasNearestAllowedRprSLocation: SCAL[2];
 BEGIN
  HasNearestAllowedRprSLocation:=0;
  IF (trgLocation < rprl_Amount) &
     (GetRprZoneNumber(RprS.Location) = GetRprZoneNumber(trgLocation)) THEN
   WHILE (trgLocation < rprl_Amount) & ~HasNearestAllowedRprSLocation DO
    IF E_AllowedRprSLocation(trgLocation) THEN
     HasNearestAllowedRprSLocation:=1;
    ELSE
     INC(trgLocation);
    END;
   END; (* WHILE (trgLocation < rprl_Amount) & ... *)
  END;
  IF HasNearestAllowedRprSLocation THEN
   RETURN trgLocation;
  ELSE
   RETURN EMPTYOF(tRprSLocation);
  END;
 END {GetNearestAllowedRprSLocation};

 PUBLIC PROCEDURE E_RprSAcceptableAction(trgAction  : LIKE(XDocJrn.Action);
                                         trgLocation: tRprSLocation): SCAL[2];
  VAR
   Local  : PROC;
   default: SCAL[2];
 BEGIN
  default:=0;
  IF E_AllowedRprSLocation(trgLocation) THEN
   IF    trgAction = L_XDoc.action_Insert THEN
    IF (trgLocation = rprl_RepairZone) | (trgLocation = rprl_RZ_Part1) THEN
     default:=0;
    ELSE
     default:=CanModify(trgLocation);
    END;
   ELSIF trgAction = L_XDoc.action_Edit THEN
    default:=CanModify(trgLocation);
   ELSIF trgAction = L_XDoc.action_rprTransfer THEN
    default:=trgLocation = GetNearestAllowedRprSLocation(RprS.Location + 1);
   ELSIF trgAction = L_XDoc.action_rprCnclPuttingIntoOperation THEN
    default:=IsMainRpr();
   ELSE
    L_General.CallUs(0);
   END;
  END;

  Local:=PROCREF(E_Rpr.RprSAcceptableAction);
  IF ~!Local THEN
   RETURN Local(trgAction, trgLocation, default);
  ELSE
   RETURN default;
  END;
 END {E_RprSAcceptableAction};

 PUBLIC PROCEDURE E_RemainsIndication_Required(D: DATE): SCAL[2];
 BEGIN
  RETURN L_EC.ExecE_Func_Scal2(D, PROCREF(E_Rpr.RemainsIndication_Required), 1);
 END {E_RemainsIndication_Required};
(*
 PUBLIC PROCEDURE E_RemainsIndication_Required(D: DATE): SCAL[2];
  VAR
   Result: SCAL[2];
 BEGIN
  IF IsRprS_w_OutCar() | IsRprS_w_Car() THEN
   Result:=L_EC.ExecE_Func_Scal2(D, PROCREF(E_Rpr.RemainsIndication_Required), 1);
  ELSE
   Result:=0;
  END;
  RETURN Result;
 END {E_RemainsIndication_Required};
*)

 PUBLIC PROCEDURE E_SpeedometerIndication_Required(D: DATE): SCAL[2];
  VAR
   Result: SCAL[2];
 BEGIN
  IF    IsRprS_w_OutCar() THEN
   Result:=1;
  ELSIF IsRprS_w_Car() THEN
   Result:=L_EC.ExecE_Func_Scal2(D, PROCREF(E_Rpr.SpeedometerIndication_Required), 1);
  ELSE
   Result:=0;
  END;
  RETURN Result;
 END {E_SpeedometerIndication_Required};

 PUBLIC PROCEDURE E_OutRprObjAllowed(): SCAL[2];
  VAR
   Local: PROC;
 BEGIN
  Local:=PROCREF(E_Rpr.OutRprObjAllowed);
  IF ~!Local THEN
   RETURN Local();
  ELSE
   RETURN 0;
  END;
 END {E_OutRprObjAllowed};

 PUBLIC PROCEDURE CheckOutRprObjAllowed();
 BEGIN
  L_General.Assert(E_OutRprObjAllowed(), " 믮 ⮩ 樨 ॡ|" +
                                       "⠭ ⥬ 'ࢨ'");
 END {CheckOutRprObjAllowed};

 PUBLIC PROCEDURE AcceptableCalcRprJSum(): SCAL[2];
  VAR
   Result: SCAL[2];
 BEGIN
  SETZERO(Result);
  IF E_OutRprObjAllowed() THEN
   SAVE(RprT);
   Result:=IsWarrantyRepair()                     |
           IsRprS_w_OutCar()                      |
           IsServiceCenterLocation(RprS.Location) |
           (IsWorkshopLocation(RprS.Location) & IsRprS_w_OutCBlc());
   RESTORE(RprT);
  END;
  RETURN Result;
 END {AcceptableCalcRprJSum};

 PUBLIC PROCEDURE E_GetNormHourPrice(): NUMERIC[2];
  VAR
   Local : PROC;
   Result: NUMERIC[2];
 BEGIN
  SETEMPTY(Result);
  IF AcceptableCalcRprJSum() THEN
   Local:=PROCREF(E_Rpr.GetNormHourPrice);
   IF ~!Local THEN
    Result:=Local();
   END;
  END;
  RETURN Result;
 END {E_GetNormHourPrice};

 PUBLIC PROCEDURE E_GetRprJobMath(D: DATE): LIKE(Math.Math);
  VAR
   Local : PROC;
   Result: LIKE(Math.Math);
 BEGIN
  SETEMPTY(Result);
  Local:=PROCREF(E_Rpr.GetRprJobMath);
  IF ~!Local THEN
   Result:=Local(D);
  END;
  IF ~!Result THEN
   IF ~SEARCH(Math, Math, Result) THEN
    L_StdFrm.WrongDB(" ࠢ筨      " + Result + "  ଫ   ६");
   END;
  END;
  RETURN Result;
 END {E_GetRprJobMath};

 PUBLIC PROCEDURE E_OccupySingleRprPlaceByWholeRprS(): SCAL[2];
 BEGIN
  RETURN L_EC.ExecE_Func_Scal2(RprS.OrdDate, PROCREF(E_Rpr.OccupySingleRprPlaceByWholeRprS), 0);
 END {E_OccupySingleRprPlaceByWholeRprS};

(*-------------BEGIN OF NORMAL ENVIRONMENT--------------------------*)

 PUBLIC PROCEDURE GetWhenBurn_Pool(Short: SCAL[2]): STRING[];
 BEGIN
  IF Short THEN
   RETURN "||";
  ELSE
   RETURN "ᯫ|⨪|";
  END;
 END {GetWhenBurn_Pool};

 PUBLIC PROCEDURE GetFixed_Pool(Short: SCAL[2]): STRING[];
 BEGIN
  IF Short THEN
   RETURN "-|+||| | | | | |";
  ELSE
   RETURN "||⫮| ⢥ত| | | | | |७ᥭ";
  END;
 END {GetFixed_Pool};

 PUBLIC PROCEDURE GetRprJobType_Pool(Short: SCAL[2]): STRING[];
 BEGIN
  IF Short THEN
   RETURN "-|||||||";
  ELSE
   RETURN "⨥-⠭|⨥|⠭|  |㫨஢||客 ६|⨪";
  END;
 END {GetRprJobType_Pool};

 PUBLIC PROCEDURE GetRprSStatus_Pool(Short: SCAL[2]): STRING[];
 BEGIN
  IF Short THEN
   RETURN "|||  |||||||";
  ELSE
   RETURN "|⮢|||寮|||⫮|஢|㫨஢|.ଭ";
  END;
 END {GetRprSStatus_Pool};

 PUBLIC PROCEDURE GetRprSStatus_AsStr(_Status: tMirrorStatus): STRING[];
 BEGIN
  RETURN L_Str.PoolItem(GetRprSStatus_Pool(0), _Status);
 END {GetRprSStatus_AsStr};

 PUBLIC PROCEDURE GetTaskResult_Pool(Short: SCAL[2]): STRING[];
 BEGIN
  IF Short THEN
   RETURN "-|+||";
  ELSE
   RETURN " |믮|㣮 |⫮";
  END;
 END {GetTaskResult_Pool};

 PUBLIC PROCEDURE AccessOrigin();
 BEGIN
  CONFORM(RprS, CUCopy);
  L_CUC.AccessOrigin();
 END {AccessOrigin};

 PUBLIC PROCEDURE AccessMark(OnDate: DATE);
 BEGIN
  AccessOrigin();
  IF    IsRprS_w_Car() THEN
   L_Car.AccessMark(Car.BoxNbr, OnDate);
  ELSIF IsRprS_w_OutCar() THEN
   CONFORM(OutCar, Mark);
  ELSE
   L_General.CallUs(0);
  END;
 END {AccessMark};

 PUBLIC PROCEDURE GetRprObjT_AsStr(): STRING[];
 BEGIN
  RETURN L_Str.PoolItem(rot_Pool, RprS.RprObjT);
 END {GetRprObjT_AsStr};

 PUBLIC PROCEDURE GetFullRprObjT_AsStr(): STRING[];
 BEGIN
  RETURN GetRprObjT_AsStr() + " " + RprS.RprObjId;
 END {GetFullRprObjT_AsStr};

 PUBLIC PROCEDURE HasRprTNotification(): SCAL[2];
 BEGIN
  RETURN ~!RprT.JobBDate & ~!RprT.JobBTime;
 END {HasRprTNotification};

 PUBLIC PROCEDURE HasRprTEnding(): SCAL[2];
 BEGIN
  RETURN ~!RprT.JobEDate & ~!RprT.JobETime;
 END {HasRprTEnding};

 PUBLIC PROCEDURE DateTimeToStr(Date: DATE; Time: TIME): STRING[];
 BEGIN
  RETURN L_DatTim.DateTimeStr(Date, Time);
 END {DateTimeToStr};

 PRIVATE PROCEDURE OverTime(PD, D: DATE; PT, T: TIME): NUMERIC[3];
  VAR
   R: NUMERIC[3];
 BEGIN
  IF PT < T THEN
   R:=-(T-PT);
  ELSE
   R:=+(PT-T);
  END;
  RETURN R+(PD-D)*24;
 END {OverTime};

 PUBLIC PROCEDURE SysOverTime(D: DATE; T: TIME): NUMERIC[3];
 BEGIN
  RETURN OverTime(SYSDATE(), D, SYSTIME(), T);
 END {SysOverTime};

 PUBLIC PROCEDURE GetRprTTaskLen(): LIKE(RprT.TaskLen);
 BEGIN
  IF ~!RprT.TaskLen THEN
   RETURN RprT.TaskLen;
  ELSE
   IF HasRprTNotification() THEN
    RETURN 2;
   ELSE
    RETURN EMPTYOF(RprT.TaskLen);
   END;
  END;
 END {GetRprTTaskLen};

 PUBLIC PROCEDURE GetEDTS(trgTaskLen : LIKE(RprT.TaskLen);
                          trgJobBDate: DATE;
                          trgJobBTime: TIME): FLOAT;
  VAR
   Result  : FLOAT;
   PlnEDate: DATE;
   PlnETime: TIME;
 BEGIN
  SETEMPTY(Result);
  IF ~!trgTaskLen & ~!trgJobBDate & ~!trgJobBTime THEN
   Result:=L_DatTim.GetVARIANTDATE(trgJobBDate, trgJobBTime, 00) + trgTaskLen / 24;
  END;
  RETURN Result;
 END {GetEDTS};

 PRIVATE PROCEDURE GetRprTEDTS(): FLOAT;
 BEGIN
  RETURN GetEDTS(GetRprTTaskLen(), RprT.JobBDate, RprT.JobBTime);
 END {GetRprTEDTS};

 PUBLIC PROCEDURE GetEndDateTime(EDTS       : FLOAT;
                                 VAR EndDate: DATE;
                                 VAR EndTime: TIME);
 BEGIN
  IF ~!EDTS THEN
   UnPkVARIANTDATE(EDTS, EndDate, EndTime);
  ELSE
   SETEMPTY(EndDate, EndTime);
  END;
 END {GetEndDateTime};

 PUBLIC PROCEDURE GetRprTEndDateTime(VAR EndDate: DATE;
                                     VAR EndTime: TIME);
 BEGIN
  GetEndDateTime(GetRprTEDTS(), EndDate, EndTime);
 END {GetRprTEndDateTime};

 PUBLIC PROCEDURE GetRprTPlanETimes_AsStr(): STRING[];
  VAR
   D: DATE;
   T: TIME;
 BEGIN
  GetRprTEndDateTime(D, T);
  RETURN L_DatTim.DateTimeStr(D, T);
 END {GetRprTPlanETimes_AsStr};

 PUBLIC PROCEDURE CompareDT(D: DATE; T: TIME; PD: DATE; PT: TIME): NUMERIC[0];
 BEGIN
  IF (D > PD) | ((D = PD) & (T > PT)) THEN
   RETURN 1;
  ELSIF (D < PD) | ((D = PD) & (T < PT)) THEN
   RETURN -1;
  ELSE
   RETURN 0;
  END;
 END {CompareDT};

 PRIVATE PROCEDURE GetRprJEDate(): DATE;
 BEGIN
  IF ~!RprJ.ETime & (RprJ.ETime < RprJ.BTime) THEN
   RETURN RprJ.BDate + 1;
  ELSE
   RETURN RprJ.BDate;
  END;
 END {GetRprJEDate};

 PUBLIC PROCEDURE CheckRprTEDT();
  VAR
   MD: DATE;
   MT: TIME;
 BEGIN
  L_General.Assert(CompareDT(RprT.EDate, RprT.ETime, RprT.BDate, RprT.BTime) > 0,
                   "- 祭  ᤥ");
  L_General.Assert(CompareDT(RprT.EDate, RprT.ETime, RprT.JobEDate, RprT.JobETime) >= 0,
                   "ᮮ⢥⢨ ६  |" +
                   " ६ 砭 | |" +
                   "६    : " + L_DatTim.DateTimeStr(RprT.EDate, RprT.ETime) + "|" +
                   "६ 砭  : " + L_DatTim.DateTimeStr(RprT.JobEDate, RprT.JobETime));
  SELECT(RprJ, RprS, , RprT.RprS, RprT.RprT);
  WHILE OCCURE(RprJ) DO
   L_General.Assert(~!RprJ.ETime, " 祭 |" +
                                  "  ⠢  ࠡ");
   MD:=GetRprJEDate();
   MT:=RprJ.ETime;
   IF CompareDT(MD, MT, RprT.EDate, RprT.ETime) > 0 THEN
    L_General.Error("ᮮ⢥⢨ ६  |" +
                    " ६ 砭 ࠡ| |" +
                    "६   : " + L_DatTim.DateTimeStr(RprT.EDate, RprT.ETime) + "|" +
                    "६ 砭 ࠡ : " + L_DatTim.DateTimeStr(MD, MT));
    MD:=GetRprJEDate(); MT:=RprJ.ETime;
   END;
   NEXT(RprJ);
  END; (* WHILE OCCURE(RprJ)... *)
 END {CheckRprTEDT};

 PUBLIC PROCEDURE AccessRprS();
 BEGIN
  L_General.Assert(ACCESS(RprS), " ⠭ ⥪騩 ");
 END {AccessRprS};

 PUBLIC PROCEDURE AccessRprT();
 BEGIN
  L_General.Assert(ACCESS(RprT), " ⠭ ⥪饥 ");
 END {AccessRprT};

 PUBLIC PROCEDURE AccessRprJ();
 BEGIN
  L_General.Assert(ACCESS(RprJ), " ⠭ ⥪ ");
 END {AccessRprJ};

 PUBLIC PROCEDURE GetRprSLocation_Pool(Short: SCAL[2]): STRING[];
  VAR
   Local  : PROC;
   default: STRING[];
 BEGIN
  IF Short THEN
   default := "||";
  ELSE
   default := "ᯥ᪠| |";
  END;
  Local:=PROCREF(E_Rpr.GetRprSLocation_Pool);
  IF ~!Local THEN
   RETURN Local(Short);
  ELSE
   RETURN default;
  END;
 END {GetRprSLocation_Pool};

 PUBLIC PROCEDURE CheckRights(trgLocation: tRprSLocation);
 BEGIN
  L_General.Assert(CanModify(trgLocation), "  筮 ࠢ  믮 ⮩ 樨");
 END {CheckRights};

 PUBLIC PROCEDURE GetShiftNbr(_Shift: LIKE(RprStaff.RprShift);
                              Dir   : NUMERIC[0]): LIKE(RprStaff.RprShift);
 BEGIN
  IF Dir = +1 THEN
   RETURN Math.Mod(_Shift + 1, 4);
  ELSE
   RETURN Math.Max(DEC(_Shift), 1)
  END;
 END {GetShiftNbr};

 PRIVATE PROCEDURE Create_RDCar();
 BEGIN
  CreateFILE(RDCar, "", "६ 䠩", "");

  CreateFIELD(RDCar, Status, SCAL[2], "", "", "", "0 - , 1 - ⮢", "");
  CreateFIELD(RDCar, RprS,   LIKE(RprS.RprS), "", "", "", "", "");
  CreateFIELD(RDCar, BoxNbr, LIKE(Car.BoxNbr), "", "", "", "ࠦ", "");
  CreateFIELD(RDCar, TSN,    LIKE(Staff.TSN), "", "", "", "⥫", "");
  CreateFIELD(RDCar, Date,   DATE, "", "", "", " /⮢", "");
  CreateFIELD(RDCar, Time,   TIME, "", "", "", "६ /⮢", "");
  CreateFIELD(RDCar, RWayS,  LIKE(RWayS.RWayS), "", "", "", "", "");

  CreateINDEXandLINK(RDCar, TSN, PLURAL, Staff, TSN, USER, "", "", TSN);
  CreateINDEXandLINK(RDCar, BoxNbr, PLURAL, Car, BoxNbr, USER, "", "", BoxNbr);
  CreateINDEX(RDCar, Status, PLURAL, "", "", Status, Date, Time);

  SetVersionOfFILE(RDCar, 0);
  L_AFM.CreateTemp("RDCar");
 END {Create_RDCar};

 PRIVATE PROCEDURE InsIntoRDCar(_Status: SCAL[2];
                                _BoxNbr: LIKE(Car.BoxNbr);
                                _TSN   : LIKE(Staff.TSN);
                                _Date  : DATE;
                                _Time  : TIME;
                                _RWayS : LIKE(RWayS.RWayS));
 BEGIN
  RDCar.Status:=_Status;
  RDCar.RprS  :=RprS.RprS;
  RDCar.BoxNbr:=_BoxNbr;
  RDCar.TSN   :=_TSN;
  RDCar.Date  :=_Date;
  RDCar.Time  :=_Time;
  RDCar.RWayS :=_RWayS;
  INSERT(RDCar);
 END {InsIntoRDCar};

 PRIVATE PROCEDURE AlreadyInspect(_RprS: LIKE(RprS.RprS); CheckReturns: SCAL[2]): SCAL[2];
 BEGIN
  SELECT(XDocJrn, XDocJrn, , L_XDoc.xdt_RprS, L_XDoc.EmptyXDocKind, _RprS);
  LAST(XDocJrn);
  WHILE OCCURE(XDocJrn) DO
   IF CheckReturns THEN
    IF    XDocJrn.Action = L_XDoc.action_rprPuttingIntoOperation THEN
     RETURN 1;
    ELSIF XDocJrn.Action = L_XDoc.action_rprCnclPuttingIntoOperation THEN
     RETURN 0;
    ELSIF (XDocJrn.Action = L_XDoc.action_rprInspection) & (XDocJrn.AcsObj = L_General.curUSER) THEN
     RETURN 1;
    END;
   ELSE
    IF    XDocJrn.Action = L_XDoc.action_rprPuttingIntoOperation THEN
     RETURN 0;
    ELSIF (XDocJrn.Action = L_XDoc.action_rprInspection) & (XDocJrn.AcsObj = L_General.curUSER) THEN
     WHILE OCCURE(XDocJrn) DO
      IF XDocJrn.Action = L_XDoc.action_rprPuttingIntoOperation THEN
       RETURN 1;
      END;
      PREV(XDocJrn);
     END; (* WHILE OCCURE(XDocJrn) ...*)
    END;
   END; (* IF CheckReturns... *)
   IF OCCURE(XDocJrn) THEN
    PREV(XDocJrn);
   END;
  END; (* WHILE OCCURE(XDocJrn) ...*)

  RETURN 0;
 END {AlreadyInspect};

 PRIVATE PROCEDURE Prepare_ClosedRDRprS(OnDate : DATE;
                                        OnTime : TIME);
  CONST
   ctrlTime = 05:00;
 BEGIN
  TABLE.Get("RprS").AccessDataMode:=AccessDataMode_SOFT;
  TABLE.Get("Car").AccessDataMode :=AccessDataMode_SOFT;
  SELECT(RprS, EDate);
  IF OnTime < ctrlTime THEN
   SRCINSEL(RprS, GE, , OnDate-1, OnTime);
   OnTime:=23:59;
  ELSE
   SRCINSEL(RprS, GE, , OnDate);
  END;
  WHILE OCCURE(RprS) DO
   PROMPT(RprS.RprS);
   TRY [TRANSACTION(TRANSACTION_SLAVE)]
    IF (RprS.Closed = 1)                  &
       (RprS.Status # ms_Cancel)          &
       IsRprS_w_Car()                     &
       E_AcceptableLocation_ForDoneRprS() &
       (L_DatTim.GetVARIANTDATE(RprS.EDate, RprS.ETime, 00) <= L_DatTim.GetVARIANTDATE(OnDate, OnTime, 00)) &
       ~AlreadyInspect(RprS.RprS, 0) THEN
     AccessOrigin();
     InsIntoRDCar(1,
                  Car.BoxNbr,
                  "",
                  RprS.EDate,
                  RprS.ETime,
                  "");
    END;
   EXCEPT
   ON Exc: Exc_Root DO
   END;
   NEXT(RprS);
  END; (* WHILE OCCURE(RprS) ... *)
 END {Prepare_ClosedRDRprS};

 PRIVATE PROCEDURE HasActualCancelPuttingIntoOperation(): SCAL[2];
 BEGIN
  SELECT(XDocJrn, XDocJrn, , L_XDoc.xdt_RprS, L_XDoc.EmptyXDocKind, RprS.RprS);
  LAST(XDocJrn);
  WHILE OCCURE(XDocJrn) DO
   IF    XDocJrn.Action = L_XDoc.action_rprCnclPuttingIntoOperation THEN
    RETURN 1;
   ELSIF XDocJrn.Action = L_XDoc.action_rprPuttingIntoOperation THEN
    RETURN 0;
   END;
   PREV(XDocJrn);
  END; (* WHILE OCCURE(XDocJrn) ...*)
  RETURN 0;
 END {HasActualCancelPuttingIntoOperation};

 PRIVATE PROCEDURE HasGivenRWayS(OnDate: DATE): SCAL[2];
 BEGIN
  SELECT(RWayS, sBoxNbr, , L_Way.rwsStat_Given, Car.BoxNbr, OnDate);
  WHILE OCCURE(RWayS) DO
   IF ~L_Way.IsRepairRWayS() THEN
    RETURN 1;
   END;
   NEXT(RWayS);
  END; (* WHILE OCCURE(RWayS) ... *)
  RETURN 0;
 END {HasGivenRWayS};

 PRIVATE PROCEDURE Prepare_ReturnedRDRprS(OnDate : DATE;
                                          OnTime : TIME);
  VAR
   ReturnDate: DATE;
   ReturnTime: TIME;
 BEGIN
  TABLE.Get("RprS").AccessDataMode:=AccessDataMode_SOFT;
  TABLE.Get("Car").AccessDataMode :=AccessDataMode_SOFT;

  SELECT(RprS, cRprS, , 0);
  WHILE OCCURE(RprS) DO
   PROMPT(RprS.RprS);
   TRY [TRANSACTION(TRANSACTION_SLAVE)]
    IF IsRprS_w_Car() THEN
     AccessOrigin();
     IF E_AcceptableLocation_ForReturnRprS() &
        HasGivenRWayS(OnDate)                &
        ~AlreadyInspect(RprS.RprS, 1) THEN
      IF HasActualCancelPuttingIntoOperation() THEN
       ReturnDate:=XDocJrn.Date;
       ReturnTime:=XDocJrn.BegTime;
      ELSE
       E_GetReturnDateTime(ReturnDate, ReturnTime);
      END;
      IF (L_DatTim.GetVARIANTDATE(ReturnDate, ReturnTime, 00) <= L_DatTim.GetVARIANTDATE(OnDate, OnTime, 00)) THEN
       InsIntoRDCar(0,
                    Car.BoxNbr,
                    RWayS.TSN,
                    ReturnDate,
                    ReturnTime,
                    RWayS.RWayS);
      END;
     END;
    END;
   EXCEPT
   ON Exc: Exc_Root DO
   END;
   NEXT(RprS);
  END; (* WHILE OCCURE(RprS) ... *)
 END {Prepare_ReturnedRDRprS};

 PUBLIC PROCEDURE Prepare_RDRprS();
  VAR
   OnDate: DATE;
   OnTime: TIME;
 BEGIN
  Create_RDCar();
  OnDate:=SYSDATE();
  OnTime:=SYSTIME();
  Prepare_ReturnedRDRprS(OnDate, OnTime);
  Prepare_ClosedRDRprS(OnDate, OnTime);
 END {Prepare_RDRprS};

 PUBLIC PROCEDURE GetRprSLocation_AsStr(trgLocation: tRprSLocation): STRING[];
 BEGIN
  RETURN L_Str.PoolItem(GetRprSLocation_Pool(0), trgLocation);
 END {GetRprSLocation_AsStr};

 PUBLIC PROCEDURE RprLev(D: DATE): tRprLev;
 BEGIN
  RETURN L_EC.ExecE_Func_Numeric(D, PROCREF(L_Env.RprLev), rprl_None);
 END {RprLev};

 PRIVATE PROCEDURE InitRprVariables();
 BEGIN
  IF ~L_General.VariableIsInitialized(v_EmptyIndexValue) THEN
   v_EmptyIndexValue := "";
   v_rprs_BegDate    := SYSDATE();
   v_rprs_Shift      := 01;
  END;
 END {InitRprVariables};

 PUBLIC PROCEDURE FoundReFrCast(trgBoxNbr  : LIKE(Car.BoxNbr);
                                trgRepEvent: L_Car.tRepEvent;
                                D          : DATE): SCAL[2];
 BEGIN
  SELECT(CarEvn, REBoxNbr, , trgRepEvent, L_Car.src_FrCast, trgBoxNbr);
  RETURN SRCINSEL(CarEvn, GE, D - 2) & (CarEvn.StartD <= (D + 2));
 END {FoundReFrCast};

 PRIVATE PROCEDURE IsPutOffRprDA(): SCAL[2];
 BEGIN
  RETURN RprDA.Fixed = daf_PutOff;
 END {IsPutOffRprDA};

 PRIVATE PROCEDURE HasPutOffDfApr(_RprS: LIKE(RprS.RprS)): SCAL[2];
 BEGIN
  SELECT(RprDA, RprS, , _RprS);
  WHILE OCCURE(RprDA) DO
   IF IsPutOffRprDA() THEN
    RETURN 1;
   END;
   NEXT(RprDA);
  END; (* WHILE OCCURE(RprDA) ... *)
  RETURN 0;
 END {HasPutOffDfApr};

 PUBLIC PROCEDURE lpoda_Create(); (*ListPutOffDfApr*)
 BEGIN
  CreateFILE(lpoda);
  CreateFIELD(lpoda, RprDfApr, LIKE(RprDA.RprDfApr));
  CreateFIELD(lpoda, RprS,     LIKE(RprS.RprS)     );
  CreateFIELD(lpoda, Comment,  LIKE(RprDA.Comment) );
  CreateFIELD(lpoda, WhenBurn, LIKE(RprDA.WhenBurn));
  CreateINDEXandLINK(lpoda, RprDfApr, UNIQUE, RprDfApr, RprDfApr, USER, , , RprDfApr, RprS);
  SetVersionOfFILE(lpoda, 0);
  L_AFM.CreateTemp("lpoda");
 END {lpoda_Create};

 PUBLIC PROCEDURE lpoda_GatherCar(_CUCopy: LIKE(CUCopy.CUCopy); ForCurRprS, AllPutOffRprDA: SCAL[2]);
  CONST
   MaxDays   = 90;
   MaxAmount = 5;
  VAR
   Amount      : NUMERIC[0];
   excludeRprS : LIKE(RprS.RprS);
 BEGIN
  APP.Get().NewPrompt(" ⫮ ࠢ⥩");
  SAVE(RprS);
  IF ForCurRprS THEN
   CHANGESEL(RprS, CUCopy, , _CUCopy);
   excludeRprS:=RprS.RprS;
  ELSE
   SETEMPTY(excludeRprS);
   SELECT(RprS, CUCopy, , _CUCopy);
   LAST(RprS);
  END;
  Amount:=0;
  WHILE OCCURE(RprS) & ((AllPutOffRprDA = 1) | (Amount < MaxAmount) | (RprS.OrdDate > (SYSDATE() - MaxDays))) DO
   PROMPT(RprS.RprObjId + " " + RprS.RprS);
   IF (RprS.Status # ms_Cancel) & (~ForCurRprS | (RprS.RprS # excludeRprS)) THEN
    IF HasPutOffDfApr(RprS.RprS) THEN
     SELECT(RprDA, RprS, , RprS.RprS);
     WHILE OCCURE(RprDA) DO
      IF    (RprS.Status # ms_Cancel) & IsPutOffRprDA() THEN
       CONFORM(RprDA, RprDfApr);
       IF (AllPutOffRprDA = 1) | ~SELECT(lpoda, RprDfApr, RprDA.RprDfApr) THEN
        lpoda.RprDfApr:=RprDA.RprDfApr;
        lpoda.RprS    :=RprDA.RprS;
        lpoda.Comment :=RprDA.Comment;
        lpoda.WhenBurn:=RprDA.WhenBurn;
        INSERT(lpoda);
       ELSIF AllPutOffRprDA = 0 THEN
        L_StdFrm.RedInform("訡 ७ ⫮ ࠢ⥩:||" +
                           "ࠢ " + RprDA.RprDfApr + " " + RprDfApr.Name + "|" +
                           " 㤥 ७ᥭ   " + RprS.RprS + ",|" +
                           "⠪   㦥 ⬥祭  ⫮   " + lpoda.RprS);
       END;
      END; (* IF IsPutOffDfApr()...*)
      NEXT(RprDA);
     END; (* WHILE OCCURE(RprDA) ... *)
    END; (* IF HasPutOffDfApr(RprS.RprS)...*)
    INC(Amount);
   END; (* IF RprS.RprS # ...*)
   PREV(RprS);
  END; (* WHILE OCCURE(RprS) ... *)
  RESTORE(RprS);
 END {lpoda_GatherCar};

 PUBLIC PROCEDURE lpoda_Purge();
 BEGIN
  L_AFM.AF_PurgeTemp("lpoda");
 END {lpoda_Purge};

 PUBLIC PROCEDURE IsOpenRprS_OnTime(curDTS: FLOAT): SCAL[2];
  VAR
   BegRprSDTS,
   EndRprSDTS: FLOAT;
 BEGIN
  BegRprSDTS:=L_DatTim.GetVARIANTDATE(RprS.OrdDate, RprS.OrdTime, 00);
  IF !RprS.EDate (* v14.44.11 22.12.2005 11:03:14 POLAK\San *) THEN
   RETURN (curDTS >= BegRprSDTS);
  ELSE
   EndRprSDTS:=L_DatTim.GetVARIANTDATE(RprS.EDate,   RprS.ETime,   00);
   RETURN (curDTS >= BegRprSDTS) & (curDTS <= EndRprSDTS);
  END;
 END {IsOpenRprS_OnTime};

 PUBLIC PROCEDURE HasOpenRprS(_BoxNbr: LIKE(Car.BoxNbr);
                              OnDate : DATE;
                              OnTime : TIME): SCAL[2];
 BEGIN
  L_General.CallUs(SEARCH(Car, BoxNbr, _BoxNbr));
  SELECT(RprS, CUCopy, , Car.CUCopy);
  SRCINSEL(RprS, LT, , OnDate,  OnTime);
  WHILE OCCURE(RprS) & (RprS.Status = ms_Cancel) DO
   PREV(RprS);
  END;

  IF OCCURE(RprS) THEN
   RETURN IsOpenRprS_OnTime(L_DatTim.GetVARIANTDATE(OnDate, OnTime, 00));
  ELSE
   RETURN 0;
  END;
 END {HasOpenRprS};

 PUBLIC PROCEDURE IsTechAidTask(_RprPlace: LIKE(RprPlace.RprPlace)): SCAL[2];
 BEGIN
  RETURN SEARCH(RprPlace, RprPlace, _RprPlace) &
         (RprPlace.Kind = rpk_TechAid);
 END {IsTechAidTask};

 PUBLIC PROCEDURE IsTechAidRprT(_RprPlace: LIKE(RprPlace.RprPlace)): SCAL[2];
 BEGIN
  RETURN IsTechAidTask(_RprPlace) |
         (OCCURE(RprT) & SELECT(RprP, RprJ, RprT.RprS, RprT.RprT, v_EmptyIndexValue, rprpwho_TechAidDrv));
 END {IsTechAidRprT};

 PUBLIC PROCEDURE IsRetrieverTask(_RprPlace: LIKE(RprPlace.RprPlace)): SCAL[2];
 BEGIN
  RETURN SEARCH(RprPlace, RprPlace, _RprPlace) & (RprPlace.Kind = rpk_Retriever);
 END {IsRetrieverTask};

 PRIVATE PROCEDURE GetMaxDTS(DTS1, DTS2: FLOAT): FLOAT;
 BEGIN
  IF    ~!DTS1 & ~!DTS2 THEN
   RETURN Math.Max(DTS1, DTS2);
  ELSIF ~!DTS1 THEN
   RETURN DTS1;
  ELSIF ~!DTS2 THEN
   RETURN DTS2;
  ELSE
   RETURN EMPTYOF(FLOAT);
  END;
 END {GetMaxDTS};

 PRIVATE PROCEDURE GetRprTMaxPlnEDTS(RealTaskLen: SCAL[2]): FLOAT;
  VAR
   PlnEDTS,
   RprTEDTS: FLOAT;
 BEGIN
  SAVE(RprT);
  SETEMPTY(PlnEDTS, RprTEDTS);
  IF SELECT(RprT, RprS, RprS.RprS) THEN
   WHILE OCCURE(RprT) DO
    IF    RealTaskLen | (RprT.Result = tr_InProgress) THEN
     RprTEDTS:=GetRprTEDTS();
    ELSIF ~!RprT.EDate THEN
     RprTEDTS:=L_DatTim.GetVARIANTDATE(RprT.EDate, RprT.ETime, 00);
    END;
    PlnEDTS:=GetMaxDTS(PlnEDTS, RprTEDTS);
    NEXT(RprT);
   END; (* WHILE OCCURE(RprT) ... *)
  END;
  RESTORE(RprT);
  RETURN PlnEDTS;
 END {GetRprTMaxPlnEDTS};

 PUBLIC PROCEDURE GetMaxPlnEDTS(): FLOAT;
  VAR
   RprSEDTS: FLOAT;
 BEGIN
  IF ~!RprS.EDate THEN
   RprSEDTS:=L_DatTim.GetVARIANTDATE(RprS.EDate, RprS.ETime, 00)
  ELSE
   SETEMPTY(RprSEDTS);
  END;
  RETURN GetMaxDTS(GetRprTMaxPlnEDTS(0), RprSEDTS);
 END {GetMaxPlnEDTS};

 PUBLIC PROCEDURE GetMaxPlnEDateTime(VAR maxPlnEDate: DATE;
                                     VAR maxPlnETime: TIME);
  VAR
   EDTS: FLOAT;
 BEGIN
  EDTS:=GetMaxPlnEDTS();
  IF ~!EDTS THEN
   UnPkVARIANTDATE(EDTS, maxPlnEDate, maxPlnETime);
  ELSE
   SETEMPTY(maxPlnEDate, maxPlnETime);
  END;
 END {GetMaxPlnEDateTime};

 PUBLIC PROCEDURE RprSTaskKind(trgRprS: LIKE(RprS.RprS)): LIKE(RprT.TaskKind);
 BEGIN
  SELECT(RprT, RprS, , trgRprS);
  WHILE OCCURE(RprT) DO
   IF ~!RprT.TaskKind THEN
    RETURN RprT.TaskKind;
   END;
   NEXT(RprT);
  END; (* WHILE OCCURE(RprT) ... *)
  RETURN EMPTYOF(RprT.TaskKind);
 END {RprSTaskKind};

 PUBLIC PROCEDURE HasRprTask(_TaskKind: LIKE(RprT.TaskKind); _Result: LIKE(RprT.Result)): SCAL[2];
 BEGIN
  CONFORM(RprS, RprT);
  WHILE OCCURE(RprT) DO
   IF (!_TaskKind | (RprT.TaskKind = _TaskKind)) &
      (!_Result   | (RprT.Result   = _Result)) THEN
    RETURN 1;
   END;
   NEXT(RprT);
  END; (* WHILE OCCURE(RprT) ... *)
  RETURN 0;
 END {HasRprTask};

 PUBLIC PROCEDURE HasOpenRprTask(): SCAL[2];
 BEGIN
  RETURN HasRprTask(EMPTYOF(RprT.TaskKind), tr_InProgress);
 END {HasOpenRprTask};

 PUBLIC PROCEDURE HasOpenTask_TO2(_RprS: LIKE(RprS.RprS)): SCAL[2];
 BEGIN
  RETURN HasRprTask(tk_Servicing2, tr_InProgress)
 END {HasOpenTask_TO2};

 PRIVATE PROCEDURE GetNextShiftBegDTS(ShiftBegDTS: TIMESTAMP;
                                      ShiftLength: NUMERIC[0]): TIMESTAMP;
 BEGIN
  RETURN ShiftBegDTS + ShiftLength / 24;
 END {GetNextShiftBegDTS};

 PRIVATE PROCEDURE GetCurShiftEndDTS(ShiftBegDTS : TIMESTAMP;
                                     ShiftBegTime: TIME;
                                     ShiftEndTime: TIME;
                                     ShiftLength : NUMERIC[0]): TIMESTAMP;
 BEGIN
  RETURN ShiftBegDTS + ShiftLength / 24;
 END {GetCurShiftEndDTS};

 PRIVATE PROCEDURE GetShiftEndDTS(DTS         : TIMESTAMP;
                                  ShiftBegTime: TIME;
                                  ShiftEndTime: TIME;
                                  ShiftLength : NUMERIC[0]): TIMESTAMP;
 BEGIN
  RETURN GetCurShiftEndDTS(L_DatTim.GetTIMESTAMP(L_DatTim.GetDateOfTIMESTAMP(DTS), ShiftBegTime), ShiftBegTime, ShiftEndTime, ShiftLength);
 END {GetShiftEndDTS};

 PUBLIC PROCEDURE GetShiftBegDTS(DTS         : TIMESTAMP;
                                 ShiftBegTime: TIME;
                                 ShiftEndTime: TIME;
                                 ShiftLength : NUMERIC[0]): TIMESTAMP;
  VAR
   Result: TIMESTAMP;
 BEGIN
  Result:=L_DatTim.GetTIMESTAMP(L_DatTim.GetDateOfTIMESTAMP(DTS), ShiftBegTime);
  IF    Result > DTS THEN
   DEC(Result, ShiftLength / 24);
  ELSIF GetShiftEndDTS(DTS, ShiftBegTime, ShiftEndTime, ShiftLength) < DTS THEN
   Result:=GetNextShiftBegDTS(Result, ShiftLength);
  END;
  RETURN Result;
 END {GetShiftBegDTS};

 PUBLIC PROCEDURE E_RprSShiftParams(VAR BegTime: TIME;
                                    VAR EndTime: TIME;
                                    VAR Length : NUMERIC[3]);
  VAR
   Local: PROC;
 BEGIN
  Local:=PROCREF(E_Rpr.RprSShiftParams);
  IF ~!Local THEN
   Local(BegTime, Length);
  ELSE
   BegTime:=00:00;
   Length :=24;
  END;
  EndTime:=L_DatTim.GetTimeOfTIMESTAMP(L_DatTim.GetTIMESTAMP(SYSDATE(), BegTime) + Length / 24);
 END {E_RprSShiftParams};

 PUBLIC PROCEDURE GetCurShiftBeginEnd(VAR BDate: DATE;
                                      VAR BTime: TIME;
                                      VAR EDate: DATE;
                                      VAR ETime: TIME);
  VAR
   DefBegTime,
   DefEndTime : TIME;
   ShiftLength: NUMERIC[3];
   SysDTS,
   ShiftBegDTS,
   ShiftEndDTS: TIMESTAMP;
 BEGIN
  E_RprSShiftParams(DefBegTime, DefEndTime, ShiftLength);
  SysDTS:=L_DatTim.GetSysTIMESTAMP();
  IF Memo.ud_cd() < SYSDATE() THEN
   ShiftBegDTS:=GetShiftBegDTS(L_DatTim.GetTIMESTAMP(Memo.ud_cd(), DefBegTime), DefBegTime, DefEndTime, ShiftLength);
  ELSE
   ShiftBegDTS:=GetShiftBegDTS(SysDTS,                             DefBegTime, DefEndTime, ShiftLength);
  END;
  ShiftEndDTS:=Math.Min(GetCurShiftEndDTS(ShiftBegDTS, DefBegTime, DefEndTime, ShiftLength), SysDTS);
  UnPkTIMESTAMP(ShiftBegDTS, BDate, BTime);
  UnPkTIMESTAMP(ShiftEndDTS, EDate, ETime);
 END {GetCurShiftBeginEnd};

 PRIVATE PROCEDURE GetMarkGRprJobBaseTime(    trgMarkG : LIKE(MarkG.MarkG);
                                              trgRprJob: LIKE(RprJob.RprJob);
                                              trgDate  : DATE;
                                          VAR trgClass : LIKE(RprJMG.Class)): LIKE(RprJMG.BaseTime);
 BEGIN
  IF SELECT(RprJMG, RprJob, trgRprJob, trgMarkG) &
     SRCINSEL(RprJMG, LE, trgDate) &
     (trgDate <= RprJMG.Till) THEN
   trgClass:=RprJMG.Class;
   RETURN RprJMG.BaseTime;
  ELSE
   SETEMPTY(trgClass);
   RETURN EMPTYOF(RprJMG.BaseTime);
  END;
 END {GetMarkGRprJobBaseTime};

 PUBLIC PROCEDURE extGetRprJobBaseTime(    trgRprJob  : LIKE(RprJob.RprJob);
                                           trgDate    : DATE;
                                           Silent     : SCAL[2];
                                       VAR trgBaseTime: LIKE(RprJMG.BaseTime);
                                       VAR trgSource  : LIKE(RprJ.Source);
                                       VAR trgClass   : LIKE(RprJMG.Class));
  VAR
   trgMarkG         : LIKE(MarkG.MarkG);
   tmpBaseTime      : LIKE(RprJMG.BaseTime);
   tmpClass         : LIKE(RprJMG.Class);
   FoundManyBaseTime: SCAL[2];
 BEGIN
  FoundManyBaseTime:=0;
  SETEMPTY(trgBaseTime, tmpBaseTime);
  IF IsRprS_w_Car() | IsRprS_w_OutCar() THEN
   SAVE(Mark);
   AccessMark(trgDate);
   SELECT(MarkGM, MMGT, , Mark.Mark, L_Way.mgt_RprJobBaseTime);
   WHILE OCCURE(MarkGM) & ~FoundManyBaseTime DO
    tmpBaseTime:=GetMarkGRprJobBaseTime(MarkGM.MarkG, trgRprJob, trgDate, tmpClass);
    IF ~!tmpBaseTime THEN
     IF ~!trgBaseTime THEN
      IF ~Silent THEN
       L_StdFrm.RedInform(" થ " + Mark.Mark + "    ଠ⨢  ६⭮ ࠡ " + trgRprJob);
      END;
      FoundManyBaseTime:=1;
     ELSE
      trgBaseTime:=tmpBaseTime;
      trgClass   :=tmpClass;
      trgSource  :=rprjbts_Select;
     END;
    END;
    NEXT(MarkGM);
   END; (* WHILE OCCURE(MarkGM) ... *)
   RESTORE(Mark);
  ELSE
   SAVE(CUCopy);
   SAVE(Math);
   AccessOrigin();
   IF    IsRprS_w_CarBlock() THEN
    CONFORM(CUCopy, Math);
   ELSIF IsRprS_w_OutCBlc() THEN
    CONFORM(OutCBlc, Math);
   ELSIF IsRprS_w_Math() THEN
    (*祣  *)
   ELSE
    L_General.CallUs(0);
   END;

   L_AFM.MakeIndex("_MGLs", "MarkG: LIKE(MarkG.MarkG)");
   SELECT(MathMrkG, Math, , Math.Math);
   WHILE OCCURE(MathMrkG) DO
    SELECT(MarkGM, MarkG, , MathMrkG.MarkG);
    WHILE OCCURE(MarkGM) DO
     PROMPT(" " + MarkGM.MarkG + " " + MarkGM.Mark);
     SAVE(MarkGM);
     SELECT(MarkGM, Mark, , MarkGM.Mark);
     WHILE OCCURE(MarkGM) DO
      CONFORM(MarkGM, MarkG);
      IF MarkG.MarkGT = L_Way.mgt_RprJobBaseTime THEN
       IF ~SEARCH(_MGLs, _MGLs, MarkGM.MarkG) THEN
        _MGLs.MarkG:=MarkGM.MarkG;
        INSERT(_MGLs);
       END;
      END;
      NEXT(MarkGM);
     END; (* WHILE OCCURE(MarkGM) ... *)
     RESTORE(MarkGM);
     NEXT(MarkGM);
    END; (* WHILE OCCURE(MarkGM) ... *)
    NEXT(MathMrkG);
   END; (* WHILE OCCURE(MathMrkG) ... *)

   SELECT(RprJMG, RprJob, , trgRprJob);
   WHILE OCCURE(RprJMG) & ~FoundManyBaseTime DO
    NARROWSEL(RprJMG, MarkG);
    IF RprJMG.MarkG # fictMarkG THEN
     WHILE OCCURE(RprJMG) DO
      IF L_DatTim.IsActive(trgDate, RprJMG.Begin, RprJMG.Till) THEN
       IF SEARCH(_MGLs, _MGLs, RprJMG.MarkG) THEN
        IF ~!trgBaseTime & (trgBaseTime # RprJMG.BaseTime) THEN
         IF ~Silent THEN
          L_StdFrm.RedInform(" " + Math.Math + " " + Math.Name + ": 筮 । 㤮||" +
                             "( 㯯 ப ⠡ ᮢ⨬   ન,|" +
                             "室騥  㯯 ப ଠ⨢  ६ ࠡ⠬|" +
                             " ࠧ筮 ଠ⨢ 㤮)");
         END;
         FoundManyBaseTime:=1;
        ELSE
         trgBaseTime:=RprJMG.BaseTime;
         trgClass   :=RprJMG.Class;
         trgMarkG   :=RprJMG.MarkG;
        END;
       END;
      END;
      NEXT(RprJMG);
     END; (* WHILE OCCURE(RprJMG) ... *)
    END;
    NEXTINEXTENDEDSEL(RprJMG, MarkG);
   END; (* WHILE OCCURE(RprJMG) ... *)
   L_AFM.AF_PurgeTemp("_MGLs");
   RESTORE(Math);
   RESTORE(CUCopy);
  END;
  IF    FoundManyBaseTime THEN
   SETEMPTY(trgBaseTime, trgClass);
   trgSource  :=rprjbts_Default;
  ELSIF !trgBaseTime THEN
   trgBaseTime:=GetMarkGRprJobBaseTime(fictMarkG, trgRprJob, trgDate, tmpClass);
   trgClass   :=tmpClass;
   trgSource  :=rprjbts_Default;
  END;
 END {extGetRprJobBaseTime};

 PUBLIC PROCEDURE GetRprJobBaseTime(    trgRprJob  : LIKE(RprJob.RprJob);
                                        trgDate    : DATE;
                                    VAR trgBaseTime: LIKE(RprJMG.BaseTime);
                                    VAR trgSource  : LIKE(RprJ.Source));
  VAR
   dummyClass: LIKE(RprJMG.Class);
 BEGIN
  extGetRprJobBaseTime(trgRprJob, trgDate, 0, trgBaseTime, trgSource, dummyClass);
 END {GetRprJobBaseTime};

 PUBLIC PROCEDURE StandOnReturnedRWayS(): SCAL[2];
  VAR
  RprSBegDTS,
  RWaySBegDTS,
  RWaySEndDTS: TIMESTAMP;
 BEGIN
  IF IsRprS_w_Car() THEN
   RprSBegDTS:=L_DatTim.GetTIMESTAMP(RprS.OrdDate, RprS.OrdTime);
   AccessOrigin();
   SELECT(RWayS, BoxNbr, , Car.BoxNbr, RprS.OrdDate);
   WHILE OCCURE(RWayS) DO
    CONFORM(RWayS, StExit);
    CONFORM(StExit, ExitClss);
    IF (StExit.Strict = L_Way.ExitStrict_Reg) | (ExitClss.BegType = L_Way.ecbt_Reserv) THEN
     RWaySBegDTS:=L_DatTim.GetTIMESTAMP(RWayS.Date, L_BegRWS.GetRWaySExitTime(0));
     RWaySEndDTS:=L_DatTim.GetTIMESTAMP(RWayS.Date, L_BegRWS.GetRWaySEnterTime(0));
     IF RWaySBegDTS >= RWaySEndDTS THEN
      INC(RWaySEndDTS);
     END;
     IF (RprSBegDTS >= RWaySBegDTS) & (RprSBegDTS <= RWaySEndDTS) THEN
      RETURN 1;
     END;
    END;
    NEXT(RWayS);
   END; (* WHILE OCCURE(RWayS) ... *)
  END;
  RETURN 0;
 END {StandOnReturnedRWayS};

 PRIVATE PROCEDURE GetManAnyClrPhones(trgContact: LIKE(Contact.Contact);
                                      D         : DATE;
                                      cvc       : L_ctc.tCoverage): STRING[];
  VAR
   Result: STRING[];
 BEGIN
  SETEMPTY(Result);
  SELECT(CtcVal, Type, , trgContact, cvc, L_ctc.cvt_PhoneClr);
  WHILE OCCURE(CtcVal) DO
   IF L_DatTim.IsActive(D, CtcVal.Begin, CtcVal.Till) THEN
    Result:=L_Str.AddStrDlm(Result, ", ") + CtcVal.Value;
   END;
   NEXT(CtcVal);
  END;
  IF ~!Result THEN
   IF    cvc = L_ctc.cvc_Home THEN
    Result:=": " + Result;
   ELSIF cvc = L_ctc.cvc_Work THEN
    Result:=": " + Result;
   ELSE
    L_General.CallUs(0);
   END;
  END;
  RETURN Result;
 END {GetManAnyClrPhones};

 PUBLIC PROCEDURE GetManClrPhones(trgTSN: LIKE(Staff.TSN);
                                  D     : DATE): STRING[];
  VAR
   Result: STRING[];
 BEGIN
  SETEMPTY(Result);
  IF L_General.GetAPSiteNumber() = 26 THEN
   L_General.Assert(SEARCH(Staff, TSN, trgTSN),
                    " ࠢ筨   ⠡ " + trgTSN);
   CONFORM(Staff, Man);
   Result:=GetManAnyClrPhones(Man.Contact, D, L_ctc.cvc_Work);
   Result:=L_Str.AddStrDlm(GetManAnyClrPhones(Man.Contact, D, L_ctc.cvc_Home), ";");
  END;
  RETURN Result;
 END {GetManClrPhones};

(*
$P{ pr_Line:
?, L, ""
@
|############################################################################################################|
}
*)

 PRIVATE PROCEDURE pr_PrintSingleLine(File,
                                      Value    : STRING[];
                                      StrLength: NUMERIC[0]);
  VAR
   i     : NUMERIC[0];
   StrArr: STRING[][10];
 BEGIN
  Str.Format(StrArr,
             Value,
             StrLength,
             LEFT);
  MAKEPART(^File, pr_Line, StrArr[0]);
  i:=1;
  WHILE ~!StrArr[i] DO
   MAKEPART(^File, pr_Line, StrArr[i]);
   INC(i);
  END; (* WHILE ~!StrArr[i]...*)
 END {pr_PrintSingleLine};

 PUBLIC CONST
  pr_Length = 112-2(* ᬮ騪*)-2(* *);

  pro_RprObj = 0;
  pro_Staff  = 1;

  rprprol_RprS = 0;
  rprprol_RprT = 1;
  rprprol_RprJ = 2;

 PUBLIC PROCEDURE IsFailureOutput(): SCAL[2];
 BEGIN
  IF P_Rpr.HasRprSPro(RprS.RprS, P_Rpr.P_FailureOutput) THEN
   IF IsRprS_w_Car() & SELECT(RWayS, sBoxNbr, L_Way.rwsStat_Given, Car.BoxNbr, RprS.OrdDate) THEN
    WHILE OCCURE(RWayS) DO
     CONFORM(RWayS, StExit);
     IF (SYSTIMESTAMP() < L_DatTim.GetTIMESTAMP(RprS.OrdDate, StExit.StopTim)) THEN
      RETURN 1;
     END;
     NEXT(RWayS);
    END; (* WHILE OCCURE(RWayS) ... *)
   END;
  END;
  RETURN 0;
 END {IsFailureOutput};

 PUBLIC PROCEDURE GetRprSTaskLen(): NUMERIC[3];
  VAR
   RprTMaxPlnEDTS: FLOAT;
 BEGIN
  RprTMaxPlnEDTS:=GetRprTMaxPlnEDTS(1);
  IF ~!RprTMaxPlnEDTS THEN
   RETURN (RprTMaxPlnEDTS - L_DatTim.GetVARIANTDATE(RprS.OrdDate, RprS.OrdTime, 00)) * 24;
  ELSE
   RETURN EMPTYOF(NUMERIC[3]);
  END;
 END {GetRprSTaskLen};

 PUBLIC PROCEDURE dti_GetDuration(_BDate: DATE; _BTime: TIME;
                                  _EDate: DATE; _ETime: TIME): NUMERIC[3];
 BEGIN
  RETURN (_EDate - _BDate) * 24 + (-24 * (_ETime < _BTime)) + (_ETime - _BTime);
 END {dti_GetDuration};

 PRIVATE PROCEDURE ConvDTToNativeLang(D: DATE; T: TIME): STRING[];
  CONST
   MaxLength = 11;
  VAR
   DaysLeft : NUMERIC[0];
   DateAsStr: STRING[];
 BEGIN
  DaysLeft:=SYSDATE() - D;
  IF    DaysLeft = -2 THEN
   DateAsStr:="᫥";
  ELSIF DaysLeft = -1 THEN
   DateAsStr:="";
  ELSIF DaysLeft =  0 THEN
   DateAsStr:="ᥣ";
  ELSIF DaysLeft =  1 THEN
   DateAsStr:="";
  ELSIF (DaysLeft >= 2) & (DaysLeft <= 6) THEN
   DateAsStr:=L_Str.IntStr(DaysLeft) + " . ";
  ELSIF L_DatTim.YEAR(SYSDATE()) = L_DatTim.YEAR(D) THEN
   DateAsStr:=FLDTOSTR(D, "D m");
  ELSE
   DateAsStr:=FLDTOSTR(D, "D.N.Y");
  END;
  RETURN "(" + DateAsStr + " " + L_DatTim.TimeStr(T) + ")";
 END {ConvDTToNativeLang};

 PRIVATE PROCEDURE DateTimeShortStr(D: DATE; T: TIME): STRING[];
 BEGIN
  RETURN FLDTOSTR(D, "D.N.Y") + " " + L_DatTim.TimeStr(T);
 END {DateTimeShortStr};

 PRIVATE PROCEDURE extGetTime_AsStr(Hours: NUMERIC[3]; Format: STRING[]; wSign, SignWithSpace: SCAL[2]): STRING[];
  VAR
   Sign: STRING[];
 BEGIN
  IF wSign THEN
   IF Hours < 0 THEN
    Sign:="-";
   ELSE
    Sign:="+";
   END;
   IF SignWithSpace THEN
    Sign:=Sign + " ";
   END;
  ELSE
   SETEMPTY(Sign);
  END;
  RETURN Sign + FLDTOSTR(Math.Abs(Hours), Format) + " .";
 END {extGetTime_AsStr};

 PRIVATE PROCEDURE GetTime_AsStr(Hours: NUMERIC[3]; wSign: SCAL[2]): STRING[];
 BEGIN
  RETURN extGetTime_AsStr(Hours, "1.", wSign, 1);
 END {GetTime_AsStr};

(*
$P{ pr_LineRprS:
?, L, ""
RprS.RprObjId, L, ""
?, L, ""
?, L, ""
L_Str.PoolItem(GetRprSStatus_Pool(1), RprS.Status), L, ""
L_Str.PoolItem(GetRprSLocation_Pool(1), RprS.Location), L, ""
@
|############################ ####### ############################################# ################### ###/#|
}
*)

 PRIVATE PROCEDURE GetRprObjDescr_ByAnyCar(trgStateNbr: LIKE(CarLog.StateNbr);
                                           trgMark    : LIKE(Mark.Mark)): STRING[];
  VAR
   Result: STRING[];
 BEGIN
  SAVE(Mark);
  SEARCH(Mark, Mark, , trgMark);
  Result:=Str.Align(trgStateNbr, Str.MaxLength(trgStateNbr) + 1, LEFT) + Mark.Name;
  RESTORE(Mark);
  RETURN Result;
 END {GetRprObjDescr_ByAnyCar};

 PUBLIC PROCEDURE GetRprObjDescr_ByOutCBlc(trgOutCBlc: LIKE(OutCBlc.OutCBlc)): STRING[];
  VAR
   Result: STRING[];
 BEGIN
  SAVE(OutCBlc);
  SAVE(Math);
  SEARCH(OutCBlc, OutCBlc, , trgOutCBlc);
  CONFORM(OutCBlc, Math);
  Result:=Str.Condense(OutCBlc.Serial + " " + Math.Name);
  RESTORE(Math);
  RESTORE(OutCBlc);
  RETURN Result;
 END {GetRprObjDescr_ByOutCBlc};

 PUBLIC PROCEDURE SetCUCopySerialByAnyCar(trgCUCopy  : LIKE(CUCopy.CUCopy);
                                          trgStateNbr: LIKE(CarLog.StateNbr);
                                          trgMark    : LIKE(Mark.Mark));
 BEGIN
  TRY [RESTORE_CURSORS(RC_ON)]
   L_AR.GrantRightsUnconditionally();
   SEARCH(CUCopy, CUCopy, , trgCUCopy);
   CUCopy.Serial:=GetRprObjDescr_ByAnyCar(trgStateNbr, trgMark);
   REPLACE(CUCopy);
  EXCEPT
  END; (* TRY *)
 END {SetCUCopySerialByAnyCar};

 PUBLIC PROCEDURE GetRprSObjDescr(): STRING[];
  VAR
   Result,
   trgStateNbr: STRING[];
 BEGIN
  TRY [RESTORE_CURSORS(RC_ON)]
   AccessOrigin();
   IF    IsRprS_w_Car() | IsRprS_w_OutCar() THEN
    AccessMark(RprS.OrdDate);
    IF    IsRprS_w_Car() THEN
     L_Car.StandOnCarLog(Car.BoxNbr, RprS.OrdDate);
     trgStateNbr:=CarLog.StateNbr;
    ELSIF IsRprS_w_OutCar() THEN
     trgStateNbr:=OutCar.StateNbr;
    ELSE
     L_General.CallUs(0);
    END;
    Result:=GetRprObjDescr_ByAnyCar(trgStateNbr, Mark.Mark);
   ELSIF IsRprS_w_CarBlock() THEN
    CONFORM(CUCopy, Math);
    Result:=CUCopy.Serial + " " + Math.Name;
   ELSIF IsRprS_w_OutCBlc() THEN
    Result:=GetRprObjDescr_ByOutCBlc(OutCBlc.OutCBlc);
   ELSIF IsRprS_w_Math() THEN
    Result:=Math.Math + " " + Math.Name;
   ELSE
    L_General.CallUs(0);
   END;
  EXCEPT
  END; (* TRY *)
  RETURN Result;
 END {GetRprSObjDescr};

 PRIVATE PROCEDURE pr_PrintRprS(File: STRING[]; pr_Obj: SCAL[3]);
  VAR
   curComment,
   FailureOutput_AsStr,
   RprSInf,
   FullRprObjId_AsStr,
   RprSTaskLen_AsStr  : STRING[];
   OverTime,
   RprSTaskLen        : NUMERIC[3];
   plnRprSEndDTS      : FLOAT;
   plnRprSEndDate     : DATE;
   plnRprSEndTime     : TIME;
 BEGIN
  SETEMPTY(plnRprSEndDate, plnRprSEndTime, RprSTaskLen_AsStr, FailureOutput_AsStr);
  RprSTaskLen:=GetRprSTaskLen();
  IF ~!RprSTaskLen THEN
   RprSTaskLen_AsStr:=FLDTOSTR(RprSTaskLen, "0");
   plnRprSEndDTS    :=L_DatTim.GetVARIANTDATE(RprS.OrdDate, RprS.OrdTime, 00) + RprSTaskLen/24;
   plnRprSEndDate   :=L_DatTim.GetDateOfVARIANTDATE(plnRprSEndDTS);
   plnRprSEndTime   :=L_DatTim.GetTimeOfVARIANTDATE(plnRprSEndDTS);
  ELSE
   plnRprSEndDate:=RprS.OrdDate;
   plnRprSEndTime:=RprS.OrdTime;
  END;

  IF ~RprS.Closed THEN
   IF IsFailureOutput() THEN
    FailureOutput_AsStr:="!!!";
   END;
   OverTime      :=-SysOverTime(plnRprSEndDate, plnRprSEndTime);
   RprSInf       :=Str.Align(" " + RprSTaskLen_AsStr, 6, LEFT) + " " + Str.Align(extGetTime_AsStr(OverTime, "0", 1, 0), 8, RIGHT) + " " + FailureOutput_AsStr;
  ELSE
   RprSInf:=DateTimeShortStr(RprS.EDate, RprS.ETime);
  END;

  FullRprObjId_AsStr:=GetRprSObjDescr();

  MAKEPART(^File, pr_LineRprS, "" + RprS.RprS + L_Str.PoolItem(" |#", ~!RprS.Parent) + ConvDTToNativeLang(RprS.OrdDate, RprS.OrdTime),
                               Str.Condense(FullRprObjId_AsStr),
                               RprSInf);
  curComment:=L_lsStore.Get(RprS.Comment);
  IF ~!curComment THEN
   pr_PrintSingleLine(File, "..: " + curComment, pr_Length);
  END;
 END {pr_PrintRprS};

 PUBLIC PROCEDURE GetRprDA_AsStr(): STRING[];
  VAR
   _Comment,
   RprDA_AsStr: STRING[];
 BEGIN
  L_General.Assert(ACCESS(RprDA), " ⠭ ⥪ ࠢ");
  CONFORM(RprDA, RprDfApr);
  CONFORM(RprDfApr, CarBlock);
  IF ~!RprDA.Comment THEN
   _Comment:=" " + "(" + RprDA.Comment + ")";
  ELSE
   _Comment:="";
  END;

  RprDA_AsStr:=CarBlock.Name + ": " + Str.Small(RprDfApr.Name);

  IF RprDfApr.Leaf = 0 THEN
   RprDA_AsStr:=RprDA_AsStr + " (ॡ 筥)";
  END;

  RETURN       "?" +
         " " + L_Str.PoolItem(GetFixed_Pool(1),    RprDA.Fixed) +
         " " + L_Str.PoolItem(GetWhenBurn_Pool(1), RprDA.WhenBurn) +
         " " + RprDA_AsStr +_Comment +
         " " + "[" + RprDfApr.RprDfApr + "]";
 END {GetRprDA_AsStr};

 PRIVATE PROCEDURE intGetRprT_AsStr(woRprSort, woRprPlace: SCAL[2]): STRING[];
  VAR
   SortAndRprPlaceName,
   Text,
   RprTBegDT_asStr: STRING[];
   plnRprTEndDTS  : FLOAT;
   plnRprTEndDate : DATE;
   plnRprTEndTime : TIME;
 BEGIN
  AccessRprT();
  IF ~!RprT.JobBDate THEN
   RprTBegDT_asStr:=" " + DateTimeShortStr(RprT.JobBDate, RprT.JobBTime)
  ELSE
   RprTBegDT_asStr:=" " + DateTimeShortStr(RprT.BDate, RprT.BTime)
  END;

  SETEMPTY(SortAndRprPlaceName, Text);
  IF ~!RprT.Sort & ~woRprSort THEN
   CONFORM(RprT, Sort);
   SortAndRprPlaceName:="[ " + Sort.Sort + " " + Sort.Name;
  END;

  IF ~!RprT.TaskLen THEN
   Text:="  " + FLDTOSTR(RprT.TaskLen, "2.");
  END;

  IF    !RprT.JobBDate THEN
   Text:=Text + " " + GetTime_AsStr(-SysOverTime(RprT.BDate, RprT.BTime), 1);
  ELSE
   IF ~!RprT.TaskLen THEN
    plnRprTEndDTS :=L_DatTim.GetVARIANTDATE(RprT.JobBDate, RprT.JobBTime, 00) + RprT.TaskLen/24;
    plnRprTEndDate:=L_DatTim.GetDateOfVARIANTDATE(plnRprTEndDTS);
    plnRprTEndTime:=L_DatTim.GetTimeOfVARIANTDATE(plnRprTEndDTS);
    Text:=Text + " (" + DateTimeShortStr(plnRprTEndDate, plnRprTEndTime) + ")";
   END;

   IF RprT.Result = tr_InProgress THEN
    IF ~!RprT.TaskLen THEN
     Text:=Text + " " + GetTime_AsStr(-SysOverTime(plnRprTEndDate, plnRprTEndTime), 1);
    END;
   ELSE
    Text:=Text + " (" + L_Str.PoolItem("???|||", RprT.Result) + " " +
                 DateTimeShortStr(RprT.EDate, RprT.ETime) + ")" +
                 "  " + GetTime_AsStr(dti_GetDuration(RprT.JobBDate, RprT.JobBTime, RprT.JobEDate, RprT.JobETime), 0);
   END;
  END;

  IF ~!RprT.RprPlace & ~woRprPlace THEN
   CONFORM(RprT, RprPlace);
   IF ~!SortAndRprPlaceName THEN
    SortAndRprPlaceName:=SortAndRprPlaceName + " " + RprPlace.RprPlace + " " + RprPlace.Name + "]";
   ELSE
    SortAndRprPlaceName:="[" + RprPlace.RprPlace + " " + RprPlace.Name + "]";
   END;
  END;

  RETURN "!" + " " + L_Str.PoolItem(GetTaskResult_Pool(1), RprT.Result) + " " +
         L_Str.PoolItem(rpr_TaskKind_Pool, RprT.TaskKind)               + " " +
         "(" + RprTBegDT_asStr + ")" +
         Text + " " +
         SortAndRprPlaceName;
 END {intGetRprT_AsStr};

 PUBLIC PROCEDURE GetRprT_AsStr(woRprPlace: SCAL[2]): STRING[];
 BEGIN
  RETURN intGetRprT_AsStr(0, woRprPlace);
 END {GetRprT_AsStr};

 PUBLIC PROCEDURE GetRprJ_AsStr(): STRING[];
  VAR
   RprJ_AsStr: STRING[];
 BEGIN
  AccessRprJ();
  CONFORM(RprJ, RprJob);
  CONFORM(RprJob, CarBlock);

  RprJ_AsStr:=CarBlock.Name + ": " + RprJob.Name;

  IF RprJob.Leaf = 0 THEN
   RprJ_AsStr:=RprJ_AsStr + " (ॡ 筥)";
  ELSE
   RprJ_AsStr:=RprJ_AsStr + ", " + L_Str.PoolItem(GetRprJobType_Pool(0), RprJob.Type);
  END;

  RETURN       "*" + " " + L_Str.PoolItem("-|+", ~!RprJ.EDate) +
         " " + RprJ_AsStr +
         " [" + RprJob.RprJob + "]";
 END {GetRprJ_AsStr};

 PRIVATE PROCEDURE PrintRprSAddInf(File       : STRING[];
                                   rprproLevel: SCAL[3];
                                   pr_Obj     : SCAL[3];
                                   _Shift     : STRING[];
                                   Length     : NUMERIC[0]);
  VAR
   Text,
   ClrPhones,
   Shift: STRING[];
   _RprT: LIKE(RprT.RprT);
   _RprJ: LIKE(RprJ.RprJ);
 BEGIN
  IF     rprproLevel = rprprol_RprS THEN
   SETEMPTY(_RprT, _RprJ);
  ELSIF rprproLevel = rprprol_RprT THEN
   _RprT:=RprT.RprT;
   SETEMPTY(_RprJ);
  ELSIF rprproLevel = rprprol_RprJ THEN
   _RprT:=RprT.RprT;
   _RprJ:=RprJ.RprJ;
  END;

  SELECT(RprP, RprJ, , RprS.RprS, _RprT, _RprJ);
  WHILE OCCURE(RprP) DO
   CONFORM(RprP, Staff);
   CONFORM(Staff, Man);
   Text:=_Shift + L_Str.PoolItem(rprpwho_Pool, RprP.Who) + " " + Staff.TSN + " " + Man.Name;
   IF (rprproLevel = rprprol_RprS) & (RprP.Who = rprpwho_DrvDeclarant) THEN
    ClrPhones:=GetManClrPhones(RprP.TSN, RprS.OrdDate);
    IF ~!ClrPhones THEN
     Text:=Text + " (" + ClrPhones + ")";
    END;
   END;
   pr_PrintSingleLine(File, Text, Length);
   NEXT(RprP);
  END; (* WHILE OCCURE(RprP) ... *)

  SELECT(RprPro, RprS, , RprS.RprS, _RprT, _RprJ);
  WHILE OCCURE(RprPro) DO
   CONFORM(RprPro, Property);
(*
   pr_PrintSingleLine(File, _Shift + "$ " + Property.Name + ": " + RprPro.Value + " [" + RprPro.Property + "]", Length);
*)
   pr_PrintSingleLine(File, _Shift + "$ " + Property.Name + ": " + RprPro.Value, Length);
   NEXT(RprPro);
  END; (* WHILE OCCURE(RprPro) ... *)
 END {PrintRprSAddInf};

 PUBLIC PROCEDURE InitRprSReport(EUMode: SCAL[2]; Title: STRING[]);
 BEGIN
  IF ~EUMode THEN
   L_XDoc.sl_Init(Title);
  END;
 END {InitRprSReport};

 PRIVATE PROCEDURE PrintPutOffRprDA(File        : STRING[];
                                    ReportLength: NUMERIC[0];
                                    _FRprS      : LIKE(RprS.RprS);
                                    _RprDfApr   : LIKE(RprDfApr.RprDfApr));
  VAR
   _Comment: STRING[];
 BEGIN
  IF ~!_FRprS THEN
   SAVE(RprDA);
   L_General.CallUs(SEARCH(RprDA, RprS, _FRprS, _RprDfApr));
   SETEMPTY(_Comment);
   IF ~!RprDA.Comment THEN
    _Comment:=" " + "(" + RprDA.Comment + ")";
   END;
   pr_PrintSingleLine(File, "    ७ᥭ   " + RprDA.RprS + _Comment, ReportLength);
   PrintPutOffRprDA(File, ReportLength, RprDA.FRprS, RprDA.RprDfApr);
   RESTORE(RprDA);
  END;
 END {PrintPutOffRprDA};

 PUBLIC PROCEDURE SinglePrintRprS(File        : STRING[];
                                  pr_Obj      : SCAL[3];
                                  EUMode,
                                  wPutOffDA   : SCAL[2];
                                  _CarBlock   : LIKE(CarBlock.CarBlock);
                                  ReportLength: NUMERIC[0]);
 BEGIN
  IF ~EUMode THEN
   L_XDoc.sl_AddItem(L_XDoc.XDocId(L_XDoc.xdt_RprS, L_XDoc.EmptyXDocKind, RprS.RprS),
                     RprS.RprS + " " +
                     L_DatTim.DateStr(RprS.OrdDate) + " " +
                     L_DatTim.DateStr(RprS.EDate) + " " +
                     L_Str.PoolItem("-|", RprS.Closed));
  END;
  AccessOrigin();

  pr_PrintSingleLine(File, L_Str.Repeat("=", ReportLength), ReportLength);
  pr_PrintRprS(File, pr_Obj);
  PrintRprSAddInf(File, rprprol_RprS, pr_Obj, "", ReportLength);

  SELECT(RprDA, RprDA, , RprS.RprS);
  WHILE OCCURE(RprDA) DO
   IF !_CarBlock | (RprDA.CarBlock = _CarBlock) THEN
    CONFORM(RprDA, RprDfApr);
    pr_PrintSingleLine(File, " " + GetRprDA_AsStr(), ReportLength);
    IF wPutOffDA THEN
     PrintPutOffRprDA(File, ReportLength, RprDA.FRprS, RprDA.RprDfApr);
    END;
   END;
   NEXT(RprDA);
  END; (* WHILE OCCURE(RprDA) ... *)
 END {SinglePrintRprS};

 PRIVATE PROCEDURE intSinglePrintRprT(File        : STRING[];
                                      pr_Obj      : SCAL[3];
                                      EUMode,
                                      woRprSort,
                                      woRprPlace,
                                      wPutOffDA   : SCAL[2];
                                      _CarBlock   : LIKE(CarBlock.CarBlock);
                                      _Sort       : LIKE(Sort.Sort);
                                      ReportLength: NUMERIC[0];
                                      VAR
                                      TotalRprJTimes: NUMERIC[2][]);
  VAR
   RprJDuration      : NUMERIC[2];
   _Shift,
   RprJDuration_asStr: STRING[];
 BEGIN
  _Shift:="  ";
  IF !_Sort | (RprT.Sort = _Sort) THEN

   pr_PrintSingleLine(File, _Shift + intGetRprT_AsStr(woRprSort, woRprPlace), ReportLength);
   PrintRprSAddInf(File, rprprol_RprT, pr_Obj, _Shift, ReportLength);
   SELECT(RprJ, RprS, , RprS.RprS, RprT.RprT);
   WHILE OCCURE(RprJ) DO
    CONFORM(RprJ, RprJob);
    _Shift:="   ";
    IF !_CarBlock | (RprJob.CarBlock = _CarBlock) THEN
     RprJDuration_asStr:=" 㤮 " + FLDTOSTR(RprJ.BaseTime, "2.") + "/";
     IF ~!RprJ.EDate THEN
      RprJDuration      :=dti_GetDuration(RprJ.BDate, RprJ.BTime, RprJ.EDate, RprJ.ETime);
      RprJDuration_asStr:=RprJDuration_asStr + FLDTOSTR(RprJDuration, "2.");
     ELSE
      RprJDuration:=0;
     END;
     IF ~!RprJ.BaseTime THEN
      INC(TotalRprJTimes[0], RprJ.BaseTime);
     END;
     INC(TotalRprJTimes[1], RprJDuration);
     pr_PrintSingleLine(File, _Shift + GetRprJ_AsStr() + RprJDuration_asStr, ReportLength);
     PrintRprSAddInf(File, rprprol_RprJ, pr_Obj, _Shift, ReportLength);
    END;
    NEXT(RprJ);
   END; (* WHILE OCCURE(RprJ) ... *)
  END;
 END {intSinglePrintRprT};

 PUBLIC PROCEDURE SinglePrintRprT(File        : STRING[];
                                  pr_Obj      : SCAL[3];
                                  EUMode,
                                  wPutOffDA   : SCAL[2];
                                  _CarBlock   : LIKE(CarBlock.CarBlock);
                                  _Sort       : LIKE(Sort.Sort);
                                  ReportLength: NUMERIC[0]);
  VAR
   Dummy: NUMERIC[2][2];
 BEGIN
  SETZERO(Dummy);
  intSinglePrintRprT(File, pr_Obj, EUMode, 0, 1, wPutOffDA, _CarBlock, _Sort, ReportLength, Dummy);
 END {SinglePrintRprT};

 PUBLIC PROCEDURE intPrintRprS_wRprJTimes(File     : STRING[];
                                          pr_Obj   : SCAL[3];
                                          EUMode,
                                          woRprSort,
                                          woRprPlace,
                                          wPutOffDA: SCAL[2];
                                          _CarBlock: LIKE(CarBlock.CarBlock);
                                          _Sort    : LIKE(Sort.Sort);
                                          VAR
                                          TotalRprJTimes: NUMERIC[2][]);
 BEGIN
  SinglePrintRprS(File, pr_Obj, EUMode, wPutOffDA, _CarBlock, pr_Length);

  SELECT(RprT, RprS, , RprS.RprS);
  WHILE OCCURE(RprT) DO
   intSinglePrintRprT(File, pr_Obj, EUMode, woRprSort, woRprPlace, wPutOffDA, _CarBlock, _Sort, pr_Length, TotalRprJTimes);
   NEXT(RprT);
  END; (* WHILE OCCURE(RprT)...*)
 END {intPrintRprS_wRprJTimes};

 PUBLIC PROCEDURE extPrintRprS(File      : STRING[];
                               pr_Obj    : SCAL[3];
                               EUMode,
                               woRprSort,
                               woRprPlace: SCAL[2];
                               wPutOffDA : SCAL[2];
                               _CarBlock : LIKE(CarBlock.CarBlock);
                               _Sort     : LIKE(Sort.Sort));
  VAR
   Dummy: NUMERIC[2][2];
 BEGIN
  SETZERO(Dummy);
  intPrintRprS_wRprJTimes(File, pr_Obj, EUMode, woRprSort, woRprPlace, wPutOffDA, _CarBlock, _Sort, Dummy);
 END {extPrintRprS};

 PUBLIC PROCEDURE intPrintRprS(File     : STRING[];
                               pr_Obj   : SCAL[3];
                               EUMode,
                               wPutOffDA: SCAL[2];
                               _CarBlock: LIKE(CarBlock.CarBlock);
                               _Sort    : LIKE(Sort.Sort));
 BEGIN
  extPrintRprS(File, pr_Obj, EUMode, 0, 1, wPutOffDA, _CarBlock, _Sort);
 END {intPrintRprS};

 PUBLIC PROCEDURE DoneRprSReport(EUMode: SCAL[2]);
 BEGIN
  IF ~EUMode THEN
   L_XDoc.sl_Done();
  END;
 END {DoneRprSReport};

 PUBLIC PROCEDURE E_GetRepairContractTemplate(D          : DATE;
                                              trgFirm    : LIKE(Firm.Firm);
                                              trgLocation: tRprSLocation): LIKE(Contract.Contract);
  VAR
   Local: PROC;
 BEGIN
  Local:=PROCREF(E_Rpr.GetRepairContractTemplate);
  IF ~!Local THEN
   RETURN Local(D, trgFirm, trgLocation);
  ELSE
   L_General.SetupRequired();
  END;
 END {E_GetRepairContractTemplate};

 PUBLIC PROCEDURE intStandOnRprContract(_Firm: LIKE(Firm.Firm); _Date: DATE): SCAL[2];
  VAR
   _Parent  : LIKE(Contract.Contract);
 BEGIN
  _Parent:=E_GetRepairContractTemplate(_Date, _Firm, RprS.Location);
  SELECT(Contract, Firm, , _Firm, 1);
  WHILE OCCURE(Contract) DO
   IF (Contract.Parent = _Parent) & L_DatTim.IsActive_Inc(_Date, Contract.Begin, Contract.Till) THEN
    RETURN 1;
   END;
   NEXT(Contract);
  END; (* WHILE OCCURE(Contract) ... *)
  RETURN 0;
 END {intStandOnRprContract};

 PUBLIC PROCEDURE StandOnRprContract(trgFirm: LIKE(Firm.Firm); trgDate: DATE);
 BEGIN
  IF ~intStandOnRprContract(trgFirm, trgDate) THEN
   L_StdFrm.WrongDB("    饣   ६" +
                    "| " + L_DatTim.DateStr(trgDate) + "  ࠣ⮬ " + trgFirm);
  END;
 END {StandOnRprContract};

 PUBLIC PROCEDURE IsWarrantyRepair(): SCAL[2];
 BEGIN
  RETURN HasRprTask(tk_WarrantyRepair, EMPTYOF(RprT.Result));
 END {IsWarrantyRepair};

 PRIVATE PROCEDURE GetRprSFirm(): LIKE(Firm.Firm);
  VAR
   Result: LIKE(Firm.Firm);
 BEGIN
  SETEMPTY(Result);
  AccessOrigin();
  IF    IsRprS_w_OutCar() THEN
   Result:=OutCar.Firm;
  ELSIF IsRprS_w_OutCBlc() THEN
   Result:=OutCBlc.Firm;
  ELSIF IsRprS_w_Car() THEN
   IF IsWarrantyRepair() THEN
    Result:=L_Car.GetFirmOfCar(RprS.OrdDate);
   END;
  END;
  RETURN Result;
 END {GetRprSFirm};

 PUBLIC PROCEDURE GetMayBePaidMDocKind(): LIKE(MDocKind.MDocKind);
  VAR
   Result : LIKE(MDocKind.MDocKind);
   trgFirm: LIKE(Firm.Firm);
 BEGIN
  SETEMPTY(Result);
  trgFirm:=GetRprSFirm();

  IF ~!trgFirm THEN
   IF P_Firm.FP_PrtnrTyp(trgFirm, RprS.OrdDate) = P_Firm.pt_Man THEN
    Result:=L_MDoc.md_RPr;
   ELSE
    Result:=L_MDoc.md_IsS;
   END;
  END;
  RETURN Result;
 END {GetMayBePaidMDocKind};

 PUBLIC PROCEDURE GetAcceptanceMDocKind(): LIKE(MDocKind.MDocKind);
 BEGIN
  IF IsRprS_w_OutCar() THEN
   AccessOrigin();
   IF (P_Firm.FP_PrtnrTyp(OutCar.Firm, RprS.OrdDate) # P_Firm.pt_Man) &
      intStandOnRprContract(OutCar.Firm, RprS.OrdDate) &
      (P_Cntr.GetBalanceType(Contract.Contract, RprS.OrdDate) = P_Cntr.ctbt_ByContract) THEN
    RETURN L_MDoc.md_IAS;
   END;
  END;
  RETURN EMPTYOF(MDocKind.MDocKind);
 END {GetAcceptanceMDocKind};

 PUBLIC PROCEDURE IsAcceptableAddMDocKind(addMDocKind: LIKE(MDocKind.MDocKind)): SCAL[2];
  VAR
   Result: SCAL[2];
 BEGIN
  AccessRprS();
  Result:=0;
  IF    IsRprS_w_Car() THEN
   Result:=(addMDocKind = L_MDoc.md_NOV) | (addMDocKind = GetMayBePaidMDocKind());
  ELSIF IsRprS_w_OutCar() THEN
   Result:=(addMDocKind = L_MDoc.md_TOV) | (addMDocKind = GetMayBePaidMDocKind()) | (addMDocKind = GetAcceptanceMDocKind());
  ELSIF IsRprS_w_CarBlock() THEN
   Result:=(addMDocKind = L_MDoc.md_TOV) | (addMDocKind = L_MDoc.md_ViP);
  ELSIF IsRprS_w_OutCBlc() THEN
   Result:=(addMDocKind = L_MDoc.md_TOV) | (addMDocKind = GetMayBePaidMDocKind()) | (addMDocKind = GetAcceptanceMDocKind());
  ELSIF IsRprS_w_Math() THEN
   Result:=(addMDocKind = L_MDoc.md_TOV) | (addMDocKind = L_MDoc.md_ViP);
  END;
  RETURN Result;
 END {IsAcceptableAddMDocKind};

 PUBLIC PROCEDURE CheckAcceptableRprSStatusForBuildMDoc(trgStatus: tMirrorStatus);
 BEGIN
  IF (trgStatus = ms_Cancel) | (trgStatus = ms_Done) | (trgStatus = ms_PutOff) THEN
   L_General.Error(" 室  ﭨ '" + GetRprSStatus_AsStr(trgStatus) + "', ࠡ   饭");
  END;
 END {CheckAcceptableRprSStatusForBuildMDoc};

 PUBLIC PROCEDURE RemAddDoc();
 BEGIN
  AccessRprS();
  CheckAcceptableRprSStatusForBuildMDoc(RprS.Status);
  L_Pmnt.ConfirmRemovingDocs(0,
                             L_Pmnt.RemoveGeneratedMDocs(0,
                                                         L_Pmnt.sbvmd_Online,
                                                         L_Pmnt.GetAddMDocKind(PROCREF(IsAcceptableAddMDocKind), " 㬥"),
                                                         L_XDoc.xdt_RprS,
                                                         L_XDoc.EmptyXDocKind,
                                                         RprS.RprS));
 END {RemAddDoc};

 PRIVATE PROCEDURE extPutInMathMvmnt(trgStorage: LIKE(Storage.Storage);
                                     mft       : L_MDoc.tMathFlowType;
                                     trgCUCopy : LIKE(CUCopy.CUCopy);
                                     trgQnt    : L_XObj.tQnt;
                                     trgSum    : L_XObj.tSum);
  VAR
   trgDbt,
   trgCrd,
   trgCrd_WO: L_XObj.tQnt;
   trgDbtSum: L_XObj.tSum;
 BEGIN
  SETZERO(trgDbt, trgDbtSum, trgCrd, trgCrd_WO);
  IF mft = L_MDoc.mft_Debit THEN
   trgDbt   :=trgQnt;
   trgDbtSum:=trgSum;
  ELSE
   IF    (MDocKind.MDocKind = L_MDoc.md_NOV) | (MDocKind.MDocKind = L_MDoc.md_TOV) THEN
    trgCrd_WO:=trgQnt;
   ELSIF MDocKind.MDocKind = L_MDoc.md_MSP THEN
    trgCrd   :=trgQnt;
   ELSE
    L_General.CallUs(0);
   END;
  END;
  ADD(MathMvmnt, Storage, , trgStorage, MDocList.Math, MDocList.MMode, trgCUCopy, MDoc.Date, MDoc.DoneDTS, L_XDoc.curXDocId(L_XDoc.xdt_MDoc),
                            MathMvmnt.Dbt,    trgDbt,
                            MathMvmnt.DbtSum, trgDbtSum,
                            MathMvmnt.Crd,    trgCrd,
                            MathMvmnt.Crd_WO, trgCrd_WO);
 END {extPutInMathMvmnt};

 PRIVATE PROCEDURE PutInMathMvmnt(trgStorage: LIKE(Storage.Storage);
                                  mft       : L_MDoc.tMathFlowType);
 BEGIN
  IF SELECT(MDocLCU, MDoc, MDoc.MDocKind, MDoc.MDoc, MDocList.MDLNbr) THEN
   WHILE OCCURE(MDocLCU) DO
    extPutInMathMvmnt(trgStorage, mft, MDocLCU.CUCopy, 1, (MDocList.Sum + MDocList.VAT) / MDocList.Qnt);
    NEXT(MDocLCU);
   END; (* WHILE OCCURE(MDocLCU) ... *)
  ELSE
   extPutInMathMvmnt(trgStorage, mft, EMPTYOF(CUCopy.CUCopy), L_MDoc.GetMDocListCir2(), (MDocList.Sum + MDocList.VAT));
  END;
 END {PutInMathMvmnt};

 PUBLIC PROCEDURE GetRprStorage(VAR trgStorage, trgStorage2: LIKE(Storage.Storage));
 BEGIN
  SETEMPTY(trgStorage, trgStorage2);
  IF L_MathR.E_GetSingleRefToXDocType(MDoc.Date, MDoc.MDocKind, MDoc.Storage) = L_XDoc.xdt_RprS THEN
   trgStorage:=MDoc.Storage;
  END;
  IF L_MathR.E_GetSingleRefToXDocType(MDoc.Date, MDoc.MDocKind, MDoc.Storage2) = L_XDoc.xdt_RprS THEN
   trgStorage2:=MDoc.Storage2;
  END;
  IF ~!trgStorage & ~!trgStorage2 THEN
   L_General.Error(" " + L_MDoc.MDocStr(MDoc.MDocKind, MDoc.MDoc) + " ⨬ 稥     ''");
  END;
 END {GetRprStorage};

 PRIVATE PROCEDURE CreateMathMvmnt();
 BEGIN
  IF !DATABASE.Get().Tables("MathMvmnt") THEN
   CreateFILE(MathMvmnt, "", " 㬬  ", "");
 
   CreateFIELD(MathMvmnt, XDocId,  L_XDoc.tXDocId,        "", "",  "", "⥫᪨ XDocId", "");
   CreateFIELD(MathMvmnt, Date,    DATE,                  "", "",  "", " 㬥", "");
   CreateFIELD(MathMvmnt, DoneDTS, FLOAT,                 "", "",  "", " MDoc.DoneDTS", "");
   CreateFIELD(MathMvmnt, Storage, LIKE(Storage.Storage), "", "",  "", "", "");
   CreateFIELD(MathMvmnt, Math,    LIKE(Math.Math),       "", "",  "", "", "");
   CreateFIELD(MathMvmnt, CUCopy,  LIKE(CUCopy.CUCopy),   "", "",  "", "", "");
   CreateFIELD(MathMvmnt, MMode,   LIKE(MMode.MMode),     "", "",  "", "", "");
   CreateFIELD(MathMvmnt, Dbt,     L_XObj.tQnt,           "", "0", "", "", "");
   CreateFIELD(MathMvmnt, DbtSum,  L_XObj.tSum,           "", "0", "", "㬬 室", "");
   CreateFIELD(MathMvmnt, Crd,     L_XObj.tQnt,           "", "0", "", "।", "");
   CreateFIELD(MathMvmnt, Crd_WO,  L_XObj.tQnt,           "", "0", "", " .. ᯨᠭ", "");
 
   CreateINDEX(MathMvmnt, Storage, UNIQUE, "", "", Storage, Math, MMode, CUCopy, Date, DoneDTS, XDocId);
   CreateINDEX(MathMvmnt, Math,    PLURAL, "", "", Math, MMode, DoneDTS, XDocId);
   SetVersionOfFILE(MathMvmnt, 0);
  END;
  L_AFM.CreateTemp("MathMvmnt");
 END {CreateMathMvmnt};

 PUBLIC PROCEDURE GetRprSMDocListMathFlowType(trgStorage, trgStorage2: LIKE(Storage.Storage)): L_MDoc.tMathFlowType;
  VAR
   Result: L_MDoc.tMathFlowType;
 BEGIN
  Result:=L_MDoc.getMDocListStorageRelatedMathFlowType();
  IF Result # L_MDoc.mft_None THEN
   IF    ~!trgStorage THEN
    L_General.CallUs(!trgStorage2);
   ELSIF ~!trgStorage2 THEN
    L_General.CallUs(!trgStorage);
    Result:=L_MDoc.InvertMathFlowType(Result);
   ELSE
    L_General.CallUs(0);
   END;
  ELSE
   SETEMPTY(Result);
  END;
  RETURN Result;
 END {GetRprSMDocListMathFlowType};

 PUBLIC PROCEDURE intPrepareMathMovementByRprS(trgRprS         : LIKE(RprS.RprS);
                                               wCheckMDocStatus: SCAL[2]);
  VAR
   i                 : NUMERIC[0];
   mft               : L_MDoc.tMathFlowType;
   trgStorage,
   trgStorage2       : LIKE(Storage.Storage);
   RprSDependentMDocs: STRING[];
 BEGIN
  APP.Get().NewPrompt("");
  CreateMathMvmnt();
  SAVE(MDocKind);
  SAVE(MDoc);
  SAVE(MDocList);
  SAVE(MDocLCU);

  RprSDependentMDocs:=L_XDoc.GetDependentXDC(L_XDoc.XDocId(L_XDoc.xdt_RprS, L_XDoc.EmptyXDocKind, trgRprS), L_XDoc.xdt_MDoc);
  i  :=0;
  WHILE L_XDoc.xdc_PositionOn(RprSDependentMDocs, i) DO
   PROMPT(L_MDoc.MDocStr(MDoc.MDocKind, MDoc.MDoc));
   CONFORM(MDoc, MDocKind);
   IF MDocKind.Activity & (MDoc.Status # L_MDoc.st_Canceled) &
      (MDocKind.MDocKind = L_MDoc.md_ViP) | (MDocKind.MDocKind = L_MDoc.md_MSP) |
      (MDocKind.MDocKind = L_MDoc.md_NOV) | (MDocKind.MDocKind = L_MDoc.md_TOV) THEN
    IF    MDoc.Status = L_MDoc.st_Passed THEN
     GetRprStorage(trgStorage, trgStorage2);
     CONFORM(MDoc, MDocList);
     WHILE OCCURE(MDocList) DO
      mft:=GetRprSMDocListMathFlowType(trgStorage, trgStorage2);
      IF ~!mft THEN
       IF ~!trgStorage THEN
        PutInMathMvmnt(trgStorage,  mft);
       END;
       IF ~!trgStorage2 THEN
        PutInMathMvmnt(trgStorage2, mft);
       END;
      END;
      NEXT(MDocList);
     END; (* WHILE OCCURE(MDocList) ... *)
    ELSIF wCheckMDocStatus THEN
     L_General.Assert((MDoc.Status=L_MDoc.st_Passed) | (MDoc.Status=L_MDoc.st_Canceled),
                      "㬥 " + L_MDoc.MDocStr(MDoc.MDocKind, MDoc.MDoc) +
                      "    ﭨ '஢'.|믮 樨 ");
    END;
   END; (* IF MDocKind.Activity &...*)
   INC(i);
  END; (* WHILE L_XDoc.xdc_PositionOn ... *)
  RESTORE(MDocLCU);
  RESTORE(MDocList);
  RESTORE(MDoc);
  RESTORE(MDocKind);
 END {intPrepareMathMovementByRprS};

 PUBLIC PROCEDURE PrepareMathMovementByRprS(trgRprS: LIKE(RprS.RprS));
 BEGIN
  intPrepareMathMovementByRprS(trgRprS, 1);
 END {PrepareMathMovementByRprS};

 PUBLIC PROCEDURE IsTransferToRepair(trgXDocId: L_XDoc.tXDocId; trgMMode: LIKE(MMode.MMode)): SCAL[2];
 BEGIN
  RETURN (trgMMode = L_MathR.mm_InBadRepair)                   &
         (L_XDoc.ExtractXDocType(trgXDocId) = L_XDoc.xdt_MDoc) &
         (L_XDoc.ExtractXDocKindId(trgXDocId) = L_XDoc.XDocKindId(L_XDoc.xdt_MDoc, L_MDoc.md_TOV));
 END {IsTransferToRepair};

 PUBLIC PROCEDURE IsRestoreFromRepair(trgXDocId: L_XDoc.tXDocId; trgMMode: LIKE(MMode.MMode)): SCAL[2];
 BEGIN
  RETURN ((trgMMode = L_MathR.mm_Restored)    | (trgMMode = L_MathR.mm_Nonserviceable) |
          (trgMMode = L_MathR.mm_InBadRepair) | (trgMMode = L_MathR.mm_New)) &
         (L_XDoc.ExtractXDocType(trgXDocId) = L_XDoc.xdt_MDoc)               &
         (L_XDoc.ExtractXDocKindId(trgXDocId) = L_XDoc.XDocKindId(L_XDoc.xdt_MDoc, L_MDoc.md_ViP));
 END {IsRestoreFromRepair};

 PRIVATE PROCEDURE CheckSingleMathMovement(VAR trgInRpr  : L_XObj.tQnt;
                                           VAR trgFrRpr  : L_XObj.tQnt[];
                                           VAR trgCrd_WO : L_XObj.tQnt;
                                           VAR trgQnt    : L_XObj.tQnt;
                                           VAR hasCrdRst : SCAL[2];
                                           VAR DocList   : STRING[];
                                           VAR XDocIdList: STRING[]);
  VAR
   curQnt : L_XObj.tQnt;
   IsDebit: SCAL[2];
 BEGIN
  SETEMPTY(DocList, XDocIdList);
  trgQnt   :=0;
  hasCrdRst:=0;
  WHILE OCCURE(MathMvmnt) DO
   IF    IsRestoreFromRepair(MathMvmnt.XDocId, MathMvmnt.MMode) THEN
    INC(trgFrRpr[MathMvmnt.MMode], MathMvmnt.Dbt);
   ELSIF IsTransferToRepair(MathMvmnt.XDocId, MathMvmnt.MMode) THEN
    INC(trgInRpr, MathMvmnt.Crd_WO);
   END;
   INC(trgQnt, MathMvmnt.Dbt-MathMvmnt.Crd-MathMvmnt.Crd_WO);

   IsDebit:=MathMvmnt.Dbt # 0;

   IF    MathMvmnt.Dbt # 0 THEN
    curQnt:=MathMvmnt.Dbt;
   ELSIF MathMvmnt.Crd # 0 THEN
    curQnt:=MathMvmnt.Crd;
   ELSIF MathMvmnt.Crd_WO # 0 THEN
    curQnt:=MathMvmnt.Crd_WO;
   ELSE
    curQnt:=0;
   END;
   IF trgQnt < 0 THEN
    hasCrdRst:=1;
   END;
   XDocIdList:=XDocIdList + MathMvmnt.XDocId + "|";
   DocList   :=DocList + L_XDoc.XDocStr(MathMvmnt.XDocId) + " " +
                         L_DatTim.DateStr(MathMvmnt.Date) +
                         Str.Align(L_MathR.DefaultFormatCir(MathMvmnt.Math, curQnt), 10, RIGHT) + " " +
                         L_Str.PoolItem("|", IsDebit) + " " +
                         Str.Align(L_MathR.DefaultFormatCir(MathMvmnt.Math, trgQnt), 10, RIGHT) + "|";
   INC(trgCrd_WO, MathMvmnt.Crd_WO);
   NEXT(MathMvmnt);
  END; (* WHILE OCCURE(MathMvmnt) ... *)
 END {CheckSingleMathMovement};

 PRIVATE PROCEDURE GetTotalFrRpr(VAR trgFrRpr: L_XObj.tQnt[]): L_XObj.tQnt;
  VAR
   i     : NUMERIC[0];
   Result: L_XObj.tQnt;
 BEGIN
  SETZERO(i, Result);
  WHILE i <= HIGH(trgFrRpr) DO
   INC(Result, trgFrRpr[i]);
   INC(i);
  END; (* WHILE i <= HIGH(trgFrRpr)...*)
  RETURN Result;
 END {GetTotalFrRpr};

 PRIVATE PROCEDURE CheckMathMovementBySingleStorage(trgStorage: LIKE(Storage.Storage);
                                                    trgRprS   : LIKE(RprS.RprS));
  VAR
   Dummy          : SCAL[2];
   trgMath        : LIKE(Math.Math);
   trgQnt,
   trgInRpr,
   totFrRpr,
   dummyCrd_WO    : L_XObj.tQnt;
   trgFrRpr       : L_XObj.tQnt[1E2];
   DocList,
   dummyXDocIdList: STRING[];
 BEGIN
  IF ~!trgStorage THEN
   SELECT(MathMvmnt, Storage, , trgStorage);
   WHILE OCCURE(MathMvmnt) DO
    SETEMPTY(DocList);
    SETZERO(trgInRpr, trgFrRpr, dummyCrd_WO);
    NARROWSEL(MathMvmnt, Math);
    trgMath:=MathMvmnt.Math;
    WHILE OCCURE(MathMvmnt) DO
     NARROWSEL(MathMvmnt, MMode);
     CheckSingleMathMovement(trgInRpr, trgFrRpr, dummyCrd_WO, trgQnt, Dummy, DocList, dummyXDocIdList);
     L_General.Assert(trgQnt >= 0, " ⮢    " + trgRprS + " ( " + trgStorage + "):|" +
                                   "䨪 ⥪饣  ਢ  ।⮢    " + trgMath + "||" +
                                   DocList);
     NEXTINEXTENDEDSEL(MathMvmnt, MMode);
    END; (* WHILE OCCURE(MathMvmnt) ... *)

    SAVE(RprS);
    SEARCH(RprS, RprS, , trgRprS);
    IF ~IsRprS_w_Car() THEN
     totFrRpr:=GetTotalFrRpr(trgFrRpr);
     IF trgInRpr < totFrRpr THEN
      L_StdFrm.Question(" " + trgStorage + ",  " + trgMath + ",  " + trgRprS + ":|" +
                        "ᥣ ।  ६ " + L_MathR.DefaultFormatCir(trgMath, trgInRpr) +
                        ", ᥣ 饭  ६ " + L_MathR.DefaultFormatCir(trgMath, totFrRpr));
     END;
    END;
    RESTORE(RprS);
    NEXTINEXTENDEDSEL(MathMvmnt, Math);
   END; (* WHILE OCCURE(MathMvmnt) ... *)
  END;
 END {CheckMathMovementBySingleStorage};

 PUBLIC PROCEDURE CheckMDocListMathMovementByRprS(trgRprS: LIKE(RprS.RprS));
  VAR
   trgStorage,
   trgStorage2: LIKE(Storage.Storage);
 BEGIN
  intPrepareMathMovementByRprS(trgRprS, 0);
  GetRprStorage(trgStorage, trgStorage2);

  CheckMathMovementBySingleStorage(trgStorage,  trgRprS);
  CheckMathMovementBySingleStorage(trgStorage2, trgRprS);
 END {CheckMDocListMathMovementByRprS};

 PUBLIC PROCEDURE PurgeMathMvmnt();
 BEGIN
  L_AFM.AF_PurgeTemp("MathMvmnt");
 END {PurgeMathMvmnt};

 PUBLIC PROCEDURE BarCode(): STRING[];
 BEGIN
  RETURN L_XDoc.BarCode(L_XDoc.bck_IdIn17, L_XDoc.xdt_RprS, L_XDoc.EmptyXDocKind, RprS.RprS, RprS.CopyCnt);
 END {BarCode};

 PRIVATE PROCEDURE BarFullCode(): STRING[];
 BEGIN
  RETURN "!" + BarCode() + "!";
 END {BarFullCode};

 PRIVATE PROCEDURE GetRoot(root: STRING[]): STRING[];
 BEGIN
  IF ~!root & (L_Str.Char(root, Str.Length(root)-1) # ".") THEN
   root:=root + ".";
  END;
  RETURN root;
 END {GetRoot};

 PUBLIC PROCEDURE UploadClientSpares(D: DATE; root: STRING[]);
  VAR
   i: NUMERIC[0];
   ClientSparesAsStr: STRING[];
   ClientSpares     : STRING[][4];
 BEGIN
  root:=GetRoot(root);
  ClientSparesAsStr:=L_lsStore.Get(RprS.ClSpares);
  i:=0;
  IF ~!ClientSparesAsStr THEN
   LOOP
    IF ~!Str.Item(ClientSparesAsStr, ";", i) THEN
     L_MSO.wordSetVar(root + "RprS.ClientSpares" + L_MSO.IndexStr(i) + ".Nbr",   L_Str.IntStr(i+1));
     L_MSO.wordSetVar(root + "RprS.ClientSpares" + L_MSO.IndexStr(i) + ".Value", Str.Item(ClientSparesAsStr, ";", i));
    ELSE
     EXIT;
    END;
    INC(i);
   END; (* LOOP *)
  ELSE
   L_MSO.wordSetVar(root + "RprS.ClientSpares" + L_MSO.IndexStr(i) + ".Nbr",   "1");
   L_MSO.wordSetVar(root + "RprS.ClientSpares" + L_MSO.IndexStr(i) + ".Value", "");
  END;
  L_MSO.extSetWordTable("RprSClientSpares", i, L_MSO.tt_Soft);
 END {UploadClientSpares};

 PRIVATE PROCEDURE UploadSingleRprP(D: DATE; root, VarName: STRING[]);
  VAR
   ManName: STRING[];
 BEGIN
  IF OCCURE(RprP) THEN
   CONFORM(RprP, Staff);
   CONFORM(Staff, Man);
   ManName:=Man.Name;
  ELSE
   SETEMPTY(ManName);
  END;
  L_MSO.SetValueDerivativesOnDate(         root + VarName + ".Name", ManName, "SetManNameVar", D);
  L_MSO.wordSetVarsByFile_wAliasE("Staff", root + VarName, ~OCCURE(RprP));
  L_MSO.wordSetVarsByFile_wAliasE("Man",   root + VarName, ~OCCURE(RprP));
 END {UploadSingleRprP};

 PRIVATE PROCEDURE UploadRprJSingleRprJ(root                 : STRING[];
                                        D                    : DATE;
                                        j                    : NUMERIC[0];
                                        wRprJExecutors,
                                        CalcTotals           : SCAL[2];
                                        VAR TotalRprJSum     : L_XObj.tSum;
                                        VAR TotalRprJVAT     : L_XObj.tSum;
                                        VAR TotalRprJDuration: NUMERIC[3]);
  VAR
   Root        : STRING[];
   RprJVAT     : L_XObj.tSum;
   RprJobMath  : LIKE(Math.Math);
   RprJDuration: NUMERIC[3];
 BEGIN
  Root:=root + "RprJ";
  SETEMPTY(RprJVAT, RprJDuration);
  IF OCCURE(RprJ) THEN
   CONFORM(RprJ, RprJob);
   CONFORM(RprJob, CarBlock);

   IF    ~!RprJ.EDate THEN
    RprJDuration:=dti_GetDuration(RprJ.BDate, RprJ.BTime, RprJ.EDate, RprJ.ETime);
   ELSIF ~!RprJ.BaseTime THEN
    RprJDuration:=RprJ.BaseTime;
   ELSE
    SETEMPTY(RprJDuration);
   END;
   IF CalcTotals & ~!RprJDuration THEN
    INC(TotalRprJDuration, RprJDuration);
   END;

   IF ~!RprJ.Sum THEN
    RprJobMath:=E_GetRprJobMath(D);
    IF ~!RprJobMath THEN
     RprJVAT:=L_Acnt.GetInclMathVAT(RprJobMath, D, RprJ.Sum);
    ELSE
     RprJVAT:=L_Acnt.GetInclVAT(D, RprJ.Sum);
    END;

    IF CalcTotals THEN
     INC(TotalRprJSum, RprJ.Sum);
     INC(TotalRprJVAT, RprJVAT);
    END;
   END;
  END;

  L_MSO.wordSetVarsByFile_wAliasAndIndexE("RprJ",     Root, j, ~OCCURE(RprJ));
  L_MSO.wordSetVarsByFile_wIndexedPrefixE("RprJob",   Root, j, ~OCCURE(RprJ));
  L_MSO.wordSetVarsByFile_wIndexedPrefixE("CarBlock", Root, j, ~OCCURE(RprJ) | ~OCCURE(CarBlock));
  L_MSO.wordSetVarsByFile_wIndexedPrefixE("RprDfApr", Root, j, ~OCCURE(RprJ));

  Root:=Root + L_MSO.IndexStr(j) + ".";
  IF OCCURE(RprJ) & (RprJob.Leaf = 1) THEN
   L_MSO.wordSetVar(Root + "RprJob.Type.AsStr", L_Str.PoolItem(GetRprJobType_Pool(0), RprJob.Type));
  ELSE
   L_MSO.wordSetVar(Root + "RprJob.Type.AsStr", "");
  END;

  L_MSO.wordSetVar(Root + "Pos",       L_Str.IntStr(j+1));
  L_MSO.wordSetVar(Root + "Duration",  L_Str.NumericStr(RprJDuration, 3));
  L_MSO.wordSetMoneyVar(Root + "VAT",  D, RprJVAT);

  UploadSingleRprP(D, root, "RprJ" + L_MSO.IndexStr(j) + "." + "Executor");
 END {UploadRprJSingleRprJ};

 PUBLIC PROCEDURE extUploadRprJ(D: DATE; root, TableName: STRING[]; wRprJExecutors: SCAL[2]);
  VAR
   j                : NUMERIC[0];
   Root             : STRING[];

   TotalRprJSum,
   TotalRprJVAT     : L_XObj.tSum;
   TotalRprJDuration: NUMERIC[3];
   CalcTotals,
   RprJHasExecutor  : SCAL[2];
 BEGIN
  root:=GetRoot(root);
  SETZERO(j, TotalRprJSum, TotalRprJVAT, TotalRprJDuration);
  IF OCCURE(RprJ) THEN
   WHILE OCCURE(RprJ) DO
    CalcTotals     :=1;
    RprJHasExecutor:=0;
    IF wRprJExecutors THEN
     SELECT(RprP, RprS, , RprS.RprS, rprpwho_Executor);
     WHILE OCCURE(RprP) DO
      IF !RprP.RprT |
         ((RprP.RprT = RprT.RprT) & !RprP.RprJ) |
         ((RprP.RprT = RprT.RprT) & (RprP.RprJ = RprJ.RprJ)) THEN
       RprJHasExecutor:=1;
       CalcTotals     :=0;
       UploadRprJSingleRprJ(root, D, j, 1, CalcTotals, TotalRprJSum, TotalRprJVAT, TotalRprJDuration);
       INC(j);
      END;
      NEXT(RprP);
     END; (* WHILE OCCURE(RprP) ... *)
    END;

    IF ~RprJHasExecutor THEN
     UploadRprJSingleRprJ(root, D, j, 0, 1, TotalRprJSum, TotalRprJVAT, TotalRprJDuration);
     INC(j);
    END;
    NEXT(RprJ);
   END; (* WHILE OCCURE(RprJ) ... *)
  ELSE
   UploadRprJSingleRprJ(root, D, j, 0, 1, TotalRprJSum, TotalRprJVAT, TotalRprJDuration);
  END;

  L_MSO.SetWordTable(TableName, j);

  L_MSO.wordSetMoneyVar(root + "RprJ.TotalSum",          D, TotalRprJSum);
  L_MSO.wordSetMoneyVar(root + "RprJ.TotalVAT",          D, TotalRprJVAT);
  L_MSO.wordSetVar     (root + "RprJ.TotalRprJDuration", L_Str.NumericStr(TotalRprJDuration, 2));
 END {extUploadRprJ};

 PUBLIC PROCEDURE UploadRprJ(D: DATE; root: STRING[]);
 BEGIN
  SELECT(RprJ, RprS, , RprS.RprS);
  extUploadRprJ(D, GetRoot(root) + "RprS", "RprSRprJ", 0);
 END {UploadRprJ};

 PUBLIC PROCEDURE E_GetServiceCenterContacts(D: DATE; root: STRING[]);
  VAR
   Local: PROC;
   sc_Site,
   sc_Phone: STRING[];
 BEGIN
  sc_Phone:=P_Firm.FP_Phone(P_Firm.OWN_FIRM, D);
  sc_Site :=P_Firm.FP_Site(P_Firm.OWN_FIRM, D);
  Local:=PROCREF(E_Rpr.GetServiceCenterContacts);
  IF ~!Local THEN
   Local(D, sc_Phone, sc_Site);
  END;
  L_MSO.wordSetVar(root + "OwnFirm.ServiceCenter.Phone", sc_Phone);
  L_MSO.wordSetVar(root + "OwnFirm.ServiceCenter.Site",  sc_Site);
 END {E_GetServiceCenterContacts};

 PUBLIC PROCEDURE UploadSingleRprT(D: DATE; root: STRING[]; wRprJExecutors: SCAL[2]);
  VAR
   Root: STRING[];
 BEGIN
  root:=GetRoot(root);
  root:=root + "RprS.";
  L_MSO.wordSetVarsByFile_wPrefix("RprT", root);
  L_MSO.wordSetVar(root + "RprT.TaskKind", L_Str.PoolItem(rpr_TaskKind_Pool, RprT.TaskKind));
  IF ~!RprT.Sort THEN
   CONFORM(RprT, Sort);
  END;
  IF ~!RprT.RprPlace THEN
   CONFORM(RprT, RprPlace);
  END;
  Root:=root + "RprT.";
  L_MSO.wordSetVarsByFile_wPrefixE("Sort",     Root, !RprT.Sort);
  L_MSO.wordSetVarsByFile_wPrefixE("RprPlace", Root, !RprT.RprPlace);

  SELECT(RprJ, RprS, , RprS.RprS, RprT.RprT);
  extUploadRprJ(D, GetRoot(root) + "RprT", "RprSRprTRprJ", wRprJExecutors);
 END {UploadSingleRprT};

 PRIVATE PROCEDURE UploadRprSRprP(_Who: LIKE(RprP.Who); D: DATE; root, VarName: STRING[]);
 BEGIN
  SELECT(RprP, RprS, , RprS.RprS, _Who);
  UploadSingleRprP(D, root, VarName);
 END {UploadRprSRprP};

 PUBLIC PROCEDURE IsSpecificRprSContractConditions(trgFirm: LIKE(Firm.Firm);
                                                   trgDate: DATE): SCAL[2];
 BEGIN
  RETURN L_PDoc.IsOneHeadFirmBranch(P_Firm.mf_Own, trgFirm, trgDate) &
         intStandOnRprContract(trgFirm, trgDate) &
         (P_Rpr.GetContractCondition(RprS.RprS) = P_Rpr.cc_Specific);
 END {IsSpecificRprSContractConditions};

 PRIVATE PROCEDURE GetRprSContractConditions(trgFirm: LIKE(Firm.Firm);
                                             trgDate: DATE): STRING[];
  VAR
   Result: STRING[];
 BEGIN
  SETEMPTY(Result);
  IF IsSpecificRprSContractConditions(trgFirm, trgDate) THEN
   Result:="䨪 " + FLDTOSTR(trgDate, L_DatTim.MonthStr(trgDate, 0)+" y ", 0);
  END;
  RETURN Result;
 END {GetRprSContractConditions};

 PUBLIC PROCEDURE RprSFileFamily(D: DATE; root: STRING[]; wFirmByRprS: SCAL[2]);
  VAR
   i                     : NUMERIC[0];
   trgFirm               : LIKE(Firm.Firm);
   Root,
   RprObjDescr,
   trgSerial,
   RprTTaskKindAsStr,
   RprSContractConditions: STRING[];
 BEGIN
  root:=GetRoot(root);
  L_MSO.wordSetVarsByFile_wPrefix("RprS", root);
  L_MSO.wordSetVar(root + "RprS.RprObjT_asStr", L_Str.PoolItem(rot_Pool, RprS.RprObjT));
  L_MSO.wordSetVar(root + "RprS.BarCode", BarCode());

  Root:=root + "RprS.RprObj";
  AccessOrigin();
  L_MSO.wordSetVarsByFile_wPrefix("CUCopy", Root + ".");
  SETEMPTY(trgSerial, RprSContractConditions);

  RprObjDescr:=GetRprSObjDescr();

  IF    IsRprS_w_Car() THEN
   trgFirm  :=L_Car.GetFirmOfCar(RprS.OrdDate);
   L_Car.AccessMark(Car.BoxNbr, D);
   L_Car.AccessVehPasp(Car.BoxNbr, D);

   L_MSO.wordSetVarsByFile_wAlias("Car",  Root);
   L_MSO.wordSetVar(Root + ".ProdYear", L_Str.IntStr(L_DatTim.YEAR(L_Car.GetCarProdDate(Car.BoxNbr, D))));
   IF OCCURE(VehPasp) THEN
    L_MSO.wordSetVar(Root + ".VIN",      VehPasp.VIN);
    L_MSO.wordSetVar(Root + ".EnginMod", VehPasp.EnginMod);
   ELSE
    L_MSO.wordSetVar(Root + ".EnginMod", "");
    L_MSO.wordSetVar(Root + ".VIN",      "");
   END;
   L_MSO.wordSetVarsByFile_wAlias("Mark", Root + ".Mark");
  ELSIF IsRprS_w_OutCar() THEN
   trgFirm  :=OutCar.Firm;
   CONFORM(OutCar, Mark);
   L_MSO.wordSetVarsByFile_wAlias("OutCar", Root);
   L_MSO.wordSetVarsByFile_wAlias("Mark", Root + ".Mark");
  ELSIF IsRprS_w_CarBlock() THEN
   trgFirm  :=L_MathR.GetFirmOfMath();
   trgSerial:=CUCopy.Serial;
  ELSIF IsRprS_w_OutCBlc() THEN
   CONFORM(OutCBlc, Math);
   trgFirm  :=OutCBlc.Firm;
   trgSerial:=OutCBlc.Serial;
   L_MSO.wordSetVarsByFile_wAlias("OutCBlc", Root);
   L_MSO.wordSetVarsByFile_wAlias("Math", Root + ".Math");
   RprSContractConditions:=GetRprSContractConditions(trgFirm, RprS.OrdDate);
  ELSIF IsRprS_w_Math() THEN
   trgFirm  :=L_MathR.GetFirmOfMath();
   trgSerial:=Math.Math;
  ELSE
   L_General.CallUs(0);
  END;

  L_MSO.wordSetVar(root + "RprS.ContractConditions", RprSContractConditions);
  L_MSO.wordSetVar(Root + ".Serial", trgSerial);
  L_MSO.wordSetVar(Root + ".Descr",  RprObjDescr);

  IF wFirmByRprS THEN
   E_GetServiceCenterContacts(D, root + "RprS.");
   P_Firm.SetFirmDefaultData(root + "RprS.Own", P_Firm.OWN_FIRM, D, "");
   P_Firm.SetFirmDefaultData(root + "RprS.",    trgFirm,         D, "");
  END;

  UploadClientSpares(D, root);

  Root:=root + "RprS.RprDA";
  i   :=0;
  SELECT(RprDA, RprDA, , RprS.RprS);
  WHILE OCCURE(RprDA) DO
   CONFORM(RprDA, CarBlock);
   CONFORM(RprDA, RprDfApr);
   L_MSO.wordSetVarsByFile_wAliasAndIndexE("RprDA",    Root, i, 0);
   L_MSO.wordSetVar(Root + "[" + L_Str.IntStr(i) + "].WhenBurn.AsStr", L_Str.PoolItem(GetWhenBurn_Pool(0), RprDA.WhenBurn));
   L_MSO.wordSetVarsByFile_wIndexedPrefixE("CarBlock", Root, i, ~OCCURE(CarBlock));
   L_MSO.wordSetVarsByFile_wIndexedPrefixE("RprDfApr", Root, i, 0);
   INC(i);
   NEXT(RprDA);
  END; (* WHILE OCCURE(RprDA) ... *)
  L_MSO.extSetWordTable("RprSRprDA", i, L_MSO.tt_Soft);

  UploadRprSRprP(rprpwho_DrvDeclarant,     D, root + "RprS.", "DrvDeclarant");
  UploadRprSRprP(rprpwho_RepairGroupChief, D, root + "RprS.", "RepairGroupChief");

  SAVE(RprT);
  IF HasRprTask(tk_Servicing1, EMPTYOF(RprT.Result)) | HasRprTask(tk_Servicing2, EMPTYOF(RprT.Result)) THEN
   L_MSO.wordSetVar(root + "RprS.Reason", L_Str.PoolItem(rpr_TaskKind_Pool, RprT.TaskKind));
  ELSE
   L_MSO.wordSetVar(root + "RprS.Reason", " N " + RprS.RprS + "  " + L_DatTim.DateStr(RprS.OrdDate));
  END;
  Root:=root + "RprS.RprT";
  SETEMPTY(RprTTaskKindAsStr);
  CONFORM(RprS, RprT);
  IF OCCURE(RprT) THEN
   RprTTaskKindAsStr:=L_Str.PoolItem(rpr_TaskKind_Pool, RprT.TaskKind);
  END;
  L_MSO.wordSetVar     (Root + L_MSO.IndexStr(0) + ".TaskKind",  RprTTaskKindAsStr);
  RESTORE(RprT);
 END {RprSFileFamily};

 PUBLIC PROCEDURE Create_RepEv();
 BEGIN
  L_AFM.MakeMultipleIndex("RepEv", "RepEvent: LIKE(RepEvent.RepEvent);" +
                                   "StartD  : DATE;" +
                                   "StopD   : DATE",
                          "RepEvent: RepEvent");
(*
  L_AFM.MakeMultipleIndex("RepEv", "RepEvent: LIKE(RepEvent.RepEvent);" +
                                   "RepEvDtl: LIKE(RepEvDtl.RepEvDtl);" +
                                   "StartD  : DATE;" +
                                   "StopD   : DATE",
                          "RepEvent: RepEvent, RepEvDtl");
*)
 END {Create_RepEv};

 PUBLIC PROCEDURE Add_RepEv(trgRepEvent: L_Car.tRepEvent; Level: NUMERIC[0]);
 BEGIN
  IF ~SELECT(RepEv, RepEvent, trgRepEvent) THEN
   RepEv.RepEvent:=trgRepEvent;
(*
   SETEMPTY(RepEv.RepEvDtl);
*)
   IF    Level = are_lev_RprDA THEN
    RepEv.StartD:=RprS.OrdDate;
    RepEv.StopD :=RprS.EDate;
   ELSIF Level = are_lev_RprT THEN
    RepEv.StartD:=RprT.BDate;
    RepEv.StopD :=RprT.EDate;
   ELSIF Level = are_lev_RprJ THEN
    RepEv.StartD:=RprJ.BDate;
    RepEv.StopD :=RprJ.EDate;
   ELSE
    L_General.CallUs(0);
   END;
   INSERT(RepEv);
  END;
 END {Add_RepEv};

 PUBLIC PROCEDURE E_GatherRequiredRepEvent(ByProceedRprS: SCAL[2]);
  VAR
   Local: PROC;
 BEGIN
  Local:=PROCREF(E_Rpr.GatherRequiredRepEvent);
  IF ~!Local THEN
   Local(ByProceedRprS);
  END;
 END {E_GatherRequiredRepEvent};

 PUBLIC PROCEDURE Clear_RepEv();
 BEGIN
  SELECT(RepEv, RepEvent);
  REMSEL(RepEv);
 END {Clear_RepEv};

 PUBLIC PROCEDURE Purge_RepEv();
 BEGIN
  L_AFM.AF_PurgeTemp("RepEv");
 END {Purge_RepEv};

 PUBLIC PROCEDURE extCheckExistsFinalMDoc(trgFirm: LIKE(Firm.Firm); wCanceledMDoc: SCAL[2]): SCAL[2];
  VAR
   i                 : NUMERIC[0];
   RprSDependentMDocs: STRING[];
   acptMDocKind,
   paidMDocKind      : LIKE(MDocKind.MDocKind);
 BEGIN
  acptMDocKind:=GetAcceptanceMDocKind();
  paidMDocKind:=GetMayBePaidMDocKind();
  IF ~!acptMDocKind | ~!paidMDocKind THEN
   RprSDependentMDocs:=L_XDoc.GetDependentXDC(L_XDoc.XDocId(L_XDoc.xdt_RprS, L_XDoc.EmptyXDocKind, RprS.RprS), L_XDoc.xdt_MDoc);
   i  :=0;
   WHILE L_XDoc.xdc_PositionOn(RprSDependentMDocs, i) DO
    PROMPT("஢ઠ  " + L_MDoc.MDocStr(MDoc.MDocKind, MDoc.MDoc));
    IF !trgFirm | (MDoc.Firm = trgFirm) THEN
     CONFORM(MDoc, MDocKind);
     IF (wCanceledMDoc | (MDoc.Status # L_MDoc.st_Canceled)) &
        ((MDocKind.MDocKind = paidMDocKind) | (MDocKind.MDocKind = acptMDocKind)) THEN
      RETURN 1;
     END; (* IF (MDoc.Status # L_MDoc.st_Canceled) &...*)
    END;
    INC(i);
   END; (* WHILE L_XDoc.xdc_PositionOn ... *)
  END;
  RETURN 0;
 END {extCheckExistsFinalMDoc};

 PUBLIC PROCEDURE CheckExistsFinalMDoc(): SCAL[2];
 BEGIN
  RETURN extCheckExistsFinalMDoc(EMPTYOF(Firm.Firm), 0);
 END {CheckExistsFinalMDoc};

 PRIVATE PROCEDURE Insert_MayBePaidMDocData(trgMath   : LIKE(Math.Math);
                                            trgMMode  : LIKE(MDocList.MMode);
                                            trgVATMode: LIKE(MDocList.VATMode);
                                            trgMUNbr  : LIKE(MDocList.MUNbr);
                                            trgQnt,
                                            trgSum,
                                            trgVAT    : NUMERIC[2]);
 BEGIN
  _MBPM.Math   :=trgMath;
  _MBPM.MMode  :=trgMMode;
  _MBPM.VATMode:=trgVATMode;
  _MBPM.MUNbr  :=trgMUNbr;
  _MBPM.Qnt    :=trgQnt;
  _MBPM.Sum    :=trgSum;
  _MBPM.VAT    :=trgVAT;
  INSERT(_MBPM);
 END {Insert_MayBePaidMDocData};

 PUBLIC PROCEDURE Purge_MBPM();
 BEGIN
  L_AFM.AF_PurgeTemp("_MBPM");
 END {Purge_MBPM};

 PUBLIC PROCEDURE E_GetRealPayer(trgDate: DATE; trgFirm: LIKE(Firm.Firm)): LIKE(Firm.Firm);
  VAR
   Local : PROC;
   Result: LIKE(Firm.Firm);
 BEGIN
  Local :=PROCREF(E_Rpr.GetRealPayer);
  Result:=trgFirm;
  IF ~!Local THEN
   Result:=Local(trgDate, trgFirm);
  END;
  RETURN Result;
 END {E_GetRealPayer};

 PUBLIC PROCEDURE PrepareMayBePaidMDocData(trgDate: DATE; wCheckMathMovement, ZeroSumAcceptable: SCAL[2]);
  VAR
   curQnt              : L_XObj.tQnt;
   curVAT,
   curSum,
   SingleVAT           : L_XObj.tSum;
   trgFirm             : LIKE(Firm.Firm);
   curMath,
   rprjMath            : LIKE(Math.Math);
   curMMode            : LIKE(MMode.MMode);
   HasMathMovement     : SCAL[2];
   SpecialAttitudeToVAT: P_Cntr.tSpecialAttitudeToVAT;
 BEGIN
  L_AFM.MakeMultipleIndex("_MBPM", "Math   : LIKE(Math.Math);" +
                                   "MMode  : LIKE(MDocList.MMode);" +
                                   "VATMode: LIKE(MDocList.VATMode);" +
                                   "MUNbr  : LIKE(MDocList.MUNbr);" +
                                   "Qnt    : NUMERIC[8,2];" +
                                   "Sum    : NUMERIC[8,2];" +
                                   "VAT    : NUMERIC[8,2];",
                          "_MBPM:Math");
  PrepareMathMovementByRprS(RprS.RprS);

  trgFirm:=E_GetRealPayer(trgDate, GetRprSFirm());
  IF ~!trgFirm THEN
   StandOnRprContract(trgFirm, trgDate);
   SpecialAttitudeToVAT:=P_Cntr.GetSpecialAttitudeToVAT(Contract.Contract, trgDate);
  ELSE
   SpecialAttitudeToVAT:=P_Cntr.satVAT_woFeatures;
  END;
  rprjMath:=E_GetRprJobMath(trgDate);
  L_General.Assert(~!rprjMath, " ।   ଫ   ६");
  SETZERO(curSum, curVAT);
  SELECT(RprJ, RprS, , RprS.RprS);
  WHILE OCCURE(RprJ) DO
   L_General.Assert(~!RprJ.Sum, " । ⮨  N " + RprJ.RprJ + ",  N " + RprJ.RprT);
   IF SpecialAttitudeToVAT = P_Cntr.satVAT_TaxFree THEN
    SingleVAT:=0;
   ELSE
    SingleVAT:=L_Acnt.GetInclMathVAT(rprjMath, trgDate, RprJ.Sum);
   END;
   INC(curVAT, SingleVAT);
   INC(curSum, RprJ.Sum - SingleVAT);
   NEXT(RprJ);
  END; (* WHILE OCCURE(RprJ) ... *)
  IF curSum = 0 THEN
   L_General.Assert(ZeroSumAcceptable, " । ⮨ ६");
  END;

  Insert_MayBePaidMDocData(rprjMath, L_MathR.mm_New, EMPTYOF(MDocList.VATMode), 000, 1, curSum, curVAT);

  IF SELECT(MathMvmnt, Math) THEN
   HasMathMovement:=0;
   WHILE OCCURE(MathMvmnt) DO
    NARROWSEL(MathMvmnt, Math);
    curMath :=MathMvmnt.Math;
    SETZERO(curQnt, curSum);
    WHILE OCCURE(MathMvmnt) DO
     NARROWSEL(MathMvmnt, MMode);
     WHILE OCCURE(MathMvmnt) DO
      IF MathMvmnt.Crd_WO # 0 THEN
       SEARCH(Storage, Storage, , MathMvmnt.Storage);
       INC(curQnt, MathMvmnt.Crd_WO);
       INC(curSum, L_MathR.GetANYMathPrice(MathMvmnt.Date, MathMvmnt.Math, Storage.MyFirm,
                                           L_MathR.MMode2PriceGrp(MathMvmnt.Date, MathMvmnt.Math, MathMvmnt.MMode)) * MathMvmnt.Crd_WO);
      END;
      NEXT(MathMvmnt);
     END; (* WHILE OCCURE(MathMvmnt) ... *)
     NEXTINEXTENDEDSEL(MathMvmnt, MMode);
    END; (* WHILE OCCURE(MathMvmnt) ... *)

    L_General.CallUs(curQnt >= 0);
    IF curQnt > 0 THEN
     IF SpecialAttitudeToVAT = P_Cntr.satVAT_TaxFree THEN
      curVAT:=0;
     ELSE
      curVAT:=L_Acnt.GetExclMathVAT(curMath, trgDate, curSum);
     END;
 
     Insert_MayBePaidMDocData(curMath, L_MathR.mm_UsedMaterial_wPublishedPrice, EMPTYOF(MDocList.VATMode), 000, curQnt, curSum, curVAT);
     HasMathMovement:=1;
    END; (* IF curQnt > 0...*)
    NEXTINEXTENDEDSEL(MathMvmnt, Math);
   END; (* WHILE OCCURE(MathMvmnt) ... *)
 
   IF wCheckMathMovement & ~HasMathMovement THEN
    L_StdFrm.Choice(" ६  䨪஢ ᯨᠭ |" +
                    " ଠ쭠 , ᫨  뫮 ᪠   ६,|" +
                    " ⨢ 砥 室 믮 楤 ᯨᠭ|" +
                    "।  ६ ");
   END;
  END;
 END {PrepareMayBePaidMDocData};

 PUBLIC PROCEDURE GetDefaultViewRprSScopeMode(VAR RprSLocationView: SCAL[2][]);
  VAR
   ViewRprSScopeMode,
   SingleRprSLocation: STRING[];
   i                 : NUMERIC[0];
 BEGIN
  SETZERO(RprSLocationView);
  IF L_SES.GetValue(L_SES.sit_User, "ViewRprSScopeMode", ViewRprSScopeMode) THEN
   i:=0;
   LOOP
    SingleRprSLocation:=Str.Item(ViewRprSScopeMode, ";", i);
    IF ~!SingleRprSLocation THEN
     RprSLocationView[STRTOFLD(Str.Item(SingleRprSLocation, ":", 0), NUMERIC)]:=Str.Item(SingleRprSLocation, ":", 1);
    ELSE
     EXIT;
    END;
    INC(i);
   END; (* LOOP *)
  ELSE
   i:=0;
   WHILE i < rprl_Amount DO
    IF E_AllowedRprSLocation(i) THEN
     IF IsMainRpr() | L_General.IsMemberOf(GetRprSGroupName(i)) THEN
      RprSLocationView[i]:=1;
     END;
    END;
    INC(i);
   END; (* WHILE i < rprl_Amount...*)
  END;
 END {GetDefaultViewRprSScopeMode};

 PUBLIC PROCEDURE CheckRprSMathRest(_Status: tMirrorStatus);
  VAR
   i,
   FormResult: NUMERIC[0];
   curMath   : LIKE(Math.Math);
   curMMode  : LIKE(MMode.MMode);
   trgQnt,
   trgInRpr,
   totFrRpr,
   totCrd_WO : L_XObj.tQnt;
   trgFrRpr  : L_XObj.tQnt[1E2];
   hasCrdRst : SCAL[2];
   Caption,
   DocList,
   SingleDoc,
   XDocIdList: STRING[];
 BEGIN
  PrepareMathMovementByRprS(RprS.RprS);
  IF SELECT(MathMvmnt, Storage) THEN
   SETZERO(totCrd_WO);
   WHILE OCCURE(MathMvmnt) DO
    NARROWSEL(MathMvmnt, Storage);
    IF P_Storage.IsRepair(MathMvmnt.Storage, RprS.OrdDate) THEN
     WHILE OCCURE(MathMvmnt) DO
      NARROWSEL(MathMvmnt, Math);
      curMath  :=MathMvmnt.Math;
      SETZERO(trgInRpr, trgFrRpr);
      WHILE OCCURE(MathMvmnt) DO
       NARROWSEL(MathMvmnt, MMode);
       curMMode :=MathMvmnt.MMode;
       CheckSingleMathMovement(trgInRpr, trgFrRpr, totCrd_WO, trgQnt, hasCrdRst, DocList, XDocIdList);
       IF    trgQnt # 0 THEN
        L_General.Error(" ⨨        ᯨᠭ ' '");
       ELSIF hasCrdRst THEN
        L_XDoc.sl_Init("ୠ  / 冷 ᫥  祭  .  " + curMath + ", ० '" + L_MathR.MModeStr(curMMode) + "'");
        Caption:="㬥                             줮                                 ";
        i:=0;
        LOOP
         SingleDoc:=L_Str.PoolItem(DocList, i);
         IF !SingleDoc THEN
          EXIT;
         END;
         L_XDoc.sl_AddItem(L_Str.PoolItem(XDocIdList, i), SingleDoc);
         INC(i);
        END; (* LOOP *)
        FormResult:=L_XDoc.sl_extShow("", Caption);
        IF FormResult = 1 THEN
         L_XDoc.PositionInVideoSystem(L_XDoc.pm_StandOnly, L_XDoc.pvs_XDocId, "");
        END;
       END;
       NEXTINEXTENDEDSEL(MathMvmnt, MMode);
      END; (* WHILE OCCURE(MathMvmnt) ... *)
      IF _Status = ms_Done THEN
       totFrRpr:=GetTotalFrRpr(trgFrRpr);
       IF    trgInRpr < trgFrRpr[L_MathR.mm_Restored] THEN
        L_General.Error(" " + curMath + ":   "+RprS.RprS+" ६஢ , 祬 뫮 ।  ६");
       ELSIF totFrRpr < trgInRpr THEN
        L_General.Error(" " + curMath + ":   "+RprS.RprS+"  饭   ।  ६ ");
       END;
      END;
      NEXTINEXTENDEDSEL(MathMvmnt, Math);
     END; (* WHILE OCCURE(MathMvmnt) ... *)
    END; (* IF P_Storage.IsRepair(MathMvmnt.Storage, RprS.OrdDate)...*)
    NEXTINEXTENDEDSEL(MathMvmnt, Storage);
   END; (* WHILE OCCURE(MathMvmnt) ... *)
   IF (totCrd_WO # 0) & IsRprS_w_OutCar() THEN
    L_General.Assert(CheckExistsFinalMDoc(), "   뤠祩   ନ஢ ");
   END;
  END; (* IF SELECT(MathMvmnt, Storage)...*)
 END {CheckRprSMathRest};

 PUBLIC PROCEDURE CurRprSXDocJrnMark(_Action: LIKE(XDocJrn.Action));
 BEGIN
  L_XDoc.XDocJrn_Mark(L_XDoc.xdt_RprS, L_XDoc.EmptyXDocKind, RprS.RprS, _Action);
 END {CurRprSXDocJrnMark};

(*   *)
 PRIVATE VAR
  RprSPrt: PRINTJOB;

 PUBLIC PROCEDURE intTypeS(X, Y: NUMERIC[1]; S: STRING[]; P: TEXT_STYLE; CP: NUMERIC[0]);
 BEGIN
  L_Print.extTypeS(RprSPrt, X, Y, S, P, CP);
 END {intTypeS};

 PUBLIC PROCEDURE TypeS(X, Y: NUMERIC[1]; S: STRING[]; P: TEXT_STYLE);
 BEGIN
  intTypeS(X, Y, S, P, L_Print.cp_OEM_Russian);
 END {TypeS};

 PRIVATE PROCEDURE GetCharsAmountInLine(PtXX: TEXT_STYLE): NUMERIC[0];
  CONST
   LineLengthInMillimeters = 185 + 10 (* 10   直 譮*);
  VAR
   S     : STRING[];
   A, B  : FLOAT;
   Result: NUMERIC[0];
 BEGIN
  SETEMPTY(S);
  SETZERO(Result, A, B);
  LOOP
   RprSPrt.TextExtent(A, B, , , S, PtXX, L_Print.cp_OEM_Russian);
   IF (A+B) >= LineLengthInMillimeters THEN
    EXIT;
   END;
   INC(S, "a");
   INC(Result);
  END; (* LOOP *)
  RETURN Result;
 END {GetCharsAmountInLine};

 PRIVATE PROCEDURE IsAcceptableFontForRprDALine(    RprDA_Arr    : STRING[][];
                                                    PtXX         : TEXT_STYLE;
                                                VAR MaxLineAmount: NUMERIC[0];
                                                VAR Lines_Arr    : STRING[][]): SCAL[2];
  VAR
   i, j,
   Length,
   Result      : NUMERIC[0];
   Shift       : STRING[];
   tmpLines_Arr: STRING[][100];
 BEGIN
  Length:=GetCharsAmountInLine(PtXX);
  SETZERO(i, Result);
  WHILE ~!RprDA_Arr[i] DO
   Str.Format(tmpLines_Arr, RprDA_Arr[i], Length, LEFT);
   SETZERO(j);
   Shift:="";
   WHILE ~!tmpLines_Arr[j] DO
    IF j # 0 THEN
     Shift:="    ";
    END;

    Lines_Arr[Result]:=Shift + tmpLines_Arr[j];
    INC(j);
    INC(Result);
   END; (* WHILE ~!RprDA_Arr[i] *)
   INC(i);
  END; (* WHILE ~!RprDA_Arr[i] *)

  RETURN Result <= MaxLineAmount;
 END {IsAcceptableFontForRprDALine};

 PRIVATE PROCEDURE ChooseAcceptableFontForRprDALine(    RprDA_Arr        : STRING[][];
                                                        FontSizes_Arr    : NUMERIC[0][];
                                                        MaxLineAmount_Arr: NUMERIC[0][];
                                                        Y_Arr            : NUMERIC[2][];
                                                        Shifts_Arr       : NUMERIC[2][];
                                                    VAR Lines_Arr        : STRING[][];
                                                    VAR PtXX             : TEXT_STYLE;
                                                    VAR Y                : NUMERIC[2];
                                                    VAR Shift            : NUMERIC[2]);
  VAR
   i: NUMERIC[0];
 BEGIN
  i:=0;
  LOOP
   L_General.CallUs(~!FontSizes_Arr[i]);
   PtXX :=L_Print.ts_Create(FontSizes_Arr[i], "Tahoma");
   Shift:=Shifts_Arr[i];
   Y    :=Y_Arr[i];
   SETEMPTY(Lines_Arr);
   IF IsAcceptableFontForRprDALine(RprDA_Arr, PtXX, MaxLineAmount_Arr[i], Lines_Arr) THEN
    EXIT;
   END;
   INC(i);
  END; (* LOOP *)
 END {ChooseAcceptableFontForRprDALine};

 PRIVATE PROCEDURE gdi_PrintRprDA();
  VAR
   i             : NUMERIC[0];
   Y, Shift      : NUMERIC[2];
   PtXX          : TEXT_STYLE;
   Lines_Arr,
   RprDA_Arr     : STRING[][100];
   RprDfAprName  : STRING[];
 BEGIN
  SETEMPTY(RprDA_Arr);
  SETZERO(i);
  SELECT(RprDA, RprDA, , RprS.RprS);
  WHILE OCCURE(RprDA) DO
   IF RprDA.Fixed = daf_ThereIs THEN
    CONFORM(RprDA, RprDfApr);
    CONFORM(RprDfApr, CarBlock);
    RprDfAprName:=RprDA.RprDA + " " + CarBlock.Name + ": " + RprDfApr.Name;
    IF ~!RprDA.Comment THEN
     RprDfAprName:=RprDfAprName + " (" + RprDA.Comment + ")";
    END;
    RprDfAprName:=RprDfAprName + " [" + RprDA.RprDfApr + "]";
    IF RprDfApr.Leaf = 0 THEN
     RprDfAprName:=RprDfAprName + " (ॡ 筥)";
    END;
    RprDA_Arr[i]:=RprDfAprName;
    INC(i);
   END;
   NEXT(RprDA);
  END; (* WHILE OCCURE(RprDA) ... *)

  ChooseAcceptableFontForRprDALine(RprDA_Arr,
                                   [14, 11,  8,    7],
                                   [09, 13, 15,   99],
                                   [38, 37, 37,   35.5],
                                   [6,   4,  3.5,  2.5],
                                   Lines_Arr, PtXX, Y, Shift);
  i:=0;
  LOOP
   IF !Lines_Arr[i] THEN
    EXIT;
   END;
   TypeS(009, Y, Lines_Arr[i], PtXX);
   INC(Y, Shift);

   INC(i);
  END;
 END {gdi_PrintRprDA};

 PRIVATE PROCEDURE gdi_PrintNote(    Text: STRING[];
                                 VAR Y   : NUMERIC[0];
                                     Pt09: TEXT_STYLE);
 BEGIN
  TypeS(009, Y, Text, Pt09);
  INC(Y, 4);
 END {gdi_PrintNote};

 PUBLIC PROCEDURE gdi_GetBegRepairDTS(): TIMESTAMP;
  VAR
   Result: TIMESTAMP;
 BEGIN
  SELECT(XDocJrn, XDocJrn, , L_XDoc.xdt_RprS, L_XDoc.EmptyXDocKind, RprS.RprS);
  WHILE OCCURE(XDocJrn) & (XDocJrn.Action # L_XDoc.action_rprTransfer) DO
   NEXT(XDocJrn);
  END; (* WHILE OCCURE(XDocJrn) ... *)

  IF OCCURE(XDocJrn) THEN
   Result:=L_DatTim.GetTIMESTAMP(XDocJrn.Date, XDocJrn.BegTime);
  ELSE
   Result:=L_DatTim.GetSysTIMESTAMP();
  END;
  RETURN Result;
 END {gdi_GetBegRepairDTS};

 PRIVATE PROCEDURE E_GetPrintRprSParam(VAR PaperForm    : STRING[];
                                       VAR Orientation  : L_Print.tOrientation;
                                       VAR PrintRearSide: SCAL[2];
                                       VAR UseDuplexMode: SCAL[2]);
  VAR
   Local: PROC;
 BEGIN
  IF    L_General.IsOurSite() THEN
   PaperForm  :=L_Print.pf_A5onA4;
   Orientation:=L_Print.o_Portrait;
  ELSE
   PaperForm  :=L_Print.pf_A5;
   Orientation:=L_Print.o_Landscape;
  END;
  UseDuplexMode:=0;
  PrintRearSide:=0;

  Local:=PROCREF(E_Rpr.GetPrintRprSParam);
  IF ~!Local THEN
   Local(PaperForm, Orientation, PrintRearSide, UseDuplexMode);
  END;
 END {E_GetPrintRprSParam};

 PRIVATE PROCEDURE gdi_Print(PrintRprS: SCAL[2]);
  VAR
   Local        : PROC;
   Y            : NUMERIC[0];
   Pt06,
   Pt08,
   Pt09,
   Pt12,
   Pt14,
   Pt16,
   PtTitle,
   PtTitleB,
   Pt10BarCode  : TEXT_STYLE;
   Text,
   Value,
   PaperForm,
   BlankName_F,
   BlankName_B  : STRING[];
   Orientation  : L_Print.tOrientation;
   picWidth,
   picHeight    : FLOAT;
   PrintRearSide,
   UseDuplexMode: SCAL[2];
 BEGIN
  AccessOrigin();

  E_GetPrintRprSParam(PaperForm, Orientation, PrintRearSide, UseDuplexMode);

  RprSPrt:=L_Print.CreatePrintJob(L_Print.pt_BlankAndDoc, "  "+RprS.RprS+" "+RprS.CopyCnt, PaperForm, Orientation);

  RprSPrt.StartPage();

  PtTitle :=L_Print.ts_Create(08, "Times New Roman");
  PtTitleB:=L_Print.ts_Create(08, "Times New Roman");
  PtTitleB.Font.Weight:=FONT.Weight_Bold;

  Pt06    :=L_Print.ts_Create(06, "Times New Roman");
  Pt08    :=L_Print.ts_Create(08, "Tahoma");
  Pt09    :=L_Print.ts_Resize(Pt08, 09);
  Pt12    :=L_Print.ts_Resize(Pt08, 12);
  Pt14    :=L_Print.ts_Resize(Pt08, 14);
  Pt16    :=L_Print.ts_Resize(Pt08, 16);

  Pt10BarCode             :=L_Print.ts_Create(10, "IDAutomation.com Code39");
  Pt10BarCode.Font.Charset:=FONT.Charset_ANSI;

  IF PrintRprS THEN BlankName_F:="RprS_F";
  ELSE              BlankName_F:="RprT_F";
  END;
  L_Print.extPrintBlankBackground(RprSPrt, PaperForm, FIO.BuildPath(BlankName_F, "EMF"));

  TypeS(008, 010, L_OwnData.ODFirmName(SYSDATE()), Pt06);
  TypeS(141, 010, Str.Align(L_DatTim.CompleteSystimeStr() + " / " + L_Str.ShortName(P_Man.GetFullNameOfCurrentUser(RprS.OrdDate)), 70, RIGHT), Pt06);

  intTypeS(149, 023, BarFullCode(), Pt10BarCode, L_Print.cp_ISO_8859_1_Latin_I);

  IF PrintRprS THEN
   TypeS(052, 015.5, RprS.RprS, Pt16);
   TypeS(075, 015, " (" + RprS.CopyCnt + ")", Pt09);
   TypeS(088, 015.5, L_DatTim.DateStr(RprS.OrdDate), Pt16);
   TypeS(118, 015.5, L_DatTim.TimeStr(RprS.OrdTime), Pt12);

   TypeS(030, 099, L_DatTim.TimestampStr(gdi_GetBegRepairDTS()), Pt12);

   IF E_RemainsIndication_Required(RprS.OrdDate) & E_SpeedometerIndication_Required(RprS.OrdDate) THEN
    TypeS(139, 097, "⮪  ", Pt08);
    TypeS(160, 097, L_Str.IntStr(RprS.RemExit), Pt12);
    TypeS(139, 107, "⮪  ", Pt08);

    TypeS(139, 101, "", Pt08);
    TypeS(160, 101, L_Str.IntStr(RprS.SMBef), Pt12);
    TypeS(139, 111, "", Pt08);
   ELSE
    IF    E_RemainsIndication_Required(RprS.OrdDate)  THEN
     Text :="⮪  ";
     Value:=L_Str.IntStr(RprS.RemExit);
    ELSIF E_SpeedometerIndication_Required(RprS.OrdDate) THEN
     Text:="";
     Value:=L_Str.IntStr(RprS.SMBef);
    ELSE
     SETEMPTY(Text);
    END;
    IF ~!Text THEN
     TypeS(139, 099, Text,  Pt08);
     TypeS(160, 099, Value, Pt14);
     TypeS(139, 109, Text,  Pt08);
    END;
   END;
   IF ~PrintRearSide | UseDuplexMode THEN
    TypeS(165, 138.5, "⮢ ⮏ () Polak IT, 2014", Pt06);
   END;
  ELSE
   L_General.CallUs(0);
   TypeS(052, 014, RprT.RprT, Pt16);
   TypeS(075, 013.5, " (" + RprT.CopyCnt + ")", Pt09);

   TypeS(052, 014, RprS.RprS, Pt12);
   TypeS(088, 014, L_DatTim.DateStr(RprS.OrdDate), Pt12);
   TypeS(118, 014, L_DatTim.TimeStr(RprS.OrdTime), Pt09);
  END;

  TypeS(009, 020, L_Str.PoolItem(rot_Pool, RprS.RprObjT), PtTitleB);

  TypeS(010, 026.5, RprS.RprObjId + "    " + GetRprSObjDescr(), Pt12);

  gdi_PrintRprDA();

  Y:=120;
  IF IsFailureOutput() THEN
   gdi_PrintNote("! ! !   ᪠: " + RprPro.Value, Y, Pt09);
  END;
  IF SELECT(RprP, RprJ, RprS.RprS, v_EmptyIndexValue, v_EmptyIndexValue, rprpwho_DrvDeclarant) |
     SELECT(RprP, RprJ, RprS.RprS, v_EmptyIndexValue, v_EmptyIndexValue, rprpwho_AnyDeclarant) THEN
   CONFORM(RprP, Staff);
   CONFORM(Staff, Man);
   gdi_PrintNote(L_Str.PoolItem(rprpwho_Pool, RprP.Who) + " " + RprP.TSN + " " + L_Str.ShortName(Man.Name), Y, Pt09);
  END;

  IF PrintRprS THEN
   IF P_Rpr.HasRprSPro(RprS.RprS, P_Rpr.P_AdditionalInfo) THEN
    gdi_PrintNote(RprPro.Value, Y, Pt09);
   END;
   IF P_Rpr.HasRprSPro(RprS.RprS, P_Rpr.P_ShortRprSDescr) THEN
    gdi_PrintNote(RprPro.Value, Y, Pt09);
   END;
  END;

  Local:=PROCREF(E_Rpr.fs_PrintRprSClientPart);
  IF ~!Local THEN
   Local();
  END;

  IF PrintRearSide THEN
   BlankName_B:=FIO.BuildPath("RprS_B", "EMF");
   IF    UseDuplexMode THEN
    L_Print.SetDuplexMode(RprSPrt, L_Print.dm_Vertical);
    RprSPrt.EndPage();
    RprSPrt.StartPage();
    L_Print.extPrintBlankBackground(RprSPrt, PaperForm, BlankName_B);
   ELSIF PaperForm = L_Print.pf_A5onA4 THEN
    L_Print.GetDefaultBlankBackgroundSize(RprSPrt, PaperForm, picWidth, picHeight);
    L_Print.PrintPicture(RprSPrt, 0, 148.5, picWidth, picHeight, L_FIO.rf_GetFullFileName(BlankName_B));
   ELSE
    L_General.CallUs(0);
   END;
  END;

  RprSPrt.EndPage();
  RprSPrt.Close();
 END {gdi_Print};

 PRIVATE PROCEDURE PrintAnyRprS();
 BEGIN
  gdi_Print(1);
 END {PrintAnyRprS};

 PUBLIC PROCEDURE PrintCarRprS();
 BEGIN
  PrintAnyRprS();
 END {PrintCarRprS};

 PUBLIC PROCEDURE PrintOutCarRprS();
 BEGIN
  PrintAnyRprS();
 END {PrintOutCarRprS};

 PUBLIC PROCEDURE PrintCarBlockRprS();
 BEGIN
  PrintAnyRprS();
 END {PrintCarBlockRprS};

 PUBLIC PROCEDURE PrintOutCBlcRprS();
 BEGIN
  PrintAnyRprS();
 END {PrintOutCBlcRprS};

 PUBLIC PROCEDURE PrintMathRprS();
 BEGIN
  PrintAnyRprS();
 END {PrintMathRprS};

 PUBLIC PROCEDURE E_PrintRprS();
  VAR
   Local,
   System: PROC;
 BEGIN
  AccessRprS();
  IF L_StdFrm.Alternative("  " + RprS.RprS + "?") THEN
   INC(RprS.CopyCnt);
   REPLACE(RprS);
   CurRprSXDocJrnMark(L_XDoc.action_Reprint);

   IF    IsRprS_w_Car() THEN
    System:=PROCREF(PrintCarRprS);
    Local :=PROCREF(E_Rpr.PrintCarRprS);
   ELSIF IsRprS_w_OutCar() THEN
    System:=PROCREF(PrintOutCarRprS);
    Local :=PROCREF(E_Rpr.PrintOutCarRprS);
   ELSIF IsRprS_w_CarBlock() THEN
    System:=PROCREF(PrintCarBlockRprS);
    Local :=PROCREF(E_Rpr.PrintCarBlockRprS);
   ELSIF IsRprS_w_OutCBlc() THEN
    System:=PROCREF(PrintOutCBlcRprS);
    Local :=PROCREF(E_Rpr.PrintOutCBlcRprS);
   ELSIF IsRprS_w_Math() THEN
    System:=PROCREF(PrintMathRprS);
    Local :=PROCREF(E_Rpr.PrintMathRprS);
   ELSE
    L_General.CallUs(0);
   END;

   IF ~!Local THEN
    Local();
   ELSE
    System();
   END;
  END;
 END {E_PrintRprS};
(*   *)

 PRIVATE CONST
  PrintBoldFont = "B";

  AddRprDfAprLineLength = 78;
  AddRprJobLineLength   = 78;

(*
$P{ FailureOutPut:
RprPro.Value, C, ""
@
              ! ! !#########################################! ! !
}
*)

(*
$P{ CommonTop:
L_OwnData.ODFirmName(SYSDATE()), L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
@
############################################################### ########## #####
--------------------------------------------------------------------------------
}
*)

(*
$P{ Top_RprSP:
RprS.RprS, L, ""                  PrintBoldFont
RprS.CopyCnt, L, ""               PrintBoldFont
RprS.OrdDate, L, "D.N.y"          PrintBoldFont
RprS.OrdTime, L, "H:M"            PrintBoldFont
@
 N ####### (##) ########## #####

}
*)

(*
$P{ Top_RprTP:
RprS.RprS, L, ""                          PrintBoldFont
RprS.CopyCnt, L, ""                       PrintBoldFont
RprT.RprT, L, ""                          PrintBoldFont
RprT.CopyCnt, L, ""                       PrintBoldFont
RprT.TaskKind, L, rpr_TaskKind_Pool       PrintBoldFont
RprT.BDate, L, "D.N.Y"                    PrintBoldFont
RprT.BTime, L, "H:M"                      PrintBoldFont
L_Str.ShortName(P_Man.GetFullNameOfCurrentUser(RprS.OrdDate)), R, "" PrintBoldFont
GetRprTPlanETimes_AsStr(), L, ""          PrintBoldFont
@
 ####### (##)  ## (##) ############# 뤠 ######## ##### ###############
ப ᯮ ################                               _________________

}
*)

(*
$P{ Top_Car:
Mark.Mark, L, ""         PrintBoldFont
Mark.Name, L, ""         PrintBoldFont
Car.BoxNbr, L, ""        PrintBoldFont
CarLog.StateNbr, L, ""   PrintBoldFont
@
ઠ #### ################################      . ####  . ##########
}
*)

(*
$P{ Top_OutCar:
Mark.Mark, L, ""         PrintBoldFont
Mark.Name, L, ""         PrintBoldFont
OutCar.StateNbr, L, ""   PrintBoldFont
Firm.Firm, L, ""         PrintBoldFont
Firm.Name, L, ""         PrintBoldFont
@
ઠ    #### ################################              . ##########

 #### ##################################################################
}
*)

(*
$P{ Top_CarBlock:
Math.Math, L, ""         PrintBoldFont
Math.Name, L, ""         PrintBoldFont
CUCopy.CUCopy, L, ""     PrintBoldFont
CUCopy.Serial, L, ""     PrintBoldFont
@
ॣ         ##### ##########################################################
       #######
᪮  ################################################
}
*)

(*
$P{ Top_OutCBlc:
Math.Math, L, ""         PrintBoldFont
Math.Name, L, ""         PrintBoldFont
OutCBlc.OutCBlc, L, ""   PrintBoldFont
OutCBlc.Serial, L, ""    PrintBoldFont
Firm.Firm, L, ""         PrintBoldFont
Firm.Name, L, ""         PrintBoldFont
@
ॣ         ##### ##########################################################
.        #######
᪮  ################################################
        #### ###########################################################
}
*)

(*
$P{ Top_Math:
Math.Math, L, ""         PrintBoldFont
Math.Name, L, ""         PrintBoldFont
@
ॣ         ##### ##########################################################
}
*)

(*
$P{ SubTop_RprT1:
RprT.Sort, L, ""                          PrintBoldFont
?, L, ""                                  PrintBoldFont
RprT.RprPlace, L, ""                      PrintBoldFont
?, L, ""                                  PrintBoldFont
@

             ##   ################################
      #### ################################
}
*)

(*
$P{ SubTop_RprT2:
?, L, ""
?, L, ""                                  PrintBoldFont
?, L, ""                                  PrintBoldFont
@
################## #############################################################
⮯     #############################################################
}
*)

(*
$P{ SingleLine:
?, L, ""
@

################################################################################

}
*)

(*
$P{ Line_RprDA:
RprDfApr.Leaf, L, "!| "
?, L, ""
@
# ##############################################################################
}
*)

(*
$P{ AddRprDfAprLine:
?, L, ""
@
                                  ##############################################
}
*)

(*
$P{ Line_RprJob:
RprJob.Leaf, L, "!| "
?, L, ""
@
# ##############################################################################
}
*)

(*
$P{ AddRprJobLine:
?, L, ""
@
                                             ###################################
}
*)

PRIVATE PROCEDURE E_GetGateSign(): STRING[];
BEGIN
 IF L_General.GetAPSiteNumber() = 84 THEN
  RETURN "";
 ELSE
  RETURN "堭";
 END;
END {E_GetGateSign};

PRIVATE PROCEDURE E_GetRepairZoneSign(): STRING[];
BEGIN
 IF L_General.GetAPSiteNumber() = 84 THEN
  RETURN "";
 ELSE
  RETURN "";
 END;
END {E_GetRepairZoneSign};

(*
$P{ Bot_AnyCar:
E_GetGateSign(), C, ""
E_GetRepairZoneSign(), C, ""
?, L, "D.N.y H:M"
RprS.RemExit, R, "0"
@

। 

--------------------------------------------------------------------------------
|          |   ६   |⮪ |                                  |
|          |                |   |####################|####################|
|----------|----------------|--------|--------------------|--------------------|
| ६  |################|########|                    |                    |
|----------|----------------|--------|--------------------|--------------------|
| ६|                |        |                    |                    |
--------------------------------------------------------------------------------
}
*)

(*
$P{ Bot_AnyCarBlock:
?, L, "D.N.y H:M"
@

। ॣ

--------------------------------------------------------------------------------
|          |   ६   |                                           |
|          |                |          堭       |                   |
|----------|----------------|------------------------|-------------------------|
| ६  |################|                        |                         |
|----------|----------------|------------------------|-------------------------|
| ६|                |                        |                         |
--------------------------------------------------------------------------------
}
*)

(*
$P{ Bot_RprTP:
?, C, ""
?, C, ""
@

  ६ 믮 : ______________________  _______

                                         ________________      ________________
                                         ################      ################}
*)

(*
$P{ rjfs_Top:
L_OwnData.ODFirmName(SYSDATE()), L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
RprT.RprT, L, ""
RprT.TaskKind, L, rpr_TaskKind_Pool
RprS.RprS, L, ""
RprS.CopyCnt, L, ""
RprS.OrdDate, L, "D.N.y"
RprS.OrdTime, L, "H:M"
@
############################################################################################# ########## #####
==============================================================================================================
|                                                                         |
|                                                                                                            |
|⭮  ## #############   N ####### (##) ########## #####                           |
|------------------------------------------------------------------------------------------------------------|
|                                                   |    믮 ࠡ   |                        |       |
|                                             |-----------------------|ᯮ⥫             ||
|                                                   |砫     |砭  |                        |       |
}
*)

(*
$P{ rjfs_Dlm:
@
|---------------------------------------------------|-----------|-----------|------------------------|-------|
}
*)

(*
$P{ rjfs_Line:
?, L, ""
@
|###################################################|           |           |                        |       |
}
*)

(*
$P{ rjfs_Bot:
@
=(c) Polak====================================================================================================
}
*)

 PRIVATE PROCEDURE rjfs_PrintLine(Prefix: STRING[]);
  VAR
   i     : NUMERIC[0];
   StrArr: STRING[][10];
 BEGIN
  Str.Format(StrArr, RprJob.Name + " [" + RprJob.RprJob + "]", 51-Str.Length(Prefix), LEFT);
  MAKEPART(R, rjfs_Dlm);
  i:=0;
  WHILE (i <= HIGH(StrArr)) & ~!StrArr[i] DO
   MAKEPART(R, rjfs_Line, Prefix+StrArr[i]);
   INC(i);
  END; (* WHILE (i <= HIGH(StrArr)) &...*)
  IF i = 1 THEN
   MAKEPART(R, rjfs_Line, "");
  END;
 END {rjfs_PrintLine};

 PRIVATE PROCEDURE rjdl_GatherSingleRprJob(    trgRprJobDt: LIKE(RprJob.RprJobDt);
                                               trgRprJob  : LIKE(RprJob.RprJob);
                                           VAR curNbr     : NUMERIC[0]);
 BEGIN
  SAVE(RprJobDt);
  SELECT(RprJobDt, Nbr, , trgRprJob);
  WHILE OCCURE(RprJobDt) DO
   SEARCH(RprJob, RprJob, , RprJobDt.RprJob2);
   IF RprJob.RprJobDt = trgRprJobDt THEN
    rjdl_GatherSingleRprJob(trgRprJobDt, RprJob.RprJob, curNbr);
   ELSE
    tsjl.Nbr   :=curNbr;
    tsjl.RprJob:=RprJob.RprJob;
    INSERT(tsjl);
    INC(curNbr);
   END;
   NEXT(RprJobDt);
  END; (* WHILE OCCURE(RprJobDt) ... *)
  RESTORE(RprJobDt);
 END {rjdl_GatherSingleRprJob};

 PRIVATE PROCEDURE rjdl_Put(VAR RprJobList  : STRING[];
                            VAR RprJobDtList: STRING[]);
 BEGIN
  RprJobDtList:=RprJobDtList + Str.Slice(RprJob.Name, 0, 70) + " [" + RprJob.RprJob + "]|";
  RprJobList  :=RprJobList + RprJob.RprJob + "|";
 END {rjdl_Put};

 PUBLIC PROCEDURE rjdl_Prepare(    curRprT     : LIKE(RprT.RprT);
                                   trgRprJobDt : LIKE(RprJob.RprJobDt);
                               VAR RprJobList  : STRING[];
                               VAR RprJobDtList: STRING[]);
 BEGIN
  SETEMPTY(RprJobDtList, RprJobList);
  IF ~!curRprT THEN
   SELECT(RprJ, RprS, , RprS.RprS, curRprT);
   WHILE OCCURE(RprJ) DO
    CONFORM(RprJ, RprJob);
    IF RprJob.RprJobDt = trgRprJobDt THEN
     rjdl_Put(RprJobList, RprJobDtList);
    END;
    NEXT(RprJ);
   END; (* WHILE OCCURE(RprJ) ... *)
  ELSE
   SELECT(RprJob, RprJobDt, , trgRprJobDt);
   WHILE OCCURE(RprJob) DO
    rjdl_Put(RprJobList, RprJobDtList);
    NEXT(RprJob);
   END; (* WHILE OCCURE(RprJob) ... *)
  END
 END {rjdl_Prepare};

 PUBLIC PROCEDURE rjdl_Gather(trgRprJobDt: LIKE(RprJob.RprJobDt);
                              trgRprJob  : LIKE(RprJob.RprJob));
  VAR
   curNbr: NUMERIC[0];
 BEGIN
  IF !DATABASE.Get().Tables("tsjl") THEN
   L_AFM.MakeMultipleIndex("tsjl",  "Nbr   : NUMERIC[0];"+
                                    "RprJob: LIKE(RprJob.RprJob)",
                           "Nbr:Nbr,RprJob;RprJob:RprJob,Nbr");
  END;
  curNbr:=1;
  rjdl_GatherSingleRprJob(trgRprJobDt, trgRprJob, curNbr);
 END {rjdl_Gather};

 PRIVATE PROCEDURE TypeFlowSheet(Silent: SCAL[2]);
  VAR
   i                  : NUMERIC[0];
   trgRprJobFlowSheet : LIKE(RprJob.RprJob);
   RprJobList,
   RprJobFlowSheetList: STRING[];
 BEGIN
  rjdl_Prepare(RprT.RprT, rjd_FlowSheet, RprJobList, RprJobFlowSheetList);
  IF ~!RprJobFlowSheetList THEN
   OPENREP(R, L_General.NameConnection("tsjl"), Print, PaperForm,    A4,
                                                       Orientation,  Portrait,
                                                       CharsPerLine, 110,
                                                       TopMargin,    10,            (* ࠢ *)
                                                       BottomMargin, 10,            (*   *)
                                                       LeftMargin,   10,            (* 孥*)
                                                       RightMargin,  10);           (*  *)
   MAKEPART(R, rjfs_Top);
   i:=0;
   LOOP
    trgRprJobFlowSheet:=L_Str.AnyItem(RprJobList, "|", i);
    IF !trgRprJobFlowSheet THEN
     EXIT;
    END;
    rjdl_Gather(rjd_FlowSheet, trgRprJobFlowSheet);

    SEARCH(RprJob, RprJob, , trgRprJobFlowSheet);
    rjfs_PrintLine("");
    SELECT(tsjl, Nbr);
    WHILE OCCURE(tsjl) DO
     SEARCH(RprJob, RprJob, , tsjl.RprJob);
     rjfs_PrintLine("  ");
     NEXT(tsjl);
    END; (* WHILE OCCURE(tsjl) ... *)
    SELECT(tsjl, Nbr);
    REMSEL(tsjl);
    INC(i);
   END; (* LOOP *)
   MAKEPART(R, rjfs_Bot);
   CLOSEREP(R);
   L_AFM.AF_PurgeTemp("tsjl");
  ELSE
   IF ~Silent THEN
    L_StdFrm.BlueStop("   㪠 ࠡ  孮᪨ ⠬");
   END;
  END;
 END {TypeFlowSheet};

 PUBLIC PROCEDURE PrintFlowSheet(Silent: SCAL[2]);
 BEGIN
  AccessRprS();
  AccessRprT();
  IF Silent |
     L_StdFrm.Alternative(" 孮    " +
                          RprT.RprT +
                          " '" + L_Str.PoolItem(rpr_TaskKind_Pool, RprT.TaskKind) + "', " +
                          " " + RprS.RprS+"?") THEN
   TypeFlowSheet(Silent);
  END;
 END {PrintFlowSheet};

 PRIVATE PROCEDURE PrintRep(RepName: STRING[]);
  VAR
   S: STRING[];
 BEGIN
  OPENREP(R, "ToPrn", Print);
  FIO.Open(F, L_General.NameConnection(RepName), "REP", Input);
  WHILE FIO.RdStr(F, S) DO
   FIO.WrStr(R, S);
   FIO.WrLn(R);
  END; (* WHILE FIO.RdStr(F, S)...*)
  FIO.Close(F);
  CLOSEREP(R);
 END {PrintRep};

 PRIVATE PROCEDURE TypeRprDA();
  VAR
   RprDfAprName   : STRING[][10];
   TmpRprDfAprName: STRING[];
   i              : NUMERIC[0];
 BEGIN
  MAKEPART(R, SingleLine, " ࠢ⥩");
  SELECT(RprDA, RprDA, , RprS.RprS);
  WHILE OCCURE(RprDA) DO
   IF RprDA.Fixed = daf_ThereIs THEN
    CONFORM(RprDA, RprDfApr);
    CONFORM(RprDfApr, CarBlock);
    TmpRprDfAprName:=CarBlock.Name + ": " + RprDfApr.Name;
    IF ~!RprDA.Comment THEN
     TmpRprDfAprName:=TmpRprDfAprName + " (" + RprDA.Comment + ")";
    END;
    TmpRprDfAprName:=TmpRprDfAprName + " [" + RprDA.RprDfApr + "]";
    Str.Format(RprDfAprName, TmpRprDfAprName, AddRprDfAprLineLength, LEFT);
    MAKEPART(R, Line_RprDA, RprDfAprName[0]);
    i:=1;
    WHILE (i <= HIGH(RprDfAprName)) & (~!RprDfAprName[i]) DO
     MAKEPART(R, AddRprDfAprLine, RprDfAprName[i]);
     INC(i);
    END; (* WHILE i <= HIGH(FullRprDfAprName)...*)
   END;
   NEXT(RprDA);
  END; (* WHILE OCCURE(RprDA) ... *)
 END {TypeRprDA};

 PRIVATE PROCEDURE MakeTop(RepName: STRING[]; trgMaxPages: NUMERIC[0]);
  VAR
   Local       : PROC;
   LinePartName: STRING[];
 BEGIN
  OPENREP(R, L_General.NameConnection(RepName), Create);

  Local:=PROCREF(E_Rpr.SetRprSPrintAttr);
  IF ~!Local THEN
   Local();
  ELSE
   SetPrintAttr(R,
                CharsPerLine,    80,
                MinLinesPerPage, 1,
                SpreadLinInPage, 0,
                PaperForm,       A5,
                MaxPages,        trgMaxPages,
                Orientation,     Landscape,
                TopMargin,       10,            (* ࠢ *)
                BottomMargin,    20,            (*   *)
                LeftMargin,      10,            (* 孥*)
                RightMargin,     0,             (*  *)
                FontProperty,    "/U /B /I");
  END;

  AccessOrigin();
  IF    IsRprS_w_Car() THEN
   L_Car.StandOnCarLog(Car.BoxNbr, RprS.OrdDate);
   CONFORM(CarLog, Mark);
   LinePartName:="Top_Car";
  ELSIF IsRprS_w_OutCar() THEN
   CONFORM(OutCar, Mark);
   CONFORM(OutCar, Firm);
   LinePartName:="Top_OutCar";
  ELSIF IsRprS_w_CarBlock() THEN
   LinePartName:="Top_CarBlock";
  ELSIF IsRprS_w_OutCBlc() THEN
   CONFORM(OutCBlc, Math);
   CONFORM(OutCBlc, Firm);
   LinePartName:="Top_OutCBlc";
  ELSIF IsRprS_w_Math() THEN
   LinePartName:="Top_Math";
  ELSE
   L_General.CallUs(0);
  END;

  MAKEPART(R, CommonTop);
  IF IsFailureOutput() THEN
   MAKEPART(R, FailureOutPut);
  END;
  MAKEPART(R, ^("Top_" + RepName));
  MAKEPART(R, ^LinePartName);
  IF SELECT(RprP, RprJ, RprS.RprS, v_EmptyIndexValue, v_EmptyIndexValue, rprpwho_DrvDeclarant) |
     SELECT(RprP, RprJ, RprS.RprS, v_EmptyIndexValue, v_EmptyIndexValue, rprpwho_AnyDeclarant) THEN
   CONFORM(RprP, Staff);
   CONFORM(Staff, Man);
   MAKEPART(R, SingleLine, L_Str.PoolItem(rprpwho_Pool, RprP.Who) + ": " + RprP.TSN + " " + Man.Name);
  END;
 END {MakeTop};

 PRIVATE PROCEDURE TypeRprJob();
  CONST
   SignPlace = " __________ _____";
  VAR
   TmpRprJobName: STRING[];
   RprJobName   : STRING[][10];
   i            : NUMERIC[0];
 BEGIN
  MAKEPART(R, SingleLine, "⮢ ࠡ");
  SELECT(RprJ, RprS, , RprT.RprS, RprT.RprT);
  WHILE OCCURE(RprJ) DO
   IF !RprJ.EDate THEN
    CONFORM(RprJ, RprJob);
    CONFORM(RprJob, CarBlock);
    TmpRprJobName  :=CarBlock.Name + ": " + RprJob.Name;
    IF RprJob.Leaf THEN
     TmpRprJobName  :=TmpRprJobName + ", " + L_Str.PoolItem(GetRprJobType_Pool(0), RprJob.Type);
    END;
    IF ~!RprJ.EDate THEN
     TmpRprJobName  :=TmpRprJobName + " " + L_DatTim.DateStr(RprJ.EDate) + " " + L_DatTim.TimeStr(RprJ.ETime);
    END;
    TmpRprJobName:=TmpRprJobName + " [" + RprJ.RprJob + "]";
    Str.Format(RprJobName, TmpRprJobName, AddRprJobLineLength, LEFT);
    i:=0;
    WHILE (i <= HIGH(RprJobName)) & (~!RprJobName[i]) DO
     INC(i);
    END; (* WHILE i <= HIGH(RprJobName)...*)

    IF !RprJobName[i] | (Str.Length(RprJobName[i]) > AddRprJobLineLength - Str.Length(SignPlace)) THEN
     RprJobName[i]  :=Str.Align(SignPlace, AddRprJobLineLength, RIGHT);
    ELSE
     RprJobName[i+1]:=Str.Align(SignPlace, AddRprJobLineLength - Str.Length(RprJobName[i]), RIGHT);
    END;

    MAKEPART(R, Line_RprJob, RprJobName[0]);

    i:=1;
    WHILE (i <= HIGH(RprJobName)) & (~!RprJobName[i]) DO
     MAKEPART(R, AddRprJobLine, RprJobName[i]);
     INC(i);
    END; (* WHILE i <= HIGH(RprJobName)...*)
   END;
   NEXT(RprJ);
  END; (* WHILE OCCURE(RprJ) ... *)
 END {TypeRprJob};

 PRIVATE PROCEDURE PrintAnyRprT();
  CONST
   RepName ="RprTP";
  VAR
   SortName,
   RprPlaceName,
   Location,
   TechAidDriver_Who,
   TechAidDriverName: STRING[];
   IsRetrieverRprT: SCAL[2];
 BEGIN
  IsRetrieverRprT:=0;
  MakeTop(RepName, 0);
  SETEMPTY(SortName,  RprPlaceName);
  IF ~!RprT.Sort THEN
   CONFORM(RprT, Sort);
   SortName:=Sort.Name;
  END;
  IF ~!RprT.RprPlace THEN
   CONFORM(RprT, RprPlace);
   RprPlaceName:=RprPlace.Name;
   IsRetrieverRprT:=RprPlace.Kind = rpk_Retriever;
  END;
  MAKEPART(R, SubTop_RprT1, SortName, RprPlaceName);
  IF ~!RprT.RprPlace &
     ((RprPlace.Kind = rpk_TechAid) | (RprPlace.Kind = rpk_Retriever)) THEN
   SETEMPTY(Location, TechAidDriver_Who,  TechAidDriverName);
   IF SELECT(RprP, RprJ, RprS.RprS, RprT.RprT, v_EmptyIndexValue, rprpwho_TechAidDrv) |
      SELECT(RprP, RprJ, RprS.RprS, RprT.RprT, v_EmptyIndexValue, rprpwho_RetrieverDrv) THEN
    CONFORM(RprP, Staff);
    CONFORM(Staff, Man);
    TechAidDriver_Who:=L_Str.PoolItem(rprpwho_Pool, RprP.Who);
    TechAidDriverName:=Staff.TSN + " " + L_Str.ShortName(Man.Name);
   END;
   IF P_Rpr.HasRprSPro(RprS.RprS, P_Rpr.P_Location) THEN
    Location:=RprPro.Value;
   END;
   MAKEPART(R, SubTop_RprT2, TechAidDriver_Who, TechAidDriverName, Location);
  END;
  TypeRprDA();
  IF ~IsRetrieverRprT THEN
   TypeRprJob();
   MAKEPART(R, Bot_RprTP, "",          "ਣ");
  ELSE
   MAKEPART(R, Bot_RprTP, "⥫ ", "堭 ");
  END;
  CLOSEREP(R);
  PrintRep(RepName);
 END {PrintAnyRprT};

 PUBLIC PROCEDURE PrintCarRprT();
 BEGIN
  PrintAnyRprT();
 END {PrintCarRprT};

 PUBLIC PROCEDURE PrintOutCarRprT();
 BEGIN
  PrintAnyRprT();
 END {PrintOutCarRprT};

 PUBLIC PROCEDURE PrintCarBlockRprT();
 BEGIN
  PrintAnyRprT();
 END {PrintCarBlockRprT};

 PUBLIC PROCEDURE PrintOutCBlcRprT();
 BEGIN
  PrintAnyRprT();
 END {PrintOutCBlcRprT};

 PUBLIC PROCEDURE PrintMathRprT();
 BEGIN
  PrintAnyRprT();
 END {PrintMathRprT};

 PUBLIC PROCEDURE E_PrintRprT(Silent: SCAL[2]);
  VAR
   Local,
   System: PROC;
 BEGIN
  AccessRprS();
  AccessRprT();

  IF Silent |
     L_StdFrm.Alternative("  " +
                          RprT.RprT +
                          " '" + L_Str.PoolItem(rpr_TaskKind_Pool, RprT.TaskKind) + "', " +
                          " " + RprS.RprS+"?") THEN
   INC(RprT.CopyCnt);
   REPLACE(RprT);
   CurRprSXDocJrnMark(L_XDoc.action_PrintAdditionalDocument);
   IF    IsRprS_w_Car() THEN
    System:=PROCREF(PrintCarRprT);
    Local :=PROCREF(E_Rpr.PrintCarRprT);
   ELSIF IsRprS_w_OutCar() THEN
    System:=PROCREF(PrintOutCarRprT);
    Local :=PROCREF(E_Rpr.PrintOutCarRprT);
   ELSIF IsRprS_w_CarBlock() THEN
    System:=PROCREF(PrintCarBlockRprT);
    Local :=PROCREF(E_Rpr.PrintCarBlockRprT);
   ELSIF IsRprS_w_OutCBlc() THEN
    System:=PROCREF(PrintOutCBlcRprT);
    Local :=PROCREF(E_Rpr.PrintOutCBlcRprT);
   ELSIF IsRprS_w_Math() THEN
    System:=PROCREF(PrintMathRprT);
    Local :=PROCREF(E_Rpr.PrintMathRprT);
   ELSE
    L_General.CallUs(0);
   END;

   IF ~!Local THEN
    Local();
   ELSE
    System();
   END;

   TypeFlowSheet(1);
  END;
 END {E_PrintRprT};


BEGIN
 InitRprVariables();
END.
