(*
%Copyright   (c) Polak IT
%Author      06.08.1997 16:27:28 SAN
%Purpose     ஫ 䨪樨 ६⭮ 
%Type        control
%Specific    AP
%Modified    14.08.2014 12:36:11 POLAK\LDA
%Environment
*)

 MODULE RprS [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT Str, Math, Memo,
        L_General, L_DatTim, L_Events, L_Rpr, L_Car, L_Str, L_XDoc, L_Staff, L_Way, L_SysLog,
        L_StdFrm, L_AR, L_ctc, L_CUC, L_Cntr, L_Prop, L_EC, L_Env, L_WDO, L_BegRWS, L_Timer,
        L_RT, L_APtm, L_lsStore, L_XObj, L_SES, L_MathR, L_MDoc, L_AFM, L_OwnData, L_Money,
        P_Rpr, P_Firm,
        E_Rpr, E_Way, E_Prop;

 PRIVATE CONST
  TimerId                = "RprS.ViewOpenRprS";
  CoefEngPwKWtToEngPower = 0.7354996;

  rfl_RprDA_Amount = 3;

  rk_wo_Assistance = 0;
  rk_NeedRetriever = 1;

  ipoda_Manual       = 0;
  ipoda_EnterBoxNbr  = 1;
  ipoda_TransferRprS = 2;
  ipoda_EditRprS     = 3;

  irm_Usual             = 0;
  irm_TechAid           = 1;
  irm_Retriever         = 2;
  irm_IndependentRepair = 3;
  irm_OutCarRprS        = 4;
  irm_OutCBlcRprS       = 5;

  csrda_OnCloseRprDA = 0;
  csrda_OnCloseRprS  = 1;
  csrda_OnEdInsRprDA = 2;

  csrda_Pool         = "饭 뢠  ࠢ, ॡ饥 筥|" +
                       "饭 뢠   稨  ࠢ⥩, ॡ 筥|" +
                       "饭 㪠뢠  ࠢ, ॡ饥 筥";

 PRIVATE PERMANENT VAR
  v_RprS        : LIKE(RprS.RprS);

 PRIVATE PROCEDURE E_UseRprTJobBegDateTime(): SCAL[2];
 BEGIN
  RETURN L_EC.ExecE_Func_Scal2(SYSDATE(), PROCREF(E_Rpr.UseRprTJobBegDateTime), 0);
 END {E_UseRprTJobBegDateTime};

 PRIVATE PROCEDURE E_UseRprTJobEndDateTime(): SCAL[2];
 BEGIN
  RETURN L_EC.ExecE_Func_Scal2(SYSDATE(), PROCREF(E_Rpr.UseRprTJobEndDateTime), 0);
 END {E_UseRprTJobEndDateTime};

 PRIVATE PROCEDURE E_RprTJobBDTEqualRprTBegDT(): SCAL[2];
 BEGIN
  RETURN L_EC.ExecE_Func_Scal2(SYSDATE(), PROCREF(E_Rpr.RprTJobBDTEqualRprTBegDT), 1);
 END {E_RprTJobBDTEqualRprTBegDT};

 PRIVATE PROCEDURE E_RprJPeriodEqualRprTJobPeriod(_Date: DATE): SCAL[2];
 BEGIN
  RETURN L_EC.ExecE_Func_Scal2(_Date, PROCREF(E_Rpr.RprJPeriodEqualRprTJobPeriod), 0);
 END {E_RprJPeriodEqualRprTJobPeriod};

 PRIVATE PROCEDURE E_GetRetrieverRprJob(): LIKE(RprJob.RprJob);
  VAR
   Local: PROC;
 BEGIN
  Local:=PROCREF(E_Rpr.GetRetrieverRprJob);
  IF ~!Local THEN
   RETURN Local();
  ELSE
   RETURN EMPTYOF(RprJob.RprJob);
  END;
 END {E_GetRetrieverRprJob};

 PRIVATE PROCEDURE E_NeedCheckCarLocation(_Date: DATE): SCAL[2];
 BEGIN
  RETURN L_EC.ExecE_Func_Scal2(_Date, PROCREF(E_Rpr.NeedCheckCarLocation), 0);
 END {E_NeedCheckCarLocation};

 PRIVATE PROCEDURE E_LocationForRegistrationFromLine(): L_Rpr.tRprSLocation;
  VAR
   Local  : PROC;
   default: L_Rpr.tRprSLocation;
 BEGIN
  default := L_Rpr.rprl_ControllerOffice;
  Local   := PROCREF(E_Rpr.LocationForRegistrationFromLine);
  IF ~!Local THEN
   RETURN Local();
  ELSE
   L_General.Assert(L_Rpr.E_AllowedRprSLocation(default), "ଫ    .||" +
                                                          "᫨  㢥७  ࠢ쭮 ᢮ ⢨,|"+
                                                          "  ");
   RETURN default;
  END;
 END {E_LocationForRegistrationFromLine};

 PRIVATE PROCEDURE E_ConditionalClose();
  VAR
   Local: PROC;
 BEGIN
  Local:=PROCREF(E_Rpr.ConditionalClose);
  IF ~!Local THEN
   Local();
  END;
 END {E_ConditionalClose};

 PRIVATE PROCEDURE E_NeedUseRprStaff(): SCAL[2];
 BEGIN
  RETURN L_EC.ExecE_Func_Scal2(SYSDATE(), PROCREF(E_Rpr.NeedUseRprStaff), 0);
 END {E_NeedUseRprStaff};

 PRIVATE PROCEDURE E_NeedUseStaff_ForDrvDeclarant(): SCAL[2];
 BEGIN
  RETURN L_EC.ExecE_Func_Scal2(SYSDATE(), PROCREF(E_Rpr.NeedUseStaff_ForDrvDeclarant), 0);
 END {E_NeedUseStaff_ForDrvDeclarant};

 PRIVATE PROCEDURE E_MayInsertPutOffDfApr(InsertingPutOffDfApr: SCAL[100]): SCAL[2];
  VAR
   Local: PROC;
 BEGIN
  Local:=PROCREF(E_Rpr.MayInsertPutOffDfApr);
  IF ~!Local THEN
   RETURN Local(InsertingPutOffDfApr);
  ELSE
   RETURN 1;
  END;
 END {E_MayInsertPutOffDfApr};

 PRIVATE PROCEDURE E_wQuestionBeforeInsertPutOffDfApr(): SCAL[2];
 BEGIN
  RETURN L_EC.ExecE_Func_Scal2(SYSDATE(), PROCREF(E_Rpr.wQuestionBeforeInsertPutOffDfApr), 0);
 END {E_wQuestionBeforeInsertPutOffDfApr};

 PRIVATE PROCEDURE E_GetRepeatedRprSDescr(): STRING[];
 BEGIN
  RETURN L_EC.ExecE_Func_String(SYSDATE(), PROCREF(E_Rpr.GetRepeatedRprSDescr), "");
 END {E_GetRepeatedRprSDescr};

 PRIVATE PROCEDURE E_NeedInformAboutRepetition(_Location: L_Rpr.tRprSLocation): SCAL[2];
  VAR
   Local: PROC;
 BEGIN
  Local:=PROCREF(E_Rpr.NeedInformAboutRepetition);
  IF ~!Local THEN
   RETURN Local(_Location);
  ELSE
   RETURN 0;
  END;
 END {E_NeedInformAboutRepetition};

 PRIVATE PROCEDURE E_CheckRprPPresence(_RprT: LIKE(RprT.RprT);
                                       _Sort: LIKE(Sort.Sort));
  VAR
   Local: PROC;
 BEGIN
  Local:=PROCREF(E_Rpr.CheckRprPPresence);
  IF ~!Local THEN
   Local(_RprT, _Sort);
  END;
 END {E_CheckRprPPresence};

 PRIVATE PROCEDURE E_RprJBaseTimeRequired(): SCAL[2];
 BEGIN
  RETURN L_EC.ExecE_Func_Scal2(SYSDATE(), PROCREF(E_Rpr.RprJBaseTimeRequired), 0);
 END {E_RprJBaseTimeRequired};

 PRIVATE PROCEDURE GetInsertRprSMode(): NUMERIC[0];
  VAR
   S     : STRING[];
   Result: NUMERIC[0];
 BEGIN
  Result:=irm_Usual;
  S     :=L_WDO.GetEnvVarValue("InsertRprSMode");
  IF    S = "TechAid"           THEN Result:=irm_TechAid;
  ELSIF S = "Retriever"         THEN Result:=irm_Retriever;
  ELSIF S = "IndependentRepair" THEN Result:=irm_IndependentRepair;
  ELSIF S = "ServiceCenter"     THEN Result:=irm_OutCarRprS;
  ELSIF S = "Workshop"          THEN Result:=irm_OutCBlcRprS;
  END;
  RETURN Result;
 END {GetInsertRprSMode};

 PRIVATE PROCEDURE GetReturnKind(): NUMERIC[0];
  VAR
   S     : STRING[];
   Result: NUMERIC[0];
 BEGIN
  Result:=rk_wo_Assistance;
  S     :=L_WDO.GetEnvVarValue("ReturnKind");
  IF S = "NeedRetriever" THEN
   Result:=rk_NeedRetriever;
  END;
  RETURN Result;
 END {GetReturnKind};

 PRIVATE PROCEDURE rfl_E_StrongCheckFillField();
  VAR
   Fields: FORM_FIELDS;
 BEGIN
  IF L_EC.ExecE_Func_Scal2(SYSDATE(), PROCREF(E_Rpr.rfl_StrongCheckFillField), 0) THEN
   Fields:=RTI.Get().CurZone.Fields;
   _Assert(~!Fields("TSN_0").Value,    "⥫ ( )");
   _Assert(~!Fields("Location").Value, "⮯");
   IF GetInsertRprSMode() # irm_IndependentRepair THEN
    _Assert(~!Fields("Sort").Value, " ᥪ");
    _Assert(~!Fields("RprPlace").Value, L_Str.PoolItem(L_Rpr.rpk_Pool, Fields("RprPlaceKind").Value));
    _Assert(~!Fields("TSN_1").Value, L_Str.PoolItem(L_Rpr.rprpwho_Pool, Fields("Who_1").Value));
   END;
  END;
 END {rfl_E_StrongCheckFillField};

 PRIVATE PROCEDURE rfl_E_PrintRprSImmediately(): SCAL[2];
 BEGIN
  RETURN L_EC.ExecE_Func_Scal2(SYSDATE(), PROCREF(E_Rpr.rfl_PrintRprSImmediately), 0)
 END {rfl_E_PrintRprSImmediately};

 PRIVATE PROCEDURE E_PrintAllUnprintedRprT(): SCAL[2];
 BEGIN
  RETURN L_EC.ExecE_Func_Scal2(SYSDATE(), PROCREF(E_Rpr.PrintAllUnprintedRprT), 0)
 END {E_PrintAllUnprintedRprT};

 PRIVATE PROCEDURE E_RprT_CheckFilling();
  VAR
   Local: PROC;
 BEGIN
  Local:=PROCREF(E_Rpr.RprT_CheckFilling);
  IF ~!Local THEN
   Local();
  END;
 END {E_RprT_CheckFilling};

 PRIVATE PROCEDURE E_TransferCondition(DestLocation: L_Rpr.tRprSLocation);
  VAR
   Text  : STRING[];
   Local : PROC;
   Result: SCAL[2];
 BEGIN
  Result:=1;
  SETEMPTY(Text);
  IF (RprS.Location = L_Rpr.rprl_Gate) &
     ((RprS.Status = L_Rpr.ms_WaitRetriever) | (RprS.Status = L_Rpr.ms_Return)) THEN
   Result:=0;
   Text  :="।   ﭨ '" + L_Rpr.GetRprSStatus_AsStr(RprS.Status) + "'|" +
            " ஢ '" + L_Rpr.GetRprSLocation_AsStr(DestLocation) + "' 饭";
  END;

  Local:=PROCREF(E_Rpr.TransferCondition);
  IF ~!Local THEN
   Local(DestLocation, Result, Text);
  END;
  L_General.Assert(Result, Text);
 END {E_TransferCondition};

 PRIVATE PROCEDURE E_GetRegistrationFromLineRprPlaceKind(): LIKE(RprPlace.Kind);
  VAR
   Result,
   default: LIKE(RprPlace.Kind);
   Local  : PROC;
 BEGIN
  L_General.Assert(L_Rpr.IsMainRpr() | L_APtm.IsRepairZone(), " 㯭 ⮫쪮  ࠡ⭨ ६");

  IF    GetInsertRprSMode() = irm_TechAid THEN
   default:=L_Rpr.rpk_TechAid;
  ELSIF GetInsertRprSMode() = irm_Retriever THEN
   default:=L_Rpr.rpk_Retriever;
  ELSIF GetInsertRprSMode() = irm_IndependentRepair THEN
   SETEMPTY(default);
  ELSE
   L_General.CallUs(0);
  END;

  Local:=PROCREF(E_Rpr.GetRegistrationFromLineRprPlaceKind);
  IF ~!Local THEN
   Result:=Local(default);
  ELSE
   Result:=default;
  END;
  RETURN Result;
 END {E_GetRegistrationFromLineRprPlaceKind};

 PRIVATE PROCEDURE SetRprJNormHourPrice();
 BEGIN
  IF ~!RprJ.RprJob THEN
   RprJ.Price:=L_Rpr.E_GetNormHourPrice();
   REPLACE(RprJ);
  END;
 END {SetRprJNormHourPrice};

 PRIVATE PROCEDURE CalcRprJSum();
  VAR
   trgSum: NUMERIC[2];
 BEGIN
  IF ~!RprJ.BaseTime & ~!RprJ.Price & ~!RprJ.Quantity THEN
   trgSum:=RprJ.BaseTime * RprJ.Price * RprJ.Quantity;
   IF trgSum > MAXOF(RprJ.Sum) THEN
    L_General.Error("⠭ ⮨ ६⭮ ࠡ "+L_Money.MoneyToStr(RprS.OrdDate, "", trgSum)+"|" +
                    "ॢ蠥 ᨬ쭮  ("+L_Money.MoneyToStr(RprS.OrdDate, "", MAXOF(RprJ.Sum))+")");
   END;
   RprJ.Sum:=trgSum;
   REPLACE(RprJ);
  END;
 END {CalcRprJSum};

 PUBLIC PROCEDURE RecalcRprJSum();
 BEGIN
  SetRprJNormHourPrice();
  CalcRprJSum();
 END {RecalcRprJSum};

 PRIVATE PROCEDURE SetSingleRprJobBaseTime();
 BEGIN
  IF ~!RprJ.RprJob THEN
   CONFORM(RprJ, RprJob);
   IF RprJob.HasNorm THEN
    IF RprJob.Leaf = 1 THEN
     IF !RprJ.BaseTime                         |
        (RprJ.Source # L_Rpr.rprjbts_Operator) |
        L_StdFrm.RedAlternative("⭠ ࠡ " + RprJ.RprJ + " ( "+RprJ.RprJob+"), ६⭮  " + RprJ.RprT + ":|" +
                                "㤮 ⠭ ஬ (" + FLDTOSTR(RprJ.BaseTime, "3.") + ").||" +
                                "믮   㤮?") THEN
      L_Rpr.GetRprJobBaseTime(RprJ.RprJob, RprJ.BDate, RprJ.BaseTime, RprJ.Source);
      REPLACE(RprJ);
     END;
    END;
   ELSE
    IF ~!RprJ.BaseTime                       &
      (RprJ.Source # L_Rpr.rprjbts_Operator) &
      L_StdFrm.RedAlternative("⭠ ࠡ " + RprJ.RprJ + " ( "+RprJ.RprJob+"), ६⭮  " + RprJ.RprT + ":|" +
                              "ࠡ  ନ,  㤮 㦥 ⠭ (" + FLDTOSTR(RprJ.BaseTime, "3.") + ").||" +
                              "  㤮?") THEN
     SETEMPTY(RprJ.BaseTime);
    END;
    RprJ.Source:=L_Rpr.rprjbts_Operator;
    REPLACE(RprJ);
   END; (* IF RprJob.HasNorm...*)
  END; (* IF ~!RprJ.RprJob...*)
 END {SetSingleRprJobBaseTime};

 PRIVATE PROCEDURE InsRprJFromTaskStandartJobsList();
  VAR
   EndDTS  : TIMESTAMP;
   trgBDate: DATE;
   trgBTime: TIME;
 BEGIN
  IF tsjl.Nbr = 1 THEN
   IF E_RprJPeriodEqualRprTJobPeriod(RprS.OrdDate) THEN
    trgBDate:=RprT.JobBDate;
    trgBTime:=RprT.JobBTime;
   ELSE
    trgBDate:=SYSDATE();
    trgBTime:=SYSTIME();
   END;
  ELSE
   SELECT(RprJ, RprS, , RprT.RprS, RprT.RprT);
   LAST(RprJ);
   EndDTS:=L_DatTim.GetTIMESTAMP(RprJ.BDate, RprJ.BTime);
   IF ~!RprJ.BaseTime THEN
    EndDTS:=EndDTS + RprJ.BaseTime / 24;
   END;
   trgBDate:=L_DatTim.GetDateOfTIMESTAMP(EndDTS);
   trgBTime:=L_DatTim.GetTimeOfTIMESTAMP(EndDTS);
  END;

  RprJ.RprS    :=RprT.RprS;
  RprJ.RprT    :=RprT.RprT;
  SETEMPTY(RprJ.RprJ);
  RprJ.RprJob  :=tsjl.RprJob;
  RprJ.BDate   :=trgBDate;
  RprJ.BTime   :=trgBTime;
  SETEMPTY(RprJ.EDate, RprJ.ETime);
  RprJ.ComplCfc:=1;
  RprJ.Quantity:=1;
  SETEMPTY(RprJ.Price, RprJ.Sum, RprJ.BaseTime, RprJ.Source);
  INSERT(RprJ);

  SetSingleRprJobBaseTime();

  RecalcRprJSum();
 END {InsRprJFromTaskStandartJobsList};

 PUBLIC PROCEDURE PutTaskStandartJobsList();
  VAR
   Choice       : NUMERIC[0];
   trgRprJobSet : LIKE(RprJob.RprJob);
   RprJobList,
   RprJobSetList: STRING[];
 BEGIN
  L_General.CallUs(ACCESS(RprT));
  L_General.Assert(RprT.Result = L_Rpr.tr_InProgress, "ଫ ⠭⭮  ࠡ|"+
                                                      " ⮫쪮  ⮣ ");

  L_Rpr.rjdl_Prepare(EMPTYOF(RprT.RprT), L_Rpr.rjd_RprJobSet, RprJobList, RprJobSetList);
  IF ~!RprJobSetList THEN
   Choice      :=L_StdFrm.ShowListAsMenu(RprJobSetList, "⠭ 祭 ࠡ");
   trgRprJobSet:=L_Str.AnyItem(RprJobList, "|", Choice);
   L_Rpr.rjdl_Gather(L_Rpr.rjd_RprJobSet, trgRprJobSet);

   SELECT(RprJ, RprS, , RprS.RprS, RprT.RprT);
   WHILE OCCURE(RprJ) DO
    IF SELECT(tsjl, RprJob, RprJ.RprJob) THEN
     L_General.Error("⭠ ࠡ " + RprJ.RprJob + " 㦥   ");
    END;
    NEXT(RprJ);
   END; (* WHILE OCCURE(RprJ) ... *)
 
   SELECT(tsjl, Nbr);
   WHILE OCCURE(tsjl) DO
    InsRprJFromTaskStandartJobsList();
    NEXT(tsjl);
   END; (* WHILE OCCURE(tsjl) ... *)
 
   L_AFM.AF_PurgeTemp("tsjl");
  ELSE
   L_StdFrm.BlueStop("    ଫ  ࠡ");
  END;
 END {PutTaskStandartJobsList};

(******)

 PRIVATE CONST
  crepm_Inform  = 0;
  crepm_Insert  = 1;
  crepm_Replace = 2;

  DoneDialogWidth = 80;

 PRIVATE PROCEDURE PutCarRepEvent(VAR RepEventList: STRING[]; cre_PutMode: SCAL[3]);
  VAR
   RepEventDescr: STRING[];
 BEGIN
  RepEventDescr:=RepEv.RepEvent + " '" + RepEvent.Name + "' (" + L_DatTim.DateStr(RepEv.StartD) + ")";
  IF cre_PutMode = crepm_Inform THEN
   RepEventDescr:=RepEventDescr + " " +
                  "筨 " + L_Str.PoolItem(L_Car.src_RE_Pool, CarEvn.Source) + " " + FLDTOSTR(CarEvn.DocNbr, "0", 7);
  END;

  RepEventList:=RepEventList + Str.Align("  " + RepEventDescr, DoneDialogWidth, LEFT) + "|";

  IF cre_PutMode # crepm_Inform THEN
   IF cre_PutMode # crepm_Insert THEN
    L_SysLog.SingleMark_Init("CarEvn");
   END;

   CarEvn.BoxNbr  :=Car.BoxNbr;
   CarEvn.RepEvent:=RepEv.RepEvent;
   CarEvn.StartD  :=RepEv.StartD;
   CarEvn.StopD   :=RepEv.StopD;
   CarEvn.DocNbr  :=RprS.RprS;
   CarEvn.Source  :=L_Car.src_RprS;
   IF cre_PutMode = crepm_Insert THEN
    INSERT(CarEvn);
    L_SysLog.SingleMark_AutoBuild("CarEvn");
   ELSE
    REPLACE(CarEvn);
    L_SysLog.SingleMark_Done("CarEvn");
   END;
  END;
 END {PutCarRepEvent};

 PRIVATE PROCEDURE MakeDoneDialogLine(Title, RepEventList: STRING[]; VAR Msg: STRING[]);
 BEGIN
  IF ~!RepEventList THEN
   Msg:=Msg + Str.Align(Title + ":", DoneDialogWidth, LEFT) + "||" + RepEventList + "|";
  END;
 END {MakeDoneDialogLine};

 PRIVATE PROCEDURE extProceedRprS(_Done: LIKE(RprS.Done); Silent: SCAL[2]);
  VAR
   Msg,
   NewRepEventList,
   DoneRepEventList,
   ExistsRepEventList: STRING[];
 BEGIN
  L_Rpr.AccessRprS();
  IF RprS.Closed & (RprS.Done # _Done) THEN
   IF (RprS.Status = L_Rpr.ms_Done) & L_Rpr.IsRprS_w_Car() THEN
    GRANT_ALL_RIGHTS();
    L_Rpr.AccessOrigin();
    L_Rpr.Create_RepEv();
    SETEMPTY(DoneRepEventList, NewRepEventList, ExistsRepEventList);
    L_Rpr.E_GatherRequiredRepEvent(1);
    IF SELECT(RepEv, RepEvent) THEN
     WHILE OCCURE(RepEv) DO
      L_General.CallUs(SEARCH(RepEvent, RepEvent, RepEv.RepEvent));
      L_General.Assert(L_DatTim.IsActive(RepEv.StartD, RepEvent.Begin, RepEvent.Till),
                       "ய⨥ " + RepEvent.RepEvent + "   " + L_DatTim.DateStr(RepEv.StartD));
      IF _Done THEN
       IF SEARCH(CarEvn, BoxNbr, Car.BoxNbr, RepEv.StartD, RepEvent.RepEvent) |
          L_Rpr.FoundReFrCast(Car.BoxNbr, RepEv.RepEvent, RepEv.StartD) THEN
        IF    CarEvn.Source = L_Car.src_FrCast THEN
         IF ~Silent THEN
          L_StdFrm.Choice("࠭ᯮ⭮ ।⢮ " + Car.BoxNbr + ":" +
                          "| ண ६⭮ ᮡ " +
                          "|" +RepEv.RepEvent + " " + RepEvent.Name +
                          "  " + L_DatTim.DateStr(CarEvn.StartD) +
                          "||  ᮡ⨥ 訬   " + L_DatTim.DateStr(RepEv.StartD)  + "?");
         END;
         PutCarRepEvent(DoneRepEventList, crepm_Replace);
        ELSIF (CarEvn.Source = L_Car.src_RprS) & (CarEvn.DocNbr = RprS.RprS) THEN
         L_General.CallUs(0);
        ELSE
         L_StdFrm.Choice("࠭ᯮ⭮ ।⢮ " + Car.BoxNbr + ":" +
                         "|  ६⭮ ᮡ⨥ " +
                         "|" + RepEv.RepEvent + " " + RepEvent.Name +
                         "  " + L_DatTim.DateStr(CarEvn.StartD) +
                         "|筨 - " + L_Str.PoolItem(L_Car.src_RE_Pool, CarEvn.Source));

         PutCarRepEvent(ExistsRepEventList, crepm_Inform);
        END;
       ELSE
        PutCarRepEvent(NewRepEventList, crepm_Insert);
       END; (* IF SEARCH(CarEvn, BoxNbr, Car.BoxNbr, RepEv.StartD, RepEvent.RepEvent) *)
      ELSE
       SETSEL(CarEvn, REBoxNbr, RepEv.RepEvent, L_Car.src_RprS, Car.BoxNbr);
       SRCINSEL(CarEvn, GE, , RprS.OrdDate);
       WHILE OCCURE(CarEvn) & (CarEvn.StartD <= RprS.EDate) DO
        IF CarEvn.DocNbr = RprS.RprS THEN
         L_SysLog.SingleMark_BeforeDelete("CarEvn");
         REMOVE(CarEvn);
        ELSE
         NEXT(CarEvn);
        END;
       END; (* WHILE OCCURE(CarEvn)...*)
      END; (* IF _Done...*)
      NEXT(RepEv);
     END; (* WHILE OCCURE(RepEv) ... *)
    END; (* IF SELECT(RepEv, RepEvent)...*)
    L_Rpr.Purge_RepEv();

    IF ~Silent & (~!DoneRepEventList | ~!NewRepEventList | ~!ExistsRepEventList) THEN
     Msg:="࠭ᯮ⭮ ।⢮ " + Car.BoxNbr + "||";
     MakeDoneDialogLine("ண, ᤥ 訬",             DoneRepEventList, Msg);
     MakeDoneDialogLine("  ய",                   NewRepEventList, Msg);
     MakeDoneDialogLine("騥 ய ( ᮯ⠢  )", ExistsRepEventList, Msg);
     L_StdFrm.Inform(Msg);
    END;
   END; (* IF RprS.Status = L_Rpr.ms_Done...*)

   RprS.Done:=_Done;
   REPLACE(RprS);
  END; (* IF RprS.Closed &...*)
 END {extProceedRprS};

 PRIVATE PROCEDURE ProceedRprS(_Done: LIKE(RprS.Done));
 BEGIN
  extProceedRprS(_Done, 0);
 END {ProceedRprS};

 PRIVATE PROCEDURE CheckSingleRprTEDT();
 BEGIN
  L_General.Assert(L_Rpr.CompareDT(RprT.BDate, RprT.BTime, RprS.OrdDate, RprS.OrdTime) >= 0,
                   "ᮮ⢥⢨ ६ 믨᪨ ६⭮ |" +
                   " ६ 믨᪨ ६⭮ | |" +
                   "६ 믨᪨ ६⭮   : " + L_Rpr.DateTimeToStr(RprS.OrdDate, RprS.OrdTime) + "|" +
                   "६ 믨᪨ ६⭮ : " + L_Rpr.DateTimeToStr(RprT.BDate, RprT.BTime));
  L_General.Assert(L_Rpr.CompareDT(RprT.JobBDate, RprT.JobBTime, RprT.BDate, RprT.BTime) >= 0,
                   "ᮮ⢥⢨ ६ 믨᪨ ६⭮ |" +
                   " ६ 砫 ࠡ  ६ | |" +
                   "६ 믨᪨ ६⭮           : " + L_Rpr.DateTimeToStr(RprT.BDate, RprT.BTime) + "|" +
                   "६ 砫 ࠡ  ६ : " + L_Rpr.DateTimeToStr(RprT.JobBDate, RprT.JobBTime));
  IF (RprS.Status # L_Rpr.ms_NeedRate) | ~!RprT.EDate THEN
   L_General.Assert(L_Rpr.CompareDT(RprS.EDate, RprS.ETime, RprT.EDate, RprT.ETime) >= 0,
                    "ᮮ⢥⢨ ६  ६⭮ |" +
                    " ६  ६⭮ | |" +
                    "६  ६⭮   : " + L_Rpr.DateTimeToStr(RprS.EDate, RprS.ETime) + "|" +
                    "६  ६⭮ : " + L_Rpr.DateTimeToStr(RprT.EDate, RprT.ETime));
   L_General.Assert(L_Rpr.CompareDT(RprT.EDate, RprT.ETime, RprT.JobEDate, RprT.JobETime) >= 0,
                    "ᮮ⢥⢨ ६  ६⭮ |" +
                    " ६ 砭 ࠡ  ६ | |" +
                    "६  ६⭮             : " + L_Rpr.DateTimeToStr(RprT.EDate, RprT.ETime) + "|" +
                    "६ 砭 ࠡ  ६ : " + L_Rpr.DateTimeToStr(RprT.JobEDate, RprT.JobETime));
  END;
 END {CheckSingleRprTEDT};

 PRIVATE PROCEDURE CheckRprSEDT();
 BEGIN
  L_General.Assert(L_Rpr.CompareDT(RprS.EDate, RprS.ETime, RprS.OrdDate, RprS.OrdTime) >= 0,
                   "ᮮ⢥⢨ ६ 믨᪨ ६⭮ |" +
                   " ६ ।  ᯫ| |" +
                   "६ 믨᪨ ६⭮ : " + L_Rpr.DateTimeToStr(RprS.OrdDate, RprS.OrdTime) + "|" +
                   "६ ।  ᯫ : " + L_Rpr.DateTimeToStr(RprS.EDate, RprS.ETime));
  CONFORM(RprS, RprT);
  WHILE OCCURE(RprT) DO
   IF RprS.Closed THEN
    L_General.Assert(RprT.Result # L_Rpr.tr_InProgress,"  ⠢  ' '");
   END;
   CheckSingleRprTEDT();
   NEXT(RprT);
  END; (* WHILE OCCURE(RprT)... *)
 END {CheckRprSEDT};

 PRIVATE PROCEDURE HasOpenDefect(): SCAL[2];
 BEGIN
  CONFORM(RprS, RprDA);
  WHILE OCCURE(RprDA) DO
   IF RprDA.Fixed = L_Rpr.daf_ThereIs THEN
    RETURN 1;
   END;
   NEXT(RprDA);
  END; (* WHILE OCCURE(RprDA)... *)
  RETURN 0;
 END {HasOpenDefect};

 PRIVATE PROCEDURE CheckSingleRprDA(csrda: SCAL[9]);
 BEGIN
  CONFORM(RprDA, RprDfApr);
  L_General.Assert(RprDfApr.Leaf = 1, L_Str.PoolItem(csrda_Pool, csrda) + "||" +
                                      "ࠢ N " + RprDA.RprDA + ", " + RprDA.RprDfApr + " " + RprDfApr.Name );
 END {CheckSingleRprDA};

 PRIVATE PROCEDURE CheckFictRprDA();
 BEGIN
  CONFORM(RprS, RprDA);
  WHILE OCCURE(RprDA) DO
   CheckSingleRprDA(csrda_OnCloseRprS);
   NEXT(RprDA);
  END; (* WHILE OCCURE(RprDA)... *)
 END {CheckFictRprDA};

 PRIVATE PROCEDURE CheckSingleRprJ(CloseRprSCheck: SCAL[2]);
  VAR
   Msg: STRING[];
 BEGIN
  IF CloseRprSCheck THEN
   Msg:="饭 뢠   稨|६ ࠡ, ॡ 筥";
  ELSE
   Msg:="饭 뢠 ६ ࠡ, ॡ 筥";
  END;
  CONFORM(RprJ, RprJob);
  L_General.Assert(RprJob.Leaf = 1, Msg + "||" +
                                    " N " + RprJ.RprT + ", ६⭠ ࠡ N " + RprJ.RprJ + ", " + RprJ.RprJob + " " + RprJob.Name );
 END {CheckSingleRprJ};

 PRIVATE PROCEDURE CheckSingleRprJBaseTime(Strong: SCAL[2]);
  VAR
   Msg: STRING[];
 BEGIN
  CONFORM(RprJ, RprJob);
  IF RprJob.Leaf THEN
   IF !RprJ.BaseTime &
      (E_RprJBaseTimeRequired() | L_Rpr.IsServiceCenterLocation(RprS.Location) | L_Rpr.IsRprS_w_OutCar()) THEN
    Msg:=" N " + RprJ.RprT + ",  " + RprJ.RprJob + " (N " + RprJ.RprJ + "):|" +
         " 㪠 ⨯筠 㤮 ࠡ";
    IF Strong THEN
     L_General.Error(Msg);
    ELSE
     L_StdFrm.Choice(Msg);
    END;
   END;
  END;
 END {CheckSingleRprJBaseTime};

 PRIVATE PROCEDURE HasOpenJob(): SCAL[2];
 BEGIN
  SELECT(RprJ, RprS, , RprS.RprS);
  WHILE OCCURE(RprJ) DO
   IF !RprJ.EDate THEN
    RETURN 1;
   END;
   NEXT(RprJ);
  END; (* WHILE OCCURE(RprJ) ... *)
  RETURN 0;
 END {HasOpenJob};

 PRIVATE PROCEDURE IsOutsideOverhaul(): SCAL[2];
 BEGIN
  RETURN (RprT.TaskKind = L_Rpr.tk_Overhaul) & !RprT.Sort & !RprT.RprPlace;
 END {IsOutsideOverhaul};

 PRIVATE PROCEDURE IsOutsideRepair(): SCAL[2];
 BEGIN
  RETURN (RprT.TaskKind = L_Rpr.tk_IndependentRepair)
 END {IsOutsideRepair};

 PRIVATE PROCEDURE IsRetireRepair(): SCAL[2];
 BEGIN
  RETURN (RprT.TaskKind = L_Rpr.tk_Retire);
 END {IsRetireRepair};

 PRIVATE PROCEDURE GetOpenTaskStatus(): L_Rpr.tMirrorStatus;
  VAR
   RprTNbr: NUMERIC[0];
 BEGIN
  RprTNbr:=0;
  CONFORM(RprS, RprT);
  WHILE OCCURE(RprT) DO
   INC(RprTNbr);
   IF RprT.Result = L_Rpr.tr_InProgress THEN
    CONFORM(RprT, RprPlace);
    IF L_Rpr.HasRprTNotification() THEN
     IF    ~!RprT.RprPlace & (RprPlace.Kind = L_Rpr.rpk_Retriever) THEN
      RETURN L_Rpr.ms_WaitRetriever;
     ELSIF L_Rpr.IsTechAidRprT(RprT.RprPlace) THEN
      RETURN L_Rpr.ms_WaitTechAid;
     ELSIF RprT.TaskKind = L_Rpr.tk_IndependentRepair THEN
      RETURN L_Rpr.ms_IndependentRepair;
     ELSIF ~!RprT.Sort & ~!RprT.RprPlace THEN
      RETURN L_Rpr.ms_Open;
     ELSE
      RETURN L_Rpr.ms_Waiting;
     END;
    ELSE
     RETURN L_Rpr.ms_Waiting;
    END; (* IF L_Rpr.HasRprTNotification()...*)
   END; (* IF RprT.Result = L_Rpr.tr_InProgress...*)
   NEXT(RprT);
  END; (* WHILE OCCURE(RprT) ... *)
  RETURN L_Rpr.ms_Open;
 END {GetOpenTaskStatus};

 PRIVATE PROCEDURE IsSelfReturn(): SCAL[2];
 BEGIN
  CONFORM(RprS, RprT);
  IF OCCURE(RprT) THEN
   CONFORM(RprT, RprPlace);
   RETURN (RprT.Result   = L_Rpr.tr_RequiredAnother) &
          ((RprT.TaskKind = L_Rpr.tk_IndependentRepair) | (RprPlace.Kind = L_Rpr.rpk_TechAid)) &
          ~NEXT(RprT);
  ELSE
   RETURN SELECT(RprP, RprJ, RprS.RprS, L_Rpr.v_EmptyIndexValue, L_Rpr.v_EmptyIndexValue, L_Rpr.rprpwho_RepairGroupChief);
  END;
 END {IsSelfReturn};

 PRIVATE PROCEDURE SetRprSDTS(VAR BegDTS, EndDTS: TIMESTAMP);
 BEGIN
  BegDTS :=L_DatTim.GetTIMESTAMP(RprS.OrdDate, RprS.OrdTime);
  IF ~!RprS.EDate THEN
   EndDTS:=L_DatTim.GetTIMESTAMP(RprS.EDate, RprS.ETime);
  ELSE
   SETEMPTY(EndDTS);
  END;
 END {SetRprSDTS};

 PRIVATE PROCEDURE TimeInt(B, E, B1, E1: TIMESTAMP): FLOAT;
 BEGIN
  IF B1 > B THEN
   B:=B1;
  END;
  IF !E THEN
   E:=L_DatTim.GetTIMESTAMP(MAXOF(DATE), 23:59);
  END;
  IF !E1 THEN
   E1:=L_DatTim.GetTIMESTAMP(MAXOF(DATE), 23:59);
  END;
  IF E1 < E THEN
   E:=E1;
  END;
  IF E >= B THEN
   RETURN E-B;
  ELSE
   RETURN 0;
  END;
 END {TimeInt};

 PRIVATE PROCEDURE intCheckRprSDTIntersection(Dir: NUMERIC[0]; ShowCrucialChoice: SCAL[2]);
  VAR
   Msg        : STRING[];
   Strong,
   Result     : SCAL[2];
   curRprS    : LIKE(RprS.RprS);
   maxEndDTS,
   minBegDTS,
   curBegDTS,
   curEndDTS,
   trgBegDTS,
   trgEndDTS  : TIMESTAMP;
   curClosed  : LIKE(RprS.Closed);
   curLocation: LIKE(RprS.Location);
 BEGIN
  curRprS    :=RprS.RprS;
  curClosed  :=RprS.Closed;
  curLocation:=RprS.Location;
  SetRprSDTS(curBegDTS, curEndDTS);
  Strong    :=~!curEndDTS & (RprS.Status # L_Rpr.ms_NeedRate);

  SAVE(RprS);
  SETSEL(RprS, CUCopy, RprS.CUCopy);
  SRCINSEL(RprS, EQ, , L_DatTim.GetDateOfTIMESTAMP(curBegDTS), L_DatTim.GetTimeOfTIMESTAMP(curBegDTS));

  LOOP
   IF    (Dir = -1) THEN
    WHILE PREV(RprS) & ((RprS.Parent = curRprS) | (RprS.RprS = curRprS) | (RprS.Status = L_Rpr.ms_Cancel)) DO
    END; (* WHILE PREV(RprS) & (RprS.Parent = curRprS)...*)
   ELSIF (Dir = +1) THEN
    WHILE NEXT(RprS) & ((RprS.Parent = curRprS) | (RprS.RprS = curRprS) | (RprS.Status = L_Rpr.ms_Cancel)) DO
    END; (* WHILE PREV(RprS) & (RprS.Parent = curRprS)...*)
   END;
   IF ~OCCURE(RprS) THEN
    EXIT;
   END;
   SetRprSDTS(trgBegDTS, trgEndDTS);

   Result:=TimeInt(curBegDTS, curEndDTS, trgBegDTS, trgEndDTS) # 0;
   IF Result &
      ((curBegDTS < SYSTIMESTAMP()) & (trgBegDTS < SYSTIMESTAMP())) |
      ((curBegDTS > SYSTIMESTAMP()) & (trgBegDTS > SYSTIMESTAMP())) THEN
     Msg:="㦥 祭 ਮ ६ ⮢|" +
          L_Rpr.GetFullRprObjT_AsStr() + "| |" +
          L_Str.PoolItem("|", curClosed)   + "  " + curRprS   + ": 믨ᠭ " + L_DatTim.TimestampStr(curBegDTS) + ",  " + L_DatTim.TimestampStr(curEndDTS) + "|" +
          L_Str.PoolItem("|", RprS.Closed) + "  " + RprS.RprS + ": 믨ᠭ " + L_DatTim.TimestampStr(trgBegDTS) + ",  " + L_DatTim.TimestampStr(trgEndDTS) +
          "| |" +
          "室 ࠭ 祭 ਮ|" +
          " ⥫쭮 ।   ᯫ";
    IF    Strong THEN
     L_General.Error(Msg);
    ELSIF ShowCrucialChoice THEN
     L_StdFrm.CrucialChoice(Msg, L_Rpr.GetRprSGroupName(curLocation));
    ELSE
     L_StdFrm.Choice(Msg);
    END
   END;
   EXIT;
  END;
  RESTORE(RprS);
 END {intCheckRprSDTIntersection};

 PRIVATE PROCEDURE CheckSingleAdditionalRprSDTIntersection();
  VAR
   curRprS,
   prnRprS  : LIKE(RprS.RprS);
   curOrdDTS,
   curEndDTS,
   prnOrdDTS,
   prnEndDTS: TIMESTAMP;
 BEGIN
  curRprS  :=RprS.RprS;
  curOrdDTS:=L_DatTim.GetTIMESTAMP(RprS.OrdDate, RprS.OrdTime);
  IF RprS.Closed THEN
   curEndDTS:=L_DatTim.GetTIMESTAMP(RprS.EDate, RprS.ETime);
  ELSE
   SETEMPTY(curEndDTS);
  END;

  SAVE(RprS);
  SEARCH(RprS, RprS, , RprS.Parent);
  prnRprS  :=RprS.RprS;
  prnOrdDTS:=L_DatTim.GetTIMESTAMP(RprS.OrdDate, RprS.OrdTime);
  IF RprS.Closed THEN
   prnEndDTS:=L_DatTim.GetTIMESTAMP(RprS.EDate, RprS.ETime);
  ELSE
   SETEMPTY(prnEndDTS);
  END;
  RESTORE(RprS);

  L_General.Assert(curOrdDTS >= prnOrdDTS,
                   "⥫      ࠭ ᭮ ||" +
                   "᭮        " + prnRprS + " ( " + L_DatTim.TimestampStr(prnOrdDTS) + ")|" +
                   "⥫  " + curRprS + " ( " + L_DatTim.TimestampStr(curOrdDTS) + ")");
  IF ~!prnEndDTS THEN
   L_General.Assert(curOrdDTS <= prnEndDTS,
                    "⥫      ᫥  ᭮ ||" +
                    "᭮        " + prnRprS + " ( " + L_DatTim.TimestampStr(prnEndDTS) + ")|" +
                    "⥫  " + curRprS + " ( " + L_DatTim.TimestampStr(curOrdDTS) + ")");
  END;

  L_General.Assert(curEndDTS <= prnEndDTS,
                   "⥫       ᭮ ||" +
                   "᭮        " + prnRprS + " ( " + L_DatTim.TimestampStr(prnEndDTS) + ")|" +
                   "⥫  " + curRprS + " ( " + L_DatTim.TimestampStr(curEndDTS) + ")");
 END {CheckSingleAdditionalRprSDTIntersection};

 PRIVATE PROCEDURE CheckAdditionalRprSDTIntersection();
 BEGIN
  SAVE(RprS);
  SELECT(RprS, Parent, , RprS.RprS);
  WHILE OCCURE(RprS) DO
   IF RprS.Status # L_Rpr.ms_Cancel THEN
    CheckSingleAdditionalRprSDTIntersection();
   END;
   NEXT(RprS);
  END; (* WHILE OCCURE(RprS) ... *)
  RESTORE(RprS);
 END {CheckAdditionalRprSDTIntersection};

 PRIVATE PROCEDURE CheckRprSDTIntersection(ShowCrucialChoice: SCAL[2]);
 BEGIN
  IF RprS.Leaf = 1 THEN
   CheckSingleAdditionalRprSDTIntersection();
  ELSE
   CheckAdditionalRprSDTIntersection();
   intCheckRprSDTIntersection(-1, ShowCrucialChoice);
   intCheckRprSDTIntersection(+1, ShowCrucialChoice);
  END;
 END {CheckRprSDTIntersection};

 PRIVATE PROCEDURE Set_ms_Pool(): STRING[];
 BEGIN
  RETURN  ""+
         "|⮢ ( ।  ᯫ)"+
         "|"+
         "|" + L_Str.PoolItem("।  ᯫ|ॢ  ﭨ '஢'", RprS.Status = L_Rpr.ms_NeedRate) +
         "|寮"+
         "|"+
         "|"+
         "|⫮"+
         "|" + L_Str.PoolItem("ਭ㤨⥫쭠 ।  ᯫ (ॡ ⠪஢)|ॡ ⠪஢", RprS.Status = L_Rpr.ms_Done);
 END {Set_ms_Pool};

 PRIVATE PROCEDURE SetRprSMirr(_Status: L_Rpr.tMirrorStatus);
  VAR
   _Group: STRING[];
   tryCnt: NUMERIC[0];
 BEGIN
  tryCnt:=0;
  LOOP
   TRY
    IF (_Status = L_Rpr.ms_Done) | (_Status = L_Rpr.ms_Cancel) THEN
     IF SEARCH(RprSMirr, RprS, RprS.RprS) THEN
      REMOVE(RprSMirr);
     END;
    ELSE
     L_Rpr.AccessOrigin();
     L_Car.StandOnCarLog(Car.BoxNbr, RprS.OrdDate);

     _Group:=L_Rpr.E_GetOpenRprSGroup();
     IF ~!_Group THEN
      IF ~SEARCH(RprSMirr, RprS, RprS.RprS) THEN
       RprSMirr.RprS  :=RprS.RprS;
       RprSMirr.Status:=_Status;
       RprSMirr.Group :=_Group;
       INSERT(RprSMirr);
      ELSE
       RprSMirr.Status:=_Status;
       RprSMirr.Group :=_Group;
       REPLACE(RprSMirr);
      END;
     ELSIF SEARCH(RprSMirr, RprS, RprS.RprS) THEN
      REMOVE(RprSMirr);
     END;
    END;
    EXIT;
   EXCEPT
   ELSE
   END; (* TRY *)
   INC(tryCnt);
   PROMPT("㭤 ... " + L_Str.IntStr(tryCnt));
   IF tryCnt > 20 THEN
    EXIT; (*?!?*)
   END;
  END; (* LOOP *)
 END {SetRprSMirr};

 PRIVATE PROCEDURE IsPutOffRprT(): SCAL[2];
 BEGIN
  CONFORM(RprS, RprT);
  WHILE OCCURE(RprT) DO
   IF  ((RprT.Result = L_Rpr.tr_PutOff) & P_Rpr.HasRprTPro(RprT.RprS, RprT.RprT, P_Rpr.P_RprTFailReason)) |
       IsOutsideOverhaul() | IsRetireRepair() THEN
    RETURN 1;
   END;
   NEXT(RprT);
  END; (* WHILE OCCURE(RprT) ... *)
  RETURN 0;
 END {IsPutOffRprT};

 PRIVATE PROCEDURE GetRprSActualStatus(): L_Rpr.tMirrorStatus;
  VAR
   _Status: L_Rpr.tMirrorStatus;
 BEGIN
  IF RprS.Closed THEN
   _Status:=RprS.Status;
  ELSE
   IF    HasOpenDefect() THEN
    IF    IsPutOffRprT() THEN
     RETURN L_Rpr.ms_PutOff;
    ELSIF ~L_Rpr.HasOpenRprTask() THEN
     IF IsSelfReturn() THEN
      _Status:=L_Rpr.ms_Return;
     ELSE
      IF ~SELECT(RprT, RprS, RprS.RprS) &
         SELECT(RprP, RprJ, RprS.RprS, L_Rpr.v_EmptyIndexValue, L_Rpr.v_EmptyIndexValue, L_Rpr.rprpwho_DrvDeclarant) &
         (RprS.Location = E_LocationForRegistrationFromLine()) THEN
       _Status:=L_Rpr.ms_WaitTechAid;
      ELSE
       _Status:=L_Rpr.ms_Waiting;
      END;
     END;
    ELSE
     _Status:=GetOpenTaskStatus();
    END;
   ELSE
    IF  L_Rpr.HasOpenRprTask() THEN
     _Status:=L_Rpr.ms_Open;
    ELSE
     _Status:=L_Rpr.ms_Ready;
    END;
   END; (* IF HasOpenDefect()...*)
  END;
  RETURN _Status;
 END {GetRprSActualStatus};

 PRIVATE PROCEDURE CheckExistRprT(Condition: SCAL[2];
                                  Msg      : STRING[]);
 BEGIN
  IF ~SELECT(RprT, RprS, RprS.RprS) THEN
   L_StdFrm.ConditionalCHOICE(Msg, Condition);
  END;
 END {CheckExistRprT};

 PRIVATE PROCEDURE RprSHasAdditionalRprS(): SCAL[2];
  VAR
   Result: SCAL[2];
 BEGIN
  SAVE(RprS);
  Result:=SELECT(RprS, Parent, RprS.RprS);
  RESTORE(RprS);
  RETURN Result;
 END {RprSHasAdditionalRprS};

 PRIVATE PROCEDURE CheckCarCompleteness();
  VAR
   Result: SCAL[2];
 BEGIN
  IF L_Rpr.IsRprS_w_Car() & L_CUC.EngineAcntLev() THEN
   Result:=0;
   L_Rpr.AccessOrigin();
   SELECT(MDocLCU, BoxNbr, , Car.BoxNbr, L_MDoc.st_Passed);
   WHILE OCCURE(MDocLCU) DO
    PROMPT(" " + MDocLCU.CUCopy);
    NARROWSEL(MDocLCU, CUCopy);
    CONFORM(MDocLCU, CUCopy);
    IF L_CUC.cucRole_IsEngine() & SRCINSEL(MDocLCU, LE, RprS.EDate) & L_CUC.IsCUAtCar(MDocLCU.OpKind) THEN
     IF    MDocLCU.OpKind = L_CUC.ok_toRsrv THEN
      L_General.Error(" " + Car.BoxNbr + ": ⥫ 뤠  १?");
     ELSIF (MDocLCU.OpKind = L_CUC.ok_Fixup) |
           (MDocLCU.OpKind = L_CUC.ok_Setting) THEN
      L_General.Assert(~Result, " " + Car.BoxNbr + ": ⠭   ⥫");
      Result:=1;
     ELSE
      L_General.CallUs(0);
     END;
    END; (* IF L_CUC.cucRole_IsEngine() &...*)
    NEXTINEXTENDEDSEL(MDocLCU, CUCopy);
   END; (* WHILE OCCURE(MDocLCU) ... *)
   L_General.Assert(Result, " " + Car.BoxNbr + ": 襭 ⭮ ,  ⠭   ⥫");
  END;
 END {CheckCarCompleteness};

 PRIVATE PROCEDURE CheckRprJEDT();
 BEGIN
  SAVE(RprT);
  CONFORM(RprJ, RprT);
  L_General.Assert(L_Rpr.CompareDT(RprJ.BDate, RprJ.BTime, RprT.JobBDate, RprT.JobBTime) >= 0,
                   "ᮮ⢥⢨ ६ 砫 ࠡ|" +
                   " ६ 砫 ६⭮ | |" +
                   "६ 砫 ࠡ            : " + L_Rpr.DateTimeToStr(RprJ.BDate, RprJ.BTime) + "|" +
                   "६ 砫 ६⭮ : " + L_Rpr.DateTimeToStr(RprT.JobBDate, RprT.JobBTime));
  L_General.Assert(L_Rpr.CompareDT(RprT.JobEDate, RprT.JobETime, RprJ.EDate, RprJ.ETime) >= 0,
                   "ᮮ⢥⢨ ६ 砭 ࠡ|" +
                   " ६ 砭 ६⭮ | |" +
                   "६ 砭 ࠡ            : " + L_Rpr.DateTimeToStr(RprJ.EDate, RprJ.ETime) + "|" +
                   "६ 砭 ६⭮ : " + L_Rpr.DateTimeToStr(RprT.JobEDate, RprT.JobETime));
  RESTORE(RprT);
 END {CheckRprJEDT};

 PRIVATE PROCEDURE RprP_MayUseInLowerLevel(_Who: LIKE(RprP.Who)): SCAL[2];
 BEGIN
  RETURN (_Who = L_Rpr.rprpwho_TechAidDrv)       |
         (_Who = L_Rpr.rprpwho_RepairGroupChief) |
         (_Who = L_Rpr.rprpwho_Executor)         |
         (_Who = L_Rpr.rprpwho_RetrieverDrv)     |
         (_Who = L_Rpr.rprpwho_Driver);
 END {RprP_MayUseInLowerLevel};

 PRIVATE PROCEDURE GetRprPLevel(): SCAL[3];
 BEGIN
  L_General.CallUs(OCCURE(RprP));
  RETURN L_Rpr.GetRprPLevel(RprP.RprS, RprP.RprT, RprP.RprJ);
 END {GetRprPLevel};

 PRIVATE PROCEDURE CheckSingleRprPWorkTimes();
  VAR
   BegDTS,
   EndDTS      : TIMESTAMP;
   begText,
   endText     : STRING[];
   begDate,
   endDate     : DATE;
   begTime,
   endTime     : TIME;
   curRprPLevel: SCAL[3];
 BEGIN
  L_General.Assert(~!RprP.BDate = ~!RprP.BTime, "  ६ 砫 ࠡ ᮭ |" +
                                                "   ६");
  L_General.Assert(~!RprP.EDate = ~!RprP.ETime, "  ६ 砭 ࠡ ᮭ |" +
                                                "   ६");
  IF !RprP.BDate & ~!RprP.EDate THEN
   L_General.Error("  ६ 砭 ࠡ ᮭ  |" +
                   " 㪠   ६ 砫 ࠡ");
  END;

  IF ~!RprP.BDate THEN
   BegDTS:=L_DatTim.GetTIMESTAMP(RprP.BDate, RprP.BTime);
   IF ~!RprP.EDate THEN
    EndDTS:=L_DatTim.GetTIMESTAMP(RprP.EDate, RprP.ETime);
    L_General.Assert(BegDTS < EndDTS, "६ 砫    ६ 砭");
   END;
  END;

  IF ~!RprP.BDate THEN
   curRprPLevel:=GetRprPLevel();
   GetTimesForRprP(RprP.RprS, RprP.RprT, RprP.RprJ, begDate, begTime, endDate, endTime);
   IF    curRprPLevel = L_Rpr.rprpl_RprS THEN
    begText   :=" ६⭮ ";
    endText   :=" ६⭮ ";
   ELSIF curRprPLevel = L_Rpr.rprpl_RprT THEN
    begText   :="砫 ࠡ  ६⭮ ";
    endText   :="砭 ࠡ  ६⭮ ";
   ELSIF curRprPLevel = L_Rpr.rprpl_RprJ THEN
    begText   :="砫 ६⭮ ࠡ";
    endText   :="砭 ६⭮ ࠡ";
   ELSE
    L_General.CallUs(0);
   END;
   L_General.Assert(L_Rpr.CompareDT(RprP.BDate, RprP.BTime, begDate, begTime) >= 0,
                    "ᮮ⢥⢨ ६ " + begText + "|" +
                    " ६ 砫 ࠡ ࠡ⭨ " + RprP.TSN + " (" + L_Str.PoolItem(L_Rpr.rprpwho_Pool, RprP.Who) + ")| |" +
                    "६ " + Str.Align(begText, 39, LEFT) + ": " + L_Rpr.DateTimeToStr(begDate, begTime) + "|" +
                    "६ 砫 ࠡ ᮭ " + GetRprPLevel_Short() + " (⠡ " + RprP.TSN + "): "  + L_Rpr.DateTimeToStr(RprP.BDate, RprP.BTime));
 
   L_General.Assert(L_Rpr.CompareDT(endDate, endTime, RprP.EDate, RprP.ETime) >= 0,
                    "ᮮ⢥⢨ ६ " + endText + "|" +
                    " ६ 砭 ࠡ ࠡ⭨ " + RprP.TSN + " (" + L_Str.PoolItem(L_Rpr.rprpwho_Pool, RprP.Who) + ")| |" +
                    "६ " + Str.Align(endText, 42, LEFT) + ": "   + L_Rpr.DateTimeToStr(endDate, endTime) + "|" +
                    "६ 砭 ࠡ ᮭ " + GetRprPLevel_Short() + " (⠡ " + RprP.TSN + "): " + L_Rpr.DateTimeToStr(RprP.EDate, RprP.ETime));
  END;
 END {CheckSingleRprPWorkTimes};

 PRIVATE PROCEDURE CheckRprPWorkTimes(trgRprS  : LIKE(RprS.RprS);
                                      trgRprT  : LIKE(RprT.RprT);
                                      trgRprJ  : LIKE(RprJ.RprJ));
 BEGIN
  SELECT(RprP, RprJ, , trgRprS, trgRprT, trgRprJ);
  WHILE OCCURE(RprP) DO
   PROMPT("஢ઠ ६ ࠡ ᮭ:  " + trgRprS + ",  " + FLDTOSTR(trgRprT) + ",  " + FLDTOSTR(trgRprJ));
   CheckSingleRprPWorkTimes();
   NEXT(RprP);
  END; (* WHILE OCCURE(RprP) ... *)
 END {CheckRprPWorkTimes};

 PRIVATE PROCEDURE RprP_CheckUniqueWho(_RprT: LIKE(RprT.RprT));
  VAR
   ErrMsg: STRING[];
 BEGIN
  SELECT(RprP, RprJ, , RprS.RprS, _RprT, L_Rpr.v_EmptyIndexValue);
  WHILE OCCURE(RprP) DO
   IF ~RprP_MayUseInLowerLevel(RprP.Who) THEN
    SAVE(RprP);
    SETEMPTY(ErrMsg);
    IF _RprT = L_Rpr.v_EmptyIndexValue THEN
     SELECT(RprP, RprS, , RprS.RprS, RprP.Who);
    ELSE
     SELECT(RprP, RprT, , RprS.RprS, _RprT, RprP.Who);
    END;
    WHILE OCCURE(RprP) DO
     IF _RprT = L_Rpr.v_EmptyIndexValue THEN
      IF RprP.RprT # L_Rpr.v_EmptyIndexValue THEN
       ErrMsg:="ᮭ ६⭮   " +
               "ᮭ " + L_Str.PoolItem("६⭮ |६⭮ |६⭮ ࠡ", GetRprPLevel());

      END;
     ELSE
      IF RprP.RprJ # L_Rpr.v_EmptyIndexValue THEN
       ErrMsg:="ᮭ ६⭮   " +
               "ᮭ " + L_Str.PoolItem("६⭮ |६⭮ |६⭮ ࠡ", GetRprPLevel());
      END;
     END;
     IF ~!ErrMsg THEN
      L_General.Error("'" + L_Str.PoolItem(L_Rpr.rprpwho_Pool, RprP.Who) + "'" +
                      "   ६ ⢮ |" +
                      ErrMsg);
     END;
     NEXT(RprP);
    END; (* WHILE OCCURE(RprP) ... *)
    RESTORE(RprP);
   END;
   NEXT(RprP);
  END; (* WHILE OCCURE(RprP) ... *)
 END {RprP_CheckUniqueWho};

 PRIVATE PROCEDURE RprJ_OnAfterModification(CloseRprSCheck: SCAL[2]);
 BEGIN
  L_General.Assert(~!RprJ.BDate = ~!RprJ.BTime, "  ६ 砫 ࠡ |" +
                                                "   ६");
  L_General.Assert(~!RprJ.EDate = ~!RprJ.ETime, "  ६ 砭 ࠡ |" +
                                                "   ६");
  L_General.Assert(RprJ.RprJ # 0, " ࠡ    00");
  L_General.Assert(L_Rpr.CompareDT(RprJ.EDate, RprJ.ETime, RprJ.BDate, RprJ.BTime) >= 0,
                   "ᮮ⢥⢨ ६ 砫 ࠡ|" +
                   " ६ 砭 ࠡ| |" +
                   "६ 砫 ࠡ   : " + L_Rpr.DateTimeToStr(RprJ.BDate, RprJ.BTime) + "|" +
                   "६ 砭 ࠡ: " + L_Rpr.DateTimeToStr(RprJ.EDate, RprJ.ETime));
  CheckSingleRprJBaseTime(CloseRprSCheck);
  IF ~!RprJ.EDate THEN
   L_General.Assert(L_Rpr.dti_GetDuration(RprJ.BDate, RprJ.BTime, RprJ.EDate, RprJ.ETime) # 0,
                    "㫥 த⥫쭮 ࠡ");
  END;
  CheckRprJEDT();
  RprP_CheckUniqueWho(RprJ.RprT);

  CheckRprPWorkTimes(RprS.RprS, RprJ.RprT, RprJ.RprJ);

  IF ~!RprJ.EDate THEN
   CheckSingleRprJ(CloseRprSCheck);
  END;
 END {RprJ_OnAfterModification};

 PRIVATE PROCEDURE CheckRprJOnCloseRprS();
  VAR
   trgSum: NUMERIC[0];
   IsAcceptableCalcRprJSum: SCAL[2];
 BEGIN
  IsAcceptableCalcRprJSum:=L_Rpr.AcceptableCalcRprJSum();
  SETEMPTY(trgSum);
  SAVE(RprJ);
  SELECT(RprJ, RprS, , RprS.RprS);
  WHILE OCCURE(RprJ) DO
   RprJ_OnAfterModification(1);
   IF IsAcceptableCalcRprJSum THEN
    L_General.Assert(~!RprJ.Sum, " N " + RprJ.RprT + ",  " + RprJ.RprJob + " (N " + RprJ.RprJ + "):|" +
                                 " । ⮨ ࠡ");
    IF !trgSum THEN
     SETZERO(trgSum);
    END;
    INC(trgSum, RprJ.Sum);
   END;
   NEXT(RprJ);
  END; (* WHILE OCCURE(RprJ) ... *)
  RESTORE(RprJ);

  IF IsAcceptableCalcRprJSum THEN
   L_General.Assert(~!trgSum, " । ⮨ ६");
   IF trgSum = 0 THEN
    L_StdFrm.Choice("㫥 ⮨ ६");
   END;
  END;
 END {CheckRprJOnCloseRprS};

 PRIVATE PROCEDURE CheckRprSSum();
  VAR
   trgSum: NUMERIC[0];
 BEGIN
  IF L_Rpr.AcceptableCalcRprJSum() THEN
   SETEMPTY(trgSum);
   SAVE(RprJ);
   SELECT(RprJ, RprS, , RprS.RprS);
   WHILE OCCURE(RprJ) DO
    L_General.Assert(~!RprJ.Sum, " । ⮨ ६⭮ ࠡ N " + RprJ.RprJ + ", ६⭮  N " + RprJ.RprT);
    IF !trgSum THEN
     SETZERO(trgSum);
    END;
    INC(trgSum, RprJ.Sum);
    NEXT(RprJ);
   END; (* WHILE OCCURE(RprJ) ... *)
   RESTORE(RprJ);
   L_General.Assert(~!trgSum, " । ⮨ ६");
   IF trgSum = 0 THEN
    L_StdFrm.Choice("㫥 ⮨ ६");
   END;
  END;
 END {CheckRprSSum};

 PRIVATE PROCEDURE ConditionalClose(trgStatus: L_Rpr.tMirrorStatus);
  VAR
   ChecklAllowed: SCAL[2];
 BEGIN
  CONFORM(RprS, RprDA);
  L_General.Assert(OCCURE(RprDA), " 㪠   ࠢ");
  IF RprS.Closed & (trgStatus # L_Rpr.ms_Cancel) & (trgStatus # L_Rpr.ms_NeedRate) &
    (HasOpenDefect() | L_Rpr.HasOpenRprTask() | HasOpenJob()) THEN
   L_General.Error(" ६    ᮤঠ|" +
                   " ࠭ ࠢ,|" +
                   " ६   ࠡ");
  END;

  IF L_Rpr.IsRprS_w_Car() THEN
   L_Rpr.AccessOrigin();
   ChecklAllowed:=L_Env.RealBoxNbr(Car.BoxNbr);
  ELSE
   ChecklAllowed:=1;
  END;

  IF    trgStatus = L_Rpr.ms_Return THEN
   IF ~L_StdFrm.RedAlternative("࠭ᯮ⭮ ।⢮ ᠬ⥫쭮|" +
                               "頥    ?") THEN
    trgStatus:=L_Rpr.ms_Waiting;
   END;
  ELSIF trgStatus = L_Rpr.ms_Done THEN
   CheckExistRprT(0, "   㪠   ");
   CheckFictRprDA();
   CheckRprJOnCloseRprS();

(*
   CheckCarCompleteness();
*)
   IF RprS.Location # L_Rpr.rprl_ControllerOffice THEN
    IF ChecklAllowed THEN
     IF L_Rpr.E_SpeedometerIndication_Required(RprS.OrdDate) THEN
      L_General.Assert(~!RprS.SMBef & ~!RprS.SMAft,
                       "室   ᯨ| 砫  砭 ६");
     END;
     IF L_Rpr.E_RemainsIndication_Required(RprS.OrdDate) THEN
      L_General.Assert(~!RprS.RemExit & ~!RprS.RemEntr,
                       "室 㪠 ⪨  | 砫  砭 ६");
     END;
    END;
   END;
  ELSIF trgStatus # L_Rpr.ms_Cancel THEN
   IF (GetInsertRprSMode() # irm_OutCarRprS) & (GetInsertRprSMode() # irm_OutCBlcRprS) THEN
    CheckExistRprT(1, "   㪠   ");
   END;

   IF ChecklAllowed                                        &
      (RprS.OrdDate <= SYSDATE())                          &
      L_Rpr.E_SpeedometerIndication_Required(RprS.OrdDate) &
      (GetInsertRprSMode() = irm_Usual) THEN
    L_General.Assert(~!RprS.SMBef,
                     "室   ᯨ  砫 ६");
   END;
  END;

  IF (trgStatus = L_Rpr.ms_Done) | (trgStatus = L_Rpr.ms_Cancel) THEN
   L_Rpr.CheckRprSMathRest(trgStatus);
  END;
  IF RprS.Status # trgStatus THEN
   IF (trgStatus = L_Rpr.ms_Done)   |
      (trgStatus = L_Rpr.ms_Cancel) |
      (trgStatus = L_Rpr.ms_NeedRate) THEN
    IF trgStatus # L_Rpr.ms_Cancel THEN
     E_ConditionalClose();
    END;
    IF !RprS.EDate THEN
     RprS.EDate:=SYSDATE();
     RprS.ETime:=SYSTIME();
    END;
    RprS.Closed:=1;
   END;
   RprS.Status:=trgStatus;
   REPLACE(RprS);
  END;

  IF trgStatus # L_Rpr.ms_Cancel THEN
   IF (trgStatus # L_Rpr.ms_NeedRate) | RprSHasAdditionalRprS() THEN
    CheckRprSDTIntersection(0);
   END;
   CheckRprSEDT();
  END;

  ProceedRprS(RprS.Closed);
  IF L_Rpr.IsRprS_w_Car() THEN
   SetRprSMirr(trgStatus);
   L_RT.rtc_PutByRprS();
  END;
 END {ConditionalClose};

 PRIVATE PROCEDURE PrintSingleUnprintedRprT(Silent: SCAL[2]);
 BEGIN
  IF RprT.CopyCnt = 0 THEN
   L_Rpr.E_PrintRprT(Silent);
  END;
 END {PrintSingleUnprintedRprT};

 PRIVATE PROCEDURE PrintAllUnprintedRprT();
 BEGIN
  TRY [TERMBYUSERMODE(TERMBYUSERMODE_IGNORE)]
   CONFORM(RprS, RprT);
   WHILE OCCURE(RprT) DO
    PrintSingleUnprintedRprT(0);
    NEXT(RprT);
   END; (* WHILE OCCURE(RprT) ... *)
  EXCEPT
  END;
 END {PrintAllUnprintedRprT};

 PUBLIC PROCEDURE PrintRprS();
 BEGIN
  L_Rpr.E_PrintRprS();
 END {PrintRprS};

 PUBLIC PROCEDURE PrintRprT();
 BEGIN
  L_Rpr.E_PrintRprT(0);
 END {PrintRprT};

 PUBLIC PROCEDURE PrintFlowSheet();
 BEGIN
  L_Rpr.PrintFlowSheet(0);
 END {PrintFlowSheet};

 PRIVATE PROCEDURE PrintUnprintedRprSwFirstRprT();
 BEGIN
  TRY [TERMBYUSERMODE(TERMBYUSERMODE_IGNORE)]
   IF RprS.CopyCnt = 0 THEN
    PrintRprS();
   END;
   CONFORM(RprS, RprT);
   PrintSingleUnprintedRprT(0);
  EXCEPT
  END;
 END {PrintUnprintedRprSwFirstRprT};

 PRIVATE PROCEDURE SetDefaultRprTBegTimes();
 BEGIN
  RprT.BDate   :=RprS.OrdDate;
  RprT.BTime   :=RprS.OrdTime;
  IF E_RprTJobBDTEqualRprTBegDT() THEN
   RprT.JobBDate:=RprT.BDate;
   RprT.JobBTime:=RprT.BTime;
  END;
  REPLACE(RprT);
 END {SetDefaultRprTBegTimes};

 PUBLIC PROCEDURE CreateAndPrintNonSpecificRprT();
 BEGIN
  L_Rpr.AccessRprS();
  IF L_StdFrm.Alternative("ନ    ᭮ ६⭮ ?") THEN

   DEFAULT(RprT);
   RprT.RprS    :=RprS.RprS;
   RprT.TaskKind:=L_Rpr.tk_Request;
   RprT.CopyCnt :=0;
   RprT.Result  :=L_Rpr.tr_InProgress;
   INSERT(RprT);

   SetDefaultRprTBegTimes();

   L_Rpr.E_PrintRprT(1);
  END;
 END {CreateAndPrintNonSpecificRprT};

 PRIVATE PROCEDURE SetFieldModifiable(Field: FORM_FIELD; Modifiable: SCAL[2]);
 BEGIN
  IF ~!Field THEN
   Field.Modifiable:=Modifiable;
  END;
 END {SetFieldModifiable};

 PRIVATE PROCEDURE SetRegistrationFromLineWinFieldFlagEdit();
  VAR
   RprTFlagEdit,
   JobBegDTFlagEdit: SCAL[2];
   Fields          : FORM_FIELDS;
 BEGIN
  RprTFlagEdit:=GetInsertRprSMode() # irm_IndependentRepair;
  Fields      :=RTI.Get().CurZone.Fields;
  SetFieldModifiable(Fields("Sort"), RprTFlagEdit);
  SetFieldModifiable(Fields("RprPlace"), RprTFlagEdit);
  SetFieldModifiable(Fields("Staff_1"),    RprTFlagEdit);
  JobBegDTFlagEdit := E_UseRprTJobBegDateTime();
  SetFieldModifiable(Fields("JobBDate"), JobBegDTFlagEdit);
  SetFieldModifiable(Fields("JobBTime"), JobBegDTFlagEdit);
 END {SetRegistrationFromLineWinFieldFlagEdit};

 PRIVATE PROCEDURE IsRegistrationFromLine(): SCAL[2];
  VAR
   InsertRprSMode: NUMERIC[0];
 BEGIN
  InsertRprSMode:=GetInsertRprSMode();
  RETURN (InsertRprSMode = irm_TechAid) |
         (InsertRprSMode = irm_Retriever) |
         (InsertRprSMode = irm_IndependentRepair);
 END {IsRegistrationFromLine};

 PRIVATE PROCEDURE CalcTaskLen(BDate   : DATE; BTime   : TIME;
                               plnEDate: DATE; plnETime: TIME): LIKE(RprT.TaskLen);
  CONST
   MaxTaskLen = MAXOF(RprT.TaskLen);
  VAR
   _TaskLen: NUMERIC[18, 2];
 BEGIN
  SETEMPTY(_TaskLen);
  IF ~!BDate & ~!BTime & ~!plnEDate & ~!plnETime THEN
   _TaskLen:=(plnEDate - BDate) * 24 + (-24 * (plnETime < BTime)) + (plnETime - BTime);
   IF    _TaskLen > MaxTaskLen THEN
    SETEMPTY(RTI.Get().CurZone.Fields("PlnEDate").Value, RTI.Get().CurZone.Fields("PlnETime").Value);
    L_General.Error("஫ ப 믮  " + FLDTOSTR(_TaskLen, "2.") + " .|" +
                    "ॢ蠥 ᨬ쭮 ⨬ (" + FLDTOSTR(MaxTaskLen, "2.") + " .)");
   ELSIF _TaskLen < 0 THEN
    L_General.Error("஫ ப 믮    ⥫");
   END;
  END;
  RETURN _TaskLen;
 END {CalcTaskLen};

 PRIVATE PROCEDURE RprTPlnEDateTimeOnSuccessfulChange();
  VAR
   Fields: FORM_FIELDS;
 BEGIN
  Fields:=RTI.Get().CurZone.Fields;
  IF IsRegistrationFromLine() THEN
   Fields("TaskLen").Value:=CalcTaskLen(RprS.OrdDate, RprS.OrdTime, Fields("PlnEDate").Value, Fields("PlnETime").Value);
  ELSE
   IF L_Rpr.HasRprTNotification() THEN
    RprT.TaskLen:=CalcTaskLen(RprT.JobBDate, RprT.JobBTime, Fields("PlnEDate").Value, Fields("PlnETime").Value);
    REPLACE(RprT);
   ELSE
    SETEMPTY(Fields("PlnEDate").Value, Fields("PlnETime").Value);
    L_General.Error(" 㪠 砫 ࠡ  ");
   END;
  END;
 END {RprTPlnEDateTimeOnSuccessfulChange};

 PRIVATE PROCEDURE RprT_PlnEDate_OnSuccessfulChange();
 BEGIN
  RprTPlnEDateTimeOnSuccessfulChange();
 END {RprT_PlnEDate_OnSuccessfulChange};

 PRIVATE PROCEDURE RprT_PlnETime_OnSuccessfulChange();
 BEGIN
  RprTPlnEDateTimeOnSuccessfulChange();
 END {RprT_PlnETime_OnSuccessfulChange};

 PRIVATE PROCEDURE CalcTaskLen_inDateTime();
  VAR
   Fields: FORM_FIELDS;
 BEGIN
  Fields:=RTI.Get().CurZone.Fields;
  IF ~!Fields("PlnEDate") & ~!Fields("PlnETime") THEN
   SETEMPTY(Fields("PlnEDate").Value, Fields("PlnETime").Value);
   IF IsRegistrationFromLine() THEN
    L_Rpr.GetEndDateTime(L_Rpr.GetEDTS(Fields("TaskLen").Value, Fields("JobBDate").Value, Fields("JobBTime").Value), Fields("PlnEDate").Value, Fields("PlnETime").Value);
   ELSE
    L_Rpr.GetEndDateTime(L_Rpr.GetEDTS(RprT.TaskLen, RprT.JobBDate,  RprT.JobBTime),  Fields("PlnEDate").Value, Fields("PlnETime").Value);
   END;
  END;
 END {CalcTaskLen_inDateTime};

 PRIVATE PROCEDURE GetTimesForRprP(    trgRprS : LIKE(RprS.RprS);
                                       trgRprT : LIKE(RprT.RprT);
                                       trgRprJ : LIKE(RprJ.RprJ);
                                   VAR trgBDate: DATE;
                                   VAR trgBTime: TIME;
                                   VAR trgEDate: DATE;
                                   VAR trgETime: TIME);
  VAR
   curRprPLevel: SCAL[3];
 BEGIN
  curRprPLevel:=L_Rpr.GetRprPLevel(trgRprS, trgRprT, trgRprJ);
  IF    curRprPLevel = L_Rpr.rprpl_RprS THEN
   trgBDate:=RprS.OrdDate;
   trgBTime:=RprS.OrdTime;
   trgEDate:=RprS.EDate;
   trgETime:=RprS.ETime;
  ELSIF curRprPLevel = L_Rpr.rprpl_RprT THEN
   trgBDate:=RprT.JobBDate;
   trgBTime:=RprT.JobBTime;
   trgEDate:=RprT.JobEDate;
   trgETime:=RprT.JobETime;
  ELSIF curRprPLevel = L_Rpr.rprpl_RprJ THEN
   trgBDate:=RprJ.BDate;
   trgBTime:=RprJ.BTime;
   trgEDate:=RprJ.EDate;
   trgETime:=RprJ.ETime;
  ELSE
   L_General.CallUs(0);
  END;
 END {GetTimesForRprP};

 PRIVATE PROCEDURE JobBDateTimeChange(IsEmpty: SCAL[2]);
 BEGIN
  IF IsEmpty THEN
   IF ~!RTI.Get().CurZone.Fields("PlnEDate").Value | ~!RTI.Get().CurZone.Fields("PlnETime").Value THEN
    L_StdFrm.Choice("  ਢ  㤠 ஫쭮 ப");
   END;
   IF IsRegistrationFromLine() THEN
    SETEMPTY(RTI.Get().CurZone.Fields("TaskLen").Value);
   ELSE
    SETEMPTY(RprT.TaskLen, RprT.JobBDate, RprT.JobBTime);
    REPLACE(RprT);

    IF RprT.Result # L_Rpr.tr_InProgress THEN
     L_StdFrm.Choice("  ਢ ⬥| ६⭮ ");
     RprT.Result:=L_Rpr.tr_InProgress;
     SETEMPTY(RprT.EDate, RprT.ETime);
     REPLACE(RprT);
    END;
   END;
  END;
  CalcTaskLen_inDateTime();
 END {JobBDateTimeChange};

 PRIVATE PROCEDURE SetTableFieldSDT(TableN,
                                    FieldN   : STRING[30];
                                    Date     : DATE;
                                    Time     : TIME;
                                    TimeKind : STRING[];
                                    wQuestion: SCAL[2]);
  VAR
   Fields       : FORM_FIELDS;
   NotEmptyField: SCAL[2];
 BEGIN
  L_General.CallUs(~!FieldN);
  NotEmptyField:=~!^TableN.^FieldN;
  IF ~NotEmptyField |
     ~wQuestion     |
     L_StdFrm.RedAlternative("⠭    ६ " + TimeKind + "?|" +
                             L_Rpr.DateTimeToStr(Date, Time)) THEN
   IF TableN = "RprS" THEN
    IF    (FieldN = "EDate")   | (FieldN = "ETime") THEN
     RprS.EDate:=Date;
     RprS.ETime:=Time;
    ELSIF (FieldN = "OrdDate") | (FieldN = "OrdTime") THEN
     RprS.OrdDate:=Date;
     RprS.OrdTime:=Time;
     REPLACE(RprS);
    END;
   ELSIF TableN = "RprT" THEN
    IF    (FieldN = "BDate") | (FieldN = "BTime") THEN
     RprT.BDate:=Date;
     RprT.BTime:=Time;
     SetJobBDateTime();
    ELSIF (FieldN = "JobBDate") | (FieldN = "JobBTime") THEN
     RprT.JobBDate:=Date;
     RprT.JobBTime:=Time;
     JobBDateTimeChange(!RprT.JobBDate | !RprT.JobBTime);
    ELSIF (FieldN = "JobEDate") | (FieldN = "JobETime") THEN
     RprT.JobEDate:=Date;
     RprT.JobETime:=Time;
    ELSIF (FieldN = "EDate") | (FieldN = "ETime") THEN
     RprT.EDate:=Date;
     RprT.ETime:=Time;
    END;
    REPLACE(RprT);
   ELSIF TableN = "RprJ" THEN
    IF    (FieldN = "BDate") | (FieldN = "BTime") THEN
     RprJ.BDate:=Date;
     RprJ.BTime:=Time;
    ELSIF (FieldN = "EDate") | (FieldN = "ETime") THEN
     RprJ.EDate:=Date;
     RprJ.ETime:=Time;
    END;
    REPLACE(RprJ);
   ELSIF TableN = "RprP" THEN
    IF    (FieldN = "BDate") | (FieldN = "BTime") THEN
     RprP.BDate:=Date;
     RprP.BTime:=Time;
     REPLACE(RprP);
     CalcRprPEndWorkTime();
    ELSIF (FieldN = "EDate") | (FieldN = "ETime") THEN
     RprP.EDate:=Date;
     RprP.ETime:=Time;
     REPLACE(RprP);
     CalcRprPWorkDuration(0);
    END;
   END;
  END;
 END {SetTableFieldSDT};

 PRIVATE PROCEDURE SetFormFieldSDT(VAR trgField : FORM_FIELD;
                                       Date     : DATE;
                                       Time     : TIME;
                                       TimeKind : STRING[];
                                       wQuestion: SCAL[2]);
  VAR
   Fields       : FORM_FIELDS;
   NotEmptyField: SCAL[2];
 BEGIN
  Fields:=RTI.Get().CurZone.Fields;
  NotEmptyField:=~!trgField.Value;
  IF ~NotEmptyField |
     ~wQuestion     |
      L_StdFrm.RedAlternative("⠭    ६ " + TimeKind + "?|" +
                              L_Rpr.DateTimeToStr(Date, Time)) THEN
   IF    (trgField.ExplicitName = "JobBDate") | (trgField.ExplicitName = "JobBTime") THEN
    Fields("JobBDate").Value:=Date;
    Fields("JobBTime").Value:=Time;
    RprTPlnEDateTimeOnSuccessfulChange();
   ELSIF (trgField.ExplicitName = "PlnEDate") | (trgField.ExplicitName = "PlnETime") THEN
    Fields("PlnEDate").Value:=Date;
    Fields("PlnETime").Value:=Time;
    RprTPlnEDateTimeOnSuccessfulChange();
   END;
  END;
 END {SetFormFieldSDT};

 PRIVATE PROCEDURE SetJobBDateTime();
 BEGIN
  IF ~E_UseRprTJobBegDateTime() THEN
   SetTableFieldSDT("RprT", "JobBDate", RprT.BDate, RprT.BTime, "", 0);
   JobBDateTimeChange(!RprT.JobBDate | !RprT.JobBTime);
  END;
 END {SetJobBDateTime};

 PRIVATE PROCEDURE SetFieldFormat(Field: FORM_FIELD; Format: STRING[]);
 BEGIN
  IF ~!Field THEN
   Field.Format:=Format;
  END;
 END {SetFieldFormat};

 PRIVATE PROCEDURE SetAllRprPools();
  VAR
   Zone      : FORM_ZONE;
   Fields    : FORM_FIELDS;
 BEGIN
  FOR_EACH Zone IN RTI.Get().CurWindow.Zones DO
   Fields:=Zone.Fields;
   SetFieldFormat(Fields("RprS_RprObjT"),         L_Rpr.rot_Pool);
   SetFieldFormat(Fields("RprP_Who"),             L_Rpr.rprpwho_Pool);
   SetFieldFormat(Fields("RprDA_WhenBurn"),       L_Rpr.GetWhenBurn_Pool(0));
   SetFieldFormat(Fields("RprDA_WhenBurn_Short"), L_Rpr.GetWhenBurn_Pool(1));
   SetFieldFormat(Fields("RprDA_Fixed"),          L_Rpr.GetFixed_Pool(0));
   SetFieldFormat(Fields("RprDA_Fixed_Short"),    L_Rpr.GetFixed_Pool(1));
   SetFieldFormat(Fields("RprT_TaskKind"),        L_Rpr.rpr_TaskKind_Pool);
   SetFieldFormat(Fields("RprT_Result"),          L_Rpr.GetTaskResult_Pool(0));
   SetFieldFormat(Fields("RprT_Result_Short"),    L_Rpr.GetTaskResult_Pool(1));
   SetFieldFormat(Fields("RprT_JobBegin"),        "-|+");
   SetFieldFormat(Fields("RprT_JobEnd"),          "-|+");
   SetFieldFormat(Fields("RprJob_Type"),          L_Rpr.GetRprJobType_Pool(0));
   SetFieldFormat(Fields("RprJob_Type_Short"),    L_Rpr.GetRprJobType_Pool(1));
  END; (* FOR_EACH Zone IN ...*)
 END {SetAllRprPools};

 PRIVATE PROCEDURE PrepareRprPro_Pool(): STRING[];
 BEGIN
  RETURN P_Rpr.GetPool(P_Rpr.P_Location);
 END {PrepareRprPro_Pool};

 PRIVATE PROCEDURE GetManName(trgTSN: LIKE(Staff.TSN)): STRING[];
 BEGIN
  L_General.Assert(SEARCH(Staff, TSN, trgTSN),
                   " ࠢ筨   ⠡ " + trgTSN);
  CONFORM(Staff, Man);
  RETURN Man.Name;
 END {GetManName};

 PRIVATE PROCEDURE GetManClrPhones(trgTSN: LIKE(Staff.TSN)): STRING[];
  VAR
   Result: STRING[];
 BEGIN
  Result:=L_Rpr.GetManClrPhones(trgTSN, RprS.OrdDate);
  IF !Result THEN
   Result:=" ";
  END;
  RETURN Result;
 END {GetManClrPhones};

 PRIVATE PROCEDURE GetFileName(_Who: LIKE(RprP.Who)): STRING[];
 BEGIN
  L_General.Assert(~!_Who, " 㪠 ஫ ᮭ");
  IF    _Who = L_Rpr.rprpwho_AnyDeclarant THEN
   RETURN "Staff";
  ELSIF _Who = L_Rpr.rprpwho_DrvDeclarant THEN
   IF E_NeedUseStaff_ForDrvDeclarant() THEN
    RETURN "Staff";
   ELSE
    RETURN "RWayS";
   END;
  ELSE
   IF E_NeedUseRprStaff() THEN
    RETURN "RprStaff";
   ELSE
    RETURN "Staff";
   END;
  END;
 END {GetFileName};

 PRIVATE PROCEDURE StandOnRWaySByTSN(_TSN: LIKE(Staff.TSN)): SCAL[2];
  VAR
   Result: SCAL[2];
 BEGIN
  IF ~E_NeedUseStaff_ForDrvDeclarant() THEN
   L_Rpr.AccessOrigin();
   Result:=SELECT(RWayS, sBoxNbr, L_Way.rwsStat_Given, Car.BoxNbr, RprS.OrdDate);
   IF ~!_TSN THEN
    WHILE OCCURE(RWayS) DO
     IF RWayS.TSN = _TSN THEN
      RETURN 1;
     END;
     NEXT(RWayS);
    END; (* WHILE OCCURE(RWayS)...*)
    RETURN 0;
   ELSE
    RETURN Result;
   END;
  END;
  RETURN 0;
 END {StandOnRWaySByTSN};

 PRIVATE PROCEDURE _PositionInGuide(_TSN: LIKE(Staff.TSN);
                                    _Who: LIKE(RprP.Who)): SCAL[2];
 BEGIN
  IF    _Who = L_Rpr.rprpwho_AnyDeclarant THEN
   RETURN SEARCH(Staff, TSN, _TSN)
  ELSIF _Who = L_Rpr.rprpwho_DrvDeclarant THEN
   IF E_NeedUseStaff_ForDrvDeclarant() THEN
    RETURN SEARCH(Staff, TSN, _TSN)
   ELSE
    RETURN StandOnRWaySByTSN(_TSN);
   END;
  ELSE
   IF E_NeedUseRprStaff() THEN
    RETURN SEARCH(RprStaff, RprTSN, L_Rpr.v_rprs_BegDate, L_Rpr.v_rprs_Shift, _TSN)
   ELSE
    RETURN SEARCH(Staff, TSN, _TSN)
   END;
  END;
 END {_PositionInGuide};

 PRIVATE PROCEDURE PositionInGuide(_TSN: LIKE(Staff.TSN);
                                   _Who: LIKE(RprP.Who));
  VAR
   AccessDataMode: NUMERIC[0];
 BEGIN
  AccessDataMode:=TABLE.Get(GetFileName(_Who)).AccessDataMode;
  TABLE.Get(GetFileName(_Who)).AccessDataMode:=adm_SOFT;
  IF _PositionInGuide(_TSN, _Who) THEN
   SE_WZD_POSITION(RTI.Get().TrgWindow.Name, RTI.Get().TrgZone.Number, ^(GetFileName(_Who)));
  END;
  TABLE.Get(GetFileName(_Who)).AccessDataMode:=AccessDataMode;
 END {PositionInGuide};

 PRIVATE PROCEDURE GetTSNFromGuide(_Who: LIKE(RprP.Who)): LIKE(Staff.TSN);
 BEGIN
  IF    _Who = L_Rpr.rprpwho_AnyDeclarant THEN
   RETURN Staff.TSN;
  ELSIF _Who = L_Rpr.rprpwho_DrvDeclarant THEN
   IF E_NeedUseStaff_ForDrvDeclarant() THEN
    RETURN Staff.TSN;
   ELSE
    RETURN RWayS.TSN;
   END;
  ELSE
   IF E_NeedUseRprStaff() THEN
    RETURN RprStaff.TSN;
   ELSE
    RETURN Staff.TSN;
   END;
  END;
 END {GetTSNFromGuide};

 PRIVATE PROCEDURE RprSE_0_OnZoneOpen();
 BEGIN
  SetAllRprPools();
  SetFieldFormat(RTI.Get().CurZone.Fields("RprS.Status"), L_Rpr.GetRprSStatus_Pool(0));
 END {RprSE_0_OnZoneOpen};

 PRIVATE PROCEDURE SinglePutOffDfApr_CancelTransfer();
 BEGIN
  SAVE(RprDA);
  L_General.CallUs(SEARCH(RprDA, RprS, RprDA.FRprS, RprDA.RprDfApr));
  RprDA.Fixed:=L_Rpr.daf_PutOff;
  REPLACE(RprDA);
  RESTORE(RprDA);
 END {SinglePutOffDfApr_CancelTransfer};

 PRIVATE PROCEDURE IsTransferredRprDA(): SCAL[2];
 BEGIN
  RETURN ~!RprDA.FRprS & (RprDA.Fixed # L_Rpr.daf_Transference);
 END {IsTransferredRprDA};

 PRIVATE PROCEDURE RprSAlreadyHasTransferredRprDA(): SCAL[2];
 BEGIN
  SELECT(RprDA, RprS, , RprS.RprS);
  WHILE OCCURE(RprDA) DO
   IF IsTransferredRprDA() THEN
    RETURN 1;
   END;
   NEXT(RprDA);
  END; (* WHILE OCCURE(RprDA) ... *)
  RETURN 0;
 END {RprSAlreadyHasTransferredRprDA};

 PRIVATE PROCEDURE PutOffDfApr_CancelTransfer(wMessage: SCAL[2]);
 BEGIN
  IF    RprSAlreadyHasTransferredRprDA() THEN
   L_StdFrm.Choice(" ࠭ ७ᥭ  㣨|६ ⮢ ⫮ ࠢ");
   SELECT(RprDA, RprS, , RprS.RprS);
   WHILE OCCURE(RprDA) DO
    IF IsTransferredRprDA() THEN
     SinglePutOffDfApr_CancelTransfer();
     REMOVE(RprDA);
    ELSE
     NEXT(RprDA);
    END;
   END; (* WHILE OCCURE(RprDA) ... *)
  ELSIF wMessage THEN
   L_StdFrm.Inform("    ७ᥭ ࠢ⥩");
  END;
 END {PutOffDfApr_CancelTransfer};

 PRIVATE PROCEDURE InsRprDA(_RprS,
                            _FRprS   : LIKE(RprS.RprS);
                            _RprDfApr: LIKE(RprDfApr.RprDfApr);
                            _Comment : LIKE(RprDA.Comment);
                            _WhenBurn: LIKE(RprDA.WhenBurn);
                            _Fixed   : LIKE(RprDA.Fixed));
 BEGIN
  IF ~!_RprDfApr THEN
   SEARCH(RprDfApr, RprDfApr, , _RprDfApr);
   DEFAULT(RprDA);
   RprDA.RprS    :=_RprS;
   RprDA.FRprS   :=_FRprS;
   RprDA.RprDfApr:=_RprDfApr;
   RprDA.CarBlock:=RprDfApr.CarBlock;
   RprDA.Comment :=_Comment;
   RprDA.WhenBurn:=_WhenBurn;
   RprDA.Fixed   :=_Fixed;
   INSERT(RprDA);
  END;
 END {InsRprDA};

 PRIVATE PROCEDURE InsertPutOffDfApr(wMessage,
                                     wQuestion: SCAL[2];
                                     Action   : SCAL[100]);
  VAR
   PutOffDfAprList       : STRING[];
   Amount,
   Result                : NUMERIC[0];
   PutOffDfAprWasInserted: SCAL[2];
 BEGIN
  L_Rpr.AccessRprS();
  CONFORM(RprS, CUCopy);
  IF E_MayInsertPutOffDfApr(Action) THEN
   IF (Action = ipoda_Manual) | ~RprSAlreadyHasTransferredRprDA() THEN
    PutOffDfApr_CancelTransfer(0);
    L_Rpr.lpoda_Create();
    L_Rpr.lpoda_GatherCar(RprS.CUCopy, 1, 0);
    SETEMPTY(PutOffDfAprList);
    SELECT(lpoda, RprDfApr);
    WHILE OCCURE(lpoda) DO
     CONFORM(lpoda, RprDfApr);
     PutOffDfAprList:=PutOffDfAprList + Str.Align(RprDfApr.RprDfApr + " " + RprDfApr.Name, 69, LEFT) + " ( " + lpoda.RprS + ")" + "|";
     NEXT(lpoda);
    END; (* WHILE OCCURE(lpoda) ... *)

    PutOffDfAprWasInserted:=0;
    Amount:=Math.Max(AMOUNT(lpoda), 5);

    IF    ~!PutOffDfAprList THEN
     Result:=0;
     IF ~wQuestion |
        STDFORM(L_StdFrm.PartForm("%L," + L_Str.IntStr(Amount)  + "<"+PutOffDfAprList+">NI"+
                                  "%<   ७   >DB"+
                                  "%<  ७ >X"+
                                  "@"+
                                  "|" +
                                  Str.Align(L_Rpr.GetFullRprObjT_AsStr() + " " + L_Rpr.GetRprSObjDescr(), 83 + 2, LEFT) +
                                  "|" +
                                  "|%###################################################################################%" +
                                  L_Str.Repeat("|", Amount) +
                                  "|"+
                                  "|%###############%          %###############%"),
                                  " 㦥 ⫮ ࠢ ",
                                 INFORM,
                                 ,
                                 Result) THEN
      SELECT(lpoda, RprDfApr);
      WHILE OCCURE(lpoda) DO
       CONFORM(lpoda, RprDfApr);
       L_General.Assert(~SEARCH(RprDA, RprS, RprS.RprS, lpoda.RprDfApr),
                        " ६⭮  㦥 |" +
                        "७ᨬ ࠢ " + lpoda.RprDfApr + ", 㧥 (⥬) " + RprDfApr.CarBlock);

       SEARCH(RprDA, RprS, , lpoda.RprS, lpoda.RprDfApr);
       RprDA.Fixed:=L_Rpr.daf_Transference;
       REPLACE(RprDA);

       InsRprDA(RprS.RprS,
                lpoda.RprS,
                lpoda.RprDfApr,
                lpoda.Comment,
                lpoda.WhenBurn,
                L_Rpr.daf_ThereIs);
       PutOffDfAprWasInserted:=1;
       NEXT(lpoda);
      END; (* WHILE OCCURE(lpoda) ... *)
     END;
    ELSIF wMessage THEN
     L_StdFrm.Inform(L_Rpr.GetFullRprObjT_AsStr() + ":|  ⫮ ࠢ⥩");
    END;
    L_Rpr.lpoda_Purge();
    IF PutOffDfAprWasInserted & ((Action = ipoda_EditRprS) | (Action = ipoda_EnterBoxNbr)) THEN
     FIX_ALTERING();
    END;
   END;
  END;
 END {InsertPutOffDfApr};

 PRIVATE PROCEDURE rfl_DrvStandToRepair(Fields: FORM_FIELDS);
 BEGIN
  IF GetInsertRprSMode() = irm_IndependentRepair THEN
   Fields("TSN_1").Value    :=Fields("TSN_0").Value;
   Fields("ManName_1").Value:=Fields("ManName_0").Value;
  END;
 END {rfl_DrvStandToRepair};

 PRIVATE PROCEDURE InsertDeclarant(RegistrationFromLine: SCAL[2]);
  VAR
   _TSN   : LIKE(Staff.TSN);
   rprpWho: LIKE(RprP.Who);
   Fields : FORM_FIELDS;
 BEGIN
  Fields:=RTI.Get().CurZone.Fields;
  IF RegistrationFromLine THEN
   SETEMPTY(Fields("TSN_0").Value, Fields("ManName_0").Value);
   rfl_DrvStandToRepair(Fields);
   rprpWho:=L_Rpr.rprpwho_DrvDeclarant;
  ELSE
   rprpWho:=L_Rpr.rprpwho_AnyDeclarant;
   IF SELECT(RprP, RprJ, RprS.RprS, L_Rpr.v_EmptyIndexValue, L_Rpr.v_EmptyIndexValue, rprpWho) THEN
    REMOVE(RprP);
   END;
  END;
  SETEMPTY(_TSN);

  IF L_Rpr.IsRprS_w_Car() THEN
   IF StandOnRWaySByTSN(EMPTYOF(Staff.TSN)) THEN
    _TSN:=RWayS.TSN;
   END;
   IF ~!_TSN THEN
    IF RegistrationFromLine THEN
     Fields("TSN_0").Value         :=_TSN;
     Fields("ManName_0").Value     :=GetManName(_TSN);
     Fields("ManClrPhones_0").Value:=GetManClrPhones(_TSN);
     rfl_DrvStandToRepair(Fields);
    ELSE
     IF ~SELECT(RprP, RprJ, RprS.RprS, L_Rpr.v_EmptyIndexValue, L_Rpr.v_EmptyIndexValue, L_Rpr.rprpwho_DrvDeclarant, _TSN) THEN
      DEFAULT(RprP);
      RprP.RprS:=RprS.RprS;
      RprP.RprT:=L_Rpr.v_EmptyIndexValue;
      RprP.RprJ:=L_Rpr.v_EmptyIndexValue;
      RprP.Who :=rprpWho;
      RprP.TSN :=_TSN;
      INSERT(RprP);
     END;
    END;
   END;
  END;
 END {InsertDeclarant};

 PRIVATE PROCEDURE ClearRprPro(_Property: LIKE(Property.Property);
                               _RprT    : LIKE(RprT.RprT);
                               _RprJ    : LIKE(RprJ.RprJ));
 BEGIN
  IF P_Rpr.HasPro(RprS.RprS, _RprT, _RprJ, _Property) THEN
   REMOVE(RprPro);
  END;
 END {ClearRprPro};

 PRIVATE PROCEDURE PutRprPro(Msg      : STRING[];
                             _Property: LIKE(Property.Property);
                             _RprS    : LIKE(RprS.RprS);
                             _RprT    : LIKE(RprT.RprT);
                             _RprJ    : LIKE(RprJ.RprJ);
                             _ProVal  : STRING[]);
 BEGIN
  IF ~!_ProVal THEN
   IF !Msg |
      (STDFORM("|" +
               Msg +
               "|%<  ⪨ >DB      %<  >B      %< ⮯! >X",
               "",
               INFORM,
               1) = 1) THEN
    RprPro.RprS    :=_RprS;
    RprPro.RprT    :=_RprT;
    RprPro.RprJ    :=_RprJ;
    RprPro.Property:=_Property;
    RprPro.Value   :=_ProVal;
    INSERT(RprPro);
   END;
  END;
 END {PutRprPro};

 PRIVATE PROCEDURE CheckCarLocation(RegistrationFromLine: SCAL[2]; _BoxNbr: LIKE(Car.BoxNbr));
  VAR
   OrdDateTime: FLOAT;
   _State     : L_RT.trtc_State;
   Msg        : STRING[];
 BEGIN
  IF E_NeedCheckCarLocation(RprS.OrdDate) & ~RprS.Closed THEN
   IF ~!_BoxNbr & ~!RprS.OrdDate & ~!RprS.OrdTime THEN
    OrdDateTime:=L_DatTim.GetVARIANTDATE(RprS.OrdDate, RprS.OrdTime, 00);
    IF SELECT(rtCar, DDBoxNbr, L_BegRWS.DspDate(RprS.OrdDate, RprS.OrdTime), _BoxNbr) THEN
     L_RT.rtCar_StandOnActual(OrdDateTime);
     _State:=L_RT.GetrtCarState(OrdDateTime);
     SETEMPTY(Msg);
     IF RegistrationFromLine THEN
      IF (_State # L_RT.rtc_st_Work) & (_State # L_RT.rtc_st_ReturnDelay) THEN
       Msg:="࠭ᯮ⭮ ।⢮ " + _BoxNbr + "  " +
            L_DatTim.DateTimeStr(RprS.OrdDate, RprS.OrdTime) + "  室  |" +
            "(⥪饥 ﭨ: '" + L_Str.PoolItem(L_RT.rtc_st_Pool, _State) + "')";
      END;
     ELSE
      IF (_State = L_RT.rtc_st_Work) | (_State = L_RT.rtc_st_ReturnDelay) THEN
       Msg:="࠭ᯮ⭮ ।⢮ " + _BoxNbr + "  " +
            L_DatTim.DateTimeStr(RprS.OrdDate, RprS.OrdTime) + "   થ|" +
            "(⥪饥 ﭨ: '" + L_Str.PoolItem(L_RT.rtc_st_Pool, _State) + "')";
      END;
     END;
     IF ~!Msg THEN
      L_StdFrm.ConditionalCHOICE(Msg + "| |   ६ ⮬ 饭",
                                 L_General.IsOurSite());
     END;
    END;
   END; (* IF ~!_BoxNbr ... *)
  END; (* IF E_NeedCheckCarLocation *)
 END {CheckCarLocation};

 PRIVATE PROCEDURE CheckOutRprObjFirmAdaptability(trgFirm: LIKE(Firm.Firm); OnDate: DATE);
 BEGIN
  SEARCH(Firm, Firm, , trgFirm);
  L_General.Assert(L_DatTim.IsActive(OnDate, Firm.Begin, Firm.Till),
                   "ࠣ " + trgFirm + " " + P_Firm.FP_ContractorBriefName(trgFirm, OnDate) + "|" +
                   "    " + L_DatTim.DateStr(OnDate));
 END {CheckOutRprObjFirmAdaptability};

 PRIVATE PROCEDURE CheckMathAdaptability(trgMath: LIKE(Math.Math); OnDate: DATE);
 BEGIN
  SEARCH(Math, Math, , trgMath);
  L_General.Assert(L_DatTim.IsActive(OnDate, Math.Begin, Math.Till),
                   " " + trgMath + " " + Math.Name + "|" +
                   "    " + L_DatTim.DateStr(OnDate));
 END {CheckMathAdaptability};

 PRIVATE PROCEDURE MakeAdditionalRprS(): SCAL[2];
  VAR
   curRprS,
   trgParent : LIKE(RprS.RprS);
   curRprSDTS,
   trgRprSDTS: TIMESTAMP;
 BEGIN
  curRprS   :=RprS.RprS;
  curRprSDTS:=L_DatTim.GetTIMESTAMP(RprS.OrdDate, RprS.OrdTime);
  SAVE(RprS);
  SETEMPTY(trgParent);
  SELECT(RprS, cCUCopy, , 0, RprS.CUCopy);
  WHILE OCCURE(RprS) & !trgParent DO
   trgRprSDTS:=L_DatTim.GetTIMESTAMP(RprS.OrdDate, RprS.OrdTime);
   IF (RprS.RprS # curRprS) &
      (RprS.Leaf = 0) &
      (curRprSDTS >= trgRprSDTS) &
      (curRprSDTS < SYSTIMESTAMP()) &
      (trgRprSDTS < SYSTIMESTAMP()) THEN
    trgParent :=RprS.RprS;
   END;
   NEXT(RprS);
  END; (* WHILE OCCURE(RprS) ... *)
  RESTORE(RprS);

  IF ~!trgParent THEN
   L_StdFrm.Question(L_Rpr.GetFullRprObjT_AsStr() + ":|" +
                     "   " + trgParent + "  " + L_DatTim.TimestampStr(trgRprSDTS) + "||" +
                     " ⥪騩  ⥫?");
   RprS.Parent:=trgParent;
   RprS.Leaf  :=1;
   REPLACE(RprS);
  END;
  RETURN ~!trgParent;
 END {MakeAdditionalRprS};

 PRIVATE PROCEDURE E_GetNormHourPricePool(): STRING[];
  VAR
   Local: PROC;
 BEGIN
  Local:=PROCREF(E_Rpr.GetNormHourPricePool);
  IF ~!Local THEN
   RETURN Local();
  ELSE
   L_General.Error(" ஥ 楤 । ⮨ ମ-");
  END;
 END {E_GetNormHourPricePool};

 PRIVATE PROCEDURE SetNormHourPriceField();
  VAR
   i                : NUMERIC[0];
   NormHourPricePool: STRING[];
 BEGIN
  NormHourPricePool:=E_GetNormHourPricePool();
  i:=0;
  WHILE ~!L_Str.PoolItem(NormHourPricePool, i) DO
   INC(i);
  END;
  SetFieldModifiable(RTI.Get().CurZone.Fields("NormHourPrice"), ~!NormHourPricePool & (i > 1));
  RTI.Get().CurZone.Fields("NormHourPrice").Template        :=NormHourPricePool;
  L_Prop.PositionOnProperty(E_Prop.P_NormHourPrice);
  RTI.Get().CurZone.Fields("NormHourPrice").TemplateIsStrict:=(Property.Format = L_Prop.pf_StrongPool) | (Property.Format = L_Prop.pf_Special);
  IF i = 1 THEN
   RTI.Get().CurZone.Fields("NormHourPrice").Value:=L_Str.PoolItem(NormHourPricePool, i-1);
  END;
 END {SetNormHourPriceField};

 PRIVATE PROCEDURE RprS_Header_OnSuccessfulChange(wInsertPutOffDfApr: SCAL[2]);
  VAR
   RegistrationFromLine: SCAL[2];
 BEGIN
  IF ~!RprS.RprObjId THEN
   L_General.Assert(~!RprS.OrdDate, "   ଫ ");
   RegistrationFromLine := IsRegistrationFromLine();
   L_Rpr.AccessOrigin();
   IF    L_Rpr.IsRprS_w_Car() THEN
    L_Car.CheckAdaptability(Car.BoxNbr, RprS.OrdDate, 1);
    CheckCarLocation(RegistrationFromLine, Car.BoxNbr);
   ELSIF L_Rpr.IsRprS_w_OutCar() THEN
    L_General.Assert(L_DatTim.IsActive(RprS.OrdDate, OutCar.Begin, OutCar.Till),
                     "஭  " + OutCar.OutCar + " (᭮ " + OutCar.StateNbr + ")|"+
                     "     (" + L_DatTim.DateStr(RprS.OrdDate) + ")");
    CheckOutRprObjFirmAdaptability(OutCar.Firm, RprS.OrdDate);
   ELSIF L_Rpr.IsRprS_w_CarBlock() THEN
    L_General.Assert(CUCopy.Origin = L_CUC.o_Other, " " + CUCopy.CUCopy + "   ஬ ॣ");
    L_General.Assert(L_DatTim.IsActive(RprS.OrdDate, CUCopy.Begin, CUCopy.Till),
                     "ॣ " + CUCopy.CUCopy + " (" + CUCopy.Serial + ")|"+
                     "     (" + L_DatTim.DateStr(RprS.OrdDate) + ")");
    IF ~L_CUC.AccessMDocLCU(CUCopy.CUCopy, RprS.OrdDate) THEN
     L_StdFrm.Choice(" ॣ " + CUCopy.CUCopy + "   ਨ .||   㤥 ந⢮  ॣ?");
    ELSIF ~L_CUC.IsCUAtStock(MDocLCU.OpKind) THEN
     L_General.Error("ॣ " + CUCopy.CUCopy + "  室  ᪫  " + L_DatTim.DateStr(RprS.OrdDate));
    END;
   ELSIF L_Rpr.IsRprS_w_OutCBlc() THEN
    L_General.Assert(L_DatTim.IsActive(RprS.OrdDate, OutCBlc.Begin, OutCBlc.Till),
                     "஭ ॣ " + OutCBlc.OutCBlc + " (" + OutCBlc.Serial + ")|"+
                     "     (" + L_DatTim.DateStr(RprS.OrdDate) + ")");
    CheckOutRprObjFirmAdaptability(OutCBlc.Firm, RprS.OrdDate);
   ELSIF L_Rpr.IsRprS_w_Math() THEN
    CheckMathAdaptability(Math.Math, RprS.OrdDate);
   ELSE
    L_General.CallUs(0);
   END;

   IF (RprS.Leaf = 1) | ~MakeAdditionalRprS() THEN
    CheckRprSDTIntersection(1);
   END;

   InsertDeclarant(RegistrationFromLine);
   IF ~RegistrationFromLine & wInsertPutOffDfApr THEN
    InsertPutOffDfApr(0, E_wQuestionBeforeInsertPutOffDfApr(), ipoda_EnterBoxNbr);
   END;
  ELSE
   PutOffDfApr_CancelTransfer(0);
  END;

  IF L_Str.IsEqStrI(RTI.Get().CurWindow.OriginalName, "RprSE_SC") |
     L_Str.IsEqStrI(RTI.Get().CurWindow.OriginalName, "RprSE_WS") THEN
   SetNormHourPriceField();
  END;
 END {RprS_Header_OnSuccessfulChange};

 PRIVATE PROCEDURE E_GetAcceptableRprObjTByLocation(VAR AcceptableRprObjTByLocation: LIKE(RprS.RprObjT)[]);
  VAR
   Local: PROC;
 BEGIN
  SETEMPTY(AcceptableRprObjTByLocation);
  IF    L_Rpr.IsRepairZoneLocation(RprS.Location) THEN
   AcceptableRprObjTByLocation[0]:=L_Rpr.rot_Car;
  ELSIF RprS.Location = L_Rpr.rprl_MaintenanceZone THEN
   AcceptableRprObjTByLocation[0]:=L_Rpr.rot_Car;
   AcceptableRprObjTByLocation[1]:=L_Rpr.rot_OutCar;
  ELSIF RprS.Location = L_Rpr.rprl_ServiceCenter THEN
   AcceptableRprObjTByLocation[0]:=L_Rpr.rot_OutCar;
  ELSIF L_Rpr.IsWorkshopLocation(RprS.Location) THEN
   AcceptableRprObjTByLocation[0]:=L_Rpr.rot_CarBlock;
   AcceptableRprObjTByLocation[1]:=L_Rpr.rot_OutCBlc;
   AcceptableRprObjTByLocation[2]:=L_Rpr.rot_Math;
  ELSE
   L_General.CallUs(0);
  END;

  Local:=PROCREF(E_Rpr.GetAcceptableRprObjT);
  IF ~!Local THEN
   Local(AcceptableRprObjTByLocation);
  END;
 END {E_GetAcceptableRprObjTByLocation};

 PRIVATE PROCEDURE CheckAcceptableRprObjT();
  VAR
   i                          : NUMERIC[0];
   Msg                        : STRING[];
   IsAcceptableRprObjT        : SCAL[2];
   AcceptableRprObjTByLocation: LIKE(RprS.RprObjT)[3];
 BEGIN
  E_GetAcceptableRprObjTByLocation(AcceptableRprObjTByLocation);
  SETEMPTY(Msg);
  SETZERO(i, IsAcceptableRprObjT);
  WHILE (i <= HIGH(AcceptableRprObjTByLocation)) & ~!AcceptableRprObjTByLocation[i] & ~IsAcceptableRprObjT DO
   IsAcceptableRprObjT:=RprS.RprObjT = AcceptableRprObjTByLocation[i];
   Msg:=Msg + L_Str.PoolItem(L_Rpr.rot_Pool, AcceptableRprObjTByLocation[i]) + "|";
   INC(i);
  END;
  IF ~IsAcceptableRprObjT THEN
   L_General.Error("᪠ ⨥  ⮫쪮   ꥪ⮢ ६:||" + Msg);
  END;
 END {CheckAcceptableRprObjT};

 PRIVATE PROCEDURE RemoveUnusedMathCUCopy();
 BEGIN
  TRY [EXCEPTION_HANDLING(EXCEPTION_HANDLING_OFF), INTEGRITY(INTEGRITY_ON)]
   L_AR.GrantRightsForInteractiveModification();
   CONFORM(RprS, CUCopy);
   SETEMPTY(RprS.CUCopy);
   REPLACE(RprS);
   REMOVE(CUCopy);
  EXCEPT
  ON Exc: Exc_Root DO
   IF Exc.ErrorCode # L_General.ec_rt_NoDeleteUser THEN
    RAISE();
   END;
  END; (*TRY*)
 END {RemoveUnusedMathCUCopy};

 PRIVATE PROCEDURE RprS_RprObjT_OnSuccessfulChange();
 BEGIN
  IF ~!RprS.CUCopy THEN
   IF GE_PVALUE(RprS.RprObjT) = L_Rpr.rot_Math THEN
    RemoveUnusedMathCUCopy();
   END;
  END;
  SETEMPTY(RprS.RprObjId, RprS.CUCopy);
  REPLACE(RprS);
  CheckAcceptableRprObjT();
 END {RprS_RprObjT_OnSuccessfulChange};

 PRIVATE PROCEDURE FillRprObjAttr();
  VAR
   trgRprObjId: LIKE(RprS.RprObjId);
 BEGIN
  IF      L_Rpr.IsRprS_w_Car() THEN
   L_Prop.CheckScalValue(RprS.RprObjId, "", MAXOF(Car.BoxNbr));
   L_General.ErrorInteractive_NonExistentOwner(SEARCH(Car, BoxNbr, RprS.RprObjId));
   IF ~L_Env.RealBoxNbr(Car.BoxNbr) THEN
    L_StdFrm.Question(" ଫ  䨪⨢ ");
   END;
   RprS.RprObjT :=L_Rpr.rot_Car;
   trgRprObjId  :=L_Str.Repeat("0", Str.Length(FLDTOSTR(MAXOF(Car.BoxNbr), "", 0)) - Str.Length(RprS.RprObjId)) + RprS.RprObjId;
   RprS.CUCopy  :=Car.CUCopy;
   RprS.BoxNbr  :=Car.BoxNbr;
  ELSIF L_Rpr.IsRprS_w_OutCar() THEN
   L_General.ErrorInteractive_NonExistentOwner(SEARCH(OutCar, OutCar, RprS.RprObjId));
   RprS.RprObjT:=L_Rpr.rot_OutCar;
   trgRprObjId :=OutCar.OutCar;
   RprS.CUCopy :=OutCar.CUCopy;
   SETEMPTY(RprS.BoxNbr);
  ELSIF L_Rpr.IsRprS_w_CarBlock() THEN
   L_Prop.CheckScalValue(RprS.RprObjId, "", MAXOF(CUCopy.CUCopy));
   L_General.ErrorInteractive_NonExistentOwner(SEARCH(CUCopy, CUCopy, RprS.RprObjId));
   RprS.RprObjT :=L_Rpr.rot_CarBlock;
   trgRprObjId  :=L_Str.Repeat("0", Str.Length(FLDTOSTR(MAXOF(CUCopy.CUCopy), "", 0)) - Str.Length(RprS.RprObjId)) + RprS.RprObjId;
   RprS.CUCopy  :=CUCopy.CUCopy;
   SETEMPTY(RprS.BoxNbr);
  ELSIF L_Rpr.IsRprS_w_OutCBlc() THEN
   L_Prop.CheckScalValue(RprS.RprObjId, "", MAXOF(OutCBlc.OutCBlc));
   L_General.ErrorInteractive_NonExistentOwner(SEARCH(OutCBlc, OutCBlc, RprS.RprObjId));
   RprS.RprObjT :=L_Rpr.rot_OutCBlc;
   trgRprObjId  :=OutCBlc.OutCBlc;
   RprS.CUCopy  :=OutCBlc.CUCopy;
   SETEMPTY(RprS.BoxNbr);
  ELSIF L_Rpr.IsRprS_w_Math() THEN
   L_Prop.CheckScalValue(RprS.RprObjId, "", MAXOF(Math.Math));
   L_General.ErrorInteractive_NonExistentOwner(SEARCH(Math, Math, RprS.RprObjId));
   L_General.Assert(Math.Leaf, "⨬ ᯮ짮 㯯஢ ᥩ ");
   CONFORM(Math, CarUnit);
   L_General.Assert(!CarUnit.SNDate, "  " + Math.Math + " " + Math.Name + "|" +
                                     "  .||" +
                                     "ଫ   ६ ୮ ॣ ");

   IF ~SELECT(CUCopy, Math, Math.Math) THEN
    TRY
     L_AR.GrantRightsForInteractiveModification();
     DEFAULT(CUCopy);
     CUCopy.Begin :=SYSDATE();
     CUCopy.Origin:=L_CUC.o_Math;
     CUCopy.Math  :=Math.Math;
     CUCopy.Serial:=Math.Name;
     INSERT(CUCopy);
    EXCEPT
    ON Exc: Exc_Root DO
     RAISE();
    END; (* TRY *)
   ELSE
    L_General.CallUs(CUCopy.Origin = L_CUC.o_Math);
    SAVE(CUCopy);
    L_General.CallUs(~NEXT(CUCopy));
    RESTORE(CUCopy);
   END;

   RprS.RprObjT :=L_Rpr.rot_Math;
   trgRprObjId  :=L_Str.Repeat("0", Str.Length(FLDTOSTR(MAXOF(Math.Math), "", 0)) - Str.Length(RprS.RprObjId)) + RprS.RprObjId;
   RprS.CUCopy  :=CUCopy.CUCopy;
   SETEMPTY(RprS.BoxNbr);
  ELSE
   L_General.CallUs(0);
  END;

  TRY [EXCEPTION_HANDLING(EXCEPTION_HANDLING_OFF)]
   RprS.RprObjId:=trgRprObjId;
   REPLACE(RprS);
  EXCEPT
  ON Exc: Exc_Root DO
   IF L_General.IsUniquenessViolationException(Exc) THEN
    L_General.Error(L_Rpr.GetRprObjT_AsStr() + " " + trgRprObjId + ": 㦥  ,  " + L_DatTim.DateTimeStr(RprS.OrdDate, RprS.OrdTime));
   ELSE
    RAISE();
   END;
  END; (* TRY *)
 END {FillRprObjAttr};

 PRIVATE PROCEDURE SetRprJobBaseTime();
 BEGIN
  SELECT(RprJ, RprS, , RprS.RprS);
  WHILE OCCURE(RprJ) DO
   SetSingleRprJobBaseTime();
   NEXT(RprJ);
  END; (* WHILE OCCURE(RprJ) ... *)
 END {SetRprJobBaseTime};

 PRIVATE PROCEDURE RprObjId_OnSuccessfulChange(prvRprObjId: LIKE(RprS.RprObjId));
  VAR
   prnRprObjT    : LIKE(RprS.RprObjT);
   prnRprObjId   : LIKE(RprS.RprObjId);
   prnLocation   : LIKE(RprS.Location);
   DependentMDocs: L_XDoc.tXDocCollection;
   i             : NUMERIC[0];
 BEGIN
  FillRprObjAttr();
  SetRprJobBaseTime();
  RprS_Header_OnSuccessfulChange(1);
  IF L_Rpr.IsRprS_w_Car() THEN
   TRY
    L_AR.GrantRightsUnconditionally();
    DependentMDocs:=L_XDoc.GetDependentXDC(L_XDoc.curXDocId(L_XDoc.xdt_RprS), L_XDoc.xdt_MDoc);
    i:=0;
    WHILE L_XDoc.xdc_PositionOn(DependentMDocs, i) DO
     IF MDoc.Status = L_MDoc.st_Passed THEN
      L_General.Error(" , 易  ⥪騬 ,     ﭨ '஢'" +
                      L_StdFrm.HR() + "ਬ, " + L_MDoc.MDocStr(MDoc.MDocKind, MDoc.MDoc));
     END;
     MDoc.BoxNbr:=RprS.RprObjId;
     REPLACE(MDoc);
     INC(i);
    END; (* L_XDoc.xdc_PositionOn ... *)
   EXCEPT
   END; (* TRY *)
  END;
  IF L_Rpr.IsRprS_w_Math() & ~!prvRprObjId THEN
   RemoveUnusedMathCUCopy();
  END;

  IF RprS.Leaf = 0 THEN
   prnRprObjT :=RprS.RprObjT;
   prnRprObjId:=RprS.RprObjId;
   prnLocation:=RprS.Location;
   SAVE(RprS);
   IF SELECT(RprS, Parent, RprS.RprS) THEN
    L_StdFrm.CrucialChoice(" ꥪ ६   ⥫ ?",
                           L_Rpr.GetRprSGroupName(prnLocation));
    WHILE OCCURE(RprS) DO
     RprS.RprObjT :=prnRprObjT;
     RprS.RprObjId:=prnRprObjId;
     REPLACE(RprS);
     FillRprObjAttr();
     SetRprJobBaseTime();
     NEXT(RprS);
    END; (* WHILE OCCURE(RprS) ... *)
   END;
   RESTORE(RprS);
  END;
 END {RprObjId_OnSuccessfulChange};

 PRIVATE PROCEDURE RprS_RprObjId_OnSuccessfulChange();
 BEGIN
  RprObjId_OnSuccessfulChange(GE_PVALUE(RprS.RprObjId));
 END {RprS_RprObjId_OnSuccessfulChange};

 PRIVATE PROCEDURE RprS_RprObjId_OnBeforeAsk();
  VAR
   OwnerWin          : STRING[];
   trgRprObjT        : LIKE(RprS.RprObjT);
   IsBeforeAskForView: SCAL[2];
 BEGIN
  L_Rpr.AccessRprS();
  trgRprObjT        :=RprS.RprObjT;
  IsBeforeAskForView:=RTI.Get().CurZone.Processes(0).Kind = FORM_PROCESS.Kind_View;
  IF IsBeforeAskForView THEN
   trgRprObjT:=L_StdFrm.ShowListAsMenu_wInit(L_Rpr.rot_Pool, "롮 ꥪ ६", trgRprObjT);
  END;

  IF    trgRprObjT = L_Rpr.rot_Car THEN
   OwnerWin:="Car";
  ELSIF trgRprObjT = L_Rpr.rot_OutCar THEN
   OwnerWin:="OutCar";
  ELSIF trgRprObjT = L_Rpr.rot_CarBlock THEN
   IF IsBeforeAskForView THEN
    OwnerWin:="CUCopyA";
   ELSE
    OwnerWin:="Math00";
   END;
  ELSIF trgRprObjT = L_Rpr.rot_OutCBlc THEN
   OwnerWin:="OutCBlc";
  ELSIF trgRprObjT = L_Rpr.rot_Math THEN
   OwnerWin:="Math00";
  ELSE
   L_General.CallUs(0);
  END;

  RTI.Get().CurZone.ActiveField.OwnerWindowOriginalName:=OwnerWin;
  RTI.Get().CurZone.ActiveField.OwnerZoneNumber        :=1;
 END {RprS_RprObjId_OnBeforeAsk};

 PRIVATE PROCEDURE RprS_RprObjId_OnAskPhase1();
 BEGIN
  IF ~!RprS.CUCopy THEN
   L_Rpr.AccessOrigin();
   L_WDO.PositionInOwnerZoneOfActiveField(L_CUC.GetOriginFileName(CUCopy.Origin));
  END;
 END {RprS_RprObjId_OnAskPhase1};

 PRIVATE PROCEDURE RprS_RprObjId_OnAskPhase2();
  VAR
   Choice      : NUMERIC[0];
   trgRprObjId : LIKE(RprS.RprObjId);
   CUCopyList,
   CarBlockList: STRING[];
 BEGIN
  IF    L_Rpr.IsRprS_w_Car() THEN
   trgRprObjId:=Car.BoxNbr;
  ELSIF L_Rpr.IsRprS_w_OutCar() THEN
   trgRprObjId:=OutCar.OutCar;
  ELSIF L_Rpr.IsRprS_w_CarBlock() THEN
   SETEMPTY(CarBlockList, CUCopyList);
   SETSEL(CUCopy, Math, Math.Math);
   SRCINSEL(CUCopy, GT, , RprS.OrdDate);
   WHILE OCCURE(CUCopy) DO
    IF CUCopy.Origin = L_CUC.o_Other THEN
     PROMPT(CUCopy.CUCopy);
     CarBlockList:=CarBlockList + Str.Align(CUCopy.Serial, Str.MaxLength(CUCopy.Serial), LEFT) + " (" + CUCopy.CUCopy + ",  " + L_DatTim.DateStr(CUCopy.Begin) + ")|";
     CUCopyList  :=CUCopyList + CUCopy.CUCopy + "|";
    END;
    NEXT(CUCopy);
   END; (* WHILE OCCURE(CUCopy) ... *)
   L_General.Assert(~!CarBlockList, " " + Math.Name + ":  㠫    ஢");
   Choice:=L_StdFrm.ShowListAsMenu(CarBlockList, Math.Name + ": 롮 ");
   trgRprObjId:=L_Str.PoolItem(CUCopyList, Choice);
  ELSIF L_Rpr.IsRprS_w_OutCBlc() THEN
   trgRprObjId:=OutCBlc.OutCBlc;
  ELSIF L_Rpr.IsRprS_w_Math() THEN
   trgRprObjId:=Math.Math;
  ELSE
   L_General.CallUs(0);
  END;

  TRY [EXCEPTION_HANDLING(EXCEPTION_HANDLING_OFF)]
   RprS.RprObjId:=trgRprObjId;
   REPLACE(RprS);
  EXCEPT
  ON Exc: Exc_Root DO
   IF L_General.IsUniquenessViolationException(Exc) THEN
    L_General.Error(L_Rpr.GetRprObjT_AsStr() + " " + trgRprObjId + ": 㦥  ,  " + L_DatTim.DateTimeStr(RprS.OrdDate, RprS.OrdTime));
   ELSE
    RAISE();
   END;
  END; (* TRY *)
 END {RprS_RprObjId_OnAskPhase2};

 PRIVATE PROCEDURE RprS_RprObjId_OnAskForViewPhase1();
  VAR
   FileName: STRING[];
 BEGIN
  L_Rpr.AccessRprS();
  L_Rpr.AccessOrigin();
  FileName:=L_CUC.GetOriginFileName(CUCopy.Origin);
  IF RTI.Get().TrgZone.MasterTable.Name = FileName THEN
   L_WDO.PositionInOwnerZoneOfActiveField(FileName);
  END;
 END {RprS_RprObjId_OnAskForViewPhase1};

 PRIVATE PROCEDURE RprS_RprObjId_OnAskForViewPhase2();
  VAR
   Z            : FORM_ZONE;
   trgCUCopy    : LIKE(CUCopy.CUCopy);
   trgZoneNumber: NUMERIC[0];
 BEGIN
  SETEMPTY(trgCUCopy);
  IF    RTI.Get().TrgZone.MasterTable.Name = "Car" THEN
   trgCUCopy:=Car.CUCopy;
  ELSIF RTI.Get().TrgZone.MasterTable.Name = "OutCar" THEN
   trgCUCopy:=OutCar.CUCopy;
  ELSIF RTI.Get().TrgZone.MasterTable.Name = "CUCopy" THEN
   trgCUCopy:=CUCopy.CUCopy;
  ELSIF RTI.Get().TrgZone.MasterTable.Name = "OutCBlc" THEN
   trgCUCopy:=OutCBlc.CUCopy;
  ELSIF RTI.Get().TrgZone.MasterTable.Name = "Math" THEN
   IF SELECT(CUCopy, Math, Math.Math) THEN
    trgCUCopy:=CUCopy.CUCopy;
    L_General.CallUs(~NEXT(CUCopy));
   END;
  ELSE
   L_General.CallUs(0);
  END;

  IF ~!trgCUCopy & SELECT(RprS, CUCopy, trgCUCopy) THEN
   LAST(RprS);
   SETEMPTY(trgZoneNumber);
   FOR_EACH Z IN RTI.Get().CurWindow.Zones DO
    IF ~Z.Plane THEN
     TRY [EXCEPTIONHANDLING(EXCEPTIONHANDLING_OFF)]
      SE_WZD_POSITION(RTI.Get().CurWindow.Name, Z.Number, RprS);
      trgZoneNumber:=Z.Number;
      EXIT;
     EXCEPT
     ON Exc:Exc_RunTime DO
      IF Exc.ErrorCode # L_General.ec_rt_PosOutOfZoneSystemSelect THEN
       RAISE();
      END;
     ELSE
      RAISE();
     END; (* TRY *)
    END;
   END; (* FOR_EACH *)

   IF ~!trgZoneNumber THEN
    IF RTI.Get().CurZone.Number # trgZoneNumber THEN
     LIKEMENU(View, ". #" + L_Str.IntStr(trgZoneNumber));
    END;
   ELSE
    L_StdFrm.Inform(" ⥪饬   믮 樮஢    ࠭ ꥪ ६");
   END;
  ELSE
   L_StdFrm.Inform(" ꥪ ६     ");
  END;
 END {RprS_RprObjId_OnAskForViewPhase2};

 PRIVATE PROCEDURE RprS_OrdDate_OnSuccessfulChange();
 BEGIN
  RprS_Header_OnSuccessfulChange(0);
 END {RprS_OrdDate_OnSuccessfulChange};

 PRIVATE PROCEDURE SetRprSHeaderFieldModifiable(FlagEdit: SCAL[2]);
 BEGIN
  SetFieldModifiable(RTI.Get().CurZone.Fields("RprS_RprObjT"),  FlagEdit);
  SetFieldModifiable(RTI.Get().CurZone.Fields("RprS.RprObjId"), RprS.Leaf = 0);
 END {SetRprSHeaderFieldModifiable};

 PRIVATE PROCEDURE NeedFillXDocJrn(): SCAL[2];
 BEGIN
  RETURN !L_WDO.GetEnvVarValue(L_WDO.MWM);
 END {NeedFillXDocJrn};

 PRIVATE PROCEDURE IsRprSEEWindow(): SCAL[2];
 BEGIN
  RETURN RTI.Get().CurWindow.OriginalName = "RprSEE";
 END {IsRprSEEWindow};

 PRIVATE PROCEDURE RprS_OnBeforeEdIns(_Action: LIKE(XDocJrn.Action));
 BEGIN
  IF NeedFillXDocJrn() THEN
   L_XDoc.XDocJrn_Start(L_XDoc.xdt_RprS, L_XDoc.EmptyXDocKind, RprS.RprS, _Action);
  END;
  IF RTI.Get().CurWindow.OriginalName = "RprSE" THEN
   RTI.Get().CurWindow.Title:=L_Str.PoolItem("⥫ ६ | ", RprS.Leaf = 0);
  END;
 END {RprS_OnBeforeEdIns};

 PRIVATE PROCEDURE CanModifyRprSAssert(Text: STRING[]);
 BEGIN
  L_General.Assert(L_Rpr.CanModify(RprS.Location), Text);
 END {CanModifyRprSAssert};

 PRIVATE PROCEDURE intClearRprPTimes(trgRprS: LIKE(RprS.RprS);
                                     trgRprT: LIKE(RprT.RprT);
                                     trgRprJ: LIKE(RprJ.RprJ));
  VAR
   trgBDate: DATE;
   trgBTime: TIME;
   trgEDate: DATE;
   trgETime: TIME;
 BEGIN
  GetTimesForRprP(trgRprS, trgRprT, trgRprJ, trgBDate, trgBTime, trgEDate, trgETime);

  SELECT(RprP, RprJ, , trgRprS, trgRprT, trgRprJ);
  WHILE OCCURE(RprP) DO
   IF (RprP.BDate = trgBDate) & (RprP.BTime = trgBTime) &
      (RprP.EDate = trgEDate) & (RprP.ETime = trgETime) THEN
    SETEMPTY(RprP.BDate, RprP.BTime, RprP.EDate, RprP.ETime);
    REPLACE(RprP);
   END;
   NEXT(RprP);
  END; (* WHILE OCCURE(RprP) ... *)
 END {intClearRprPTimes};

 PRIVATE PROCEDURE ClearRprPTimes();
 BEGIN
  intClearRprPTimes(RprS.RprS, EMPTYOF(RprT.RprT), EMPTYOF(RprJ.RprJ));
  SELECT(RprT, RprS, , RprS.RprS);
  WHILE OCCURE(RprT) DO
   intClearRprPTimes(RprT.RprS, RprT.RprT, EMPTYOF(RprJ.RprJ));

   SELECT(RprJ, RprS, , RprT.RprS, RprT.RprT);
   WHILE OCCURE(RprJ) DO
    intClearRprPTimes(RprJ.RprS, RprJ.RprT, RprJ.RprJ);
    NEXT(RprJ);
   END; (* WHILE OCCURE(RprJ) ... *)
   NEXT(RprT);
  END; (* WHILE OCCURE(RprT) ... *)
 END {ClearRprPTimes};

 PRIVATE PROCEDURE RprS_OnBeforeEdit();
 BEGIN
  RprS_OnBeforeEdIns(L_XDoc.action_Edit);
  L_General.Assert(L_Rpr.E_RprSAcceptableAction(L_XDoc.action_Edit, RprS.Location),
                   "  筮 ࠢ  믮 ⮩ 樨");
  IF ~IsRprSEEWindow() THEN
   IF L_Rpr.CheckExistsFinalMDoc() THEN
    L_StdFrm.Choice(" ନ஢  ⥪饬  ⮢ 㬥.||" +
                    "஢  ᫥ ஢ ࠩ ⭮,|" +
                    "⮡   ਢ  ᮮ⢥⢨   .");
   END;
   SetRprSHeaderFieldModifiable(0);
   CanModifyRprSAssert("  㯥  ।஢,|" +
                       ".. 室  㣮 ஢|" +
                       "ᯮ ShiftEnter  ᬮ");
   ProceedRprS(0);
   InsertPutOffDfApr(0, 1, ipoda_EditRprS);
   ClearRprPTimes();
  END;
 END {RprS_OnBeforeEdit};

 PRIVATE PROCEDURE intChooseAction(_Action          : LIKE(XDocJrn.Action);
                                   Choice           : NUMERIC[0];
                                   List             : STRING[];
                                   VAR rprl_Selected: NUMERIC[0][]): NUMERIC[0];
  VAR
   Title: STRING[];
 BEGIN
  IF    _Action = L_XDoc.action_rprTransfer THEN
   Title:=" । ६⭮  ";
  ELSIF _Action = L_XDoc.action_Insert THEN
   Title:=" ⠢ ६⭮  ";
  ELSE
   L_General.CallUs(0);
  END;

  L_General.Assert(~!List, Title + "");
  IF (_Action = L_XDoc.action_Insert) & (Choice = 1) THEN
   Choice := 0;
  ELSE
   Choice := L_StdFrm.ShowListAsMenu(List, Title);
  END;
  RETURN rprl_Selected[Choice];
 END {intChooseAction};

 PRIVATE PROCEDURE CheckSingleAction(_Action          : LIKE(XDocJrn.Action);
                                     _Location        : L_Rpr.tRprSLocation;
                                     VAR Choice       : NUMERIC[0];
                                     VAR List         : STRING[];
                                     VAR rprl_Selected: NUMERIC[0][]);
  VAR
   Text: STRING[];
 BEGIN
  IF    _Action = L_XDoc.action_rprTransfer THEN
   Text :="।   ஢ ";
  ELSIF _Action = L_XDoc.action_Insert THEN
   Text :="⠢   ஢ ";
  ELSE
   L_General.CallUs(0);
  END;

  IF L_Rpr.E_RprSAcceptableAction(_Action, _Location) THEN
   rprl_Selected[Choice] := _Location;
   List                  := List + Text + L_Rpr.GetRprSLocation_AsStr(_Location) + "|";
   INC(Choice);
  END;
 END {CheckSingleAction};

 PRIVATE PROCEDURE ChooseAction(_Action: LIKE(XDocJrn.Action)): NUMERIC[0];
  VAR
   Choice       : NUMERIC[0];
   DestLocation : L_Rpr.tRprSLocation;
   List         : STRING[];
   rprl_Selected: NUMERIC[0][L_Rpr.rprl_Amount];
 BEGIN
  IF    _Action = L_XDoc.action_rprTransfer THEN
   CanModifyRprSAssert("। , 室饣  ஢ '" + L_Rpr.GetRprSLocation_AsStr(RprS.Location) + "'|" +
                       "ࠧ襭 襬 堭 ()  짮⥫,|" +
                       "室騬  㯯 짮⥫ 㯠  ⮬ ஢");
  END;

  Choice      :=0;
  List        :="";
  DestLocation:=0;
  WHILE DestLocation < L_Rpr.rprl_Amount DO
   CheckSingleAction(_Action, DestLocation, Choice, List, rprl_Selected);
   INC(DestLocation);
  END; (* WHILE DestLocation < L_Rpr.rprl_Amount...*)

  RETURN intChooseAction(_Action, Choice, List, rprl_Selected);
 END {ChooseAction};

 PRIVATE PROCEDURE PrepareCommonRegistrationRprSForm();
  VAR
   i     : NUMERIC[0];
   Fields: FORM_FIELDS;
 BEGIN
  Fields:=RTI.Get().CurZone.Fields;
  IF IsRegistrationFromLine() THEN
   i:=0;
   WHILE i < 2 DO
    SETEMPTY(Fields(L_WDO.Fld_wIdx("TSN", i)).Value,
             Fields(L_WDO.Fld_wIdx("ManName", i)).Value,
             Fields(L_WDO.Fld_wIdx("Who", i)).Value);
    INC(i);
   END; (* WHILE i < ...*)
   Fields("ManClrPhones_0").Value:=" ";

   SETEMPTY(Fields("JobBDate").Value,
            Fields("JobBTime").Value,
            Fields("Sort").Value,
            Fields("RprPlace").Value,
            Fields("RprPlaceKind").Value,
            Fields("TaskLen").Value,
            Fields("Location").Value);
   L_WDO.CreateFormLink("Sort", "");
   L_WDO.CreateFormLink("RprPlace", "");

  END; (* IF IsRegistrationFromLine()... *)

  i:=0;
  WHILE i < rfl_RprDA_Amount DO
   SETEMPTY(Fields(L_WDO.Fld_wIdx("RprDfApr", i)).Value,
            Fields(L_WDO.Fld_wIdx("CarBlock", i)).Value,
            Fields(L_WDO.Fld_wIdx("RprDA_Comment", i)).Value);
   L_WDO.extCreateFormLink("RprDfApr", "", i);
   L_WDO.extCreateFormLink("CarBlock", "", i);
   INC(i);
  END; (* WHILE i < ...*)
 END {PrepareCommonRegistrationRprSForm};

 PRIVATE PROCEDURE GetSpecificKindRprPlace(trgRprPlaceKind: LIKE(RprPlace.Kind)): LIKE(RprPlace.RprPlace);
  VAR
   Amount: NUMERIC[0];
   Result: LIKE(RprPlace.RprPlace);
 BEGIN
  SETEMPTY(Result);
  SETZERO(Amount);
  SELECT(RprPlace, Kind, , trgRprPlaceKind);
  WHILE OCCURE(RprPlace) DO
   IF L_DatTim.IsActive(SYSDATE(), RprPlace.Begin, RprPlace.Till) THEN
    Result:=RprPlace.RprPlace;
    INC(Amount);
   END;
   NEXT(RprPlace);
  END; (* WHILE OCCURE(RprPlace) ... *)
  IF Amount > 1 THEN
   SETEMPTY(Result);
  END;
  RETURN Result;
 END {GetSpecificKindRprPlace};

 PRIVATE PROCEDURE PrepareRegistrationFromLineRprSForm();
  VAR
   Fields: FORM_FIELDS;
 BEGIN
  Fields:=RTI.Get().CurZone.Fields;
  PrepareCommonRegistrationRprSForm();

  IF    GetInsertRprSMode() = irm_TechAid THEN
   Fields("Who_1").Value:=L_Rpr.rprpwho_TechAidDrv;
  ELSIF GetInsertRprSMode() = irm_Retriever THEN
   Fields("Who_1").Value:=L_Rpr.rprpwho_RetrieverDrv;
  ELSIF GetInsertRprSMode() = irm_IndependentRepair THEN
   Fields("Who_1").Value:=L_Rpr.rprpwho_Driver;
  ELSE
   L_General.CallUs(0);
  END;

  Fields("Who_0").Value:=L_Rpr.rprpwho_DrvDeclarant;

  SETEMPTY(Fields("PlnEDate").Value, Fields("PlnETime").Value);
  Fields("JobBDate").Value:=RprS.OrdDate;
  Fields("JobBTime").Value:=RprS.OrdTime;

  IF (GetInsertRprSMode() = irm_TechAid) | (GetInsertRprSMode() = irm_Retriever) THEN
   Fields("RprPlaceKind").Value:=E_GetRegistrationFromLineRprPlaceKind();
   IF SEARCH(Sort, Sort, L_Rpr.E_GetDefaultTechAidSort(Fields("RprPlaceKind").Value)) THEN
    Fields("Sort").Value:=Sort.Sort;
   END;
   Fields("RprPlace").Value:=GetSpecificKindRprPlace(Fields("RprPlaceKind").Value);
  END;
  Fields("CorrectionRequired_0").Value:=" ";
  Fields("CorrectionRequired_1").Value:=" ";
  Fields("CorrectionRequired_2").Value:=" ";

  SetRegistrationFromLineWinFieldFlagEdit();
 END {PrepareRegistrationFromLineRprSForm};

 CONST
  ClientSparesAmount = 5;

 PRIVATE PROCEDURE PrepareSpecificRegistrationRprSForm();
  VAR
   i     : NUMERIC[0];
   Fields: FORM_FIELDS;
 BEGIN
  SETZERO(InsertNewObjects);
  PrepareCommonRegistrationRprSForm();

  Fields:=RTI.Get().CurZone.Fields;
  IF    GetInsertRprSMode() = irm_OutCarRprS THEN
   RTI.Get().CurWindow.Title:="-  ६ ࠭ᯮ⭮ ।⢠" + " (" + L_Rpr.GetRprSLocation_AsStr(RprS.Location) + ")";
   SETEMPTY(Fields("OutCar").Value,
            Fields("StateNbr").Value,
            Fields("VIN").Value,
            Fields("EnginMod").Value,
            Fields("SaleDate").Value,
            Fields("ProdYear").Value,
            Fields("Mark").Value,
            Fields("MarkName").Value,
            Fields("MarkEnginTyp").Value,
            Fields("MarkEngVol").Value,
            Fields("MarkEngPower").Value,
            Fields("MarkEngPwKWt").Value,
            Fields("MarkEnginTypName").Value,
            Fields("FirmPhoneClr").Value,
            Fields("FirmPhonePST").Value,
            Fields("FirmPrtnrType").Value);
  ELSIF GetInsertRprSMode() = irm_OutCBlcRprS THEN
   RTI.Get().CurWindow.Title:="-  ६ ஭ ॣ" + " (" + L_Rpr.GetRprSLocation_AsStr(RprS.Location) + ")";
   SETEMPTY(Fields("OutCBlc").Value, Fields("Math").Value);
  ELSE
   L_General.CallUs(0);
  END;

  SETEMPTY(Fields("NormHourPrice").Value,
           Fields("Firm").Value,
           Fields("FirmName").Value,
           Fields("Contract").Value,
           Fields("Comment").Value);

  Fields("CorrectionRequired_0").Value:=" ";
  Fields("CorrectionRequired_1").Value:=" ";
  Fields("CorrectionRequired_2").Value:=" ";
  i:=0;
  WHILE i < ClientSparesAmount DO
   SETEMPTY(Fields("ClientSpares_" + L_Str.IntStr(i)).Value);
   INC(i);
  END;

  SetNormHourPriceField();
 END {PrepareSpecificRegistrationRprSForm};

 PRIVATE PROCEDURE SetOutCarAttrFieldModifiable(Modifiable: SCAL[2]);
 BEGIN
  SetFieldModifiable(RTI.Get().CurZone.Fields("VIN"),      Modifiable);
  SetFieldModifiable(RTI.Get().CurZone.Fields("EnginMod"), Modifiable);
  SetFieldModifiable(RTI.Get().CurZone.Fields("SaleDate"), Modifiable);
  SetFieldModifiable(RTI.Get().CurZone.Fields("ProdYear"), Modifiable);
 END {SetOutCarAttrFieldModifiable};

 PRIVATE PROCEDURE SetOutCarBlockAttrFieldModifiable(Modifiable: SCAL[2]);
 BEGIN
  SetFieldModifiable(RTI.Get().CurZone.Fields("OutCBlc"),  Modifiable);
  SetFieldModifiable(RTI.Get().CurZone.Fields("Math"),     0);
 END {SetOutCarBlockAttrFieldModifiable};

 PRIVATE PROCEDURE SetMarkAttrFieldModifiable(ModifiableMarkName, Modifiable: SCAL[2]);
 BEGIN
  SetFieldModifiable(RTI.Get().CurZone.Fields("MarkName"),     ModifiableMarkName);
  SetFieldModifiable(RTI.Get().CurZone.Fields("MarkEnginTyp"), Modifiable);
  SetFieldModifiable(RTI.Get().CurZone.Fields("MarkEngVol"),   Modifiable);
  SetFieldModifiable(RTI.Get().CurZone.Fields("MarkEngPwKWt"), Modifiable);
 END {SetMarkAttrFieldModifiable};

 PRIVATE PROCEDURE SetFirmAttrFieldModifiable(ModifiableFirmName: SCAL[2]);
 BEGIN
  SetFieldModifiable(RTI.Get().CurZone.Fields("FirmName"), ModifiableFirmName);
 END {SetFirmAttrFieldModifiable};

 PRIVATE PROCEDURE SetFirmContactAttrFieldModifiable(ModifiablePhoneClr, ModifiablePhonePST: SCAL[2]);
 BEGIN
  SetFieldModifiable(RTI.Get().CurZone.Fields("FirmPhoneClr"),  ModifiablePhoneClr);
  SetFieldModifiable(RTI.Get().CurZone.Fields("FirmPhonePST"),  ModifiablePhonePST);
 END {SetFirmContactAttrFieldModifiable};

 PRIVATE PROCEDURE RprS_OnBeforeInsert();
  VAR
   trgLocation                : L_Rpr.tRprSLocation;
   RprObjTModifiable,
   RegistrationFromLine       : SCAL[2];
   i,
   Choice                     : NUMERIC[0];
   List                       : STRING[];
   rprl_Selected              : NUMERIC[0][L_Rpr.rprl_Amount];
   _Leaf                      : LIKE(RprS.Leaf);
   prnRprS                    : LIKE(RprS.RprS);
   prnRprObjT                 : LIKE(RprS.RprObjT);
   prnRprObjId                : LIKE(RprS.RprObjId);
   AcceptableRprObjTByLocation: LIKE(RprS.RprObjT)[3];
 BEGIN
  SETEMPTY(prnRprS, prnRprObjId, prnRprObjT);
  _Leaf  :=0;
  prnRprS:=L_WDO.GetEnvVarValue("MainRprS");
  IF ~!prnRprS THEN
   _Leaf:=1;
   SAVE(RprS);
   SEARCH(RprS, RprS, , prnRprS);
   IF ~!RprS.Parent THEN
    prnRprS:=RprS.Parent;
   END;
   prnRprObjId:=RprS.RprObjId;
   prnRprObjT :=RprS.RprObjT;
   RESTORE(RprS);
  END;
  RprS.RprObjId:=prnRprObjId;
  RprS.RprObjT :=prnRprObjT;
  RprS.Parent  :=prnRprS;
  RprS.Leaf    :=_Leaf;
  REPLACE(RprS);

  IF ~!prnRprObjId THEN
   FillRprObjAttr();
  END;

  RegistrationFromLine := IsRegistrationFromLine();
  IF    RegistrationFromLine THEN
   trgLocation:=E_LocationForRegistrationFromLine();
   L_Rpr.CheckRights(trgLocation);
  ELSIF GetInsertRprSMode() = irm_OutCarRprS THEN
   Choice:=0;
   SETEMPTY(List);
   CheckSingleAction(L_XDoc.action_Insert, L_Rpr.rprl_MaintenanceZone, Choice, List, rprl_Selected);
   CheckSingleAction(L_XDoc.action_Insert, L_Rpr.rprl_ServiceCenter,   Choice, List, rprl_Selected);
   trgLocation:=intChooseAction(L_XDoc.action_Insert, Choice, List, rprl_Selected);
   L_AR.GrantRightsForInteractiveModification();
   SetOutCarAttrFieldModifiable(1);
   SetMarkAttrFieldModifiable(1, 1);
   SetFirmAttrFieldModifiable(1);
   SetFirmContactAttrFieldModifiable(1, 1);
  ELSIF GetInsertRprSMode() = irm_OutCBlcRprS THEN
   trgLocation:=L_Rpr.rprl_Workshop;
   L_Rpr.CheckRights(L_Rpr.rprl_Workshop);
   L_AR.GrantRightsForInteractiveModification();
   SetOutCarBlockAttrFieldModifiable(1);
   SetFirmAttrFieldModifiable(0);
   SetFirmContactAttrFieldModifiable(1, 1);
  ELSE
   trgLocation:=ChooseAction(L_XDoc.action_Insert);
  END;

  RprS.Location:=trgLocation;

  RprObjTModifiable:=0;
  IF !prnRprS THEN
   E_GetAcceptableRprObjTByLocation(AcceptableRprObjTByLocation);
   i:=0;
   WHILE (i <= HIGH(AcceptableRprObjTByLocation)) & ~!AcceptableRprObjTByLocation[i] DO
    INC(i);
   END;
   RprObjTModifiable:=i > 1;
  END;
  SetRprSHeaderFieldModifiable(RprObjTModifiable);

  IF !RprS.RprObjT THEN
   IF    L_Rpr.IsRepairZoneLocation(RprS.Location) THEN
    RprS.RprObjT:=L_Rpr.rot_Car;
   ELSIF L_Rpr.IsServiceCenterLocation(RprS.Location) THEN
    RprS.RprObjT:=L_Rpr.rot_OutCar;
   ELSIF L_Rpr.IsWorkshopLocation(RprS.Location) THEN
    IF    GetInsertRprSMode() = irm_OutCBlcRprS THEN
     RprS.RprObjT:=L_Rpr.rot_OutCBlc;
    ELSIF RprS.Location = L_Rpr.rprl_MathWorkshop THEN
     RprS.RprObjT:=L_Rpr.rot_Math;
    ELSE
     RprS.RprObjT:=L_Rpr.rot_CarBlock;
    END;
   ELSE
    L_General.Error(" ঠ   Location = " + RprS.Location);
   END;
  ELSE
   CheckAcceptableRprObjT();
  END;

  RprS.OrdDate :=SYSDATE();
  RprS.OrdTime :=SYSTIME();
  RprS.Status  :=L_Rpr.ms_Open;
  RprS.Closed  :=0;
  REPLACE(RprS);

  IF    RegistrationFromLine THEN
   PrepareRegistrationFromLineRprSForm();
  ELSIF (GetInsertRprSMode() = irm_OutCarRprS) | (GetInsertRprSMode() = irm_OutCBlcRprS) THEN
   PrepareSpecificRegistrationRprSForm();
  END;
  RprS_OnBeforeEdIns(L_XDoc.action_Insert);
 END {RprS_OnBeforeInsert};

 PUBLIC PROCEDURE InsertAdditionalRprS();
  VAR
   EnvParam: STRING[];
 BEGIN
  SETEMPTY(EnvParam);
  IF ACCESS(RprS) THEN
   EnvParam:="MainRprS=" + RprS.RprS;
  END;
  LIKEMENU(Ins, "@ " + EnvParam);
 END {InsertAdditionalRprS};

 PRIVATE PROCEDURE RprS_OnBeforeDelete();
 BEGIN
  L_General.Error("  饭, ᯮ '㫨஢'");
 END {RprS_OnBeforeDelete};

 PRIVATE PROCEDURE InsRprP(_RprT: LIKE(RprT.RprT);
                           _Who : LIKE(RprP.Who);
                           _TSN : LIKE(RprP.TSN));
 BEGIN
  IF ~!_TSN THEN
   IF ~SELECT(RprP, RprT, RprS.RprS, _RprT, _Who) THEN
    DEFAULT(RprP);
    RprP.RprS :=RprS.RprS;
    RprP.RprT :=_RprT;
    RprP.Who  :=_Who;
    INSERT(RprP);
   END;
   RprP.TSN:=_TSN;
   REPLACE(RprP);
  END;
 END {InsRprP};

 PRIVATE PROCEDURE InsRprDA_FL(trgRprDfApr: LIKE(RprDfApr.RprDfApr);
                               trgComment : LIKE(RprDA.Comment));
 BEGIN
  InsRprDA(RprS.RprS,
           EMPTYOF(RprS.RprS),
           trgRprDfApr,
           trgComment,
           L_Rpr.rprda_Exploitation,
           L_Rpr.tr_InProgress);
 END {InsRprDA_FL};

 PRIVATE PROCEDURE _Assert(Cond      : SCAL[2];
                           FieldDescr: STRING[]);
 BEGIN
  L_General.Assert(Cond, " '" + FieldDescr + "'    ");
 END {_Assert};

 PRIVATE PROCEDURE CheckFilligRprDA();
  VAR
   i     : NUMERIC[0];
   Fields: FORM_FIELDS;
 BEGIN
  Fields:=RTI.Get().CurZone.Fields;
  i     :=0;
  WHILE i < rfl_RprDA_Amount DO
   IF !Fields(L_WDO.Fld_wIdx("RprDfApr", i)).Value & ~!Fields(L_WDO.Fld_wIdx("RprDA_Comment", i)).Value THEN
    L_General.Error("  ਩  ⮩ ࠢ|" +
                    "ࠢ N " + L_Str.IntStr(i+1));
   END;

   InsRprDA_FL(Fields(L_WDO.Fld_wIdx("RprDfApr", i)).Value, Fields(L_WDO.Fld_wIdx("RprDA_Comment", i)).Value);
   INC(i);
  END; (* WHILE i < ...*)
 END {CheckFilligRprDA};

 PRIVATE PROCEDURE GetFirmCoverage(_PrtnrTyp: LIKE(Firm.PrtnrTyp)): L_ctc.tCoverage;
 BEGIN
  IF _PrtnrTyp = P_Firm.pt_Firm THEN
   RETURN L_ctc.cvc_Work;
  ELSE
   RETURN L_ctc.cvc_Home;
  END;
 END {GetFirmCoverage};

 PRIVATE CONST
  ino_Pool    = "|ન|ࠣ|. ⥫䮭|⥫䮭|ॣ";
  inoi_Amount = 6;

  inoi_OutCar   = 0;
  inoi_Mark     = 1;
  inoi_Firm     = 2;
  inoi_PhoneClr = 3;
  inoi_PhonePST = 4;
  inoi_OutCBlc  = 5;

 PRIVATE PERMANENT VAR
  WasAskProcess   : SCAL[2];
  InsertNewObjects: SCAL[2][inoi_Amount];

 PRIVATE PROCEDURE E_GetDefaultCtcKind(): LIKE(CtcKind.CtcKind);
 BEGIN
  IF Firm.PrtnrTyp = P_Firm.pt_Man THEN
   RETURN 10;
  ELSE
   RETURN 00;
  END;
 END {E_GetDefaultCtcKind};

 PRIVATE PROCEDURE getFV_String(FieldName: STRING[]): STRING[];
  VAR
   Field: FORM_FIELD;
 BEGIN
  Field:=RTI.Get().CurZone.Fields(FieldName);
  L_General.CallUs(~!Field);
  RETURN Field.Value;
 END {getFV_String};

 PRIVATE PROCEDURE InsertNewContact(inoIdx: NUMERIC[0]);
  VAR
   _FirmCtc: LIKE(FirmCtc.FirmCtc);
 BEGIN
  IF InsertNewObjects[inoIdx] THEN
   SETEMPTY(_FirmCtc);
   SELECT(FirmCtc, Firm, , Firm.Firm);
   WHILE OCCURE(FirmCtc) & !_FirmCtc DO
    IF L_DatTim.IsActive_Inc(RprS.OrdDate, FirmCtc.Begin, FirmCtc.Till) THEN
     _FirmCtc:=FirmCtc.FirmCtc;
    END;
    NEXT(FirmCtc);
   END; (* WHILE OCCURE(FirmCtc) ... *)

   IF !_FirmCtc THEN
    L_General.Assert(SEARCH(CtcKind, CtcKind, E_GetDefaultCtcKind()), "   ⠪ " + E_GetDefaultCtcKind());

    DEFAULT(Contact);
    Contact.Begin   :=RprS.OrdDate;
    Contact.Origin  :=L_ctc.o_FirmCtc;
    Contact.IsPerson:=L_ctc.CtcTypeIsPerson(CtcKind.Type);
    INSERT(Contact);
    L_APtm.SysLogHandler("Contact", L_SysLog.knd_AutoBuild);

    _FirmCtc:=0;
    IF SELECT(FirmCtc, Firm, Firm.Firm) THEN
     LAST(FirmCtc);
     _FirmCtc:=FirmCtc.FirmCtc;
    END;

    DEFAULT(FirmCtc);
    FirmCtc.Firm    :=Firm.Firm;
    FirmCtc.FirmCtc :=_FirmCtc + 1;
    FirmCtc.Contact :=Contact.Contact;
    FirmCtc.Begin   :=Contact.Begin;
    FirmCtc.CtcKind :=CtcKind.CtcKind;
    FirmCtc.CKType  :=CtcKind.Type;
    FirmCtc.Name    :=Firm.Name;
    IF ~Contact.IsPerson THEN
     FirmCtc.ECKName :=FirmCtc.Name;
    END;
    INSERT(FirmCtc);
    L_ctc.SetupContactNames(1);

    L_APtm.SysLogHandler("FirmCtc", L_SysLog.knd_AutoBuild);
   ELSE
    SELECT(FirmCtc, Firm, , Firm.Firm, _FirmCtc);
    CONFORM(FirmCtc, Contact);
   END;

   DEFAULT(CtcVal);
   CtcVal.Contact :=Contact.Contact;
   CtcVal.Begin   :=Contact.Begin;
   CtcVal.Coverage:=GetFirmCoverage(Firm.PrtnrTyp);
   IF inoIdx = inoi_PhoneClr THEN
    CtcVal.Type   :=L_ctc.cvt_PhoneClr;
    CtcVal.Value  :=getFV_String("FirmPhoneClr");
   ELSE
    CtcVal.Type   :=L_ctc.cvt_PhonePST;
    CtcVal.Value  :=getFV_String("FirmPhonePST");
   END;
   INSERT(CtcVal);
   L_ctc.SetCtcValInvValue();
   L_APtm.SysLogHandler("CtcVal", L_SysLog.knd_AutoBuild);
  END;
 END {InsertNewContact};

 PRIVATE PROCEDURE InsertNewContract();
  VAR
   rct_Type              : LIKE(CntrT.Type);
   rct_CntrT             : LIKE(CntrT.CntrT);
   rct_ACSet             : LIKE(ACSet.ACSet);
   rct_MyFirm            : LIKE(MyFirm.MyFirm);
   RepairContractTemplate: LIKE(Contract.Contract);
 BEGIN
  IF ~L_Rpr.intStandOnRprContract(Firm.Firm, RprS.OrdDate) THEN
   L_General.Assert(Firm.PrtnrTyp = P_Firm.pt_Man,
                    "       ६   ਤ᪨ 殬 ||" + Firm.Firm + " " + Firm.Name + "||" +
                    " ଫ  室   ᮮ⢥騩 ⤥");
   RepairContractTemplate:=L_Rpr.E_GetRepairContractTemplate(RprS.OrdDate, Firm.Firm, RprS.Location);
   L_General.Assert(SEARCH(Contract, Contract, RepairContractTemplate), "  蠡  " + RepairContractTemplate);
   rct_CntrT   :=Contract.CntrT;
   rct_Type    :=Contract.Type;
   rct_ACSet   :=Contract.ACSet;
   rct_MyFirm  :=Contract.MyFirm;

   DEFAULT(Contract);
   Contract.iiType  :=L_Cntr.iit_Contract;
   Contract.Leaf    :=1;
   Contract.Parent  :=RepairContractTemplate;
   Contract.Name    :="㣨 ࢨ";
   Contract.Type    :=rct_Type;
   Contract.SrcDate :=RprS.OrdDate;
   Contract.CntrT   :=rct_CntrT;
   Contract.Firm    :=Firm.Firm;
   Contract.Date    :=Contract.SrcDate;
   Contract.Begin   :=Contract.Date;
   Contract.ACSet   :=rct_ACSet;
   Contract.MyFirm  :=rct_MyFirm;
   INSERT(Contract);

   L_Cntr.UpdateGroupParent(L_Cntr.iit_FirmGroup, Contract.Firm, 1);
   L_Cntr.UpdateGroupParent(L_Cntr.iit_CntrTGroup, Contract.CntrT, 1);
   L_Cntr.ReplicationFirmNameToContract();
   L_Cntr.ReplicationCntrTNameToContract();
   L_XObj.AfterOriginInsert(L_XObj.o_Contract, Contract.MyFirm);

   L_APtm.SysLogHandler("Contract", L_SysLog.knd_AutoBuild);
  END;
 END {InsertNewContract};

 PRIVATE PROCEDURE CheckObjectExistInGuide(inoIdx: NUMERIC[0]);
  VAR
   DescrFieldName,
   FieldName,
   _Object: STRING[];
 BEGIN
  IF    inoIdx = inoi_Firm THEN
   FieldName     :="Firm";
   DescrFieldName:="FirmName";
  ELSIF inoIdx = inoi_Mark THEN
   FieldName     :="Mark";
   DescrFieldName:="MarkName";
  ELSIF inoIdx = inoi_OutCar THEN
   FieldName     :="OutCar";
   DescrFieldName:="StateNbr";
  ELSIF inoIdx = inoi_OutCBlc THEN
   FieldName     :="OutCBlc";
   DescrFieldName:="OutCBlc";
  END;
  _Object:=getFV_String(FieldName);
  L_General.Assert(~!_Object, L_Str.PoolItem("࠭ᯮ⭮ ।⢮|ઠ|ࠣ|???|????|஭ ॣ", inoIdx) + " " +  getFV_String(DescrFieldName) + "   ࠢ筨.|" +
                              ",  ६ ଫ   뫠 ଫ ⠢  ࠢ筨.");
 END {CheckObjectExistInGuide};

 PRIVATE PROCEDURE SetRprSAdditionalInf(Window: FORM_WINDOW);
  VAR
   i                : NUMERIC[0];
   ClientSparesAsStr: STRING[];
 BEGIN
  Window.Zones(0).Fields("Comment").Value:=L_lsStore.Get(RprS.Comment);
  ClientSparesAsStr:=L_lsStore.Get(RprS.ClSpares);
  i:=0;
  WHILE i < ClientSparesAmount DO
   Window.Zones(0).Fields("ClientSpares_" + L_Str.IntStr(i)).Value:=Str.Item(ClientSparesAsStr, ";", i);
   INC(i);
  END;
 END {SetRprSAdditionalInf};

 PRIVATE PROCEDURE GetRprSAdditionalInf();
  VAR
   i            : NUMERIC[0];
   _ClientSpares: STRING[];
 BEGIN
  RprS.Comment :=L_lsStore.Replace(RprS.Comment, getFV_String("Comment"));
  i:=0;
  SETEMPTY(_ClientSpares);
  WHILE i < ClientSparesAmount DO
   IF ~!getFV_String("ClientSpares_" + L_Str.IntStr(i)) THEN
    _ClientSpares:=_ClientSpares + getFV_String("ClientSpares_" + L_Str.IntStr(i)) + ";";
   END;
   INC(i);
  END;

  RprS.ClSpares:=L_lsStore.Replace(RprS.ClSpares, _ClientSpares);
  REPLACE(RprS);
 END {GetRprSAdditionalInf};

 PRIVATE PROCEDURE GetTIMESTAMP(trgDate: DATE; trgTime: TIME): TIMESTAMP;
  VAR
   trgDTS: TIMESTAMP;
 BEGIN
  SETEMPTY(trgDTS);
  IF ~!trgDate THEN
   trgDTS:=L_DatTim.GetTIMESTAMP(trgDate, trgTime);
  END;
  RETURN trgDTS;
 END {GetTIMESTAMP};

 PRIVATE PROCEDURE ChkRprPlaceIsFree(trgRprPlace: LIKE(RprPlace.RprPlace));
  VAR
   Msg     : STRING[];
   BIntvl1,
   BIntvl2,
   EIntvl1,
   EIntvl2 : TIMESTAMP;
   RprTAmnt: NUMERIC[0];
   curRprT : LIKE(RprT.RprT);
   curRprS : LIKE(RprS.RprS);
 BEGIN
  IF ~!trgRprPlace THEN
   IF L_Rpr.HasRprTNotification() THEN
    SAVE(RprS);
    SAVE(RprT);
    SAVE(RprPlace);
    TRY
     TABLE.Get("RprT").AccessDataMode    :=adm_SOFT;
     TABLE.Get("RprPlace").AccessDataMode:=adm_SOFT;
     SEARCH(RprPlace, RprPlace, , trgRprPlace);
     IF (RprPlace.Kind # L_Rpr.rpk_TechAid) & (RprPlace.Kind # L_Rpr.rpk_Retriever) THEN
      curRprS:=RprT.RprS;
      curRprT:=RprT.RprT;
      RprTAmnt:=1;
      SETEMPTY(Msg);
      BIntvl1:=GetTIMESTAMP(RprT.JobBDate, RprT.JobBTime);
      EIntvl1:=GetTIMESTAMP(RprT.JobEDate, RprT.JobETime);
      SELECT(RprT, ActiveRT, , L_Rpr.tr_InProgress, trgRprPlace);
      WHILE OCCURE(RprT) DO
       IF L_Rpr.HasRprTNotification() &
          ((RprT.RprS # curRprS) | (RprT.RprT # curRprT)) &
          (~L_Rpr.E_OccupySingleRprPlaceByWholeRprS() | (RprT.RprS # curRprS)) THEN
        CONFORM(RprT, RprS);
        PROMPT("஢ઠ 㦥 .  " + RprS.RprS + ",  " + RprT.RprT);
        IF RprS.Status # L_Rpr.ms_Cancel THEN
         BIntvl2:=GetTIMESTAMP(RprT.JobBDate, RprT.JobBTime);
         EIntvl2:=GetTIMESTAMP(RprT.JobEDate, RprT.JobETime);
         IF !EIntvl1 | !EIntvl2 | ((Math.Max(BIntvl1, BIntvl2) - Math.Min(EIntvl1, EIntvl2)) < 0) THEN
          INC(RprTAmnt);
          Msg:=Msg + " " + RprS.RprS + ",  N " + RprT.RprT +
                     ", 砫 ࠡ " + L_Rpr.DateTimeToStr(RprT.JobBDate, RprT.JobBTime) +
                     ",  " + FLDTOSTR(L_Rpr.GetRprTTaskLen(), "2.", 6) + " .|";
         END;
        END;
       END;
       NEXT(RprT);
      END; (* WHILE OCCURE(RprT) ... *)
 
      IF ~!Msg & (RprTAmnt > RprPlace.Capacity) THEN
       L_StdFrm.Choice(" "+ trgRprPlace + " | |" + Msg);
      END;
     END;
    EXCEPT

    END; (* TRY *)
    RESTORE(RprPlace);
    RESTORE(RprT);
    RESTORE(RprS);
   END;
  END;
 END {ChkRprPlaceIsFree};

 PRIVATE PROCEDURE RprT_OnAfterModification(IsInteractiveModification: SCAL[2]);
  VAR
   _RprT     : LIKE(RprT.RprT);
   ReturnKind: NUMERIC[0];
 BEGIN
  L_General.Assert(RprT.RprT # 0, "     00");
  L_General.Assert((!RprT.JobBDate = !RprT.JobBTime) &
                   (!RprT.JobEDate = !RprT.JobETime) &
                   (!RprT.EDate    = !RprT.ETime),
                    " 祭 ''  '६'|" +
                    "    ६");
  IF IsInteractiveModification THEN
   L_General.Assert(!RTI.Get().CurZone.Fields("PlnEDate").Value = !RTI.Get().CurZone.Fields("PlnETime").Value,
                    " 祭 '  砭'  ' ६ 砭'|" +
                    "    ६");
  END;
  RprP_CheckUniqueWho(RprT.RprT);
  CheckSingleRprTEDT();

  IF ~IsRetireRepair() THEN
   IF ~!RprT.RprPlace & !RprT.Sort THEN
    L_General.Error("   㪠뢠  ᥪ");
   END;
  END;

  IF ~!RprT.RprPlace & ~!RprT.Sort THEN
   CONFORM(RprT, RprPlace);
   CONFORM(RprT, Sort);
   IF (L_Rpr.E_IsTechAidSort(L_Rpr.rpk_TechAid, RprT.Sort) | L_Rpr.E_IsTechAidSort(L_Rpr.rpk_Retriever, RprT.Sort)) # ((RprPlace.Kind = L_Rpr.rpk_TechAid) | (RprPlace.Kind = L_Rpr.rpk_Retriever)) THEN
    L_General.Error("ᮮ⢥⢨ ६⭮ ᥪ|" +
                    " ६⭮ :| |" +
                    "  : " + Str.Align(RprT.RprPlace + " " + RprPlace.Name, 37, LEFT) + "|" +
                    ": " + Str.Align(RprT.Sort + " " + Sort.Name, 37, LEFT));
   END;
   IF RprT.TaskKind # L_Rpr.tk_Line THEN
    L_General.Assert((RprPlace.Kind # L_Rpr.rpk_TechAid) & (RprPlace.Kind # L_Rpr.rpk_Retriever),
                     "  " + L_Str.PoolItem(L_Rpr.rpk_Pool, RprPlace.Kind) + "   ᯮ짮|" +
                     "⮫쪮  ६⭮   '" + L_Str.PoolItem(L_Rpr.rpr_TaskKind_Pool, L_Rpr.tk_Line) + "'");
   END;
  END;

  E_RprT_CheckFilling();

  IF ~!RprT.RprPlace THEN
   IF SELECT(RprP, RprT, RprT.RprS, RprT.RprT) THEN
    WHILE OCCURE(RprP) DO
     IF    RprP.Who = L_Rpr.rprpwho_TechAidDrv THEN
      L_General.Assert(L_Rpr.IsTechAidTask(RprT.RprPlace),
                       " ᮭ ⮣ ६⭮    ⢮|" +
                       "'" + L_Str.PoolItem(L_Rpr.rprpwho_Pool, RprP.Who) + "'");
     ELSIF RprP.Who = L_Rpr.rprpwho_RetrieverDrv THEN
      L_General.Assert(L_Rpr.IsRetrieverTask(RprT.RprPlace),
                       " ᮭ ⮣ ६⭮    ⢮|" +
                       "'" + L_Str.PoolItem(L_Rpr.rprpwho_Pool, RprP.Who) + "'");
     END;
     NEXT(RprP);
    END; (* WHILE OCCURE(RprP) ... *)
   END;
  END;

  IF RprT.TaskKind = L_Rpr.tk_IndependentRepair THEN
   L_General.Assert(SELECT(RprP, RprJ, RprS.RprS, RprT.RprT, L_Rpr.v_EmptyIndexValue, L_Rpr.rprpwho_Driver),
                    " ᮭ ६⭮  '" + L_Str.PoolItem(L_Rpr.rpr_TaskKind_Pool, RprT.TaskKind) + "'  ⢮|" +
                    L_Str.PoolItem(L_Rpr.rprpwho_Pool, L_Rpr.rprpwho_Driver));
  END;

  E_CheckRprPPresence(RprT.RprT, RprT.Sort);

  CheckRprPWorkTimes(RprS.RprS, RprT.RprT, EMPTYOF(RprP.RprJ));

  IF ~!RprT.RprPlace THEN
   CONFORM(RprT, RprPlace);
   L_General.Assert(L_DatTim.IsActive(RprT.BDate, RprPlace.Begin, RprPlace.Till),
                    " " + RprPlace.RprPlace + " " + RprPlace.Name + "   " +
                    L_DatTim.DateStr(RprT.BDate));
   ChkRprPlaceIsFree(RprT.RprPlace);
   IF (RprPlace.Kind # L_Rpr.rpk_Retriever) &
      (RprT.Result # L_Rpr.tr_InProgress)   &
      ~SELECT(RprJ, RprS, RprT.RprS, RprT.RprT) THEN
    L_StdFrm.ConditionalCHOICE("   㪠   ࠡ", (RprT.Result # L_Rpr.tr_Done) | L_Rpr.E_Task_woJobSupport());
   END;
  ELSE
   IF IsOutsideOverhaul() THEN
    L_StdFrm.Choice(" ⠫ ६  ஭ ࣠樨?");
   ELSE
    IF ~IsOutsideRepair() & ~IsRetireRepair() THEN
     L_General.Assert(~L_Rpr.HasRprTNotification(),
                      "      |" +
                      " 㪠 ");
    END;
   END;
  END; (* IF ~!RprT.RprPlace...*)

  IF ~L_Rpr.HasRprTNotification() & ~!RprT.JobEDate THEN
   L_General.Error("    祭  㪠 ६ 砫 ࠡ  ");
  END;

  IF RprT.Result > L_Rpr.tr_InProgress THEN
   L_General.Assert(~!RprT.EDate & ~!RprT.ETime, "室    ६ 砭");
   L_Rpr.CheckRprTEDT();
  ELSE
   L_General.Assert(!RprT.EDate & !RprT.ETime, "ᯮ     ' '");
  END;

  CONFORM(RprT, RprJ);
  WHILE OCCURE(RprJ) DO
   RprJ_OnAfterModification(0);
   NEXT(RprJ);
  END; (* WHILE OCCURE(RprJ) ... *)

  IF L_Rpr.HasRprTNotification() & !RprT.TaskLen THEN
   L_General.Assert(IsRetireRepair() | (RprT.Result = L_Rpr.tr_PutOff),
                    " 㪠 ஫ ப 믮 ");
  END;
  IF RprT.Result = L_Rpr.tr_PutOff THEN
   L_General.Assert(P_Rpr.HasRprTPro(RprT.RprS, RprT.RprT, P_Rpr.P_RprTFailReason),
                    " ⫮  易⥫쭮 㪠 稭 믮 (᢮⢮ " + FLDTOSTR(P_Rpr.P_RprTFailReason, "L0", 4) + ")");
  END;
  IF ~!RprT.TaskLen THEN
   IF    RprT.TaskLen = 0 THEN
    L_General.Error("஫ ப 믮     㫥");
   ELSIF RprT.TaskLen < 0 THEN
    L_General.Error("஫ ப 믮    ⥫");
   END;
  END;

  IF (RprT.Result = L_Rpr.tr_RequiredAnother) &
     (L_Rpr.IsTechAidTask(RprT.RprPlace) | (RprT.TaskKind = L_Rpr.tk_IndependentRepair)) THEN
   CheckRprT();
   ReturnKind:=rk_NeedRetriever;
   STDFORM(L_StdFrm.sf_Choice("᫥騥 ⢨         |"+
                              "%###########################%|",
                              "%,2<⥫ |뤠  >O"),
           ,
           ,
           ,
           ReturnKind);
   IF ReturnKind = rk_NeedRetriever THEN
    LIKEMENU(Ins, "@ ReturnKind=NeedRetriever");
   END;
  END;
 END {RprT_OnAfterModification};

 PRIVATE PROCEDURE GetRprPLevel_Short(): STRING[];
 BEGIN
  IF    !RprP.RprT & !RprP.RprJ THEN
   RETURN "";
  ELSIF ~!RprP.RprT & !RprP.RprJ THEN
   RETURN "";
  ELSIF ~!RprP.RprT & ~!RprP.RprJ THEN
   RETURN "";
  ELSE
   L_General.CallUs(0);
  END;
 END {GetRprPLevel_Short};

 PRIVATE PROCEDURE CheckIsWarrantyRepair();
  VAR
   RprTAmount           : NUMERIC[0];
   HasWarrantyRepairRprT: SCAL[2];
 BEGIN
  SETZERO(RprTAmount, HasWarrantyRepairRprT);
  SELECT(RprT, RprS, , RprS.RprS);
  WHILE OCCURE(RprT) DO
   IF RprT.TaskKind = L_Rpr.tk_WarrantyRepair THEN
    HasWarrantyRepairRprT:=1;
   END;
   INC(RprTAmount);
   NEXT(RprT);
  END; (* WHILE OCCURE(RprT) ... *)
  IF HasWarrantyRepairRprT & (RprTAmount > 1) THEN
   L_General.Error("   ࠭⨩ ६  ⢮|" +
                   "⢥   '" + L_Str.PoolItem(L_Rpr.rpr_TaskKind_Pool, L_Rpr.tk_WarrantyRepair) + "'");
  END;
 END {CheckIsWarrantyRepair};

 PRIVATE PROCEDURE intFillRprPTimes(trgRprS: LIKE(RprS.RprS);
                                    trgRprT: LIKE(RprT.RprT);
                                    trgRprJ: LIKE(RprJ.RprJ));
  VAR
   trgBDate    : DATE;
   trgBTime    : TIME;
   trgEDate    : DATE;
   trgETime    : TIME;
 BEGIN
  GetTimesForRprP(trgRprS, trgRprT, trgRprJ, trgBDate, trgBTime, trgEDate, trgETime);
  SELECT(RprP, RprJ, , trgRprS, trgRprT, trgRprJ);
  WHILE OCCURE(RprP) DO
   IF !RprP.BDate & !RprP.BTime & !RprP.EDate & !RprP.ETime THEN
    RprP.BDate:=trgBDate;
    RprP.BTime:=trgBTime;
    RprP.EDate:=trgEDate;
    RprP.ETime:=trgETime;
    REPLACE(RprP);
   END;
   NEXT(RprP);
  END; (* WHILE OCCURE(RprP) ... *)
 END {intFillRprPTimes};

 PRIVATE PROCEDURE FillRprPTimes();
 BEGIN
  intFillRprPTimes(RprS.RprS, EMPTYOF(RprT.RprT), EMPTYOF(RprJ.RprJ));
  SELECT(RprT, RprS, , RprS.RprS);
  WHILE OCCURE(RprT) DO
   intFillRprPTimes(RprT.RprS, RprT.RprT, EMPTYOF(RprJ.RprJ));

   SELECT(RprJ, RprS, , RprT.RprS, RprT.RprT);
   WHILE OCCURE(RprJ) DO
    intFillRprPTimes(RprJ.RprS, RprJ.RprT, RprJ.RprJ);
    NEXT(RprJ);
   END; (* WHILE OCCURE(RprJ) ... *)
   NEXT(RprT);
  END; (* WHILE OCCURE(RprT) ... *)
 END {FillRprPTimes};

 PRIVATE PROCEDURE RprS_OnAfterModification();
  CONST
   rfl_DefaultRprT = 01;
  VAR
   Fields             : FORM_FIELDS;
   _Mark              : LIKE(Mark.Mark);
   _OutCar            : LIKE(OutCar.OutCar);
   _OutCBlc           : LIKE(OutCBlc.OutCBlc);
   rp_RprS,
   rp_AllUnprintedRprT: SCAL[2];
 BEGIN
  IF NeedFillXDocJrn() THEN
   L_XDoc.XDocJrn_Stop(L_XDoc.xdt_RprS, L_XDoc.EmptyXDocKind, RprS.RprS);
  END;

  CheckIsWarrantyRepair();

  CheckRprPWorkTimes(RprS.RprS, EMPTYOF(RprP.RprT), EMPTYOF(RprP.RprJ));

  rp_RprS            :=0;
  rp_AllUnprintedRprT:=0;
  IF ~IsRprSEEWindow() THEN
   Fields:=RTI.Get().CurZone.Fields;
   IF    IsRegistrationFromLine() THEN
    rp_RprS            :=rfl_E_PrintRprSImmediately();
    rp_AllUnprintedRprT:=E_PrintAllUnprintedRprT();
    rfl_E_StrongCheckFillField();
    CheckFilligRprDA();
    DEFAULT(RprPro);
    RprPro.RprS    :=RprS.RprS;
    RprPro.Property:=P_Rpr.P_Location;
    RprPro.Value   :=Fields("Location").Value;
    INSERT(RprPro);
 
    InsRprP(L_Rpr.v_EmptyIndexValue, Fields("Who_0").Value, Fields("TSN_0").Value);
    IF ~!Fields("Sort").Value | ~!Fields("RprPlace").Value | (GetInsertRprSMode() = irm_IndependentRepair) THEN
     DEFAULT(RprT);
     RprT.RprS    :=RprS.RprS;
     RprT.Sort    :=Fields("Sort").Value;
     RprT.RprPlace:=Fields("RprPlace").Value;
     IF GetInsertRprSMode() = irm_IndependentRepair THEN
      RprT.TaskKind:=L_Rpr.tk_IndependentRepair;
     ELSE
      RprT.TaskKind:=L_Rpr.tk_Line;
     END;
     RprT.BDate   :=RprS.OrdDate;
     RprT.BTime   :=RprS.OrdTime;
     RprT.JobBDate:=Fields("JobBDate").Value;
     RprT.JobBTime:=Fields("JobBTime").Value;
     RprT.TaskLen :=Fields("TaskLen").Value;
     RprT.CopyCnt :=0;
     RprT.Result  :=L_Rpr.tr_InProgress;
     INSERT(RprT);
  
     InsRprP(rfl_DefaultRprT,         Fields("Who_1").Value, Fields("TSN_1").Value);
     RprT_OnAfterModification(1);
    END;
   ELSIF (GetInsertRprSMode() = irm_OutCarRprS) | (GetInsertRprSMode() = irm_OutCBlcRprS) THEN
    CheckFilligRprDA();
    IF    GetInsertRprSMode() = irm_OutCarRprS THEN
     IF !getFV_String("FirmPhoneClr") & !getFV_String("FirmPhonePST") THEN
      L_StdFrm.Question(" 㪠   ⥫䮭 稪");
     END;

     IF InsertNewObjects[inoi_Firm] THEN
      DEFAULT(Firm);
      Firm.Begin    :=RprS.OrdDate;
      Firm.Name     :=getFV_String("FirmName");
      Firm.PrtnrTyp :=getFV_String("FirmPrtnrType");
      INSERT(Firm);
 
      L_General.CallUs(Firm.PrtnrTyp = P_Firm.pt_Man);
      L_APtm.SysLogHandler("Firm", L_SysLog.knd_AutoBuild);

      CALL(Firm.extInsertRequiredFirmProperty());
     ELSE
      CheckObjectExistInGuide(inoi_Firm);
      SEARCH(Firm, Firm, , getFV_String("Firm"));
     END;
  
     InsertNewContract();
  
     InsertNewContact(inoi_PhoneClr);
     InsertNewContact(inoi_PhonePST);
     IF InsertNewObjects[inoi_Mark] THEN
      SELECT(Mark, Mark);
      LAST(Mark);
      _Mark:=Mark.Mark;
      DEFAULT(Mark);
      Mark.Mark    :=_Mark + 1;
      Mark.Name    :=getFV_String("MarkName");
      Mark.Begin   :=RprS.OrdDate;
      Mark.EngVol  :=RTI.Get().CurZone.Fields("MarkEngVol").Value;
      Mark.EnginTyp:=RTI.Get().CurZone.Fields("MarkEnginTyp").Value;
      Mark.EngPower:=RTI.Get().CurZone.Fields("MarkEngPower").Value;
      Mark.use_Self:=0;
      Mark.use_OutC:=1;
      INSERT(Mark);
      L_APtm.SysLogHandler("Mark", L_SysLog.knd_AutoBuild);
     ELSE
      CheckObjectExistInGuide(inoi_Mark);
      SEARCH(Mark, Mark, , getFV_String("Mark"));
      IF ~Mark.use_OutC THEN
       Mark.use_OutC:=1;
       REPLACE(Mark);
      END;
     END;
  
     IF InsertNewObjects[inoi_OutCar] THEN
      TRY [EXCEPTION_HANDLING(EXCEPTION_HANDLING_OFF)]
       DEFAULT(OutCar);
       OutCar.StateNbr:=getFV_String("StateNbr");
       _OutCar        :=Str.Condense(Str.Slice(OutCar.StateNbr, 0, Str.MaxLength(OutCar.OutCar)));
       OutCar.VIN     :=getFV_String("VIN");
       OutCar.EnginMod:=getFV_String("EnginMod");
       OutCar.OutCar  :=_OutCar;
       OutCar.SaleDate:=RTI.Get().CurZone.Fields("SaleDate").Value;
       OutCar.ProdYear:=RTI.Get().CurZone.Fields("ProdYear").Value;
       OutCar.Mark    :=Mark.Mark;
       OutCar.Begin   :=RprS.OrdDate;
       OutCar.Firm    :=Firm.Firm;
       INSERT(OutCar);
      EXCEPT
      ON Exc: Exc_Root DO
       IF Exc.ErrorCode = L_General.ec_rt_UniquenessViolation THEN
        SEARCH(OutCar, OutCar, , _OutCar);
        L_General.Error("訡  ଫ  ஭ :||" +
                        " ࠢ筨 㦥    ᭮஬ " + OutCar.StateNbr + ",|" +
                        " । 㭨    ᭮ " + getFV_String("StateNbr") + "||" +
                        " ஢ ࠢ쭮  ᭮.|" +
                        "᫨  ࠢ, 室 ନ  |।⢥  ࠢ筨.");
       ELSE
        RAISE();
       END;
      END; (*TRY*)
      CALL(OutCar.OutCar_OnAfterInsert());
      L_APtm.SysLogHandler("OutCar", L_SysLog.knd_AutoBuild);

      RprS.CUCopy  :=OutCar.CUCopy;
      RprS.RprObjId:=OutCar.OutCar;
      REPLACE(RprS);
     ELSE
      CheckObjectExistInGuide(inoi_OutCar);
      SEARCH(OutCar, OutCar, , getFV_String("OutCar"));
     END;

    ELSIF GetInsertRprSMode() = irm_OutCBlcRprS THEN
     CheckObjectExistInGuide(inoi_OutCBlc);
     SEARCH(OutCBlc, OutCBlc, , getFV_String("OutCBlc"));
     REPLACE(RprS);
    ELSE
     L_General.CallUs(0);
    END; (* IF    GetInsertRprSMode() = irm_OutCarRprS...*)

    IF ~!getFV_String("NormHourPrice") THEN
     L_Prop.CheckNumericValue(getFV_String("NormHourPrice"), "");
     PutRprPro("",
               E_Prop.P_NormHourPrice,
               RprS.RprS,
               "",
               "",
               getFV_String("NormHourPrice"));
    END;
 
    GetRprSAdditionalInf();
   ELSE
    rp_AllUnprintedRprT:=E_PrintAllUnprintedRprT();
   END;

   ConditionalClose(GetRprSActualStatus());
   RprP_CheckUniqueWho(L_Rpr.v_EmptyIndexValue);

   IF    rp_RprS THEN
    PrintUnprintedRprSwFirstRprT();
   ELSIF rp_AllUnprintedRprT THEN
    PrintAllUnprintedRprT();
   END;
  ELSE
   GetRprSAdditionalInf();
  END;
  FillRprPTimes();
 END {RprS_OnAfterModification};

 PRIVATE PROCEDURE RprS_OnAfterInsert();
 BEGIN
  RprS_OnAfterModification();
 END {RprS_OnAfterInsert};

 PRIVATE PROCEDURE RprS_OnAfterEdit();
 BEGIN
  RprS_OnAfterModification();
 END {RprS_OnAfterEdit};

 PRIVATE PROCEDURE CheckRprT();
 BEGIN
  L_General.Assert(L_Rpr.HasRprTNotification(), " 㪠 ६ 砫 믮 ");
 END {CheckRprT};

 PRIVATE PROCEDURE SetRprDA_WinFieldFlagEdit(FlagEdit,
                                             FixedFlagEdit: SCAL[2]);
 BEGIN
  RTI.Get().CurZone.Fields("RprDA.RprDfApr").AskMode:=FORM_FIELD.AskMode_Manual;
  SetFieldModifiable(RTI.Get().CurZone.Fields("RprDA.RprDfApr"), FlagEdit);
  SetFieldModifiable(RTI.Get().CurZone.Fields("RprDA_WhenBurn"), FlagEdit);
  SetFieldModifiable(RTI.Get().CurZone.Fields("RprDA_Fixed"),    FixedFlagEdit);
 END {SetRprDA_WinFieldFlagEdit};

 PRIVATE PROCEDURE SetRprTWinFieldFlagEdit();
  VAR
   Modifiable: SCAL[2];
 BEGIN
  Modifiable:=~IsOutsideRepair();
  SetFieldModifiable(RTI.Get().CurZone.Fields("RprT.Sort"),     Modifiable & ~IsRetireRepair());
  SetFieldModifiable(RTI.Get().CurZone.Fields("RprT.RprPlace"), Modifiable | IsRetireRepair());
 END {SetRprTWinFieldFlagEdit};

 PRIVATE PROCEDURE RprDAE_0_OnReposition();
 BEGIN
  RTI.Get().CurZone.Fields("RprDA_MsgIfTransfered").Visible:=~!RprDA.FRprS;
  RTI.Get().CurZone.Fields("RprDA.FRprS").Visible:=~!RprDA.FRprS;
 END {RprDAE_0_OnReposition};

 PRIVATE PROCEDURE RprDAE_OnInitializeWindow();
 BEGIN
  L_WDO.iEvents      (0, [L_WDO.e_OnAnyModification, L_WDO.e_OnReposition]);
  L_WDO.iScsChange   (0, ["RprDA_Fixed", "RprDA.RprDfApr"]);
  L_WDO.iUnmodifiable(0, ["RprDA.FRprS"]);
  L_WDO.iMayBeEmpty  (0, ["RprDA.Comment"]);
  L_WDO.iProgs       (0, "RprS");
  SetAllRprPools();
 END {RprDAE_OnInitializeWindow};

 PRIVATE PROCEDURE RprStaff_OnBeforeInsert();
 BEGIN
  RprStaff.BegDate :=L_Rpr.v_rprs_BegDate;
  RprStaff.RprShift:=L_Rpr.v_rprs_Shift;
  REPLACE(RprStaff);
 END {RprStaff_OnBeforeInsert};

 PRIVATE PROCEDURE CheckExistsTSNInGuide(_TSN: LIKE(Staff.TSN);
                                         _Who: LIKE(RprP.Who));
  VAR
   Msg: STRING[];
 BEGIN
  IF _Who = L_Rpr.rprpwho_DrvDeclarant & ~E_NeedUseStaff_ForDrvDeclarant() THEN
   Msg:=" 뤠   " + L_DatTim.DateStr(RprS.OrdDate) + ",  " + RprS.RprObjId;
  ELSE
   Msg:=" ࠢ筨 '" + TABLE.Get(GetFileName(_Who)).Description + "'" +
        "|  ⠡ " + _TSN;
  END;
  L_General.Assert(_PositionInGuide(_TSN, _Who), Msg);
 END {CheckExistsTSNInGuide};

 PRIVATE PROCEDURE CheckStaffInState(_TSN  : LIKE(Staff.TSN);
                                     OnDate: DATE;
                                     Strong: SCAL[2]);
 BEGIN
  SEARCH(Staff, TSN, , _TSN);
  L_Staff.PosToStaffLog(_TSN, OnDate, 0);
  IF L_Staff.IsDischargeStaffLog() THEN
   L_StdFrm.ConditionalCHOICE("⭨  室    " + L_DatTim.DateStr(OnDate) + "|" +
                              " " + _TSN, ~Strong);
  END;
  L_Staff.PosToStaffLog(_TSN, OnDate, 1);
 END {CheckStaffInState};

 PRIVATE PROCEDURE CheckStaffIsRepairMan(_TSN: LIKE(Staff.TSN);
                                         _Who: LIKE(RprP.Who));
 BEGIN
  IF (_Who = L_Rpr.rprpwho_TechAidDrv) |
     (_Who = L_Rpr.rprpwho_RetrieverDrv) |
     (_Who = L_Rpr.rprpwho_RepairGroupChief) |
     (_Who = L_Rpr.rprpwho_Executor) THEN
   CONFORM(StaffLog, Sort);
   IF ~L_Env.RealTSN(_TSN) | ~Sort.IsRpr THEN
    CONFORM(Staff, Man);
    L_StdFrm.Choice(" " + _TSN + " " + Man.Name + "|" +
                    "  ࠡ⭨ ६");
   END;
  END;
 END {CheckStaffIsRepairMan};

 PRIVATE PROCEDURE RprStaff_TSN_OnSuccessfulChange();
  VAR
   _TSN: LIKE(Staff.TSN);
 BEGIN
  IF ~!RprStaff.TSN THEN
   _TSN:=RprStaff.TSN;
   CheckExistsTSNInGuide(_TSN, L_Rpr.rprpwho_TechAidDrv);
   CheckStaffInState(_TSN, RprStaff.BegDate, 1);
   CheckStaffIsRepairMan(_TSN, L_Rpr.rprpwho_Executor);
   SAVE(RprStaff);
   L_General.Assert(~SEARCH(RprStaff, RprTSN, L_Rpr.v_rprs_BegDate, L_Rpr.v_rprs_Shift, _TSN, StaffLog.Sort),
                    "⭨ " + _TSN + " 㦥 室  ᮭ ६|"+
                    " " + L_DatTim.DateStr(L_Rpr.v_rprs_BegDate) +
                    ", ᬥ N " + L_Str.IntStr(L_Rpr.v_rprs_Shift));
   RESTORE(RprStaff);
   RprStaff.Sort:=StaffLog.Sort;
  ELSE
   SETEMPTY(RprStaff.Sort);
  END;
  REPLACE(RprStaff);
 END {RprStaff_TSN_OnSuccessfulChange};

 PRIVATE PROCEDURE intSetOwnerWindow(trgOwnerWin : STRING[];
                                     trgOwnerZone: NUMERIC[0];
                                     trgAskMode  : SCAL[2]);
  VAR
   curField: FORM_FIELD;
 BEGIN
  curField:=RTI.Get().CurZone.ActiveField;
  curField.OwnerWindowOriginalName:=trgOwnerWin;
  IF trgAskMode = FORM_FIELD.AskMode_Manual THEN
   curField.OwnerZoneNumber:=trgOwnerZone;
  END;
  curField.AskMode:=trgAskMode;
 END {intSetOwnerWindow};

 PRIVATE PROCEDURE SetOwnerWindow(trgWho: LIKE(RprP.Who));
 BEGIN
  L_General.Assert(~!trgWho, " ஫ ᯮ⥫");
  IF    trgWho = L_Rpr.rprpwho_AnyDeclarant THEN
   IF !RTI.Get().CurZone.ActiveField.TableField THEN
    intSetOwnerWindow("Staff", 1, FORM_FIELD.AskMode_Manual);
   ELSE
    intSetOwnerWindow("Staff", 1, FORM_FIELD.AskMode_System);
   END;
  ELSIF trgWho = L_Rpr.rprpwho_DrvDeclarant THEN
   IF    E_NeedUseStaff_ForDrvDeclarant() THEN
    intSetOwnerWindow("Staff",  1, FORM_FIELD.AskMode_Manual);
   ELSIF L_Way.E_BegRWSLev(RprS.OrdDate) >= L_Way.brwsl_Active THEN
    intSetOwnerWindow("Beg1",   1, FORM_FIELD.AskMode_Manual);
   END;
  ELSE
   IF E_NeedUseRprStaff() THEN
    intSetOwnerWindow("RprStaff", 1, FORM_FIELD.AskMode_Manual);
   ELSE
    intSetOwnerWindow("Staff",    1, FORM_FIELD.AskMode_Manual);
   END;
  END;
 END {SetOwnerWindow};

 PRIVATE PROCEDURE CheckRprSCUCopy();
 BEGIN
  L_General.Assert(~!RprS.CUCopy, " 㪠 ꥪ ६");
 END {CheckRprSCUCopy};

 PRIVATE PROCEDURE RprP_OnBeforeInsert();
  VAR
   trgWho: LIKE(RprP.Who);
 BEGIN
  trgWho:=L_WDO.GetEnvVarValue("RprPWho");
  L_General.CallUs(~!trgWho);
  CheckRprSCUCopy();
  RprP.Who:=trgWho;
  REPLACE(RprP);
  IF (RprP.Who = L_Rpr.rprpwho_DrvDeclarant) | (RprP.Who = L_Rpr.rprpwho_Driver) THEN
   L_General.Assert(L_Rpr.IsRprS_w_Car(),
                    "ᮭ  " + L_Str.PoolItem(L_Rpr.rprpwho_Pool, trgWho) + "|" +
                    "  㪠 ⮫쪮    ६ ᮡ⢥ ");
  END;
 END {RprP_OnBeforeInsert};

 PRIVATE PROCEDURE RprP_Check(curRprPLevel: SCAL[3];
                              _RprT      : LIKE(RprT.RprT);
                              _Who       : LIKE(RprP.Who);
                              _TSN       : LIKE(Staff.TSN));
  VAR
   Text     : STRING[];
   RprPLevel: SCAL[3];
 BEGIN
  SELECT(RprP, RprS, , RprS.RprS, _Who, _TSN);
  WHILE OCCURE(RprP) DO
   RprPLevel:=GetRprPLevel();
   IF (!_RprT | !RprP.RprT | (RprP.RprT = _RprT)) & (RprPLevel # curRprPLevel) THEN
    IF    RprPLevel = L_Rpr.rprpl_RprS THEN
     Text:="६⭮ ";
    ELSIF RprPLevel = L_Rpr.rprpl_RprT THEN
     Text:="६⭮  " + RprP.RprT;
    ELSIF RprPLevel = L_Rpr.rprpl_RprJ THEN
     Text:="६⭮ ࠡ " + RprP.RprJ + ", ६⭮  " + RprP.RprT;
    END;
    L_General.Error(L_Str.PoolItem(L_Rpr.rprpwho_Pool, _Who) + " " + _TSN + " 㦥 㪠  ᮭ " + Text);
   END;
   NEXT(RprP);
  END; (* WHILE OCCURE(RprP) ... *)
 END {RprP_Check};

 PRIVATE PROCEDURE RprP_OnAfterModification();
  VAR
   Amnt        : NUMERIC[0];
   _Who        : LIKE(RprP.Who);
   _TSN        : LIKE(Staff.TSN);
   curRprPLevel: SCAL[3];
 BEGIN
  CheckRprSCUCopy();
  L_General.Assert(~!RprP.TSN, " 㪠 ⠡ ");
  CheckExistsTSNInGuide(RprP.TSN, RprP.Who);
  _Who:=RprP.Who;
  _TSN:=RprP.TSN;
  curRprPLevel:=GetRprPLevel();
  SAVE(RprP);
  Amnt:=0;
  SELECT(RprP, RprJ, , RprP.RprS, RprP.RprT, RprP.RprJ, RprP.Who, RprP.TSN);
  WHILE OCCURE(RprP) DO
   INC(Amnt);
   L_General.Assert(Amnt <= 1,
                    "  ⠡. " + RprP.TSN + " " +
                    L_Str.PoolItem(L_Rpr.rprpwho_Pool, RprP.Who));
   NEXT(RprP);
  END; (* WHILE OCCURE(RprP) ... *)

  IF    curRprPLevel = L_Rpr.rprpl_RprS THEN
   RprP_Check(curRprPLevel, EMPTYOF(RprT.RprT), _Who, _TSN);
  ELSIF curRprPLevel = L_Rpr.rprpl_RprT THEN
   RprP_Check(curRprPLevel, RprT.RprT,          _Who, _TSN);
  ELSIF curRprPLevel = L_Rpr.rprpl_RprJ THEN
   RprP_Check(curRprPLevel, RprJ.RprT,          _Who, _TSN);
  ELSE
   L_General.CallUs(0);
  END;
  RESTORE(RprP);
 END {RprP_OnAfterModification};

 PRIVATE PROCEDURE RprP_OnAfterInsert();
 BEGIN
  RprP_OnAfterModification();
 END {RprP_OnAfterInsert};

 PRIVATE PROCEDURE RprP_OnAfterEdit();
 BEGIN
  CheckSingleRprPWorkTimes();
  RprP_OnAfterModification();
 END {RprP_OnAfterEdit};

 PRIVATE PROCEDURE AllowedRprWho(): SCAL[2];
  VAR
   RprPLevel: SCAL[3];
 BEGIN
  RprPLevel:=GetRprPLevel();
  IF    (RprP.Who = L_Rpr.rprpwho_AnyDeclarant) |
        (RprP.Who = L_Rpr.rprpwho_DrvDeclarant) THEN
   RETURN (RprPLevel # L_Rpr.rprpl_RprT) &
          (RprPLevel # L_Rpr.rprpl_RprJ);
  ELSIF (RprP.Who = L_Rpr.rprpwho_TechAidDrv)   |
        (RprP.Who = L_Rpr.rprpwho_Executor)    |
        (RprP.Who = L_Rpr.rprpwho_RetrieverDrv) |
        (RprP.Who = L_Rpr.rprpwho_Driver) THEN
   RETURN RprPLevel # L_Rpr.rprpl_RprS;
  END;
  RETURN 1;
 END {AllowedRprWho};

 PRIVATE PROCEDURE RprP_Who_OnSuccessfulChange();
 BEGIN
  IF ~!RprP.Who THEN
   IF ~AllowedRprWho() THEN
    L_General.Error(" ᮭ " +
                    L_Str.PoolItem("६⭮ |६⭮ |६⭮ ࠡ", GetRprPLevel()) +
                    "|  ⢮ '" + L_Str.PoolItem(L_Rpr.rprpwho_Pool, RprP.Who) + "'");
   END;
  END;
  SETEMPTY(RprP.TSN);
  REPLACE(RprP);
 END {RprP_Who_OnSuccessfulChange};

 PRIVATE PROCEDURE RprP_TSN_OnSuccessfulChange();
  VAR
   OnDate: DATE;
 BEGIN
  IF ~!RprP.TSN THEN
   CheckRprSCUCopy();
   CheckExistsTSNInGuide(RprP.TSN, RprP.Who);
   IF    !RprP.RprT THEN
    OnDate:=RprS.OrdDate;
   ELSIF !RprP.RprJ THEN
    OnDate:=RprT.BDate;
   ELSE
    IF ~!RprJ.BDate THEN
     OnDate:=RprJ.BDate;
    ELSE
     OnDate:=SYSDATE();
    END;
   END;
   CheckStaffInState(RprP.TSN, OnDate, 0);
   CheckStaffIsRepairMan(Staff.TSN, RprP.Who);
  END;
 END {RprP_TSN_OnSuccessfulChange};

 PRIVATE PROCEDURE RprP_TSN_OnBeforeAsk();
 BEGIN
  SetOwnerWindow(RprP.Who);
 END {RprP_TSN_OnBeforeAsk};

 PRIVATE PROCEDURE RprP_TSN_OnAskPhase1();
 BEGIN
  PositionInGuide(RprP.TSN, RprP.Who);
 END {RprP_TSN_OnAskPhase1};

 PRIVATE PROCEDURE RprP_TSN_OnAskPhase2();
 BEGIN
  RprP.TSN:=GetTSNFromGuide(RprP.Who);
  REPLACE(RprP);
 END {RprP_TSN_OnAskPhase2};

 PRIVATE PROCEDURE RprTPrn_1_OnZoneOpen();
 BEGIN
  SetFieldFormat(RTI.Get().CurZone.Fields("RprT_TaskKind"), L_Rpr.rpr_TaskKind_Pool);
 END {RprTPrn_1_OnZoneOpen};

 PRIVATE PROCEDURE RprTE_0_OnReposition();
 BEGIN
  IF ACCESS(RprT) THEN
   CalcTaskLen_inDateTime();
  END;
 END {RprTE_0_OnReposition};

 PRIVATE PROCEDURE RprTE_OnInitializeWindow();
 BEGIN
  L_WDO.iWindow().MNUFileName:="RprS";
  L_WDO.iEvents      (0, [L_WDO.e_OnAnyModification, L_WDO.e_OnReposition]);
  L_WDO.iField       (0, "RprT.RprPlace").OwnerWindowOriginalName:="ARprPlc";
  L_WDO.iField       (0, "RprT.RprPlace").OwnerZoneNumber:=1;
  L_WDO.iField       (0, "RprT.Sort").OwnerWindowOriginalName:="RprSort";
  L_WDO.iField       (0, "RprT.Sort").OwnerZoneNumber:=1;
  L_WDO.iField       (0, "RprT.JobEDate").Modifiable:=E_UseRprTJobEndDateTime();
  L_WDO.iField       (0, "RprT.JobETime").Modifiable:=E_UseRprTJobEndDateTime();
  L_WDO.iField       (0, "RprT.JobBDate").Modifiable:=E_UseRprTJobBegDateTime();
  L_WDO.iField       (0, "RprT.JobBTime").Modifiable:=E_UseRprTJobBegDateTime();
  L_WDO.iScsChange   (0, ["RprT_Result", "RprT.TaskLen", "PlnEDate", "PlnETime", "RprT.EDate", "RprT.JobBTime", "RprT.JobBDate", "RprT.ETime", "RprT.RprPlace", "RprT.Sort", "RprT.BTime", "RprT.BDate", "RprT_TaskKind"]);
  L_WDO.iUnmodifiable(0, ["RprT.RprS"]);
  L_WDO.iMayBeEmpty  (0, ["RprT.TaskLen", "PlnEDate", "PlnETime", "RprT.EDate", "RprT.JobBTime", "RprT.JobETime", "RprT.JobEDate", "RprT.JobBDate", "RprT.ETime", "RprT.RprPlace", "RprT.Sort"]);
  L_WDO.iProgs       (0, "RprS");

  L_WDO.iSubwindow   (1, "RprJE");

  L_WDO.iEvents      (2, [L_WDO.e_OnAfterEdit, L_WDO.e_OnBeforeInsert, L_WDO.e_OnAfterInsert, L_WDO.e_OnSetSubwindow]);
  L_WDO.iZone        (2).Narrowing:="(RprP.RprS=RprT.RprS)&(RprP.RprT=RprT.RprT)&(RprP.RprJ=L_Rpr.v_EmptyIndexValue)";
  L_WDO.iField       (2, "RprP.TSN").OnBeforeAsk:=1;
  L_WDO.iField       (2, "RprP.TSN").First:=1;
  L_WDO.iScsChange   (2, ["RprP.TSN", "RprP_Who"]);
  L_WDO.iProgs       (2, "RprS");

  L_WDO.iEvents      (3, [L_WDO.e_OnAnyModification, L_WDO.e_OnAfterDelete, L_WDO.e_OnSetSubwindow]);
  L_WDO.iZone        (3).Narrowing:="(RprPro.RprS=RprT.RprS)&(RprPro.RprT=RprT.RprT)&(RprPro.RprJ=)";
  L_WDO.iProgs       (3, "ObjPro");
  SetAllRprPools();
 END {RprTE_OnInitializeWindow};

 PRIVATE PROCEDURE RprT_OnBeforeModification();
  VAR
   FirstFieldName: STRING[];
 BEGIN
  RTI.Get().CurZone.Fields("RprT.RprT"    ).First:=0;
  RTI.Get().CurZone.Fields("RprT.Sort"    ).First:=0;
  RTI.Get().CurZone.Fields("RprT.RprPlace").First:=0;
  RTI.Get().CurZone.Fields("RprT.JobBDate").First:=0;
  RTI.Get().CurZone.Fields("RprT_Result"  ).First:=0;

  FirstFieldName:="";
  IF    RTI.Get().CurProcess.Kind = FORM_PROCESS.Kind_Insert THEN
   FirstFieldName:="RprT.RprT";
  ELSIF RTI.Get().CurProcess.Kind = FORM_PROCESS.Kind_Edit THEN
   IF ACCESS(RprT) THEN
    IF    !RprT.Sort THEN
     FirstFieldName:="RprT.Sort";
    ELSIF !RprT.RprPlace THEN
     FirstFieldName:="RprT.RprPlace";
    ELSIF ~L_Rpr.HasRprTNotification() THEN
     FirstFieldName:="RprT.JobBDate";
    ELSE
     FirstFieldName:="RprT_Result";
    END;
   END;
  END;
  IF ~!FirstFieldName THEN
   RTI.Get().CurZone.Fields(FirstFieldName).First:=1;
  END;
 END {RprT_OnBeforeModification};

 PRIVATE PROCEDURE RprT_OnBeforeEdit();
 BEGIN
  SetRprTWinFieldFlagEdit();
 END {RprT_OnBeforeEdit};

 PRIVATE PROCEDURE RprT_OnBeforeInsert();
  VAR
   _RrpJob: LIKE(RprJob.RprJob);
 BEGIN
  CheckRprSCUCopy();
  SetDefaultRprTBegTimes();

  IF GetReturnKind() = rk_NeedRetriever THEN
   RprT.Sort    :=L_Rpr.E_GetDefaultTechAidSort(L_Rpr.rpk_Retriever);
   RprT.TaskKind:=L_Rpr.tk_Line;
   REPLACE(RprT);
   _RrpJob:=E_GetRetrieverRprJob();
   IF ~!_RrpJob THEN
    DEFAULT(RprJ);
    RprJ.RprS    :=RprT.RprS;
    RprJ.RprT    :=RprT.RprT;
    RprJ.RprJob  :=_RrpJob;
    RprJ.BDate   :=RprT.BDate;
    RprJ.BTime   :=RprT.BTime;
    RprJ.ComplCfc:=1;
    INSERT(RprJ);
   END;
  END;
  SetRprTWinFieldFlagEdit();
  FIX_ALTERING();
 END {RprT_OnBeforeInsert};

 PRIVATE PROCEDURE RprT_TaskKind_OnSuccessfulChange();
 BEGIN
  IF    IsRetireRepair() THEN
   L_General.Assert(L_Rpr.IsMainRpr(),
                    " ⨯    ⠭|" +
                    "⮫쪮 訬 ஬");
   L_General.Assert(~SELECT(RprJ, RprS, RprT.RprS, RprT.RprT),
                    " ६⭮   ⠪ ⨯    ࠡ");
   SETEMPTY(RprT.Sort, RprT.RprPlace);
   REPLACE(RprT);
  ELSIF RprT.TaskKind = L_Rpr.tk_Servicing2 THEN
   SETEMPTY(RprT.Sort, RprT.RprPlace);
   REPLACE(RprT);
  END;
  SetRprTWinFieldFlagEdit();
 END {RprT_TaskKind_OnSuccessfulChange};

 PRIVATE PROCEDURE RprT_BDate_OnSuccessfulChange();
 BEGIN
  SetJobBDateTime();
 END {RprT_BDate_OnSuccessfulChange};

 PRIVATE PROCEDURE RprT_BTime_OnSuccessfulChange();
 BEGIN
  SetJobBDateTime();
 END {RprT_BTime_OnSuccessfulChange};

 PRIVATE PROCEDURE RprT_JobBDate_OnSuccessfulChange();
 BEGIN
  JobBDateTimeChange(!RprT.JobBDate);
 END {RprT_JobBDate_OnSuccessfulChange};

 PRIVATE PROCEDURE RprT_JobBTime_OnSuccessfulChange();
 BEGIN
  JobBDateTimeChange(!RprT.JobBTime);
 END {RprT_JobBTime_OnSuccessfulChange};

 PRIVATE PROCEDURE CheckSortAdaptability(trgSort: LIKE(Sort.Sort));
 BEGIN
  IF ~!trgSort THEN
   L_General.Assert(~!RprT.BDate, " 뤠  ଫ   ।");
   SEARCH(Sort, Sort, , trgSort);
   L_General.Assert(L_DatTim.IsActive(RprT.BDate, Sort.Begin, Sort.Till), "    " + L_DatTim.DateStr(RprT.BDate));
   L_General.Assert(Sort.IsRpr, "⭮   ଫ ⮫쪮  ६ ᥪ");
  END;
 END {CheckSortAdaptability};

 PRIVATE PROCEDURE RprT_Sort_OnSuccessfulChange();
 BEGIN
  CheckSortAdaptability(RprT.Sort);
  SetJobBDateTime();
 END {RprT_Sort_OnSuccessfulChange};

 PRIVATE PROCEDURE RprT_RprPlace_OnSuccessfulChange();
 BEGIN
  SetJobBDateTime();
 END {RprT_RprPlace_OnSuccessfulChange};

 PRIVATE PROCEDURE RprT_TaskLen_OnSuccessfulChange();
 BEGIN
  IF ~!RprT.TaskLen THEN
   CheckRprT();
  END;
  CalcTaskLen_inDateTime();
 END {RprT_TaskLen_OnSuccessfulChange};

 PRIVATE PROCEDURE RprT_Result_OnSuccessfulChange();
 BEGIN
  CheckRprT();
  IF RprT.Result = L_Rpr.tr_InProgress THEN
   SETEMPTY(RprT.EDate, RprT.ETime, RprT.JobEDate, RprT.JobETime);
   REPLACE(RprT);
  ELSE
   SetTableFieldSDT("RprT", "JobEDate", SYSDATE(),     SYSTIME(),     "砭 ࠡ  ", E_UseRprTJobEndDateTime());
   SetTableFieldSDT("RprT", "EDate",    RprT.JobEDate, RprT.JobETime, " ",            1);
  END;
 END {RprT_Result_OnSuccessfulChange};

 PRIVATE PROCEDURE SetJobEDateTime();
 BEGIN
  IF ~E_UseRprTJobEndDateTime() THEN
   SetTableFieldSDT("RprT", "JobEDate", RprT.EDate, RprT.ETime, "", 0);
  END;
 END {SetJobEDateTime};

 PRIVATE PROCEDURE RprT_EDate_OnSuccessfulChange();
 BEGIN
  SetJobEDateTime();
 END {RprT_EDate_OnSuccessfulChange};

 PRIVATE PROCEDURE RprT_ETime_OnSuccessfulChange();
 BEGIN
  SetJobEDateTime();
 END {RprT_BTime_OnSuccessfulChange};

 PRIVATE PROCEDURE RprT_OnAfterInsert();
 BEGIN
  RprT_OnAfterModification(1);
 END {RprT_OnAfterInsert};

 PRIVATE PROCEDURE RprT_OnAfterEdit();
 BEGIN
  RprT_OnAfterModification(1);
 END {RprT_OnAfterEdit};

 PRIVATE PROCEDURE CheckBeforeDelete(trgRprT: LIKE(RprT.RprT); trgRprJ: LIKE(RprJ.RprJ));
  VAR
   Msg: STRING[];
 BEGIN
  IF !trgRprJ THEN
   L_General.Assert(~SELECT(RprJ, RprS, RprS.RprS, trgRprT), " 㤠塞 ६⭮     ६ ࠡ");
  END;

  SETEMPTY(Msg);
  IF SELECT(RprP, RprJ, RprS.RprS, trgRprT, trgRprJ) THEN
   Msg:="ᮭ";
  END;

  IF SELECT(RprPro, RprS, RprS.RprS, trgRprT, trgRprJ) THEN
   IF ~!Msg THEN
    Msg:=Msg + "  ";
   END;
   Msg:=Msg + "᢮⢠";
  END;

  IF ~!Msg THEN
   IF ~!trgRprJ THEN
    Msg:=" 㤠塞 ६⭮ ࠡ  " + Msg;
   ELSE
    Msg:=" 㤠塞 ६⭮   " + Msg;
   END;
 
   L_StdFrm.Choice(Msg);
 
   IF SELECT(RprP, RprJ, RprS.RprS, trgRprT, trgRprJ) THEN
    REMSEL(RprP);
   END;
 
   IF SELECT(RprPro, RprS, RprS.RprS, trgRprT, trgRprJ) THEN
    REMSEL(RprPro);
   END;
  END;
 END {CheckBeforeDelete};

 PRIVATE PROCEDURE RprT_OnBeforeDelete();
 BEGIN
  CheckBeforeDelete(RprT.RprT, EMPTYOF(RprJ.RprJ));
 END {RprT_OnBeforeDelete};

 PRIVATE PROCEDURE SetFieldVisible(Field: FORM_FIELD; Visible: SCAL[2]);
 BEGIN
  IF ~!Field THEN
   Field.Visible:=Visible;
  END;
 END {SetFieldVisible};

 PRIVATE PROCEDURE RprJE_0_OnReposition();
  VAR
   Visible: SCAL[2];
   Fields : FORM_FIELDS;
 BEGIN
  ACCESS(RprS);
  Visible:=~!L_Rpr.E_GetNormHourPrice();
  Fields:=RTI.Get().CurZone.Fields;

  SetFieldVisible(Fields("RprJ.Price"),      Visible);
  SetFieldVisible(Fields("v_PriceTitle"),    Visible);
  SetFieldVisible(Fields("RprJ.Sum"),        Visible);
  SetFieldVisible(Fields("v_SumTitle"),      Visible);
 END {RprJE_0_OnReposition};

 PRIVATE PROCEDURE RprJ_BDate_OnSuccessfulChange();
 BEGIN
  SetSingleRprJobBaseTime();
 END {RprJ_BDate_OnSuccessfulChange};

 PRIVATE PROCEDURE IsRepeatedRprJob(): SCAL[2];
  VAR
   _OrdDate: DATE;
   _RprS   : LIKE(RprS.RprS);
   _RprJob : LIKE(RprJob.RprJob);
 BEGIN
  _RprS   :=RprS.RprS;
  _OrdDate:=RprS.OrdDate;
  _RprJob :=RprJ.RprJob;
  SETSEL(RprS, CUCopy, RprS.CUCopy);
  SRCINSEL(RprS, LE, , _OrdDate);
  WHILE OCCURE(RprS) & (RprS.OrdDate >= (_OrdDate - 10)) DO
   IF (RprS.RprS # _RprS) & (RprS.Status # L_Rpr.ms_Cancel) THEN
    IF SELECT(RprJ, RprS, RprS.RprS) THEN
     WHILE OCCURE(RprJ) DO
      IF RprJ.RprJob = _RprJob THEN
       RETURN 1;
      END;
      NEXT(RprJ);
     END; (* WHILE OCCURE(RprJ)...*)
    END;
   END;
   PREV(RprS);
  END; (* WHILE OCCURE(RprS) ... *)
  RETURN 0;
 END {IsRepeatedRprJob};

 PRIVATE PROCEDURE CheckCarBlockInRprDA(_CarBlock: LIKE(CarBlock.CarBlock));
  VAR
   FoundCarBlockInRprDA: SCAL[2];
 BEGIN
  FoundCarBlockInRprDA:=0;
  SELECT(RprDA, RprS, , RprS.RprS);
  WHILE OCCURE(RprDA) & ~FoundCarBlockInRprDA DO
   FoundCarBlockInRprDA:=RprDA.CarBlock = _CarBlock;
   NEXT(RprDA);
  END; (* WHILE OCCURE(RprDA) & (RprDA.Fixed # L_Rpr.daf_ThereIs)...*)

  IF ~FoundCarBlockInRprDA THEN
   L_StdFrm.Choice(" (⥬) '" + CarBlock.Name + "',|" +
                   "  뫠 ந ࠡ,|" +
                   " ᮢ    ⥬,|" +
                   "㪠   ࠢ");
  END;
 END {CheckCarBlockInRprDA};

 PRIVATE PROCEDURE SetRprJAttrFieldModifiable(Modifiable: SCAL[2]);
  VAR
   SumAcceptable: SCAL[2];
 BEGIN
  SumAcceptable:=L_Rpr.AcceptableCalcRprJSum();
  RTI.Get().CurZone.Fields("RprJ.RprJob").AskMode:=FORM_FIELD.AskMode_Manual;
  SetFieldModifiable(RTI.Get().CurZone.Fields("RprJ.Quantity"), Modifiable);
  SetFieldModifiable(RTI.Get().CurZone.Fields("RprJ.BaseTime"), Modifiable);
  SetFieldModifiable(RTI.Get().CurZone.Fields("RprJ.Price"),    Modifiable * SumAcceptable);
  SetFieldModifiable(RTI.Get().CurZone.Fields("RprJ.Sum"),      Modifiable * SumAcceptable);
 END {SetRprJAttrFieldModifiable};

 PRIVATE PROCEDURE RprJ_RprJob_OnAskPhase1();
 BEGIN
  IF !RprJ.RprJob THEN
   IF SELECT(RprJob, Parent, EMPTYOF(RprJob.Parent), 0) THEN
    SE_WZD_POSITION(RTI.Get().TrgWindow.Name, RTI.Get().TrgZone.Number, RprJob);
   END;
  END;
 END {RprJ_RprJob_OnAskPhase1};

 PRIVATE PROCEDURE RprJ_RprJob_OnAskPhase2();
 BEGIN
  IF ACCESS(RprJob) THEN
   RprJ.RprJob:=RprJob.RprJob;
   REPLACE(RprJ);
  END;
 END {RprJ_RprJob_OnAskPhase2};

 PRIVATE PROCEDURE RprJ_RprJob_OnSuccessfulChange();
  VAR
   _IsRepeatedRprJob: SCAL[2];
   _RprS            : LIKE(RprS.RprS);
   _OrdDate         : DATE;
 BEGIN
  L_General.Assert(SEARCH(RprJob, RprJob, RprJ.RprJob),
                   " ࠢ筨   ६⭠ ࠡ " + RprJ.RprJob);
  CONFORM(RprJob, CarBlock);

  CheckCarBlockInRprDA(CarBlock.CarBlock);

  IF E_NeedInformAboutRepetition(RprS.Location) THEN
   ClearRprPro(P_Rpr.P_RepeatedRprJ, RprJ.RprT, RprJ.RprJ);
   IF ~!RprJ.RprJob THEN
    _IsRepeatedRprJob:=0;
    SAVE(RprS);
    SAVE(RprJ);
    IF IsRepeatedRprJob() THEN
     _IsRepeatedRprJob:=1;
     _RprS            :=RprS.RprS;
     _OrdDate         :=RprS.OrdDate;
    END;
    RESTORE(RprJ);
    RESTORE(RprS);
    IF _IsRepeatedRprJob THEN
     PutRprPro(" ࠡ 㦥 믮﫠:" +
               "| " + _RprS + "  " + L_DatTim.DateStr(_OrdDate) + "|",
               P_Rpr.P_RepeatedRprJ,
               RprS.RprS,
               RprJ.RprT,
               RprJ.RprJ,
               " " + _RprS + "  " + L_DatTim.DateStr(_OrdDate));
    END;
   END;
  END;
  SetRprJAttrFieldModifiable(RprJob.Leaf = 1);

  IF RprJob.Leaf = 0 THEN
   SETEMPTY(RprJ.BaseTime, RprJ.Price, RprJ.Sum);
   RprJ.ComplCfc:=1;
   REPLACE(RprJ);
  ELSE
   RprJ.ComplCfc:=1;
   REPLACE(RprJ);

   SetSingleRprJobBaseTime();
   SetRprJNormHourPrice();
   CalcRprJSum();
  END;
 END {RprJ_RprJob_OnSuccessfulChange};

 PRIVATE PROCEDURE RprJ_Quantity_OnSuccessfulChange();
 BEGIN
  CalcRprJSum();
 END {RprJ_Quantity_OnSuccessfulChange};

 PRIVATE PROCEDURE RprJ_Price_OnSuccessfulChange();
 BEGIN
  CalcRprJSum();
 END {RprJ_Price_OnSuccessfulChange};

 PRIVATE PROCEDURE RprJ_Sum_OnSuccessfulChange();
 BEGIN
  IF ~!RprJ.Price THEN
   L_General.Assert(~!RprJ.BaseTime, "  ଠ⨢ 㤮");
   RprJ.Price:=RprJ.Sum / (RprJ.BaseTime * RprJ.Quantity);
   REPLACE(RprJ);
  END;
 END {RprJ_Sum_OnSuccessfulChange};

 PRIVATE PROCEDURE RprJ_BaseTime_OnSuccessfulChange();
  VAR
   prvBaseTime: LIKE(RprJ.BaseTime);
 BEGIN
  prvBaseTime:=GE_PVALUE();
  IF !RprJ.BaseTime THEN
   SetSingleRprJobBaseTime();
  ELSE
   CONFORM(RprJ, RprJob);
   IF RprJob.HasNorm & ~!prvBaseTime & ~!RprJ.Source & (RprJ.Source # L_Rpr.rprjbts_Operator) THEN
    IF L_General.GetAPSiteNumber() = 84 THEN
     L_StdFrm.CrucialChoice_FileExplicit("RprS", " ⮬᪨ ࠭  ६", L_Rpr.GetRprSGroupName(RprS.Location));
    ELSE
     L_StdFrm.Question(" ⢨⥫쭮   ⮬᪨ ࠭  ६?");
    END;
   END;
   RprJ.Source:=L_Rpr.rprjbts_Operator;
   REPLACE(RprJ);
  END;
  CalcRprJSum();
 END {RprJ_BaseTime_OnSuccessfulChange};

 PRIVATE PROCEDURE RprJ_OnBeforeEdIns();
  VAR
   Modifiable: SCAL[2];
 BEGIN
  IF ~!RprJ.RprJob THEN
   CONFORM(RprJ, RprJob);
   Modifiable:=RprJob.Leaf = 1;
  ELSE
   Modifiable:=0;
  END;
  SetRprJAttrFieldModifiable(Modifiable);
 END {RprJ_OnBeforeEdIns};

 PRIVATE PROCEDURE RprJ_OnBeforeInsert();
 BEGIN
  CheckRprT();

  L_General.Assert(~IsOutsideOverhaul() & ~IsOutsideRepair() & ~IsRetireRepair(),
                   " ⨯  '" +
                   L_Str.PoolItem(L_Rpr.rpr_TaskKind_Pool, RprT.TaskKind) +
                   "'     ࠡ");

  IF E_RprJPeriodEqualRprTJobPeriod(RprS.OrdDate) THEN
   SetTableFieldSDT("RprJ", "BDate", RprT.JobBDate, RprT.JobBTime, "", 0);
   SetTableFieldSDT("RprJ", "EDate", RprT.JobEDate, RprT.JobETime, "", 0);
  ELSE
   SetTableFieldSDT("RprJ", "BDate", SYSDATE(),     SYSTIME(),     "", 0);
  END;
  RprJ_OnBeforeEdIns();
 END {RprJ_OnBeforeInsert};

 PRIVATE PROCEDURE PutValue(VAR ValueCode: VARIANT;
                            VAR _Value   : VARIANT;
                                fillProc : PROC);
 BEGIN
  IF ~!ValueCode THEN
   _Value:=fillProc(ValueCode);
  ELSE
   SETEMPTY(ValueCode);
   _Value:=L_Prop.EmptyObjectName;
  END; (* IF *)
 END {PutValue};

 PRIVATE PROCEDURE AccessCarBlock(_CarBlock: LIKE(CarBlock.CarBlock));
 BEGIN
  L_General.ErrorInteractive_NonExistentOwner(SEARCH(CarBlock, CarBlock, _CarBlock));
 END {AccessCarBlock};

 PRIVATE PROCEDURE RprJ_OnBeforeEdit();
 BEGIN
  IF !RprJ.BaseTime THEN
   SetSingleRprJobBaseTime();
   IF ~!RprJ.BaseTime THEN
    FIX_ALTERING();
   END;
  END;
  RprJ_OnBeforeEdIns();
 END {RprJ_OnBeforeEdit};

 PRIVATE PROCEDURE RprJ_OnAfterInsert();
 BEGIN
  RprJ_OnAfterModification(0);
 END {RprJ_OnAfterInsert};

 PRIVATE PROCEDURE RprJ_OnAfterEdit();
 BEGIN
  RprJ_OnAfterModification(0);
 END {RprJ_OnAfterEdit};

 PRIVATE PROCEDURE RprJ_OnBeforeDelete();
 BEGIN
  CheckBeforeDelete(RprJ.RprT, RprJ.RprJ);
 END {RprJ_OnBeforeDelete};

 PRIVATE PROCEDURE RprSE_Fl_0_OnZoneOpen();
 BEGIN
  SetFieldFormat(RTI.Get().CurZone.Fields("RprS.RprObjT"), L_Rpr.rot_Pool);
  SetFieldFormat(RTI.Get().CurZone.Fields("Who_0"),        L_Rpr.rprpwho_Pool);
  SetFieldFormat(RTI.Get().CurZone.Fields("Who_1"),        L_Rpr.rprpwho_Pool);
  SetFieldFormat(RTI.Get().CurZone.Fields("RprPlaceKind"), L_Rpr.rpk_Pool);
  RTI.Get().CurZone.Fields("Location").Template:=PrepareRprPro_Pool();
 END {RprSE_Fl_0_OnZoneOpen};

 PRIVATE PROCEDURE StandOnRprDA_OnlyInExpl(_RprDfApr: LIKE(RprDfApr.RprDfApr));
  CONST
   MinLength = 47;
  VAR
   MaxLength   : NUMERIC[0];
   Msg,
   RprDfAprAsStr,
   CarBlockAsStr: STRING[];
 BEGIN
  SETEMPTY(Msg);
  IF    ~SEARCH(RprDfApr, RprDfApr, _RprDfApr) THEN
   Msg:="  ࠢ " + _RprDfApr;
  ELSIF RprDfApr.InExpl = 0 THEN
   SETEMPTY(CarBlockAsStr);
   RprDfAprAsStr:=RprDfApr.RprDfApr + " " + RprDfApr.Name;
   IF ~!RprDfApr.CarBlock THEN
    CONFORM(RprDfApr, CarBlock);
    CarBlockAsStr:=CarBlock.CarBlock + " " + CarBlock.Name;
   END;
   MaxLength:=Math.Max(Str.Length(RprDfAprAsStr), Str.Length(CarBlockAsStr));
   MaxLength:=Math.Max(MaxLength, MinLength);

   Msg:="ࠢ      ᯫ樨||" +
        "ࠢ  " + Str.Align(RprDfAprAsStr, MaxLength, LEFT) + "|" +
        " (⥬) " + Str.Align(CarBlockAsStr, MaxLength, LEFT);
  END;
  L_General.Assert(!Msg, Msg);
 END {StandOnRprDA_OnlyInExpl};

 PRIVATE PROCEDURE GetRprDfAprName(_RprDfApr: LIKE(RprDfApr.RprDfApr)): STRING[];
 BEGIN
  IF ~!_RprDfApr THEN
   StandOnRprDA_OnlyInExpl(_RprDfApr);
   RETURN RprDfApr.Name;
  ELSE
   RETURN "";
  END;
 END {GetRprDfAprName};

 PRIVATE PROCEDURE GetCarBlockName(_CarBlock: LIKE(CarBlock.CarBlock)): STRING[];
 BEGIN
  IF ~!_CarBlock THEN
   AccessCarBlock(_CarBlock);
   RETURN CarBlock.Name;
  ELSE
   RETURN "";
  END;
 END {GetCarBlockName};

 PRIVATE PROCEDURE GetSortName(_Sort: LIKE(Sort.Sort)): STRING[];
 BEGIN
  IF ~!_Sort THEN
   L_General.Assert(SEARCH(Sort, Sort, _Sort),
                    "  ᥪ " + _Sort);
   RETURN Sort.Name;
  ELSE
   RETURN "";
  END;
 END {GetSortName};

 PRIVATE PROCEDURE GetRprPlaceName(_RprPlace: LIKE(RprPlace.RprPlace)): STRING[];
 BEGIN
  IF ~!_RprPlace THEN
   L_General.Assert(SEARCH(RprPlace, RprPlace, _RprPlace),
                    "   " + _RprPlace);
   RETURN RprPlace.Name;
  ELSE
   RETURN "";
  END;
 END {GetRprPlaceName};

 PRIVATE PROCEDURE GetRealFieldName(FieldName: STRING[]): STRING[];
 BEGIN
  RETURN Str.Item(FieldName, "_", 1);
 END {GetRealFieldName};

 PRIVATE PROCEDURE Fld_woIdx(FieldName: STRING[]): STRING[];
 BEGIN
  RETURN Str.Item(FieldName, "_", 0);
 END {Fld_woIdx};

 PRIVATE PROCEDURE GetCurFieldName(): STRING[];
 BEGIN
  RETURN RTI.Get().CurZone.ActiveField.Name;
 END {GetCurFieldName};

 PRIVATE PROCEDURE RprS_TSN_0_OnBeforeAsk();
  VAR
   Idx: NUMERIC[0];
 BEGIN
  Idx:=L_Prop.GetCurVideoFieldArrIdx();
  L_General.Assert(~!RprS.RprObjId, "   " + L_Rpr.GetRprObjT_AsStr());
  SetOwnerWindow(RTI.Get().CurZone.Fields(L_WDO.Fld_wIdx("Who", Idx)).Value);
 END {RprS_TSN_0_OnBeforeAsk};

 PRIVATE PROCEDURE RprS_TSN_1_OnBeforeAsk();
  VAR
   Idx: NUMERIC[0];
 BEGIN
  Idx:=L_Prop.GetCurVideoFieldArrIdx();
  SetOwnerWindow(RTI.Get().CurZone.Fields(L_WDO.Fld_wIdx("Who", Idx)).Value);
 END {RprS_TSN_1_OnBeforeAsk};

 PRIVATE PROCEDURE StandOnMarkByMarkName(): SCAL[2];
  VAR
   _MarkName: STRING[];
 BEGIN
  _MarkName:=getFV_String("MarkName");
  IF ~!_MarkName THEN
   RETURN SEARCH(Mark, MarkName, _MarkName);
  ELSE
   L_General.CLEAR("Mark");
   RETURN 0;
  END;
 END {StandOnMarkByMarkName};

 PRIVATE PROCEDURE GetMarkFromMarkName(): LIKE(Mark.Mark);
 BEGIN
  IF StandOnMarkByMarkName() THEN
   RETURN Mark.Mark;
  ELSE
   RETURN EMPTYOF(Mark.Mark);
  END;
 END {GetMarkFromMarkName};

 PRIVATE PROCEDURE StandOnOutCarByStateNbr(): SCAL[2];
  VAR
   _StateNbr: STRING[];
 BEGIN
  _StateNbr:=getFV_String("StateNbr");
  IF ~!_StateNbr THEN
   RETURN SEARCH(OutCar, StateNbr, _StateNbr);
  ELSE
   L_General.CLEAR("OutCar");
   RETURN 0;
  END;
 END {StandOnOutCarByStateNbr};

 PRIVATE PROCEDURE GetFirmFromFirmName(): LIKE(Firm.Firm);
  VAR
   _FName: STRING[];
 BEGIN
  _FName:=getFV_String("FirmName");
  IF ~!_FName & SEARCH(Firm, FName, _FName) THEN
   RETURN Firm.Firm;
  ELSE
   RETURN EMPTYOF(Firm.Firm);
  END;
 END {GetFirmFromFirmName};

 PRIVATE PROCEDURE RprS__OnAskPhase1();
  VAR
   FieldName: STRING[];
   Idx      : NUMERIC[0];
   _EnginTyp: LIKE(EnginTyp.EnginTyp);
   _StateNbr: LIKE(OutCar.StateNbr);
   _FirmName: STRING[];
   _OutCBlc : LIKE(OutCBlc.OutCBlc);
   TryCnt   : NUMERIC[0];
   Fields   : FORM_FIELDS;
 BEGIN
  L_Rpr.AccessRprS();
  Fields   :=RTI.Get().CurZone.Fields;
  FieldName:=GetCurFieldName();
  IF Fld_woIdx(FieldName) = "TSN" THEN
   Idx:=L_Prop.GetVideoFieldArrIdx(FieldName);
   PositionInGuide(RTI.Get().CurZone.ActiveField.Value, Fields(L_WDO.Fld_wIdx("Who", Idx)).Value);
  ELSIF FieldName = "MarkName" THEN
   IF ~!GetMarkFromMarkName() THEN
    L_WDO.PositionInOwnerZoneOfActiveField("Mark");
   END;
  ELSIF FieldName = "MarkEnginTyp" THEN
   _EnginTyp:=getFV_String("MarkEnginTyp");
   IF ~!_EnginTyp & SEARCH(EnginTyp, EnginTyp, _EnginTyp) THEN
    L_WDO.PositionInOwnerZoneOfActiveField("EnginTyp");
   END;
  ELSIF FieldName = "StateNbr" THEN
   _StateNbr:=getFV_String("StateNbr");
   IF ~!_StateNbr & SELECT(OutCar, StateNbr, _StateNbr) THEN
    L_WDO.PositionInOwnerZoneOfActiveField("OutCar");
   END;
  ELSIF FieldName = "FirmName" THEN
   _FirmName:=getFV_String("FirmName");
   IF ~!_FirmName & SELECT(Firm, FName, _FirmName) THEN
    L_WDO.PositionInOwnerZoneOfActiveField("Firm");
   END;
  ELSIF FieldName = "OutCBlc" THEN
   _OutCBlc:=getFV_String("OutCBlc");
   IF ~!_OutCBlc & SELECT(OutCBlc, OutCBlc, _OutCBlc) THEN
    L_WDO.PositionInOwnerZoneOfActiveField("OutCBlc");
   END;
  ELSE
   L_General.CallUs(0);
  END;
 END {RprS__OnAskPhase1};

 PRIVATE PROCEDURE FillOutCarAttributesField(FillFromOutCar: SCAL[2]);
  VAR
   Fields: FORM_FIELDS;
 BEGIN
  Fields:=RTI.Get().CurZone.Fields;
  IF FillFromOutCar THEN
   Fields("StateNbr").Value:=OutCar.StateNbr;
   Fields("OutCar").Value  :=OutCar.OutCar;
   Fields("VIN").Value     :=OutCar.VIN;
   Fields("EnginMod").Value:=OutCar.EnginMod;
   Fields("SaleDate").Value:=OutCar.SaleDate;
   Fields("ProdYear").Value:=OutCar.ProdYear;
  ELSE
   SETEMPTY(Fields("OutCar").Value,
            Fields("VIN").Value,
            Fields("EnginMod").Value,
            Fields("SaleDate").Value,
            Fields("ProdYear").Value);
  END;
  SetOutCarAttrFieldModifiable(~FillFromOutCar);
 END {FillOutCarAttributesField};

 PRIVATE PROCEDURE SetOutCBlcAttrFieldModifiable(Modifiable: SCAL[2]);
 BEGIN
  SetFieldModifiable(RTI.Get().CurZone.Fields("Math"),      0);
 END {SetOutCBlcAttrFieldModifiable};

 PRIVATE PROCEDURE FillOutCBlcAttributesField(FillFromOutCBlc: SCAL[2]);
  VAR
   Fields: FORM_FIELDS;
 BEGIN
  Fields:=RTI.Get().CurZone.Fields;
  IF FillFromOutCBlc THEN
   Fields("OutCBlc").Value:=OutCBlc.OutCBlc;
   Fields("Math").Value   :=OutCBlc.Math;
  ELSE
   SETEMPTY(Fields("Math").Value);
  END;
  SetOutCBlcAttrFieldModifiable(~FillFromOutCBlc);
 END {FillOutCBlcAttributesField};

 PRIVATE PROCEDURE FillMarkAttributesField(FillFromMark, ModifiableMarkName, ResetMarkName: SCAL[2]);
  VAR
   Fields: FORM_FIELDS;
 BEGIN
  Fields:=RTI.Get().CurZone.Fields;
  IF FillFromMark THEN
   Fields("Mark").Value        :=Mark.Mark;
   Fields("MarkName").Value    :=Mark.Name;
   Fields("MarkEnginTyp").Value:=Mark.EnginTyp;

   IF ~!Mark.EnginTyp THEN
    CONFORM(Mark, EnginTyp);
    Fields("MarkEnginTypName").Value:=EnginTyp.Name;
   ELSE
    SETEMPTY(Fields("MarkEnginTypName").Value);
   END;
   Fields("MarkEngVol").Value  :=Mark.EngVol;
   Fields("MarkEngPower").Value:=Mark.EngPower;
   IF ~!Mark.EngPower THEN
    Fields("MarkEngPwKWt").Value:=Mark.EngPower * CoefEngPwKWtToEngPower;
   ELSE
    SETEMPTY(Fields("MarkEngPwKWt").Value);
   END;
  ELSE
   SETEMPTY(Fields("Mark").Value,
            Fields("MarkEnginTyp").Value,
            Fields("MarkEnginTypName").Value,
            Fields("MarkEngVol").Value,
            Fields("MarkEngPower").Value,
            Fields("MarkEngPwKWt").Value);
  END;
  IF ResetMarkName THEN
   SETEMPTY(Fields("Mark").Value, Fields("MarkName").Value);
  END;

  SetMarkAttrFieldModifiable(ModifiableMarkName, ~FillFromMark);
 END {FillMarkAttributesField};

 PRIVATE PROCEDURE FillFirmAttributesField(FillFromFirm, ModifiableFirmName, ResetFirmName: SCAL[2]);
  VAR
   _Contract: LIKE(Contract.Contract);
   Fields   : FORM_FIELDS;
 BEGIN
  Fields:=RTI.Get().CurZone.Fields;
  IF FillFromFirm THEN
   Fields("Firm").Value    :=Firm.Firm;
   Fields("FirmName").Value:=Firm.Name;
   IF ~!Fields("FirmPrtnrType") THEN
    Fields("FirmPrtnrType").Value:=Firm.PrtnrTyp;
   END;
  ELSE
   SETEMPTY(Fields("Firm").Value);
   IF ~!Fields("FirmPrtnrType") THEN
    Fields("FirmPrtnrType").Value:=P_Firm.pt_Man;
   END;
  END;

  IF ResetFirmName THEN
   SETEMPTY(Fields("Firm").Value, Fields("FirmName").Value);
  END;

  SETEMPTY(Fields("Contract").Value);
  IF FillFromFirm & L_Rpr.intStandOnRprContract(Firm.Firm, RprS.OrdDate) THEN
   Fields("Contract").Value:=Contract.Contract;
  END;

  SetFirmAttrFieldModifiable(ModifiableFirmName);
 END {FillFirmAttributesField};

 PRIVATE PROCEDURE FillFirmContactAttributesField(FillFromFirm, ResetPhoneNbr: SCAL[2]);
  VAR
   ModifiablePhoneClr,
   ModifiablePhonePST: SCAL[2];
   Fields            : FORM_FIELDS;
 BEGIN
  ModifiablePhoneClr:=1;
  ModifiablePhonePST:=1;
  Fields:=RTI.Get().CurZone.Fields;

  IF FillFromFirm THEN
   SETEMPTY(Fields("FirmPhoneClr").Value, Fields("FirmPhonePST").Value);

   SELECT(FirmCtc, fCtcKind, , Firm.Firm, E_GetDefaultCtcKind());
   WHILE OCCURE(FirmCtc) DO
    IF L_DatTim.IsActive_Inc(RprS.OrdDate, FirmCtc.Begin, FirmCtc.Till) THEN
     CONFORM(FirmCtc, Contact);
     CONFORM(Contact, CtcVal);
     WHILE OCCURE(CtcVal) DO
      IF L_DatTim.IsActive_Inc(RprS.OrdDate, CtcVal.Begin, CtcVal.Till) &
        (CtcVal.Coverage = GetFirmCoverage(Firm.PrtnrTyp)) THEN
       IF    CtcVal.Type = L_ctc.cvt_PhoneClr THEN
        InsertNewObjects[inoi_PhoneClr]:=0;
        ModifiablePhoneClr             :=0;
        Fields("FirmPhoneClr").Value:=CtcVal.Value;
       ELSIF CtcVal.Type = L_ctc.cvt_PhonePST THEN
        InsertNewObjects[inoi_PhonePST]:=0;
        ModifiablePhonePST             :=0;
        Fields("FirmPhonePST").Value:=CtcVal.Value;
       END;
      END;
      NEXT(CtcVal);
     END; (* WHILE OCCURE(CtcVal) ... *)
    END;
    NEXT(FirmCtc);
   END; (* WHILE OCCURE(FirmCtc) ... *)
  END;

  IF ResetPhoneNbr THEN
   SETEMPTY(Fields("FirmPhoneClr").Value, Fields("FirmPhonePST").Value);
  END;

  SetFirmContactAttrFieldModifiable(ModifiablePhoneClr, ModifiablePhonePST);
 END {FillFirmContactAttributesField};

 PRIVATE PROCEDURE OnAfterChooseOutCarFromGuide();
 BEGIN
(*Shit! *)
  RprS.CUCopy  :=OutCar.CUCopy;
  RprS.RprObjId:=OutCar.OutCar;
  REPLACE(RprS);

  TRY
(*shit.   Assert, ⮬   䫠*)
   RprObjId_OnSuccessfulChange(EMPTYOF(RprS.RprObjId));
  EXCEPT
  ON Exc: Exc_Root DO
   SETEMPTY(RTI.Get().CurZone.Fields("OutCar").Value);
   WasAskProcess:=0;
   RAISE();
  END; (* TRY *)

  InsertNewObjects[inoi_OutCar]  :=0;
  InsertNewObjects[inoi_PhoneClr]:=0;
  InsertNewObjects[inoi_PhonePST]:=0;
  InsertNewObjects[inoi_Firm]    :=0;
  FillOutCarAttributesField(1);
  CONFORM(OutCar, Mark);
  FillMarkAttributesField(1, 0, 0);
  CONFORM(OutCar, Firm);
  FillFirmAttributesField(1, 0, 0);
  FillFirmContactAttributesField(1, 0);
 END {OnAfterChooseOutCarFromGuide};

 PRIVATE PROCEDURE OnAfterChooseOutCBlcFromGuide();
 BEGIN
(*Shit! *)
  RprS.CUCopy  :=OutCBlc.CUCopy;
  RprS.RprObjId:=OutCBlc.OutCBlc;
  REPLACE(RprS);

  TRY
(*shit.   Assert, ⮬   䫠*)
   RprObjId_OnSuccessfulChange(EMPTYOF(RprS.RprObjId));
  EXCEPT
  ON Exc: Exc_Root DO
   WasAskProcess:=0;
   RAISE();
  END; (* TRY *)

  InsertNewObjects[inoi_OutCBlc] :=0;
  InsertNewObjects[inoi_PhoneClr]:=0;
  InsertNewObjects[inoi_PhonePST]:=0;
  InsertNewObjects[inoi_Firm]    :=0;
  CONFORM(OutCBlc, Math);
  FillOutCBlcAttributesField(1);
  CONFORM(OutCBlc, Firm);
  FillFirmAttributesField(1, 0, 0);
 END {OnAfterChooseOutCBlcFromGuide};

 PRIVATE PROCEDURE OnAfterChooseMarkFromGuide();
 BEGIN
  InsertNewObjects[inoi_Mark]:=0;
  FillMarkAttributesField(1, 1, 0);
 END {OnAfterChooseMarkFromGuide};

 PRIVATE PROCEDURE OnAfterChooseFirmByPhoneFromGuide(inoIdx: NUMERIC[0]);
 BEGIN
  InsertNewObjects[inoi_Firm]:=0;
  InsertNewObjects[inoIdx]   :=0;
  FillFirmAttributesField(1, 0, 0);
  FillFirmContactAttributesField(1, 0);
 END {OnAfterChooseFirmByPhoneFromGuide};

 PRIVATE PROCEDURE OnAfterChooseFirmFromGuide();
 BEGIN
  CheckOutRprObjFirmAdaptability(Firm.Firm, RprS.OrdDate);
  InsertNewObjects[inoi_Firm]:=0;
  FillFirmAttributesField(1, 1, 0);
  FillFirmContactAttributesField(1, 0);
 END {OnAfterChooseFirmFromGuide};

 PRIVATE PROCEDURE RprS__OnAskPhase2();
  VAR
   FieldName: STRING[];
   Idx      : NUMERIC[0];
 BEGIN
  WasAskProcess:=1;
  FieldName    :=GetCurFieldName();
  IF    Fld_woIdx(FieldName)= "TSN" THEN
   Idx:=L_Prop.GetVideoFieldArrIdx(FieldName);
   RTI.Get().CurZone.ActiveField.Value:=GetTSNFromGuide(RTI.Get().CurZone.Fields(L_WDO.Fld_wIdx("Who", Idx)).Value);
  ELSIF FieldName = "StateNbr" THEN
   RTI.Get().CurZone.Fields("OutCar").Value  :=OutCar.OutCar;
   RTI.Get().CurZone.Fields("StateNbr").Value:=OutCar.StateNbr;
(*
   OnAfterChooseOutCarFromGuide();
*)
  ELSIF FieldName = "MarkName" THEN
   RTI.Get().CurZone.Fields("Mark").Value    :=Mark.Mark;
   RTI.Get().CurZone.Fields("MarkName").Value:=Mark.Name;
(*
   OnAfterChooseMarkFromGuide();
*)
  ELSIF FieldName = "MarkEnginTyp" THEN
   RTI.Get().CurZone.Fields("MarkEnginTyp").Value    :=EnginTyp.EnginTyp;
   RTI.Get().CurZone.Fields("MarkEnginTypName").Value:=EnginTyp.Name;
(*
   RTI.Get().CurZone.Fields("MarkEnginTypName").Value:=EnginTyp.Name;
*)
  ELSIF FieldName = "FirmName" THEN
   RTI.Get().CurZone.Fields("Firm").Value    :=Firm.Firm;
   RTI.Get().CurZone.Fields("FirmName").Value:=Firm.Name;
(*
   OnAfterChooseFirmFromGuide();
*)
  ELSIF FieldName = "OutCBlc" THEN
   RTI.Get().CurZone.Fields("OutCBlc").Value:=OutCBlc.OutCBlc;
(*
   OnAfterChooseOutCBlcFromGuide();
*)
  ELSE
   L_General.CallUs(0);
  END;
 END {RprS__OnAskPhase2};

 PRIVATE PROCEDURE ChooseObject(VAR NewObjectName: STRING[]; List, Object: STRING[]; RequiredInsertNewObject: SCAL[2]; VAR InsertNew: SCAL[2]): NUMERIC[0];
  CONST
   MaxLength = 55;
  VAR
   tmpNewObject,
   s, Msg,
   ButtonList,
   VariableList: STRING[];
   i, j,
   MaxL,
   Result,
   Choice,
   aws_Height  : NUMERIC[0];
 BEGIN
  IF ~!List THEN
   j      :=0;
   MaxL   :=0;
   LOOP
    s      :=L_Str.PoolItem(List, j);
    IF ~!s THEN
     MaxL   :=Math.Max(MaxL,    Str.Length(s));
     INC(j);
     s:=L_Str.PoolItem(List, j);
    ELSE
     EXIT;
    END;
   END; (* LOOP *)

   GE_APPWIN_SIZE(, aws_Height);
   j:=Math.Min(Math.Max(j, 2), aws_Height * 2 DIV 3);
   Choice:=0;
  ELSE
   SETEMPTY(Choice);
  END;

  MaxL:=Math.Max(Str.Length(NewObjectName), MaxLength);

  INC(MaxL, 2);

  SETEMPTY(Msg, VariableList);
  IF ~!List THEN
   Msg         :="|%" + L_Str.IntStr(MaxL) + "," + L_Str.IntStr(j) + "<" + List + ">I" + L_Str.Repeat("|", j-1);
   VariableList:="Choice";
  END;

  IF RequiredInsertNewObject THEN
   Msg         :=Msg + "|";
   IF ~!List THEN
    Msg         :=Msg +
                  L_Str.Repeat("", MaxL + 2) +
                  "||";
   END;
   Msg         :=Msg + "%" + L_Str.IntStr(MaxL-2) + "YI";

   IF ~!List THEN
    ButtonList  :="%< ⮯! >Z  %< ନ   >B  %<  >DB";
   ELSE
    ButtonList  :="%< ⮯! >Z  %< ନ   >DB";
   END;

   VariableList:=L_Str.AddStrDlm(VariableList, ",") + "NewObjectName";
  ELSE
   ButtonList  :="%< ⮯! >X  %<  >DB";
  END;

  LOOP
   tmpNewObject:=NewObjectName;
   Result      :=STDFORM(Msg + "||" + ButtonList, " 롮 " + Object + " ", INFORM_NEUTRAL, 1, ^(VariableList));
   InsertNew   :=(Result = 1) & RequiredInsertNewObject;
   IF InsertNew & !NewObjectName THEN
    L_StdFrm.RedInform(" 㪠  ꥪ");
    NewObjectName:=tmpNewObject;
   ELSE
    EXIT;
   END;
  END; (* LOOP *)

  RETURN Choice;
 END {ChooseObject};

 PRIVATE PROCEDURE IsSuccessfullChangeAfterAsk(): SCAL[2];
 BEGIN
  RETURN VAR_IMPL.Get(WasAskProcess).Initialized & WasAskProcess;
 END {IsSuccessfullChangeAfterAsk};

 PRIVATE PROCEDURE SetAccessDataModeSOFT(FileList: STRING[]; VAR AccessDataMode: NUMERIC[0][]);
  VAR
   i   : NUMERIC[0];
   File: STRING[];
 BEGIN
  i:=0;
  LOOP
   File:=Str.Item(FileList, ";", i);
   IF !File THEN
    EXIT;
   END;
   AccessDataMode[i]:=TABLE.Get(File).AccessDataMode;
   TABLE.Get(File).AccessDataMode:=adm_SOFT;
   INC(i);
  END; (* LOOP *)
 END {SetAccessDataModeSOFT};

 PRIVATE PROCEDURE RestoreAccessDataMode(FileList: STRING[];  AccessDataMode: NUMERIC[0][]);
  VAR
   i   : NUMERIC[0];
   File: STRING[];
 BEGIN
  i:=0;
  LOOP
   File:=Str.Item(FileList, ";", i);
   IF !File THEN
    EXIT;
   END;
   TABLE.Get(File).AccessDataMode:=AccessDataMode[i];
   INC(i);
  END; (* LOOP *)
 END {RestoreAccessDataMode};

 PRIVATE PROCEDURE FillMarkList(_MarkName: STRING[]; Dummy: STRING[]; VAR FoundMark: SCAL[2]; VAR Amount: NUMERIC[0]; VAR MarkList, ChooseList, SearchList: STRING[]);
  VAR
   AccessDataMode: NUMERIC[0];
 BEGIN
  SetAccessDataModeSOFT("Mark", AccessDataMode);

  SETEMPTY(MarkList, ChooseList, SearchList);
  SELECT(Mark, MarkName);
  WHILE OCCURE(Mark) DO
   PROMPT(" " + Mark.Mark);
   IF L_DatTim.IsActive(RprS.OrdDate, Mark.Begin, Mark.Till) &
      Str.Match(Str.Cap(Mark.Name), "*" + _MarkName + "*") THEN
    IF L_Str.IsEqStrI(Mark.Name, _MarkName) THEN
     FoundMark:=1;
    END;
    SearchList:=SearchList + Mark.Mark + "|";
    MarkList  :=MarkList   + Mark.Name + "|";
    ChooseList:=ChooseList + Str.Align(Mark.Name, Str.MaxLength(Mark.Name), LEFT) + " " + L_Str.PoolItem("!| ", Mark.use_OutC) +  "|";
    INC(Amount);
   END;
   NEXT(Mark);
  END; (* WHILE OCCURE(Mark) ... *)

  RestoreAccessDataMode("Mark", AccessDataMode);
 END {FillMarkList};

 PRIVATE PROCEDURE FillOutCarList(_StateNbr: STRING[]; Dummy: STRING[]; VAR FoundOutCar: SCAL[2]; VAR Amount: NUMERIC[0]; VAR OutCarList, ChooseList, SearchList: STRING[]);
  VAR
   AccessDataMode: NUMERIC[0][2];
 BEGIN
  SetAccessDataModeSOFT("Mark;OutCar", AccessDataMode);

  SETEMPTY(OutCarList, ChooseList, SearchList);
  SELECT(OutCar, StateNbr);
  WHILE OCCURE(OutCar) DO
   PROMPT(" " + OutCar.OutCar);
   IF L_DatTim.IsActive(RprS.OrdDate, OutCar.Begin, OutCar.Till) & (Str.Match(Str.Cap(OutCar.StateNbr), "*" + _StateNbr + "*")) THEN
    CONFORM(OutCar, Mark);
    IF L_Str.IsEqStrI(OutCar.StateNbr, _StateNbr) THEN
     FoundOutCar:=1;
    END;
    SearchList:=SearchList + OutCar.OutCar + "|";
    OutCarList:=OutCarList + OutCar.StateNbr + "|";
    ChooseList:=ChooseList + Str.Align(OutCar.StateNbr, Str.MaxLength(OutCar.StateNbr), LEFT) + " " + Mark.Name + "|";
    INC(Amount);
   END;
   NEXT(OutCar);
  END; (* WHILE OCCURE(OutCar) ... *)

  RestoreAccessDataMode("Mark;OutCar", AccessDataMode);
 END {FillOutCarList};

 PRIVATE PROCEDURE FillOutCBlcList(_OutCBlc: LIKE(OutCBlc.OutCBlc); Dummy: STRING[]; VAR FoundOutCBlc: SCAL[2]; VAR Amount: NUMERIC[0]; VAR OutCBlcList, ChooseList, SearchList: STRING[]);
  VAR
   AccessDataMode: NUMERIC[0][2];
 BEGIN
  SetAccessDataModeSOFT("OutCBlc;Mark", AccessDataMode);

  SETEMPTY(OutCBlcList, ChooseList, SearchList);
  SELECT(OutCBlc, OutCBlc);
  WHILE OCCURE(OutCBlc) DO
   PROMPT(" " + OutCBlc.OutCBlc);
   IF L_DatTim.IsActive(RprS.OrdDate, OutCBlc.Begin, OutCBlc.Till) & (Str.Match(Str.Cap(OutCBlc.OutCBlc), "*" + _OutCBlc + "*")) THEN
    CONFORM(OutCBlc, Math);
    IF L_Str.IsEqStrI(OutCBlc.OutCBlc, _OutCBlc) THEN
     FoundOutCBlc:=1;
    END;
    SearchList :=SearchList + OutCBlc.OutCBlc + "|";
    OutCBlcList:=OutCBlcList + OutCBlc.OutCBlc + "|";
    ChooseList:=ChooseList + Str.Align(OutCBlc.OutCBlc, Str.MaxLength(OutCBlc.OutCBlc), LEFT) + " " + Math.Name + "|";
    INC(Amount);
   END;
   NEXT(OutCBlc);
  END; (* WHILE OCCURE(OutCBlc) ... *)

  RestoreAccessDataMode("OutCBlc;Math", AccessDataMode);
 END {FillOutCBlcList};

 PRIVATE PROCEDURE FillFirmListByPhone(_Phone: STRING[]; _Type: LIKE(CtcVal.Type); VAR FoundFirm: SCAL[2]; VAR Amount: NUMERIC[0]; VAR FirmList, ChooseList, SearchList: STRING[]);
  VAR
   AccessDataMode: NUMERIC[0][4];
 BEGIN
  SetAccessDataModeSOFT("Firm;FirmCtc;Contact;CtcVal", AccessDataMode);
(*
  L_Prop.CheckNumericValue(_Phone, "0");
*)
  SETEMPTY(FirmList, ChooseList, SearchList);
  _Phone:=L_ctc.GetInvValue(_Phone);
  SETSEL(CtcVal, InvValue);
  SRCINSEL(CtcVal, GE, , _Phone);
  WHILE OCCURE(CtcVal) & Str.Match(CtcVal.InvValue, _Phone+"*") DO
   PROMPT(" " + CtcVal.Contact);
   IF L_DatTim.IsActive_Inc(RprS.OrdDate, CtcVal.Begin, CtcVal.Till) &
      (CtcVal.Type = _Type) THEN
    CONFORM(CtcVal, Contact);
    SELECT(FirmCtc, Contact, , Contact.Contact);
    WHILE OCCURE(FirmCtc) DO
     IF L_DatTim.IsActive_Inc(RprS.OrdDate, FirmCtc.Begin, FirmCtc.Till) THEN
      CONFORM(FirmCtc, Firm);
      IF (CtcVal.Coverage = GetFirmCoverage(Firm.PrtnrTyp)) & (FirmCtc.CtcKind = 00) THEN
       SearchList:=SearchList + Firm.Firm  + "|";
       FirmList  :=FirmList   + CtcVal.Value + "|";
       ChooseList:=ChooseList + Str.Align(Firm.Name, 32, LEFT) + " " + CtcVal.Value + "|";
       IF L_Str.IsEqStrI(CtcVal.InvValue, _Phone) THEN
        FoundFirm:=1;
       END;
       INC(Amount);
      END;
     END;
     NEXT(FirmCtc);
    END; (* WHILE OCCURE(FirmCtc) ... *)
   END;
   NEXT(CtcVal);
  END;
  RestoreAccessDataMode("Firm;FirmCtc;Contact;CtcVal", AccessDataMode);
 END {FillFirmListByPhone};

 PRIVATE PROCEDURE FillFirmList(_FirmName: STRING[]; Dummy: STRING[]; VAR FoundFirm: SCAL[2]; VAR Amount: NUMERIC[0]; VAR FirmList, ChooseList, SearchList: STRING[]);
  VAR
   AccessDataMode: NUMERIC[0];
 BEGIN
  SetAccessDataModeSOFT("Firm", AccessDataMode);

  SETEMPTY(FirmList, ChooseList, SearchList);
  SELECT(Firm, FName);
  WHILE OCCURE(Firm) DO
   PROMPT(" " + Firm.Firm);
   IF L_DatTim.IsActive(RprS.OrdDate, Firm.Begin, Firm.Till) &
      Str.Match(Str.Cap(Firm.Name), "*" + _FirmName + "*") THEN
    IF L_Str.IsEqStrI(Firm.Name, _FirmName) THEN
     FoundFirm:=1;
    END;
    SearchList:=SearchList + Firm.Firm + "|";
    FirmList  :=FirmList   + Firm.Name + "|";
    ChooseList:=ChooseList + Firm.Firm + " " + Str.Align(Firm.Name, Str.MaxLength(Firm.Name), LEFT) + "|";
    INC(Amount);
   END;
   NEXT(Firm);
  END; (* WHILE OCCURE(Firm) ... *)
  RestoreAccessDataMode("Firm", AccessDataMode);
 END {FillFirmList};

 PRIVATE PROCEDURE intChooseAcceptableObject(FieldName, ObjectName, AddParam: STRING[]; ino_Index: NUMERIC[0]; FillObjectList: PROC; ManualChoose: SCAL[2]): STRING[];
  VAR
   tmpObjectName,
   SearchList,
   ChooseList,
   ObjectList     : STRING[];
   Amount, Choice : NUMERIC[0];
   FoundObject,
   InsertNewObject: SCAL[2];
 BEGIN
  FoundObject    :=0;
  Amount         :=0;
  InsertNewObject:=0;
  SETEMPTY(tmpObjectName);
  LOOP
   IF tmpObjectName # ObjectName THEN
    FillObjectList(ObjectName, AddParam, FoundObject, Amount, ObjectList, ChooseList, SearchList);
   END;
   IF ~!tmpObjectName & (~InsertNewObject | (tmpObjectName = ObjectName)) THEN
    EXIT;
   END;
   IF InsertNewObject & !ChooseList THEN
    EXIT;
   END;
   InsertNewObject:=0;
   tmpObjectName  :=ObjectName;
   Choice:=ChooseObject(ObjectName, ChooseList, L_Str.PoolItem(ino_Pool, ino_Index), ~FoundObject, InsertNewObject);
  END;

  IF    ~InsertNewObject THEN
   RTI.Get().CurZone.Fields(FieldName).Value:=L_Str.PoolItem(ObjectList, Choice);
   RETURN L_Str.PoolItem(SearchList, Choice);
  ELSE
   RTI.Get().CurZone.Fields(FieldName).Value:=ObjectName;
   RETURN "";
  END;
 END {intChooseAcceptableObject};

 PRIVATE PROCEDURE ChooseAcceptableObject(FieldName: STRING[]; AddParam: STRING[]; ino_Index: NUMERIC[0]; FillObjectList: PROC; ManualChoose: SCAL[2]): STRING[];
  VAR
   ObjectName: STRING[];
 BEGIN
  ObjectName :=getFV_String(FieldName);
  L_General.Assert(~!ObjectName, "  ࠬ .   .");

  RETURN intChooseAcceptableObject(FieldName, ObjectName, AddParam, ino_Index, FillObjectList, ManualChoose);
 END {ChooseAcceptableObject};

 PRIVATE PROCEDURE ChooseAcceptableOutCar(ManualChoose, _WasAskProcess: SCAL[2]);
  VAR
   trgOutCar: LIKE(OutCar.OutCar);
 BEGIN
  IF ~_WasAskProcess THEN
   trgOutCar:=ChooseAcceptableObject("StateNbr", "", inoi_OutCar, PROCREF(FillOutCarList), ManualChoose);
  ELSE
   trgOutCar:=RTI.Get().CurZone.Fields("OutCar").Value;
  END;

  IF ~!trgOutCar THEN
   SEARCH(OutCar, OutCar, , trgOutCar);
   OnAfterChooseOutCarFromGuide();
  ELSE
   InsertNewObjects[inoi_OutCar]:=1;
   FillOutCarAttributesField(0);

   IF !getFV_String("MarkName") THEN
    FillMarkAttributesField(0, 1, 1);
   ELSE
    SetMarkAttrFieldModifiable(1, !getFV_String("Mark"));
   END;

   IF !getFV_String("FirmName") THEN
    FillFirmAttributesField(0, 1, 1);
   ELSE
    SetFirmAttrFieldModifiable(1);
   END;

   FillFirmContactAttributesField(0, 0);
  END;
 END {ChooseAcceptableOutCar};

 PRIVATE PROCEDURE ChooseAcceptableMark(ManualChoose, _WasAskProcess: SCAL[2]);
  VAR
   trgMark: LIKE(Mark.Mark);
 BEGIN
  IF ~_WasAskProcess THEN
   trgMark:=ChooseAcceptableObject("MarkName", "", inoi_Mark, PROCREF(FillMarkList), ManualChoose);
  ELSE
   trgMark:=RTI.Get().CurZone.Fields("Mark").Value;
  END;
  IF ~!trgMark THEN
   SEARCH(Mark, Mark, , trgMark);
   OnAfterChooseMarkFromGuide();
  ELSE
   InsertNewObjects[inoi_Mark]:=1;
   FillMarkAttributesField(0, 1, 0);
  END;
 END {ChooseAcceptableMark};

 PRIVATE PROCEDURE ChooseAcceptableFirmByPhone(ManualChoose: SCAL[2]; _Type: LIKE(CtcVal.Type));
  VAR
   _FirmCtcAttr: STRING[];
   ocFirm,
   _Firm       : LIKE(Firm.Firm);
   _FirmCtc    : LIKE(FirmCtc.FirmCtc);
   _Contact    : LIKE(Contact.Contact);
   inoIdx      : NUMERIC[0];
   PhoneNbr    : STRING[];
 BEGIN
  IF _Type = L_ctc.cvt_PhoneClr THEN
   inoIdx:=inoi_PhoneClr;
  ELSE
   inoIdx:=inoi_PhonePST;
  END;
  PhoneNbr:=getFV_String(GetCurFieldName());
  IF ~!PhoneNbr THEN
   _Firm:=ChooseAcceptableObject(GetCurFieldName(), _Type, inoIdx, PROCREF(FillFirmListByPhone), ManualChoose);
  ELSE
   SETEMPTY(_Firm);
  END;

  IF ~!_Firm THEN
   SEARCH(Firm, Firm, , _Firm);
   IF ~!getFV_String("OutCar") THEN
    ocFirm:=getFV_String("Firm");
    L_General.Assert(_Firm = ocFirm,
                     "ࠣ|" +
                     Firm.Name + "||" +
                     "࠭   ⥫䮭 " + PhoneNbr + "||" +
                     " ᮢ  ࠣ⮬ |" +
                     getFV_String("FirmName"));
   END;
   OnAfterChooseFirmByPhoneFromGuide(inoIdx);
  ELSE
   L_ctc.CheckPhoneFormat(getFV_String(GetCurFieldName()));
   InsertNewObjects[inoIdx]:=1;
   IF !getFV_String("FirmName") THEN
    FillFirmAttributesField(0, 1, 1);
    FillFirmContactAttributesField(0, 0);
   END;
  END;
 END {ChooseAcceptableFirmByPhone};

 PRIVATE PROCEDURE ChooseAcceptableFirm(ManualChoose, _WasAskProcess: SCAL[2]);
  VAR
   trgFirm: LIKE(Firm.Firm);
 BEGIN
  IF ~_WasAskProcess THEN
   trgFirm:=ChooseAcceptableObject("FirmName", "", inoi_Firm, PROCREF(FillFirmList), ManualChoose);
  ELSE
   trgFirm:=RTI.Get().CurZone.Fields("Firm").Value;
  END;
  IF ~!trgFirm THEN
   SEARCH(Firm, Firm, , trgFirm);
   OnAfterChooseFirmFromGuide();
  ELSE
   InsertNewObjects[inoi_Firm]:=1;
   FillFirmAttributesField(0, 1, 0);

   IF ~InsertNewObjects[inoi_PhoneClr] THEN
    SETEMPTY(RTI.Get().CurZone.Fields("FirmPhoneClr").Value);
   END;
   IF ~InsertNewObjects[inoi_PhonePST] THEN
    SETEMPTY(RTI.Get().CurZone.Fields("FirmPhonePST").Value);
   END;
   SetFirmContactAttrFieldModifiable(1, 1);
  END;
 END {ChooseAcceptableFirm};

 PRIVATE PROCEDURE RprS__OnSuccessfulChange();
  VAR
   _VIN,
   FieldName         : STRING[];
   i, Idx            : NUMERIC[0];
   tmpWasAskProcess  : SCAL[2];
   _EnginTyp         : LIKE(EnginTyp.EnginTyp);
   MarkEngPwKWt      : NUMERIC[2];
   CorrectionRequired: SCAL[2];
   curRprDfApr       : LIKE(RprDfApr.RprDfApr);
   Fields            : FORM_FIELDS;
 BEGIN
  L_Rpr.AccessRprS();
  IF ~IsSuccessfullChangeAfterAsk() THEN
   tmpWasAskProcess:=0;
  ELSE
   tmpWasAskProcess:=WasAskProcess;
  END;
  WasAskProcess:=0;
  FieldName    :=GetCurFieldName();
  Fields       :=RTI.Get().CurZone.Fields;
  IF    Fld_woIdx(FieldName) = "RprDfApr" THEN
   Idx:=L_Prop.GetVideoFieldArrIdx(FieldName);
   curRprDfApr:=RTI.Get().CurZone.ActiveField.Value;
   IF ~!curRprDfApr THEN
    i:=0;
    WHILE i < rfl_RprDA_Amount DO
     IF i # Idx THEN
      L_General.Assert(curRprDfApr # RTI.Get().CurZone.Fields(L_WDO.Fld_wIdx("RprDfApr", i)).Value,
                       "  㦥  ࠢ " + curRprDfApr);
     END;
     INC(i);
    END; (* WHILE i < ...*)
    StandOnRprDA_OnlyInExpl(curRprDfApr);
    RTI.Get().CurZone.Fields(L_WDO.Fld_wIdx("CarBlock", Idx)).Value:=RprDfApr.CarBlock;
    CorrectionRequired :=RprDfApr.Leaf = 0;
   ELSE
    CorrectionRequired :=0;
    SETEMPTY(Fields(L_WDO.Fld_wIdx("CarBlock", Idx)).Value);
   END;
   Fields(L_WDO.Fld_wIdx("CorrectionRequired", Idx)).Value:=L_Str.PoolItem(" |!", CorrectionRequired);
  ELSIF (FieldName = "JobBDate") | (FieldName = "JobBTime") THEN
   JobBDateTimeChange(!Fields("JobBDate").Value | !Fields("JobBTime").Value);
  ELSIF FieldName = "Sort" THEN
   CheckSortAdaptability(RTI.Get().CurZone.ActiveField.Value);
  ELSIF FieldName = "RprPlace" THEN
   IF ~!RTI.Get().CurZone.ActiveField.Value THEN
    SEARCH(RprPlace, RprPlace, , RTI.Get().CurZone.ActiveField.Value);
    L_General.Assert(RprPlace.Kind = RTI.Get().CurZone.Fields("RprPlaceKind").Value,
                     " ࠭ ६⭮   ᮮ⢥ ଫ塞 ");
   END;

   IF (GetInsertRprSMode() = irm_IndependentRepair) &
      E_NeedUseRprStaff() &
      SEARCH(RprStaff, RprPlace, RTI.Get().CurZone.ActiveField.Value, RprS.OrdDate) THEN
    Fields("TSN_1").Value    :=RprStaff.TSN;
    Fields("ManName_1").Value:=GetManName(RprStaff.TSN);
   END;
  ELSIF Fld_woIdx(FieldName) = "TSN" THEN
   Idx:=L_Prop.GetVideoFieldArrIdx(FieldName);
   IF ~!RTI.Get().CurZone.ActiveField.Value THEN
    CheckRprSCUCopy();
    CheckExistsTSNInGuide(RTI.Get().CurZone.ActiveField.Value, Fields(L_WDO.Fld_wIdx("Who", Idx)).Value);
    CheckStaffInState(RTI.Get().CurZone.ActiveField.Value, RprS.OrdDate, 1);
    IF    Fields(L_WDO.Fld_wIdx("Who", Idx)).Value = L_Rpr.rprpwho_DrvDeclarant THEN
     Fields("ManClrPhones_0").Value:=GetManClrPhones(RTI.Get().CurZone.ActiveField.Value);
    ELSIF Fields(L_WDO.Fld_wIdx("Who", Idx)).Value = L_Rpr.rprpwho_TechAidDrv THEN
     CheckStaffIsRepairMan(RTI.Get().CurZone.ActiveField.Value, Fields(L_WDO.Fld_wIdx("Who", Idx)).Value);
    END;
    Fields(L_WDO.Fld_wIdx("ManName", Idx)).Value:=GetManName(RTI.Get().CurZone.ActiveField.Value);
    rfl_DrvStandToRepair(Fields);
   ELSE
    SETEMPTY(Fields(L_WDO.Fld_wIdx("ManName", Idx)).Value);
    IF  Fields(L_WDO.Fld_wIdx("Who", Idx)).Value = L_Rpr.rprpwho_DrvDeclarant THEN
     Fields("ManClrPhones_0").Value:=" ";
    END;
    rfl_DrvStandToRepair(Fields);
   END;
  ELSIF FieldName = "TaskLen" THEN
   CalcTaskLen_inDateTime();
  ELSIF (FieldName = "PlnEDate") | (FieldName = "PlnETime") THEN
   Fields("TaskLen").Value:=CalcTaskLen(RprS.OrdDate, RprS.OrdTime, Fields("PlnEDate").Value, Fields("PlnETime").Value);
  ELSIF FieldName = "VIN" THEN
   _VIN:=Str.Cap(getFV_String("VIN"));
   RTI.Get().CurZone.Fields("VIN").Value:=_VIN;
   L_Car.CheckVIN(_VIN);
  ELSIF FieldName = "StateNbr" THEN
   L_WDO.cField("StateNbr").Value:=L_Car.E_GetCorrectedStateNbr(getFV_String("StateNbr"), 0);
   ChooseAcceptableOutCar(0, tmpWasAskProcess);
  ELSIF FieldName = "MarkName" THEN
   ChooseAcceptableMark(0, tmpWasAskProcess);
  ELSIF FieldName = "MarkEnginTyp" THEN
   _EnginTyp:=getFV_String("MarkEnginTyp");
   SETEMPTY(RTI.Get().CurZone.Fields("MarkEnginTypName").Value);
   IF ~!_EnginTyp THEN
    L_General.Assert(SEARCH(EnginTyp, EnginTyp, _EnginTyp), "  ⨯ ⥫ " + _EnginTyp);
    RTI.Get().CurZone.Fields("MarkEnginTypName").Value:=EnginTyp.Name;
   END;
  ELSIF FieldName = "MarkEngPwKWt" THEN
   MarkEngPwKWt:=RTI.Get().CurZone.Fields("MarkEngPwKWt").Value;
   IF ~!MarkEngPwKWt THEN
    RTI.Get().CurZone.Fields("MarkEngPower").Value:=MarkEngPwKWt / CoefEngPwKWtToEngPower;
   ELSE
    SETEMPTY(RTI.Get().CurZone.Fields("MarkEngPower").Value);
   END;
  ELSIF FieldName = "FirmPhoneClr" THEN
   ChooseAcceptableFirmByPhone(0, L_ctc.cvt_PhoneClr);
  ELSIF FieldName = "FirmPhonePST" THEN
   ChooseAcceptableFirmByPhone(0, L_ctc.cvt_PhonePST);
  ELSIF FieldName = "FirmName" THEN
   ChooseAcceptableFirm(0, tmpWasAskProcess);
  ELSIF FieldName = "OutCBlc" THEN
   L_General.ErrorInteractive_NonExistentOwner(SEARCH(OutCBlc, OutCBlc, RTI.Get().CurZone.ActiveField.Value));
   L_Rpr.StandOnRprContract(OutCBlc.Firm, RprS.OrdDate);
   OnAfterChooseOutCBlcFromGuide();
  ELSE
   L_General.CallUs(0);
  END;
 END {RprS__OnSuccessfulChange};

 PUBLIC PROCEDURE RprS_Transfer();
  VAR
   DestLocation: L_Rpr.tRprSLocation;
 BEGIN
  L_General.Assert(ACCESS(RprS), " ࠭ ६ ");
  IF RprS.Closed THEN
   IF (RprS.Status = L_Rpr.ms_NeedRate) & L_Rpr.IsMainRpr() & ~L_General.IsAdmin() THEN
    L_StdFrm.CrucialChoice("।  㣮 ஢ ,  ஬ 㦥|"+
                           "뫠 믮 ।  ᯫ", L_General.AdminGroupName());
   ELSE
    L_General.Assert_wReferToAdmin(0, "  , । ");
   END;
  END;
  DestLocation:=ChooseAction(L_XDoc.action_rprTransfer);

  E_TransferCondition(DestLocation);

  RprS.Location:=DestLocation;
  REPLACE(RprS);
  IF E_NeedInformAboutRepetition(RprS.Location) THEN
   ClearRprPro(P_Rpr.P_RepeatedRprS, "", "");
   PutRprPro("",
             P_Rpr.P_RepeatedRprS,
             RprS.RprS,
             "",
             "",
             E_GetRepeatedRprSDescr());
  END;
  L_Rpr.CurRprSXDocJrnMark(L_XDoc.action_rprTransfer);
  InsertPutOffDfApr(0, E_wQuestionBeforeInsertPutOffDfApr(), ipoda_TransferRprS);
 END {RprS_Transfer};

 PRIVATE PROCEDURE MakeRprShift();
  VAR
   _RprShift: LIKE(RprStaff.RprShift);
 BEGIN
  SELECT(RprStaff, RprTSN);
  LAST(RprStaff);
  L_StdFrm.Choice(" ⠢ ᬥ ६⭮ |" +
                  " " + L_DatTim.DateStr(L_Rpr.v_rprs_BegDate) +
                  ", ᬥ N " + L_Rpr.GetShiftNbr(RprStaff.RprShift, +1));
 END {MakeRprShift};

 PRIVATE PROCEDURE HasVisibleLocation(RprSLocationView: SCAL[2][L_Rpr.rprl_Amount]; wCheckOwnLocation: SCAL[2]): SCAL[2];
  VAR
   Result   : SCAL[2];
   _Location: L_Rpr.tRprSLocation;
 BEGIN
  Result   :=0;
  _Location:=0;
  WHILE _Location < L_Rpr.rprl_Amount DO
   IF wCheckOwnLocation &
      ~RprSLocationView[_Location] &
      L_Rpr.E_AllowedRprSLocation(_Location) &
      L_General.IsMemberOf(L_Rpr.GetRprSGroupName(_Location)) THEN
    IF ~L_StdFrm.RedAlternative(" ⪫稫 ᬮ   ஢ " + L_Rpr.GetRprSLocation_AsStr(_Location) + ",|" +
                                "    ࠢ  䨪  ⮣ ஢||" +
                                "   ⮣ ஢ 㤥 㤭|"+
                                "த?") THEN
     RETURN 0;
    END;
   END;
   IF RprSLocationView[_Location] = 1 THEN
    Result:=1;
   END;
   INC(_Location);
  END; (* WHILE _Location < L_Rpr.rprl_Amount...*)
  RETURN Result;
 END {HasVisibleLocation};

 PRIVATE PROCEDURE intSetRprSScopeFilter(Zone: NUMERIC[0]);
  VAR
   _Location       : L_Rpr.tRprSLocation;
   RprSLocationView: SCAL[2][L_Rpr.rprl_Amount];
   Filter          : STRING[];
 BEGIN
  L_General.Assert(RTI.Get().CurWindow.OriginalName = "RprSO", " ० ⮡ࠦ   ⮬  ");
  L_Rpr.GetDefaultViewRprSScopeMode(RprSLocationView);
  Filter:="RprS.RprS=0000000"; (*dummy 䨫 -     ᬮ*)

  IF HasVisibleLocation(RprSLocationView, 0) THEN
   SETEMPTY(Filter);
   _Location:=0;
   WHILE _Location < L_Rpr.rprl_Amount DO
    IF RprSLocationView[_Location] = 1 THEN
     Filter:=L_Str.AddStrDlm(Filter, "|") + "(RprS.Location=" + _Location + ")";
    END;
    INC(_Location);
   END; (* WHILE _Location < L_Rpr.rprl_Amount...*)

   IF Zone = 3 (* *) THEN
    Filter:="(" + Filter + ")&";
    IF L_General.GetAPSiteNumber() = 26 THEN
     SETEMPTY(Filter);
    END;
    Filter:=Filter + "((RprS.Status=" + L_Str.IntStr(L_Rpr.ms_WaitTechAid) + ")|" +
                      "(RprS.Status=" + L_Str.IntStr(L_Rpr.ms_WaitRetriever) + ")|" +
                      "(RprS.Status=" + L_Str.IntStr(L_Rpr.ms_IndependentRepair) + "))";
   END;
  END;

  RTI.Get().CurWindow.Zones(Zone).PermanentFilter:=Filter;
 END {intSetRprSScopeFilter};

 PRIVATE PROCEDURE SetRprSScopeFilter();
  VAR
   BegZone,
   EndZone: NUMERIC[0];
 BEGIN
  IF RTI.Get().CurWindow.OriginalName = "RprSO" THEN
   EndZone:=4;
  ELSE
   L_General.CallUs(0);
  END;

  BegZone:=1;
  WHILE BegZone <= EndZone DO
   intSetRprSScopeFilter(BegZone);
   INC(BegZone);
  END;
 END {SetRprSScopeFilter};

 PRIVATE PROCEDURE Get_rot_Pool_Short(): STRING[];
 BEGIN
  IF L_Rpr.IsMainRpr() | L_APtm.IsViewRprS() | L_APtm.IsLeaders() |
     L_General.IsMemberOf("RPRS_3") | L_General.IsMemberOf("RPRS_6") THEN
   RETURN L_Rpr.rot_Pool_Short;
  ELSE
   RETURN " ";
  END;
 END {Get_rot_Pool_Short};

 PRIVATE PROCEDURE RprSO_1_OnZoneOpen();
  VAR
   z: NUMERIC[0];
 BEGIN
  SetFieldFormat(RTI.Get().CurZone.Fields("RprS.Status"), L_Rpr.GetRprSStatus_Pool(0));
  z:=1;
  WHILE z <= 4 DO
   SetFieldFormat(RTI.Get().CurWindow.Zones(z).Fields("RprS.RprObjT"),  Get_rot_Pool_Short());
   SetFieldFormat(RTI.Get().CurWindow.Zones(z).Fields("RprS.Location"), L_Rpr.GetRprSLocation_Pool(1));
   INC(z);
  END;
  SetRprSScopeFilter();
 END {RprSO_1_OnZoneOpen};

 PRIVATE PROCEDURE RprS_OnInitializeWindow();
 BEGIN
  L_WDO.iEvents   (1, [L_WDO.e_OnOpenZone]);
  L_WDO.iZone     (1).HierarchicLink:=LINK.Get("RprS", "Parent");
  L_WDO.iZone     (1).BanHierarchicView:=1;
  L_WDO.iSubwindow(1, "RprSE");
  L_WDO.iField    (1, "RprS.RprS").Hierarchic:=1;
  L_WDO.iField    (1, "RprS.RprS").ReverseSorting:=1;
  L_WDO.iField    (1, "RprS.RprObjId").OnBeforeAsk:=1;
  L_WDO.iField    (1, "RprS.RprObjId").AskMode:=1;
 END {RprS_OnInitializeWindow};

 PRIVATE PROCEDURE RprS_1_OnZoneOpen();
 BEGIN
  RTI.Get().CurZone.Fields("RprS_RprObjT_Short").Format:=Get_rot_Pool_Short();
  RTI.Get().CurZone.Fields("RprS.Location").Format     :=L_Rpr.GetRprSLocation_Pool(1);
  RTI.Get().CurZone.Fields("RprS.Status").Format       :=L_Rpr.GetRprSStatus_Pool(1);
 END {RprS_1_OnZoneOpen};

 PUBLIC PROCEDURE GetTaskForRetriever();
 BEGIN
  LIKEMENU(Ins, "@ ReturnKind=NeedRetriever");
 END {GetTaskForRetriever};

 PRIVATE PROCEDURE RprDA_OnBeforeEdit();
 BEGIN
  SetRprDA_WinFieldFlagEdit((RprDA.Fixed # L_Rpr.daf_Transference) & ~IsTransferredRprDA(),
                            (RprDA.Fixed # L_Rpr.daf_Transference));
 END {RprDA_OnBeforeEdit};

 PRIVATE PROCEDURE RprDA_OnBeforeInsert();
  VAR
   trgWhenBurn: LIKE(RprDA.WhenBurn);
 BEGIN
  CheckRprSCUCopy();
  IF    RprS.Location = L_Rpr.rprl_ControllerOffice THEN
   trgWhenBurn:=L_Rpr.rprda_Exploitation;
  ELSIF RprS.Location = L_Rpr.rprl_Gate THEN
   trgWhenBurn:=L_Rpr.rprda_Diagnostics;
  ELSIF (RprS.Location = L_Rpr.rprl_RepairZone) | (RprS.Location = L_Rpr.rprl_RZ_Part1) THEN
   trgWhenBurn:=L_Rpr.rprda_Repair;
  ELSIF L_Rpr.IsServiceCenterLocation(RprS.Location) THEN
   trgWhenBurn:=L_Rpr.rprda_Diagnostics;
  ELSIF L_Rpr.IsWorkshopLocation(RprS.Location) THEN
   trgWhenBurn:=L_Rpr.rprda_Diagnostics;
  ELSE
   L_General.CallUs(0);
  END;
  RprDA.WhenBurn:=trgWhenBurn;
  REPLACE(RprDA);
  SetRprDA_WinFieldFlagEdit(1, 1);
 END {RprDA_OnBeforeInsert};

 PRIVATE PROCEDURE RprDA_OnBeforeDelete();
  VAR
   _OrdDate: DATE;
 BEGIN
  _OrdDate:=RprS.OrdDate;
  L_General.Assert(RprDA.Fixed # L_Rpr.daf_Transference,
                   " ७ᥭ ࠢ⥩ 饭.|" +
                   "।⥫쭮 室 㤠 ७ᥭ ࠢ");
  IF IsTransferredRprDA() THEN
   SAVE(RprS);
   SEARCH(RprS, RprS, , RprDA.FRprS);
   L_General.Assert(RprS.OrdDate >= L_DatTim.IncMonth(_OrdDate, -3),
                    "ࠢ 뫠 ⫮  3- 楢 , 㤠 .|" +
                    "室  ࠭  ࠢ  ⫮ ୮.");
   RESTORE(RprS);
   SinglePutOffDfApr_CancelTransfer();
  END;
 END {RprDA_OnBeforeDelete};

 PRIVATE PROCEDURE RprDA_RprDfApr_OnSuccessfulChange();
 BEGIN
  CONFORM(RprDA, RprDfApr);
  RprDA.CarBlock:=RprDfApr.CarBlock;
  REPLACE(RprDA);
 END {RprDA_RprDfApr_OnSuccessfulChange};

 PRIVATE PROCEDURE RprDA_RprDfApr_OnAskPhase1();
 BEGIN
  IF !RprDA.RprDfApr THEN
   IF SELECT(RprDfApr, Parent, EMPTYOF(RprDfApr.Parent), 0) THEN
    SE_WZD_POSITION(RTI.Get().TrgWindow.Name, RTI.Get().TrgZone.Number, RprDfApr);
   END;
  END;
 END {RprDA_RprDfApr_OnAskPhase1};

 PRIVATE PROCEDURE RprDA_RprDfApr_OnAskPhase2();
 BEGIN
  IF ACCESS(RprDfApr) THEN
   TRY [EXCEPTION_HANDLING(EXCEPTION_HANDLING_OFF)]
    RprDA.RprDfApr:=RprDfApr.RprDfApr;
    REPLACE(RprDA);
   EXCEPT
   ON Exc: Exc_Root DO
    IF L_General.IsUniquenessViolationException(Exc) THEN
     L_General.Error("  " + RprS.RprS + " 㦥  ࠢ   " + RprDfApr.RprDfApr);
    ELSE
     RAISE();
    END;
   END; (* TRY *)
  END;
 END {RprDA_RprDfApr_OnAskPhase2};

 PRIVATE PROCEDURE RprDA_Fixed_OnSuccessfulChange();
 BEGIN
  L_General.Assert(RprDA.Fixed # L_Rpr.daf_Transference,
                   " 祭  ⮫쪮 ⮬᪨");
 END {RprDA_Fixed_OnSuccessfulChange};

 PRIVATE PROCEDURE RprDA_OnAfterModification();
 BEGIN
  IF RprDA.Fixed # L_Rpr.daf_ThereIs THEN
   CheckSingleRprDA(csrda_OnCloseRprDA);
  END;

  IF (L_General.GetAPSiteNumber() = 25) | (L_General.GetAPSiteNumber() = 90) THEN
   CheckSingleRprDA(csrda_OnEdInsRprDA);
  END;
 END {RprDA_OnAfterModification};

 PRIVATE PROCEDURE RprDA_OnAfterInsert();
 BEGIN
  RprDA_OnAfterModification();
 END {RprDA_OnAfterInsert};

 PRIVATE PROCEDURE RprDA_OnAfterEdit();
 BEGIN
  RprDA_OnAfterModification();
 END {RprDA_OnAfterEdit};

 PUBLIC PROCEDURE DrvStandToRepair();
  VAR
   _TSN: LIKE(Staff.TSN);
 BEGIN
  L_General.Assert(ACCESS(RprT), " ࠭ ");
  L_General.Assert(SELECT(RprP, RprJ, RprS.RprS, L_Rpr.v_EmptyIndexValue, L_Rpr.v_EmptyIndexValue, L_Rpr.rprpwho_DrvDeclarant),
                   " 㪠 " + L_Str.PoolItem(L_Rpr.rprpwho_Pool, L_Rpr.rprpwho_DrvDeclarant));
  _TSN:=RprP.TSN;
  DEFAULT(RprP);
  RprP.RprS:=RprS.RprS;
  RprP.RprT:=RprT.RprT;
  RprP.RprJ:=L_Rpr.v_EmptyIndexValue;
  RprP.Who :=L_Rpr.rprpwho_Driver;
  RprP.TSN :=_TSN;
  INSERT(RprP);
  RprP_OnAfterModification();
  L_APtm.SysLogHandler("RprP", L_SysLog.knd_AutoBuild);
 END {DrvStandToRepair};

 PRIVATE PROCEDURE PuttingIntoOperation(): L_Rpr.tMirrorStatus;
  VAR
   ms_Pool    : STRING[];
   ms_Selected: L_Rpr.tMirrorStatus[MAXOF(L_Rpr.tMirrorStatus)];
   List       : STRING[];
   Choice     : NUMERIC[0];
   ms         : L_Rpr.tMirrorStatus;
 BEGIN
  ms_Pool:=Set_ms_Pool();
  Choice :=0;
  List   :="";
  ms     :=MINOF(L_Rpr.tMirrorStatus);
  WHILE ms < MAXOF(L_Rpr.tMirrorStatus) DO
   IF L_Rpr.E_MaySetMirrorStatus(ms) THEN
    ms_Selected[Choice]:=ms;
    List               :=List + L_Str.PoolItem(ms_Pool, ms) + "|";
    INC(Choice);
   END;
   INC(ms);
  END;
  L_General.Assert(Choice > 0,
                   "  筮 ࠢ  믮 樨|" +
                   "  ﭨ   ");
  Choice:=L_StdFrm.ShowListAsMenu(List, " ﭨ ");
  RETURN ms_Selected[Choice];
 END {PuttingIntoOperation};

 PRIVATE PROCEDURE AlreadyPutInOperation(): SCAL[2];
 BEGIN
  L_General.CallUs(SELECT(XDocJrn, XDocJrn, L_XDoc.xdt_RprS, L_XDoc.EmptyXDocKind, RprS.RprS));
  LAST(XDocJrn);
  WHILE OCCURE(XDocJrn) DO
   IF    XDocJrn.Action = L_XDoc.action_rprCnclPuttingIntoOperation THEN
    RETURN 0;
   ELSIF XDocJrn.Action = L_XDoc.action_rprPuttingIntoOperation THEN
    RETURN 1;
   END;
   PREV(XDocJrn);
  END; (* WHILE OCCURE(XDocJrn) ... *)
  RETURN 0;
 END {AlreadyPutInOperation};

 PUBLIC PROCEDURE RprS_ChangeStatus();
  VAR
   SysDate  : DATE;
   SysTime  : TIME;
   newStatus: L_Rpr.tMirrorStatus;
 BEGIN
  L_Rpr.AccessRprS();
  CanModifyRprSAssert(" ﭨ , 室饣  ஢ '" + L_Rpr.GetRprSLocation_AsStr(RprS.Location) + "'|" +
                      "ࠧ襭 襬 堭 ()  짮⥫,|" +
                      "室騬  㯯 짮⥫ 㯠  ⮬ ஢");
  L_General.Assert(RprS.Status # L_Rpr.ms_Cancel,
                   "।⥫쭮 室 ⬥ 㫨஢ ");

  L_SysLog.SingleMark_Init("RprS");

  ClearRprPTimes();
  newStatus:=PuttingIntoOperation();
  IF ~L_Rpr.IsCarReadinessStatus(RprS.Status) THEN
   SELECT(RprDA, RprS, , RprS.RprS);
   WHILE OCCURE(RprDA) DO
    IF RprDA.Fixed = L_Rpr.daf_ThereIs THEN
     IF newStatus = L_Rpr.ms_Ready THEN
      CheckSingleRprDA(csrda_OnCloseRprDA);
     END;
     RprDA.Fixed:=L_Rpr.daf_Done;
     REPLACE(RprDA);
    END;
    NEXT(RprDA);
   END; (* WHILE OCCURE(RprDA) ... *)
 
   SysDate:=SYSDATE();
   SysTime:=SYSTIME();
   SELECT(RprT, RprS, , RprS.RprS);
   WHILE OCCURE(RprT) DO
    IF RprT.Result = L_Rpr.tr_InProgress THEN
     RprT.Result  :=L_Rpr.tr_Done;
     RprT.JobEDate:=SysDate;
     RprT.JobETime:=SysTime;
     REPLACE(RprT);
    END;
    NEXT(RprT);
   END; (* WHILE OCCURE(RprT) ... *)
  END;
  ProceedRprS(0);
  IF ((newStatus = L_Rpr.ms_Done) | (newStatus = L_Rpr.ms_NeedRate)) & ~AlreadyPutInOperation() THEN
   L_Rpr.CurRprSXDocJrnMark(L_XDoc.action_rprPuttingIntoOperation);
  ELSE
   L_Rpr.CurRprSXDocJrnMark(L_XDoc.action_Edit);
  END;
  ConditionalClose(newStatus);
  FillRprPTimes();
  L_SysLog.SingleMark_Done("RprS");
 END {RprS_ChangeStatus};

 PUBLIC PROCEDURE CancelPuttingIntoOperation();
 BEGIN
  L_Rpr.AccessRprS();
  L_General.Assert((RprS.Status = L_Rpr.ms_Done) | (RprS.Status = L_Rpr.ms_NeedRate),
                   " ⮬   뫮 ।  ᯫ");
  L_General.Assert(L_Rpr.E_RprSAcceptableAction(L_XDoc.action_rprCnclPuttingIntoOperation, RprS.Location),
                   "  筮 ࠢ  믮 ⮩ 樨");
  L_StdFrm.Choice("⬥ ।  ᯫ");
  ClearRprPTimes();
  ProceedRprS(0);
  RprS.Closed:=0;
  RprS.Status:=L_Rpr.ms_Ready;
  RprS.EDate :=EMPTYOF(DATE);
  RprS.ETime :=EMPTYOF(TIME);
  REPLACE(RprS);
  L_Rpr.CurRprSXDocJrnMark(L_XDoc.action_rprCnclPuttingIntoOperation);

  CheckRprSDTIntersection(1);
  IF L_Rpr.IsRprS_w_Car() THEN
   L_RT.rtc_PutByRprS();
  END;
  FillRprPTimes();
 END {CancelPuttingIntoOperation};

 PUBLIC PROCEDURE RprDA_ManualClose();
 BEGIN
  L_General.Assert(ACCESS(RprDA), " ⠭ ࠢ");
  L_General.Assert(RprDA.Fixed # L_Rpr.daf_Transference, "ࠢ ७ᥭ  㣮 ");

  CheckSingleRprDA(csrda_OnCloseRprDA);

  RprDA.Fixed:=L_Rpr.daf_Done;
  REPLACE(RprDA);
 END {RprDA_ManualClose};

 PUBLIC PROCEDURE RprDA_PutOffAll();
 BEGIN
  L_StdFrm.Question("⫮  ࠭  ࠢ?");
  SELECT(RprDA, RprS, , RprS.RprS);
  WHILE OCCURE(RprDA) DO
   IF RprDA.Fixed = L_Rpr.daf_ThereIs THEN
    CheckSingleRprDA(csrda_OnCloseRprDA);
    RprDA.Fixed:=L_Rpr.daf_PutOff;
    REPLACE(RprDA);
   END;
   NEXT(RprDA);
  END; (* WHILE OCCURE(RprDA) ... *)
 END {RprDA_PutOffAll};

 PUBLIC PROCEDURE RprT_ManualClose();
  VAR
   SysDate: DATE;
   SysTime: TIME;
 BEGIN
  L_Rpr.AccessRprT();
  IF RprT.Result = L_Rpr.tr_InProgress THEN
   SELECT(RprJ, RprS, , RprS.RprS, RprT.RprT);
   WHILE OCCURE(RprJ) DO
    L_General.Assert(~!RprJ.EDate, "    祭 ࠡ");
    NEXT(RprJ);
   END; (* WHILE OCCURE(RprJ) ... *)
   RprT.Result:=L_Rpr.tr_Done;
   SysDate:=SYSDATE();
   SysTime:=SYSTIME();
   IF ~L_Rpr.HasRprTNotification() THEN
    L_StdFrm.Choice("   㯠  ࠡ");
    SetTableFieldSDT("RprT", "JobBDate", SysDate, SysTime, "砫 ࠡ  ", 1);
   END;
   SetTableFieldSDT("RprT", "EDate",    SysDate, SysTime, "", 0);
   SetTableFieldSDT("RprT", "JobEDate", SysDate, SysTime, "", 0);

   CalcTaskLen_inDateTime();
   RprT_OnAfterModification(0);
  END;
 END {RprT_ManualClose};

 PUBLIC PROCEDURE RprJ_ManualClose();
 BEGIN
  L_General.Assert(ACCESS(RprJ), " ⠭ ⥪ ६⭠ ࠡ");
  IF !RprJ.EDate THEN
   SetTableFieldSDT("RprJ", "EDate", SYSDATE(), SYSTIME(), " ", 1);
  END;
  RprJ_OnAfterModification(0);
 END {RprJ_ManualClose};

 PRIVATE PROCEDURE _StandOnRprS();
 BEGIN
  IF L_Rpr.CanModify(RprS.Location) THEN
   LIKEMENU(Edit, "@");
  ELSE
   LIKEMENU(ShowWin, "@");
  END;
 END {_StandOnRprS};

 PUBLIC PROCEDURE StandOnRprS_2();
 BEGIN
  SEARCH(RprS, RprS, , v_RprS);
  SE_WZD_POSITION("RprS", 1, RprS);
  _StandOnRprS();
 END {StandOnRprSByRprS_2};

 PUBLIC PROCEDURE StandOnRprS_FromARprPlc();
 BEGIN
  L_Rpr.AccessRprT();
  v_RprS:=RprT.RprS;
  LIKEMENU(View, "RprS 1", CALL, "RprS.StandOnRprS_2()");
 END {StandOnRprSByRprS_FromARprPlc};

 PRIVATE PROCEDURE StandOnRprS_FromRprSView();
 BEGIN
  L_Rpr.AccessRprS();
  _StandOnRprS();
 END {StandOnRprS_FromRprSView};

 PRIVATE PROCEDURE intCancel_RprS(Cancel: SCAL[2]);
 BEGIN
  IF Cancel = (RprS.Status # L_Rpr.ms_Cancel) THEN
   L_General.Assert(L_Rpr.IsMainRpr(), "  믮 ⮫쪮 訬 ஬");
   L_StdFrm.Choice(L_Str.PoolItem("⬥ 㫨஢ |㫨஢ ", Cancel));
   IF Cancel THEN
    CONFORM(RprS, RprDA);
    WHILE OCCURE(RprDA) DO
     L_General.Assert(~IsTransferredRprDA(), "   ७ᥭ ࠢ, 㫨஢ 饭");
     NEXT(RprDA);
    END; (* WHILE OCCURE(RprDA) ... *)

    IF RprS.Leaf = 0 THEN
     SAVE(RprS);
     SELECT(RprS, Parent, , RprS.RprS);
     WHILE OCCURE(RprS) DO
      PROMPT("஢ઠ ⥫ : " + RprS.RprS);
      L_General.Assert(RprS.Status = L_Rpr.ms_Cancel,
                       " ⥫    㫨஢.||" +
                       "⥫  " + RprS.RprS + " 室  ﭨ '" + L_Rpr.GetRprSStatus_AsStr(RprS.Status) + "'");
      NEXT(RprS);
     END; (* WHILE OCCURE(RprS) ... *)
     RESTORE(RprS);
    END;

    RprS.Closed:=1;
    RprS.Status:=L_Rpr.ms_Cancel;
    IF !RprS.EDate THEN
     RprS.EDate :=SYSDATE();
     RprS.ETime :=SYSTIME();
    END;
   ELSE
    RprS.Closed:=0;
    RprS.Status:=GetRprSActualStatus();
    RprS.EDate :=EMPTYOF(DATE);
    RprS.ETime :=EMPTYOF(TIME);
   END;
   REPLACE(RprS);
  END;
 END {intCancel_RprS};

 PUBLIC PROCEDURE ManualSetRprSEDateTime();
  VAR
   trgEDate: DATE;
   trgETime: TIME;
 BEGIN
  L_Rpr.AccessRprS();
  CheckRprSCUCopy();
  L_General.Assert(RprS.Closed, "   !");
  trgEDate:=RprS.EDate;
  trgETime:=RprS.ETime;
  LOOP
   STDFORM(L_StdFrm.sf_Choice("| %##########%  ६ %#####%|",
                              "%L<D.N.y>I  %L<H:M>I"),
                              " ।  ᯫ ",
                              ,
                              ,
                              trgEDate, trgETime);
   IF L_DatTim.GetTIMESTAMP(trgEDate, trgETime) > L_DatTim.GetSysTIMESTAMP() THEN
    L_StdFrm.RedInform("।  ᯫ ' 饬'?");
   ELSE
    EXIT;
   END;
  END; (* LOOP *)
  RprS.EDate:=trgEDate;
  RprS.ETime:=trgETime;
  REPLACE(RprS);

  CheckRprSDTIntersection(1);
  CheckRprSEDT();
 END {ManualSetRprSEDateTime};

 PRIVATE PROCEDURE SetRprPlaceFieldsModifiable();
  VAR
   Fields    : FORM_FIELDS;
   Modifiable: SCAL[2];
 BEGIN
  Modifiable:=L_General.IsProgrammer();
  Fields:=RTI.Get().CurZone.Fields;
  Fields("RprPlace.RprPlace").Modifiable:=Modifiable;
  Fields("RprPlace.Kind").Modifiable    :=Modifiable;
  Fields("RprPlace.Capacity").Modifiable:=Modifiable;
 END {SetRprPlaceFieldsModifiable};

 PRIVATE PROCEDURE RprPlace_OnBeforeInsert();
 BEGIN
  IF ~L_General.IsProgrammer() THEN
   L_General.Error("⠢ ६ ⮢ 饭");
  ELSE
   L_General.PrgsOnly();
  END;
  SetRprPlaceFieldsModifiable();
 END {RprPlace_OnBeforeInsert};

 PRIVATE PROCEDURE RprPlace_OnBeforeEdit();
 BEGIN
  SetRprPlaceFieldsModifiable();
 END {RprPlace_OnBeforeEdit};

 PRIVATE PROCEDURE RprPlace_OnBeforeDelete();
 BEGIN
  L_General.Error(" ६ ⮢ 饭");
 END {RprPlace_OnBeforeDelete};

 PRIVATE PROCEDURE RprPlc_OnInitializeWindow();
 BEGIN
  L_WDO.iEvents    (1, [L_WDO.e_OnBeforeEdit, L_WDO.e_OnBeforeInsert, L_WDO.e_OnBeforeDelete]);
  L_WDO.iMayBeEmpty(1, "RprPlace.Till");
  L_WDO.iField     (1, "RprPlace.Equip").Format:=L_Rpr.rpe_Pool;
  L_WDO.iField     (1, "RprPlace.Kind").Format:=L_Rpr.rpk_Pool;
  L_WDO.iProgs     (1, "RprS");
 END {RprPlc_OnInitializeWindow};

 PRIVATE PROCEDURE ARprPlc_OnInitializeWindow();
 BEGIN
  L_WDO.iWindow().MNUFileName:="RprS";
  L_WDO.iZone (1).ViewOnly:=1;
  L_WDO.iField(1, "RprPlace.Equip").Format:=L_Rpr.rpe_Pool;
  L_WDO.iProgs(1, "RprS");
  L_WDO.iZone (2).ViewOnly:=1;
  L_WDO.iZone (2).Narrowing:="(RprT.RprPlace=RprPlace.RprPlace)&(RprT.Result=0)";
 END {ARprPlc_OnInitializeWindow};


 PRIVATE PROCEDURE SpecificWindowRprSE_0_OnZoneOpen();
  VAR
   i: NUMERIC[0];
 BEGIN
  SetFieldFormat(RTI.Get().CurZone.Fields("FirmPrtnrType"), P_Firm.pt_Pool);
  i:=0;
  WHILE i <= HIGH(InsertNewObjects) DO
   SetFieldFormat(RTI.Get().CurZone.Fields("InsertNewObjects_" + L_Str.IntStr(i)), " |+");
   INC(i);
  END;
 END {SpecificWindowRprSE_0_OnZoneOpen};

 PRIVATE PROCEDURE RprSE_SC_0_OnZoneOpen();
 BEGIN
  SpecificWindowRprSE_0_OnZoneOpen();
 END {RprSE_SC_0_OnZoneOpen};

 PRIVATE PROCEDURE RprSE_WS_0_OnZoneOpen();
 BEGIN
  SpecificWindowRprSE_0_OnZoneOpen();
  L_WDO.CreateFormLink("Math", "");
 END {RprSE_WS_0_OnZoneOpen};

 PRIVATE PROCEDURE AnyRprSA_OnConformToWindow(CursorFile: STRING[]);
  VAR
   i                : NUMERIC[0];
   ClientSparesAsStr: STRING[];
   TargetWindow     : FORM_WINDOW;
   Fields           : FORM_FIELDS;
 BEGIN
  ACCESS(RprS);
  IF ~!RprS.CUCopy THEN
   L_Rpr.AccessOrigin();
   TargetWindow:=RTI.Get().ConformTargetWindow;
   Fields      :=TargetWindow.Zones(0).Fields;

   SE_WWD_CURSOR(TargetWindow.Name, ^CursorFile);

   Fields("RprS").Value       :=RprS.RprS;
   Fields("RprSOrdDate").Value:=RprS.OrdDate;
   Fields("RprSOrdTime").Value:=RprS.OrdTime;
   IF ~!Fields("SMBef") THEN
    Fields("SMBef").Value:=RprS.SMBef;
   END;

   SetRprSAdditionalInf(TargetWindow);
  END;
 END {AnyRprSA_OnConformToWindow};

 PRIVATE PROCEDURE AnyRprSA_OnInitializeWindow(trgNarrowingFirmField: STRING[]);
 BEGIN
  L_WDO.iZone     (0).ViewOnly:=1;
  L_WDO.iField    (0, "Firm.PrtnrTyp").Format:=P_Firm.pt_Pool;
  L_WDO.iZone     (1).ViewOnly:=1;
  L_WDO.iZone     (1).Narrowing:="FirmCtc.Firm="+trgNarrowingFirmField;
  L_WDO.iZone     (2).ViewOnly:=1;
  L_WDO.iZone     (2).ParentZone:=L_WDO.iZone(1);
  L_WDO.iField    (2, "CtcVal.Coverage").Format:=L_ctc.cvc_Pool;
  L_WDO.iField    (2, "CtcVal.Type").Format:=L_ctc.cvt_Pool;
  L_WDO.iZone     (3).ViewOnly:=1;
  L_WDO.iZone     (3).ParentZone:=L_WDO.iZone(0);
  L_WDO.iSubwindow(3, "CntrE");
  L_WDO.iField    (3, "Contract.Type").Format:=L_Cntr.ct_Pool;
  L_WDO.iZone     (3).Narrowing:="(Contract.Leaf=1)&(Contract.Firm="+trgNarrowingFirmField+")";
 END {AnyRprSA_OnInitializeWindow};

 PRIVATE PROCEDURE RprSA1_OnConformToWindow();
 BEGIN
  AnyRprSA_OnConformToWindow("OutCar");
 END {RprSA1_OnConformToWindow};

 PRIVATE PROCEDURE RprSA1_OnInitializeWindow();
 BEGIN
  AnyRprSA_OnInitializeWindow("OutCar.Firm");
 END {RprSA1_OnInitializeWindow};

 PRIVATE PROCEDURE RprSA2_OnConformToWindow();
 BEGIN
  AnyRprSA_OnConformToWindow("OutCBlc");
 END {RprSA2_OnConformToWindow};

 PRIVATE PROCEDURE RprSA2_OnInitializeWindow();
 BEGIN
  AnyRprSA_OnInitializeWindow("OutCBlc.Firm");
 END {RprSA2_OnInitializeWindow};

 PRIVATE PROCEDURE RprJE_OnInitializeWindow();
 BEGIN
  L_WDO.iWindow().MNUFileName:="RprS";
  L_WDO.iEvents      (0, [L_WDO.e_OnAnyModification, L_WDO.e_OnReposition]);
  L_WDO.iField       (0, "RprT.EDate").ReverseSorting:=1;
  L_WDO.iField       (0, "RprJ.RprJob").OwnerWindowOriginalName:="RprJob";
  L_WDO.iField       (0, "RprJ.RprJob").OwnerZoneNumber:=1;
  L_WDO.iField       (0, "RprJ.RprJob").First:=1;
  L_WDO.iField       (0, "RprJ.Source").Format:="|||!";
  L_WDO.iField       (0, "v_PriceTitle").Value   :="⮨ /";
  L_WDO.iField       (0, "v_SumTitle").Value     :="㬬";
  L_WDO.iScsChange   (0, ["RprJ.BaseTime", "RprJ.Quantity", "RprJ.Price", "RprJ.Sum", "RprJ.BDate", "RprJ.RprJob"]);
  L_WDO.iUnmodifiable(0, ["RprJ.Source", "v_SumTitle", "v_PriceTitle"]);
  L_WDO.iMayBeEmpty  (0, ["RprJ.BaseTime", "RprJ.ETime", "RprJ.EDate", "RprJ.BTime", "RprJ.BDate"]);
  L_WDO.iField       (0, "RprJob_Type").Format:=" | | | | | | | ";
  L_WDO.iField       (0, "RprJob.Leaf").Format:="ॡ 筥| ";
  L_WDO.iProgs       (0, "RprS");
  L_WDO.iEvents      (1, [L_WDO.e_OnAfterEdit, L_WDO.e_OnBeforeInsert, L_WDO.e_OnAfterInsert, L_WDO.e_OnSetSubwindow]);
  L_WDO.iZone        (1).Narrowing:="(RprP.RprS=RprJ.RprS)&(RprP.RprT=RprJ.RprT)&(RprP.RprJ=RprJ.RprJ)";
  L_WDO.iField       (1, "RprP.TSN").OnBeforeAsk:=1;
  L_WDO.iField       (1, "RprP.TSN").First:=1;
  L_WDO.iScsChange   (1, ["RprP.TSN", "RprP_Who"]);
  L_WDO.iProgs       (1, "RprS");
  L_WDO.iEvents      (2, [L_WDO.e_OnAnyModification, L_WDO.e_OnAfterDelete, L_WDO.e_OnSetSubwindow]);
  L_WDO.iZone        (2).Narrowing:="(RprPro.RprT=RprJ.RprT)&(RprPro.RprJ=RprJ.RprJ)&(RprPro.RprS=RprJ.RprS)";
  L_WDO.iProgs       (2, "ObjPro");
  SetAllRprPools();
 END {RprJE_OnInitializeWindow};

 PUBLIC PROCEDURE SetViewRprSScopeMode();
  VAR
   _Location        : L_Rpr.tRprSLocation;
   RprSLocationView : SCAL[2][L_Rpr.rprl_Amount];
   Body,
   FieldList,
   VariableList,
   ViewRprSScopeMode: STRING[];
 BEGIN
  L_General.Assert(RTI.Get().CurWindow.OriginalName = "RprSO", " ० ⮡ࠦ   ⮬  ");
  L_Rpr.GetDefaultViewRprSScopeMode(RprSLocationView);
  SETEMPTY(Body, FieldList, VariableList);
  _Location:=0;
  WHILE _Location < L_Rpr.rprl_Amount DO
   IF L_Rpr.E_AllowedRprSLocation(_Location) THEN
    FieldList   :=FieldList + "%<" + L_Rpr.GetRprSLocation_AsStr(_Location) + ">E";
    Body        :=Body + "|%" + L_Str.Repeat("#", 40) + "%|";
    VariableList:=L_Str.AddStrDlm(VariableList, ",") + "RprSLocationView[" + _Location + "]";
   END;
   INC(_Location);
  END; (* WHILE _Location < L_Rpr.rprl_Amount...*)
  LOOP
   STDFORM(L_StdFrm.sf_Choice(Body, FieldList),
           " ன ⮡ࠦ ᯨ᪠  ",
           INFORM,
           ,
           ^(VariableList));
   IF HasVisibleLocation(RprSLocationView, 1) THEN
    SETEMPTY(ViewRprSScopeMode);
    _Location:=0;
    WHILE _Location < L_Rpr.rprl_Amount DO
     ViewRprSScopeMode:=ViewRprSScopeMode + _Location + ":" + RprSLocationView[_Location] + ";";
     INC(_Location);
    END; (* WHILE _Location < L_Rpr.rprl_Amount...*)

    L_SES.PutValueAtCurTrn(L_SES.sit_User, "ViewRprSScopeMode", ViewRprSScopeMode);
    PROMPT(" ० ⮡ࠦ...");
    SetRprSScopeFilter();
    EXIT;
   ELSE
    L_StdFrm.RedInform(" ⮡ࠦ  ஥");
   END;
  END; (* LOOP *)
 END {SetViewRprSScopeMode};

 PRIVATE PROCEDURE RprSEE_OnInitializeWindow();
 BEGIN
  L_WDO.iEvents      (0, [L_WDO.e_OnBeforeEdit, L_WDO.e_OnAfterEdit, L_WDO.e_OnReposition]);
  L_WDO.iUnmodifiable(0, ["RprS.RprObjId", "RprS_RprObjT", "RprS.OrdTime", "RprS.OrdDate", "RprS.RprS"]);
  L_WDO.iMayBeEmpty  (0, ["ClientSpares_4", "ClientSpares_3", "ClientSpares_2", "ClientSpares_1", "ClientSpares_0", "Comment", "RprS.RemEntr", "RprS.SMAft", "RprS.RemExit"]);
 END {RprSEE_OnInitializeWindow};

 PRIVATE PROCEDURE RprSEE_0_OnReposition();
  VAR
   Fields    : FORM_FIELDS;
   Modifiable: SCAL[2];
 BEGIN
  Fields:=RTI.Get().CurZone.Fields;
  L_Rpr.AccessRprS();
  IF    L_Rpr.IsRprS_w_Car() THEN
   L_Rpr.AccessOrigin();
   Modifiable:=L_Env.RealBoxNbr(Car.BoxNbr);
  ELSIF L_Rpr.IsRprS_w_OutCar() THEN
   Modifiable:=1;
  ELSE
   Modifiable:=0;
  END;
  SetFieldFormat(Fields("RprS_RprObjT"), L_Rpr.rot_Pool);
  SetFieldModifiable(Fields("RprS.SMBef"),   Modifiable & L_Rpr.E_SpeedometerIndication_Required(RprS.OrdDate));
  SetFieldModifiable(Fields("RprS.SMAft"),   Modifiable & L_Rpr.E_SpeedometerIndication_Required(RprS.OrdDate));
  SetFieldModifiable(Fields("RprS.RemExit"), Modifiable & L_Rpr.E_RemainsIndication_Required(RprS.OrdDate));
  SetFieldModifiable(Fields("RprS.RemEntr"), Modifiable & L_Rpr.E_RemainsIndication_Required(RprS.OrdDate));

  SetRprSAdditionalInf(RTI.Get().CurWindow);
 END {RprSEE_0_OnReposition};

 PRIVATE PROCEDURE RprSort_OnInitializeWindow();
 BEGIN
  L_WDO.iWindow().MNUFileName:="Officer";
  L_WDO.iZone(1).ViewOnly:=1;
  L_WDO.iZone(1).Narrowing:="Sort.IsRpr=1";
 END {RprSort_OnInitializeWindow};

 PUBLIC PROCEDURE ResetTimer();
 BEGIN
  L_Timer.ResetTimer(TimerId);
 END {ResetTimer};

 PRIVATE PROCEDURE RprP_OnSubWinEvents(SubWindow: STRING[]);
 BEGIN
  IF RTI.Get().CurProcess.Kind = FORM_PROCESS.Kind_ShowWin THEN
   ACCESS(RprP);
   IF ~!RprP.BDate THEN
    SubWindow:="RprPE";
   END;
  END;
  RTI.Get().CurZone.HasVariousSubwindows :=1;
  RTI.Get().CurZone.SubwindowOriginalName:=SubWindow;
 END {RprP_OnSubWinEvents};

 PRIVATE PROCEDURE intDetailRprPWorkTime(ViewOnly: SCAL[2]);
 BEGIN
  RprP_OnSubWinEvents("RprPE");
  L_General.Assert(ACCESS(RprP), " ࠭ ࠡ⭨");
  L_General.Assert((RprP.Who = L_Rpr.rprpwho_Executor),
                   " ᮭ  '" + L_Str.PoolItem(L_Rpr.rprpwho_Pool, RprP.Who) + "'|" +
                   "筥 ६ ࠡ ");
  L_General.Assert(~!RprP.RprT & ~!RprP.RprJ,
                   "筥 ६ ࠡ  ⮫쪮  ᮭ ६⭮ ࠡ");
  IF ViewOnly THEN
   LIKEMENU(ShowWin, "RprPE 0 ViewOnly=1");
  ELSE
   LIKEMENU(Edit, "RprPE 0 ViewOnly=0");
  END;
 END {intDetailRprPWorkTime};

 PUBLIC PROCEDURE ViewDetailRprPWorkTime();
 BEGIN
  intDetailRprPWorkTime(1);
 END {ViewDetailRprPWorkTime};

 PUBLIC PROCEDURE DetailRprPWorkTime();
 BEGIN
  intDetailRprPWorkTime(0);
 END {DetailRprPWorkTime};

 PRIVATE PROCEDURE RprPE_OnInitializeWindow();
 BEGIN
  L_WDO.iWindow().MNUFileName:="RprS";
  L_WDO.iEvents      (0, [L_WDO.e_OnAfterEdit, L_WDO.e_OnReposition]);
  L_WDO.iScsChange   (0, ["WorkDuration", "RprP.ETime", "RprP.EDate", "RprP.BTime", "RprP.BDate"]);
  L_WDO.iUnmodifiable(0, ["RprP.TSN", "RprP.Who"]);
  L_WDO.iMayBeEmpty  (0, ["WorkDuration", "RprP.ETime", "RprP.EDate", "RprP.BTime", "RprP.BDate", "RprP.Comment"]);
  L_WDO.iProgs       (0, "RprS");
  L_WDO.iField       (0, "RprT.TaskKind").Format:=L_Rpr.rpr_TaskKind_Pool;
  L_WDO.iField       (0, "RprP.Who").Format:=L_Rpr.rprpwho_Pool;
 END {RprPE_OnInitializeWindow};

 PUBLIC PROCEDURE SetSysDateTime();
  VAR
   curField: FORM_FIELD;
 BEGIN
  curField:=RTI.Get().CurZone.ActiveField;
  IF ~!curField.TableField THEN
   SetTableFieldSDT(curField.TableField.Table.Name, curField.TableField.Name, SYSDATE(), SYSTIME(), "", 1);
  ELSE
   SetFormFieldSDT(curField, SYSDATE(), SYSTIME(), "", 1);
  END;
 END {SetSysDateTime};

 PRIVATE PROCEDURE CalcRprPWorkDuration(Force: SCAL[2]);
 BEGIN
  IF    ~!RprP.BDate & ~!RprP.BTime &
        ~!RprP.EDate & ~!RprP.ETime THEN
   TRY [EXCEPTION_HANDLING(EXCEPTION_HANDLING_OFF)]
    RTI.Get().CurZone.Fields("WorkDuration").Value:=(L_DatTim.GetTIMESTAMP(RprP.EDate, RprP.ETime) - L_DatTim.GetTIMESTAMP(RprP.BDate, RprP.BTime)) * 24;
   EXCEPT
   ON Exc:Exc_Root DO
    IF Exc.ErrorCode = L_General.ec_rt_Overfilling THEN
     L_General.Error("஢  祭: ᫨誮  த⥫쭮 ࠡ");
    ELSE
     RAISE();
    END;
   END; (* TRY *)
  ELSIF Force THEN
   SETEMPTY(RTI.Get().CurZone.Fields("WorkDuration").Value);
  END;
 END {CalcRprPWorkDuration};

 PRIVATE PROCEDURE CalcRprPEndWorkTime();
  VAR
   WorkDTS     : TIMESTAMP;
   WorkDuration: NUMERIC[2];
 BEGIN
  WorkDuration:=RTI.Get().CurZone.Fields("WorkDuration").Value;
  IF ~!RprP.BDate & ~!RprP.BTime  THEN
   IF    ~!WorkDuration THEN
    TRY [EXCEPTION_HANDLING(EXCEPTION_HANDLING_OFF)]
     WorkDTS:=L_DatTim.GetTIMESTAMP(RprP.BDate, RprP.BTime) + WorkDuration / 24;
    EXCEPT
    ON Exc:Exc_Root DO
     IF Exc.ErrorCode = L_General.ec_rt_InvalidDate THEN
      L_General.Error("஢  祭: ९  砭 ࠡ");
     ELSE
      RAISE();
     END;
    END; (* TRY *)
    RprP.EDate:=L_DatTim.GetDateOfTIMESTAMP(WorkDTS);
    RprP.ETime:=L_DatTim.GetTimeOfTIMESTAMP(WorkDTS);
    REPLACE(RprP);
   ELSIF ~!RprP.EDate & ~!RprP.ETime THEN
    CalcRprPWorkDuration(0);
   END;
  END;
 END {CalcRprPEndWorkTime};

 PRIVATE PROCEDURE RprP_BDate_OnSuccessfulChange();
 BEGIN
  CalcRprPEndWorkTime();
 END {RprP_BDate_OnSuccessfulChange};

 PRIVATE PROCEDURE RprP_BTime_OnSuccessfulChange();
 BEGIN
  CalcRprPEndWorkTime();
 END {RprP_BTime_OnSuccessfulChange};

 PRIVATE PROCEDURE RprP_EDate_OnSuccessfulChange();
 BEGIN
  CalcRprPWorkDuration(0);
 END {RprP_EDate_OnSuccessfulChange};

 PRIVATE PROCEDURE RprP_ETime_OnSuccessfulChange();
 BEGIN
  CalcRprPWorkDuration(0);
 END {RprP_ETime_OnSuccessfulChange};

 PRIVATE PROCEDURE RprP_WorkDuration_OnSuccessfulChange();
 BEGIN
  IF    !RTI.Get().CurZone.ActiveField.Value THEN
   SETEMPTY(RprP.EDate, RprP.ETime);
   REPLACE(RprP);
  ELSIF ~!RprP.BDate & ~!RprP.BTime THEN
   CalcRprPEndWorkTime();
  END;
 END {RprP_WorkDuration_OnSuccessfulChange};

 PRIVATE PROCEDURE RprPE_0_OnReposition();
  VAR
   Fields    : FORM_FIELDS;
   Modifiable: SCAL[2];
 BEGIN
  CalcRprPWorkDuration(1);
  Fields    :=RTI.Get().CurZone.Fields;
  Modifiable:=L_WDO.GetEnvVarValue("ViewOnly")="0";
  Fields("RprP.BDate").Modifiable  :=Modifiable;
  Fields("RprP.BTime").Modifiable  :=Modifiable;
  Fields("WorkDuration").Modifiable:=Modifiable;
  Fields("RprP.EDate").Modifiable  :=Modifiable;
  Fields("RprP.ETime").Modifiable  :=Modifiable;
  Fields("RprP.Comment").Modifiable:=Modifiable;
 END {RprPE_0_OnReposition};

 PUBLIC PROCEDURE ShowFullRprSInfo();
 BEGIN
  L_Rpr.AccessRprS();
  IF    L_Rpr.IsRprS_w_OutCar() THEN
   LIKEMENU(ShowWin, "RprSA1 1 " + GE_CURWIN() + " " + L_Str.IntStr(GE_CURZONE()));
  ELSIF L_Rpr.IsRprS_w_OutCBlc() THEN
   LIKEMENU(ShowWin, "RprSA2 1 " + GE_CURWIN() + " " + L_Str.IntStr(GE_CURZONE()));
  ELSE
   L_General.Error(" ஥");
  END;
 END {ShowFullRprSInfo};

 PUBLIC PROCEDURE ManualChooseAcceptableMark();
 BEGIN
  ChooseAcceptableMark(1, 0);
 END {ManualChooseAcceptableMark};

 PUBLIC PROCEDURE ManualChooseAcceptableOutCar();
 BEGIN
  ChooseAcceptableOutCar(1, 0);
 END {ManualChooseAcceptableOutCar};

 PUBLIC PROCEDURE ManualChooseAcceptableFirm();
 BEGIN
  ChooseAcceptableFirm(1, 0);
 END {ManualChooseAcceptableFirm};

 PUBLIC PROCEDURE RemAddDoc();
 BEGIN
  L_Rpr.RemAddDoc();
 END {RemAddDoc};

 PUBLIC PROCEDURE Cancel_RprS();
 BEGIN
  intCancel_RprS(1);
 END {Cancel_RprS};

 PUBLIC PROCEDURE Restore_RprS();
 BEGIN
  intCancel_RprS(0);
 END {Restore_RprS};

 PUBLIC PROCEDURE MakeDone();
 BEGIN
  ProceedRprS(1);
 END {MakeDone};

 PUBLIC PROCEDURE MakeUnDone();
 BEGIN
  ProceedRprS(0);
 END {MakeUnDone};

 PUBLIC PROCEDURE SetTimer();
 BEGIN
  L_Timer.SetTimer(TimerId, 60, 60, "");
 END {SetTimer};

 PUBLIC PROCEDURE TransferPutOffDfApr();
 BEGIN
  InsertPutOffDfApr(1, 0, ipoda_Manual);
 END {TransferPutOffDfApr};

 PUBLIC PROCEDURE CancelTransferPutOffDfApr();
 BEGIN
  PutOffDfApr_CancelTransfer(1);
 END {CancelTransferPutOffDfApr};

 PUBLIC PROCEDURE SetRprTJobBDateTime();
 BEGIN
  L_General.Assert(E_UseRprTJobBegDateTime(), " ন    ६ 砫 ࠡ  ");
  IF ACCESS(RprT) THEN
   SetTableFieldSDT("RprT", "JobBDate", SYSDATE(), SYSTIME(), "砫 ࠡ  ", 1);
  END;
 END {SetRprTJobBDateTime};

 PRIVATE PROCEDURE RprSE_3_OnSetSubwindow();
 BEGIN
  RprP_OnSubWinEvents("");
 END {RprSE_3_OnSetSubwindow};

 PRIVATE PROCEDURE RprTE_2_OnSetSubwindow();
 BEGIN
  RprP_OnSubWinEvents("");
 END {RprTE_2_OnSetSubwindow};

 PRIVATE PROCEDURE RprJE_1_OnSetSubwindow();
 BEGIN
  RprP_OnSubWinEvents("");
 END {RprJE_1_OnSetSubwindow};

 PUBLIC PROCEDURE Edit_RprSEE();
 BEGIN
  L_WDO.MultiWindowsModification("RprSEE");
 END {Edit_RprSEE};

(*
$P { pr_Top:
L_OwnData.ODFirmName(SYSDATE()), L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
?, L, ""
RprS.RprS, L, ""
RprS.OrdDate, L, "D.N.y"
RprS.RprObjId, L, ""
L_Rpr.GetRprSObjDescr(), L, ""
@
############################################################################################# ########## #####
=#####========================================================================================================
|                                ⮪ ࠡ⪨  #######  ##########                                |
|------------------------------------------------------------------------------------------------------------|
|ꥪ ६ ####### #####################################################################################|
}
*)


(*
$P{ pr_Bot:
@
=(c) Polak====================================================================================================
}
*)

 PUBLIC PROCEDURE MakeProtocol();
  CONST
   RepId = "RprPr";
 BEGIN
  ACCESS(RprS);
  APP.Get().NewPrompt(RprS.RprS + ": ⮪ ࠡ⪨");
  OPENREP(R, L_General.NameConnection(RepId), Create);
  CONFORM(RprS, CUCopy);
  MAKEPART(R, pr_Top, RepId);
  CALL(Rpr30.MakeProtocol_SingleRprS());
  MAKEPART(R, pr_Bot);
  CLOSEREP(R);
  L_General.SurveyLastReport();
 END {MakeProtocol};

 PUBLIC PROCEDURE MakeProtocol_ByCurrentCar();
  CONST
   RepId = "RprPr";
 BEGIN
  ACCESS(Car);
  APP.Get().NewPrompt(Car.BoxNbr + ": ⮪ ࠡ⪨");
  OPENREP(R, L_General.NameConnection("RprPr"), Create);
  CONFORM(Car, CUCopy);
  SELECT(RprS, CUCopy, , Car.CUCopy);
  SRCINSEL(RprS, GE, , Memo.ud_fr());
  WHILE OCCURE(RprS) & (RprS.OrdDate <= Memo.ud_ut()) DO
   PROMPT(L_DatTim.DateStr(RprS.OrdDate));
   MAKEPART(R, pr_Top, RepId);
   CALL(Rpr30.MakeProtocol_SingleRprS());
   MAKEPART(R, pr_Bot);
   NEXT(RprS);
  END; (* WHILE OCCURE(RprS) ... *)
  CLOSEREP(R);
  L_General.SurveyLastReport();
 END {MakeProtocol_ByCurrentCar};

BEGIN
 L_Events.ExecuteHandler();
END.
