(*
%Copyright   (c) Polak Computer System
%Author      24.10.2001 11:48:57 MOG
%Purpose     ⥪  ࠡ  ⠬
%Type        library
%Specific    SYS
%Modified    22.09.2014 18:46:49 POLAK\San
%Environment
*)

 MODULE L_Pmnt [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

PUBLIC PERMANENT VAR
 zXObject: LIKE(XObject.XObject);

 PUBLIC TYPE
  tVATMDocBuildMode                 = SCAL[8];
  tValuesToBalance                  = NUMERIC[2][4];
  tContractFunction                 = SCAL[64];
  tStageOfBuildingVATMDoc           = SCAL[2];
  tSomeParticularDests              = SCAL[2];
  tVATRates                         = SCAL[7];
  tValuesByVATRate                  = NUMERIC[2][MAXOF(tVATRates)+1];
  tIncompletelyPaidIncludeCondition = SCAL[2];
  tBalanceHistoryType               = SCAL[2];
  tBackflowType                     = SCAL[4];
  tXDocOrderValue                   = SCAL[3];

 PUBLIC CONST
  vtb_Total           = 0;
  vtb_Netto           = 1;
  vtb_VAT             = 2;
  vtb_SaleTax         = 3;

  vmdbm_Acceptance = 0;
  vmdbm_Prepayment = 1;
  vmdbm_OnPrpShpmt = 2;
  vmdbm_PrchPstpay = 3;
  vmdbm_Underpay   = 4;
  vmdbm_Pstpayment = 5;
  vmdbm_PrchUndpay = 6;
  vmdbm_PrpReturn  = 7;

  ctr_No        = 0;
  ctr_Yes       = 1;
  ctr_ItDepends = 2;

  cf_General = 0;
  cf_PFIn    = 1;
  cf_PFAc    = 2;
  cf_TrvmObl = 3;

  sbvmd_Offline = 0;
  sbvmd_Online  = 1;

  spd_CashMovement        = 0;
  spd_SumPaidOutOnAccount = 1;

  vr_20 = 0;
  vr_10 = 1;
  vr_00 = 2;
  vr_NV = 3;
  vr_18 = 4;
  vr_UK = 5;
  vroNV = 6;

  vr_Pool = "20%|10%|0%| |18%|??| |";

  ipic_Any     = 0;
  ipic_AutoPay = 1;

  bht_Contract       = 0;
  bht_AccountableMan = 1;

  bht_Pool = "|⭮ ";

  CstDclr_DomesticManufacture = 0000000;

  bf_None             = 0;
  bf_MathReturn       = 1;
  bf_DebtAmortization = 2;
  bf_CredAmortization = 3;

PUBLIC VAR
converterVATMDocBuildMode: tVATMDocBuildMode;

 IMPORT Memo, L_General, L_DatTim, L_XDoc, L_PDoc, L_MDoc, L_AFM, L_EC, L_Acnt, L_Str, L_Money, L_MathR,
        L_StdFrm, L_Events, L_APEMl, L_CUC, L_AcCut, L_XObj, L_APtm, L_Cntr, L_Dest, L_XDR, L_CarAD,
        L_Prop, L_AcsPnt, L_JDoc, L_CWOrder, L_AR, L_MSO,
        Math, Str,
        P_MDoc, P_Cntr, P_Math, P_Firm, P_MyFirm, E_Pmnt, E_Stock, L_Env;

 PRIVATE TYPE
  tDistributeManner = SCAL[2];

 PRIVATE CONST
  dm_ByPDocTotal = 0;
  dm_UnknownSum  = 1;

 PRIVATE PROCEDURE vtbTotal_wSaleTax(_MDocKind: LIKE(MDoc.MDocKind)): SCAL[2];
 BEGIN
  IF L_MDoc.E_MDocKind_wSaleTax(_MDocKind) THEN
   RETURN 1;
  ELSE
   RETURN 0;
  END;
 END {vtbTotal_wSaleTax};

 PUBLIC PROCEDURE ConvEtZ(v: NUMERIC[2]): NUMERIC[2];
 BEGIN
  IF !v THEN
   RETURN 0;
  ELSE
   RETURN v;
  END;
 END {ConvEtZ};

 PUBLIC PROCEDURE vtb_EmptyValue(): tValuesToBalance;
  VAR
   Result: tValuesToBalance;
 BEGIN
  SETEMPTY(Result);
  RETURN Result;
 END {vtb_EmptyValue};

 PRIVATE PROCEDURE vtb_ZeroValue(): tValuesToBalance;
  VAR
   Result: tValuesToBalance;
 BEGIN
  SETZERO(Result);
  RETURN Result;
 END {vtb_ZeroValue};

 PRIVATE PROCEDURE aN2Add(VAR a1: NUMERIC[2][]; a2: NUMERIC[2][]);
  VAR
   i: NUMERIC[0];
 BEGIN
  i:=0;
  WHILE i <= HIGH(a1) DO
   INC(a1[i], a2[i]);
   INC(i);
  END;
 END {aN2Add};

 PUBLIC PROCEDURE vtbAdd(vtb1, vtb2: tValuesToBalance): tValuesToBalance;
  VAR
   i: NUMERIC[0];
 BEGIN
  i:=0;
  WHILE i <= HIGH(vtb1) DO
   INC(vtb1[i], vtb2[i]);
   INC(i);
  END;
  RETURN vtb1;
 END {vtbAdd};

 PUBLIC PROCEDURE vtbSub(vtb1, vtb2: tValuesToBalance): tValuesToBalance;
  VAR
   i: NUMERIC[0];
 BEGIN
  i:=0;
  WHILE i <= HIGH(vtb1) DO
   DEC(vtb1[i], vtb2[i]);
   INC(i);
  END;
  RETURN vtb1;
 END {vtbSub};

 PUBLIC PROCEDURE vtbInv(Values: tValuesToBalance): tValuesToBalance;
  VAR
   i: NUMERIC[0];
 BEGIN
  i:=0;
  WHILE i <= HIGH(Values) DO
   Values[i]:=-Values[i];
   INC(i);
  END;
  RETURN Values;
 END {vtbInv};

 PUBLIC PROCEDURE vtbExtractTotal(vtb: tValuesToBalance): NUMERIC[2];
 BEGIN
  RETURN vtb[vtb_Total];
 END {vtbExtractTotal};

 PRIVATE PROCEDURE BalanceIt(Acpt, Paid: tValuesToBalance): tValuesToBalance;
 BEGIN
  RETURN vtbAdd(Acpt, Paid);
 END {BalanceIt};

 PRIVATE PROCEDURE vtbCnv(_Total, _VAT: NUMERIC[2]): tValuesToBalance;
  VAR
   Result: tValuesToBalance;
 BEGIN
  Result[vtb_Netto  ]:=_Total-_VAT;
  Result[vtb_VAT    ]:=_VAT;
  Result[vtb_SaleTax]:=0;
  Result[vtb_Total  ]:=_Total;
  RETURN Result;
 END {vtbCnv};

 PRIVATE PROCEDURE vtbConv(_MDocKind : LIKE(MDocKind.MDocKind);
                           _Total,
                           _VAT,
                           _SaleTax  : NUMERIC[2]): tValuesToBalance;
  VAR
   R: tValuesToBalance;
 BEGIN
  R[vtb_Netto  ]:=_Total-ConvEtZ(_VAT)-ConvEtZ(_SaleTax);
  R[vtb_VAT    ]:=ConvEtZ(_VAT);
  R[vtb_SaleTax]:=ConvEtZ(_SaleTax);
  R[vtb_Total  ]:=R[vtb_Netto]+R[vtb_VAT];
  IF vtbTotal_wSaleTax(_MDocKind) THEN
   INC(R[vtb_Total], R[vtb_SaleTax]);
  END;
  RETURN R;
 END {vtbConv};

 PUBLIC PROCEDURE vtbGetByPDocMDoc(): tValuesToBalance;
 BEGIN
  RETURN vtbConv(PDocMDoc.MDocKind, PDocMDoc.Total, PDocMDoc.NDS, PDocMDoc.SaleTax);
 END {vtbGetByPDocMDoc};

 PUBLIC PROCEDURE vtbGetByPDocMDocBalance(): tValuesToBalance;
 BEGIN
  IF L_PDoc.IsOutPDoc(PDocMDoc.PDocKind) THEN
   RETURN vtbGetByPDocMDoc();
  ELSE
   RETURN vtbInv(vtbGetByPDocMDoc());
  END;
 END {vtbGetByPDocMDocBalance};

 PRIVATE PROCEDURE vtbGetByPDocList(): tValuesToBalance;
 BEGIN
  RETURN vtbConv(PDocList.PDocKind, PDocList.Sum, 0, 0);
 END {vtbGetByPDocList};

 PRIVATE PROCEDURE IsOutPDocList(_PDocKind: LIKE(PDoc.PDocKind)): SCAL[2];
 BEGIN
  RETURN L_PDoc.IsOutPDoc(_PDocKind) & (_PDocKind # L_PDoc.pd_AVO);
 END {IsOutPDocList};

 PRIVATE PROCEDURE vtbGetByPDocListBalance(): tValuesToBalance;
 BEGIN
  IF IsOutPDocList(PDocList.PDocKind) THEN
   RETURN vtbGetByPDocList();
  ELSE
   RETURN vtbInv(vtbGetByPDocList());
  END;
 END {vtbGetByPDocListBalance};

 PRIVATE PROCEDURE GetContractAccountingBegin(_Contract: LIKE(Contract.Contract)): DATE;
  VAR
   Result: DATE;
 BEGIN
  SAVE(Contract);
  SEARCH(Contract, Contract, , _Contract);
  IF SEARCH(ACSetL, ACSet, Contract.ACSet, L_Acnt.acp_Contract_Netto) THEN
   Result:=L_XObj.GetBeginOfAccountingOnAcCut(ACSetL.AcCut);
  ELSE
   SETEMPTY(Result);
  END;
  RESTORE(Contract);
  RETURN Result;
 END {GetContractAccountingBegin};

 PRIVATE PROCEDURE HasEntranceXDocApr(_XDocId  : L_XDoc.tXDocId;
                                      _XObject : LIKE(XObject.XObject);
                                      _XDocDate: DATE;
                                      _Source  : L_XObj.tSource): SCAL[2];
 BEGIN
  IF L_Acnt.E_DoXDocApr(_XDocDate, _Source, _XDocId) THEN
   SELECT(XDocApr, XDocApr, , _XDocId);
   WHILE OCCURE(XDocApr) DO
    IF    ((XDocApr.XObject  = _XObject) & L_Acnt.IsEntranceApport(XDocApr.Apport)) |
          ((XDocApr.XObject2 = _XObject) & L_Acnt.IsEntranceApport(XDocApr.Apport2)) THEN
     RETURN 1;
    END;
    NEXT(XDocApr);
   END; (* WHILE OCCURE(XDocApr) ... *)
   RETURN 0;
  ELSE
   RETURN 1;
  END
 END {HasEntranceXDocApr};

 PRIVATE PROCEDURE IsEntranceMDoc(_XObject: LIKE(XObject.XObject); cab: DATE): SCAL[2];
 BEGIN
  RETURN ((MDoc.Date + 1) = cab) & ((MDoc.MDocKind = L_MDoc.md_PPr) | (MDoc.MDocKind = L_MDoc.md_PPk)) &
         HasEntranceXDocApr(L_XDoc.XDocId(L_XDoc.xdt_MDoc, MDoc.MDocKind, MDoc.MDoc), _XObject, MDoc.Date, L_XObj.src_MDoc);
 END {IsEntranceMDoc};

 PRIVATE PROCEDURE IsEntrancePDoc(_XObject: LIKE(XObject.XObject); oab: DATE): SCAL[2];
 BEGIN
  RETURN ((PDoc.Date + 1) = oab) & ((PDoc.PDocKind = L_PDoc.pd_IsP) | (PDoc.PDocKind = L_PDoc.pd_VhP)) &
         HasEntranceXDocApr(L_XDoc.XDocId(L_XDoc.xdt_PDoc, PDoc.PDocKind, PDoc.PDoc), _XObject, PDoc.Date, L_XObj.src_PDoc);
 END {IsEntrancePDoc};

 PUBLIC PROCEDURE TakeMDocIntoAccount(): SCAL[2];
  VAR
   cab     : DATE;
   _XObject: LIKE(XObject.XObject);
 BEGIN
  cab:=GetContractAccountingBegin(MDoc.Contract);
  IF MDoc.Date < cab THEN
   SAVE(Contract);
   CONFORM(MDoc, Contract);
   _XObject:=Contract.XObject;
   RESTORE(Contract);
   RETURN IsEntranceMDoc(_XObject, cab);
  ELSE
   RETURN 1;
  END;
 END {TakeMDocIntoAccount};

 PUBLIC PROCEDURE TakePDocMDocIntoAccount(): SCAL[2];
 BEGIN
  RETURN ~!PDocMDoc.Contract & (PDoc.Date >= GetContractAccountingBegin(PDocMDoc.Contract));
 END {TakePDocMDocIntoAccount};

 PRIVATE PROCEDURE IsAcceptablePDoc(D              : DATE;
                                    termPDocDoneDTS: FLOAT): SCAL[2];
 BEGIN
  IF (PDoc.Status#L_PDoc.st_Canceled) THEN
   IF    PDoc.Date < D THEN
    RETURN 1;
   ELSIF PDoc.Date = D THEN
    RETURN (PDoc.DoneDTS = L_XDoc.max_DoneDTS) | (PDoc.DoneDTS < termPDocDoneDTS);
   END;
  END;
  RETURN 0;
 END {IsAcceptablePDoc};

 PRIVATE PROCEDURE IsAcceptableMDoc(D              : DATE;
                                    termMDocDoneDTS: FLOAT): SCAL[2];
 BEGIN
  IF    MDoc.Date < D THEN
   RETURN 1;
  ELSIF MDoc.Date = D THEN
   RETURN (MDoc.DoneDTS = L_XDoc.max_DoneDTS) | (MDoc.DoneDTS < termMDocDoneDTS);
  ELSE
   RETURN 0;
  END;
 END {IsAcceptableMDoc};

 PRIVATE PROCEDURE IsAcceptableJDoc(D              : DATE;
                                    JDocDoneDTS,
                                    termJDocDoneDTS: FLOAT): SCAL[2];
 BEGIN
  IF    JDoc.Date < D THEN
   RETURN 1;
  ELSIF JDoc.Date = D THEN
   RETURN (JDocDoneDTS = L_XDoc.max_DoneDTS) | (JDocDoneDTS < termJDocDoneDTS);
  ELSE
   RETURN 0;
  END;
 END {IsAcceptableJDoc};

 PRIVATE PROCEDURE IsAcceptablePDocMDoc(EndDate: DATE;
                                        termPDocDoneDTS: FLOAT): SCAL[2];
 BEGIN
  CONFORM(PDocMDoc, PDoc);
  RETURN TakePDocMDocIntoAccount() & IsAcceptablePDoc(EndDate, termPDocDoneDTS);
 END {IsAcceptablePDocMDoc};

 PUBLIC PROCEDURE GetMDocPayment(   EndDate: DATE;
                                    termPDocDoneDTS: FLOAT;
                                 VAR _Netto,
                                     _Total : NUMERIC[2][];
                                 VAR _DocD  : DATE[];
                                 VAR _PDocK : LIKE(PDocKind.PDocKind)[];
                                 VAR _PDoc  : LIKE(PDoc.PDoc)[]): tValuesToBalance;
  VAR
   _Paid,
   tPaid: tValuesToBalance;
   i   : NUMERIC[0];
 BEGIN
  SAVE(PDocMDoc);
  SAVE(PDoc);
  SETEMPTY(_Netto, _DocD, _PDocK, _PDoc);
  SETZERO(tPaid);
  i:=0;
  SELECT(PDocMDoc, MDoc, , MDoc.MDocKind, MDoc.MDoc);
  WHILE OCCURE(PDocMDoc) DO
   CONFORM(PDocMDoc, PDoc);
   IF IsAcceptablePDocMDoc(EndDate, termPDocDoneDTS) THEN
    tPaid:=vtbAdd(tPaid, vtbGetByPDocMDocBalance());
_Paid:=vtbGetByPDocMDoc();
_Netto[i]:=_Paid[vtb_Netto];
_Total[i]:=_Paid[vtb_Total];
    _DocD [i]:=PDoc.Date;
    _PDocK[i]:=PDoc.PDocKind;
    _PDoc [i]:=PDoc.PDoc;
    INC(i);
   END;
   NEXT(PDocMDoc);
  END; (* WHILE OCCURE(PDocMDoc) ... *)
  RESTORE(PDoc);
  RESTORE(PDocMDoc);
  RETURN tPaid;
 END {GetMDocPayment};

 PUBLIC PROCEDURE GetMDocPmntBalance(EndDate: DATE; termPDocDoneDTS: FLOAT): tValuesToBalance;
  VAR
   Result: tValuesToBalance;
 BEGIN
  SAVE(PDocMDoc);
  SAVE(PDoc);
  SETZERO(Result);
  SELECT(PDocMDoc, MDoc, , MDoc.MDocKind, MDoc.MDoc);
  WHILE OCCURE(PDocMDoc) DO
   CONFORM(PDocMDoc, PDoc);
   IF IsAcceptablePDocMDoc(EndDate, termPDocDoneDTS) THEN
    Result:=vtbAdd(Result, vtbGetByPDocMDocBalance());
   END;
   NEXT(PDocMDoc);
  END; (* WHILE OCCURE(PDocMDoc) ... *)
  RESTORE(PDoc);
  RESTORE(PDocMDoc);
  RETURN Result;
 END {GetMDocPmntBalance};

 PUBLIC PROCEDURE GetMDocListAcpt(): tValuesToBalance;
 BEGIN
  RETURN vtbConv(MDocList.MDocKind, MDocList.Sum+MDocList.VAT+MDocList.SaleTax, MDocList.VAT, MDocList.SaleTax);
 END {GetMDocListAcpt};

 PUBLIC PROCEDURE GetMDocAcpt(): tValuesToBalance;
  VAR
   _Netto,
   _VAT,
   _SaleTax: NUMERIC[2];
 BEGIN
  IF (MDoc.Status#L_MDoc.st_Canceled) THEN
   SETZERO(_Netto, _VAT, _SaleTax);
   SETSEL(MDocList, MDoc, MDoc.MDocKind, MDoc.MDoc);
   FOR_EACH MDocList DO
    INC(_Netto, MDocList.Sum);
    INC(_VAT, MDocList.VAT);
    INC(_SaleTax, MDocList.SaleTax);
   END; (* FOR_EACH MDocList  *)
   RETURN vtbConv(MDoc.MDocKind, _Netto+_VAT+_SaleTax, _VAT, _SaleTax);
  ELSE
   RETURN vtbConv(MDoc.MDocKind, 0, 0, 0);
  END;
 END {GetMDocAcpt};

 PUBLIC PROCEDURE GetMDocAcptBalance(): tValuesToBalance;
 BEGIN
  IF E_IsSellMDoc() THEN
   RETURN GetMDocAcpt();
  ELSE
   RETURN vtbInv(GetMDocAcpt());
  END;
 END {GetMDocAcptBalance};

 PUBLIC PROCEDURE GetMDocBalance(d: DATE; termPDocDoneDTS: FLOAT): tValuesToBalance;
 BEGIN
  RETURN BalanceIt(GetMDocAcptBalance(),
                   GetMDocPmntBalance(d, termPDocDoneDTS));
 END {GetMDocBalance};

 PUBLIC PROCEDURE XDocOrderValue(_XDocId: L_XDoc.tXDocId): tXDocOrderValue;
 BEGIN
  IF    _XDocId = MAXOF(L_XDoc.tXDocId) THEN
   RETURN 0;
  ELSIF  ~L_Str.TestStrAlowChar(_XDocId, "09") THEN
   RETURN 2;
  ELSIF L_XDoc.ExtractXDocType(_XDocId) = L_XDoc.xdt_PDoc THEN
   RETURN 1;
  ELSE
   RETURN 2;
  END;
 END {XDocOrderValue};

 PRIVATE PROCEDURE xob_Put(_XObject : LIKE(XObject.XObject);
                           _XDocId  : L_XDoc.tXDocId;
                           XDocDate : DATE;
                           XDoneDTS : FLOAT;
                           _CirType : SCAL[2];
                           _Value   : tValuesToBalance;
                           _fromXDJR: SCAL[2]);

 BEGIN
  ADD(CnBHs, CnBHs, , _XObject, XDocDate, XDocOrderValue(_XDocId), XDoneDTS, _XDocId, _CirType, _fromXDJR,
                      CnBHs.Value[vtb_Total],   _Value[vtb_Total],
                      CnBHs.Value[vtb_Netto],   _Value[vtb_Netto],
                      CnBHs.Value[vtb_VAT],     _Value[vtb_VAT],
                      CnBHs.Value[vtb_SaleTax], _Value[vtb_SaleTax],
                      CnBHs.Balance[vtb_Total],   0,
                      CnBHs.Balance[vtb_Netto],   0,
                      CnBHs.Balance[vtb_VAT],     0,
                      CnBHs.Balance[vtb_SaleTax], 0);
 END {xob_Put};

 PRIVATE PROCEDURE getContract_XObject(_Contract: LIKE(Contract.Contract)): LIKE(XObject.XObject);
  VAR
   Result: LIKE(XObject.XObject);
 BEGIN
  SAVE(Contract);
  L_Cntr.PositionOnContract(_Contract);
  Result:=Contract.XObject;
  RESTORE(Contract);
  RETURN Result;
 END {getContract_XObject};

 PRIVATE TYPE
  tOriginId = SCAL[1E7];

 PRIVATE PROCEDURE getXObject_OriginId(_XObject: LIKE(XObject.XObject)): tOriginId;
  VAR
   Result: tOriginId;
 BEGIN
  SAVE(XObject);
  L_XObj.AccessXObject(_XObject);
  IF    XObject.Origin = L_XObj.o_Contract THEN
   SAVE(Contract);
   L_General.CallUs(SEARCH(Contract, XObject, _XObject));
   Result:=Contract.Contract;
   RESTORE(Contract);
  ELSIF XObject.Origin = L_XObj.o_Man THEN
   L_General.CallUs(SEARCH(mfMan, XObject, _XObject));
   Result:=mfMan.Man;
  ELSE
   L_General.CallUs(0);
  END;
  RESTORE(XObject);
  RETURN Result;
 END {getXObject_OriginId};

 PUBLIC PROCEDURE IsAccountableManPDoc(): SCAL[2];
 BEGIN
  RETURN ~L_PDoc.IsSalPDoc() &
         ((PDoc.PDocKind = L_PDoc.pd_AVO) |
          (PDoc.Dest = L_Dest.erkn_GetSoft(PDoc.Date, L_Dest.erkn_SumPaidOutOnAccount)));
 END {IsAccountableManPDoc};

 PRIVATE PROCEDURE xob_intGet(wShow    : SCAL[2];
                              _XObject : LIKE(XObject.XObject);
                              bht      : tBalanceHistoryType;
                              oab      : DATE;
                              begDate  : DATE;
                              Balance  : tValuesToBalance;
                              d        : DATE;
                              termMDocDoneDTS,
                              termPDocDoneDTS : FLOAT): tValuesToBalance;
  VAR
   originId   : tOriginId;
   Value      : tValuesToBalance;
   jdlPassCnt : SCAL[2];
   JDocDoneDTS: L_XDoc.tDoneDTS;
   trgMyFirm  : P_Firm.tMyFirm;
 BEGIN
  APP.Get().NewPrompt("");
  originId:=getXObject_OriginId(_XObject);
  IF bht = bht_Contract THEN
   SAVE(MDoc);
   SELECT(MDoc, Contract, , originId);
   WHILE OCCURE(MDoc) DO
    NARROWSEL(MDoc, MDocKind);
    IF IsAcptMDocKind(MDoc.MDocKind) THEN
     IF begDate = oab THEN
      SRCINSEL(MDoc, GE, , begDate-1);
     ELSE
      SRCINSEL(MDoc, GE, , begDate);
     END;
     WHILE OCCURE(MDoc) & (MDoc.Date <= d) DO
      IF (MDoc.Status # L_MDoc.st_Canceled) & ~L_MDoc.IsMDoc_wJDocOnly() & ((MDoc.Date >= begDate) | IsEntranceMDoc(_XObject, oab)) THEN
       IF IsAcceptableMDoc(d, termMDocDoneDTS) THEN
        PROMPT(L_XDoc.XDocStr(MDoc.XDocId));
        IF wShow THEN
         xob_Put(_XObject, L_XDoc.curXDocId(L_XDoc.xdt_MDoc), MDoc.Date, MDoc.DoneDTS, E_IsSellMDoc(), GetMDocAcpt(), 0);
        ELSE
         Balance:=vtbAdd(Balance, GetMDocAcptBalance());
        END;
       END;
      END; (* IF MDoc.Status ... *)
      NEXT(MDoc);
     END; (* WHILE OCCURE(MDoc) ... *)
    END;
    NEXTINEXTENDEDSEL(MDoc, MDocKind);
   END; (* WHILE OCCURE(MDoc) ... *)

   FOR_EACH jdlPassCnt DO
    IF jdlPassCnt = 0 THEN
     SETSEL(JDocList, XObject,  _XObject);
    ELSE
     SETSEL(JDocList, XObject2, _XObject);
    END;
    IF begDate = oab THEN
     SRCINSEL(JDocList, GE, , begDate-1);
    ELSE
     SRCINSEL(JDocList, GE, , begDate);
    END;
    WHILE OCCURE(JDocList) & (JDocList.Date <= d) DO
     CONFORM(JDocList, JDoc);
     IF jdlPassCnt = 0 THEN
      SEARCH(Apport, Apport, , JDocList.Apport);
      SEARCH(AcCut, AcCut, , JDocList.AcCut);
     ELSE
      SEARCH(Apport, Apport, , JDocList.Apport2);
      SEARCH(AcCut, AcCut, , JDocList.AcCut2);
     END;
     IF (JDoc.Status # L_JDoc.st_Canceled) &
        ((JDocList.Date >= begDate) | L_Acnt.IsEntranceApport(Apport.Apport)) &
        ItCntrBalAcCut(AcCut.AcCut, JDocList.Date) THEN
      JDocDoneDTS:=L_JDoc.GetJDocDoneDTS();
      IF IsAcceptableJDoc(d, JDocDoneDTS, termMDocDoneDTS) THEN
       PROMPT(L_XDoc.XDocStr(JDoc.XDocId));
       Value:=vtbCnv(JDocList.Sum, 0);
       IF wShow THEN
        xob_Put(_XObject, L_JDoc.GetJDocOnBehalfOfXDocId(), JDoc.Date, JDocDoneDTS, Apport.CirType = L_Acnt.ct_Debit, Value, 1);
       ELSE
        IF Apport.CirType = L_Acnt.ct_Credit THEN
         Value:=vtbInv(Value);
        END;
        Balance:=vtbAdd(Balance, Value);
       END;
      END;
     END;
     NEXT(JDocList);
    END; (* WHILE OCCURE(JDocList) ... *)
   END; (* FOR_EACH jdlPassCnt ... *)
   RESTORE(MDoc);
  END; (* IF bht = bht_Contract *)
  SAVE(PDoc);
  IF    bht = bht_Contract THEN
   SAVE(PDocMDoc);
   SETSEL(PDocMDoc, Contract, originId);
   SRCINSEL(PDocMDoc, GE, , begDate);
   WHILE OCCURE(PDocMDoc) & (PDocMDoc.PDocDate <= d) DO
    CONFORM(PDocMDoc, PDoc);
    IF IsAcceptablePDocMDoc(d, termPDocDoneDTS) & ~L_PDoc.IsPDoc_wJDocOnly() THEN
     PROMPT(L_XDoc.XDocStr(PDoc.XDocId));
     IF wShow THEN
      xob_Put(_XObject,
              L_XDoc.XDocId(L_XDoc.xdt_PDoc, PDocMDoc.PDocKind, PDocMDoc.PDoc),
              PDocMDoc.PDocDate, PDoc.DoneDTS,
              L_PDoc.IsOutPDoc(PDocMDoc.PDocKind),
              vtbGetByPDocMDoc(), 0);
     ELSE
      Balance:=vtbAdd(Balance, vtbGetByPDocMDocBalance());
     END;
    END;
    NEXT(PDocMDoc);
   END; (* WHILE OCCURE(PDocMDoc) ... *)
   RESTORE(PDocMDoc);
  ELSIF bht = bht_AccountableMan THEN
   SAVE(Staff);
   L_General.CallUs(SEARCH(mfMan, XObject, _XObject));
   trgMyFirm:=mfMan.MyFirm;
   SETSEL(Staff, Man, mfMan.Man);
   FOR_EACH Staff DO
    SETSEL(PDocList, TSN, Staff.TSN);
    IF begDate = oab THEN
     SRCINSEL(PDocList, GE, , begDate-1);
    ELSE
     SRCINSEL(PDocList, GE, , begDate);
    END;
    WHILE OCCURE(PDocList) DO
     CONFORM(PDocList, PDoc);
     IF (PDoc.MyFirm = trgMyFirm) & ((PDoc.Date >= begDate) | IsEntrancePDoc(_XObject, oab)) &
        IsAcceptablePDoc(d, termPDocDoneDTS) & IsAccountableManPDoc() & ~L_PDoc.IsPDoc_wJDocOnly() THEN
      PROMPT(L_XDoc.XDocStr(PDoc.XDocId));
      IF wShow THEN
       xob_Put(_XObject,
               L_XDoc.XDocId(L_XDoc.xdt_PDoc, PDoc.PDocKind, PDoc.PDoc),
               PDoc.Date, PDoc.DoneDTS,
               IsOutPDocList(PDoc.PDocKind),
               vtbGetByPDocList(), 0);
      ELSE
       Balance:=vtbAdd(Balance, vtbGetByPDocListBalance());
      END;
     END;
     NEXT(PDocList);
    END; (* WHILE OCCURE(PDocList) ... *)
   END; (* FOR_EACH Staff *)
   RESTORE(Staff);
  END;
  RESTORE(PDoc);
  IF wShow THEN
   IF begDate > oab THEN
    xob_Put(_XObject, MAXOF(L_XDoc.tXDocId), begDate, L_XDoc.min_DoneDTS, L_Acnt.ct_Credit, vtb_ZeroValue(), 0);
   END;
   SETSEL(CnBHs, CnBHs, _XObject);
   FOR_EACH CnBHs DO
    IF CnBHs.CirType = L_Acnt.ct_Credit THEN
     Balance:=vtbSub(Balance, CnBHs.Value);
    ELSE
     Balance:=vtbAdd(Balance, CnBHs.Value);
    END;
    CnBHs.Balance:=Balance;
    REPLACE(CnBHs);
   END; (* FOR_EACH CnBHs *)
  END;
  RETURN Balance;
 END {xob_intGet};

 PRIVATE PROCEDURE xob_Get(wShow    : SCAL[2];
                           _XObject : LIKE(XObject.XObject);
                           bht      : tBalanceHistoryType;
                           frDate,
                           onDate   : DATE;
                           termMDocDoneDTS,
                           termPDocDoneDTS : FLOAT): tValuesToBalance;
  VAR
   Balance : tValuesToBalance;
   trgAcCut: LIKE(AcCut.AcCut);
   minDate : DATE;
 BEGIN
  SETZERO(Balance);
  IF    bht = bht_Contract THEN
   trgAcCut:=L_kn.Get(SYSDATE(), L_AcCut.erkn_OnlineBalance);
   minDate :=GetContractAccountingBegin(getXObject_OriginId(_XObject));
  ELSIF bht = bht_AccountableMan THEN
   trgAcCut:=L_kn.Get(SYSDATE(), L_AcCut.erkn_AccountableMan);
   minDate :=L_XObj.GetBeginOfAccountingOnAcCut(trgAcCut);
  END;
  IF !minDate THEN
   RETURN Balance;
  END;
  frDate:=L_DatTim.Per(frDate);
  SETSEL(XCalc, XObject, _XObject, trgAcCut);
  IF SRCINSEL(XCalc, LT, frDate) THEN
   frDate:=L_DatTim.NextPer(XCalc.XDat);
   IF frDate > minDate (* ᯥ䨪!    뢠   㯨⥫ 㬥 *) THEN
    Balance[vtb_Netto]:=L_XObj.mo_OutRSaldo();
    Balance[vtb_Total]:=Balance[vtb_Netto]+Balance[vtb_VAT];
   END; (* IF From ... *)
  END; (* IF SRCINSEL(XCalc ... *)
  IF wShow THEN
   IF (bht = bht_Contract) & (onDate >= L_PRoll.E_DoSecondSide()) THEN
    IF ~OCCURE(XCalc) THEN
     FIRST(XCalc);
    END;
    WHILE OCCURE(XCalc) DO
     SETSEL(XApport, XObject, XCalc.XObject, XCalc.AcCut, XCalc.XDat);
     FOR_EACH XApport DO
      IF (XApport.Source = L_XObj.src_Salary) THEN
       CONFORM(XApport, Apport);
       xob_Put(XApport.XObject, "௫",
               L_DatTim.MonthEnd(XApport.XDat), L_XDoc.max_DoneDTS, Apport.CirType, vtbCnv(XApport.Sum, 0), 0);
 
      END;
     END;
     NEXT(XCalc);
    END;
   END; (* IF (bht = bht_Contract) ... *)
  END; (* IF wShow *)
  frDate:=Math.Max(frDate, minDate);
  RETURN xob_intGet(wShow, _XObject, bht, minDate, frDate, Balance, onDate, termMDocDoneDTS, termPDocDoneDTS);
 END {xob_Get};

 PRIVATE PROCEDURE xob_PrepareHistory(_XObject : LIKE(XObject.XObject);
                                      bht      : tBalanceHistoryType;
                                      frDate,
                                      OnDate   : DATE);
  VAR
   Dummy: tValuesToBalance;
 BEGIN
  L_AFM.MakeMultipleIndex("CnBHs", "XObject  : LIKE(XObject.XObject);"+
                                   "Date     : DATE;"+
                                   "OrdVal   : "+TYPENAMEOF(tXDocOrderValue)+";"+
                                   "DoneDTS  : FLOAT;"+
                                   "XDocId   : "+TYPENAMEOF(L_XDoc.tXDocId)+";"+
                                   "CirType  : SCAL[2];"+
                                   "Value    : "+TYPENAMEOF(tValuesToBalance)+";"+
                                   "Balance  : "+TYPENAMEOF(tValuesToBalance)+";"+
                                   "fromXDJR : SCAL[2]",
                              "CnBHs: XObject, Date, OrdVal, DoneDTS, XDocId, CirType, fromXDJR");
  Dummy:=xob_Get(1, _XObject, bht, frDate, OnDate, L_XDoc.max_DoneDTS, L_XDoc.max_DoneDTS);
 END {xob_PrepareHistory};

 PUBLIC PROCEDURE PrepareContractBalanceHistory(trgContract: LIKE(Contract.Contract);
                                                frDate,
                                                OnDate   : DATE);
 BEGIN
  xob_PrepareHistory(getContract_XObject(trgContract), bht_Contract, frDate, OnDate);
 END {PrepareContractBalanceHistory};

 PUBLIC PROCEDURE PrepareAccountableManBalanceHistory(trgMan   : LIKE(Man.Man);
                                                      trgMyFirm: P_Firm.tMyFirm;
                                                      frDate,
                                                      OnDate   : DATE);
 BEGIN
  xob_PrepareHistory(L_XObj.GetManXObject(trgMan, trgMyFirm), bht_AccountableMan, frDate, OnDate);
 END {PrepareAccountableManBalanceHistory};

 PRIVATE PROCEDURE xob_sh_GetVarPrc(v: tValuesToBalance): STRING[];
  VAR
   Result: STRING[];
 BEGIN
  IF v[vtb_VAT] # 0 THEN
   IF v[vtb_Netto] # 0 THEN
    Result:=FLDTOSTR(v[vtb_VAT]/v[vtb_Netto] * 100, "2.", 0);
   ELSE
    Result:="!";
   END;
  ELSE
   Result:="";
  END;
  RETURN "(" + Str.Align(Result, 5, RIGHT) + ")";
 END {xob_sh_GetVarPrc};

 PRIVATE PROCEDURE xob_ShowHistory(trgXObject: LIKE(XObject.XObject);
                                   bht       : tBalanceHistoryType;
                                   Full      : SCAL[2]): STRING[];
  VAR
   List,
   XDocIds,
   XDoc_asStr,
   Value_asStr: STRING[];
   DocCnt     : NUMERIC[0];
   Result     : L_XDoc.tXDocId;
   Title      : STRING[];
 BEGIN
  TRY
   RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
   Title:="   ꥪ: " + L_Str.PoolItem(bht_Pool, bht) + " " + getXObject_OriginId(trgXObject);
   APP.Get().NewPrompt(Title);
   IF Full THEN
    xob_PrepareHistory(trgXObject, bht, L_DatTim.MINDATE(), SYSDATE());
   ELSE
    xob_PrepareHistory(trgXObject, bht, SYSDATE()-90, SYSDATE());
   END;
   SETZERO(DocCnt);
   SETEMPTY(List, XDocIds);
   SETSEL(CnBHs, CnBHs, trgXObject);
   LAST(CnBHs);
   WHILE OCCURE(CnBHs) DO
    PROMPT("⮢ ᯨ᪠ " + L_DatTim.DateStr(CnBHs.Date));
    IF CnBHs.XDocId # MAXOF(L_XDoc.tXDocId) THEN
     IF L_Str.TestStrAlowChar(CnBHs.XDocId, "09") THEN
      XDoc_asStr :=L_XDoc.XDocStr(CnBHs.XDocId);
     ELSE
      XDoc_asStr :=Str.Align(CnBHs.XDocId, 15, LEFT);
     END;
     Value_asStr:=FLDTOSTR(CnBHs.Value[vtb_Total], "2.", 15) + " " + xob_sh_GetVarPrc(CnBHs.Value) + " " + L_Str.PoolItem("|", CnBHs.CirType);
    ELSE
     XDoc_asStr :=Str.Align("줮", 15, LEFT);
     Value_asStr:=Str.Align("", 12+1+7+1+1+3, LEFT);
    END;
    List:=List+XDoc_asStr + " " +
               L_DatTim.DateStr(CnBHs.Date) + " " +
               L_Str.PoolItem(" |", CnBHs.fromXDJR) + " " +
               Value_asStr + " " +
               FLDTOSTR(CnBHs.Balance[vtb_Total], "2.", 15) + "|";
    XDocIds:=XDocIds + CnBHs.XDocId + "|";
    INC(DocCnt);
    PREV(CnBHs);
   END; (* WHILE OCCURE(CnBHs) ... *)
   L_AFM.AF_PurgeTemp("CnBHs");
   PROMPT("");
   DocCnt:=L_StdFrm.ShowListAsMenu_wInit(List, Title, 0);
   Result:=L_Str.PoolItem(XDocIds, DocCnt);
  EXCEPT
  END;
  IF (Result # MAXOF(L_XDoc.tXDocId)) & L_Str.TestStrAlowChar(Result, "09") THEN
   RETURN Result;
  ELSE
   HALT(1);
  END;
 END {xob_ShowHistory};

 PUBLIC PROCEDURE ShowContractBalanceHistory(_Contract: LIKE(Contract.Contract);
                                             Full     : SCAL[2]): STRING[];
 BEGIN
  RETURN xob_ShowHistory(getContract_XObject(_Contract), bht_Contract, Full);
 END {ShowContractBalanceHistory};

 PUBLIC PROCEDURE GetContractBalance(_Contract: LIKE(Contract.Contract);
                                     d        : DATE;
                                     termMDocDoneDTS,
                                     termPDocDoneDTS : FLOAT): tValuesToBalance;
 BEGIN
  RETURN xob_Get(0, getContract_XObject(_Contract), bht_Contract, d, d, termMDocDoneDTS, termPDocDoneDTS);
 END {GetContractBalance};

 PUBLIC PROCEDURE ShowAccountableManHistory(_Man   : LIKE(Man.Man);
                                            _MyFirm: P_Firm.tMyFirm;
                                            Full   : SCAL[2]): STRING[];
  VAR
   Result: STRING[];
 BEGIN
  L_XDR.InitEntryList();
  Result:=xob_ShowHistory(L_XObj.GetManXObject(_Man, _MyFirm), bht_AccountableMan, Full);
  L_XDR.DeInitEntryList();
  RETURN Result;
 END {ShowAccountableManHistory};

 PUBLIC PROCEDURE GetAccountableManBalance(_Man    : LIKE(Man.Man);
                                           _MyFirm : P_Firm.tMyFirm;
                                           d       : DATE;
                                           termMDocDoneDTS,
                                           termPDocDoneDTS: FLOAT): tValuesToBalance;
  VAR
   VTB: tValuesToBalance;
 BEGIN
  L_XDR.InitEntryList();
  VTB:=xob_Get(0, L_XObj.GetManXObject(_Man, _MyFirm), bht_AccountableMan, d, d, termMDocDoneDTS, termPDocDoneDTS);
  L_XDR.DeInitEntryList();
  RETURN VTB;
 END {GetAccountableManBalance};

 PRIVATE PROCEDURE E_CheckMDocOrder(): SCAL[2];
 BEGIN
  RETURN L_EC.ExecE_Func_Scal2(SYSDATE(), PROCREF(E_Pmnt.CheckMDocOrder), 0);
 END {E_CheckMDocOrder};

 PUBLIC PROCEDURE CheckRemoveOrder(remMDocKind: L_XDoc.tXDocKind; maxMDoc: L_XDoc.tXDoc);
 BEGIN
  SAVE(MDoc);
  SETSEL(MDoc, MDoc, remMDocKind);
  L_General.Assert(~LAST(MDoc) |
                   (MDoc.MDoc<maxMDoc) |
                   ~E_IsSellMDoc() |
                   ~E_CheckMDocOrder(), "  ⮫쪮 ᫥ 㬥");
  RESTORE(MDoc);
 END {CheckRemoveOrder};

 PRIVATE PROCEDURE GetBaseDocAmntAsStr(): STRING[];
  VAR
   _Count: NUMERIC[0];
 BEGIN
  _Count:=L_XDoc.xdc_Count(L_XDoc.GetAllRefToXDC(L_XDoc.curXDocId(L_XDoc.xdt_MDoc)));
  IF _Count > 1 THEN
   RETURN " (" + FLDTOSTR(_Count, "0", 2) + ")";
  ELSE
   RETURN "     ";
  END;
 END {GetBaseDocAmntAsStr};

 PRIVATE PROCEDURE CheckRemMDocPrinted();
 BEGIN
  L_General.Assert(~L_XDoc.XDocIsPrinted(L_XDoc.xdt_MDoc, MDoc.MDocKind, MDoc.MDoc), " "+L_MDoc.MDocStr(MDoc.MDocKind, MDoc.MDoc)+" ⯥⠭     㤠|ᯮ '㫨஢'");
 END {CheckRemMDocPrinted};

 PUBLIC PROCEDURE PassMayGenerateMDocAcsPnt();
 BEGIN
  L_AcsPnt.PassAccessPoint(0000016);
 END {PassMayGenerateMDocAcsPnt};

 PUBLIC PROCEDURE RemoveGeneratedMDocs(remLastOnly: SCAL[2];
                                       Stage      : tStageOfBuildingVATMDoc;
                                       remMDocKind: LIKE(MDoc.MDocKind);
                                       baseDocT   : SCAL[32];
                                       baseDocKind: SCAL[1E2];
                                       baseDoc    : SCAL[1E9]): STRING[];
  VAR
   maxMDoc       : LIKE(MDoc.MDoc);
   remMDocList   : STRING[];
   _Count        : NUMERIC[0];
   DependentMDocs: L_XDoc.tXDocCollection;
   i             : NUMERIC[0];
 BEGIN
  PassMayGenerateMDocAcsPnt();
  SAVE(MDoc);
  remMDocList:=""; maxMDoc:=0; _Count:=0;
  i:=0;
  DependentMDocs:=L_XDoc.GetDependentXDC(L_XDoc.XDocId(baseDocT, baseDocKind, baseDoc), L_XDoc.xdt_MDoc);
  WHILE L_XDoc.xdc_PositionOn(DependentMDocs, i) DO
   IF (MDoc.Status # L_MDoc.st_Canceled) &
      (MDoc.MDocKind = remMDocKind) &
      (~IsVATMDocKind(MDoc.MDocKind) |
       (E_StageOfBuildingVATMDoc(MDoc.Date, MDoc.MDocKind, MDoc.Dest) = Stage) &
       (MDoc.WFPeriod >= SpecialVATMDocClcPer(MDoc.Date))
      ) THEN
    INC(_Count);
    maxMDoc:=Math.Max(maxMDoc, MDoc.MDoc);
    IF ~remLastOnly THEN
     remMDocList:=remMDocList + "|" + L_XDoc.extXDocStr(L_XDoc.curXDocId(L_XDoc.xdt_MDoc), L_XDoc.xdast_wStatus) + GetBaseDocAmntAsStr();
     CheckRemMDocPrinted();
     IF IsVATMDocKind(MDoc.MDocKind) & (Stage = sbvmd_Offline) THEN
      L_MDoc.Cancel_MDoc();
     ELSE
      L_MDoc.Remove_MDoc();
     END;
    END;
   END;
   INC(i);
  END; (* WHILE L_XDoc.xdc_PositionOn ... *)
  IF _Count > 0 THEN
   IF remLastOnly THEN
    SETSEL(MDoc, MDoc, remMDocKind);
    SRCINSEL(MDoc, EQ, , maxMDoc);
    remMDocList:=remMDocList + "|" + L_XDoc.XDocStr(L_XDoc.curXDocId(L_XDoc.xdt_MDoc));
    CheckRemMDocPrinted();
    L_MDoc.Remove_MDoc();
   END;
   CheckRemoveOrder(remMDocKind, maxMDoc);
  END;
  RESTORE(MDoc);
  RETURN remMDocList;
 END {RemoveGeneratedMDocs};

 PUBLIC PROCEDURE IsVATMDocKind(_MDocKind: LIKE(MDocKind.MDocKind)): SCAL[2];
 BEGIN
  RETURN (_MDocKind = L_MDoc.md_ISF) |
         (_MDocKind = L_MDoc.md_VSF) |
         (_MDocKind = L_MDoc.md_DPk) |
         (_MDocKind = L_MDoc.md_DPr) ;
 END {IsVATMDocKind};

 PUBLIC PROCEDURE IsSpecifiedVATMDoc(bm: tVATMDocBuildMode): SCAL[2];
 BEGIN
  IF IsVATMDocKind(MDoc.MDocKind) & (MDoc.Status # L_MDoc.st_Canceled) THEN
   IF bm = vmdbm_Acceptance THEN
    RETURN ~IsSpecialVATMDocDest(MDoc.Date, MDoc.Dest);
   ELSE
    RETURN E_GetVATMDocDest(MDoc.Date, bm) = MDoc.Dest;
   END;
  ELSE
   RETURN 0;
  END;
 END {IsSpecifiedVATMDoc};

 PUBLIC PROCEDURE RemoveGeneratedVATMDocs(Stage      : tStageOfBuildingVATMDoc;
                                          baseDocT   : SCAL[32];
                                          baseDocKind: SCAL[1E2];
                                          baseDoc    : SCAL[1E9]);

  VAR
   asStr: STRING[];
 BEGIN
  PassMayGenerateMDocAcsPnt();
  asStr:="";
  SAVE(MDocKind);
  SELECT(MDocKind, MDocKind);
  WHILE OCCURE(MDocKind) DO
   IF IsVATMDocKind(MDocKind.MDocKind) THEN
    asStr:=asStr+RemoveGeneratedMDocs(0, Stage, MDocKind.MDocKind, baseDocT, baseDocKind, baseDoc);
   END;
   NEXT(MDocKind);
  END; (* WHILE OCCURE(MDocKind) ... *)
  RESTORE(MDocKind);
  ConfirmRemovingDocs(0, asStr);
 END {RemoveGeneratedVATMDocs};

 PRIVATE PROCEDURE CheckOrder();
  VAR
   PrevMDocDate: DATE;
   Msg         : STRING[];
 BEGIN
  IF E_IsSellMDoc() & E_CheckMDocOrder() THEN
   PrevMDocDate:=MDoc.Date;
   SAVE(MDoc);
   CHANGESEL(MDoc, MDoc, , MDoc.MDocKind);
   IF PREV(MDoc) THEN
    PrevMDocDate:=MDoc.Date;
   END;
   RESTORE(MDoc);
   IF PrevMDocDate > MDoc.Date THEN
    Msg:="襭 ᫥⥫쭮 ନ஢ "+L_MDoc.MDocKindNick(MDoc.MDocKind, 1);
    L_General.Assert(L_General.IsAdmin(), Msg);
    Msg:=Msg + "|᫥ 㬥   " + L_DatTim.DateStr(PrevMDocDate) +
               "|ନ㥬 㬥   "+L_DatTim.DateStr(MDoc.Date)+
               "| ()   믮 ନ஢";
    L_StdFrm.CrucialChoice_FileExplicit("MDoc", Msg, L_General.AdminGroupName());
   END;
  END;
 END {CheckOrder};

 PRIVATE PROCEDURE GenerateProportionalMDoc(baseMDocKind : LIKE(MDoc.MDocKind);
                                            baseMDoc     : LIKE(MDoc.MDoc);
                                            _Netto,
                                            _VAT         : NUMERIC[2]);
  VAR
   baseMDocTotal,
   restMDocTotal,
   maxValue,
   basValue     : tValuesToBalance;
   ratio_Netto,
   ratio_VAT    : FLOAT;
   maxNbr_Netto,
   maxNbr_VAT   : LIKE(MDocList.MDLNbr);
   trgSum       : LIKE(MDocList.Sum);
   trgVAT       : LIKE(MDocList.VAT);
 BEGIN
  SAVE(MDoc);
  SEARCH(MDoc, MDoc, , baseMDocKind, baseMDoc);
  baseMDocTotal:=GetMDocAcpt();
  RESTORE(MDoc);
  restMDocTotal[vtb_Netto]:=_Netto;
  restMDocTotal[vtb_VAT]  :=_VAT;
  IF baseMDocTotal[vtb_Netto] # 0 THEN
   ratio_Netto:=restMDocTotal[vtb_Netto]/baseMDocTotal[vtb_Netto];
  ELSE
   ratio_Netto:=0;
  END;
  IF baseMDocTotal[vtb_VAT] # 0 THEN
   ratio_VAT:=restMDocTotal[vtb_VAT]/baseMDocTotal[vtb_VAT];
  ELSE
   ratio_VAT:=0;
  END;
  SETZERO(maxValue);
  SETEMPTY(maxNbr_Netto, maxNbr_VAT);
  SETSEL(MDocList, MDoc, baseMDocKind, baseMDoc);
  FOR_EACH MDocList DO
(* 18.02.2003 20:29:59 POLAK\SAN - ratio_*   १୮  *)
   basValue[vtb_Netto]:=MDocList.Sum;
   basValue[vtb_VAT  ]:=MDocList.VAT;
   trgSum:=MDocList.Sum * ratio_Netto; (*0104279 07.07.2014 19:07:33 POLAK\Bor*)
   trgVAT:=MDocList.VAT * ratio_VAT;
   L_MDoc.InsMDocList(MDocList.Math, MDocList.MMode, MDocList.VATMode, MDocList.Qnt,
                      trgSum, trgVAT);
   DEC(restMDocTotal[vtb_Netto], trgSum);
   DEC(restMDocTotal[vtb_VAT  ], trgVAT);
   IF basValue[vtb_Netto] > maxValue[vtb_Netto] THEN
    maxValue[vtb_Netto]:=basValue[vtb_Netto];
    maxNbr_Netto       :=MDocList.MDLNbr;
   END;
   IF basValue[vtb_VAT] > maxValue[vtb_VAT] THEN
    maxValue[vtb_VAT]:=basValue[vtb_VAT];
    maxNbr_VAT       :=MDocList.MDLNbr;
   END;
  END; (* FOR_EACH MDocList ... *)
  IF restMDocTotal[vtb_Netto] # 0 THEN
   SEARCH(MDocList, MDoc, , MDoc.MDocKind, MDoc.MDoc, maxNbr_Netto);
   INC(MDocList.Sum, restMDocTotal[vtb_Netto]);
   REPLACE(MDocList);
   INC(MDoc.Total, restMDocTotal[vtb_Netto]);
   REPLACE(MDoc);
  END;
  IF restMDocTotal[vtb_VAT] # 0 THEN
   SEARCH(MDocList, MDoc, , MDoc.MDocKind, MDoc.MDoc, maxNbr_VAT);
   INC(MDocList.VAT, restMDocTotal[vtb_VAT]);
   REPLACE(MDocList);
   INC(MDoc.Total, restMDocTotal[vtb_VAT]);
   REPLACE(MDoc);
  END;
 END {GenerateProportionalMDoc};

 PUBLIC PROCEDURE VATValue(Rate: tVATRates): NUMERIC[0];
 BEGIN
  IF    Rate = vr_18 THEN RETURN 18;
  ELSIF Rate = vr_20 THEN RETURN 20;
  ELSIF Rate = vr_10 THEN RETURN 10;
  ELSIF Rate = vr_00 THEN RETURN  0;
  ELSIF Rate = vr_NV THEN RETURN  0;
  ELSIF Rate = vroNV THEN RETURN  0;
  ELSE
   L_General.CallUs(0);
  END;
 END {VATValue};

 PUBLIC PROCEDURE CalcVAT(Netto: NUMERIC[2]; Rate: tVATRates): NUMERIC[2];
 BEGIN
  RETURN Netto * VATValue(Rate) / 100;
 END {CalcVAT};

 PRIVATE PROCEDURE GenerateVATMDocByVATRates(_Math        : LIKE(Math.Math);
                                             _Netto,
                                             _VAT         : NUMERIC[2];
                                             _Amn         : NUMERIC[2];
                                             _VATMode     : LIKE(MDocList.VATMode);
                                             patNetto     : tValuesByVATRate);
  VAR
   patVAT,
   NettoByRate,
   VATByRate    : tValuesByVATRate;
   tNetto,
   tVAT,
   rstNetto,
   rstVAT       : NUMERIC[2];
   maxVATRate,
   bstNetRate,
   r            : tVATRates;
 BEGIN
  SETZERO(tNetto, tVAT);
  SETEMPTY(maxVATRate, bstNetRate);
  FOR_EACH r DO
   IF patNetto[r] # 0 THEN
    patVAT[r]:=CalcVAT(patNetto[r], r);
    INC(tNetto, patNetto[r]);
    INC(tVAT,   patVAT[r]);
    IF !maxVATRate | (Math.Abs(patVAT[r]) > Math.Abs(patVAT[maxVATRate])) THEN
     maxVATRate:=r;
    END;
   END;
  END; (* FOR_EACH r DO ... *)
  IF (tNetto = 0) | (tVAT = 0) THEN
   L_MDoc.InsMDocList(_Math, L_MathR.mm_New, _VATMode, _Amn, _Netto, _VAT);
  ELSE
   SETZERO(NettoByRate, VATByRate);
   rstNetto:=_Netto;
   rstVAT  :=_VAT;
   FOR_EACH r DO
    IF patNetto[r] # 0 THEN
     IF VATValue(r) # 0 THEN
      VATByRate[r]  :=_VAT*(patVAT[r] / tVAT);
      NettoByRate[r]:=VATByRate[r] * 100 / VATValue(r);
     ELSE
      NettoByRate[r]:=_Netto*(patNetto[r] / tNetto);
      VATByRate  [r]:=0;
      bstNetRate:=r;
     END;
     DEC(rstNetto, NettoByRate[r]);
     DEC(rstVAT,   VATByRate  [r]);
    END;
   END; (* FOR_EACH r DO ... *)
   IF rstNetto # 0 THEN
    IF !bstNetRate THEN
     bstNetRate:=maxVATRate;
    END;
    INC(NettoByRate[bstNetRate], rstNetto);
    IF (Math.Abs(NettoByRate[bstNetRate]) < 0.5) & (maxVATRate # bstNetRate) THEN
     INC(NettoByRate[maxVATRate], NettoByRate[bstNetRate]);
     NettoByRate[bstNetRate]:=0;
    END;
   END;
   IF rstVAT # 0 THEN
    INC(VATByRate  [maxVATRate], rstVAT  );
   END;
   FOR_EACH r DO
    IF (NettoByRate[r] # 0) | (VATByRate[r] # 0) THEN
     L_MDoc.InsMDocList(_Math, L_MathR.mm_New, _VATMode, _Amn,
                        NettoByRate[r], VATByRate[r]);
    END;
   END; (* FOR_EACH r DO ... *)
  END;
 END {GenerateVATMDocByVATRates};

 IMPORT L_ACL;

 PUBLIC PROCEDURE FillMDocListCstDclr(Silent: SCAL[2]);
  VAR
   Need: SCAL[2];
 BEGIN
  CONFORM(MDoc, MDocKind);
  IF ~MDocKind_wCstDclr(MDoc.MDocKind, MDoc.Date) | L_MDoc.IsPrchMDocKind() THEN
   IF ~Silent THEN
    L_General.Error("ᮢ   ਬ  ⮬  ");
   ELSE
    RETURN;
   END;
  END;
  CONFORM(MDoc, MDocList);
  WHILE OCCURE(MDocList) DO
   CONFORM(MDocList, Math);
   IF !MDocList.CstDclr & E_MDocListMustHasCstDclr() THEN
    MDocList.CstDclr:=GetMDocListCstDclr();
    REPLACE(MDocList);
    IF !MDocList.CstDclr THEN
     MDoc.Status:=L_MDoc.st_Prepared;
     REPLACE(MDoc);
    END;
   END;
   NEXT(MDocList);
  END; (* WHILE OCCURE(MDocList) ... *)
 END {FillMDocListCstDclr};

 PUBLIC PROCEDURE GetUncoveredMDocAcpt(trgMDocKind: LIKE(MDoc.MDocKind);
                                       trgDest    : LIKE(MDoc.Dest)): tValuesToBalance;
  VAR
   DependentMDocs: L_XDoc.tXDocCollection;
   i             : NUMERIC[0];
   Result        : tValuesToBalance;
 BEGIN
  SAVE(MDoc);
  Result:=GetMDocAcpt();
  DependentMDocs:=L_XDoc.GetDependentXDC(L_XDoc.curXDocId(L_XDoc.xdt_MDoc), L_XDoc.xdt_MDoc);
  i:=0;
  WHILE L_XDoc.xdc_PositionOn(DependentMDocs, i) DO
   IF (MDoc.MDocKind = trgMDocKind)(* & (MDoc.Dest = trgDest)*) & (MDoc.Status#L_MDoc.st_Canceled) THEN
    Result:=vtbSub(Result, GetMDocAcpt());
   END;
   INC(i);
  END; (* WHILE L_XDoc.xdc_PositionOn ... *)
  RESTORE(MDoc);
  L_General.CallUs(Result[vtb_Total] >= 0);
  RETURN Result;
 END {GetUncoveredMDocAcpt};

 PRIVATE PROCEDURE grvmd_IsTrgMDoc(D: DATE; trgBM: tVATMDocBuildMode): SCAL[2];
 BEGIN
  RETURN IsSpecifiedVATMDoc(trgBM) & (MDoc.Date <= D) &
         ~L_XDoc.IsInReversedPair(L_XDoc.curXDocId(L_XDoc.xdt_MDoc));
 END {grvmd_IsTrgMDoc};

 PRIVATE PROCEDURE grvmd_TryFindTheSame(_Contract: LIKE(MDoc.Contract);
                                        D        : DATE;
                                        trgBM    : tVATMDocBuildMode;
                                        curBM    : tVATMDocBuildMode;
                                        VAR
                                         curValue: tValuesToBalance): SCAL[2];
  VAR
   trgValue  : tValuesToBalance;
   closedMDoc: L_XDoc.tXDocCollection;
   i         : NUMERIC[0];
   Result    : SCAL[2];
 BEGIN
  Result:=0;
  SETEMPTY(closedMDoc);
  SELECT(MDoc, CntrClsd, , _Contract, E_GetVATMDocMDocKind(D, trgBM), EMPTYOF(MDoc.Closed));
  LOOP
   IF ~OCCURE(MDoc) THEN
    EXIT;
   END;
   IF grvmd_IsTrgMDoc(D, trgBM) THEN
    trgValue:=GetUncoveredMDocAcpt(E_GetVATMDocMDocKind(D, curBM), E_GetVATMDocDest(D, curBM));
    IF trgValue[vtb_Total] > 0 THEN
     IF trgValue[vtb_Total] = curValue[vtb_Total] THEN
      curValue:=trgValue;
      Result:=1;
      EXIT;
     END;
    ELSE
     L_XDoc.xdc_Put(closedMDoc, L_XDoc.curXDocId(L_XDoc.xdt_MDoc));
    END;
   END; (* IF IsSpecifiedVATMDoc *)
   NEXT(MDoc);
  END; (* LOOP ... *)
  SAVE(MDoc);
  i:=0;
  WHILE L_XDoc.xdc_PositionOn(closedMDoc, i) DO
   MDoc.Closed:=SYSDATE();
   REPLACE(MDoc);
   INC(i);
  END;
  RESTORE(MDoc);
  RETURN Result;
 END {grvmd_TryFindTheSame};

 PRIVATE PROCEDURE grvmd_Put(_Value: tValuesToBalance;
                             i     : NUMERIC[0];
                             VAR
                              XDocId: L_XDoc.tXDocId[];
                             VAR
                              xdValue: NUMERIC[2][] (*SIC!!!*));
 BEGIN
  XDocId[i]:=L_XDoc.curXDocId(L_XDoc.xdt_MDoc);
  (* SIC! *)
  xdValue[vtb_Netto + i*RANGEOF(tValuesToBalance)]:=_Value[vtb_Netto];
  xdValue[vtb_VAT   + i*RANGEOF(tValuesToBalance)]:=_Value[vtb_VAT];
 END {grvmd_Put};

(*PRIVATE  ६  *)
 PUBLIC PROCEDURE GetRelatedVATMDocCollection(     _Contract: LIKE(MDoc.Contract);
                                                   D        : DATE;
                                                   trgBM    : tVATMDocBuildMode;
                                                   curBM    : tVATMDocBuildMode;
                                                   curValue : tValuesToBalance;
                                               VAR XDocId   : L_XDoc.tXDocId[];
                                               VAR xdValue  : NUMERIC[2][] (*SIC!!!*));
  VAR
   trgValue : tValuesToBalance;
   i        : NUMERIC[0];
 BEGIN
  SETEMPTY(XDocId);
  SAVE(MDoc);
  i:=0;
  IF grvmd_TryFindTheSame(_Contract, D, trgBM, curBM, curValue) THEN
   grvmd_Put(curValue, 0, XDocId, xdValue);
  ELSE
   SELECT(MDoc, CntrClsd, , _Contract, E_GetVATMDocMDocKind(D, trgBM), EMPTYOF(MDoc.Closed));
   LOOP
    IF curValue[vtb_Total] = 0 THEN
     EXIT;
    ELSIF ~OCCURE(MDoc) THEN
     L_General.Error(" " + _Contract + " - ⪠ ନ஢  ( " + E_GetVATMDocDest(D, curBM) + ")"+
                     "||"+
                     "  ᮮ⢥騩(-)  ( " + E_GetVATMDocDest(D, trgBM)  +")"+
                     L_StdFrm.THR(" 稭")+
                     "1   ଫ   ஢;                                           |"+
                     "2     㪠 ᢮⢮ 'ନ஢ '  祭 ' ନ஢'");
    END;
    IF grvmd_IsTrgMDoc(D, trgBM) THEN
     trgValue:=GetUncoveredMDocAcpt(E_GetVATMDocMDocKind(D, curBM), E_GetVATMDocDest(D, curBM));
     IF trgValue[vtb_Total] > curValue[vtb_Total] THEN
      trgValue:=vtbCnv(curValue[vtb_Total], curValue[vtb_Total]/trgValue[vtb_Total]*trgValue[vtb_VAT]);
      SETZERO(curValue);
     ELSE
      curValue:=vtbSub(curValue, trgValue);
     END;
     grvmd_Put(trgValue, i, XDocId, xdValue);
     INC(i);
    END; (* IF IsSpecifiedVATMDoc *)
    NEXT(MDoc);
   END; (* LOOP ... *)
  END; (* IF grvmd_TryFindTheSame *)
  RESTORE(MDoc);
 END {GetRelatedVATMDocCollection};

 PUBLIC PROCEDURE vmdbm_GetRelatedBM(bm: tVATMDocBuildMode): tVATMDocBuildMode;
 BEGIN
  IF    bm = vmdbm_PrchPstpay THEN RETURN vmdbm_PrchUndpay;
  ELSIF bm = vmdbm_Pstpayment THEN RETURN vmdbm_Underpay;
  ELSIF bm = vmdbm_OnPrpShpmt THEN RETURN vmdbm_Prepayment;
  ELSIF bm = vmdbm_PrpReturn  THEN RETURN vmdbm_Prepayment;
  ELSE
   RETURN EMPTYOF(tVATMDocBuildMode);
  END;
 END {vmdbm_GetRelatedBM};

 PUBLIC PROCEDURE NeedCondenseSingleMathMDocList(_SingleMath: LIKE(Math.Math); _Contract: LIKE(Contract.Contract)): SCAL[2];
  VAR
   Need: SCAL[2];
 BEGIN
  IF ~!_SingleMath THEN
   SAVE(Contract);
   L_Cntr.PositionOnContract(_Contract);
   Need:=(Contract.Type = L_Cntr.ct_Sell);
   RESTORE(Contract);
   RETURN Need;
  ELSE
   RETURN 0;
  END;
 END {NeedCondenseSingleMathMDocList};

 PRIVATE PROCEDURE IsUSNOMyFirmContract(_Contract: LIKE(Contract.Contract);
                                        D        : DATE): SCAL[2];
  VAR
   Result: SCAL[2];
 BEGIN
  SAVE(Contract);
  SEARCH(Contract, Contract, , _Contract);
  Result:=P_MyFirm.IsUSNO(P_MyFirm.GetTaxationMode(Contract.MyFirm, D));
  RESTORE(Contract);
  RETURN Result;
 END {IsUSNOMyFirmContract};

 PRIVATE PROCEDURE DoSpecialVATMDoc(_Contract: LIKE(Contract.Contract); D: DATE): SCAL[2];
 BEGIN
  RETURN (P_Cntr.GetSpecialAttitudeToVAT(_Contract, D) = P_Cntr.satVAT_woFeatures) |
         IsUSNOMyFirmContract(_Contract, D);
 END {DoSpecialVATMDoc};

 PUBLIC PROCEDURE ConvPer2VATClcPer(P: DATE): DATE;
 BEGIN
  IF P >= 01\01\2008 THEN
   RETURN PackDATE(1, L_DatTim.QUARTAL(P)*3, L_DatTim.YEAR(P));
  ELSE
   RETURN P;
  END;
 END {ConvPer2VATClcPer};

 PUBLIC PROCEDURE GetVATClcPerLastDay(P: DATE): DATE;
  VAR
   vcp: DATE;
 BEGIN
  vcp:=ConvPer2VATClcPer(P);
  WHILE ConvPer2VATClcPer(P) = vcp DO
   P:=L_DatTim.IncMonth(P, +1);
  END;
  RETURN P-1;
 END {GetVATClcPerLastDay};

 PUBLIC PROCEDURE SpecialVATMDocClcPer(D: DATE): DATE;
  VAR
   D_CP,
   S_CP: DATE;
 BEGIN
  RETURN ConvPer2VATClcPer(L_DatTim.Per(D));
(*
  D_CP:=ConvPer2VATClcPer(D);
  S_CP:=ConvPer2VATClcPer(L_APtm.ANYSystem_ClcPer(L_APtm.system_VAT));
  IF D_CP >= S_CP THEN
   RETURN D_CP;
  ELSE
   RETURN S_CP;
  END;
*)
(*
  IF L_General.IsOurEngineeringCopy() THEN
   RETURN 01\01\2008;
  ELSE
   RETURN ConvPer2VATClcPer(L_DatTim.Per(D));
  END;
*)
 END {SpecialVATMDocClcPer};

 PRIVATE PROCEDURE bsvmd_IsTrgMDoc(Stage      : tStageOfBuildingVATMDoc;
                                   D          : DATE;
                                   byContract : LIKE(Contract.Contract)): SCAL[2];
 BEGIN
  RETURN IsVATMDocKind(MDoc.MDocKind) & (MDoc.Status # L_MDoc.st_Canceled) &
         (E_StageOfBuildingVATMDoc(D, MDoc.MDocKind, MDoc.Dest) = Stage) &
         (!byContract | (MDoc.Contract = byContract)) & !converterVATMDocBuildMode;
 END {bsvmd_IsTrgMDoc};

 PRIVATE PROCEDURE bsvmd_PutMDocList();
 BEGIN
  ADD(BSVMD, BSVMD, , MDoc.MDocKind, MDoc.Dest, MDocList.Math, MDocList.VATMode,
      BSVMD.Netto, MDocList.Sum,
      BSVMD.VAT,   MDocList.VAT);
 END {bsvmd_PutMDocList};

 PRIVATE PROCEDURE bsvmd_MakeReverseMDoc(): L_XDoc.tXDocId;
  VAR
   bXDocId,
   Result : L_XDoc.tXDocId;
 BEGIN
  bXDocId:=MDoc.XDocId;
  SAVE(MDoc);
  CONFORM(MDoc, MDocList);
  SETEMPTY(MDoc.MDoc, MDoc.mfNbr, MDoc.SrcNbr);
  MDoc.MyFirm:=P_Firm.mf_Fict;
  MDoc.Total:=(-1) * MDoc.Total;
  MDoc.WFPeriod:=SpecialVATMDocClcPer(MDoc.Date);
  L_MDoc.Insert_MDoc();
  SELECT(XDocRef, bXDocId, , bXDocId);
  WHILE OCCURE(XDocRef) DO
   SAVE(XDocRef);
   XDocRef.bXDocId:=L_XDoc.curXDocId(L_XDoc.xdt_MDoc);
   INSERT(XDocRef);
   RESTORE(XDocRef);
   NEXT(XDocRef);
  END; (* WHILE OCCURE(XDocRef) *)
  WHILE OCCURE(MDocList) DO
   SAVE(MDocList);
   MDocList.MDocKind:=MDoc.MDocKind;
   MDocList.MDoc    :=MDoc.MDoc;
   MDocList.Sum     :=(-1) * MDocList.Sum;
   MDocList.Qnt     :=(-1) * MDocList.Qnt;
   MDocList.VAT     :=(-1) * MDocList.VAT;
   INSERT(MDocList);
   bsvmd_PutMDocList();
   RESTORE(MDocList);
   NEXT(MDocList);
  END;
  L_MDoc.MDoc_OnAnyModification(+1, 0, 0);
  Result:=L_XDoc.curXDocId(L_XDoc.xdt_MDoc);
  L_XDoc.rf_coreInsert(Result, bXDocId, L_XDoc.rft_Reverse);
  RESTORE(MDoc);
  RETURN Result;
 END {bsvmd_MakeReverseMDoc};

 PRIVATE PROCEDURE bsvmd_Prepare(Stage      : tStageOfBuildingVATMDoc;
                                 D          : DATE;
                                 baseDocT   : L_XDoc.tXDocType;
                                 baseDocKind: L_XDoc.tXDocKind;
                                 baseDoc    : L_XDoc.tXDoc;
                                 byContract : LIKE(Contract.Contract);
                                 CheckOnly  : SCAL[2]): STRING[];
  VAR
   DependentMDocs: L_XDoc.tXDocCollection;
   i             : NUMERIC[0];
   Result        : STRING[];
 BEGIN
  Result:="";
  IF ~CheckOnly THEN
   TRY
    L_General.DisableDebuggerExceptionBreak();
    L_AFM.AF_PurgeTemp("BSVMD");
   EXCEPT
   ELSE
   END;
   L_AFM.MakeMultipleIndex("BSVMD", "MDocKind: LIKE(MDocKind.MDocKind);"+
                                    "Dest    : LIKE(Dest.Dest);"+
                                    "Math    : LIKE(Math.Math);"+
                                    "VATMode : LIKE(MDocList.VATMode);"+
                                    "Netto   : NUMERIC[2];"+
                                    "VAT     : NUMERIC[2]",
                           "BSVMD: MDocKind, Dest, Math, VATMode");
  END;
  SAVE(MDoc);
  i:=0;
  DependentMDocs:=L_XDoc.GetDependentXDC(L_XDoc.XDocId(baseDocT, baseDocKind, baseDoc), L_XDoc.xdt_MDoc);
  WHILE L_XDoc.xdc_PositionOn(DependentMDocs, i) DO
   IF bsvmd_IsTrgMDoc(Stage, D, byContract) THEN
    IF MDoc.WFPeriod >= SpecialVATMDocClcPer(MDoc.Date) THEN
     L_General.Error("樠 㬥    㦥 ନ஢");
    ELSIF ~CheckOnly THEN
     IF ~L_XDoc.IsInReversedPair(L_XDoc.curXDocId(L_XDoc.xdt_MDoc)) THEN
      Result:=Result + bsvmd_MakeReverseMDoc() + "|";
     END;
    END;
   END;
   INC(i);
  END; (* WHILE L_XDoc.xdc_PositionOn ... *)
  RESTORE(MDoc);
  RETURN Result;
 END {bsvmd_Prepare};

 PRIVATE PROCEDURE bsvmd_HasNoChanges(): SCAL[2];
 BEGIN
  SELECT(BSVMD, BSVMD);
  WHILE OCCURE(BSVMD) DO
   IF (BSVMD.Netto # 0) | (BSVMD.VAT # 0) THEN
    RETURN 0;
   END;
   NEXT(BSVMD);
  END; (* WHILE OCCURE(BSVMD) ... *)
  RETURN 1;
 END {bsvmd_HasNoChanges};

 PUBLIC PROCEDURE VATMDocsAlreadyBuilt(Stage      : tStageOfBuildingVATMDoc;
                                       D          : DATE;
                                       baseDocT   : L_XDoc.tXDocType;
                                       baseDocKind: L_XDoc.tXDocKind;
                                       baseDoc    : L_XDoc.tXDoc;
                                       byContract : LIKE(Contract.Contract)): SCAL[2];
  VAR
   Dummy: STRING[];
 BEGIN
  TRY
   L_General.DisableDebuggerExceptionBreak();
   Dummy:=bsvmd_Prepare(Stage, D, baseDocT, baseDocKind, baseDoc, byContract, 1);
   RETURN 0;
  EXCEPT
  ON Exc:Exc_Raise DO
   RETURN 1;
  END;
 END {VATMDocsAlreadyBuilt};

 PUBLIC PROCEDURE IsAcptToVATMDocList(): SCAL[2];
 BEGIN
  RETURN (MDocList.MMode # L_MathR.mm_TransactionObject) &
         (MDocList.MMode # L_MathR.mm_TrnObjectGadget  ) &
         (MDocList.MMode # L_MathR.mm_UsedMaterial     ) &
         (MDocList.MMode # L_MathR.mm_TradeIn          ) &
         (MDocList.MMode # L_MathR.mm_MnfctOper        );
 END {IsAcptToVATMDocList};

 PRIVATE PROCEDURE CopyMDocListPro(trgProperty: LIKE(Property.Property);
                                   trgMDocId  : STRING[];
                                   trgPropRow : LIKE(MDocPro.PropRow));
  VAR
   trgMDocKind: LIKE(MDocKind.MDocKind);
   trgMDoc    : LIKE(MDoc.MDoc);
 BEGIN
  IF SELECT(MDocPro, MDoc, MDocList.MDocKind, MDocList.MDoc, trgProperty, MDocList.MDLNbr) THEN
   L_MDoc.DecodeMDocId(trgMDocId, trgMDocKind, trgMDoc);
   P_MDoc.extSetMDocPro(trgMDocKind, trgMDoc, trgProperty, trgPropRow, MDocPro.Value);
  END;
 END {CopyMDocListPro};

 PRIVATE PROCEDURE CopyMDocPro(trgProperty: LIKE(Property.Property); trgMDocId: STRING[]);
  VAR
   trgMDocKind: LIKE(MDocKind.MDocKind);
   trgMDoc    : LIKE(MDoc.MDoc);
 BEGIN
  IF SELECT(MDocPro, MDoc, MDoc.MDocKind, MDoc.MDoc, trgProperty) THEN
   L_MDoc.DecodeMDocId(trgMDocId, trgMDocKind, trgMDoc);
   P_MDoc.SetMDocPro(trgMDocKind, trgMDoc, trgProperty, MDocPro.Value);
  END;
 END {CopyMDocPro};

 PRIVATE PROCEDURE _Generate_VATMDoc(Stage      : tStageOfBuildingVATMDoc;
                                     BuildMode  : tVATMDocBuildMode;
                                     baseDocType: L_XDoc.tXDocType;
                                     _Netto,
                                     _VAT       : NUMERIC[2];
                                     NettobyRate: tValuesByVATRate): STRING[];
  CONST
   relXDocAmount = 1000;
  VAR
   gnrtMDocKind   : LIKE(MDoc.MDocKind);
   gnrtDest       : LIKE(MDoc.Dest);
   baseDocKind    : L_XDoc.tXDocKind;
   baseDoc        : L_XDoc.tXDoc;
   baseDate       : LIKE(MDoc.Date);
   baseSrcDate    : LIKE(MDoc.SrcDate);
   baseDest       : LIKE(MDoc.Dest);
   baseTSN        : LIKE(Staff.TSN);
   _Math          : LIKE(Math.Math);
   _Amn           : NUMERIC[2];
   _VATMode       : LIKE(MDocList.VATMode);
   genMDocId      : L_XDoc.tXDocId;
   relXDocId      : L_XDoc.tXDocId[relXDocAmount];
   relXDocValue   : NUMERIC[2]    [relXDocAmount * RANGEOF(tValuesToBalance)];
   gmdCount       : NUMERIC[0];
   relatedBM      : tVATMDocBuildMode;
   Result         : STRING[];
   NeedCondenseMDL: SCAL[2];
   DependentMDocs : L_XDoc.tXDocCollection;
   i              : NUMERIC[0];
   genMDLNbr      : LIKE(MDocList.MDLNbr);
 BEGIN
  SETEMPTY(Result);
IF ~!converterVATMDocBuildMode & (converterVATMDocBuildMode # BuildMode) THEN
RETURN Result;
END;
  CONFORM(Contract, Firm);
  IF baseDocType = L_XDoc.xdt_MDoc THEN
   L_MDoc.CheckPassed();
   baseDocKind:=MDoc.MDocKind;
   baseDoc    :=MDoc.MDoc;
   baseDate   :=MDoc.Date;
   baseDest   :=MDoc.Dest;
   baseTSN    :=MDoc.TSN;
   IF BuildMode = vmdbm_Acceptance THEN
    baseSrcDate:=MDoc.SrcDate;
   ELSE
    baseSrcDate:=baseDate;
   END;
  ELSIF baseDocType = L_XDoc.xdt_PDoc THEN
   L_PDoc.CheckPassed();
   baseDocKind:=PDoc.PDocKind;
   baseDoc    :=PDoc.PDoc;
   baseDate   :=PDoc.Date;
   baseSrcDate:=baseDate;
   SAVE(PDocMDoc);
   SELECT(PDocMDoc, PDoc, , PDoc.PDocKind, PDoc.PDoc);
   LOOP
    IF ~OCCURE(PDocMDoc) THEN
     L_General.CallUs(0);
    ELSIF PDocMDoc.Contract = Contract.Contract THEN
     SAVE(MDoc);
     CONFORM(PDocMDoc, MDoc);
     baseTSN:=MDoc.TSN;
     RESTORE(MDoc);
     EXIT;
    END;
    NEXT(PDocMDoc);
   END; (* LOOP *)
   RESTORE(PDocMDoc);
  ELSE
   L_General.CallUs(0);
  END;
  gnrtMDocKind:=E_GetVATMDocMDocKind(baseDate, BuildMode);
  IF BuildMode#vmdbm_Acceptance THEN
   gnrtDest:=E_GetVATMDocDest(baseDate, BuildMode);
  ELSE
   gnrtDest:=baseDest;
  END;
  IF ~!gnrtMDocKind & (E_StageOfBuildingVATMDoc(baseDate, gnrtMDocKind, gnrtDest) = Stage) THEN
   gmdCount:=0;
   relatedBM:=vmdbm_GetRelatedBM(BuildMode);
   IF ~!relatedBM THEN
    GetRelatedVATMDocCollection(Contract.Contract,
                                baseDate,
                                relatedBM,
                                BuildMode,
                                vtbConv(gnrtMDocKind, _Netto+_VAT, _VAT, 0),
                                relXDocId, relXDocValue);
   ELSE
    SETEMPTY(relXDocId);
   END;
   SAVE(MDoc);
   REPEAT
    TRY
     IF ~!relXDocId[gmdCount] THEN
      _Netto:=relXDocValue[vtb_Netto + gmdCount*RANGEOF(tValuesToBalance)];
      _VAT  :=relXDocValue[vtb_VAT   + gmdCount*RANGEOF(tValuesToBalance)];
     END;
     L_General.CLEAR("MDoc");
     IF Stage = sbvmd_Offline THEN
      i:=0;
      DependentMDocs:=L_XDoc.GetDependentXDC(L_XDoc.XDocId(baseDocType, baseDocKind, baseDoc), L_XDoc.xdt_MDoc);
      LOOP
       IF L_XDoc.xdc_PositionOn(DependentMDocs, i) THEN
        IF (MDoc.MDocKind = gnrtMDocKind) &
           (MDoc.Status = L_MDoc.st_Canceled) &
           L_XDoc.XDoc_wo_Handicraft(L_XDoc.xdt_MDoc, MDoc.MDocKind, MDoc.MDoc) THEN
         EXIT;
        END;
       ELSE
        L_General.CLEAR("MDoc");
        EXIT
       END;
       INC(i);
      END; (* LOOP  ... *)
     END; (* IF Stage = sbvmd_Offline *)
     IF OCCURE(MDoc) THEN
      L_MDoc.MDoc_OnAnyModification(-1, 1, 1);
      MDoc.Date:=baseDate;
      REPLACE(MDoc);
      L_XDoc.XDocJrn_Mark(L_XDoc.xdt_MDoc, MDoc.MDocKind, MDoc.MDoc, L_XDoc.action_AutoEdit);
      L_XDoc.rf_Clear(L_XDoc.xdt_MDoc);
      SELECT(MDocList, MDoc, , MDoc.MDocKind, MDoc.MDoc);
      WHILE OCCURE(MDocList) DO
       REMOVE(MDocList);
      END; (* WHILE OCCURE(MDocList) ... *)
     ELSE
      DEFAULT(MDoc);
      MDoc.MDocKind:=gnrtMDocKind;
      MDoc.Date    :=baseDate;
      L_MDoc.Insert_MDoc();
     END;
     CONFORM(MDoc, MDocKind); (* ? *)
     IF L_MDoc.IsOutgoingMDocKind(MDoc.MDocKind) THEN
      MDoc.SrcDate  :=MDoc.Date;
     ELSE
      MDoc.SrcDate  :=baseSrcDate;
     END;
     MDoc.WFPeriod:=SpecialVATMDocClcPer(MDoc.Date);
     MDoc.PayDate :=MDoc.Date;
     MDoc.TSN     :=baseTSN;
     MDoc.Status  :=L_MDoc.st_Passed;
     MDoc.Firm    :=Firm.Firm;
     MDoc.Contract:=Contract.Contract;
     MDoc.Dest    :=gnrtDest;
     MDoc.Alower  :=L_MDoc.E_DefaultAlower(MDoc.Date);
     MDoc.CopyCnt :=0;
     MDoc.Done    :=0;
     MDoc.Total   :=0;
     REPLACE(MDoc);
     genMDocId:=L_XDoc.XDocId(L_XDoc.xdt_MDoc, MDoc.MDocKind, MDoc.MDoc);
     IF BuildMode = vmdbm_Acceptance THEN
      SETZERO(_Netto, _Amn, _VAT);
      _Math:=P_Cntr.GetCntrProSoft(Contract.Contract, MDoc.Date, P_Cntr.P_SingleMath);
      NeedCondenseMDL:=NeedCondenseSingleMathMDocList(_Math, Contract.Contract);
      SELECT(MDocList, MDoc, , baseDocKind, baseDoc);
      WHILE OCCURE(MDocList) DO
       IF ~NeedCondenseMDL THEN
        IF IsAcptToVATMDocList() THEN
         SAVE(MDocList);
         L_MDoc.extInsMDocList(MDocList.Math, MDocList.MMode, MDocList.VATMode, MDocList.MUNbr,
                               MDocList.Qnt, MDocList.Sum, MDocList.VAT);
         genMDLNbr:=MDocList.MDLNbr;
         RESTORE(MDocList);
         CopyMDocListPro(P_MDoc.P_AddMDLNames, genMDocId, genMDLNbr);
        ELSE
         L_General.Assert((MDocList.Sum = 0) & (MDocList.VAT = 0),
                          "ப   ᯥ᪨ ० (" + L_MathR.MModeStr(MDocList.MMode) + ") ᮤন" +
                          "|" +
                          "㫥 㬬  / ");
        END;
       ELSE
        _VATMode:=MDocList.VATMode;
       END;
       INC(_Netto, MDocList.Sum);
       INC(_Amn, MDocList.Qnt);
       INC(_VAT, MDocList.VAT);
       NEXT(MDocList);
      END; (* WHILE OCCURE(MDocList) ... *)
     ELSIF (BuildMode = vmdbm_PrchUndpay) & (baseDocType = L_XDoc.xdt_MDoc) THEN
      _Math:=P_Cntr.GetCntrProSoft(Contract.Contract, MDoc.Date, P_Cntr.P_SingleMath);
      NeedCondenseMDL:=NeedCondenseSingleMathMDocList(_Math, Contract.Contract);
      IF ~NeedCondenseMDL THEN
       GenerateProportionalMDoc(baseDocKind, baseDoc, _Netto, _VAT);
      ELSE
       _Amn:=1;
       SELECT(MDocList, MDoc, , baseDocKind, baseDoc);
       _VATMode:=MDocList.VATMode;
      END;
     ELSE
      _Math:=E_Pmnt.MathForPayment(MDoc.Date);
      _Amn:=1;
      SETEMPTY(_VATMode);
      NeedCondenseMDL:=~!_Math;
     END;
     IF NeedCondenseMDL THEN
      GenerateVATMDocByVATRates(_Math, _Netto, _VAT, _Amn, _VATMode, NettobyRate);
     END;
     IF ~!relXDocId[gmdCount] THEN
      L_XDoc.rf_coreInsert(genMDocId,
                           relXDocId[gmdCount],
                           L_XDoc.rft_wRelTo);
      MDoc.Closed:=SYSDATE();
      REPLACE(MDoc);
     ELSIF ~SELECT(MDocList, MDoc, MDoc.MDocKind, MDoc.MDoc) |
           ((_VAT = 0) & ~DoSpecialVATMDoc(Contract.Contract, MDoc.Date)) THEN
      L_General.RaiseLockReleaseException();
     END;
     CheckOrder();
     SELECT(MDocList, MDoc, , MDoc.MDocKind, MDoc.MDoc);
     WHILE OCCURE(MDocList) DO
      bsvmd_PutMDocList();
      NEXT(MDocList);
     END; (* WHILE OCCURE(MDocList) ... *)
     L_XDoc.rf_coreInsert(genMDocId,
                          L_XDoc.XDocId(baseDocType, baseDocKind, baseDoc),
                          L_XDoc.rft_BaseOn);
     FillMDocListCstDclr(1);
     L_MDoc.MDoc_OnAnyModification(+1, 0, 0);
     Result:=Result+"|"+genMDocId;
    EXCEPT
    ON Exc: Exc_Root DO
     L_General.CheckIsLockReleaseException(Exc);
    END;
    INC(gmdCount);
   UNTIL !relXDocId[gmdCount];
   RESTORE(MDoc);
  END;
  RETURN Result;
 END {_Generate_VATMDoc};

 PUBLIC PROCEDURE ConfirmRemovingDocs(Silent: SCAL[2]; asStrList: STRING[]);
 BEGIN
  IF ~Silent THEN
   L_General.Assert(~!asStrList, " 㬥⮢  㤠");
   L_StdFrm.Choice(" 㤠 㬥:" + asStrList);
  END;
 END {ConfirmRemovingDocs};

 PRIVATE CONST
  ag_Complete     = 0;
  ag_ModPossible  = 1;
  ag_ModNecessary = 2;

 PRIVATE PROCEDURE GetGeneratedDocGroup(trgXDocId: L_XDoc.tXDocId; VAR trgGroup: SCAL[3]);
  VAR
   curXDocKindId: L_XDoc.tXDocKindId;
   curGroup     : SCAL[3];
 BEGIN
  curXDocKindId:=L_XDoc.ExtractXDocKindId(trgXDocId);
  IF (curXDocKindId = L_XDoc.XDocKindId(L_XDoc.xdt_MDoc, L_MDoc.md_VSF)) |
     (curXDocKindId = L_XDoc.XDocKindId(L_XDoc.xdt_PDoc, L_PDoc.pd_AVO)) THEN
   curGroup:=ag_ModNecessary;
  ELSE
   curGroup:=ag_Complete;
  END;
  IF !trgGroup | (trgGroup < curGroup) THEN
   trgGroup:=curGroup;
  END;
 END {GetGeneratedDocGroup};

 PRIVATE PROCEDURE cgd_Proceed(XDocIds: L_XDoc.tXDocCollection);
  VAR
   i        : NUMERIC[0];
   _XDocType: L_XDoc.tXDocType;
 BEGIN
  SAVE(MDoc);
  SAVE(PDoc);
  i:=0;
  WHILE L_XDoc.xdc_PositionOn(XDocIds, i) DO
   _XDocType:=L_XDoc.ExtractXDocType(L_XDoc.xdc_Item(XDocIds, i));
   IF    _XDocType = L_XDoc.xdt_MDoc THEN
    CALL(MDoc.StreamMakeDone());
   ELSIF _XDocType = L_XDoc.xdt_PDoc THEN
    CALL(PDoc.StreamMakeDone());
   ELSE
    L_General.CallUs(0);
   END;
   INC(i);
  END; (* WHILE L_XDoc.xdc_PositionOn ... *)
  RESTORE(PDoc);
  RESTORE(MDoc);
 END {cgd_Proceed};

 PUBLIC PROCEDURE ConfirmGeneratedDocs(Silent: SCAL[2]; XDocIds: L_XDoc.tXDocCollection);
  VAR
   ch_Proceed,
   ch_Ok,
   ch_Edit  : SCAL[10];
   trgGroup : SCAL[3];
   CountXDI,
   Choice,
   i        : NUMERIC[0];
   AddBtnsBlank,
   AddBtnsPoolIns,
   Blank,
   PoolIns: STRING[];
 BEGIN
  IF ~Silent THEN
   CountXDI:=L_XDoc.xdc_Count(XDocIds);
   IF CountXDI=0 THEN
    L_StdFrm.BlueHalt(" 室  ନ஢ 㬥⮢");
   END;

   SETEMPTY(trgGroup, PoolIns);
   Blank:=L_XDoc.ConvertXDocIdsToAsStrList(XDocIds) + "|";
   i    :=0;
   WHILE i < CountXDI DO
    GetGeneratedDocGroup(L_XDoc.xdc_Item(XDocIds, i), trgGroup);
    INC(i);
   END;

   ch_Ok:=1;
   IF trgGroup = ag_ModNecessary THEN
    SETEMPTY(AddBtnsPoolIns, AddBtnsBlank);
    ch_Proceed:=EMPTYOF(ch_Proceed);
    ch_Edit   :=2;
   ELSE
    AddBtnsPoolIns:="%C< 믮  ࠡ >B";
    AddBtnsBlank  :="%########################%";
    ch_Proceed:=2;
    ch_Edit   :=3;
   END;

   IF i = 1 THEN
    Blank:="|" + "㤥 ନ஢ 㬥:" + "|" + Blank;
    INC(AddBtnsPoolIns, "%C< 믮  ३  䨪樨 >B");
    INC(AddBtnsBlank,   "%###################################%");
   ELSE;
    Blank:="|" + " ନ஢ 㬥:" + "|" + Blank;
   END;
   Choice:=STDFORM(L_StdFrm.sf_Choice_wAddBtns(Blank, PoolIns, AddBtnsBlank, AddBtnsPoolIns),
                   "",
                   CHOICE);

   IF    Choice = ch_Proceed THEN
    cgd_Proceed(XDocIds);
   ELSIF Choice = ch_Edit THEN
    L_XDoc.PositionInVideoSystem(L_XDoc.pm_GoToEdit, L_XDoc.xdc_Item(XDocIds, 0), "")
   END; (* IF Choice ... *)
  ELSE
   cgd_Proceed(XDocIds);
  END; (* IF Silent *)
 END {ConfirmGeneratedDocs};

 PRIVATE PROCEDURE IsMDoc_wVAT(): SCAL[2];
  VAR
   Dummy: tValuesToBalance;
 BEGIN
  IF L_MDoc.CalculateVAT() # L_MDoc.cvat_Impossible THEN
   RETURN 1;
  ELSE
   Dummy:=GetMDocAcpt();
   L_General.Assert(Dummy[vtb_VAT] = 0, " ᮤন 㫥  - ⨬");
   RETURN 0;
  END;
 END {IsMDoc_wVAT};

 PRIVATE PROCEDURE DoAcceptanceVATMDoc(Backflow: tBackflowType; Stage: tStageOfBuildingVATMDoc): SCAL[2];
  VAR
   cab     : DATE;
   _XObject: LIKE(XObject.XObject);
 BEGIN
  IF (Backflow # bf_DebtAmortization) & (Backflow # bf_CredAmortization) & IsMDoc_wVAT() THEN
   cab:=GetContractAccountingBegin(MDoc.Contract);
   IF MDoc.Date < cab THEN
    IF Stage = sbvmd_Online THEN
     SAVE(Contract);
     CONFORM(MDoc, Contract);
     _XObject:=Contract.XObject;
     RESTORE(Contract);
     RETURN ~IsEntranceMDoc(_XObject, cab);
    ELSE
     RETURN 0;
    END;
   ELSE
    RETURN 1;
   END;
  ELSE
   RETURN 0;
  END;
 END {DoAcceptanceVATMDoc};

 PRIVATE PROCEDURE E_DoSpecialVATMDocByMDoc(): SCAL[2];
 BEGIN
  RETURN (IsMDoc_wVAT() | DoSpecialVATMDoc(MDoc.Contract, MDoc.Date)) &
         (P_MDoc.DoSpecVATMDoc(MDoc.MDocKind, MDoc.MDoc) = P_MDoc.dsvmd_Auto) &
         TakeMDocIntoAccount();
 END {E_DoSpecialVATMDocByMDoc};

 PRIVATE PROCEDURE bvmd_ContractHasUnalteredBalance(trgContract: LIKE(Contract.Contract); D: DATE): SCAL[2];
  VAR
   Res1,
   Res2      : tValuesToBalance;
   trgXObject: LIKE(XObject.XObject);
   cab       : DATE;
 BEGIN
  trgXObject:=getContract_XObject(trgContract);
  cab:=GetContractAccountingBegin(trgContract);
  IF cab = D THEN (*⮬   cab 뢠  㬥 㯨⥫쭮 ᠫ줮*)
   Res1:=xob_intGet(0, trgXObject, bht_Contract, cab, D, vtb_ZeroValue(), D,
                    L_XDoc.min_DoneDTS, L_XDoc.min_DoneDTS);
  ELSE
   SETZERO(Res1);
  END;
  Res2:=xob_intGet(0, trgXObject, bht_Contract, cab, D, vtb_ZeroValue(), D,
                   L_XDoc.max_DoneDTS, L_XDoc.max_DoneDTS);
  RETURN (Res1[vtb_Total] = Res2[vtb_Total]);
 END {bvmd_ContractHasUnalteredBalance};

 PRIVATE PROCEDURE bvmd_GetBalanceAlteration(oBal: NUMERIC[2];
                                             Alt : tValuesToBalance;
                                             VAR
                                              pInc,
                                              nInc: tValuesToBalance);
  VAR
   nBal: NUMERIC[2];
 BEGIN
  nBal:=oBal + Alt[vtb_Total];
  IF    nBal < 0 THEN
   IF oBal > 0 THEN
    pInc:=vtbInv(vtbCnv(oBal, 0));
    nInc:=vtbCnv(nBal, nBal/Alt[vtb_Total] * Alt[vtb_VAT]);
   ELSE
    pInc:=vtb_ZeroValue();
    nInc:=Alt;
   END;
  ELSE
   IF oBal < 0 THEN
    pInc:=vtbCnv(nBal, nBal/Alt[vtb_Total] * Alt[vtb_VAT]);
    nInc:=vtbInv(vtbCnv(oBal, 0));
   ELSE
    pInc:=Alt;
    nInc:=vtb_ZeroValue();
   END;
  END;
 END {bvmd_GetBalanceAlteration};

 PRIVATE PROCEDURE DefineMDocBackflow(): tBackflowType;
  VAR
   Result: tBackflowType;
 BEGIN
  Result:=bf_None;
  IF ~!MDoc.Contract THEN
   CONFORM(MDoc, Contract);
   IF    MDoc.Dest = L_Dest.erkn_GetSoft(MDoc.Date, L_Dest.erkn_DebtAmortization) THEN
    Result:=bf_DebtAmortization;
   ELSIF MDoc.Dest = L_Dest.erkn_GetSoft(MDoc.Date, L_Dest.erkn_CredAmortization) THEN
    Result:=bf_CredAmortization;
   ELSIF ((Contract.Type = L_Cntr.ct_Sell) # E_IsSellMDoc()) | (vtbExtractTotal(GetMDocAcpt()) < 0) THEN
    Result:=bf_MathReturn;
   END;
  END;
  RETURN Result;
 END {DefineMDocBackflow};

 PRIVATE VAR
  novatmd: SCAL[2];

 PRIVATE PROCEDURE intNeedOnlineVATMDoc();
  VAR
   genMDocList: STRING[];
 BEGIN
  novatmd:=0;
  L_XDoc.TransactionMustBeRollback:=1;
  TRY
   CONFORM(MDoc, Contract);
   genMDocList:=bsvmd_Prepare(sbvmd_Online, MDoc.Date, L_XDoc.xdt_MDoc, MDoc.MDocKind, MDoc.MDoc, EMPTYOF(Contract.Contract), 0(*Stage = sbvmd_Online*));
   IF DoAcceptanceVATMDoc(DefineMDocBackflow(), sbvmd_Online) THEN
    novatmd:=~!_Generate_VATMDoc(sbvmd_Online, vmdbm_Acceptance, L_XDoc.xdt_MDoc, 0, 0, GetMDocNettobyRate());
   END;
   L_XDoc.TransactionMustBeRollback:=0;
  EXCEPT
  ON Exc: Exc_Root DO
   L_XDoc.TransactionMustBeRollback:=0;
   RAISE();
  END;
 END {intNeedOnlineVATMDoc};

 PUBLIC PROCEDURE NeedOnlineVATMDoc(): SCAL[2];
 BEGIN
  L_General.RidgeExecute("MDoc", PROCREF(intNeedOnlineVATMDoc), L_General.rem_Discard);
  RETURN novatmd;
 END {NeedOnlineVATMDoc};

 PRIVATE PROCEDURE CheckAcceptanceVATMDocAmount();
  VAR
   DependentMDocs: L_XDoc.tXDocCollection;
   i, Cnt        : NUMERIC[0];
 BEGIN
  IF P_MDoc.DoSpecVATMDoc(MDoc.MDocKind, MDoc.MDoc) = P_MDoc.dsvmd_Auto THEN
   SAVE(MDoc);
   SETZERO(i, Cnt);
   DependentMDocs:=L_MDoc.GetDependentMDocXDC();
   WHILE L_XDoc.xdc_PositionOn(DependentMDocs, i) DO
    INC(Cnt, IsSpecifiedVATMDoc(vmdbm_Acceptance));
    INC(i);
   END;
   IF Cnt > 1 THEN
    L_General.Error("  " + L_MDoc.MDocStr(MDoc.MDocKind, MDoc.MDoc) + " 㦥  -䠪| 㬥,  騩");
   END;
   RESTORE(MDoc);
  END;
 END {CheckAcceptanceVATMDocAmount};

 PUBLIC PROCEDURE Build_VATMDocs(Silent, Stage: tStageOfBuildingVATMDoc);
  VAR
   oBal,
   curAcpt,
   pInc,
   nInc           : tValuesToBalance;
   curNettobyRate : tValuesByVATRate;
   genMDocList    : STRING[];
   lastPDocDoneDTS: FLOAT;
   IsBackflow     : tBackflowType;
   BuildMode      : tVATMDocBuildMode;
 BEGIN
  PassMayGenerateMDocAcsPnt();
  L_General.Assert(IsAcptMDocKind(MDoc.MDocKind),
                   "㬥    ନ ⮫쪮  ᭮ ,|ࠦ ॠ");
  TRY
   SETEMPTY(BuildMode);
   genMDocList:=bsvmd_Prepare(Stage, MDoc.Date, L_XDoc.xdt_MDoc, MDoc.MDocKind, MDoc.MDoc, EMPTYOF(Contract.Contract), 0(*Stage = sbvmd_Online*));
   CONFORM(MDoc, Contract);
   IsBackflow:=DefineMDocBackflow();
   curNettobyRate:=GetMDocNettobyRate();
   IF DoAcceptanceVATMDoc(IsBackflow, Stage) THEN
    genMDocList:=genMDocList+"|"+
                 _Generate_VATMDoc(Stage, vmdbm_Acceptance, L_XDoc.xdt_MDoc,
                                   0, 0, curNettobyRate);
    CheckAcceptanceVATMDocAmount();
    BuildMode:=vmdbm_Acceptance;
   END;
   IF E_DoSpecialVATMDocByMDoc() THEN
    IF ~bvmd_ContractHasUnalteredBalance(MDoc.Contract, MDoc.Date) THEN
     IF Stage = sbvmd_Online THEN
      lastPDocDoneDTS:=L_XDoc.min_DoneDTS;
     ELSE
      lastPDocDoneDTS:=L_XDoc.max_DoneDTS;
     END;
     curAcpt:=GetMDocAcptBalance();
     oBal:=GetContractBalance(MDoc.Contract, MDoc.Date,
                              MDoc.DoneDTS,
                              lastPDocDoneDTS);
     bvmd_GetBalanceAlteration(oBal[vtb_Total], curAcpt, pInc, nInc);
     IF Contract.Type = L_Cntr.ct_Sell THEN
      IF (IsBackflow = bf_None) | (IsBackflow = bf_CredAmortization) THEN
       IF nInc[vtb_Total]>0 THEN
        genMDocList:=genMDocList+"|"+
                     _Generate_VATMDoc(Stage, vmdbm_OnPrpShpmt, L_XDoc.xdt_MDoc,
                                       nInc[vtb_Netto],
                                       nInc[vtb_VAT],
                                       curNettobyRate);
       END;
       IF pInc[vtb_Total]>0 THEN
        genMDocList:=genMDocList+"|"+
                     _Generate_VATMDoc(Stage, vmdbm_Underpay, L_XDoc.xdt_MDoc,
                                       pInc[vtb_Netto],
                                       pInc[vtb_VAT  ],
                                       curNettobyRate);
       END;
      ELSE
       IF pInc[vtb_Total]<0 THEN
        genMDocList:=genMDocList+"|"+
                     _Generate_VATMDoc(Stage, vmdbm_Pstpayment, L_XDoc.xdt_MDoc,
                                       -pInc[vtb_Netto],
                                       -pInc[vtb_VAT  ],
                                       curNettobyRate);
       END;
       IF IsBackflow = bf_MathReturn THEN
        IF nInc[vtb_Total]<0 THEN
         genMDocList:=genMDocList+"|"+
                      _Generate_VATMDoc(Stage, vmdbm_Prepayment, L_XDoc.xdt_MDoc,
                                        -nInc[vtb_Netto],
                                        -nInc[vtb_VAT  ],
                                        curNettobyRate);
        END;
       END;
      END; (* IF IsBackflow ... *)
     ELSE
      IF IsBackflow = bf_None THEN
       IF nInc[vtb_Total]<0 THEN
        genMDocList:=genMDocList+"|"+
                     _Generate_VATMDoc(Stage, vmdbm_PrchUndpay, L_XDoc.xdt_MDoc,
                                       -nInc[vtb_Netto],
                                       -nInc[vtb_VAT  ],
                                       curNettobyRate);
       END;
      ELSIF IsBackflow = bf_MathReturn THEN
       IF nInc[vtb_Total]>0 THEN
        genMDocList:=genMDocList+"|"+
                     _Generate_VATMDoc(Stage, vmdbm_PrchPstpay, L_XDoc.xdt_MDoc,
                                       nInc[vtb_Netto],
                                       nInc[vtb_VAT],
                                       curNettobyRate);
       END;
      END; (* IF IsBackflow ... *)
     END; (* IF Contract.Type ... *)
    END; (* IF ~bvmd_ContractHasUnalteredBalance ... *)
   END; (* IF E_DoSpecialVATMDocByMDoc ... *)
   IF bsvmd_HasNoChanges() & (BuildMode # vmdbm_Acceptance) THEN
    genMDocList:="";
    ConfirmGeneratedDocs(Silent, genMDocList);
    L_General.RaiseLockReleaseException();
   ELSE
    ConfirmGeneratedDocs(Silent, genMDocList);
   END;
  EXCEPT
  ON Exc: Exc_Root DO
   L_General.CheckIsLockReleaseException(Exc);
  END;
 END {Build_VATMDocs};

 PRIVATE PROCEDURE TransferCUCopies(_MDLNbr: LIKE(MDocList.MDLNbr));
  VAR
   _OpKind: L_CUC.tOpKind;
 BEGIN
  IF (MDocList.MMode = L_MathR.mm_TransactionObject) |
     (MDocList.MMode = L_MathR.mm_TrnObjectGadget) THEN
   _OpKind:=L_CUC.ok_Sale;
  ELSE
   _OpKind:=L_CUC.ok_Mentioning;
  END;
  CONFORM(MDocList, MDocLCU);
  WHILE OCCURE(MDocLCU) DO
   SAVE(MDocLCU);
   L_CUC.InsMDocLCU(MDocLCU.CUCopy, _MDLNbr, _OpKind);
   RESTORE(MDocLCU);
   NEXT(MDocLCU);
  END; (* WHILE OCCURE(MDocLCU) ... *)
 END {TransferCUCopies};

 PRIVATE PROCEDURE AppendAsAResultXDocs(baseMDocId: L_XDoc.tXDocId);
  CONST
   di_Nothing = 0;
   di_Sell    = 1;
   di_TradeIn = 2;
  VAR
   DoIt        : SCAL[3];
   aarXDC      : L_XDoc.tXDocCollection;
   i           : NUMERIC[0];
   _MMode      : LIKE(MDocList.MMode);
   _MDLNbr     : LIKE(MDocList.MDLNbr);
 BEGIN
  SAVE(MDoc);
  aarXDC:=L_XDoc.GetDependentXDC(baseMDocId, L_XDoc.xdt_MDoc);
  i:=0;
  WHILE L_XDoc.xdc_PositionOn(aarXDC, i) DO
   IF MDoc.Status # L_MDoc.st_Canceled THEN
    IF    MDoc.MDocKind = L_MDoc.md_TOV THEN
     DoIt:=di_Sell;
    ELSIF MDoc.MDocKind = L_MDoc.md_ViP THEN
     DoIt:=di_TradeIn;
    ELSE
     DoIt:=di_Nothing;
    END;
    IF DoIt # di_Nothing THEN
     L_General.Assert(MDoc.Status # L_MDoc.st_Prepared,
                      "易 㬥 室   '⮢'");
     CONFORM(MDoc, MDocList);
     RESTORE(MDoc);
     SAVE(MDoc);
     WHILE OCCURE(MDocList) DO
      SAVE(MDocList);
      IF DoIt = di_Sell THEN
       _MMode:=L_MathR.mm_UsedMaterial;
      ELSE
       _MMode:=L_MathR.mm_TradeIn;
      END;
      L_MDoc.InsMDocList(MDocList.Math, _MMode,
                         MDocList.VATMode,
                         MDocList.Qnt, 0, 0);
      _MDLNbr:=MDocList.MDLNbr;
      RESTORE(MDocList);
      TransferCUCopies(_MDLNbr);
      NEXT(MDocList);
     END; (* WHILE OCCURE(MDocList) ... *)
    END; (* IF DoIt # di_Nothing *)
   END; (* IF MDoc.Status # ... *)
   INC(i);
  END; (* WHILE L_XDoc.xdc_PositionOn *)
  RESTORE(MDoc);
 END {AppendAsAResultXDocs};

 PUBLIC PROCEDURE E_DefineMDocPayDate(): DATE;
  VAR
   default     : DATE;
   Local       : PROC;
   _PayDuration: NUMERIC[0];
 BEGIN
  IF ~!MDoc.SrcDate THEN
   default:=MDoc.SrcDate;
  ELSE
   default:=MDoc.Date;
  END;
  IF ~!MDoc.Contract & IsMayBePaidMDocKind(MDoc.MDocKind) THEN
   _PayDuration:=L_Prop.GetNumericValueFromStr(P_Cntr.GetCntrProSoft(MDoc.Contract, MDoc.SrcDate, P_Cntr.P_PaymentDay));
   IF !_PayDuration THEN
    _PayDuration:=5;
   END;
   default:=DateOfPerformanceOfLiability(default, _PayDuration);
  END;
  Local:=PROCREF(E_Pmnt.DefineMDocPayDate);
  IF ~!Local THEN
   RETURN Local(default);
  ELSE
   RETURN default;
  END;
 END {E_DefineMDocPayDate};

 PRIVATE PROCEDURE MakePartialShipmentIndex(Silent: SCAL[2]; trgMDocKind: LIKE(MDocKind.MDocKind));
  VAR
   DependentMDocs: L_XDoc.tXDocCollection;
   i             : NUMERIC[0];
 BEGIN
  IF ~Silent THEN
   IF (IsMayBePaidMDocKind(MDoc.MDocKind) & IsAcptMDocKind(trgMDocKind))   |
      (IsTransitiveMDoc(MDoc.MDocKind)    & IsAcptMDocKind(trgMDocKind))   |
      (IsMayBePaidMDocKind(MDoc.MDocKind) & IsTransitiveMDoc(trgMDocKind)) THEN
    SAVE(MDoc);
    DependentMDocs:=L_XDoc.GetDependentXDC(MDoc.XDocId, L_XDoc.xdt_MDoc);
    i:=0;
    WHILE L_XDoc.xdc_PositionOn(DependentMDocs, i) DO
     IF (MDoc.MDocKind = trgMDocKind) & (MDoc.Status # L_MDoc.st_Canceled) THEN
      CONFORM(MDoc, MDocList);
      WHILE OCCURE(MDocList) DO
       ADD(PrtSp, PrtSp, , MDocList.Math, MDocList.MMode, MDocList.VATMode, MDocList.MUNbr,
                           PrtSp.Sum, MDocList.Sum, PrtSp.Qnt, MDocList.Qnt, PrtSp.VAT, MDocList.VAT);
       NEXT(MDocList);
      END; (* WHILE OCCURE(MDocList) ... *)
     END;
     INC(i);
    END; (* L_XDoc.xdc_PositionOn ... *)
    RESTORE(MDoc);
    IF SELECT(PrtSp, PrtSp) THEN
     IF ~L_StdFrm.Alternative(" 㦥 ନ஢ "+L_MDoc.MDocKindNick(trgMDocKind, 1)+"   㧪?") THEN
      REMSEL(PrtSp);
     END;
    END;
   END;
  END; (* ~Silent *)
 END {MakePartialShipmentIndex};

 PRIVATE PROCEDURE CheckPartialShipmentOver(basXDocId: L_XDoc.tXDocId; genMDocKind: LIKE(MDoc.MDocKind));
  VAR
   Lst,
   VATModeStr: STRING[];
   n,
   dmy       : NUMERIC[0];
 BEGIN
  Lst:=""; n:=0;
  SELECT(PrtSp, PrtSp);
  WHILE OCCURE(PrtSp) DO
   IF (PrtSp.Sum # 0) | (PrtSp.Qnt # 0) | (PrtSp.VAT # 0) THEN
    SEARCH(Math, Math, , PrtSp.Math);
    SEARCH(MathUnit, Math, , PrtSp.Math, PrtSp.MUNbr);
    SEARCH(MMode, MMode, , PrtSp.MMode);
    IF ~!Lst THEN
     Lst:=Lst+L_Str.CRLF;
    END;
    IF ~!PrtSp.VATMode THEN
     VATModeStr:=L_Str.PoolItem(L_MDoc.vatm_Pool, PrtSp.VATMode);
    ELSE
     VATModeStr:="";
    END;
    Lst:=Lst+
         Math.Math+" "+Str.Align(Math.Name, 30, LEFT)+" "+Str.Align(MMode.Sign, 3, LEFT)+" "+
         FLDTOSTR(PrtSp.Sum, "2-", 12, "R")+" "+
         FLDTOSTR(PrtSp.Qnt, "3.", 10, "R")+" "+
         FLDTOSTR(PrtSp.VAT, "2-", 10, "R")+" "+
         Str.Align(VATModeStr, 13, LEFT);
    INC(n);
   END;
   NEXT(PrtSp);
  END; (* WHILE OCCURE(PrtSp) ... *)
  IF ~!Lst THEN
   IF n > 30 THEN
    n:=30;
   END;
   dmy:=-1;
   SETEMPTY(dmy);
   STDFORM(L_StdFrm.sf_Choice(" 㦥 ନ஢  筮 㧪  ப, 騥  室 "+L_XDoc.XDocStr(basXDocId)+":"+
                              "|"+
                              "|%#############################################################################################%"+
                              L_Str.Repeat("|", n)+
                              "|   ⥭  ନ஢ "+L_MDoc.MDocKindNick(genMDocKind, 1)+
                              L_StdFrm.HR()+
                              " ।⥫쭮 ਢ  冷 室 "+L_XDoc.XDocStr(basXDocId),
                              "%,"+L_Str.IntStr(n)+"NI"),
           ,
           CHOICE, , Lst);
  END;
 END {CheckPartialShipmentOver};


 PRIVATE PROCEDURE intGenerate_MDoc(dstMDocKind: LIKE(MDocKind.MDocKind); Silent, forcePassed: SCAL[2]): STRING[];
  VAR
   baseMDocKind  : LIKE(MDoc.MDocKind);
   baseMDoc      : LIKE(MDoc.MDoc);
   baseDate      : LIKE(MDoc.Date);
   baseSrcDate   : LIKE(MDoc.SrcDate);
   baseDest      : LIKE(MDoc.Dest);
   baseTSN       : LIKE(MDoc.TSN);
   baseMDocId,
   genMDocId     : L_XDoc.tXDocId;
   genMDLNbr     : LIKE(MDocList.MDLNbr);
   trgSum        : LIKE(MDocList.Sum);
   trgQnt        : LIKE(MDocList.Qnt);
   trgVAT        : LIKE(MDocList.VAT);
 BEGIN
  L_MDoc.CheckPassed();

  L_AFM.MakeMultipleIndex("PrtSp", "Math   : LIKE(Math.Math);"+
                                   "MMode  : LIKE(MDocList.MMode);"+
                                   "VATMode: LIKE(MDocList.VATMode);"+
                                   "MUNbr  : LIKE(MDocList.MUNbr);"+
                                   "Sum    : LIKE(MDocList.Sum);"+
                                   "Qnt    : LIKE(MDocList.Qnt);"+
                                   "VAT    : LIKE(MDocList.VAT)",
                          "PrtSp: Math, MMode, VATMode, MUNbr");
  MakePartialShipmentIndex(Silent, dstMDocKind);

  SAVE(MDoc);
  baseMDocKind:=MDoc.MDocKind;
  baseMDoc    :=MDoc.MDoc;
  baseMDocId  :=MDoc.XDocId;
  baseDate    :=MDoc.Date;
  baseSrcDate :=MDoc.SrcDate;
  baseDest    :=MDoc.Dest;
  baseTSN     :=MDoc.TSN;
  CONFORM(MDoc, Firm);
  CONFORM(MDoc, Contract);
  DEFAULT(MDoc);
  MDoc.MDocKind:=dstMDocKind;
  L_MDoc.Insert_MDoc();
  CONFORM(MDoc, MDocKind); (* ? *)
  IF forcePassed THEN
   MDoc.Date   :=baseDate;
   MDoc.SrcDate:=baseSrcDate;
   MDoc.TSN    :=baseTSN;
   MDoc.Status :=L_MDoc.st_Passed;
  ELSE
   MDoc.Date   :=SYSDATE();
   MDoc.SrcDate:=MDoc.Date;
   MDoc.TSN    :=L_Env.fictTSN;
   MDoc.Status :=L_MDoc.st_Prepared;
  END;
  MDoc.Firm    :=Firm.Firm;
  MDoc.Dest    :=baseDest;
  MDoc.Contract:=Contract.Contract;
  MDoc.PayDate :=E_DefineMDocPayDate();
  MDoc.CostItem:=L_MDoc.E_DefMDocCostItem();
  MDoc.Alower  :=L_MDoc.E_DefaultAlower(MDoc.Date);
  MDoc.CopyCnt :=0;
  MDoc.Done    :=0;
  MDoc.Total   :=0;
  REPLACE(MDoc);

  genMDocId:=L_XDoc.XDocId(L_XDoc.xdt_MDoc, MDoc.MDocKind, MDoc.MDoc);

  SELECT(MDocList, MDoc, , baseMDocKind, baseMDoc);
  WHILE OCCURE(MDocList) DO
   SAVE(MDocList);
   trgSum:=MDocList.Sum;
   trgQnt:=MDocList.Qnt;
   trgVAT:=MDocList.VAT;
   IF SEARCH(PrtSp, PrtSp, MDocList.Math, MDocList.MMode, MDocList.VATMode, MDocList.MUNbr) THEN
    DEC(trgSum, Math.Min(MDocList.Sum, PrtSp.Sum));   DEC(PrtSp.Sum, MDocList.Sum-trgSum);
    DEC(trgQnt, Math.Min(MDocList.Qnt, PrtSp.Qnt));   DEC(PrtSp.Qnt, MDocList.Qnt-trgQnt);
    DEC(trgVAT, Math.Min(MDocList.VAT, PrtSp.VAT));   DEC(PrtSp.VAT, MDocList.VAT-trgVAT);
    REPLACE(PrtSp);
   END;
   L_MDoc.extInsMDocList(MDocList.Math, MDocList.MMode, MDocList.VATMode, MDocList.MUNbr,
                         trgQnt, trgSum, trgVAT);
   genMDLNbr:=MDocList.MDLNbr;
   RESTORE(MDocList);
   CopyMDocListPro(P_MDoc.P_AddMDLNames, genMDocId, genMDLNbr);
   IF baseMDocKind = L_MDoc.md_ZNr THEN
    TransferCUCopies(genMDLNbr);
   END;
   NEXT(MDocList);
  END; (* WHILE OCCURE(MDocList) ... *)

  IF ~Silent THEN
   CheckPartialShipmentOver(baseMDocId, MDoc.MDocKind);
  END;

  IF baseMDocKind = L_MDoc.md_ZNr THEN
   AppendAsAResultXDocs(baseMDocId);
  END;
  IF ~SELECT(MDocList, MDoc, MDoc.MDocKind, MDoc.MDoc) THEN
   L_General.Error("ନ஢ 㬥  ॡ");
  END;
  FillMDocListCstDclr(1);
  L_MDoc.MDoc_OnAnyModification(+1, 0, 0);
  CheckOrder();
  RESTORE(MDoc);
  CopyMDocPro(P_MDoc.P_Note,         genMDocId);
  CopyMDocPro(P_MDoc.P_ServiceNote,  genMDocId);
  CopyMDocPro(P_MDoc.P_PartnerAgent, genMDocId);
  L_XDoc.rf_InsertParent(genMDocId, L_XDoc.xdt_MDoc, L_XDoc.rft_BaseOn);
  L_AFM.AF_PurgeTemp("PrtSp");
  RETURN genMDocId;
 END {intGenerate_MDoc};

 PUBLIC PROCEDURE extIsAcceptableAddMDocKind(curMDocKind, addMDocKind: LIKE(MDocKind.MDocKind)): SCAL[2];
 BEGIN
  IF    (addMDocKind = L_MDoc.md_FPr) |
        (addMDocKind = L_MDoc.md_FPk) THEN
   RETURN 0;
  ELSIF curMDocKind = L_MDoc.md_IsS THEN
   RETURN (addMDocKind = L_MDoc.md_Nrd) |
          L_MDoc.IsOutgoingMDocKind(addMDocKind) & IsAcptMDocKind(addMDocKind) & ~IsMayBePaidMDocKind(addMDocKind);
  ELSIF curMDocKind = L_MDoc.md_Nrd THEN
   RETURN (addMDocKind = L_MDoc.md_IAU) |
          L_MDoc.IsOutgoingMDocKind(addMDocKind) & IsAcptMDocKind(addMDocKind) & ~IsMayBePaidMDocKind(addMDocKind);
  ELSIF curMDocKind = L_MDoc.md_VhS THEN
   RETURN (addMDocKind = L_MDoc.md_Dvr) |
          L_MDoc.IsIngoingMDocKind(addMDocKind) & IsAcptMDocKind(addMDocKind) & ~IsMayBePaidMDocKind(addMDocKind);
  ELSIF curMDocKind = L_MDoc.md_Dvr THEN
   RETURN L_MDoc.IsIngoingMDocKind(addMDocKind) & IsAcptMDocKind(addMDocKind) & ~IsMayBePaidMDocKind(addMDocKind);
  ELSIF curMDocKind = L_MDoc.md_ZNr THEN
   RETURN (addMDocKind = L_MDoc.md_ISA) |
          (addMDocKind = L_MDoc.md_IsS) |
          (addMDocKind = L_MDoc.md_IAS);
  END;
  RETURN 0;
 END {extIsAcceptableAddMDocKind};

 PUBLIC PROCEDURE IsAcceptableAddMDocKind(addMDocKind: LIKE(MDocKind.MDocKind)): SCAL[2];
  VAR
   Result: SCAL[2];
 BEGIN
  Result:=extIsAcceptableAddMDocKind(MDoc.MDocKind, addMDocKind);
  IF ~Result THEN
   SAVE(Contract);
   CONFORM(MDoc, Contract);
   Result:=addMDocKind = E_GetVATMDocMDocKind(MDoc.Date, vmdbm_Acceptance);
   RESTORE(Contract);
  END;
  RETURN Result;
 END {IsAcceptableAddMDocKind};

 PUBLIC PROCEDURE GetAddMDocKind(Proc: PROC; Title: STRING[]): LIKE(MDocKind.MDocKind);
  CONST
   mdknLength = 32;
  VAR
   amdk: LIKE(MDocKind.MDocKind)[16];
   i   : NUMERIC[0];
   List: STRING[];
 BEGIN
  List:="";
  i:=0;
  SELECT(MDocKind, MDocKind);
  WHILE OCCURE(MDocKind) DO
   IF Proc(MDocKind.MDocKind) THEN
    amdk[i]:=MDocKind.MDocKind;
    List:=List + MDocKind.MDocKind + " "
               + Str.Align(MDocKind.SName, mdknLength, LEFT) + " ("
               + MDocKind.Sign + ")" + "|";
    INC(i);
   END;
   NEXT(MDocKind);
  END; (* WHILE OCCURE(MDocKind) ... *)
  L_General.Assert(i > 0,
                   " ।ᬮ७ 稥 ⥫쭮 㬥");
  IF i = 1 THEN
   i:=0;
  ELSE
   i:=L_StdFrm.ShowListAsMenu(List, Title);
  END;
  RETURN amdk[i];
 END {GetAddMDocKind};

 PUBLIC PROCEDURE extIsAcceptableAddPDocKind(curPDocKind: LIKE(PDocKind.PDocKind);
                                             curDest    : LIKE(PDoc.Dest);
                                             D          : DATE;
                                             addPDocKind: LIKE(PDocKind.PDocKind)): SCAL[2];
  VAR
   Result: SCAL[2];
 BEGIN
  IF    addPDocKind = L_PDoc.pd_AVO THEN
   IF (curPDocKind = L_PDoc.pd_RKO) | (curPDocKind = L_PDoc.pd_IPP) THEN
    RETURN !curDest | (curDest = L_Dest.erkn_GetSoft(D, L_Dest.erkn_SumPaidOutOnAccount));
   END;
  ELSIF curPDocKind = L_PDoc.pd_AVO THEN
   RETURN (addPDocKind = L_PDoc.pd_PKO) |
          (addPDocKind = L_PDoc.pd_RKO) |
          (addPDocKind = L_PDoc.pd_IPP) |
          (addPDocKind = L_PDoc.pd_VPP);
  ELSIF addPDocKind = L_PDoc.pd_OVN THEN
   IF curPDocKind = L_PDoc.pd_RKO THEN
    RETURN !curDest | (curDest = L_Dest.erkn_GetSoft(D, L_Dest.erkn_CashMovement));
   END;
  ELSIF curPDocKind = L_PDoc.pd_CND THEN
   RETURN (addPDocKind = L_PDoc.pd_PKO);
  END;
  RETURN 0;
 END {extIsAcceptableAddPDocKind};

 PUBLIC PROCEDURE IsAcceptableAddPDocKind(addPDocKind: LIKE(PDocKind.PDocKind)): SCAL[2];
 BEGIN
  RETURN extIsAcceptableAddPDocKind(PDoc.PDocKind, PDoc.Dest, PDoc.Date, addPDocKind);
 END {IsAcceptableAddPDocKind};

 PUBLIC PROCEDURE IsTransitiveMDoc(_MDocKind: LIKE(MDoc.MDocKind)): SCAL[2];
 BEGIN
  RETURN (_MDocKind = L_MDoc.md_Dvr) |
         (_MDocKind = L_MDoc.md_Nrd) ;
 END {IsTransitiveMDoc};

 PRIVATE PROCEDURE ConfirmHasGeneratedMDoc(Silent     : SCAL[2];
                                           trgMDocKind: LIKE(MDoc.MDocKind);
                                           curXDocId  : L_XDoc.tXDocId);
  VAR
   DependentMDocs: L_XDoc.tXDocCollection;
   i,
   gmc           : NUMERIC[0];
   curXDocType   : L_XDoc.tXDocType;
   curXDocKind   : L_XDoc.tXDocKind;
   curXDoc       : L_XDoc.tXDoc;
   refToXDocId   : L_XDoc.tXDocId;
 BEGIN
  IF ~Silent THEN
   SAVE(MDoc);
   SETZERO(i, gmc);
   DependentMDocs:=L_XDoc.GetDependentXDC(curXDocId, L_XDoc.xdt_MDoc);
   WHILE L_XDoc.xdc_PositionOn(DependentMDocs, i) DO
    IF (MDoc.MDocKind = trgMDocKind) & (MDoc.Status # L_MDoc.st_Canceled) THEN
     INC(gmc);
    END;
    INC(i);
   END; (* L_XDoc.xdc_PositionOn ... *)
   IF gmc > 0 THEN
    L_StdFrm.Choice(" ᭮ " + L_XDoc.XDocStr(curXDocId) +
                    "|"+
                    "㦥  ନ஢ "+L_MDoc.MDocKindNick(trgMDocKind, 1));
   ELSE
    L_XDoc.DecodeXDocId(curXDocId, curXDocType, curXDocKind, curXDoc);
    IF (curXDocType = L_XDoc.xdt_MDoc) & IsTransitiveMDoc(curXDocKind) THEN
     refToXDocId:=L_XDoc.GetBaseOnXDocId(curXDocId);
     IF ~!refToXDocId THEN
      ConfirmHasGeneratedMDoc(0, trgMDocKind, refToXDocId);
     END;
    END;
   END;
   RESTORE(MDoc);
  END;
 END {ConfirmHasGeneratedMDoc};

 PUBLIC PROCEDURE Build_MDoc(dstMDocKind: LIKE(MDocKind.MDocKind); Silent, forcePassed: SCAL[2]);
  VAR
   genMDocList: STRING[];
 BEGIN
  PassMayGenerateMDocAcsPnt();
  L_General.CallUs(IsAcceptableAddMDocKind(dstMDocKind));
  ConfirmHasGeneratedMDoc(Silent, dstMDocKind, L_XDoc.curXDocId(L_XDoc.xdt_MDoc));
  genMDocList:="|"+intGenerate_MDoc(dstMDocKind, Silent, forcePassed);
  ConfirmGeneratedDocs(Silent, genMDocList);
 END {Build_MDoc};

 PRIVATE PROCEDURE __Generate_VATMDoc(VAR DocList    : STRING[];
                                          Stage      : tStageOfBuildingVATMDoc;
                                          BuildMode  : tVATMDocBuildMode;
                                          v          : tValuesToBalance;
                                          NettobyRate: tValuesByVATRate);
 BEGIN
  DocList:=DocList+"|"+
           _Generate_VATMDoc(Stage, BuildMode, L_XDoc.xdt_PDoc,
                             v[vtb_Total]-v[vtb_VAT],
                             v[vtb_VAT],
                             NettobyRate);
 END {__Generate_VATMDoc};

 (* . 0043273 *)
 PUBLIC PROCEDURE AnalyzePaymentByContract(byContract: LIKE(Contract.Contract);
                                           Silent,
                                           Stage     : tStageOfBuildingVATMDoc);
  VAR
   Prepaid,
   Pstpaid,
   pInc,
   nInc,
   oBal       : tValuesToBalance;
   genMDocList: STRING[];
   lastMDocDoneDTS : FLOAT;
 BEGIN
  IF L_PDoc.IsPDocwMDoc() THEN
   TRY
    L_AFM.MakeMultipleIndex("_Cntr", "Contract   : LIKE(Contract.Contract);"+
                                     "Payment    : "+GET_TYPE_SPEC(tValuesToBalance).Name+";"+
                                     "NettobyRate: "+GET_TYPE_SPEC(tValuesByVATRate).Name+";"+
                                     "DoVATMDocs : SCAL[2]",
                            "_Cntr: Contract");
    genMDocList:=bsvmd_Prepare(Stage, PDoc.Date, L_XDoc.xdt_PDoc, PDoc.PDocKind, PDoc.PDoc, byContract, 0);
    SAVE(MDoc);
    SETSEL(PDocMDoc, PDoc, PDoc.PDocKind, PDoc.PDoc);
    FOR_EACH PDocMDoc DO
     CONFORM(PDocMDoc, MDoc);
     IF !byContract | (MDoc.Contract = byContract) THEN
      IF ~SELECT(_Cntr, _Cntr, MDoc.Contract) THEN
       _Cntr.Contract:=MDoc.Contract;
       SETZERO(_Cntr.Payment, _Cntr.NettobyRate, _Cntr.DoVATMDocs);
       INSERT(_Cntr);
      END;
      _Cntr.DoVATMDocs:=_Cntr.DoVATMDocs | E_DoSpecialVATMDocByMDoc();
      _Cntr.Payment   :=vtbAdd(_Cntr.Payment, vtbGetByPDocMDocBalance());
      aN2Add(_Cntr.NettobyRate, GetMDocNettobyRate());
      REPLACE(_Cntr);
     END;
    END; (* FOR_EACH PDocMDoc *)
    IF Stage = sbvmd_Online THEN
     lastMDocDoneDTS:=L_XDoc.max_DoneDTS;
    ELSE
     lastMDocDoneDTS:=L_XDoc.min_DoneDTS;
    END;
    SETSEL(_Cntr, _Cntr);
    FOR_EACH _Cntr DO
     IF _Cntr.DoVATMDocs & ~bvmd_ContractHasUnalteredBalance(_Cntr.Contract, PDoc.Date) THEN
      L_Cntr.PositionOnContract(_Cntr.Contract);
      oBal:=GetContractBalance(_Cntr.Contract, PDoc.Date,
                               lastMDocDoneDTS,
                               PDoc.DoneDTS);
      bvmd_GetBalanceAlteration(oBal[vtb_Total], _Cntr.Payment, pInc, nInc);
      IF Contract.Type = L_Cntr.ct_Sell THEN
       IF    pInc[vtb_Total]<0 THEN
        __Generate_VATMDoc(genMDocList, Stage, vmdbm_Pstpayment,
                           vtbInv(pInc), _Cntr.NettobyRate);
       ELSIF pInc[vtb_Total]>0 THEN
        __Generate_VATMDoc(genMDocList, Stage, vmdbm_Underpay,
                           pInc, _Cntr.NettobyRate);
       END;
       IF    nInc[vtb_Total]<0 THEN
        __Generate_VATMDoc(genMDocList, Stage, vmdbm_Prepayment,
                           vtbInv(nInc), _Cntr.NettobyRate);
       ELSIF nInc[vtb_Total]>0 THEN
        __Generate_VATMDoc(genMDocList, Stage, vmdbm_PrpReturn,
                           nInc, _Cntr.NettobyRate);
       END;
      ELSE                         (* 㯪 *)
       IF    nInc[vtb_Total]<0 THEN
        __Generate_VATMDoc(genMDocList, Stage, vmdbm_PrchUndpay,
                           vtbInv(nInc), _Cntr.NettobyRate);
       ELSIF nInc[vtb_Total]>0 THEN
        __Generate_VATMDoc(genMDocList, Stage, vmdbm_PrchPstpay,
                           nInc, _Cntr.NettobyRate);
       END;
      END; (* IF Contract.Type...*)
     END;
    END; (* FOR_EACH _Cntr *)
    RESTORE(MDoc);
    IF bsvmd_HasNoChanges() THEN
     genMDocList:="";
     ConfirmGeneratedDocs(Silent, genMDocList);
     L_General.RaiseLockReleaseException();
    ELSE
     ConfirmGeneratedDocs(Silent, genMDocList);
    END;
   EXCEPT
   ON Exc: Exc_Root DO
    L_General.CheckIsLockReleaseException(Exc);
   FINALLY
    L_AFM.AF_PurgeTemp("_Cntr");
   END;
  END; (* IF L_PDoc.IsPDocwMDoc()... *)
 END {AnalyzePaymentByContract};

 PUBLIC PROCEDURE AnalyzePayment(Silent, Stage: tStageOfBuildingVATMDoc);
 BEGIN
  AnalyzePaymentByContract(EMPTYOF(Contract.Contract), Silent, Stage);
 END {AnalyzePayment};

 PUBLIC PROCEDURE CheckPDocHasUnalteredBalanceButVATChange();
 BEGIN
  IF L_PDoc.IsPDocwMDoc() THEN
   L_AFM.MakeMultipleIndex("_Cnt1", "Contract: LIKE(Contract.Contract);"+
                                    "Payment: "+GET_TYPE_SPEC(tValuesToBalance).Name,
                           "_Cnt1: Contract");
   SETSEL(PDocMDoc, PDoc, PDoc.PDocKind, PDoc.PDoc);
   FOR_EACH PDocMDoc DO
    CONFORM(PDocMDoc, Contract);
    IF Contract.Type = L_Cntr.ct_Sell THEN
     IF ~ADD(_Cnt1, _Cnt1, PDocMDoc.Contract) THEN
      SETZERO(_Cnt1.Payment);
      REPLACE(_Cnt1);
     END;
     _Cnt1.Payment:=vtbAdd(_Cnt1.Payment, vtbGetByPDocMDocBalance());
     REPLACE(_Cnt1);
    END;
   END; (* FOR_EACH PDocMDoc *)
   SETSEL(_Cnt1, _Cnt1);
   FOR_EACH _Cnt1 DO
    IF (_Cnt1.Payment[vtb_Total] = 0) & (_Cnt1.Payment[vtb_VAT] # 0) THEN
     L_StdFrm.Choice(L_PDoc.PDocStr(PDoc.PDocKind, PDoc.PDoc)+"   "+_Cnt1.Contract+"   ᠫ줮 ⮢,   㫥 ⮣   "+
                     L_StdFrm.THR("")+
                     "㬥  訡    ᫥ ⭮    '㯫  ।'|"+
                     " ᫥騬 ।    "+_Cnt1.Contract+"   ⥦ ४஢");
    END;
   END; (* FOR_EACH _Cnt1 *)
   L_AFM.AF_PurgeTemp("_Cnt1");
  END;
 END {CheckPDocHasUnalteredBalanceButVATChange};

 PRIVATE PROCEDURE intResetMDocClosed_SelfAndDependent();
  VAR
   DependentMDocs: L_XDoc.tXDocCollection;
   i             : NUMERIC[0];
 BEGIN
  PROMPT(L_MDoc.GetMDocStrNbr());
  SAVE(MDoc);
  IF ~!MDoc.Closed THEN
   SETEMPTY(MDoc.Closed);
   REPLACE(MDoc);
  END;
  i:=0;
  DependentMDocs:=L_MDoc.GetDependentMDocXDC();
  WHILE L_XDoc.xdc_PositionOn(DependentMDocs, i) DO
   intResetMDocClosed_SelfAndDependent();
   INC(i);
  END;
  RESTORE(MDoc);
 END {intResetMDocClosed_SelfAndDependent};

 PRIVATE PROCEDURE intResetMDocClosed();
  VAR
   ReftoMDocs: L_XDoc.tXDocCollection;
   i         : NUMERIC[0];
 BEGIN
  SAVE(MDoc);
  i:=0;
  ReftoMDocs:=L_XDoc.GetRefToXDC(L_XDoc.curXDocId(L_XDoc.xdt_MDoc), L_XDoc.xdt_MDoc);
  WHILE L_XDoc.xdc_PositionOn(ReftoMDocs, i) DO
   intResetMDocClosed();
   INC(i);
  END;
  intResetMDocClosed_SelfAndDependent();
  RESTORE(MDoc);
 END {intResetMDocClosed};

 PRIVATE PROCEDURE ResetContractClosed(trgContract: LIKE(Contract.Contract));
 BEGIN
  IF ~!trgContract THEN
   SAVE(Contract);
   L_General.CallUs(SEARCH(Contract, Contract, trgContract));
   IF Contract.Closed THEN
    TRY
     L_AR.GrantRightsUnconditionally();
     Contract.Closed:=0;
     REPLACE(Contract);
    EXCEPT
    ON Exc: Exc_Root DO
     RAISE();
    END; (* TRY *)
   END;
   RESTORE(Contract);
  END;
 END {ResetContractClosed};

 PUBLIC PROCEDURE ResetMDocClosed();
 BEGIN
  APP.Get().NewPrompt(" ﭨ ' '");
  ResetContractClosed(MDoc.Contract);
  intResetMDocClosed();
 END {ResetMDocClosed};

 PUBLIC PROCEDURE InsPDocMDoc(_MDocKind: LIKE(MDoc.MDocKind);
                              _MDoc    : LIKE(MDoc.MDoc);
                              _Total,
                              _VAT,
                              _SaleTax : NUMERIC[2]);
 BEGIN
  PDocMDoc.PDocKind:=PDoc.PDocKind;
  PDocMDoc.PDoc    :=PDoc.PDoc;
  PDocMDoc.MDocKind:=_MDocKind;
  PDocMDoc.MDoc    :=_MDoc;
  PDocMDoc.PDocDate:=PDoc.Date;
  SAVE(MDoc);
  SAVE(Contract);
  L_General.CallUs(SEARCH(MDoc, MDoc, _MDocKind, _MDoc));
  PDocMDoc.Dest:=MDoc.Dest;
  CONFORM(MDoc, Contract);
  PDocMDoc.Contract:=Contract.Contract;
  IF P_Cntr.GetSpecialAttitudeToVAT(Contract.Contract, MDoc.Date) = P_Cntr.satVAT_TaxFree THEN
   L_General.Assert(ConvEtZ(_VAT) = 0,
                    "⨬ 稥    " + Contract.Contract);
   SETEMPTY(_VAT);
  END;
  RESTORE(Contract);
  RESTORE(MDoc);
  PDocMDoc.Total   :=_Total;
  PDocMDoc.NDS     :=_VAT;
  PDocMDoc.SaleTax :=_SaleTax;
  IF ~vtbTotal_wSaleTax(_MDocKind) THEN
   INC(PDocMDoc.Total, PDocMDoc.SaleTax);
  END;
  INSERT(PDocMDoc);
 END {InsPDocMDoc};

 PUBLIC PROCEDURE ipic_CheckMDoc(ipic: tIncompletelyPaidIncludeCondition): SCAL[2];
  VAR
   ToPay : tValuesToBalance;
 BEGIN
  IF (MDoc.Status # L_MDoc.st_Prepared) &
     IsMayBePaidMDocKind(MDoc.MDocKind) &
     (P_MDoc.GetDealCheckType(MDoc.MDocKind, MDoc.MDoc) # P_MDoc.dct_DoNot)  THEN
   ToPay:=GetMDocBalance(EMPTYOF(DATE), L_XDoc.max_DoneDTS);
   RETURN ((ipic = ipic_Any    ) & ((ToPay[vtb_Total] # 0) |
                                    (ToPay[vtb_Netto] # 0))) |
          ((ipic = ipic_AutoPay) & (vtbExtractTotal(ToPay) # 0));
  ELSE
   RETURN 0;
  END;
 END {ipic_CheckMDoc};

 PUBLIC PROCEDURE GetContractIncompletelyPaidMDocs(_Contract: LIKE(Contract.Contract);
                                                   ipic     : tIncompletelyPaidIncludeCondition): STRING[];
  VAR
   Result: STRING[];
   ToPay : tValuesToBalance;
 BEGIN
  Result:="";
  SELECT(MDocKind, MDocKind);
  WHILE OCCURE(MDocKind) DO
   IF IsMayBePaidMDocKind(MDocKind.MDocKind) THEN
    SETSEL(MDoc, CntrClsd, _Contract, MDocKind.MDocKind);
    SRCINSEL(MDoc, GE, , EMPTYOF(MDoc.Closed));
    WHILE OCCURE(MDoc) DO
     PROMPT("ᬮ 㬥⮢ " + L_MDoc.MDocStr(MDoc.MDocKind, MDoc.MDoc));
     IF ipic_CheckMDoc(ipic) THEN
      IF ~!Result THEN
       Result:=Result + "|";
      END;
      Result:=Result + L_XDoc.XDocId(L_XDoc.xdt_MDoc, MDoc.MDocKind, MDoc.MDoc);
     END;
     NEXT(MDoc);
    END; (* WHILE OCCURE(MDoc) ... *)
   END; (* IF IsMayBePaidMDocKind ... *)
   NEXT(MDocKind);
  END; (* WHILE OCCURE(MDocKind) ... *)
  RETURN Result;
 END {GetContractIncompletelyPaidMDocs};

 PUBLIC PROCEDURE GetFirmIncompletelyPaidMDocs(_Firm  : LIKE(Firm.Firm);
                                               _MyFirm: P_Firm.tMyFirm;
                                               ipic   : tIncompletelyPaidIncludeCondition): STRING[];
  VAR
   Result,
   Dummy : STRING[];
 BEGIN
  Result:="";
  SELECT(Contract, Firm, , _Firm, 1);
  WHILE OCCURE(Contract) DO
   IF Contract.MyFirm = _MyFirm THEN
    Dummy:=GetContractIncompletelyPaidMDocs(Contract.Contract, ipic);
    IF ~!Dummy THEN
     IF ~!Result THEN
      Result:=Result + "|";
     END;
     Result:=Result + Dummy;
    END;
   END;
   NEXT(Contract);
  END; (* WHILE OCCURE(Contract) ... *)
  RETURN Result;
 END {GetFirmIncompletelyPaidMDocs};

 CONST
  cd_Amount = 400;

 VAR
  cd_MDocK      : LIKE(MDoc.MDocKind)[cd_Amount];
  cd_MDoc       : LIKE(MDoc.MDoc)    [cd_Amount];
  cd_UndP       : NUMERIC[2]         [cd_Amount];
  cd_VAT        : NUMERIC[2]         [cd_Amount];
  cd_SaleTax    : NUMERIC[2]         [cd_Amount];
  cd_ToDo       : SCAL[3]            [cd_Amount];

 PRIVATE PROCEDURE dp_ExactlyToAllUndP(ToDistribute: NUMERIC[2]): SCAL[2];
  VAR
   j     : NUMERIC[0];
   Result: SCAL[2];
 BEGIN
  Result:=0;
  IF (PDoc.PDocKind = L_PDoc.pd_VPP) | (PDoc.PDocKind = L_PDoc.pd_VPK) THEN
   TRY
    j:=0;
    WHILE ~!cd_MDoc[j] DO
     InsPDocMDoc(cd_MDocK[j], cd_MDoc[j], cd_UndP[j], cd_VAT[j], cd_SaleTax[j]);
     DEC(ToDistribute, cd_UndP[j]);
     INC(j);
    END;
    IF ToDistribute # 0 THEN
     L_General.RaiseLockReleaseException();
    ELSE
     Result:=1;
    END;
   EXCEPT
   ON Exc: Exc_Root DO
    L_General.CheckIsLockReleaseException(Exc);
   END; (* TRY *)
  END;
  RETURN Result;
 END {dp_ExactlyToAllUndP};

 PRIVATE PROCEDURE dp_Combine(s    : NUMERIC[2];
                              i    : NUMERIC[0];
                              Light: SCAL[2]): SCAL[2];
  VAR
   j: NUMERIC[0];
 BEGIN
  PROMPT("। ⥦.  㬬. 浪  " + L_Str.IntStr(i));
  j:=i;
  WHILE ~!cd_MDoc[j] DO
   IF s=cd_UndP[j] THEN
    InsPDocMDoc(cd_MDocK[j], cd_MDoc[j], cd_UndP[j], cd_VAT[j], cd_SaleTax[j]);
    RETURN 1;
   END;
   INC(j);
  END;
  IF ~Light THEN
   j:=i;
   WHILE ~!cd_MDoc[j] DO
    IF s >= cd_UndP[j] THEN
     IF dp_Combine(s-cd_UndP[j], j+1, 0) THEN
      InsPDocMDoc(cd_MDocK[j], cd_MDoc[j], cd_UndP[j], cd_VAT[j], cd_SaleTax[j]);
      RETURN 1;
     END;
    END;
    INC(j);
   END;
  END;
  RETURN 0;
 END {dp_Combine};

 PRIVATE PROCEDURE dp_FillSingleMDoc(i: NUMERIC[0]; _ToDo: SCAL[3]): STRING[];
 BEGIN
  RETURN Str.Align(MDoc.SrcNbr, 12, LEFT) + " " +
         L_Str.PoolItem("-||*", _ToDo) + " " +
         L_MDoc.MDocKindNick(MDoc.MDocKind, 1) + " " +
         MDoc.MDoc + " " +
         L_DatTim.DateStr(MDoc.SrcDate) + " " +
         Str.Align(MDoc.Contract + " " + Contract.Name, 24, LEFT) + " " +
         FLDTOSTR(cd_UndP[i], "2-", 15);
 END {dp_FillSingleMDoc};

 PRIVATE PROCEDURE dp_Manual(Manner      : tDistributeManner;
                             ToDistribute: NUMERIC[2];
                             Subject     : STRING[]);
  VAR
   i,
   j             : NUMERIC[0];
   cd_Paid       : NUMERIC[2][cd_Amount];
   List          : STRING[];
   Title         : STRING[];
   Distributed   : NUMERIC[2];
   FormResult    : NUMERIC[0];
 BEGIN
  PROMPT("'筮' । ⥦");
  SETZERO(j, Distributed);
  i:=0;
  WHILE ~!cd_MDoc[i] DO
   IF cd_ToDo[i] THEN
    cd_Paid[i]:=cd_UndP[i];
    INC(Distributed, cd_Paid[i]);
   END;
   INC(i);
  END;
  LOOP
   List:="";
   i:=0;
   WHILE ~!cd_MDoc[i] DO
    SEARCH(MDoc, MDoc, , cd_MDocK[i], cd_MDoc[i]);
    CONFORM(MDoc, Contract);
    List:=List + dp_FillSingleMDoc(i, cd_ToDo[i]) + "|";
    INC(i);
   END;
   TRY
    IF Manner = dm_ByPDocTotal THEN
     Title:="  । " + FLDTOSTR(ToDistribute, "2-");
    ELSE
     Title:=" । " + FLDTOSTR(Distributed, "2-");
    END;
    L_StdFrm.ShowListAsMenu_wButtons(List, Title + " (" + Subject + ") ", "", j, ["/᪫", ""], j, FormResult);
    IF cd_ToDo[j] > 0 THEN
     IF Manner = dm_ByPDocTotal THEN
      INC(ToDistribute, cd_Paid[j]);
     END;
     DEC(Distributed, cd_Paid[j]);
     cd_ToDo[j]:=0;
     cd_Paid[j]:=0;
    ELSE
     IF Manner = dm_ByPDocTotal THEN
      cd_Paid[j]:=Math.Min(cd_UndP[j], ToDistribute);
      DEC(ToDistribute, cd_Paid[j]);
     ELSE
      cd_Paid[j]:=cd_UndP[j];
     END;
     INC(Distributed, cd_Paid[j]);
     IF    cd_Paid[j] = 0 THEN
      cd_ToDo[j]:=0;
     ELSIF cd_Paid[j] < cd_UndP[j] THEN
      cd_ToDo[j]:=2;
     ELSE
      cd_ToDo[j]:=1;
     END;
    END;
   EXCEPT
   ELSE
    IF    (!ToDistribute | (ToDistribute = 0)) & (Distributed <= 0) THEN
     L_StdFrm.Question(" 㬬      . த ।?");
    ELSIF (ToDistribute # 0) & (Manner = dm_ByPDocTotal) THEN
     IF L_StdFrm.Alternative("।   㬬.  ।?") THEN
      EXIT;
     END;
    ELSE
     EXIT;
    END;
   END;
  END; (* LOOP *)
  i:=0;
  WHILE ~!cd_MDoc[i] DO
   IF cd_ToDo[i] THEN
    L_General.Assert(~SEARCH(PDocMDoc, PDoc, PDoc.PDocKind, PDoc.PDoc, cd_MDocK[i], cd_MDoc[i]), " । ⥦   "+L_MDoc.MDocStr(cd_MDocK[i], cd_MDoc[i])+"| ᭠砫 㤠   ᯨ᪠ '뫪  ⮢ 㬥'");

    InsPDocMDoc(cd_MDocK[i], cd_MDoc[i],
                cd_Paid[i], cd_VAT[i]     * (cd_Paid[i]/cd_UndP[i]),
                            cd_SaleTax[i] * (cd_Paid[i]/cd_UndP[i]));
   END;
   INC(i);
  END;
 END {dp_Manual};

 PRIVATE PROCEDURE dp_UndP_BySingleMDoc(VAR i: NUMERIC[0]; _Sign: NUMERIC[0]; forceAll: SCAL[2]): NUMERIC[2];
  VAR
   Blnc: tValuesToBalance;
   UndP: NUMERIC[2];
 BEGIN
  UndP:=0;
  IF ~SEARCH(PDocMDoc, PDoc, PDoc.PDocKind, PDoc.PDoc, MDoc.MDocKind, MDoc.MDoc) THEN
   PROMPT("। ⥦. ᬮ  " + L_MDoc.MDocStr(MDoc.MDocKind, MDoc.MDoc));
   IF (MDoc.Status#L_MDoc.st_Prepared) & IsMayBePaidMDocKind(MDoc.MDocKind) & TakeMDocIntoAccount() THEN
    Blnc:=GetMDocBalance(EMPTYOF(DATE), L_XDoc.max_DoneDTS);
    IF ((Blnc[vtb_Total] > 0) = (_Sign > 0)) | (_Sign = -1) | forceAll THEN
     cd_UndP[i]:=_Sign*Blnc[vtb_Total];
     IF cd_UndP[i]#0 THEN
      cd_VAT    [i]:=_Sign*Blnc[vtb_VAT];
      cd_SaleTax[i]:=_Sign*Blnc[vtb_SaleTax];
      cd_MDocK[i]:=MDoc.MDocKind;
      cd_MDoc [i]:=MDoc.MDoc;
      UndP       :=cd_UndP[i];
      INC(i);
      L_General.Assert(i<(cd_Amount-1), "誮  祭 ⮢ 㬥⮢  ࠣ")
     END;
    END;
   END;
  END; (* IF ~SEARCH(PDocMDoc ... *)
  RETURN UndP;
 END {dp_UndP_BySingleMDoc};

 PRIVATE PROCEDURE E_IsMDocToPaymentDistribution(): SCAL[2];
  VAR
   Local: PROC;
   default: SCAL[2];
 BEGIN
  default:=(MDoc.MDocKind = L_MDoc.md_RPk);
  Local:=PROCREF(E_Pmnt.IsMDocToPaymentDistribution);
  IF ~!Local THEN
   RETURN Local(default);
  END;
  RETURN default;
 END {E_IsMDocToPaymentDistribution};

 PUBLIC PROCEDURE RecalcPDocSums(ByUnknownSum: SCAL[2]);
  VAR
   _Total      : LIKE(PDoc.Total);
   _NDS        : LIKE(PDoc.NDS);
   _SaleTax    : LIKE(PDoc.SaleTax);
   OnlyEmptyVAT: SCAL[2];
 BEGIN
  IF SELECT(PDocMDoc, PDoc, PDoc.PDocKind, PDoc.PDoc) THEN
   OnlyEmptyVAT:=1;
   SETZERO(_Total, _NDS, _SaleTax);
   WHILE OCCURE(PDocMDoc) DO
    INC(_Total,   PDocMDoc.Total);
    OnlyEmptyVAT:=OnlyEmptyVAT & !PDocMDoc.NDS;
    INC(_NDS,     ConvEtZ(PDocMDoc.NDS));
    INC(_SaleTax, ConvEtZ(PDocMDoc.SaleTax));
    NEXT(PDocMDoc);
   END; (* WHILE OCCURE(PDocMDoc) ... *)
   IF (_Total = PDoc.Total) | ByUnknownSum | (L_PDoc.PDocTotalFillMethod() = L_PDoc.pdtfm_byPDocMDoc) THEN
    PDoc.Total:=_Total;
    IF ConvEtZ(PDoc.NDS) # _NDS THEN
     PDoc.NDS:=_NDS;
    END;
    IF OnlyEmptyVAT THEN
     SETEMPTY(PDoc.NDS);
    ELSIF !PDoc.NDS THEN
     PDoc.NDS:=0;
    END;
    IF ConvEtZ(PDoc.SaleTax) # _SaleTax THEN
     PDoc.SaleTax:=_SaleTax;
    END;
   END;
   PDoc.Dest:=L_Dest.PDocwMDocDest();
   IF (PDoc.Status = L_PDoc.st_Prepared) & ~L_PDoc.IsOurselvesPDoc(PDoc.PDocKind) THEN
    PDoc.Status:=L_PDoc.st_Passed;
   END;
   REPLACE(PDoc);
  END;
 END {RecalcPDocSums};

 PRIVATE CONST
   UnsuccessfulCombine = "16.05.2003 09:41:42 POLAK\SAN -  ।";

 PRIVATE PROCEDURE dp_DoIt(Silent: SCAL[2]; MDocIds, wDoneIds: STRING[]);
  VAR
   _Sign       : NUMERIC[0];
   Manner      : tDistributeManner;
   ToDistribute,
   curUndP     : NUMERIC[2];
   ipdCount,
   j           : NUMERIC[0];
   _XDocId     : L_XDoc.tXDocId;
   _Subject    : STRING[];
   begDate     : DATE;
 BEGIN
  SETZERO(ipdCount, cd_ToDo);
  SETEMPTY(cd_MDoc);
  IF L_PDoc.IsOutPDoc(PDoc.PDocKind) THEN
   _Sign:=-1;
  ELSE
   _Sign:=+1;
  END;
  IF PDoc.PDocKind = L_PDoc.pd_AVO THEN
   SETEMPTY(ToDistribute);
   Manner:=dm_UnknownSum;
   L_General.Assert(SELECT(PDocList, PDoc, PDoc.PDocKind, PDoc.PDoc),
                    "砫 㪠 '⭨'");
   CONFORM(PDocList, Staff);
   _Subject:="⭨ " + Staff.TSN;
   SAVE(Staff);
   IF L_PDoc.E_AllowAnyStaffMyFirmInPDocList() THEN
    CHANGESEL(Staff, Man, , Staff.Man);
    FIRST(Staff);
   ELSE
    CHANGESEL(Staff, TSN, , Staff.TSN);
   END;

   begDate:=L_XObj.GetBeginOfAccountingOnAcCut(L_kn.Get(SYSDATE(), L_AcCut.erkn_AccountableMan));
   begDate:=Math.Max(begDate, SYSDATE() - 365);
   WHILE OCCURE(Staff) DO
    SELECT(MDoc, TSN, , Staff.TSN);
    WHILE OCCURE(MDoc) DO
     NARROWSEL(MDoc, MDocKind);
     IF IsMayBePaidMDocKind(MDoc.MDocKind) THEN
      SRCINSEL(MDoc, GE, , begDate);
      WHILE OCCURE(MDoc) DO
       PROMPT("   ।: " + L_MDoc.GetMDocStrNbr());
       IF (MDoc.MyFirm = PDoc.MyFirm) & E_IsMDocToPaymentDistribution() THEN
        curUndP:=dp_UndP_BySingleMDoc(ipdCount, _Sign, 0);
       END;
       NEXT(MDoc);
      END; (* WHILE OCCURE(MDoc) ... *)
     END;
     NEXTINEXTENDEDSEL(MDoc, MDocKind);
    END; (* WHILE OCCURE(MDoc) *)
    NEXT(Staff);
   END; (* WHILE OCCURE(Staff) ... *)
   RESTORE(Staff);
  ELSE
   ToDistribute:=PDoc.Total;
   CONFORM(PDoc, PDocMDoc);
   WHILE OCCURE(PDocMDoc) DO
    DEC(ToDistribute, PDocMDoc.Total);
    NEXT(PDocMDoc);
   END; (* WHILE OCCURE(PDocMDoc) ... *)
   IF !ToDistribute THEN
    Manner:=dm_UnknownSum;
   ELSE
    L_General.Assert((ToDistribute > 0) | ((PDoc.PDocKind = L_PDoc.pd_VPK) | (PDoc.PDocKind = L_PDoc.pd_IPK)),
                     "㬬  । ࠢ " + FLDTOSTR(ToDistribute, "2.", 0));
    Manner:=dm_ByPDocTotal;
   END;
   L_General.Assert(~!PDoc.Firm, " 㪠 ࠣ  " + L_PDoc.PDocStr(PDoc.PDocKind, PDoc.PDoc));
   CONFORM(PDoc, Firm);
   _Subject:="ࠣ " + Firm.Firm;
   IF !MDocIds THEN
    MDocIds:=GetFirmIncompletelyPaidMDocs(Firm.Firm, PDoc.MyFirm, ipic_AutoPay);
   END;
   j:=0;
   LOOP
    _XDocId:=L_Str.PoolItem(MDocIds, j);
    IF !_XDocId THEN
     EXIT;
    END;
    L_XDoc.PositionOnXDoc(_XDocId);
    L_General.CallUs(L_XDoc.ExtractXDocType(_XDocId) = L_XDoc.xdt_MDoc);
    curUndP:=dp_UndP_BySingleMDoc(ipdCount, _Sign, (PDoc.PDocKind = L_PDoc.pd_VPK) |
                                                   (PDoc.PDocKind = L_PDoc.pd_IPK) |
                                                   (PDoc.PDocKind = L_PDoc.pd_VPP) |
                                                   (PDoc.PDocKind = L_PDoc.pd_IPP) );
    IF (curUndP # 0) & ~! wDoneIds THEN
     cd_ToDo[ipdCount-1]:=Str.Pos(_XDocId, wDoneIds) # Str.Length(wDoneIds);
    END;
    INC(j);
   END;
  END;
  IF ipdCount = 0 THEN
   L_StdFrm.BlueHalt(_Subject + ":||   ᮮ⢥饩 ⮩");
  END;
  TRY
   IF ~((Manner # dm_UnknownSum) &
        (dp_ExactlyToAllUndP(ToDistribute) | dp_Combine(ToDistribute, 0, ipdCount > 10))) THEN
    RAISE(0, UnsuccessfulCombine);
   END;
  EXCEPT
  ON Exc:Exc_Raise DO
   IF Exc.MsgOriginalText = UnsuccessfulCombine THEN
    IF ~Silent THEN
     dp_Manual(Manner, ToDistribute, _Subject);
    ELSE
     RAISE();
    END;
   ELSE
    RAISE();
   END;
  END; (* TRY *)
  RecalcPDocSums(Manner = dm_UnknownSum);
 END {dp_DoIt};

 PUBLIC PROCEDURE DistributePayment();
 BEGIN
  dp_DoIt(0, "", "");
 END {DistributePayment};

 PUBLIC PROCEDURE TryDistributePayment(VAR ErrMsg: STRING[]);
 BEGIN
  SETEMPTY(ErrMsg);
  TRY [MSG_SUPPRESSION(MSG_SUPPRESSION_ALL)]
   dp_DoIt(1, "", "");
  EXCEPT
  ON Exc: Exc_Halt DO
   ErrMsg:="   ᮮ⢥饩 ⮩";
  ON Exc: Exc_Root DO
   IF Exc.MsgOriginalText = UnsuccessfulCombine THEN
    ErrMsg:=" 㤠 । ⥦";
   ELSE
    ErrMsg:=Exc.Description;
   END;
  END;
 END {TryDistributePayment};

 PUBLIC PROCEDURE ShowPaymentDistribution(MDocIds, wDoneIds: STRING[]);
 BEGIN
  dp_DoIt(0, MDocIds, wDoneIds);
 END {ShowPaymentDistribution};

 PRIVATE PROCEDURE IsPDKForPay(): SCAL[2];
 BEGIN
  RETURN (PDocKind.PDocKind # L_PDoc.pd_IMO) &
         (PDocKind.PDocKind # L_PDoc.pd_VMO) &
         (PDocKind.PDocKind # L_PDoc.pd_ITP) &
         (PDocKind.PDocKind # L_PDoc.pd_VTP) &
         (PDocKind.PDocKind # L_PDoc.pd_OVN) &
         (PDocKind.PDocKind # L_PDoc.pd_CND) &
         (PDocKind.PDocKind # L_PDoc.pd_AVO) &
         (PDocKind.PDocKind # L_PDoc.pd_VPK) &
         (PDocKind.PDocKind # L_PDoc.pd_VPP) &
         (PDocKind.PDocKind # L_PDoc.pd_IPK);
 END {IsPDKForPay};

 PRIVATE PROCEDURE E_PDocKindForPay(): LIKE(PDocKind.PDocKind);
  VAR
   Local     : PROC;
   _PDocKind : LIKE(PDocKind.PDocKind);
   _PDKCodes,
   _PDKNames : STRING[];
 BEGIN
  CONFORM(MDoc, MDocKind);
  IF    (MDoc.MDocKind = L_MDoc.md_RPr) |
        (MDoc.MDocKind = L_MDoc.md_IsS) |
        (MDoc.MDocKind = L_MDoc.md_OBK) THEN
   _PDocKind:=L_PDoc.pd_PKO;
  ELSIF (MDoc.MDocKind = L_MDoc.md_VhS) |
        (MDoc.MDocKind = L_MDoc.md_VhA) |
        (MDoc.MDocKind = L_MDoc.md_NDk) |
        (MDoc.MDocKind = L_MDoc.md_NlO) THEN
   _PDocKind:=L_PDoc.pd_IPP;
  ELSE
   SETEMPTY(_PDocKind);
  END;
  Local:=PROCREF(E_Pmnt.PDocKindForPay);
  IF ~!Local THEN
   _PDocKind:=Local(_PDocKind);
  END;
  IF !_PDocKind THEN
   _PDKCodes:="";
   _PDKNames:="";
   SELECT(PDocKind, PDocKind);
   WHILE OCCURE(PDocKind) DO
    IF IsPDKForPay() &
       (L_MDoc.IsPrchMDocKind() = L_PDoc.IsOutPDoc(PDocKind.PDocKind)) THEN
     _PDKCodes:=_PDKCodes+PDocKind.PDocKind+"|";
     _PDKNames:=_PDKNames+PDocKind.Sign+" "+PDocKind.Name+"|";
    END;
    NEXT(PDocKind);
   END; (* WHILE OCCURE(PDocKind) ... *)
   FIRST(PDocKind);
   WHILE OCCURE(PDocKind) DO
    IF IsPDKForPay() &
       (L_MDoc.IsPrchMDocKind() # L_PDoc.IsOutPDoc(PDocKind.PDocKind)) THEN
     _PDKCodes:=_PDKCodes+PDocKind.PDocKind+"|";
     _PDKNames:=_PDKNames+PDocKind.Sign+" "+PDocKind.Name+"|";
    END;
    NEXT(PDocKind);
   END; (* WHILE OCCURE(PDocKind) ... *)
   _PDocKind:=L_Str.PoolItem(_PDKCodes, L_StdFrm.ShowListAsMenu(_PDKNames, " ⥦ 㬥"));
  END;
  RETURN _PDocKind;
 END {E_PDocKindForPay};

 PUBLIC PROCEDURE extMakePDocwMDoc(XDocIds, wDoneIds: STRING[]; Silent: SCAL[2]): L_XDoc.tXDocId;
  VAR
   MDocSums   : tValuesToBalance;
   Result,
   trgXDocId  : L_XDoc.tXDocId;
   trgPDocKind: LIKE(PDoc.PDocKind);
 BEGIN
  SETEMPTY(Result);
  trgXDocId:=L_Str.PoolItem(wDoneIds, 0);
  IF ~!trgXDocId THEN
   L_General.Assert(L_XDoc.ExtractXDocType(trgXDocId) = L_XDoc.xdt_MDoc, "ନ஢   ⮫쪮  ᭮ ");
   L_XDoc.PositionOnXDoc(trgXDocId);
   L_MDoc.CheckPassed();
   L_General.Assert(IsMayBePaidMDocKind(MDoc.MDocKind), "㬥 ⮣     ᭮  ");
   L_General.Assert(ipic_CheckMDoc(ipic_AutoPay), L_MDoc.MDocStr(MDoc.MDocKind, MDoc.MDoc) + ":   ॡ");

   CONFORM(MDoc, Contract);
   CONFORM(Contract, Firm);
   trgPDocKind:=E_PDocKindForPay();

   DEFAULT(PDoc);
   PDoc.PDocKind:=trgPDocKind;
   PDoc.MyFirm  :=MDoc.MyFirm;
   IF    L_PDoc.MoneyKind(trgPDocKind) = L_PDoc.mk_Bank THEN
    PDoc.OwnAcnt :=P_Cntr.GetDefaultPayOwnFirmAcnt(Contract.Contract, SYSDATE());
   ELSIF L_PDoc.MoneyKind(trgPDocKind) = L_PDoc.mk_OprDskCash THEN
    IF L_PDoc.dodAssigned THEN
     L_General.Assert(L_PDoc.dodMyFirm = PDoc.MyFirm, "'樮   㬮砭' 易  㣮 ");
     PDoc.OwnAcnt:=L_PDoc.dodFirmAcnt;
    ELSE
     L_General.Error(" ⠭ '樮   㬮砭'");
    END;
   END;
   PDoc.Date    :=L_PDoc.GetActualPDocDate(Silent);
   PDoc.PrpDate :=PDoc.Date;
   PDoc.Firm    :=Firm.Firm;
   IF L_PDoc.MoneyKind(trgPDocKind) # L_PDoc.mk_Bank THEN
    SETEMPTY(PDoc.FirmAcnt);
   ELSE
    PDoc.FirmAcnt:=P_Cntr.GetDefaultPayFirmAcnt(Contract.Contract, PDoc.Date);
    IF !PDoc.FirmAcnt THEN
     P_Firm.AccessSilentFirmAcnt(Firm.Firm, PDoc.Date);
     PDoc.FirmAcnt:=FirmAcnt.FirmAcnt;
    END;
   END;
   SETEMPTY(PDoc.payp, PDoc.Queue);
   PDoc.Dest    :=L_Dest.PDocwMDocDest();
   PDoc.Type    :=L_PDoc.typ_Other;
   IF L_PDoc.IsOurselvesPDoc(trgPDocKind) THEN
    PDoc.Status  :=L_PDoc.st_Prepared;
   ELSE
    PDoc.Status  :=L_PDoc.st_Passed;
   END;
   PDoc.Source  :=L_PDoc.src_Auto;
   PDoc.PmntKind:=L_PDoc.E_DefaultPDocPmntKind(PDoc.Date);
   SETEMPTY(PDoc.Total, PDoc.NDS, PDoc.SaleTax);
   L_PDoc.Insert_PDoc();

   IF ~!XDocIds & (XDocIds = wDoneIds) & (L_XDoc.xdc_Count(XDocIds) = 1) THEN
    MDocSums:=GetMDocBalance(EMPTYOF(DATE), L_XDoc.max_DoneDTS);
    IF L_PDoc.IsOutPDoc(PDoc.PDocKind) THEN
     MDocSums:=vtbInv(MDocSums);
    END;
    InsPDocMDoc(MDoc.MDocKind, MDoc.MDoc, MDocSums[vtb_Total], MDocSums[vtb_VAT], MDocSums[vtb_SaleTax]);
    RecalcPDocSums(1);
   ELSE
    ShowPaymentDistribution(XDocIds, wDoneIds);
   END;
   IF SELECT(PDocMDoc, PDoc, PDoc.PDocKind, PDoc.PDoc) THEN
    L_PDoc.FillPDocAbout();
    L_PDoc.PDoc_OnAnyModification(+1, L_PDoc.np_No, 0);
    Result:=PDoc.XDocId;
   END;
  END;
  RETURN Result;
 END {extMakePDocwMDoc};

 PUBLIC PROCEDURE MakePDocwMDoc(XDocIds, wDoneIds: STRING[]): L_XDoc.tXDocId;
 BEGIN
  RETURN extMakePDocwMDoc(XDocIds, wDoneIds, 0);
 END {MakePDocwMDoc};

 PUBLIC PROCEDURE AccessContract();
 BEGIN
  L_General.Assert(ACCESS(Contract), " ⠭ ⥪騩 ");
 END {AccessContract};

 PRIVATE PROCEDURE E_AcptMDoc_wCstDclr(): SCAL[2];
 BEGIN
  RETURN L_General.IsPolakSpecific();
 END {E_AcptMDoc_wCstDclr};

 PUBLIC PROCEDURE MDocKind_wCstDclr(_MDocKind: LIKE(MDocKind.MDocKind);
                                    _Date    : DATE): SCAL[2];
  VAR
   Result: SCAL[2];
 BEGIN
  Result:=(_MDocKind = L_MDoc.md_VSF) |
          (_MDocKind = L_MDoc.md_ViP) |
          (_MDocKind = L_MDoc.md_ISF) |
          (_MDocKind = L_MDoc.md_TOV) |
          (_MDocKind = L_MDoc.md_Spc);
  IF E_AcptMDoc_wCstDclr() THEN
   IF ~Result THEN
    SAVE(MDocKind);
    L_General.CallUs(SEARCH(MDocKind, MDocKind, _MDocKind));
    Result:=(IsAcptMDocKind(_MDocKind) & L_MDoc.IsSellMDocKind());
    RESTORE(MDocKind);
   END;
  END;
  RETURN Result;
 END {MDocKind_wCstDclr};

 PUBLIC PROCEDURE IsMDocKindWithJustCopyCstDclr(trgMDocKind: LIKE(MDocKind.MDocKind)): SCAL[2];
 BEGIN
  IF E_AcptMDoc_wCstDclr() THEN
   RETURN (trgMDocKind = L_MDoc.md_ISF);
  ELSE
   RETURN 0;
  END;
 END {IsMDocKindWithJustCopyCstDclr};

 PUBLIC PROCEDURE E_MDocListMustHasCstDclr(): SCAL[2];
  VAR
   Result: SCAL[2];
   Local : PROC;
 BEGIN
  IF ((MDocList.MDocKind = L_MDoc.md_ISF) |
      (MDocList.MDocKind = L_MDoc.md_VSF)) THEN
   Result:=MDocList.Math # E_Pmnt.MathForPayment(MDoc.Date);
  ELSE
   Result:=0;
  END;
  Local:=PROCREF(E_Pmnt.MDocListMustHasCstDclr);
  IF ~!Local THEN
   Result:=Local(Result);
  END;
  RETURN Result;
 END {E_MDocListMustHasCstDclr};

 PUBLIC PROCEDURE IsMDocListWithSignificantCstDclr(): SCAL[2];
 BEGIN
  RETURN E_MDocListMustHasCstDclr() & ~IsMDocKindWithJustCopyCstDclr(MDocList.MDocKind);
 END {IsMDocListWithSignificantCstDclr};

 PRIVATE PROCEDURE pwcd_ml_GetSign(Required, Available: NUMERIC[2]): STRING[];
 BEGIN
  IF    Required = Available THEN
   RETURN "";
  ELSIF Required < Available THEN
   RETURN "+";
  ELSIF MthCD.Amount < 0 THEN
   RETURN "?";
  ELSE
   RETURN "-";
  END;
 END {pwcd_ml_GetSign};

 PRIVATE PROCEDURE pwcd_MakeList(_Math: LIKE(Math.Math); Required: NUMERIC[2]): STRING[];
  VAR
   Result: STRING[];
 BEGIN
  Result:="";
  SELECT(MthCD, MthCD);
  WHILE OCCURE(MthCD) DO
   IF MthCD.Amount # 0 THEN
    SEARCH(CstDclr, CstDclr, , MthCD._CstDclr);
    CONFORM(CstDclr, Country);
    Result:=Result+CstDclr.CstDclr                         + " " +
                   Str.Align(Country.Name,    8, LEFT)     + " " +
                   Str.Align(CstDclr.Number, 32, LEFT)     + " " +
                   Str.Align(L_MathR.DefaultFormatCir(_Math, MthCD.Amount), 10, RIGHT) + " " +
                   pwcd_ml_GetSign(Required, MthCD.Amount) +
                   Str.Align(L_MathR.DefaultFormatCir(_Math, MthCD.Total ), 10, RIGHT) + " " +
                   pwcd_ml_GetSign(Required, MthCD.Total) +
                   "|";
   END;
   NEXT(MthCD);
  END; (* WHILE OCCURE(MthCD) ... *)
  RETURN Result;
 END {pwcd_MakeList};

 PRIVATE PROCEDURE pwcd_FindTheBest(_Math: LIKE(Math.Math); Required: NUMERIC[2]): STRING[];
  VAR
   _CstDclr: LIKE(CstDclr.CstDclr);
 BEGIN
  SETEMPTY(_CstDclr);
  IF Required > 0 THEN
   SELECT(MthCD, MthCD);
   WHILE OCCURE(MthCD) DO
    IF MthCD.Total >= Required THEN
     IF    Required = MthCD.Amount THEN
      RETURN MthCD._CstDclr;
     ELSIF !_CstDclr & (Required < MthCD.Amount) THEN
      _CstDclr:=MthCD._CstDclr;
     END;
    END;
    NEXT(MthCD);
   END; (* WHILE OCCURE(MthCD) ... *)
  END;
  RETURN _CstDclr;
 END {pwcd_FindTheBest};

 PRIVATE PROCEDURE ProceedWithCstDclr(FinalProc: PROC): STRING[];
  VAR
   curMDocKind: LIKE(MDocList.MDocKind);
   curMDoc    : LIKE(MDocList.MDoc);
   curMDocDate: DATE;
   curMath    : LIKE(Math.Math);
   curMDLNbr  : LIKE(MDocList.MDLNbr);
   _Cir2      : NUMERIC[2];
   Dir        : NUMERIC[0];
   Result     : STRING[];
   curMyFirm  : P_Firm.tMyFirm;
 BEGIN
  L_General.Assert(ACCESS(MDocList) & ~!MDocList.Math, " ⠭ ");
  curMath    :=MDocList.Math;
  curMDocKind:=MDocList.MDocKind;
  curMDoc    :=MDocList.MDoc;
  curMDLNbr  :=MDocList.MDLNbr;
  curMDocDate:=MDoc.Date;
  APP.Get().NewPrompt(" . " + L_MDoc.MDocStr(curMDocKind, curMDoc) + ",  " + curMath);
  IF MDoc.MyFirm = P_Firm.mf_Fict THEN
   SAVE(MDocList);
   curMyFirm:=L_MDoc.GetMDocMyFirm();
   RESTORE(MDocList);
   L_General.Assert(~!curMyFirm, " । ' ࣠  ⥪饣 '");
  ELSE
   curMyFirm:=MDoc.MyFirm;
  END;
  SAVE(MDoc);
  SAVE(MDocList);
  IF !DATABASE.Get().Tables("MthCD") THEN
   L_AFM.MakeMultipleIndex("MthCD", "_CstDclr: LIKE(CstDclr.CstDclr);"+
                                    "Amount  : NUMERIC[2];"+
                                    "Total   : NUMERIC[2]",
                           "MthCD: _CstDclr");
  ELSE
   L_AFM.ReattachTemp("MthCD", "MthCD");
  END;

  SELECT(MDocList, Math, , curMath);
  WHILE OCCURE(MDocList) DO
   PROMPT(L_MDoc.MDocStr(MDocList.MDocKind, MDocList.MDoc));
   CONFORM(MDocList, MDoc);
   CONFORM(MDocList, Math);
   IF IsMDocListWithSignificantCstDclr() THEN
    IF ((MDocList.MDocKind # curMDocKind) |
        (MDocList.MDoc # curMDoc) |
        ((MDocList.MDLNbr # curMDLNbr) & ~!MDocList.CstDclr)) THEN
     IF (MDoc.Status # L_MDoc.st_Canceled) & ((MDoc.MyFirm = curMyFirm)|(MDoc.MyFirm = P_Firm.mf_Fict)) THEN
      IF ~!MDocList.CstDclr THEN
       _Cir2:=L_MDoc.GetMDocListCir2();
       IF L_MDoc.getMDocListMathFlowType() = L_MDoc.mft_Debit THEN
        Dir:=+1;
       ELSE
        Dir:=-1;
       END;
       IF MDoc.Date <= curMDocDate THEN
        ADD(MthCD, MthCD, , MDocList.CstDclr,
            MthCD.Amount, Dir*_Cir2,
            MthCD.Total,  Dir*_Cir2);
       ELSE
        ADD(MthCD, MthCD, , MDocList.CstDclr,
            MthCD.Amount,         0,
            MthCD.Total,  Dir*_Cir2);
       END;
      ELSIF MDoc.Status = L_MDoc.st_Passed THEN
(*
        L_General.Error(" ᪥ ᢮    " + MDocList.Math + "|" +
                        "㦥 㬥: " + L_MDoc.MDocStr(MDocList.MDocKind, MDocList.MDoc) + "|" +
                        " , ⮣     㪠.");
*)
      END;
     END;
    END; (* IF not curMDocList *)
   END; (* IF IsMDocListWithSignificantCstDclr() ... *)
   NEXT(MDocList);
  END; (* WHILE OCCURE(MDocList) ... *)
  RESTORE(MDocList);
  RESTORE(MDoc);
  Result:=FinalProc(curMath, L_MDoc.GetMDocListCir2());
  L_AFM.AF_PurgeTemp("MthCD");
  RETURN Result;
 END {ProceedWithCstDclr};

 PRIVATE PROCEDURE BuildCstDclrListForViP(): STRING[];
  VAR
   CUCopyList: STRING[];
   Alike     : SCAL[2];
   _FirmName : STRING[];
   Dummy     : STRING[];
   rfXDocType: L_XDoc.tXDocType;
   rfXDocKind: L_XDoc.tXDocKind;
   rfXDoc    : L_XDoc.tXDoc;
   Result    : STRING[];
 BEGIN
  SAVE(MDoc);
  SAVE(MDocList);
  SAVE(MDocLCU);
  CUCopyList:="";
  CONFORM(MDocList, MDocLCU);
  WHILE OCCURE(MDocLCU) DO
   CUCopyList:=CUCopyList + MDocLCU.CUCopy + "|";
   NEXT(MDocLCU);
  END; (* WHILE OCCURE(MDocLCU) ... *)
  CHANGESEL(MDocList, Math, , MDocList.Math);
  Result:="";
  WHILE OCCURE(MDocList) DO
   IF ~!MDocList.CstDclr & ~IsMDocKindWithJustCopyCstDclr(MDocList.MDocKind) THEN
    CONFORM(MDocList, MDoc);
    IF (MDoc.Status # L_MDoc.st_Canceled) &
       (L_MDoc.getMDocListMathFlowType() = L_MDoc.mft_Credit) THEN
     Alike:=0;
     IF ~!CUCopyList THEN
      IF MDocList.MDocKind = L_MDoc.md_ISF THEN
       L_XDoc.DecodeXDocId(L_XDoc.GetBaseOnXDocId(L_XDoc.XDocId(L_XDoc.xdt_MDoc, MDocList.MDocKind, MDocList.MDoc)),
                           rfXDocType, rfXDocKind, rfXDoc);
       L_General.CallUs(rfXDocType = L_XDoc.xdt_MDoc);
       SELECT(MDocLCU, MDoc, , rfXDocKind, rfXDoc, MDocList.MDLNbr);
      ELSE
       CONFORM(MDocList, MDocLCU);
      END;
      WHILE OCCURE(MDocLCU) DO
       IF Str.Pos(CUCopyList, MDocLCU.CUCopy) < Str.Length(CUCopyList) THEN
        Alike:=1;
       END;
       NEXT(MDocLCU);
      END; (* WHILE OCCURE(MDocLCU) ... *)
     END;
     IF ~!MDoc.Contract THEN
      CONFORM(MDoc, Contract);
      _FirmName:=P_Firm.FP_FirmShortName(Contract.Firm, MDoc.Date);
     ELSIF ~!MDoc.Firm THEN
      _FirmName:=P_Firm.FP_FirmShortName(MDoc.Firm, MDoc.Date);
     ELSE
      _FirmName:=P_Firm.FP_FirmShortName(P_Firm.OWN_FIRM, MDoc.Date);
     END;
     Dummy:=      MDocList.CstDclr                         +
            " " + L_Str.PoolItem("-|", Alike)             +
            " " + L_MDoc.MDocStr(MDoc.MDocKind, MDoc.MDoc) +
            " " + L_DatTim.DateStr(MDoc.Date)              +
            " " + Str.Align(_FirmName, 32, LEFT)           ;
     IF Alike THEN
      Result:=Dummy + "|" + Result;
     ELSE
      Result:=Result + Dummy + "|";
     END;
    END;
   END;
   PREV(MDocList);
  END; (* WHILE OCCURE(MDocList) ... *)
  RESTORE(MDocLCU);
  RESTORE(MDocList);
  RESTORE(MDoc);
  RETURN Result;
 END {BuildCstDclrListForViP};

 PUBLIC PROCEDURE FindMDocListCstDclr();
  VAR
   List  : STRING[];
   Choice: NUMERIC[0];
 BEGIN
  IF L_MDoc.getMDocListMathFlowType() = L_MDoc.mft_Credit THEN
   List:=ProceedWithCstDclr(PROCREF(pwcd_MakeList));
  ELSIF MDocList.MDocKind = L_MDoc.md_ViP THEN
   List:=BuildCstDclrListForViP();
  ELSE
   L_General.Error("롮   ⮫쪮  ଫ 室 ");
  END;
  Choice:=L_StdFrm.ShowListAsMenu(List, "롮 ");
  SEARCH(CstDclr, CstDclr, , Str.Item(L_Str.PoolItem(List, Choice), " ", 0));
  MDocList.CstDclr:=CstDclr.CstDclr;
  REPLACE(MDocList);
 END {FindMDocListCstDclr};

 PRIVATE PROCEDURE GetMDocListCstDclrFromBaseMDoc(): LIKE(CstDclr.CstDclr);
  VAR
   basXDocId      : L_XDoc.tXDocId;
   Result         : LIKE(CstDclr.CstDclr);
   ctrMath        : LIKE(Math.Math);
   NeedCondenseMDL: SCAL[2];
   curMDLNbr,
   needMDLNbr     : LIKE(MDocList.MDLNbr);
   curMDocKind    : LIKE(MDocList.MDocKind);
   curMDoc        : LIKE(MDocList.MDoc);
   curMath        : LIKE(MDocList.Math);
   curMMode       : LIKE(MDocList.MMode);
   curSum         : LIKE(MDocList.Sum);
   curQnt         : LIKE(MDocList.Qnt);
   curVAT         : LIKE(MDocList.VAT);
   curVATMode     : LIKE(MDocList.VATMode);
 BEGIN
  SETEMPTY(Result);

  ctrMath:=P_Cntr.GetCntrProSoft(MDoc.Contract, MDoc.Date, P_Cntr.P_SingleMath);
  NeedCondenseMDL:=NeedCondenseSingleMathMDocList(ctrMath, MDoc.Contract);
  L_General.Assert(~NeedCondenseMDL, L_MDoc.MDocStr(MDocList.MDocKind, MDocList.MDoc)+":   ' ᨨ'   - ⢥ । ?");

  curMDocKind:=MDocList.MDocKind;
  curMDoc    :=MDocList.MDoc;
  curMDLNbr  :=MDocList.MDLNbr;
  curMath    :=MDocList.Math;
  curMMode   :=MDocList.MMode;
  curSum     :=MDocList.Sum;
  curQnt     :=MDocList.Qnt;
  curVAT     :=MDocList.VAT;
  curVATMode :=MDocList.VATMode;

  SAVE(MDocList);
  SAVE(MDoc);
  basXDocId:=L_XDoc.GetBaseOnXDocId(L_XDoc.curXDocId(L_XDoc.xdt_MDoc));
  L_General.Assert(~!basXDocId, " 室 㬥  "+L_MDoc.MDocStr(MDocList.MDocKind, MDocList.MDoc));
  L_General.CallUs(L_XDoc.ExtractXDocType(basXDocId) = L_XDoc.xdt_MDoc);
  L_XDoc.PositionOnXDoc(basXDocId);

  needMDLNbr:=0;
  CONFORM(MDoc, MDocList);
  LOOP
   IF ~OCCURE(MDocList) THEN
    EXIT;
   END;
   IF IsAcptToVATMDocList() THEN
    INC(needMDLNbr);
    IF needMDLNbr = curMDLNbr THEN
     EXIT;
    END;
   END;
   NEXT(MDocList);
  END; (* LOOP ... *)
  IF OCCURE(MDocList) &
     (MDocList.Math    = curMath) &
     (MDocList.MMode   = curMMode) &
     (MDocList.Sum     = curSum) &
     (MDocList.Qnt     = curQnt) &
     (MDocList.VAT     = curVAT) &
     (MDocList.VATMode = curVATMode) THEN
   L_General.CallUs(E_MDocListMustHasCstDclr());
   L_General.Assert(~!MDocList.CstDclr, " 㪠   "+L_MDoc.MDocStr(MDocList.MDocKind, MDocList.MDoc)+" ப "+MDocList.MDLNbr);
   Result:=MDocList.CstDclr;
  ELSE
   L_General.Error("室 ਢ  ᮮ⢥⢨ "+L_MDoc.MDocStr(curMDocKind, curMDoc)+"  "+L_MDoc.MDocStr(MDoc.MDocKind, MDoc.MDoc));
  END;

  RESTORE(MDocList);
  RESTORE(MDoc);

  RETURN Result;
 END {GetMDocListCstDclrFromBaseMDoc};

 PUBLIC PROCEDURE GetMDocListCstDclr(): LIKE(CstDclr.CstDclr);
 BEGIN
  IF P_Math.IsDomesticManufacture(MDocList.Math, MDocList.Date) THEN
   RETURN CstDclr_DomesticManufacture;
  ELSIF IsMDocKindWithJustCopyCstDclr(MDocList.MDocKind) THEN
   RETURN GetMDocListCstDclrFromBaseMDoc();
  ELSIF IsVATMDocKind(MDocList.MDocKind) | (L_MDoc.getMDocListMathFlowType() = L_MDoc.mft_Credit) THEN
   RETURN ProceedWithCstDclr(PROCREF(pwcd_FindTheBest));
  ELSE
   RETURN "";
  END;
 END {GetMDocListCstDclr};

 PRIVATE PROCEDURE StandOnContractBySrcNbr(_MyFirm: P_Firm.tMyFirm;
                                           D      : DATE;
                                           _Type  : LIKE(Contract.Type);
                                           _SrcNbr: LIKE(Contract.SrcNbr)): SCAL[2];
  VAR
   Result: SCAL[2];
 BEGIN
  Result:=0;
  SELECT(Contract, SrcNbr, , _SrcNbr);
  WHILE OCCURE(Contract) & ~Result DO
   IF (Contract.Leaf = 1)         &
      (Contract.Type = _Type)     &
      (Contract.MyFirm = _MyFirm) &
      L_DatTim.IsActive(D, Contract.Begin, Contract.Till) THEN
    Result:=1;
   ELSE
    NEXT(Contract);
   END;
  END; (* WHILE OCCURE(Contract) ... *)
  RETURN OCCURE(Contract);
 END {StandOnContractBySrcNbr};

 PUBLIC PROCEDURE StandOnKnownContract(_MyFirm: P_Firm.tMyFirm; D: DATE; CF: tContractFunction): SCAL[2];
 BEGIN
  L_General.CallUs(CF # cf_General);
  IF    CF = cf_PFIn THEN
   RETURN StandOnContractBySrcNbr(_MyFirm, D, L_Cntr.ct_Prch, "1010610");
  ELSIF CF = cf_PFAc THEN
   RETURN StandOnContractBySrcNbr(_MyFirm, D, L_Cntr.ct_Prch, "1010620");
  ELSIF CF = cf_TrvmObl THEN
   RETURN StandOnContractBySrcNbr(_MyFirm, D, L_Cntr.ct_Prch, "39310202050071000160");
  ELSE
   L_General.CallUs(0);
  END;
 END {StandOnKnownContract};

 PUBLIC PROCEDURE GetStandartVATRate(D: DATE): tVATRates;
 BEGIN
  IF D >= 01\01\2004 THEN RETURN vr_18;
  ELSE                    RETURN vr_20;
  END;
 END {GetStandartVATRate};

 PUBLIC PROCEDURE GetPreferentialVATRate(D: DATE): tVATRates;
 BEGIN
  RETURN vr_10;
 END {GetPreferentialVATRate};

 PRIVATE PROCEDURE GetVATRate(D: DATE; Value: tValuesToBalance): tVATRates;
  VAR
   VATPrc: NUMERIC[0];
   Result: tVATRates;
 BEGIN
  IF Value[vtb_Netto] # 0 THEN
   VATPrc:=Value[vtb_VAT] / Value[vtb_Netto] * 100;
   IF (D >= 01\01\2004) & (VATPrc = 18) THEN
    Result:=vr_18;
   ELSIF VATPrc = 20 THEN Result:=vr_20;
   ELSIF VATPrc = 10 THEN Result:=vr_10;
   ELSIF VATPrc = 00 THEN
    IF CalcVAT(Value[vtb_Netto], GetStandartVATRate(D)) = 0 THEN
     Result:=vr_UK;
    ELSE
     Result:=vr_00;
    END;
   ELSE
    Result:=vr_UK;
   END;
  ELSIF Value[vtb_VAT] # 0 THEN
   Result:=vr_UK;
  ELSE
   Result:=vr_00;
  END;
  RETURN Result;
 END {GetVATRate};

 PUBLIC PROCEDURE GetMDocListVATRate(): tVATRates;
  VAR
   msatVAT       : P_Math.tSpecialAttitudeToVAT;
   vtb_ByMDocList: tValuesToBalance;
   Result        : tVATRates;
 BEGIN
  CONFORM(MDocList, Math);
  CONFORM(Math, MathType);
  vtb_ByMDocList:=GetMDocListAcpt();
  Result:=GetVATRate(MDoc.Date, vtb_ByMDocList);
  IF ~!MDoc.Contract & P_Cntr.GetSpecialAttitudeToVAT(MDoc.Contract, MDoc.Date) # P_Cntr.satVAT_woFeatures THEN
   L_General.Assert(vtb_ByMDocList[vtb_VAT] = 0,
                    "㫥   ,  饬 ꥪ⮬   ");
   Result:=vroNV;
  ELSE
   msatVAT:=P_Math.GetSpecialAttitudeToVAT(MDocList.Math, MDoc.Date);
   IF msatVAT = P_Math.satVAT_TaxFree THEN
    L_General.Assert(vtb_ByMDocList[vtb_VAT] = 0,
                     "㫥   ,   ");
    Result:=vr_NV;
   ELSE
    IF (Result = vr_00) & L_MathR.E_IsComplexMath(MDoc.Date) THEN
     Result:=vr_UK;
    END;
    IF    (Result = vr_UK) THEN
     IF    (msatVAT = P_Math.satVAT_woFeatures) THEN
      Result:=GetStandartVATRate(MDoc.Date);
     ELSIF (msatVAT = P_Math.satVAT_IncentiveRate) THEN
      Result:=GetPreferentialVATRate(MDoc.Date);
     END;
    ELSIF (Result = vr_00) THEN
     IF (MDocList.Math = E_Pmnt.MathForPayment(MDoc.Date)) THEN
      Result:=vr_NV;
     ELSIF ~!MDoc.Contract & P_Cntr.GetInHouse(MDoc.Contract, MDoc.Date) THEN
      IF MathType.Category = L_Acnt.mtc_Inventories THEN
       Result:=vr_NV;
      ELSE
       Result:=vroNV;
      END;
     END;
    END;
   END;
  END;
  IF (MathType.Category = L_Acnt.mtc_StrangeGains) & (Result # vroNV) THEN
   L_General.Assert(Result = vr_NV,
                    ' ⥣ਨ "'+L_Str.PoolItem(L_Acnt.mtc_Pool, MathType.Category)+'"    ');
   Result:=vroNV;
  END;
  RETURN Result;
 END {GetMDocListVATRate};

 PRIVATE PROCEDURE GetMDocNettobyRate(): tValuesByVATRate;
  VAR
   VATRate: tVATRates;
   Result : tValuesByVATRate;
 BEGIN
  SETZERO(Result);
  IF (MDoc.Status#L_MDoc.st_Canceled) THEN
   CONFORM(MDoc, MDocList);
   WHILE OCCURE(MDocList) DO
    INC(Result[GetMDocListVATRate()], MDocList.Sum);
    NEXT(MDocList);
   END; (* WHILE OCCURE(MDocList) ... *)
  END;
  RETURN Result;
 END {GetMDocNettobyRate};

 PUBLIC PROCEDURE DateOfPerformanceOfLiability(_Date    : DATE;
                                               _Duration: NUMERIC[0]): DATE;
 BEGIN
  _Date:=_Date+_Duration-1;
  L_General.Assert(SEARCH(Calendar, Date, _Date), L_DatTim.DateStr(_Date)+"   ");
  WHILE Calendar.WeekDay > L_DatTim.wd_Fri DO
   INC(_Date);
   L_General.Assert(SEARCH(Calendar, Date, _Date), L_DatTim.DateStr(_Date)+"   ");
  END;
  RETURN _Date;
 END {DateOfPerformanceOfLiability};

 PUBLIC PROCEDURE GetMDocPayDate(trgPayDuration: NUMERIC[0]): DATE;
  VAR
   refDate: DATE;
 BEGIN
  refDate:=MDoc.SrcDate;
  TRY [ABORT_AFTER(AA_ON)]
   TABLE.Get("XDocJrn").AccessDataMode:=adm_HOTTEST;
   IF SELECT(XDocJrn, XDocJrn, L_XDoc.xdt_MDoc, MDoc.MDocKind, MDoc.MDoc) THEN
    refDate:=Math.Max(refDate, XDocJrn.Date);
   END;
  EXCEPT
  END; (* TRY *)
  IF L_DatTim.IncMonth(MDoc.SrcDate, -1) = L_DatTim.Per(MDoc.Date) (* 0099674  ਧ 㬥    諮  㣠 *) THEN
   IF refDate > L_DatTim.IncWorkDay(L_DatTim.MonthEnd(MDoc.Date), +1) THEN
    refDate:=L_DatTim.IncWorkDay(refDate, +1);
   END;
  END;
  RETURN DateOfPerformanceOfLiability(refDate, trgPayDuration);
 END {GetMDocPayDate};

 PRIVATE PROCEDURE _IsOfflineVATMDocExist(_MDocKind: LIKE(MDoc.MDocKind); P: DATE): SCAL[2];
 BEGIN
  SAVE(MDoc);
  SETSEL(MDoc, MDKDate, _MDocKind);
  SRCINSEL(MDoc, GE, , P);
  WHILE OCCURE(MDoc) DO
   IF (MDoc.Status # L_MDoc.st_Canceled) &
      (E_StageOfBuildingVATMDoc(MDoc.Date, MDoc.MDocKind, MDoc.Dest) = sbvmd_Offline) THEN
    RESTORE(MDoc);
    RETURN 1;
   END;
   NEXT(MDoc);
  END; (* WHILE OCCURE(MDoc) ... *)
  RESTORE(MDoc);
  RETURN 0;
 END {_IsOfflineVATMDocExist};

 PRIVATE PROCEDURE IsOfflineVATMDocExist(P: DATE): SCAL[2];
 BEGIN
  RETURN _IsOfflineVATMDocExist(L_MDoc.md_DPr, P) |
         _IsOfflineVATMDocExist(L_MDoc.md_DPk, P);
 END {IsOfflineVATMDocExist};

 PUBLIC PROCEDURE IsSpecialVATMDocDone(trgContract: LIKE(Contract.Contract); P: DATE): SCAL[2];
  VAR
   Result: SCAL[2];
 BEGIN
  SAVE(Contract);
  SEARCH(Contract, Contract, , trgContract);
  CONFORM(Contract, XObject);
  Result:=L_XObj.XODone_IsSingleIntermediateDone(P, L_XObj.xoid_Contract_SpecVATMDocNeed);
  RESTORE(Contract);
  RETURN Result;
 END {IsSpecialVATMDocDone};

 PUBLIC PROCEDURE CheckSpecialVATMDocDone(trgContract: LIKE(Contract.Contract); D: DATE);
  VAR
   P, PFrom: DATE;
 BEGIN
  SAVE(Contract);
  SEARCH(Contract, Contract, , trgContract);
  PFrom:=L_DatTim.Per(Math.Min(D, L_DatTim.MonthBeg(SYSDATE())-1)); (*   祭 -  ᫠ 㣠*)
  P:=PFrom;
  WHILE ~IsSpecialVATMDocDone(Contract.Contract, P) DO
   PFrom:=P;
   P:=L_DatTim.PrevPer(P);
  END;
  L_General.Assert(P = PFrom, "ॡ (-)ନ஢    "+Contract.Contract+"  "+L_DatTim.PeriodStr(PFrom));
  RESTORE(Contract);
 END {CheckSpecialVATMDocDone};

 PUBLIC PROCEDURE CheckSpecialVATMDocDoneAll(trgMyFirm: LIKE(Contract.MyFirm); D: DATE);
 BEGIN
  APP.Get().NewPrompt("஢ઠ ");
  IF ~!trgMyFirm THEN
   SETSEL(Contract, MyFirm, trgMyFirm);
  ELSE
   SETSEL(Contract, Leaf, 1);
  END;
  FOR_EACH Contract DO
   PROMPT(" "+Contract.Contract);
   IF Contract.Leaf = 1 THEN
    CheckSpecialVATMDocDone(Contract.Contract, D);
   END;
  END; (* FOR_EACH Contract *)
 END {CheckSpecialVATMDocDoneAll};

 PUBLIC PROCEDURE SetSpecialVATMDocDone(trgContract: LIKE(Contract.Contract); P: DATE; trgDone, forceFix: SCAL[2]);
 BEGIN
  SAVE(Contract);
  L_Cntr.PositionOnContract(trgContract);
  L_XObj.AccessXObject(Contract.XObject);
  IF (trgDone = 0) &
    ~(DoSpecialVATMDoc(trgContract, P) & (GetContractAccountingBegin(trgContract) <= L_DatTim.NextPer(P))) THEN
   trgDone:=L_XObj.XODone_IsSingleIntermediateDone(L_DatTim.PrevPer(P), L_XObj.xoid_Contract_SpecVATMDocNeed);
   forceFix:=~trgDone;
  END;
  L_XObj.XODone_SetSingleIntermediate(P, L_XObj.xoid_Contract_SpecVATMDocNeed, trgDone, forceFix);
  RESTORE(Contract);
 END {SetSpecialVATMDocDone};

 PRIVATE PROCEDURE sob_Put(Sign       : NUMERIC[0];
                           D          : DATE;
                           curContract,
                           trgContract: LIKE(Contract.Contract);
                           IsDebit    : SCAL[2];
                           Sum        : L_XObj.tSum);
  VAR
   _Apport  : LIKE(Apport.Apport);
   saveDate : DATE;
 BEGIN
  IF !trgContract | (curContract = trgContract) THEN
   SetSpecialVATMDocDone(curContract, L_DatTim.Per(D), 0, 1);
   IF IsDebit THEN
    _Apport:=L_Acnt.E_Apport_MoneyDebit(D);
   ELSE
    _Apport:=L_Acnt.E_Apport_MoneyCredit(D);
   END;
   SAVE(Contract);
   SAVE(XObject);
   L_Cntr.PositionOnContract(curContract);
   L_XObj.AccessXObject(Contract.XObject);
   saveDate:=Memo.gl_cd();
   TRY
    Memo.gl_SetCurDate(D);
    L_XObj.mo_MakeCir(Sign,
                      L_kn.Get(D, L_AcCut.erkn_OnlineBalance),
                      L_DatTim.Per(D), _Apport,
                      L_kn.Get(D, L_AcCut.erkn_Fictive),
                      Sum,
                      L_XObj.src_Online);
    Memo.gl_SetCurDate(saveDate);
   EXCEPT
   ELSE
    Memo.gl_SetCurDate(saveDate);
    RAISE();
   END;
   RESTORE(XObject);
   RESTORE(Contract);
  END;
 END {sob_Put};

 PRIVATE PROCEDURE sob_CheckContractValidity(D          : DATE;
                                             trgContract: LIKE(Contract.Contract);
                                             trgXDocId  : L_XDoc.tXDocId);
 BEGIN
  IF ~!trgContract THEN
   SAVE(Contract);
   SEARCH(Contract, Contract, , trgContract);
   IF ~L_DatTim.IsActive(D, Contract.Begin, Contract.Till) THEN
    L_General.Error(L_XDoc.XDocStr(trgXDocId) + ": ⭠   ਮ ਬ  " + Contract.Contract);
   END;
   RESTORE(Contract);
  END;
 END {sob_CheckContractValidity};

 PUBLIC PROCEDURE sc_SupportOnlineBalance(DocType    : L_XDoc.tXDocType;
                                          Sign       : NUMERIC[0];
                                          trgContract: LIKE(Contract.Contract));
  VAR
   JDocId: L_XDoc.tXDocId;
 BEGIN
  TRY
   L_General.SetConcurrentMode();
   SETEMPTY(JDocId);
   IF    DocType = L_XDoc.xdt_MDoc THEN
    IF (Sign = +1) & !trgContract & (MDoc.Status = L_MDoc.st_Passed) THEN
     sob_CheckContractValidity(MDoc.Date, MDoc.Contract, MDoc.XDocId);
    END;
    IF MDoc.Status # L_MDoc.st_Canceled THEN
     IF !MDoc.Contract | TakeMDocIntoAccount() THEN
      IF    IsAcptMDocKind(MDoc.MDocKind) & ~L_MDoc.IsMDoc_wJDocOnly() THEN
       sob_Put(Sign, MDoc.Date, MDoc.Contract, trgContract, E_IsSellMDoc(), vtbExtractTotal(GetMDocAcpt()));
      END;
     END;
     JDocId:=L_XDoc.GetAnnexXDocId(MDoc.XDocId);
     IF IsVATMDocKind(MDoc.MDocKind) THEN
      SetSpecialVATMDocDone(MDoc.Contract, L_DatTim.Per(MDoc.Date), 0, 1);
     END;
    END;
   ELSIF DocType = L_XDoc.xdt_PDoc THEN
    SAVE(PDoc);
    SAVE(PDocMDoc);
    IF !trgContract THEN
     SELECT(PDocMDoc, PDoc, , PDoc.PDocKind, PDoc.PDoc);
    ELSE
     CONFORM(PDocMDoc, PDoc);
     CHANGESEL(PDocMDoc, PDoc, , PDocMDoc.PDocKind, PDocMDoc.PDoc, PDocMDoc.MDocKind, PDocMDoc.MDoc);
    END;
    IF (PDoc.Status # L_PDoc.st_Canceled) THEN
     WHILE OCCURE(PDocMDoc) DO
      IF (Sign = +1) & !trgContract & (PDoc.Status = L_PDoc.st_Passed) THEN
       sob_CheckContractValidity(PDoc.Date, PDocMDoc.Contract, PDoc.XDocId);
      END;
      IF TakePDocMDocIntoAccount() & ~L_PDoc.IsPDoc_wJDocOnly() THEN
       sob_Put(Sign, PDoc.Date, PDocMDoc.Contract, trgContract, L_PDoc.IsOutPDoc(PDocMDoc.PDocKind), vtbExtractTotal(vtbGetByPDocMDoc()));
      END;
      NEXT(PDocMDoc);
     END; (* OCCURE(PDocMDoc) *)
     JDocId:=L_XDoc.GetAnnexXDocId(PDoc.XDocId);
    END;
    RESTORE(PDocMDoc);
    RESTORE(PDoc);
   ELSIF DocType = L_XDoc.xdt_JDoc THEN
    IF JDoc.Status # L_JDoc.st_Canceled THEN
     JDocId:=JDoc.XDocId;
    END;
   ELSE
    L_General.CallUs(0);
   END;
   IF ~!JDocId THEN
    IF L_XDoc.ExtractXDocType(JDocId) = L_XDoc.xdt_JDoc THEN
     L_XDoc.PositionOnXDoc(JDocId);
     CONFORM(JDoc, JDocList);
     WHILE OCCURE(JDocList) DO
      IF (L_XObj.GetXObjectOrigin(JDocList.XObject) = L_XObj.o_Contract) &
          ItCntrBalAcCut(JDocList.AcCut, JDoc.Date) &
          (JDoc.Date >= GetContractAccountingBegin(getXObject_OriginId(JDocList.XObject))) THEN
       SEARCH(Apport, Apport, , JDocList.Apport);
       sob_Put(Sign, JDoc.Date, getXObject_OriginId(JDocList.XObject), trgContract, Apport.CirType = L_Acnt.ct_Debit, JDocList.Sum);
      END;
      IF (L_XObj.GetXObjectOrigin(JDocList.XObject2) = L_XObj.o_Contract) &
         ItCntrBalAcCut(JDocList.AcCut2, JDocList.Date) &
         (JDoc.Date >= GetContractAccountingBegin(getXObject_OriginId(JDocList.XObject2))) THEN
       SEARCH(Apport, Apport, , JDocList.Apport2);
       sob_Put(Sign, JDoc.Date, getXObject_OriginId(JDocList.XObject2), trgContract, Apport.CirType = L_Acnt.ct_Debit, JDocList.Sum);
      END;
      NEXT(JDocList);
     END; (* WHILE OCCURE(JDocList) ... *)
    ELSE
     L_General.CallUs(0);
    END;
   END; (* IF ~!JDocId ... *)
  EXCEPT
  END; (* TRY *)
 END {sc_SupportOnlineBalance};

 PUBLIC PROCEDURE SupportOnlineBalance(DocType: L_XDoc.tXDocType;
                                       Sign   : NUMERIC[0]);
 BEGIN
  sc_SupportOnlineBalance(DocType, Sign, EMPTYOF(Contract.Contract));
 END {SupportOnlineBalance};

(*-------------- Begin of normal environment----------------------*)

 PUBLIC PROCEDURE E_MathIsService(): SCAL[2];
  VAR
   Local: PROC;
 BEGIN
  Local:=PROCREF(E_Pmnt.MathIsService);
  IF ~!Local THEN
   RETURN Local();
  ELSE
   RETURN 0;
  END;
 END {E_MathIsService};

 PUBLIC PROCEDURE IsAcptMDocKind(_MDocKind: LIKE(MDoc.MDocKind)): SCAL[2];
 BEGIN
  RETURN (_MDocKind = L_MDoc.md_IAS) |
         (_MDocKind = L_MDoc.md_ITN) |
         (_MDocKind = L_MDoc.md_VTN) |
         (_MDocKind = L_MDoc.md_VhA) |
         (_MDocKind = L_MDoc.md_NDk) |
         (_MDocKind = L_MDoc.md_RPr) |
         (_MDocKind = L_MDoc.md_RPk) |
         (_MDocKind = L_MDoc.md_OBK) |
         (_MDocKind = L_MDoc.md_PPr) |
         (_MDocKind = L_MDoc.md_PPR) |
         (_MDocKind = L_MDoc.md_PPk) |
         (_MDocKind = L_MDoc.md_PPK) |
         (_MDocKind = L_MDoc.md_FPk) |
         (_MDocKind = L_MDoc.md_FPr) |
         (_MDocKind = L_MDoc.md_ISA) |
         (_MDocKind = L_MDoc.md_VAP) |
         (_MDocKind = L_MDoc.md_IAP) ;
 END {IsAcptMDocKind};

(*!*) PUBLIC PROCEDURE E_IsAcptMDoc(): SCAL[2];
 BEGIN
  RETURN IsAcptMDocKind(MDoc.MDocKind);
 END {E_IsAcptMDoc};

 PUBLIC PROCEDURE IsMayBePaidMDocKind(_MDocKind: LIKE(MDoc.MDocKind)): SCAL[2];
 BEGIN
  RETURN (_MDocKind = L_MDoc.md_IsS) |
         (_MDocKind = L_MDoc.md_VhS) |
         (_MDocKind = L_MDoc.md_NDk) |
         (_MDocKind = L_MDoc.md_NlO) |
         (_MDocKind = L_MDoc.md_RPr) |
         (_MDocKind = L_MDoc.md_RPk) |
         (_MDocKind = L_MDoc.md_OBK) |
         (_MDocKind = L_MDoc.md_PPk) |
         (_MDocKind = L_MDoc.md_PPr) |
         (_MDocKind = L_MDoc.md_FPk) |
         (_MDocKind = L_MDoc.md_ISA) |
         (_MDocKind = L_MDoc.md_VOD) |
         (_MDocKind = L_MDoc.md_IOD);
 END {IsMayBePaidMDocKind};

(*!*) PUBLIC PROCEDURE E_IsMayBePaidMDoc(): SCAL[2];
 BEGIN
  RETURN IsMayBePaidMDocKind(MDoc.MDocKind);
 END {E_IsMayBePaidMDoc};

 PUBLIC PROCEDURE E_IsSellMDoc(): SCAL[2];
  VAR
   Result: SCAL[2];
 BEGIN
  SAVE(MDocKind);
  CONFORM(MDoc, MDocKind);
  Result:=L_MDoc.IsSellMDocKind();
  RESTORE(MDocKind);
  RETURN Result;
 END {E_IsSellMDoc};

 PRIVATE PROCEDURE E_IsPrchMDoc(): SCAL[2];
  VAR
   Result: SCAL[2];
 BEGIN
  SAVE(MDocKind);
  CONFORM(MDoc, MDocKind);
  Result:=L_MDoc.IsPrchMDocKind();
  RESTORE(MDocKind);
  RETURN Result;
 END {E_IsPrchMDoc};

 PRIVATE PROCEDURE E_AM_VAT(D: DATE): L_Acnt.tAccountingMethod;
  VAR
   Local  : PROC;
   Result : L_Acnt.tAccountingMethod;
 BEGIN
  Local:=PROCREF(E_Pmnt.AM_VAT);
  IF ~!Local THEN
   Result:=Local(D);
  ELSE
   IF L_APtm.IsMTA() THEN
    Result:=L_Acnt.am_Accrual;
   ELSE
    L_General.Error(" ஥ ⮤,  ਬ  " +
                    "|" +
                    " ਧ 室  室: ᫥  ᮢ?" +
                    "||" +
                    ", ନ ᮮ⢥饥 ");
   END;
  END;
  RETURN Result;
 END {E_AM_VAT};

 PUBLIC PROCEDURE E_GetVATMDocMDocKind(D: DATE; BuildMode: tVATMDocBuildMode): LIKE(MDocKind.MDocKind);
  VAR
   default: LIKE(MDoc.MDocKind);
 BEGIN
  IF    BuildMode = vmdbm_Acceptance THEN
   L_MDoc.AccessMDoc();
   IF IsAcptMDocKind(MDoc.MDocKind) THEN
    IF P_Cntr.GetInHouse(Contract.Contract, D) THEN
     IF E_IsSellMDoc() THEN
      default:=L_MDoc.md_DPr;
     ELSE
      default:=L_MDoc.md_DPk;
     END;
    ELSIF (MDoc.MDocKind = L_MDoc.md_RPr) |
          (MDoc.MDocKind = L_MDoc.md_OBK) THEN
     default:=L_MDoc.md_DPr;
    ELSIF (MDoc.MDocKind = L_MDoc.md_FPk) THEN
     default:=L_MDoc.md_DPk;
    ELSIF (MDoc.MDocKind = L_MDoc.md_FPr) THEN
     default:=L_MDoc.md_DPr;
    ELSIF E_IsSellMDoc() THEN
     default:=L_MDoc.md_ISF;
    ELSE
     default:=L_MDoc.md_VSF;
    END;
   ELSE
    SETEMPTY(default);
   END;
  ELSIF P_Cntr.GetInHouse(Contract.Contract, D) THEN
   SETEMPTY(default);
  ELSE
   IF    (BuildMode = vmdbm_Prepayment) |
         (BuildMode = vmdbm_OnPrpShpmt) |
         (BuildMode = vmdbm_PrpReturn ) THEN
    default:=L_MDoc.md_DPr;
   ELSIF (BuildMode = vmdbm_Underpay  ) |
         (BuildMode = vmdbm_Pstpayment) THEN
    IF E_AM_VAT(D) = L_Acnt.am_Cash THEN
     default:=L_MDoc.md_DPr;
    ELSE
     SETEMPTY(default);
    END;
   ELSIF (BuildMode = vmdbm_PrchUndpay) |
         (BuildMode = vmdbm_PrchPstpay) THEN
    default:=L_MDoc.md_DPk;
   ELSE
    L_General.CallUs(0);
   END;
  END;
  RETURN default;
 END {E_GetVATMDocMDocKind};

 PUBLIC PROCEDURE E_GetVATMDocDest(D: DATE; BuildMode: tVATMDocBuildMode): LIKE(MDoc.Dest);
  VAR
   _Notion: L_APtm.tNotion;
 BEGIN
  IF    BuildMode = vmdbm_Prepayment THEN _Notion:=L_Dest.erkn_vmdbm_Prepayment; (*652*)
  ELSIF BuildMode = vmdbm_OnPrpShpmt THEN _Notion:=L_Dest.erkn_vmdbm_OnPrpShpmt; (*653*)
  ELSIF BuildMode = vmdbm_Underpay   THEN _Notion:=L_Dest.erkn_vmdbm_Underpay;   (*654*)
  ELSIF BuildMode = vmdbm_Pstpayment THEN _Notion:=L_Dest.erkn_vmdbm_Pstpayment; (*655*)
  ELSIF BuildMode = vmdbm_PrchUndpay THEN _Notion:=L_Dest.erkn_vmdbm_PrchUndpay; (*656*)
  ELSIF BuildMode = vmdbm_PrchPstpay THEN _Notion:=L_Dest.erkn_vmdbm_PrchPstpay; (*657*)
  ELSIF BuildMode = vmdbm_PrpReturn  THEN _Notion:=L_Dest.erkn_vmdbm_PrpReturn;  (*658*)
  ELSE
   L_General.CallUs(0);
  END;
  RETURN L_Dest.erkn_Get(D, _Notion);
 END {E_GetVATMDocDest};

 PUBLIC PROCEDURE GetVATMDocBuildMode(D: DATE; _Dest: LIKE(MDoc.Dest)): tVATMDocBuildMode;
  VAR
   Idx,
   Result: tVATMDocBuildMode;
 BEGIN
  Result:=EMPTYOF(tVATMDocBuildMode);
  FOR_EACH Idx DO
   IF (Idx # vmdbm_Acceptance) & (E_GetVATMDocDest(D, Idx) = _Dest) THEN
    Result:=Idx;
    EXIT;
   END;
  END;
  RETURN Result;
 END {GetVATMDocBuildMode};

 PRIVATE PROCEDURE IsSpecialVATMDocDest(D: DATE; _Dest: LIKE(MDoc.Dest)): SCAL[2];
 BEGIN
  RETURN ~!GetVATMDocBuildMode(D, _Dest);
 END {IsSpecialVATMDocDest};

 PUBLIC PROCEDURE IsVATMDocToKeepInBook(): SCAL[2];
  VAR
   bm,
   rbm       : tVATMDocBuildMode;
   ReftoMDocs: L_XDoc.tXDocCollection;
   i,
   rCnt      : NUMERIC[0];
   Result    : SCAL[2];
 BEGIN
  Result:=1;
  IF IsVATMDocKind(MDoc.MDocKind) THEN
   SAVE(Contract);
   CONFORM(MDoc, Contract);
   IF (Contract.Type = L_Cntr.ct_Sell) &
      P_Cntr.GetInHouse(MDoc.Contract, MDoc.Date) THEN
    Result:=0;
   ELSE
    bm:=GetVATMDocBuildMode(MDoc.Date, MDoc.Dest);
    IF ~!bm THEN
     IF MDoc.Date >= 01\01\2006 THEN
      IF    (bm = vmdbm_Underpay) | (bm = vmdbm_PrchUndpay) THEN
       Result:=0;
      ELSIF (bm = vmdbm_Pstpayment) | (bm = vmdbm_PrchPstpay) THEN
       rbm:=vmdbm_GetRelatedBM(bm);
       SAVE(MDoc);
       rCnt:=0;
       i:=0;
       ReftoMDocs:=L_XDoc.GetRefToXDC(L_XDoc.curXDocId(L_XDoc.xdt_MDoc), L_XDoc.xdt_MDoc);
       WHILE L_XDoc.xdc_PositionOn(ReftoMDocs, i) DO
        IF IsSpecifiedVATMDoc(rbm) THEN
         IF MDoc.Date >= 01\01\2006 THEN
          Result:=0;
         END;
         INC(rCnt);
        END;
        INC(i);
       END;
       L_General.CallUs(rCnt = 1);
       RESTORE(MDoc);
      END;
     END;
    END; (* IF ~!bm ... *)
   END;
   RESTORE(Contract);
  END; (* IF IsVATMDocKind(MDoc.MDocKind) ... *)
  RETURN Result;
 END {IsVATMDocToKeepInBook};

 PUBLIC PROCEDURE DefineMyFirm_wVAT(D: DATE): P_Firm.tMyFirm;
  VAR
   MyFirms: P_Firm.tMyFirm[100];
   i      : NUMERIC[0];
 BEGIN
  SETEMPTY(MyFirms);
  i:=0;
  SELECT(MyFirm, MyFirm);
  WHILE OCCURE(MyFirm) DO
   IF MyFirm.MyFirm # P_Firm.mf_Fict THEN
    IF ~P_Firm.FirmHasSimplifiedTaxation(P_Firm.fomf(MyFirm.MyFirm), D) THEN
     MyFirms[i]:=MyFirm.MyFirm;
     INC(i);
    END;
   END;
   NEXT(MyFirm);
  END; (* WHILE OCCURE(MyFirm) ... *)
  RETURN P_Firm.extDefineMyFirm(D, MyFirms);
 END {DefineMyFirm_wVAT};

 PUBLIC PROCEDURE E_StageOfBuildingVATMDoc(D          : DATE;
                                           VATMDocKind: LIKE(MDoc.MDocKind);
                                           VATMDocDest: LIKE(MDoc.Dest)): SCAL[2];
 BEGIN
  IF (VATMDocKind = L_MDoc.md_ISF) |
     (VATMDocKind = L_MDoc.md_VSF) THEN
   RETURN sbvmd_Online;
  ELSE
   RETURN sbvmd_Offline;
  END;
 END {E_StageOfBuildingVATMDoc};

 PUBLIC PROCEDURE E_GetSenderEMail(_XDocId: L_XDoc.tXDocId; _MyFirm: P_Firm.tMyFirm): STRING[];
  VAR
   Local: PROC;
 BEGIN
  Local:=PROCREF(E_Pmnt.GetSenderEMail);
  IF ~!Local THEN
   RETURN Local(_XDocId, _MyFirm)
  ELSE
   RETURN L_APEMl.MyFirmContact(_MyFirm);
  END;
 END {E_GetSenderEMail};

 PUBLIC PROCEDURE E_GetBlindCarbonCopyEMail(trg_iri: L_General.tInternalRecordId; trgMyFirm: P_Firm.tMyFirm): STRING[];
  VAR
   Local: PROC;
 BEGIN
  Local:=PROCREF(E_Pmnt.GetBlindCarbonCopyEMail);
  IF ~!Local THEN
   RETURN Local(trg_iri, trgMyFirm)
  ELSE
   RETURN L_APEMl.MyFirmContact(trgMyFirm);
  END;
 END {E_GetBlindCarbonCopyEMail};

 PUBLIC PROCEDURE E_DefaultMDocSrcNbr(D: DATE): STRING[];
  VAR
   Local : PROC;
   Result: STRING[];
 BEGIN
  Result:="";
  IF L_MDoc.E_FillMDocSrcNbr() # L_MDoc.fmdsn_No THEN
   IF MDoc.MyFirm # P_Firm.mf_Fict THEN
    Result:=MDoc.mfNbr;
    IF L_MDoc.E_ResetMDocNumberingFromYearBeg(D) THEN
     Result:=L_MDoc.mfNbr_woYearPart(Result);
    END;
    Local:=PROCREF(E_Pmnt.DefaultMDocSrcNbr);
    IF ~!Local THEN
     Result:=Local(D, Result);
    END;
   END;
  END;
  RETURN Result;
 END {E_DefaultMDocSrcNbr};

 PUBLIC PROCEDURE CheckXDocIsInMDoc(XDT: L_XDoc.tXDocType;
                                    P  : PROC);
  VAR
   DependentMDocs: STRING[];
   i             : NUMERIC[0];
   curXDocId     : L_XDoc.tXDocId;
 BEGIN
  curXDocId     :=L_XDoc.curXDocId(XDT);
  DependentMDocs:=L_XDoc.GetDependentXDC(curXDocId, L_XDoc.xdt_MDoc);
  i:=0;
  WHILE L_XDoc.xdc_PositionOn(DependentMDocs, i) DO
   IF (MDoc.Status # L_MDoc.st_Canceled) & P() THEN
    L_General.Error(" " + L_XDoc.XDocStr(curXDocId) +  " 㦥 ନ஢ " + L_MDoc.MDocStr(MDoc.MDocKind, MDoc.MDoc));
   END;
   INC(i);
  END; (* L_XDoc.xdc_PositionOn ... *)
 END {CheckXDocIsInMDoc};

 PUBLIC PROCEDURE E_wordAsIfSignDocument(trgMyFirm: P_Firm.tMyFirm; D: DATE; IsSigned: SCAL[2]);
  VAR
   Local   : PROC;
   fn_Sign,
   fn_Stamp: STRING[];
 BEGIN
  SETEMPTY(fn_Sign, fn_Stamp);
  IF IsSigned THEN
   Local:=PROCREF(E_Pmnt.DefineSignedDocumentPictures);
   IF ~!Local THEN
    Local(trgMyFirm, D, fn_Sign, fn_Stamp);
   END;
  END;
  L_MSO.wordSetPic("Sign_1", fn_Sign,  30, -1);
  L_MSO.wordSetPic("Stamp",  fn_Stamp, 40, -1);
 END {E_wordAsIfSignDocument};

 PUBLIC PROCEDURE ItCntrBalAcCut(trgAcCut: LIKE(AcCut.AcCut); D: DATE): SCAL[2];
  VAR
   Result: SCAL[2];
 BEGIN
  SAVE(AcCut);
  SEARCH(AcCut, AcCut, , trgAcCut);
  IF ~L_kn.Is(D, L_AcCut.erkn_VATPrepay)          &
     ~L_kn.Is(D, L_AcCut.erkn_VATUnderpay)        &
     ~L_kn.Is(D, L_AcCut.erkn_VATAccumulation)    &
     ~L_kn.Is(D, L_AcCut.erkn_BoughtKeyAssVAT)    &
     ~L_kn.Is(D, L_AcCut.erkn_BoughtInventoryVAT) &
     ~L_kn.Is(D, L_AcCut.erkn_BoughtGoodsVAT)     &
     ~L_kn.Is(D, L_AcCut.erkn_BoughtVATTransit) THEN
   L_Acnt.StandOnCAcnt(D, trgAcCut);
   Result:=CAcnt.Type = L_Acnt.catyp_Balance;
  ELSE
   Result:=0;
  END;
  RESTORE(AcCut);
  RETURN Result;
 END {ItCntrBalAcCut};

 PUBLIC PROCEDURE CheckOwnAgentCntrSumLimit(trgContract: LIKE(Contract.Contract); D: DATE);
  VAR
   TSN        : LIKE(Staff.TSN);
   DocType,
   DocSer,
   DocNum,
   DocGiveS   : STRING[];
   DocGiveD,
   DocExpD    : DATE;
   CntrSum,
   totUnderpay,
   curUnderpay: NUMERIC[2];
   Balance    : NUMERIC[2][2];
   balAcCut   : LIKE(AcCut.AcCut);
 BEGIN
  TRY [ABORT_AFTER(AA_ON)]
   P_Cntr.Get_FullOwnAgentInfo(trgContract, D, TSN, DocType, DocSer, DocNum, DocGiveS, DocGiveD, DocExpD, CntrSum);
   IF ~!CntrSum THEN
    L_General.CallUs(P_Cntr.HasActualPro(trgContract, D, P_Cntr.P_OwnAgent));
    SETZERO(Balance, totUnderpay);
    SELECT(MDocKind, MDocKind);
    WHILE OCCURE(MDocKind) DO
     IF IsMayBePaidMDocKind(MDocKind.MDocKind) THEN
      SETSEL(MDoc, CntrClsd, trgContract, MDocKind.MDocKind);
      SRCINSEL(MDoc, GE, , EMPTYOF(MDoc.Closed));
      WHILE OCCURE(MDoc) DO
       PROMPT("ᬮ 㬥⮢ " + L_MDoc.MDocStr(MDoc.MDocKind, MDoc.MDoc));
       IF (MDoc.Status # L_MDoc.st_Prepared) &
          L_DatTim.IsActive_Inc(MDoc.Date, CntrPro.Date, CntrPro.EndDate) &
          TakeMDocIntoAccount() &
          (P_MDoc.GetDealCheckType(MDoc.MDocKind, MDoc.MDoc) # P_MDoc.dct_DoNot) THEN
        curUnderpay:=vtbExtractTotal(GetMDocBalance(EMPTYOF(DATE), L_XDoc.max_DoneDTS));
        IF ~E_IsSellMDoc() THEN
         DEC(totUnderpay,              curUnderpay);
         DEC(Balance[L_Acnt.ct_Debit], curUnderpay);
        ELSE
         INC(totUnderpay,               curUnderpay);
         INC(Balance[L_Acnt.ct_Credit], curUnderpay);
        END;
       END;
       NEXT(MDoc);
      END; (* WHILE OCCURE(MDoc) ... *)
     END; (* IF IsMayBePaidMDocKind ... *)
     NEXT(MDocKind);
    END; (* WHILE OCCURE(MDocKind) ... *)

    SEARCH(Contract, Contract, , trgContract);
    balAcCut:=L_kn.Get(SYSDATE(), L_AcCut.erkn_OnlineBalance);
    SETSEL(XApport, WFD, Contract.XObject, balAcCut);
    SRCINSEL(XApport, GE, , L_DatTim.Per(CntrPro.Date));
    WHILE OCCURE(XApport) & (XApport.WFDate <= CntrPro.EndDate) DO
     CONFORM(XApport, Apport);
     INC(Balance[Apport.CirType], XApport.Sum);
     NEXT(XApport);
    END; (* WHILE OCCURE(XApport) ... *)

    IF CntrSum < Math.Max(Balance[L_Acnt.ct_Debit], Balance[L_Acnt.ct_Credit]) THEN
     L_AcsPnt.fullPassAccessPoint(0000059, "", " " + Contract.Contract + " " + Contract.Name+
                                               "|"+
                                               "|࠭祭 㬬   ७: "+FLDTOSTR(CntrSum, "2-", 12, "R")+
                                               "|  ⮬ ⥪饣 㬥        : "+FLDTOSTR(Math.Max(Balance[L_Acnt.ct_Debit], Balance[L_Acnt.ct_Credit]), "2-", 12, "R")+
                                               "|  ⮬ ᫥                       : "+FLDTOSTR(totUnderpay, "2-", 12, "R"));
    END; (* IF CntrSum < ... *)
   END; (* IF ~!CntrSum *)
  EXCEPT
  END;
 END {CheckOwnAgentCntrSumLimit};

BEGIN
 SETEMPTY(converterVATMDocBuildMode)
END.
