(*
%Copyright   (c) Polak Computer System
%Author      16.02.1998 17:44:45 GINA
%Purpose       室  ᨮ 䮭
%Type        report
%Specific    SYS
%Modified    24.09.2014 16:11:52 LDA
%Environment
*)

 MODULE ManIns [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT Memo, L_General, L_AFM, L_Russia, L_DatTim, L_Str, L_Man, L_Staff, L_STx, L_XML,
        L_StdFrm, L_APtm, L_Prop, L_Tax, L_EC, L_Sheet, L_PRoll, L_AcCut, L_SFee, L_XDoc,
        L_Acnt, L_XObj, L_Pmnt, L_AvePay, L_Packet, P_Staff, P_Man, P_MyFirm, P_Firm,
        Math, Str, E_Staff, E_PRoll, L_Env, P_OwnData, L_Cntr, L_ACL;

 CONST
  MaxPerAmo        = 24;
  MaxStageNum      = 1024;
  PagLength        = 60;
  SZV_4_AddrLen    = 46;
  SZV_6_AddrLen    = 30;
  Max_SZVX_2_Count = 10;

  mi_Stage          = 0;
  mi_DisabilityLen  = 1;
  mi_UnpaidLeaveLen = 2;

  ps_InInc          = 0;
  ps_InPaid         = 1;
  ps_AcInc          = 2;
  ps_AcPaid         = 3;

 TYPE
  tCoefIncPaidElm = NUMERIC[12];
  tCoefIncPaid    = tCoefIncPaidElm[2];
  tCategory       = SCAL[10];
  tCategoryList   = tCategory[10];

  tPFPart = SCAL[2];
  tPFSum  = L_PRoll.tSum[2];
 CONST
  tp_PFIn = 0;
  tp_PFAc = 1;

 TYPE
  tQMonth            = SCAL[3+1];
  tYMonth            = SCAL[12+1];
  tQuartalByMonthSum = L_PRoll.tSum[MAXOF(tQMonth)+1];
  tYearByMonthSum    = L_PRoll.tSum[MAXOF(tYMonth)+1];
 CONST
  TotQBMS = MAXOF(tQMonth);
  TotYBMS = MAXOF(tYMonth);

 VAR
  aAmount         : NUMERIC[0];

  pSum, pPns      : L_PRoll.tSum;

  CurPacket       : L_Packet.tPFExtNbr;
  PacketForADV1X  : LIKE(Packet.Packet);
  RealPacketAmount,
  CurNumInP,
  TotNumInP       : NUMERIC[0];

 TYPE
  tAddTypeLen = NUMERIC[0][MAXOF(L_Packet.tMInsAddType)+1];
 VAR
  Days            : tAddTypeLen;
  Months          : tAddTypeLen;
  StageNum        : NUMERIC[0];
  Ms1             : NUMERIC[0][999];
  Ms2             : SCAL[2]   [999];

  pPns2,
  pSum1,
  pSum2           : L_PRoll.tSum;
  pInc,
  pPaid,
  past_pInc,
  past_pPaid      : tPFSum;

  pObject,
  pBase,
  pOvrPrt         : tQuartalByMonthSum;

  orgnPerE,
  PerB,
  PerE            : DATE;
  orgnYear,
  Year            : SCAL[1e4];
  PerAmount,
  orgnQuarter,
  Quarter         : NUMERIC[0];

  orgnPerByWord,
  PerByWord       : STRING[];
  SZVXx           : SCAL[3];
  SZVX_2_Count    : NUMERIC[0];

  NeedConsolidated,
  ADV11After2009  : SCAL[2];

  sprTotPrvOver,
  sprTotCurOver,
  sprTotPrvInc,
  sprTotPrvPaid,
  sprTotCurInc,
  sprTotCurPaid   : tPFSum;

  chkPkIdxMan   : LIKE(Man.Man);
  chkPkIdxTill  : DATE;
  chkPkIdxMyFirm: LIKE(MyFirm.MyFirm);

 TYPE
  tContrNum    = STRING[20];

 CONST
  pg_Main =  1;
  pg_HPA  =  2;
  pg_MStg =  3; (*-4-1*)

  cat_Main                = 1;
  cat_Inv                 = 2;
  cat_Inv1                = 3;
  cat_woCtzn_Commorancy   = 4;
  cat_woCtzn_TmpResidence = 5;

 TYPE
  tAcntDataYear     = SCAL[4];
  tAcntDataFraction = SCAL[2];

 CONST
  AcntDataYearPool = "Prv|Cur|Nxt|Tot";
  ady_Previous = 0;
  ady_Current  = 1;
  ady_Next     = 2;
  ady_Total    = 3;

  AcntDataFractionPool = "In|Ac";
  adf_PFIn = 0;
  adf_PFAc = 1;

  patt_Packets       = "ADVPcks";
  patt_Items         = "ADVMans";

  patt_ActualDate    = "ActualD";
  patt_Debts         = "Debts";
  patt_Pay           = "Pay";
  patt_SickPay       = "SPay";
  patt_ChargedDue    = "CDue";
  patt_TransferDue   = "TDue";
  patt_AverageNum    = "ANum";
  patt_Group         = "㯯";
  patt_Category      = "⥣";
  patt_CategoryNick  = "⥣";
  patt_ManPerE       = "ManPerE";
  patt_CntrType      = "";
  patt_PrvPaid       = ["PrvInPaid", "PrvAcPaid"];
  patt_CurPaid       = ["CurInPaid", "CurAcPaid"];
  patt_PrvInc        = ["PrvInInc",  "PrvAcInc"];
  patt_CurInc        = ["CurInInc",  "CurAcInc"];
  patt_BackInc       = "BackInc";
  patt_PerCode       = "";

(*
$P{ SZV_1_00_1:
Packet.ExtNbr, R, "", "U"
CurNumInP, R, "", "U"
L_Packet.SINumberToAnyOut(Man.SINumber), L, "", "U"
?, L, "", "U"
?, L, "", "U"
Packet.DataType, L, " |X| "
?, L, "", "U"
Packet.CorrType, L, " |X| "
Packet.CorrType, L, " | |X"
PerByWord, L, ""
Packet.DataType, L, " | |X"
L_Packet.OwnNumInPFR, L, "", "U"
L_Packet.OwnFirmName, L, "", "U"
GetCategoryNick(Prt01.Category), L, "", "U"
GetCategoryName(Prt01.Category), L, "", "U"
MoneyToTxt(Prt01.manPns2), R, "", "U"
MoneyToTxt(Prt01.manPns1), R, "", "U"
@
                                                  N 窨 #####   N  窥 ###
ଠ -1                                                   ________

 
 㤮 ⠦, ࠡ⪥ (ࠦ), 室
 ᫥ 客  客 

客 : ##############                         -----------------------
                                                        |             |
     : ########################################  |                     |
         : ########################################  | # 室          |
    ⢮: ########################################  | # ४    |
                                                        | # ⬥        |
 ਮ: #####################################  | # 祭 ᨨ |
                                                        -----------------------
  ࠡ⮤⥫
樮 : ########################################################
:          ########################################################

⥣ ⥫騪 客 ᮢ:  ####  ################
㬬 ᫥ 客 ᮢ
                    㯫稢 ࠡ⮤⥫     ########### 
㯫稢  ࠡ⪠ 客      ########### 

  ࠡ⪥ (ࠦ), 室   ਮ:
-------------------------------------------------------------------------------
|             |      騥 ᫥, 뢠  祭 ᨨ      |
|        |---------------------------------------------------------------|
|             |                         ᥣ|  ⮬ ᫥  쭨.⪠|
|-------------|------------------------------|--------------------------------|
}
*)

(*
$P{ SZV_ConfGarant:
@
䨤樠쭮 ଠ樨 ࠭ ⥫
}
*)

(*
$P{ SZV_3_00_1:
Packet.ExtNbr, R, "", "U"
CurNumInP, R, "", "U"
L_Packet.SINumberToAnyOut(Man.SINumber), L, "", "U"
?, L, "", "U"
?, L, "", "U"
Packet.DataType, L, " |X| "
?, L, "", "U"
Packet.CorrType, L, " |X| "
Packet.CorrType, L, " | |X"
PerByWord, L, "", "U"
Packet.DataType, L, " | |X"
L_Packet.OwnINN, L, "", "U"
L_Packet.OwnKPP, L, "", "U"
L_Packet.OwnNumInPFR, L, "", "U"
L_Packet.OwnFirmName, L, "", "U"
GetCategoryNick(Prt01.Category), L, "", "U"
MoneyToTxt(Prt01.manBase), R, "", "U"
MoneyToTxt(Prt01.manPns2), R, "", "U"
@
                                           N 窨  #####       N 㬥 ###
ଠ -3                                                   ________

 
 㤮 ⠦, ࠡ⪥ (ࠦ), 室
 ᫥ 客    客 
                                                        -----------------------
客 : ##############                         |             |
     : ########################################  |                     |
         : ########################################  | # 室          |
    ⢮: ########################################  | # ४    |
                                                        | # ⬥        |
 ਮ: #####################################  | # 祭 ᨨ |
                                                        -----------------------
  ⥫騪 c  :    ##########     #########
樮   #####################################################
 (⪮)    #####################################################

  客 :
 ⥣ਨ 客  ####      ⥫쭮 

㬬  ࠡ⪠(ࠦ) 
                               室  砫   ###################### 
㬬 ᫥     砫         ###################### 
  ࠡ⪥ (ࠦ)  室 客  
 ਮ, 뢠  祭 ᨨ
-------------------------------------------------------------------------------
|        |             ᥣ ᫥  | ⮬ ᫥ ᮡ  ६|
|             |                              | 㤮ᯮᮡ, ⨯  |
|-------------|------------------------------|--------------------------------|
}
*)

(*
$P{ SZV_X_X_2:
?, L, ""
?, R, ""
?, R, ""
@
|#############|##############################|################################|
}
*)

(*
$P{ SZV_X_X_3:
?, R, ""
?, R, ""
?, L, "", "U"
?, L, "", "U"
?, L, "", "U"
@
|-------------|------------------------------|--------------------------------|
|⮣        |##############################|################################|
-------------------------------------------------------------------------------
  : ##############################################################
 祭: ################
     믫: ################
⠦ ࠡ   ਮ:
-------------------------------------------------------------------------------
|N |          |          |   |              |  塞  |   㣠    |
| |  砫  |     ||ᮡ ᫮| 㤮 ⠦ |                 |
| |  ਮ |  ਮ ||     㤠    |---------------|-----------------|
| |          |          |   |              |᭮|.|᭮  |.|
|--|----------|----------|---|--------------|-----|---------|-----------|-----|
}
*)

(*
$P{ SZV_4_X_4:
@
---------------------------------------------------------------------------------------

⠦ ࠡ   ਮ:
-------------------------------------------------------------------------------
|N |          |          |   |              |  塞  |᫮  .|
| |  砫  |     ||ᮡ ᫮| 㤮 ⠦ |. .ᨨ|
| |  ਮ |  ਮ ||     㤠    |---------------|-----------------|
| |          |          |   |              |᭮|.|᭮  |.|
|--|----------|----------|---|--------------|-----|---------|-----------|-----|
}
*)

(*
$P{ SZV_X_X_5:
?, L, ""
?, L, ""
?, L, ""
?, L, ""
?, L, ""
@
|##|##########|##########|   |##############|     |#########|           |  |  |
}
*)

(*
$P{ SZV_4_2_Add:
@
--------}
*)

(*
$P{ SZV_6_2_Add:
@
---------------------------------------------------------}
*)

(*
$P{ SZV_X_X_6:
L_Packet.ActingLeadPostName, L, "", "U"
L_Str.ShortName(L_Packet.ActingLeadName), L, "", "U"
L_DatTim.FullDateStr(L_Packet.PrepareDate), L, "", "U"
@
-------------------------------------------------------------------------------
  㪮⥫              ஢ 

###################################                     #######################

 ##############################                 ..}
*)

(*
$P{ SZV_4_X_1:
Packet.ExtNbr, R, "", "U"
?, R, "", "U"
SZVXx, L, ""
L_Packet.OwnNumInPFR, L, "", "U"
L_Packet.OwnFirmName, L, "", "U"
PerByWord, L, "", "U"
@
                                                         N 窨 #####  N 㬥 ###
ଠ -4-#                                                         ________
  
 客 ⠦  ᫥ 客 
 易⥫쭮 ᨮ 客 客 
  客⥫ :
樮   #############################################################
(⪮)     #############################################################
 ਮ :        #############################################################
    ਮ  客 :
}
*)

(*
$P{ SZV_4_1_2:
L_Packet.SINumberToAnyOut(Man.SINumber), L, ""
Prt01.Name, L, ""
Prt01.manPns2, R, "2."
?, L, "D.N.Y"
?, L, "D.N.Y"
?, L, ""
Prt01.manPns1, R, "2."
Prt01.Months[L_Packet.miat_Disability], R, ""
!Prt01.Months[L_Packet.miat_Disability], L, ".| "
Prt01.Days[L_Packet.miat_Disability], R, ""
!Prt01.Days[L_Packet.miat_Disability], L, ".| "
?, L, ""
Prt01.Months[L_Packet.miat_UnpaidLeave], R, ""
!Prt01.Months[L_Packet.miat_UnpaidLeave], L, ".| "
Prt01.Days[L_Packet.miat_UnpaidLeave], R, ""
!Prt01.Days[L_Packet.miat_UnpaidLeave], L, ".| "
@
---------------------------------------------------------------------------------------
| 客    |      , , ⢮       |  㬬 . |  ਮ ࠡ  |
|         |                                   | . ᮢ |                 |
|--------------------------------------------------|----------------|-----------------|
|     ࠢ ଠ樨  ﭨ   | .  |                 |
|                                                  |㤮 ᨨ |-----------------|
|          㠫쭮 楢           |----------------| ६ - |
|                                                  | ⥫|㤮ᯮᮡ |
|                                                  | . ᨨ|-----------------|
|                                                  |----------------|  -|
|                                                  | ⥫- | ࠡ⭮ |
|                                                  |      | (. .) |
|--------------------------------------------------|----------------|-----------------|
|############## ###################################|################|######## ########|
|##################################################|################|### #### ## ###  |
|##################################################|                |### #### ## ###  |
---------------------------------------------------------------------------------------

⠦ ࠡ   ਮ:
-------------------------------------------------------------------------------
|N |          |          |   |              |  塞  |᫮  .|
| |  砫  |     ||ᮡ ᫮| 㤮 ⠦ |. .ᨨ|
| |  ਮ |  ਮ ||     㤠    |---------------|-----------------|
| |          |          |   |              |᭮|.|᭮  |.|
|--|----------|----------|---|--------------|-----|---------|-----------|-----|
}
*)

(*
$P{ SZV_4_2_2:
@
---------------------------------------------------------------------------------------
|N  | 客    |   , , ⢮      |  㬬 . |  ਮ ࠡ  |
|/|         |                               | . ᮢ |                 |
|   |----------------------------------------------|----------------|-----------------|
|   |   ࠢ ଠ樨  ﭨ | .  |       |      |
|   |                                              |㤮 ᨨ |-----------------|
|   |      㠫쭮 楢           |----------------| ६ - |
|   |                                              | ⥫|㤮ᯮᮡ |
|   |                                              | . ᨨ|-----------------|
|   |                                              |----------------|  -|
|   |                                              | ⥫- | ࠡ⭮ |
|   |                                              |      | (. .) |
|---|----------------------------------------------|----------------|-----------------|
}
*)

(*
$P{ SZV_4_2_3:
CurNumInP, R, ""
L_Packet.SINumberToAnyOut(Man.SINumber), L, ""
Prt01.Name, L, ""
Prt01.manPns2, R, "2."
?, L, "D.N.Y"
?, L, "D.N.Y"
?, L, ""
Prt01.manPns1, R, "2."
Prt01.Months[L_Packet.miat_Disability], R, ""
!Prt01.Months[L_Packet.miat_Disability], L, ".| "
Prt01.Days[L_Packet.miat_Disability], R, ""
!Prt01.Days[L_Packet.miat_Disability], L, ".| "
?, L, ""
Prt01.Months[L_Packet.miat_UnpaidLeave], R, ""
!Prt01.Months[L_Packet.miat_UnpaidLeave], L, ".| "
Prt01.Days[L_Packet.miat_UnpaidLeave], R, ""
!Prt01.Days[L_Packet.miat_UnpaidLeave], L, ".| "
@
|###|############## ###############################|################|######## ########|
|   |##############################################|################|### #### ## ###  |
|   |##############################################|                |### #### ## ###  |
}
*)

(*
$P{ SZV_4_2_Fill:
@
|   |                                              |                |                 |
|   |                                              |                |                 |
|   |                                              |                |                 |
}
*)

(*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*)
(*+++++++++++++++++           6                                         ++++++++++++++++++*)
(*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*)

(*
$P{ SPV_1_1:
Packet.ExtNbr, R, "", "U"
?, R, "", "U"
L_Packet.OwnOKPO, R, "", "U"
L_Packet.OwnNumInPFR, L, "", "U"
L_Packet.OwnFirmName, L, "", "U"
L_Packet.OwnINN, L, "", "U"
L_Packet.OwnKPP, L, "", "U"
GetCategoryNick(Prt01.Category), L, "", "U"
L_DatTim.FullDateStr(GetManPerE()), L, "", "U"
PerByWord, L, "", "U"
Packet.DataType, L, " |X| "
Packet.CorrType, L, " |X| "
Packet.CorrType, L, " | |X"
L_Packet.SINumberToAnyOut(Man.SINumber), L, ""
?, L, ""
Prt01.manPns2, R, "2."
GetCurPaidFromInc(Prt01.manPns2, tp_PFIn, Intrm.Category, Intrm.CntrType), R, "2."
Prt01.manPns1, R, "2."
GetCurPaidFromInc(Prt01.manPns1, tp_PFAc, Intrm.Category, Intrm.CntrType), R, "2."
?, L, ""
?, L, ""
@
                                                         N 窨 #####  N 㬥 ###
ଠ -1                       ________               ############

                    
             
                             

 客⥫:
樮    ###########################################################
(⪮)       ###########################################################
 ############         #########
 ⥣ਨ 客  ####################################################
 ⠢          ###########################################################
 ।⠢      ___________________________________________________________
 ਮ:
#######################################################################################
 ᢥ:
[#] 室
[#] ४騥
[#] ⬥騥

   客 :
---------------------------------------------------------------------------------------
|  客   |       ,       |㬬 客 ᮢ|㬬 客 ᮢ|
|         |         ,         |   客    | ⥫  |
|              |       ⢮       |    㤮 ᨨ    |    㤮 ᨨ    |
|              |                      |-----------------------|-----------------------|
|              |                      |  ᫥|   祭|  ᫥|   祭|
|--------------|----------------------|-----------|-----------|-----------|-----------|
|##############|######################|###########|###########|###########|###########|
|              |######################|           |           |           |           |
|              |######################|           |           |           |           |
---------------------------------------------------------------------------------------

⠦ ࠡ:
-------------------------------------------------------------------------------
|N |          |          |   |              |  ᫥   |᫮  .|
| |  砫  |     ||ᮡ ᫮|㤮 ⠦|. .ᨨ|
| |  ਮ |  ਮ ||     㤠    |---------------|-----------------|
| |          |          |   |              |᭮|.|᭮  |.|
|--|----------|----------|---|--------------|-----|---------|-----------|-----|
}
*)

(*
$P{ SZV_6_1_1:
Packet.ExtNbr, R, "", "U"
?, R, "", "U"
L_Packet.OwnOKPO, R, "", "U"
L_Packet.OwnNumInPFR, L, "", "U"
L_Packet.OwnFirmName, L, "", "U"
L_Packet.OwnINN, L, "", "U"
L_Packet.OwnKPP, L, "", "U"
GetCategoryNick(Prt01.Category), L, "", "U"
orgnPerByWord, L, "", "U"
Packet.DataType, L, " |X| "
Packet.CorrType, L, " |X| "
Packet.CorrType, L, " | |X"
L_Str.PoolItem(PerByWord, Packet.CorrType = L_Packet.ct_None), L, "", "U"
@
                                                                                  N 窨 #####  N 㬥 ###
ଠ -6-1                                              ________               ############

                                   
                          

 客⥫:
樮    ###########################################################
(⪮)       ####################################################################################
 ############         #########
 ⥣ਨ 客  ####################################################
 ।⠢      ___________________________________________________________
 ਮ :           ####################################################################################
 ᢥ:
[#] 室
[#] ४騥            ਮ
[#] ⬥騥              ####################################################################################
}
*)

(*
$P{ SZV_6_1_2:
?, L, ""
L_Packet.SINumberToAnyOut(Man.SINumber), L, ""
?, L, ""
Prt01.manPns2, R, "2."
GetCurPaidFromInc(Prt01.manPns2, tp_PFIn, Intrm.Category, Intrm.CntrType), R, "2."
Prt01.manPns1, R, "2."
GetCurPaidFromInc(Prt01.manPns1, tp_PFAc, Intrm.Category, Intrm.CntrType), R, "2."
?, L, ""
?, L, ""
?, L, ""
?, L, ""
@
   客 :
----------------------------------------------------------------------------------------------------------------
|    ,    |  客   |      ࠢ     |㬬 客 ᮢ|㬬 客 ᮢ|
|      ,      |         |    ଠ樨  ﭨ    |   客    | ⥫  |
|    ⢮    |              |   㠫쭮 楢   |    㤮 ᨨ    |    㤮 ᨨ    |
|                |              |                         |-----------------------|-----------------------|
|                |              |                              |  ᫥|   祭|  ᫥|   祭|
|----------------|--------------|------------------------------|-----------|-----------|-----------|-----------|
|################|##############|##############################|###########|###########|###########|###########|
|################|              |##############################|           |           |           |           |
|################|              |##############################|           |           |           |           |
----------------------------------------------------------------------------------------------------------------

ਮ ࠡ  ᫥   ( 2010    楢) ⭮ ਮ:
-------------------------------------------------------------------------------
|N |          |          |   |              |  ᫥   |᫮  .|
| |  砫  |     ||ᮡ ᫮|㤮 ⠦|. .ᨨ|
| |  ਮ |  ਮ ||     㤠    |---------------|-----------------|
| |          |          |   |              |᭮|.|᭮  |.|
|--|----------|----------|---|--------------|-----|---------|-----------|-----|
}
*)

(*
$P{ SZV_6_2_1:
Packet.ExtNbr, R, "", "U"
?, R, "", "U"
L_Packet.OwnOKPO, R, "", "U"
L_Packet.OwnNumInPFR, L, "", "U"
L_Packet.OwnFirmName, L, "", "U"
L_Packet.OwnINN, L, "", "U"
L_Packet.OwnKPP, L, "", "U"
?, L, "", "U"
orgnPerByWord, L, "", "U"
Packet.DataType, L, " |X| "
Packet.CorrType, L, " |X| "
Packet.CorrType, L, " | |X"
L_Str.PoolItem(PerByWord, Packet.CorrType = L_Packet.ct_None), L, "", "U"
?, L, "", "U"
@
                                                                                                          N 窨 #####  N 㬥 ###
ଠ -6-2                                                                      ________               ############

                                                                 
                  

 客⥫:
樮    ###########################################################
(⪮)       ############################################################################################################
 ############         #########
 ⥣ਨ 客  ####################################################
 ।⠢      ___________________________________________________________
 ਮ :           ############################################################################################################
 ᢥ:
[#] 室
[#] ४騥            ਮ
[#] ⬥騥              ############################################################################################################

⢮ 客   ॥ ##############################################
----------------------------------------------------------------------------------------------------------------------------------------
|  N  |    ,    |  客   |      ࠢ     |㬬 客 ᮢ|㬬 客 ᮢ|  ਮ ࠡ  |
| / |      ,      |         |    ଠ樨  ﭨ    |   客    | ⥫  |                 |
|     |    ⢮    |              |   㠫쭮 楢   |    㤮 ᨨ    |    㤮 ᨨ    |                 |
|     |                |              |                         |-----------------------|-----------------------|-----------------|
|     |                |              |                              |  ᫥|   祭|  ᫥|   祭|       |      |
|-----|----------------|--------------|------------------------------|-----------|-----------|-----------|-----------|--------|--------|
}
*)

(*
$P{ SZV_6_2_2:
CurNumInP, R, ""
?, L, ""
L_Packet.SINumberToAnyOut(Man.SINumber), L, ""
?, L, ""
Prt01.manPns2, R, "2."
GetCurPaidFromInc(Prt01.manPns2, tp_PFIn, Intrm.Category, Intrm.CntrType), R, "2."
Prt01.manPns1, R, "2."
GetCurPaidFromInc(Prt01.manPns1, tp_PFAc, Intrm.Category, Intrm.CntrType), R, "2."
?, L, "D.N.Y"
?, L, "D.N.Y"
?, L, ""
?, L, ""
?, L, ""
?, L, ""
@
|#####|################|##############|##############################|###########|###########|###########|###########|########|########|
|     |################|              |##############################|           |           |           |           |        |        |
|     |################|              |##############################|           |           |           |           |        |        |
}
*)

(*
$P{ SZV_6_2_Fill:
@
|     |                |              |                              |           |           |           |           |        |        |
|     |                |              |                              |           |           |           |           |        |        |
|     |                |              |                              |           |           |           |           |        |        |
}
*)

(*
$P{ SZV_6_2_3:
?, R, "2."
?, R, "2."
?, R, "2."
?, R, "2."
@
|--------------------------------------------------------------------|-----------|-----------|-----------|-----------|-----------------|
|ᥣ  ॥                                                    |###########|###########|###########|###########|                 |
}
*)

(*
$P{ SZV_6_4_1:
Packet.ExtNbr, R, "", "U"
?, R, "", "U"
L_Packet.OwnOKPO, R, "", "U"
L_Packet.OwnNumInPFR, L, "", "U"
L_Packet.OwnFirmName, L, "", "U"
L_Packet.OwnINN, L, "", "U"
L_Packet.OwnKPP, L, "", "U"
GetCategoryNick(Prt01.Category), L, "", "U"
orgnPerByWord, L, "", "U"
Packet.DataType, L, " |X| "
Packet.CorrType, L, " |X| "
Packet.CorrType, L, " | |X"
L_Str.PoolItem(PerByWord, Packet.CorrType = L_Packet.ct_None), L, "", "U"
L_Str.PoolItem(P_MyFirm.NumInPFR(L_Packet.PckMyFirm, PerE), Packet.CorrType = L_Packet.ct_None), L, "", "U"
(Intrm.CntrType=L_Packet.cntrt_Basic), L, " |X"
(Intrm.CntrType=L_Packet.cntrt_CA),    L, " |X"
?, L, "", "U"
?, L, "", "U"
?, L, "", "U"
L_Packet.SINumberToAnyOut(Man.SINumber), L, "", "U"
Prt01.Object[TotQBMS], R, "2."
Prt01.Base[TotQBMS],   R, "2."
Prt01.OvrPrt[TotQBMS], R, "2."
Prt01.Object[0], R, "2."
Prt01.Base[0],   R, "2."
Prt01.OvrPrt[0], R, "2."
Prt01.Object[1], R, "2."
Prt01.Base[1],   R, "2."
Prt01.OvrPrt[1], R, "2."
Prt01.Object[2], R, "2."
Prt01.Base[2],   R, "2."
Prt01.OvrPrt[2], R, "2."
Prt01.BasPFA1[TotQBMS], R, "2."
Prt01.BasPFA2[TotQBMS], R, "2."
Prt01.BasPFA1[0], R, "2."
Prt01.BasPFA2[0], R, "2."
Prt01.BasPFA1[1], R, "2."
Prt01.BasPFA2[1], R, "2."
Prt01.BasPFA1[2], R, "2."
Prt01.BasPFA2[2], R, "2."
Prt01.manPns2, R, "2."
GetCurPaidFromInc(Prt01.manPns2, tp_PFIn, Intrm.Category, Intrm.CntrType), R, "2."
Prt01.manPns1, R, "2."
GetCurPaidFromInc(Prt01.manPns1, tp_PFAc, Intrm.Category, Intrm.CntrType), R, "2."
@
                                                               N 窨 #####  N 㬥 ###
ଠ -6-4                           ________               ############

                            ,
                       
                      

 客⥫:
樮    #################################################################
(⪮)       #################################################################
 ############         #########
 ⥣ਨ 客  ##########################################################
 ।⠢      _________________________________________________________________
 ਮ: ############################################################################
 ᢥ:
[#] 室
[#] ४騥   ਮ
[#] ⬥騥     ##########################################################################
                   樮    ४㥬 ਮ ########################

 (⨯ ), 祭  客 殬:
[#] - 㤮;     [#] - ࠦ᪮-ࠢ

   客 :
  ####################################################################################
      ####################################################################################
⢮ ####################################################################################
客  #############################################################################

    㬬  믫     ࠦ,  ᫥    
䨧᪮ 
-------------------------------------------------------------------------------
|                    |  㬬 믫   |    ⮬ ᫥   ᫥  |
|                    |              |   客   易⥫쭮  |
|                    |  ࠦ  |       ᨮ 客        |
|                    |                  |-------------------------------------|
|                    |                  | 室    | 室    |
|                    |                  |   ᫥  |   ᫥  |
|                    |                  |客 ᮢ,|客 ᮢ,|
|                    |                  |   ॢ  |   ॢ    |
|                    |                  |    ।    |    ।    |
|--------------------|------------------|------------------|------------------|
|ᥣ  ᫥  |##################|##################|##################|
|  ⭮|                  |                  |                  |
|ਮ,  ..     |                  |                  |                  |
|--------------------|------------------|------------------|------------------|
|1              |##################|##################|##################|
|--------------------|------------------|------------------|------------------|
|2              |##################|##################|##################|
|--------------------|------------------|------------------|------------------|
|3              |##################|##################|##################|
-------------------------------------------------------------------------------

    㬬  믫      ࠦ  客  ,
⮣    ᮮ⢥    ࠡ,   ᫥ 客
  ⥫쭮 
-------------------------------------------------------------------------------
|                     |    㬬 믫      |    㬬 믫      |
|                     |ࠦ, ᫥|ࠦ,᫥ |
|                     |   客 ,   |   客 ,   |
|                     |  ⮬   ࠡ, |  ⮬   ࠡ, |
|                     |  㪠  㭪 1  |   㪠  㭪  |
|                     |     㭪 1  27    | 2 - 18 㭪 1  27 |
|                     |   ࠫ쭮    |   ࠫ쭮    |
|                     |   17.12.2001 " 㤮  |   17.12.2001 " 㤮  |
|                     |      ᨩ᪮   |      ᨩ᪮   |
|                     |         樨"        |         樨"        |
|---------------------|---------------------------|---------------------------|
|ᥣ  ᫥   |###########################|###########################|
|  ⭮ |                           |                           |
|ਮ,  ..      |                           |                           |
|---------------------|---------------------------|---------------------------|
|1               |###########################|###########################|
|---------------------|---------------------------|---------------------------|
|2               |###########################|###########################|
|---------------------|---------------------------|---------------------------|
|3               |###########################|###########################|
-------------------------------------------------------------------------------

    ᫥  㯫祭  客      易⥫쭮
ᨮ 客  ᫥   ⭮ ਮ
-------------------------------------------------------------------------------
|    客   客     |  客   ⥫   |
|         㤮 ᨨ         |         㤮 ᨨ         |
|--------------------------------------|--------------------------------------|
|     ᫥     |     㯫祭     |     ᫥     |     㯫祭     |
|-------------------|------------------|-------------------|------------------|
|###################|##################|###################|##################|
-------------------------------------------------------------------------------

ਮ ࠡ  ᫥   ⭮ ਮ
-------------------------------------------------------------------------------
|N |          |          |   |              |  ᫥   |᫮  .|
| |  砫  |     ||ᮡ ᫮|㤮 ⠦|. .ᨨ|
| |  ਮ |  ਮ ||     㤠    |---------------|-----------------|
| |          |          |   |              |᭮|.|᭮  |.|
|--|----------|----------|---|--------------|-----|---------|-----------|-----|
}
*)

(*
$P{ ADV6_2_1:
Packet.ExtNbr, R, "", "U"
L_Packet.OwnOKPO, R, "", "U"
L_Packet.OwnNumInPFR, L, "", "U"
L_Packet.OwnFirmName, L, "", "U"
L_Packet.OwnINN, L, "", "U"
L_Packet.OwnKPP, L, "", "U"
PerByWord, L, "", "U"
?, R, "0", "U"
?, R, "0", "U"
@
                                                                                                                                  N 窨 #####
ଠ -6-2                                                                             ________               ############

                                                ᢥ, । 客⥫  

 客⥫:
樮    ###################################################################################################################
(⪮)       ###################################################################################################################
 ############         #########
 ।⠢      ___________________________________________________________
 ਮ :           ###################################################################################################################

⢮ 室 祪 㬥⮢                    ####
⢮ ४ (⬥) 祪 㬥⮢ ####

  室 ᢥ:
-----------------------------------------------------------------------------------------------------------------------------------------------
| N |      |㬬 客 ᮢ|㬬 客 ᮢ|⢮|                      䠩 ( ॥)                      |
|/|⥣ਨ|   客    | ⥫  | -|                                                                    |
|   |-|    㤮 ᨨ    |    㤮 ᨨ    |    |                                                                    |
|   |  |-----------------------|-----------------------|       |                                                                    |
|   |     |  ᫥|   祭|  ᫥|   祭|          |                                                                    |
|---|---------|-----------|-----------|-----------|-----------|----------|--------------------------------------------------------------------|
}
*)


(*
$P{ ADV6_2_3:
?, R, "0"
?, C, ""
Packet.Sums[ps_InInc],  R, "2-"
Packet.Sums[ps_InPaid], R, "2-"
Packet.Sums[ps_AcInc],  R, "2-"
Packet.Sums[ps_AcPaid], R, "2-"
?, R, "0"
L_Packet.GetTransportFileName(), L, ""
@
|###|#########|###########|###########|###########|###########|##########|####################################################################|
}
*)

(*
$P{ ADV6_2_2:
?, R, "2-"
?, R, "2-"
?, R, "2-"
?, R, "2-"
?, R, "0"
@
|-------------|-----------|-----------|-----------|-----------|----------|--------------------------------------------------------------------|
|⮣        |###########|###########|###########|###########|##########|                                                                    |
-----------------------------------------------------------------------------------------------------------------------------------------------

  ४ (⬥) ᢥ:
-----------------------------------------------------------------------------------------------------------------------------------------------
| N |      |  㬬 ᫥  |  㬬 ᫥  |⢮|                      䠩 ( ॥)                      |
|/|⥣ਨ| 客  ᮢ  | 客  ᮢ  | -|                                                                    |
|   |-|    客     |  ⥫   |    |                                                                    |
|   |  |    㤮 ᨨ    |    㤮 ᨨ    |       |                                                                    |
|   |     |-----------------------|-----------------------|          |                                                                    |
|   |         |  ᫥|   祭|  ᫥|   祭|          |                                                                    |
|---|---------|-----------|-----------|-----------|-----------|----------|--------------------------------------------------------------------|
}
*)


(*
$P{ ADV6_2_4:
?, R, "2-"
?, R, "2-"
?, R, "2-"
?, R, "2-"
?, R, "0"
L_Packet.ActingLeadPostName, L, "", "U"
L_Str.ShortName(L_Packet.ActingLeadName), L, "", "U"
L_DatTim.FullDateStr(L_Packet.PrepareDate), L, "", "U"
@
|-------------|-----------|-----------|-----------|-----------|----------|--------------------------------------------------------------------|
|⮣        |###########|###########|###########|###########|##########|                                                                    |
-----------------------------------------------------------------------------------------------------------------------------------------------

  㪮⥫     ஢ 
###################################            ###########################

 ##############################            ..}
*)

(*
$P{ ADV6_X_1:
Packet.ExtNbr, R, "", "U"
1, R, "", "U"
?, L, ""
L_Packet.OwnOKPO, R, "", "U"
L_Packet.OwnNumInPFR, L, "", "U"
L_Packet.OwnFirmName, L, "", "U"
L_Packet.OwnINN, L, "", "U"
L_Packet.OwnKPP, L, "", "U"
?, L, "", "U"
orgnPerByWord, L, "", "U"
Packet.DataType, L, " |X| "
Packet.CorrType, L, " |X| "
Packet.CorrType, L, " | |X"
L_Str.PoolItem(PerByWord, Packet.CorrType = L_Packet.ct_None), L, "", "U"
@
                                             N 窨 #####   N  窥 ###
ଠ -6-#        ________               ############

      㬥⮢,  ᫥  㯫祭 客  
    客 ⠦ 客  । 客⥫  

 客⥫:
樮   ################################################
 ࣠樨  ################################################
(⪮)
 ##########         #########
 ⥣ਨ 客  #######################################
 ।⠢    ________________________________________________
 ਮ:
##########################################################################
 ᢥ:
[#] 室
[#] ४    ਮ
[#] ⬥      ######################################################

}
*)

(*
$P{ ADV6_5_1_1:
?, L, " |X"
?, L, " |X"
@
 (⨯ ), 祭  客 殬:
[#] 㤮       [#] ࠦ᪮-ࠢ

}
*)

(*
$P{ ADV6_X_2:
?, R, "0"
?, L, ""
Packet.ExtNbr, R, "", "U"
@
ਬ砭: ______________________________________________________________
--------------------------------------------------------------------------
|                                                     |⢮ 㬥|
|            室饣 㬥          |⮢  -|
|                                                     |  窥   |
|-----------------------------------------------------|------------------|
|  ᫥  㯫祭 客 |##################|
| 易⥫쭮 ᨮ 客  客   |                  |
|⠦ 客  -6-#                   |                  |
|-----------------------------------------------------|------------------|
| 室騥 㬥:_____________________________|                  |
--------------------------------------------------------------------------
  窨 㬥⮢,ᮯ஢ ஭ ।⠢
 窨 㬥⮢, ᢮ 客⥫ ######
 ॣ樨 窨  ਠ쭮 ࣠  __________ / _____

}
*)

(*
$P{ ADV6_5_2_1:
?, R, "2-"
?, R, "2-"
?, R, "2-"
@
--------------------------------------------------------------------------
|               |  㬬 믫   |    ⮬ ᫥   ᫥  |
|               |              |   客   易⥫쭮  |
|               |  ࠦ  |       ᨮ 客        |
|               |                  |-------------------------------------|
|               |                  | 室    | 室    |
|               |                  |   ᫥  |   ᫥  |
|               |                  |客 ᮢ,|客 ᮢ,|
|               |                  |   ॢ  |   ॢ    |
|               |                  |    ।    |    ।    |
|---------------|------------------|------------------|------------------|
|ᥣ ᫥|##################|##################|##################|
--------------------------------------------------------------------------
}
*)

(*
$P{ ADV6_X_3:
?, R, "2-"
?, R, "2-"
?, R, "2-"
?, R, "2-"
L_Packet.ActingLeadPostName, L, "", "U"
L_Str.ShortName(L_Packet.ActingLeadName), L, "", "U"
L_DatTim.FullDateStr(L_Packet.PrepareDate), L, "", "U"
@
--------------------------------------------------------------------------
|                |  㬬 客 ᮢ  |  㬬 客 ᮢ  |
|                |     客      |   ⥫    |
|                |      㤮 ᨨ      |      㤮 ᨨ      |
|                |---------------------------|---------------------------|
|                |    ᫥|     祭|    ᫥|     祭|
|----------------|-------------|-------------|-------------|-------------|
|ᥣ ᫥ |#############|#############|#############|#############|
--------------------------------------------------------------------------

  㪮⥫     ஢ 
###################################            ###########################

 ##############################            ..}
*)

(*
$P{ NN2_x_00_1:
PerByWord, L, ""
L_Str.IntStr(GetADV10Total("Items")), L, ""
L_Str.IntStr(GetADV10Total("Items")-GetADV10Total("DPItems")), L, ""
L_Packet.OwnFirmName, L, ""
L_Packet.OwnNumInPFR, L, ""
L_Packet.OwnINN, L, ""
L_Packet.OwnKPP, L, ""
@
   ᭨⥫쭠 ᪠  㠫 ᢥ  㤮 ⠦  ࠡ⪥
          ਮ ###############################################

 ᫥ ࠡ  ⭮ ਮ ########### ⭠ ᫥ ####

 ࣠樨    ####################################################
               (⪮)
. N ⥫騪   ####################  ##########  #########

                                    ।⠢ 㠫 ᢥ
----------------------------------------------------------------------------------------------------------------------------
}
*)

(*
$P{ NN2_3_00_2:
@
|  |                                | | | |N  | N|-|              㬬  窥 ( ./.)         |
|  |                                |.|||ࠡ.|窨|    |---------------------------------------------------|
|  |                                |    |    |    |      |     |  | ᥣ ᫥|    ..  /|() |
}
*)

(*
$P{ NN2_4_00_2:
@
|  |                                | | | |N  | N|-|  㬬 ᫥ 客 ᮢ (./.)  |
|  |                                ||||ࠡ.|窨|    |---------------------------------------------------|
|  |                                |    |    |    |      |     |  | 客 |⥫.|  .|
}
*)

(*
$P{ NN2_x_00_3:
"", R, ""
"", R, ""
"", R, ""
"", R, ""
"", R, ""
"", R, ""
"", R, ""
"", R, ""
@
|--|--------------------------------|----|----|----|------|-----|------|----------------|----------------|-----------------|
|  |                1               |  2 | 3  | 4  |  5   |  6  |  7   |       8        |       9        |       10        |
|--|--------------------------------|----|----|----|------|-----|------|----------------|----------------|-----------------|
|1 | 㬬 ᫥  窠| X  | X  | X  |  X   |  X  |######|################|################|#################|
|  |㠫 ᢥ, ࠭  |    |    |    |      |     |      |                |                |                 |
|  |।⠢   . |    |    |    |      |     |      |                |                |                 |
|--|--------------------------------|----|----|----|------|-----|------|----------------|----------------|-----------------|
|1| .. "祭 ᨨ"      | X  | X  | X  |  X   |  X  |######|################|################|#################|
|  | த ࠡ          |    |    |    |      |     |      |                |                |                 |
|--|--------------------------------|----|----|----|------|-----|------|----------------|----------------|-----------------|
|1|४.  . ஢.      | X  | X  | X  |  X   |  X  |      |                |                |                 |
|  |(㬬  "."  "")    |    |    |    |      |     |      |                |                |                 |
|--|--------------------------------|----|----|----|------|-----|------|----------------|----------------|-----------------|
|1|ࠢ 訡.          | X  | X  | X  |  X   |  X  |      |                |                |                 |
|--|--------------------------------|----|----|----|------|-----|------|----------------|----------------|-----------------|
|2 |㬬 ᫥  ।⠢-|    |    |    |      |     |      |                |                |                 |
|  | 窠   ਮ   |    |    |    |      |     |      |                |                |                 |
}
*)

(*
$P{ NN2_x_00_4:
PacketGroupType(ADV10.Group, ADV10.Category), L, ""
?, L, ""
?, L, ""
ADV10._Packet, L, ""
L_Str.IntStr(GetADV10ByPacket(ADV10._Packet, "Items")), R, ""
?, R, ""
?, R, ""
?, R, ""
@
|  |                                |####|####|####|######|     |######|################|################|#################|
}
*)

(*
$P{ NN2_3_00_5:
L_Str.IntStr(GetADV10ByRealPackets("Items")), R, ""
MoneyToTxt(GetADV10ByRealPackets("_Sum1")), R, ""
MoneyToTxt(GetADV10ByRealPackets("_Sum2")), R, ""
MoneyToTxt(GetADV10ByRealPackets("_Pns2")), R, ""
L_Str.IntStr(GetADV10Total("Items")), R, ""
MoneyToTxt(GetADV10Total("_Sum1")), R, ""
MoneyToTxt(GetADV10Total("_Sum2")), R, ""
MoneyToTxt(GetADV10Total("_Pns2")), R, ""
MoneyToTxt(GetADV10Total("_Pns2")), R, ""
L_Packet.OwnLeadPostName, L, ""
L_Str.ShortName(L_Packet.OwnLeadName), L, ""
L_DatTim.FullDateStr(L_Packet.PrepareDate), L, ""
@
|--|--------------------------------|----|----|----|------|-----|------|----------------|----------------|-----------------|
|2|⬥騥                    |    | X  | X  |      |     |      |                |                |                 |
|--|------------------------------------------------------------|------|----------------|----------------|-----------------|
|3 | 㬬 ᫥  ᥬ ।⠢ 窠      |######|################|################|#################|
|  | ਮ                                             |      |                |                |                 |
|--|------------------------------------------------------------|------|----------------|----------------|-----------------|
|4 | 㬬 ᫥ ࠡ⭨,            |      |                |                |                 |
|  |।⠢                                              |      |                |                |                 |
|--|------------------------------------------------------------|------|----------------|----------------|-----------------|
|5 | 㬬 ᫥ ࠡ⭨,          |      |                |                |                 |
|  |।⠢                                              |      |                |                |                 |
|--|------------------------------------------------------------|------|----------------|----------------|-----------------|
|6 |ᥣ (3+4+5)                                               |######|################|################|#################|
|--|-----------------------------------------------------------------------------------------------------|-----------------|
|7 |᫥ ᮢ ⥦  ᫮ ./.  砫                            |                 |
|--|-----------------------------------------------------------------------------------------------------|-----------------|
|8 |᫥ ᮢ ⥦  砫          (. .)                                   |#################|
|--|-----------------------------------------------------------------------------------------------------|-----------------|
|9 |᫥ ᮢ ⥦   ਮ (. .)                                     |                 |
|--|-----------------------------------------------------------------------------------------------------|-----------------|
|10|᫨/㬥 (㦭 ભ)          (. .)                                     |                 |
----------------------------------------------------------------------------------------------------------------------------

ਬ砭: ________________________________________________________________________________________________________________
____________________________________________________________________________________________________________________________
____________________________________________________________________________________________________________________________
____________________________________________________________________________________________________________________________

  㪮⥫                      ஢ 

###################################                             ###########################################

 ##############################         ..

祭                                        ஢ 



                                        ⠬ 㯮祭

樠                                             ஢ 



                                        ⠬ ᯥ樠 }
*)

(*
$P{ NN2_4_00_5:
L_Str.IntStr(GetADV10ByRealPackets("Items")), R, ""
MoneyToTxt(GetADV10ByRealPackets("_Pns2")), R, ""
MoneyToTxt(GetADV10ByRealPackets("_Pns1")), R, ""
"", R, ""
L_Str.IntStr(GetADV10Total("Items")), R, ""
MoneyToTxt(GetADV10Total("_Pns2")), R, ""
MoneyToTxt(GetADV10Total("_Pns1")), R, ""
"", R, ""
L_Packet.OwnLeadPostName, L, ""
L_Str.ShortName(L_Packet.OwnLeadName), L, ""
L_DatTim.FullDateStr(L_Packet.PrepareDate), L, ""
@
|--|--------------------------------|----|----|----|------|-----|------|----------------|----------------|-----------------|
|2|⬥騥                    |    | X  | X  |      |     |      |                |                |                 |
|--|------------------------------------------------------------|------|----------------|----------------|-----------------|
|3 |᫥  ।⠢塞 窠                         |######|################|################|#################|
|--|------------------------------------------------------------|------|----------------|----------------|-----------------|
|3|᫥ ᥣ  ࣠樨                              |######|################|################|#################|
|--|-------------------------------------------------------------------|----------------|----------------|-----------------|
|3|᫥ ᮢ ⥦  , 祭        |                |                |        X        |
----------------------------------------------------------------------------------------------------------------------------

ਬ砭: ________________________________________________________________________________________________________________
____________________________________________________________________________________________________________________________
____________________________________________________________________________________________________________________________
____________________________________________________________________________________________________________________________

  㪮⥫                      ஢ 

###################################                             ###########################################

 ##############################         ..

祭                                        ஢ 



                                        ⠬ 㯮祭

樠                                             ஢ 



                                        ⠬ ᯥ樠 }
*)

(*
$P{ NN1_3_00_1:
Packet.ExtNbr, R, ""
L_Packet.OwnNumInPFR, L, ""
L_Packet.OwnINN, L, ""
L_Packet.OwnKPP, L, ""
L_Packet.OwnFirmName, L, ""
PerByWord, L, ""
@
                           ᮪ 客               窠 N ######
--------------------------------------------------------------------------------
| ࠡ⮤⥫, ।饣 㬥:                                |
|樮   ####################################################|
| ##########         #########                                           |
| ࣠樨  ####################################################|
|(⪮)                                                                     |
| ਮ:                                                              |
|##############################################################################|
|------------------------------------------------------------------------------|
| N  |  客   | , , ⢮                                   |
|/ |         |                                                          |
|----|--------------|----------------------------------------------------------|
}
*)

(*
$P{ NN1_3_00_2:
PckBody.SeqNbr+1, R, "N"
L_Packet.SINumberToAnyOut(Man.SINumber), L, ""
L_Packet.GetManInPFRFName(SYSDATE()), L, ""
@
|####|##############|##########################################################|
}
*)

(*
$P{ NN1_3_00_3:
@
--------------------------------------------------------------------------------}
*)

(*
$P{ ADV10_3_00_1:
L_Packet.OwnOKPO, L, "", "U"
Packet.ExtNbr, R, "", "U"
?, R, "", "U"
L_Packet.OwnNumInPFR, L, "", "U"
L_Packet.OwnINN, L, "", "U"
L_Packet.OwnKPP, L, "", "U"
L_Packet.OwnFirmName, L, "", "U"
PerByWord, L, "", "U"
?, R, "", "U"
?, R, "", "U"
?, R, "", "U"
?, R, "", "U"
@
ଠ -10                       ________               #########

                                                                    N 窨 #####
                                                N 㬥 #####
 㬥⮢ -3, । ࠡ⮤⥫  

 ------------------------------------------------------------------------------------
| ࠡ⮤⥫, ।饣 㬥:                                      |
|                                                                                    |
|樮   ##############                                            |
|                                                                                    |
|                       ##########      #########                              |
|                                                                                    |
| ࣠樨  ##########################################################|
| (⪮)                                                                          |
| ਮ:          ##########################################################|
 ------------------------------------------------------------------------------------

 ⢮ 祪  室묨 㬥⠬ -3:      #############
 ⢮ 室 㬥⮢ -3:                #############
   㯫 ᮢ  
   ⭮ ਮ:           ################  

  ᫥, ࠡ⪥ (ࠦ)  室, 뢠  祭
ᨨ  ⥣ਨ 客 : ########

------------------------------------------------------------------------------------------
        |   ⥣ਨ 客  |                   ࠢ筮
        |                            |
        |--------------------------------|------------------------------------------------
   |   ࠡ⮪    | ..ᮡ  |।    |ਧ|   ᫥   |  ᫥
        |(ࠦ)| ६   |᫥| |    ᮢ    |    ᮢ
        |    室       |㤮ᯮᮡ- |ࠡ⭨ ||           |      
        |                |,⨯|(- |  |               |
        |                |               | )|    |               |
------------------------------------------------------------------------------------------
}
*)

(*
$P{ ADV10_3_00_2:
?, L, ""
?, R, ""
?, R, ""
?, R, ""
?, C, ""
?, R, ""
?, R, ""
@
########|################|###############|###########|####|###############|###############
}
*)

(*
$P{ ADV10_3_00_3:
?, R, ""
?, R, ""
?, R, ""
?, R, ""
L_Packet.OwnLeadPostName, L, "", "U"
L_Str.ShortName(L_Packet.OwnLeadName), L, "", "U"
L_DatTim.FullDateStr(L_Packet.PrepareDate), L, "", "U"
@
------------------------------------------------------------------------------------------
 ⮣  |################|###############|     X     | X  |###############|###############
------------------------------------------------------------------------------------------

  㪮⥫               ஢ 

###################################                      #################################

 ##############################             ..}
*)

(*
$P{ ADV11_4_00_1:
L_Packet.OwnOKPO, L, "", "U"
Packet.ExtNbr, R, "", "U"
?, R, "", "U"
L_Packet.OwnNumInPFR, L, "", "U"
L_Packet.OwnINN, L, "", "U"
L_Packet.OwnKPP, L, "", "U"
L_Packet.OwnFirmName, L, "", "U"
PerByWord, L, "", "U"
L_DatTim.FullDateStr(L_Packet.ActualDate), L, "", "U"
?, R, "", "U"
?, R, "", "U"
?, L, "", "U"
?, C, ""
?, R, ""
?, R, ""
?, C, ""
?, R, ""
?, R, ""
?, R, ""
?, R, ""
?, C, ""
?, R, ""
?, R, ""
?, C, ""
?, R, ""
?, R, ""
?, C, ""
?, R, ""
?, R, ""
?, R, ""
?, R, ""
?, C, ""
?, R, ""
?, R, ""
?, C, ""
?, R, ""
?, R, ""
?, C, ""
?, R, ""
?, R, ""
?, R, ""
?, R, ""
L_Str.ShortName(L_Packet.OwnAcntName), L, "", "U"
L_Packet.OwnLeadPostName, L, "", "U"
L_Str.ShortName(L_Packet.OwnLeadName), L, "", "U"
L_DatTim.FullDateStr(L_Packet.PrepareDate), L, "", "U"
@
ଠ -11                       ________               #########

 㯫 客 ᮢ  易⥫쭮 ᨮ 客
                                                                    N 窨 #####
                                                                N 㬥 #####
--------------------------------------------------------------------------------------
| ࠡ⮤⥫, ।饣 㬥:                                      |
|                                                                                    |
|樮   ##############                                            |
|                                                                                    |
|                       ##########      #########                              |
|                                                                                    |
| ࣠樨  ##########################################################|
| (⪮)                                                                          |
| ਮ:         ##########################################################|
| ⠢  ﭨ  : ######################################   |
--------------------------------------------------------------------------------------

 ⢮ 祪  㬥⠬ -4-1  -4-2:                    #####
 ᫮ 客 , ।⠢  ଠ -4-1  -4-2: #####
  ᭮ :       ####
  ⥫쭮 :

  㯫 客 ᮢ  砫 ⭮ ਮ:
--------------------------------------------------------------------------------------
|     |    客    |  ⥫   |    ⥫쭮   |
|        |    㤮 ᨨ     |     㤮 ᨨ     |                  |
|--------|------------------------|-------------------------|------------------------|
|########|########################|#########################|                        |
|########|########################|#########################|                        |
|--------|------------------------|-------------------------|------------------------|
|⮣   |########################|#########################|                        |
--------------------------------------------------------------------------------------

᫥ 客 ᮢ   ਮ:
--------------------------------------------------------------------------------------
|ਧ |    客    |  ⥫   |    ⥫쭮   |
|  |     㤮 ᨨ    |     㤮 ᨨ     |                  |
|--------|------------------------|-------------------------|------------------------|
|########|########################|#########################|                        |
--------------------------------------------------------------------------------------

祭 客 ᮢ  ⭮ ਮ:
--------------------------------------------------------------------------------------
|   |    客    |  ⥫   |    ⥫쭮   |
|        |    㤮 ᨨ     |     㤮 ᨨ     |                  |
|--------|------------------------|-------------------------|------------------------|
|########|########################|#########################|                        |
|########|########################|#########################|                        |
|--------|------------------------|-------------------------|------------------------|
|⮣   |########################|#########################|                        |
--------------------------------------------------------------------------------------

  㯫 客 ᮢ   ⭮ ਮ:
--------------------------------------------------------------------------------------
|     |    客    |  ⥫   |    ⥫쭮   |
|        |    㤮 ᨨ     |     㤮 ᨨ     |                  |
|--------|------------------------|-------------------------|------------------------|
|########|########################|#########################|                        |
|########|########################|#########################|                        |
|########|########################|#########################|                        |
|--------|------------------------|-------------------------|------------------------|
|⮣   |########################|#########################|                        |
--------------------------------------------------------------------------------------

                                              ஢ 

 壠                                    #################################

  㪮⥫           ஢ 

###################################                  #################################

 ##############################     ..}
*)

(*
$P{ PartX1:
L_Packet.OwnFirmName, L, "", "U"
L_Packet.OwnNumInPFR, L, "", "U"
?, L, ""
?, L, "", "U"
?, L, "", "U"
PerByWord, L, "", "U"
?, R, ""
?, R, ""
?, R, ""
?, R, ""
?, R, ""
?, R, ""
?, R, ""
?, R, ""
?, R, ""
?, R, ""
?, R, ""
?, R, ""
?, R, ""
?, R, ""
L_Packet.OwnLeadPostName, L, "", "U"
L_Str.ShortName(L_Packet.OwnLeadName), L, "", "U"
@
                                                                   ଠ -10

 

 ࣠樨 ######################################################
樮     ######################################################
######################## ######################################################
⢮  -3    ######################################################
 ਮ          ######################################################

-------------------------------------------------------------------------------
|        |  㤠|  㤠|宦      |              |
|        |    ଠ     |   "⭮  |   䮭   |  ਬ砭  |
|        |". ᢥ"|    "   |      㤠      |              |
|--------|-----------------|-----------------|-----------------|--------------|
|   1    |        2        |        3        |        4        |       5      |
|--------|-----------------|-----------------|-----------------|--------------|
|  |#################|                 |                 |              |
|ࠫ |#################|                 |                 |              |
|    |#################|                 |                 |              |
|५  |#################|                 |                 |              |
|     |#################|                 |                 |              |
|    |#################|                 |                 |              |
|    |#################|                 |                 |              |
|  |#################|                 |                 |              |
||#################|                 |                 |              |
| |#################|                 |                 |              |
|  |#################|                 |                 |              |
| |#################|                 |                 |              |
|--------|-----------------|-----------------|-----------------|--------------|
|⮣   |#################|                 |                 |              |
-------------------------------------------------------------------------------
         ----------------------------------------------------------------------
         |㬬 客  |㬬 客  |   宦   |              |
         |ᮢ,         |ᮢ,         |㬬 客   |  ਬ砭  |
         |⠭   |⠭   |ᮢ          |              |
         |-3       ()|e 4- (.)|(.)           |              |
         |-----------------|-----------------|-----------------|--------------|
         |        6        |        7        |        8        |       9      |
         |-----------------|-----------------|-----------------|--------------|
         |#################|                 |                 |              |
         ----------------------------------------------------------------------

ਬ砭: ࠡ⮤⥫  樨 - 2, 6. 뢠 㬬
            祭  ।⠢塞 㠫 ᢥ


###################################                         ###################
  㪮⥫                  ஢ 

⬥⪠ ⤥ ᡮ 客 ᮢ        ..
                                                             ⠬}
*)

(*
$P{ PrbTop:
L_Packet.OwnFirmName, L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
?, L, ""
PerB, L, "N.y"
PerE, L, "N.y"
@
############################################################################################# ########## #####
=#####========================================================================================================
|            㦥 訡  ନ஢ ᢥ   ਮ  #######  #######            |
|------------------------------------------------------------------------------------------------------------|
|                                |ਬ砭                                                               |
|----------------------------------|-------------------------------------------------------------------------|
}
*)

(*
$P{ PrbLine:
?, L, ""
?, L, ""
@
|##################################|#########################################################################|
}
*)

(*
$P{ PrbBot:
@
=(c) Polak====================================================================================================
}
*)

 PRIVATE PROCEDURE intGetPaidFromInc(trgInc: L_PRoll.tSum; trgCoefIncPaid: tCoefIncPaidElm): L_PRoll.tSum;
  VAR
   Dummy: FLOAT;
 BEGIN
  Dummy:=trgCoefIncPaid;
  RETURN trgInc * Dummy;
 END {intGetPaidFromInc};

 PRIVATE PROCEDURE GetCurPaidFromInc(trgInc: L_PRoll.tSum;
                                     trgPFPart: tPFPart;
                                     trgCategory: tCategory;
                                     trgCntrType: L_Packet.tCntrType): L_PRoll.tSum;
  VAR
   Result: L_PRoll.tSum;
 BEGIN
  IF SEARCH(TmpIP, Man, Man.Man, trgCategory, trgCntrType) THEN
(*
   L_General.CallUs(trgInc = TmpIP.CurInc[trgPFPart]);
*)
   L_General.CallUs(Math.Abs(trgInc - TmpIP.CurInc[trgPFPart]) <= 0.031); (*23.04.2013 16:30:01 POLAK\Bor 0097146 .4*)
   Result:=TmpIP.CurPaid[trgPFPart];
  ELSE
(*
   L_General.CallUs((trgInc = 0) | (L_Packet.BuildMode = L_Packet.bm_bySingle));
*)
   L_General.CallUs((trgInc = 0) | (trgInc <= 0.031) | (L_Packet.BuildMode = L_Packet.bm_bySingle));
   Result:=0;
  END;
  RETURN Result;
 END {GetCurPaidFromInc};

 PRIVATE PROCEDURE GetPaidFromInc(trgInc: tPFSum; trgCoefIncPaid: tCoefIncPaid): tPFSum;
  VAR
   Result: tPFSum;
 BEGIN
  Result[tp_PFIn]:=intGetPaidFromInc(trgInc[tp_PFIn], trgCoefIncPaid[tp_PFIn]);
  Result[tp_PFAc]:=intGetPaidFromInc(trgInc[tp_PFAc], trgCoefIncPaid[tp_PFAc]);
  RETURN Result;
 END {GetPaidFromInc};

 PRIVATE PROCEDURE PFSumINC(VAR dstPFSum: tPFSum; srcPFSum: tPFSum);
 BEGIN
  INC(dstPFSum[tp_PFIn], srcPFSum[tp_PFIn]);
  INC(dstPFSum[tp_PFAc], srcPFSum[tp_PFAc]);
 END {PFSumINC};

 PRIVATE PROCEDURE PFSumDEC(VAR dstPFSum: tPFSum; srcPFSum: tPFSum);
 BEGIN
  DEC(dstPFSum[tp_PFIn], srcPFSum[tp_PFIn]);
  DEC(dstPFSum[tp_PFAc], srcPFSum[tp_PFAc]);
 END {PFSumDEC};

 PRIVATE PROCEDURE PFSumSUM(frsPFSum, secPFSum: tPFSum): tPFSum;
  VAR
   Result: tPFSum;
 BEGIN
  Result[tp_PFIn]:=frsPFSum[tp_PFIn]+secPFSum[tp_PFIn];
  Result[tp_PFAc]:=frsPFSum[tp_PFAc]+secPFSum[tp_PFAc];
  RETURN Result;
 END {PFSumSUM};

 PRIVATE PROCEDURE PFSumSUB(frsPFSum, secPFSum: tPFSum): tPFSum;
  VAR
   Result: tPFSum;
 BEGIN
  Result[tp_PFIn]:=frsPFSum[tp_PFIn]-secPFSum[tp_PFIn];
  Result[tp_PFAc]:=frsPFSum[tp_PFAc]-secPFSum[tp_PFAc];
  RETURN Result;
 END {PFSumSUB};

 PRIVATE PROCEDURE PFSumIsZERO(trgPFSum: tPFSum): SCAL[2];
 BEGIN
  RETURN (trgPFSum[tp_PFIn] = 0) & (trgPFSum[tp_PFAc] = 0);
 END {PFSumIsZERO};

 PRIVATE PROCEDURE SetQBMS(VAR trgQuartalByMonthSum: tQuartalByMonthSum; QMonth: tQMonth; Sum: L_PRoll.tSum);
 BEGIN
  trgQuartalByMonthSum[QMonth]:=Sum;
  INC(trgQuartalByMonthSum[TotQBMS], Sum);
 END {SetQBMS};

 PRIVATE PROCEDURE _GetADV10BySelect(Field: STRING[]): L_PRoll.tSum;
  VAR
   R: L_PRoll.tSum;
 BEGIN
  R:=0;
  WHILE OCCURE(ADV10) DO
   INC(R, ^("ADV10."+Field));
   NEXT(ADV10);
  END; (* WHILE OCCURE(ADV10) ... *)
  RETURN R;
 END {_GetADV10BySelect};

 PRIVATE PROCEDURE GetADV10Total(Field: STRING[]): L_PRoll.tSum;
  VAR
   R: L_PRoll.tSum;
 BEGIN
  SAVE(ADV10);
  SELECT(ADV10, ADV10);
  R:=_GetADV10BySelect(Field);
  RESTORE(ADV10);
  RETURN R;
 END {GetADV10Total};

 PRIVATE PROCEDURE GetADV10ByPacket(_Packet: LIKE(Packet.ExtNbr); Field: STRING[]): L_PRoll.tSum;
  VAR
   R: L_PRoll.tSum;
 BEGIN
  SAVE(ADV10);
  SELECT(ADV10, ADV10, , _Packet);
  R:=_GetADV10BySelect(Field);
  RESTORE(ADV10);
  RETURN R;
 END {GetADV10ByPacket};

 PRIVATE PROCEDURE GetADV10ByRealPackets(Field: STRING[]): L_PRoll.tSum;
 BEGIN
  RETURN GetADV10Total(Field);
 END {GetADV10ByRealPackets};

 PRIVATE PROCEDURE GetADV10BySelectForADV10(Field: STRING[]): L_PRoll.tSum;
  VAR
   R: L_PRoll.tSum;
 BEGIN
  SAVE(ADV10);
  R:=_GetADV10BySelect(Field);
  RESTORE(ADV10);
  RETURN R;
 END {GetADV10BySelectForADV10};

 PRIVATE PROCEDURE IsSince2014(): SCAL[2];
 BEGIN
  RETURN PerB >= 01\01\2014;
 END {IsSince2014};

 PRIVATE PROCEDURE IsSince2013(): SCAL[2];
 BEGIN
  RETURN PerB >= 01\01\2013;
 END {IsSince2013};

 PRIVATE PROCEDURE IsSince2012(): SCAL[2];
 BEGIN
  RETURN PerB >= 01\01\2012;
 END {IsSince2012};

 PRIVATE PROCEDURE IsSince2011(): SCAL[2];
 BEGIN
  RETURN PerB >= 01\01\2011;
 END {IsSince2011};

 PRIVATE PROCEDURE IsSince2010(): SCAL[2];
 BEGIN
  RETURN (PerB >= 01\01\2010) & ~ADV11After2009;
 END {IsSince2010};

 PRIVATE PROCEDURE IsSince2002(): SCAL[2];
 BEGIN
  RETURN PerB >= 01\01\2002;
 END {IsSince2002};

 PRIVATE PROCEDURE IsSince2001(): SCAL[2];
 BEGIN
  RETURN PerB >= 01\01\2001;
 END {IsSince2001};

 PRIVATE PROCEDURE IsCorrPacket(): SCAL[2];
 BEGIN
  RETURN (Packet.CorrType # L_Packet.ct_None);
 END {IsCorrPacket};

 PRIVATE PROCEDURE IsForPensPacket(): SCAL[2];
 BEGIN
  RETURN (Packet.DataType = L_Packet.dt_ForPens) | (Packet.Kind = L_Packet.knd_PF_SPV1);
 END {IsForPensPacket};

 PRIVATE PROCEDURE E_ManIns_NeedMakeKORR(): L_Packet.tNeedCorr;
  VAR
   Result: L_Packet.tNeedCorr;
 BEGIN
  Result:=L_EC.ExecE_Func_Numeric(PerE, PROCREF(E_PRoll.ManIns_NeedMakeKORR), L_Packet.minc_No);
  IF IsSince2010() & (Result = L_Packet.minc_ForPens) THEN
   RETURN L_Packet.minc_Basic;
  ELSE
   RETURN Result;
  END;
 END {E_ManIns_NeedMakeKORR};

 PRIVATE PROCEDURE E_ManIns_ExtNbrForADV(): LIKE(Packet.ExtNbr);
  VAR
   Proc: PROC;
 BEGIN
  Proc:=PROCREF(E_PRoll.ManIns_ExtNbrForADV);
  IF ~!Proc THEN
   DEC(CurPacket);
   RETURN Proc(PerE);
  ELSE
   RETURN CurPacket;
  END;
 END {E_ManIns_ExtNbrForADV};

 PRIVATE PROCEDURE GetStaffCntrType(D: DATE): L_Packet.tCntrType;
  CONST
   vldP = 01\01\2013;
  VAR
   Result: L_Packet.tCntrType;
 BEGIN
  TRY [RESTORE_CURSORS(RC_ON)]
   IF (D>=vldP) |             (* 2013   ᢥ  ⨯ ஢*)
      L_Staff.IsStandOnMainContract(Staff.Man, L_Packet.PckMyFirm, vldP-1) THEN
    IF (Staff.Contract = L_Staff.cnt_ContractorsAgreement) THEN
     Result:=L_Packet.cntrt_CA;
    ELSE
     Result:=L_Packet.cntrt_Basic;
    END;
   ELSE
    Result:=L_Packet.cntrt_Basic;
   END;
  EXCEPT
  END; (* TRY *)
  RETURN Result;
 END {GetStaffCntrType};

 PRIVATE PROCEDURE PutNumToPckAttr(_Attr: LIKE(PckAttr.Attr); _Value: NUMERIC[2]);
 BEGIN
  L_Packet.PutPacketAttr(Packet.Packet, _Attr, FLDTOSTR(_Value, "2."));
 END {PutNumToPckAttr};

 PRIVATE PROCEDURE PutDateToPckAttr(_Attr: LIKE(PckAttr.Attr); _Value: DATE);
 BEGIN
  L_Packet.PutPacketAttr(Packet.Packet, _Attr, FLDTOSTR(_Value, "D.N.y"));
 END {PutDateToPckAttr};

 PRIVATE PROCEDURE GetPckAttrAsNum(_Attr: STRING[]): NUMERIC[2];
  VAR
   _Val: STRING[];
 BEGIN
  _Val:=L_Packet.GetPacketAttr(Packet.Packet, _Attr);
  IF !_Val THEN
   RETURN 0;
  ELSE
   RETURN STRTOFLD(_Val, NUMERIC);
  END;
 END {GetPckAttrAsNum};

 PRIVATE PROCEDURE GetPckAttrAsDate(trgAttr: STRING[]): DATE;
 BEGIN
  RETURN STRTOFLD(L_Packet.GetPacketAttr(Packet.Packet, trgAttr), DATE);
 END {GetPckAttrAsDate};

 PRIVATE PROCEDURE GetPckBodyManPerE(): DATE;
 BEGIN
  RETURN STRTOFLD(L_Packet.GetPckBodyAttr(PckBody.Packet, PckBody.SeqNbr, patt_ManPerE), DATE);
 END {GetPckBodyManPerE};

 PRIVATE PROCEDURE GetManPerB(): DATE;
 BEGIN
  RETURN PerB;
 END {GetManPerB};

 PRIVATE PROCEDURE GetManPerE(): DATE;
  VAR
   D  : DATE;
   Msg: STRING[];
 BEGIN
  D:=GetPckBodyManPerE();
  IF !D THEN
   RETURN PerE;
  ELSE
   Msg:=" "+Packet.ExtNbr+" ( "+Packet.Packet+")"+
        "|ਮ  "+L_DatTim.DateStr(Packet.PerB)+
        "  "+L_DatTim.DateStr(Packet.PerE)+
        "| |ப "+PckBody.SeqNbr+" ( "+PckBody.Man+")"+
        "|ਮ  "+L_DatTim.DateStr(Packet.PerB)+
        "  "+L_DatTim.DateStr(D)+"| |";
   L_General.Assert(IsForPensPacket(), Msg+"࠭祭 ਮ    ਬ|⮫쪮    ⨯ '祭 ᨨ'");
   L_General.Assert(L_DatTim.Per(D) = L_DatTim.Per(PerE), Msg+" 砭 ਮ  |    砭 ਮ   楫");
   RETURN D;
  END;
 END {GetManPerE};

 PRIVATE PROCEDURE PutManPerE(_ManPerE: DATE);
 BEGIN
  L_Packet.PutPckBodyAttr(PckBody.Packet, PckBody.SeqNbr, patt_ManPerE, FLDTOSTR(_ManPerE, "D.N.y"));
 END {PutManPerE};

 PRIVATE PROCEDURE PerBMoney(D: DATE): DATE;
 BEGIN
  IF D # L_DatTim.MonthBeg(D) THEN
   RETURN L_DatTim.MonthEnd(D)+1;
  ELSE
   RETURN D;
  END;
 END {PerBMoney};

 PRIVATE PROCEDURE PerEMoney(D: DATE): DATE;
 BEGIN
  IF D # L_DatTim.MonthEnd(D) THEN
   RETURN L_DatTim.MonthBeg(D)-1;
  ELSE
   RETURN D;
  END;
 END {PerEMoney};

 PRIVATE PROCEDURE MoneyToTxt(x: L_PRoll.tSum): STRING[];
 BEGIN
  IF !x THEN
   RETURN "";
  END;
  IF PerE < L_General.DenominationDate() THEN
   RETURN FLDTOSTR(x, "0", 0);
  ELSE
   RETURN FLDTOSTR(x, "2.", 0);
  END;
 END {MoneyToTxt};

 PRIVATE PROCEDURE MoneyToIntTxt(x: L_PRoll.tSum): STRING[];
 BEGIN
  IF !x THEN
   RETURN "";
  END;
  RETURN FLDTOSTR(x, "0", 0);
 END {MoneyToIntTxt};

 PRIVATE PROCEDURE GoodTSN(ManPerB, ManPerE: DATE; InIntvl, WithInternalCombine: SCAL[2]): SCAL[2];
 BEGIN
  RETURN L_Env.RealTSN(Staff.TSN) &
         (WithInternalCombine | (Staff.Contract # L_Staff.cnt_InternalCombine)) &
         (~InIntvl | L_DatTim.IsActiveInIntvl_Inc(ManPerB, ManPerE, Staff.BegDate, Staff.EndDate)) &
         ~L_Packet.E_ManIns_ExcludedTSN(ManPerB);
 END {GoodTSN};

 PRIVATE PROCEDURE CheckMCList_Type1();
 BEGIN
  IF IsSince2002() THEN
   L_General.Assert(~L_DatTim.IsActive(PerE, MCList.Begin, MCList.Till),
                    "   㤥ঠ, 易  ");
  ELSE
   L_General.Assert((MCList.MCode = L_Tax.Tax_GetLoanProfitMCode(PerE)),
                    "⭮    㤥ঠ, 易    - 룮  %");
  END;
 END {CheckMCList_Type1};

 PRIVATE PROCEDURE CheckActiveMCList(Cond: SCAL[2]; Text: STRING[]);
 BEGIN
  IF L_DatTim.IsActiveInIntvl(PerB, PerE, MCList.Begin, MCList.Till) THEN
   L_General.Assert(Cond, Text);
  END;
 END {CheckActiveMCList};

 PRIVATE PROCEDURE PrepareMsForMoney();
 BEGIN
  IF ~IsSince2002() THEN
   SETZERO(Ms1, Ms2);
   SELECT(MCList, MCode);
   WHILE OCCURE(MCList) DO
    PROMPT(" / "+MCList.MCode);
    IF IsSince2001() THEN
     IF  MCList.InSign[5](*-  ᨨ*) THEN
      IF MCList.MCTyp=0 THEN
       Ms1[MCList.MCode]:=+1;
      ELSE
       CheckMCList_Type1();
       Ms1[MCList.MCode]:=-1;
      END;
     END;
     IF   MCList.InSign[1] THEN
      L_General.Assert(MCList.InSign[5],
       "  /,   㯫稢 ,|室  ࠡ⮪  ᫥ ᨨ| "+MCList.MCode);
      IF MCList.MCTyp # 0 THEN
       CheckMCList_Type1();
      END;
      Ms2[MCList.MCode]:=1;
     END;
    ELSE
     IF  MCList.InSign[5](*-  ᨨ*) THEN
      CheckActiveMCList(MCList.MCTyp=0, " ᨨ  뢠 ⮫쪮 ᫥| "+MCList.MCode);
      Ms1[MCList.MCode]:=1;
     END;
     IF MCList.ForDed[2](* *) THEN
      CheckActiveMCList(MCList.MCTyp=0,   " ᨮ ᮢ  뢠 ⮫쪮 ᫥| "+MCList.MCode);
      CheckActiveMCList(MCList.InSign[5], "  ᫥,   㯫稢   ,|室    ᫥ ᨨ| "+MCList.MCode);
      Ms2[MCList.MCode]:=1;
     END;
    END;
    NEXT(MCList);
   END; (* WHILE OCCURE(MCList)... *)
  END;
 END {PrepareMsForMoney};

 PRIVATE PROCEDURE GetMoney(P: DATE; VAR s1, s2: L_PRoll.tSum);
 BEGIN
  SELECT(Money, TSN, , Staff.TSN, P);
  WHILE OCCURE(Money) DO
   IF Ms1[Money.MCode] # 0 THEN
    INC(s1, Money.Sum*Ms1[Money.MCode]);
    IF ~Ms2[Money.MCode] THEN
     INC(s2, Money.Sum);
    END;
   END;
   NEXT(Money);
  END; (* WHILE OCCURE(Money)... *)
 END {GetMoney};

 PRIVATE PROCEDURE GetManStrId(_Man: LIKE(Man.Man)): STRING[];
 BEGIN
  RETURN "窠 "+Packet.ExtNbr+"-"+L_Str.IntStr(CurNumInP) + " (: " + _Man + ")";
 END {GetManStrId};

 PRIVATE PROCEDURE MakeStfLg(trgCntrType: L_Packet.tCntrType; ManPerB, ManPerE: DATE);
  VAR
   DB, DE,
   B,  E    : DATE;
   PrvOut,
   Out,
   Rem,
   NewPns,
   Need     : SCAL[2];
   curPnsAttr : LIKE(Officer.PnsAttr);
   _TSN     : LIKE(Staff.TSN);
   curContract: LIKE(Staff.Contract);
   curCntrType: L_Packet.tCntrType;
 BEGIN
  SETSEL(StfLg, StfLg);
  REMSEL(StfLg);

  SELECT(Staff, MyFirm, , L_Packet.PckMyFirm, Man.Man);
  WHILE OCCURE(Staff) DO
   IF GoodTSN(ManPerB, ManPerE, 1, 0) & (GetStaffCntrType(ManPerE) = trgCntrType) THEN
    PrvOut:=1;
    SETEMPTY(curPnsAttr);
    SETSEL(StaffLog, TSN, Staff.TSN);
    SRCINSEL(StaffLog, LE, , Math.Max(ManPerB, Staff.BegDate));
    LOOP
     Out:=~OCCURE(StaffLog) | (StaffLog.Date>Math.Min(ManPerE, Staff.EndDate)) | L_Staff.IsDischargeStaffLog();
     IF ~Out THEN
      CONFORM(StaffLog, Officer);
      NewPns:=curPnsAttr # Officer.PnsAttr;
     ELSE
      NewPns:=0;
     END;
     IF (PrvOut # Out) | NewPns THEN
      IF ~PrvOut THEN
       IF ~OCCURE(StaffLog) THEN
        E:=ManPerE;
       ELSE
        E:=Math.Min(ManPerE, StaffLog.Date-1);
       END;
       StfLg.Numb:=0;
       StfLg.TSN:=Staff.TSN;
       StfLg.Contract:=Staff.Contract;
       StfLg.CntrType:=GetStaffCntrType(ManPerE);
       StfLg.DateB:=B;
       StfLg.DateE:=E;
       StfLg.PnsAttr:=curPnsAttr;
       INSERT(StfLg);
       SETEMPTY(curPnsAttr);
      END;
      IF PrvOut | NewPns THEN
       B:=Math.Max(ManPerB, StaffLog.Date);
       curPnsAttr:=Officer.PnsAttr;
      END;
     END;
     PrvOut:=Out;
     IF ~OCCURE(StaffLog) THEN
      EXIT;
     END;
     NEXT(StaffLog);
    END;
   END; (* IF Staff.Contract ... *)
   NEXT(Staff);
  END; (* WHILE OCCURE(Staff) ... *)

  SELECT(StfLg, StfLg, , trgCntrType, 0);
  WHILE OCCURE(StfLg) DO
   _TSN:=StfLg.TSN;
   B:=StfLg.DateB;
   E:=StfLg.DateE;
   DB:=B;
   DE:=E;
   curPnsAttr:=StfLg.PnsAttr;
   curContract:=StfLg.Contract;
   curCntrType:=StfLg.CntrType;

   Need:=1;
   SAVE(StfLg);
   Rem:=1;
   NEXT(StfLg);
   WHILE OCCURE(StfLg) & (StfLg.DateB<=E) & Rem DO
    Rem:=0;
    IF (StfLg.PnsAttr = L_Packet.OrdinaryPnsAttr) & (StfLg.Contract # L_Staff.cnt_Basic) THEN
     IF StfLg.DateE <= E THEN
      REMOVE(StfLg);
      Rem:=1;
     ELSE
      StfLg.DateB:=E+1;
      REPLACE(StfLg);
     END;
    ELSE
     IF StfLg.DateB > B THEN
      DE:=StfLg.DateB-1;
      B:=StfLg.DateB;
      PREV(StfLg);
      StfLg.DateB:=B;
      INSERT(StfLg);
     ELSE (*StfLg.DateB = B*)
      IF StfLg.DateE<E THEN
       DE:=StfLg.DateE;
       SAVE(StfLg);
       B:=StfLg.DateE+1;
       PREV(StfLg);
       StfLg.DateB:=B;
       INSERT(StfLg);
       RESTORE(StfLg);
      END;
      IF (curContract # L_Staff.cnt_Basic) & (curPnsAttr = L_Packet.OrdinaryPnsAttr) THEN
       Need:=0;
      ELSE
       IF StfLg.DateE>E THEN
        SAVE(StfLg);
        StfLg.DateB:=E+1;
        INSERT(StfLg);
        RESTORE(StfLg);
        StfLg.DateE:=E;
        REPLACE(StfLg);
       END;
       IF (curPnsAttr = L_Packet.OrdinaryPnsAttr) & (curContract = L_Staff.cnt_Basic) THEN
        curPnsAttr:=StfLg.PnsAttr;
        REMOVE(StfLg);
       END;
      END;
     END;
    END;
   END;
   IF Need THEN
    DEFAULT(StfLg);
    StfLg.Numb:=1;
    StfLg.TSN:=_TSN;
    StfLg.DateB:=DB;
    StfLg.DateE:=DE;
    StfLg.PnsAttr:=curPnsAttr;
    StfLg.Contract:=curContract;
    StfLg.CntrType:=curCntrType;
    INSERT(StfLg);
   END;
   RESTORE(StfLg);
   NEXT(StfLg);
  END; (* WHILE OCCURE(StfLg) ... *)
 END {MakeStfLg};

 PRIVATE PROCEDURE GetAvePay(VAR _APJMode: LIKE(Sheet.JMode); VAR BD, ED: DATE): SCAL[2];
 BEGIN
  IF Sheet.Source = L_Sheet.src_AvePay THEN
   SETSEL(AvePay, TSN, StfLg.TSN);
   SRCINSEL(AvePay, LE, , Sheet.Period+Sheet.Day-1);
   WHILE OCCURE(AvePay) DO
    IF L_AvePay.IsRealAvePay() THEN
     CONFORM(AvePay, AvePayP);
     WHILE OCCURE(AvePayP) DO
      IF L_DatTim.IsActive_Inc(Sheet.Period+Sheet.Day-1, AvePayP.StartD, AvePayP.StopD) THEN
       CONFORM(AvePayP, AveTypeP);
       IF ~!AveTypeP.JMode THEN
        _APJMode:=AveTypeP.JMode;
        BD:=AvePayP.StartD;
        ED:=AvePayP.StopD;
        RETURN 1;
       END;
      END;
      NEXT(AvePayP);
     END; (* WHILE OCCURE(AvePayP) ... *)
    END;
    PREV(AvePay);
   END; (* WHILE OCCURE(AvePay) ... *)
  END;
  RETURN 0;
 END {GetAvePay};

 PRIVATE PROCEDURE CheckType(    D: DATE;
                                 ForceNotInState: SCAL[2];
                                 curJMode: LIKE(Sheet.JMode);
                                 trgCategory: tCategory;
                                 trgCntrType: L_Packet.tCntrType;
                             VAR prvMInsType: L_Packet.tMInsType;
                             VAR _BegD: DATE;
                                 Last: SCAL[2]);
  VAR
   curMInsType: L_Packet.tMInsType;
 BEGIN
  IF ForceNotInState THEN
   curMInsType:=EMPTYOF(L_Packet.tMInsType);
  ELSE
   IF L_Packet.BuildMode = L_Packet.bm_byPacket THEN
    curMInsType:=L_Packet.ext_E_SpecStageForPens(D, curJMode, Packet.Kind);
   ELSE
    curMInsType:=L_Packet.ext_E_SpecStageForPens(D, curJMode, L_Packet.Get_PF_PacketKind(PerB, PerE, L_Packet.dt_Basic, L_Packet.ct_None));
   END;
  END;

  IF (curMInsType # prvMInsType) | Last THEN
   IF ~!prvMInsType THEN
    _MIns.Numb:=mi_Stage;
    _MIns.Man:=Man.Man;
    _MIns.Category:=trgCategory;
    _MIns.CntrType:=trgCntrType;
    _MIns.BegD:=_BegD;
    _MIns.EndD:=D-1;
    _MIns.PostName:="";
    _MIns.Type:=prvMInsType;
    INSERT(_MIns);
   END;
   IF ~!curMInsType THEN
    _BegD:=D;
   END;
   prvMInsType:=curMInsType;
  END;
 END {CheckType};

 PRIVATE PROCEDURE CheckType2(D: DATE;
                              ForceNotInState: SCAL[2];
                              curJMode: LIKE(Sheet.JMode);
                              VAR prvAddType: L_Packet.tMInsAddType;
                              VAR _BegD2: DATE);
  VAR
   curAddType: L_Packet.tMInsAddType;
 BEGIN
  IF ForceNotInState THEN
   SETEMPTY(curAddType);
  ELSE
   curAddType:=E_Staff.SpecStage2ForPens(D, curJMode);
  END;
  IF (curAddType # prvAddType) THEN
   IF ~!prvAddType THEN
    INC(Days[prvAddType], L_Packet.DaysInIntvl(_BegD2, D-1));
   END;
   IF ~!curAddType THEN
    _BegD2:=D;
   END;
   prvAddType:=curAddType;
  END;
 END {CheckType2};

 PRIVATE PROCEDURE GetNotInState(D: DATE; PerToExcl: SCAL[2][]): SCAL[2];
 BEGIN
  RETURN PerToExcl[L_DatTim.MONTH(D)] | ~IsInsuredInPF_OnDate(D);
 END {GetNotInState};

 PRIVATE PROCEDURE GetSpecStage(trgCategory: tCategory;
                                trgCntrType: L_Packet.tCntrType;
                                ManPerB,
                                ManPerE: DATE;
                                PerToExcl: SCAL[2][]): NUMERIC[0];
  CONST
   FictDate = 01\01\1900;
  VAR
   _APD1,
   _APD2,
   _BegD,
   _BegD2,
   _EndD,
   D, DE,
   D1, D2  : DATE;
   _APJMode: LIKE(Sheet.JMode);
   _PnsAttr: LIKE(Officer.PnsAttr);
   _Type   : L_Packet.tMInsType;
   _Type2  : L_Packet.tMInsAddType;
   SN      : NUMERIC[0];
   _PostName: LIKE(Post.Name);
 BEGIN
  SETZERO(Days, Months);
  IF ~SELECT(_MIns, _MIns, mi_Stage, Man.Man, trgCategory, trgCntrType) THEN
   StageNum:=0;
   SETEMPTY(_APJMode, _APD1, _APD2);
   MakeStfLg(trgCntrType, ManPerB, ManPerE);
   SELECT(StfLg, StfLg, , trgCntrType, 1);
   WHILE OCCURE(StfLg) DO
    D1:=Math.Max(StfLg.DateB, ManPerB);
    D2:=StfLg.DateE;
    SETEMPTY(_Type, _Type2);

    IF D1<L_Env.aptm_Start THEN
     DE:=Math.Min(L_Env.aptm_Start-1, D2);
     D:=D1;

     SELECT(AvePay, TSN, , StfLg.TSN);
     WHILE OCCURE(AvePay) & (AvePay.StartD<=DE) DO
      IF AvePay.StopD>=D1 THEN
       CONFORM(AvePay, AvePayP);
       WHILE OCCURE(AvePayP) DO
        IF L_DatTim.IsActiveInIntvl_Inc(D1, DE, AvePayP.StartD, AvePayP.StopD) THEN
         CONFORM(AvePayP, AveTypeP);
         IF ~!AveTypeP.JMode THEN

          WHILE D < AvePayP.StartD DO
           CheckType (D, GetNotInState(D, PerToExcl), EMPTYOF(JMode.JMode), trgCategory, trgCntrType, _Type,  _BegD, 0);
           CheckType2(D, GetNotInState(D, PerToExcl), EMPTYOF(JMode.JMode), _Type2, _BegD2);
           INC(D);
          END;

          _APD2:=Math.Min(AvePayP.StopD, DE);
          WHILE D<=_APD2 DO
           CheckType (D, GetNotInState(D, PerToExcl), AveTypeP.JMode, trgCategory, trgCntrType, _Type,  _BegD, 0);
           CheckType2(D, GetNotInState(D, PerToExcl), AveTypeP.JMode, _Type2, _BegD2);
           D:=L_DatTim.NextPer(D);
          END;
          D:=_APD2+1;
         END;
        END;
        NEXT(AvePayP);
       END; (* WHILE OCCURE(AvePayP) ... *)
      END;
      NEXT(AvePay);
     END; (* WHILE OCCURE(AvePay) ... *)

     WHILE D <= DE DO
      CheckType (D, GetNotInState(D, PerToExcl), EMPTYOF(JMode.JMode), trgCategory, trgCntrType, _Type,  _BegD, 0);
      CheckType2(D, GetNotInState(D, PerToExcl), EMPTYOF(JMode.JMode), _Type2, _BegD2);
      INC(D);
     END;
    END;

    D:=Math.Max(D1, L_Env.aptm_Start);
    SETSEL(Sheet, TSN, StfLg.TSN);
    SRCINSEL(Sheet, GE, , L_DatTim.Per(D), L_DatTim.DAY(D));
    WHILE OCCURE(Sheet) & ((Sheet.Period+Sheet.Day-1) <= D2) DO
     PROMPT(":  "+Man.Man+"  "+L_DatTim.DateStr(Sheet.Period+Sheet.Day-1));

     IF GetAvePay(_APJMode, _APD1, _APD2) THEN
      D:=Math.Max(_APD1, D1);
      WHILE D<=Math.Min(_APD2, D2) DO
       CheckType (D, GetNotInState(D, PerToExcl), _APJMode, trgCategory, trgCntrType, _Type,  _BegD, 0);
       CheckType2(D, GetNotInState(D, PerToExcl), _APJMode, _Type2, _BegD2);
       D:=L_DatTim.NextPer(D);
      END;
      SRCINSEL(Sheet, GT, , L_DatTim.Per(_APD2), L_DatTim.DAY(_APD2));
     ELSE
      D:=Sheet.Period+Sheet.Day-1;
      CheckType (D, GetNotInState(D, PerToExcl), Sheet.JMode, trgCategory, trgCntrType, _Type,  _BegD, 0);
      CheckType2(D, GetNotInState(D, PerToExcl), Sheet.JMode, _Type2, _BegD2);
      NEXT(Sheet);
     END;
    END;
    CheckType (D2+1, 1, EMPTYOF(JMode.JMode), trgCategory, trgCntrType, _Type,  _BegD, 1);
    CheckType2(D2+1, 1, EMPTYOF(JMode.JMode), _Type2, _BegD2);

    SETEMPTY(_PnsAttr, _BegD);
    SEARCH(PnsAttr, PnsAttr, , StfLg.PnsAttr);
    IF IsSince2002() THEN
     _Type:=PnsAttr.Str2002;
    ELSE
     _Type:=PnsAttr.Str;
    END;

    NEXT(StfLg);
   END; (* WHILE OCCURE(Staff) ... *)

   (*⪠ 㦭 ࠧ*)
   SETEMPTY(_PostName, _Type, _BegD, _EndD);
   SELECT(_MIns, _MIns, , mi_Stage, Man.Man, trgCategory, trgCntrType);
   WHILE OCCURE(_MIns) DO
    IF !_MIns.Type THEN
     SETEMPTY(_PostName, _Type, _BegD, _EndD);
     REMOVE(_MIns);
    ELSE
     IF (_Type = _MIns.Type) & (*(_PostName = _MIns.PostName) &*) (_EndD = (_MIns.BegD-1)) THEN
      _EndD:=_MIns.EndD;
      PREV(_MIns);
      _MIns.EndD:=_EndD;
      REPLACE(_MIns);
      NEXT(_MIns);
      REMOVE(_MIns);
     ELSE
      INC(StageNum);
      _Type    :=_MIns.Type;
      _PostName:=_MIns.PostName;
      _BegD    :=_MIns.BegD;
      _EndD    :=_MIns.EndD;
      NEXT(_MIns);
     END;
    END;
   END; (* WHILE OCCURE(_MIns)... *)

   DEFAULT(_MIns);
   _MIns.Numb:=mi_DisabilityLen;
   _MIns.Man:=Man.Man;
   _MIns.Category:=trgCategory;
   _MIns.CntrType:=trgCntrType;
   _MIns.BegD:=FictDate;
   _MIns.EndD:=FictDate+Days[L_Packet.miat_Disability];
   INSERT(_MIns);
   _MIns.Numb:=mi_UnpaidLeaveLen;
   _MIns.BegD:=FictDate;
   _MIns.EndD:=FictDate+Days[L_Packet.miat_UnpaidLeave];
   INSERT(_MIns);
   SN:=StageNum;
  ELSE
   SN:=0;
   SELECT(_MIns, _MIns, , mi_Stage, Man.Man, trgCategory, trgCntrType);
   WHILE OCCURE(_MIns) DO
    INC(SN);
    NEXT(_MIns);
   END; (* WHILE OCCURE(_MIns) ... *)
   SELECT(_MIns, _MIns, , mi_DisabilityLen, Man.Man, trgCategory, trgCntrType);
   Days[L_Packet.miat_Disability]:=_MIns.EndD-_MIns.BegD;
   SELECT(_MIns, _MIns, , mi_UnpaidLeaveLen, Man.Man, trgCategory, trgCntrType);
   Days[L_Packet.miat_UnpaidLeave]:=_MIns.EndD-_MIns.BegD;
  END;
  L_Packet.NormalizeDM(Days[L_Packet.miat_Disability],  Months[L_Packet.miat_Disability]);
  L_Packet.NormalizeDM(Days[L_Packet.miat_UnpaidLeave], Months[L_Packet.miat_UnpaidLeave]);
  IF Months[L_Packet.miat_Disability] = 12 THEN
   Days[L_Packet.miat_Disability]:=0; (*- ਢ ⬠   ॢ  *)
  END;
  IF Months[L_Packet.miat_UnpaidLeave] = 12 THEN
   Days[L_Packet.miat_UnpaidLeave]:=0;
  END;
  RETURN SN;
 END {GetSpecStage};

 PRIVATE PROCEDURE Inc(VAR S: NUMERIC[2]; s: NUMERIC[2]);
 BEGIN
  IF !S THEN S:=0; END;
  INC(S, s);
 END {Inc};

 PRIVATE PROCEDURE AccessPacket(_ExtNbr: LIKE(Packet.ExtNbr)): SCAL[2];
 BEGIN
  RETURN SELECT(Packet, PacketDS, L_Packet.rcv_PensFund, L_Packet.DTStamp, _ExtNbr);
 END {AccessPacket};

 PRIVATE PROCEDURE SetPckBodyByIntrm(trgExtNbr: LIKE(Packet.ExtNbr));
 BEGIN
  IF ~AccessPacket(trgExtNbr) THEN
   L_Packet.InsPFPacket(Intrm.PckKind, trgExtNbr, PerB, PerE, Intrm.DataType, Intrm.CorrType);
   L_Packet.PutPacketAttr(Packet.Packet, patt_Category, Intrm.Category);
   L_Packet.PutPacketAttr(Packet.Packet, patt_CategoryNick, GetCategoryNick(Intrm.Category));
   L_Packet.PutPacketAttr(Packet.Packet, patt_Group,    L_Str.IntStr(Intrm.Group));
   L_Packet.PutPacketAttr(Packet.Packet, patt_CntrType, L_Str.PoolItem(L_Packet.cntrt_Pool, Intrm.CntrType));
   L_Packet.PutPacketAttr(Packet.Packet, patt_PerCode,  L_Str.IntStr(Quarter));
  END;
  DEFAULT(PckBody);
  PckBody.Packet  :=Packet.Packet;
  PckBody.Man     :=Intrm.Man;
  INSERT(PckBody);
  IF ~!Intrm.ManPerE & (Intrm.ManPerE # PerE) THEN
   PutManPerE(Intrm.ManPerE);
  END;
  Intrm.Packet:=PckBody.Packet;
  Intrm.SeqNbr:=PckBody.SeqNbr;
  REPLACE(Intrm);
 END {SetPckBodyByIntrm};

 PRIVATE PROCEDURE HasExcludedTSN(P: DATE): SCAL[2];
 BEGIN
  SELECT(Staff, MyFirm, , L_Packet.PckMyFirm, Man.Man);
  WHILE OCCURE(Staff) DO
   IF L_Packet.E_ManIns_ExcludedTSN(P) THEN
    RETURN 1;
   END;
   NEXT(Staff);
  END; (* WHILE OCCURE(Staff) ... *)
  RETURN 0;
 END {HasExcludedTSN};

 PRIVATE PROCEDURE WorkInPer(ManPerB, ManPerE: DATE; VAR PerOfPay: SCAL[2][]): SCAL[2];
  VAR
   _Sum   : L_PRoll.tSum;
   _Period: DATE;
   _Month : L_DatTim.tMonth;
   Work   : SCAL[2];
 BEGIN
  SETZERO(PerOfPay, Work);
  SELECT(Staff, MyFirm, , L_Packet.PckMyFirm, Man.Man);
  WHILE OCCURE(Staff) DO
   IF (Staff.BegDate <= ManPerE) & GoodTSN(ManPerB, ManPerE, 0, 1) THEN
    _Period:=Math.Max(ManPerB, Staff.BegDate);
    SETSEL(StaffLog, TSN, Staff.TSN);
    SRCINSEL(StaffLog, LE, , _Period);
    _Period:=L_DatTim.Per(_Period);
    WHILE OCCURE(StaffLog) DO
     WHILE (_Period<=ManPerE) & ((_Period<=StaffLog.DateE) | ~L_Staff.ItsNotLastDischargeStaffLog()) DO
      _Month:=L_DatTim.MONTH(_Period);
      IF ~PerOfPay[_Month] THEN
       IF ~L_Staff.IsDischargeStaffLog() THEN
        Work:=1;
       END;
       IF    IsSince2013() THEN
        PerOfPay[_Month]:=HasPFObject(_Period) | ~PFSumIsZERO(GetPFSum(_Period));
       ELSIF IsSince2002() THEN
        PerOfPay[_Month]:=~PFSumIsZERO(GetPFSum(_Period));
       ELSE
        _Sum:=0;
        SELECT(Money, TSN, , Staff.TSN, _Period);
        WHILE OCCURE(Money) DO
         CONFORM(Money, MCList);
         IF Ms1[Money.MCode] # 0 THEN
          INC(_Sum, Money.Sum*Ms1[Money.MCode]);
         END;
         NEXT(Money);
        END;
        IF _Sum # 0 THEN
         PerOfPay[_Month]:=1;
        END;
       END;
       IF PerOfPay[_Month] THEN
        Work:=1;
       END;
      END;
      _Period:=L_DatTim.NextPer(_Period);
     END;
     NEXT(StaffLog);
    END; (* WHILE OCCURE(StaffLog) ... *)
   END;
   NEXT(Staff);
  END; (* WHILE OCCURE(Staff) ... *)
  RETURN Work;
 END {WorkInPer};

 PRIVATE PROCEDURE HasPnsAttr(ManPerB, ManPerE: DATE): SCAL[2];
  VAR
   D1, D2: DATE;
 BEGIN
  SELECT(Staff, MyFirm, , L_Packet.PckMyFirm, Man.Man);
  WHILE OCCURE(Staff) DO
   IF GoodTSN(ManPerB, ManPerE, 1, 0) THEN
    D1:=Math.Max(ManPerB, Staff.BegDate);
    IF !Staff.EndDate THEN
     D2:=ManPerE;
    ELSE
     D2:=Math.Min(ManPerE, Staff.EndDate);
    END;
    SELECT(StaffLog, TSN, , Staff.TSN);
    WHILE OCCURE(StaffLog) DO
     IF (L_DatTim.DATEINT(D1, D2, StaffLog.Date, StaffLog.DateE) > 0) &
         ~L_Staff.IsDischargeStaffLog() THEN
      CONFORM(StaffLog, Officer);
      IF Officer.PnsAttr # L_Packet.OrdinaryPnsAttr THEN
       RETURN 1;
      END;
     END;
     NEXT(StaffLog);
    END; (* WHILE OCCURE(StaffLog ... *)
   END; (* IF Staff.Contract ... *)
   NEXT(Staff);
  END; (* WHILE OCCURE(Staff) ... *)
  RETURN 0;
 END {HasPnsAttr};

 PRIVATE PROCEDURE Fill_SZV_X_2();
 BEGIN
  IF (SZVXx = 2) & (SZVX_2_Count#0) THEN
   WHILE (SZVX_2_Count<Max_SZVX_2_Count) DO
    IF    Packet.Kind = L_Packet.knd_PF_SZV6 THEN
     MAKEPART(R, SZV_6_2_Fill);
    ELSIF Packet.Kind = L_Packet.knd_PF_SZV4 THEN
     MAKEPART(R, SZV_4_2_Fill);
    END;
    INC(SZVX_2_Count);
   END;
   IF    Packet.Kind = L_Packet.knd_PF_SZV6 THEN
    IF CurNumInP = (TotNumInP+1) THEN
     MAKEPART(R, SZV_6_2_3, pInc[tp_PFIn], pPaid[tp_PFIn], pInc[tp_PFAc], pPaid[tp_PFAc]);
    END;
    MAKEPART(R, SZV_6_2_Add);
   ELSIF Packet.Kind = L_Packet.knd_PF_SZV4 THEN
    MAKEPART(R, SZV_4_2_Add);
   END;
   MAKEPART(R, SZV_X_X_6);
   SZVX_2_Count:=0;
   FORMFEED(R);
  END;
 END {Fill_SZV_X_2};

 PRIVATE PROCEDURE IsInvalid(P: DATE): SCAL[2];
 BEGIN
  L_General.CallUs(~IsSince2010());
  RETURN L_STx.STx_Man_IsInvalid(P, Man.Man);
 END {IsInvalid};

 PUBLIC PROCEDURE GetMSFeeTypeCategory(P: DATE; trgType: LIKE(ManSFee.Type)): tCategory;
 BEGIN
  IF    trgType = L_SFee.t_Normal THEN              RETURN cat_Main;
  ELSIF trgType = L_SFee.t_Invalid THEN             RETURN cat_Inv;
  ELSIF trgType = L_SFee.t_USNO THEN                RETURN cat_Main;
  ELSIF trgType = L_SFee.t_woCtzn_Commorancy THEN   RETURN cat_woCtzn_Commorancy;
  ELSIF trgType = L_SFee.t_woCtzn_TmpResidence THEN RETURN cat_woCtzn_TmpResidence;
  ELSE                                              RETURN EMPTYOF(tCategory);
  END;
 END {GetMSFeeTypeCategory};

 PRIVATE PROCEDURE IsCategoryInList(trgCategory: tCategory): SCAL[2];
  VAR
   curCategory: tCategory;
 BEGIN
  FOR_EACH curCategory IN CategoryList() DO
   IF curCategory = trgCategory THEN
    RETURN 1;
   END;
  END;
  RETURN 0;
 END {IsCategoryInList};

 PRIVATE PROCEDURE GetManCategory(P: DATE): tCategory;
  VAR
   dfnTypeStr: STRING[];
   dfnType   : LIKE(ManSFee.Type);
   Result    : tCategory;
 BEGIN
  IF    IsSince2010() THEN
   TRY
    dfnType:=L_SFee.DefineType(L_Packet.PckMyFirm, Man.Man, P);
   EXCEPT
   ON Exc:Exc_Raise DO (*0091495 25.04.2012 16:02:36 AK1786\Bor.Polak*)
    SETEMPTY(dfnType);
   END;
   IF SELECT(ManSFee, MyFirm, L_Packet.PckMyFirm, Man.Man, 1, P) THEN
    IF ManSFee.Type # dfnType THEN
     IF !dfnType THEN
      dfnTypeStr:='।'
     ELSE
      dfnTypeStr:=L_Str.PoolItem(L_SFee.t_Pool, dfnType);
     END;
     InsPrb01("    ᫮.  '"+L_Str.PoolItem(L_SFee.t_Pool, ManSFee.Type)+"', ⠫ '"+dfnTypeStr+"'. ॡ    "+L_DatTim.PeriodStr(P), 1)
    END;
   END;

   Result:=GetMSFeeTypeCategory(P, dfnType);
  ELSIF IsSince2002() THEN
   Result:=cat_Main;
  ELSIF IsSince2001() THEN
   IF IsInvalid(P) THEN Result:=cat_Inv;
   ELSE                 Result:=cat_Main;
   END;
  ELSE
   IF IsInvalid(P) THEN
    IF P_Man.HasActualManPro(Man.Man, ManPerE, P_Man.P_Pension) &
       (L_Prop.GetProValueAsScal(P_Man.GetManProPool(P_Man.P_Pension), ManPro.Value) = 0(* *)) THEN
     Result:=cat_Inv1;
    ELSE
     Result:=cat_Inv;
    END;
   ELSE
    Result:=cat_Main;
   END;
  END;
  L_General.CallUs(!Result | IsCategoryInList(Result));
  RETURN Result;
 END {GetManCategory};

 PRIVATE PROCEDURE GetManCntrType(P: DATE): L_Packet.tCntrType;
  VAR
   Result: L_Packet.tCntrType;
 BEGIN
  TRY [RESTORE_CURSORS(RC_ON)]
   SETEMPTY(Result);
   IF P >= 01\01\2013 THEN
    SETSEL(CnTpP, Man, Man.Man);
    IF SRCINSEL(CnTpP, LE, P) |
       SRCINSEL(CnTpP, GT, P) THEN
     CHANGESEL(CnTpP, Man, , CnTpP.Man, CnTpP.P);
     L_General.CallUs(SRCINSEL(CnTpP, EQ, L_Packet.cntrt_Basic) | (* ਮ⭥ ࠦ᪮-ࠢ*)
                      SRCINSEL(CnTpP, EQ, L_Packet.cntrt_CA));
     Result:=CnTpP.CntrType;
    END;
   END; (* IF P >= 01\01\2013 ... *)
   IF !Result THEN
    IF L_Staff.IsStandOnMainContract(Man.Man, L_Packet.PckMyFirm, P-1) THEN
     Result:=GetStaffCntrType(P-1);
    ELSE
     Result:=L_Packet.cntrt_Basic;
    END;
   END;
  EXCEPT
  END; (* TRY *)
  RETURN Result;
 END {GetManCntrType};

 PRIVATE PROCEDURE CategoryList(): tCategoryList;
  VAR
   Result: tCategoryList;
 BEGIN
  SETEMPTY(Result);
  IF    IsSince2012() THEN
   Result[0]:=cat_Main;
   Result[1]:=cat_Inv;
   Result[2]:=cat_woCtzn_Commorancy;
   Result[3]:=cat_woCtzn_TmpResidence;
  ELSIF IsSince2010() THEN
   Result[0]:=cat_Main;
   Result[1]:=cat_Inv;
  ELSIF IsSince2002() THEN
   Result[0]:=cat_Main;
  ELSIF IsSince2001() THEN
   Result[0]:=cat_Main;
   Result[1]:=cat_Inv;
  ELSE
   Result[0]:=cat_Main;
   Result[1]:=cat_Inv;
   Result[2]:=cat_Inv1;
  END;
  RETURN Result;
 END {CategoryList};

 PRIVATE PROCEDURE IsInsuredInPF_OnDate(D: DATE): SCAL[2];
 BEGIN
  IF D >= L_SFee.TheStartingPoint THEN
   RETURN L_Staff.IsStandOnMainContract(Man.Man, L_Packet.PckMyFirm, D) &
          L_SFee.ManIsInsuredInPF(Man.Man, D);
  ELSE
   RETURN (L_STx.Get_woTaxManKind(D, Man.Man) # L_STx.wotmk_Foreigner);
  END;
 END {IsInsuredInPF_OnDate};

 PRIVATE PROCEDURE IsInsuredInPF_InPer(ManPerB, ManPerE: DATE): SCAL[2];
  VAR
   P: DATE;
 BEGIN
  P:=ManPerB;
  WHILE P <= ManPerE DO
   IF IsInsuredInPF_OnDate(L_DatTim.MonthEnd(P)) THEN
    RETURN 1;
   END;
   P:=L_DatTim.NextPer(P);
  END;
  RETURN 0;
 END {IsInsuredInPF_InPer};

 PRIVATE PROCEDURE ManHasCategoryAndCntrType(trgCategory: tCategory;
                                             trgCntrType: L_Packet.tCntrType;
                                             ManPerB,
                                             ManPerE: DATE): SCAL[2];
  VAR
   P: DATE;
 BEGIN
  P:=L_DatTim.Per(ManPerB);
  WHILE (P <= ManPerE) DO
   IF (trgCategory = GetManCategory(P)) & SEARCH(CnTpP, CnTpP, Man.Man, trgCntrType, P) THEN
    RETURN 1;
   END;
   P:=L_DatTim.NextPer(P);
  END;
  IF IsSince2010() THEN
   RETURN SELECT(TmpIP, Man, Man.Man, trgCategory, trgCntrType);
  END;
  RETURN 0;
 END {ManHasCategoryAndCntrType};

 PRIVATE PROCEDURE GetPacketGroupForMan(trgCategory: tCategory;
                                        trgCntrType: L_Packet.tCntrType;
                                        ManPerB,
                                        ManPerE: DATE;
                                        PerOfPay: SCAL[2][]): L_Packet.tPacketGroup;
  VAR
   P          : DATE;
   M          : L_DatTim.tMonth;
   PerToExcl  : SCAL[2][12];
   StageNum   : NUMERIC[0];
   i          : NUMERIC[0];
   HasMoney   : SCAL[2];
   curCategory: tCategory;
 BEGIN
  IF IsSince2001() THEN
   SETZERO(PerToExcl, HasMoney, i);
   P:=PerBMoney(ManPerB);
   WHILE P <= PerEMoney(ManPerE) DO
    M:=L_DatTim.MONTH(P);
    curCategory:=GetManCategory(P);
    IF ~!trgCategory & (trgCategory # curCategory) THEN
     PerToExcl[M]:=1;
    ELSIF ~HasMoney THEN
     HasMoney:=PerOfPay[M];
    END;
    P:=L_DatTim.NextPer(P);
   END; (* WHILE Period ... *)
   StageNum:=GetSpecStage(trgCategory, trgCntrType, ManPerB, ManPerE, PerToExcl);

   IF SELECT(_MIns, _MIns, mi_Stage, Man.Man, trgCategory, trgCntrType) THEN
    WHILE OCCURE(_MIns) DO
     IF L_Packet.IsPAttMInsType(_MIns.Type) THEN
      RETURN pg_HPA;
     END;
     IF IsSince2002() & L_Packet.IsAddMInsType(_MIns.Type) THEN
      RETURN pg_MStg;
     END;
     INC(i);
     NEXT(_MIns);
    END; (* WHILE OCCURE(_MIns) ... *)
   END;
   IF IsSince2002() & (i > 1) THEN
    RETURN pg_MStg;
   ELSIF (i >= 1) | HasMoney THEN
    RETURN pg_Main;
   ELSE
    IF IsSince2010() &
       SEARCH(TmpIP, Man, Man.Man, trgCategory, trgCntrType) &
       (~PFSumIsZERO(TmpIP.CurInc) | ~PFSumIsZERO(TmpIP.CurPaid)) THEN
     RETURN pg_Main;
    END;
    RETURN EMPTYOF(L_Packet.tPacketGroup);
   END;
  ELSE
   IF HasPnsAttr(ManPerB, ManPerE) THEN
    RETURN pg_HPA;
   ELSE
    RETURN pg_Main;
   END;
  END; (* IF IsSince2001() ... *)
 END {GetPacketGroupForMan};

 PRIVATE PROCEDURE GetCategoryNick(trgCategory: tCategory): STRING[];
  VAR
   TaxationMode: P_MyFirm.tTaxationMode;
 BEGIN
  IF    trgCategory = cat_Main THEN
   IF    IsSince2011() THEN
    IF L_SFee.IsUSNOLowSFee(L_Packet.PckMyFirm, PerB) THEN
     RETURN "";
    END;
   ELSIF IsSince2010() THEN
    IF P_MyFirm.GetTaxationMode(L_Packet.PckMyFirm, PerB) # P_MyFirm.tm_Common THEN
     RETURN "";
    END;
   END;
   RETURN "";
  ELSIF trgCategory = cat_Inv  THEN
   IF    IsSince2011() THEN RETURN "";
   ELSIF IsSince2010() THEN RETURN "";
   ELSE                     RETURN "";
   END;
  ELSIF trgCategory = cat_Inv1 THEN
   L_General.CallUs(~IsSince2001()); RETURN "";
  ELSE
   L_General.CallUs(IsSince2012());
   IF    trgCategory = cat_woCtzn_Commorancy   THEN RETURN "";
   ELSIF trgCategory = cat_woCtzn_TmpResidence THEN RETURN "";
   ELSIF !trgCategory THEN
    L_General.CallUs(IsSince2014());
    RETURN "";
   ELSE
    L_General.CallUs(0);
   END;
  END;
 END {GetCategoryNick};

 PRIVATE PROCEDURE GetCategoryName(trgCategory: tCategory): STRING[];
 BEGIN
  L_General.CallUs(~IsSince2010());
  IF    trgCategory = cat_Main THEN  RETURN "/";
  ELSIF trgCategory = cat_Inv  THEN  RETURN " (0+0)";
  ELSIF trgCategory = cat_Inv1 THEN
   L_General.CallUs(~IsSince2001()); RETURN " (28+0)";
  ELSE
   L_General.CallUs(0);
  END;
 END {GetCategoryName};

 PRIVATE PROCEDURE PacketGroupType(trgGroup: L_Packet.tPacketGroup; trgCategory: tCategory): STRING[];
  VAR
   N: STRING[];
 BEGIN
  IF IsSince2002() THEN
   IF IsSince2010() THEN  N:="6-";
   ELSE                   N:="4-";
   END;
   IF (trgGroup = pg_Main) THEN  RETURN N+"2";
   ELSE                          RETURN N+"1";
   END;
  ELSIF (trgGroup = pg_HPA) | (trgCategory = cat_Inv) | (trgCategory = cat_Inv1) THEN
   RETURN "";
  END;
  RETURN "";
 END {PacketGroupType};

 PRIVATE PROCEDURE GetXCalcCrd(trgAcCut: LIKE(AcCut.AcCut); P: DATE): L_PRoll.tSum;
 BEGIN
  IF SEARCH(XCalc, XObject, L_STx.GetManXObject(Man.Man, L_Packet.PckMyFirm), _AcCut, P) THEN
   RETURN XCalc.CrdSum;
  ELSE
   RETURN 0;
  END;
 END {GetXCalcCrd};

 PRIVATE PROCEDURE HasPFObject(P: DATE): SCAL[2];
 BEGIN
  L_General.CallUs(P >= L_SFee.TheStartingPoint);
  IF SELECT(ManSFee, MyFirm, L_Packet.PckMyFirm, Man.Man, 1, P) THEN
   RETURN (ManSFee.Object # 0) &
          (ManSFee.Type # L_SFee.t_woCtzn);
  ELSE
   RETURN 0;
  END;
 END {HasPFObject};

 PRIVATE PROCEDURE GetPFSum(P: DATE): tPFSum;
  VAR
   Result: tPFSum;
 BEGIN
  IF P >= L_SFee.TheStartingPoint THEN
   IF SELECT(ManSFee, MyFirm, L_Packet.PckMyFirm, Man.Man, 1, P) THEN
    Result[tp_PFIn]:=ManSFee.Fee[L_SFee.p_PFIn];
    Result[tp_PFAc]:=ManSFee.Fee[L_SFee.p_PFAc];
   ELSE
    SETZERO(Result);
   END;
  ELSE
   Result[tp_PFIn]:=GetXCalcCrd(L_STx.STx_GetTaxAcCut(L_STx.stxp_PFIn), P);
   Result[tp_PFAc]:=GetXCalcCrd(L_STx.STx_GetTaxAcCut(L_STx.stxp_PFAc), P);
  END;
  RETURN Result;
 END {GetPFSum};

 PRIVATE PROCEDURE intGetPFSumForPer(trgCategory: tCategory;
                                     trgCntrType: L_Packet.tCntrType;
                                     trgManPerB,
                                     trgManPerE: DATE): tPFSum;
  VAR
   P     : DATE;
   Result: tPFSum;
 BEGIN
  SETZERO(Result);
  P:=trgManPerB;
  WHILE P <= trgManPerE DO
   IF (!trgCategory | (GetManCategory(P) = trgCategory)) &
      (!trgCntrType | (GetManCntrType(P) = trgCntrType)) THEN
    PFSumINC(Result, GetPFSum(P));
   END;
   P:=L_DatTim.NextPer(P);
  END;
  RETURN Result;
 END {intGetPFSumForPer};

 PRIVATE PROCEDURE GetPFSumForPer(trgManPerB, trgManPerE: DATE): tPFSum;
 BEGIN
  RETURN intGetPFSumForPer(EMPTYOF(tCategory), EMPTYOF(L_Packet.tCntrType), trgManPerB, trgManPerE);
 END {GetPFSumForPer};

 PRIVATE PROCEDURE xIsWorking(P: DATE): SCAL[2];
 BEGIN
  RETURN L_Staff.InStateInPer(L_DatTim.MonthBeg(P), L_DatTim.MonthEnd(P));
 END {xIsWorking};

 PRIVATE PROCEDURE NumOfSZV4(trgCategory: tCategory; trgCntrType: L_Packet.tCntrType): SCAL[3];
 BEGIN
  IF ~SELECT(_MIns, _MIns, mi_Stage, Man.Man, trgCategory, trgCntrType) |
     (L_Packet.IsOrdinaryType(_MIns.Type) & ~NEXT(_MIns)) THEN
   RETURN 2;
  ELSE
   RETURN 1;
  END;
 END {NumOfSZV4};

 PRIVATE PROCEDURE trn_intPutPer(nParent: L_XML.tNode; NodeName: STRING[]; trgYear: SCAL[1e4]; trgQuarter: SCAL[10]);
  VAR
   nPer: L_XML.tNode;
 BEGIN
  nPer:=L_Packet.trn_PutNode(nParent, NodeName);
  L_Packet.trn_PutInt(nPer, "⠫", trgQuarter);
  L_Packet.trn_PutInt(nPer, "", trgYear);
(*
  L_Packet.trn_PutString(nPer, "", ""); (*???*)
*)
 END {trn_intPutPer};

 PRIVATE PROCEDURE trn_PutPer(nParent: L_XML.tNode; NodeName: STRING[]);
 BEGIN
  trn_intPutPer(nParent, NodeName, Year, Quarter);
 END {trn_PutPer};

 PRIVATE PROCEDURE trn_PutTariff(nParent: L_XML.tNode; NodeName: STRING[]; trgCategory: tCategory);
  VAR
   nTrff: L_XML.tNode;
 BEGIN
  nTrff:=L_Packet.trn_PutNode(nParent, NodeName);
  L_Packet.trn_PutString(nTrff, "⥣ਨ", GetCategoryNick(trgCategory));
(*
  L_Packet.trn_PutString(nTrff, "⥫쭮", "");
*)
  L_Packet.trn_PutString(nTrff, "⥣ਨ", GetCategoryName(trgCategory));
(*
  L_Packet.trn_PutString(nTrff, "⥫쭮", "");
*)
 END {trn_PutTariff};

 PRIVATE PROCEDURE trn_PutYMonth(nParent: L_XML.tNode; trgMonth: L_DatTim.tMonth);
 BEGIN
  IF ~!trgMonth THEN
   L_Packet.trn_PutString(nParent, "ப", "");
   L_Packet.trn_PutInt(nParent, "", trgMonth+1);
  ELSE
   L_Packet.trn_PutString(nParent, "ப", "");
  END;
 END {trn_PutYMonth};

 PRIVATE PROCEDURE trn_PutQMonth(nParent: L_XML.tNode; QMonth: tQMonth);
 BEGIN
  IF ~!QMonth & (QMonth # TotQBMS) THEN
   L_Packet.trn_PutString(nParent, "ப", "");
   L_Packet.trn_PutInt(nParent, "", L_DatTim.MONTH(PerB)+QMonth+1);
  ELSE
   L_Packet.trn_PutString(nParent, "ப", "");
  END;
 END {trn_PutQMonth};

 PRIVATE PROCEDURE trn_PutIncStr(nParent: L_XML.tNode; NodeName: STRING[]; trgMonth: L_DatTim.tMonth; TotInc, SickInc: L_PRoll.tSum);
  VAR
   nIncStr: L_XML.tNode;
 BEGIN
  nIncStr:=L_Packet.trn_PutNode(nParent, NodeName);
  trn_PutYMonth(nIncStr, trgMonth);
  L_Packet.trn_PutMoney(nIncStr, "᫥ᥣ", TotInc);
  L_Packet.trn_PutMoney(nIncStr, "᫥쭨", SickInc);
 END {trn_PutIncStr};

 PRIVATE PROCEDURE trn_PutIncIM(nParent: L_XML.tNode; trgObject, trgBase, trgOvrPrt: tQuartalByMonthSum);
  VAR
   QMonth: tQMonth;
   nInc  : L_XML.tNode;
 BEGIN
  FOR_EACH QMonth DO
   nInc:=L_Packet.trn_PutNode(nParent, "㬬믫∢ࠦ㇋");
   trn_PutQMonth(nInc, QMonth);
   L_Packet.trn_PutMoney(nInc, "㬬믫ᥣ", trgObject[QMonth]);
   L_Packet.trn_PutMoney(nInc, "㬬믫⍠᫥客륂덥ॢ騥", trgBase[QMonth]);
   L_Packet.trn_PutMoney(nInc, "㬬믫⍠᫥客륂ॢ騥",   trgOvrPrt[QMonth]);
  END;
 END {trn_PutIncIM};

 PRIVATE PROCEDURE trn_PutInsPrem(nParent: L_XML.tNode; NodeName: STRING[]; Insurance, Accumulat, Extra: L_PRoll.tSum);
  VAR
   tInsPrem: L_XML.tNode;
 BEGIN
  tInsPrem:=L_Packet.trn_PutNode(nParent, NodeName);
  L_Packet.trn_PutMoney(tInsPrem, "客", Insurance);
  L_Packet.trn_PutMoney(tInsPrem, "⥫", Accumulat);
  L_Packet.trn_PutMoney(tInsPrem, "⥫", Extra);
 END {trn_PutInsPrem};

 PRIVATE PROCEDURE trn_PutInsIncPaid(nParent: L_XML.tNode; NodeName: STRING[]; Income, Paid: L_PRoll.tSum);
  VAR
   tInsPrem: L_XML.tNode;
 BEGIN
  IF (Income # 0) | (Paid # 0) THEN
   tInsPrem:=L_Packet.trn_PutNode(nParent, NodeName);
   L_Packet.trn_PutMoney(tInsPrem, "᫥", Income);
   L_Packet.trn_PutMoney(tInsPrem, "祭",  Paid);
  END;
 END {trn_PutInsIncPaid};

 PRIVATE PROCEDURE trn_PutInsIncPaidInt(nParent: L_XML.tNode; NodeName: STRING[]; Income, Paid: L_PRoll.tSum);
  VAR
   tInsPrem: L_XML.tNode;
 BEGIN
  tInsPrem:=L_Packet.trn_PutNode(nParent, NodeName);
  L_Packet.trn_PutInt(tInsPrem, "᫥", Income);
  L_Packet.trn_PutInt(tInsPrem, "祭",  Paid);
 END {trn_PutInsIncPaidInt};

 PRIVATE PROCEDURE trn_PutPayStr(nParent: L_XML.tNode;
                                 NodeName: STRING[];
                                 trgMonth: L_DatTim.tMonth;
                                 Pay, SickPay: L_PRoll.tSum;
                                 Quantity: NUMERIC[0];
                                 TrfSign   : STRING[1];
                                 ChargedDue, TransferDue: L_PRoll.tSum);
  VAR
   nPayStr: L_XML.tNode;
 BEGIN
  IF (Pay # 0) | (SickPay # 0) | (Quantity # 0) THEN
   nPayStr:=L_Packet.trn_PutNode(nParent, NodeName);
   trn_PutYMonth(nPayStr, trgMonth);
   L_Packet.trn_PutMoney(nPayStr, "⥣ਨࠡ⮪", Pay);
   L_Packet.trn_PutMoney(nPayStr, "⥣ਨ쭨", SickPay);

   L_Packet.trn_PutInt(nPayStr, "।᫥쐠⭨", Quantity);
   L_Packet.trn_PutString(nPayStr, "ਧ", TrfSign);
   L_Packet.trn_PutMoney(nPayStr, "᫥ᮢ", ChargedDue);
   L_Packet.trn_PutMoney(nPayStr, "᫥ᮢ", TransferDue);
  END;
 END {trn_PutPayStr};

 PRIVATE PROCEDURE trn_PutMInsFeatures(nParent: L_XML.tNode; NodeName: STRING[]);
  VAR
   nFeatures,
   nSpCond,
   nStand,
   nLongServ: L_XML.tNode;
 BEGIN
  nFeatures:=L_Packet.trn_PutNode(nParent, NodeName);
  L_Packet.trn_PutTerrCond(nFeatures, "ਠ륓᫮", "", 0);

  nSpCond:=L_Packet.trn_PutNode(nFeatures, "ᮡ륓᫮㤠");
  L_Packet.trn_PutString(nSpCond, "᭮", Str.Item(_MIns.Type, ";", 0));
  L_Packet.trn_PutString(nSpCond, "᪠", Str.Item(_MIns.Type, ";", 1));

  nStand:=L_Packet.trn_PutNode(nFeatures, "塞멑⠦");
  L_Packet.trn_PutString(nStand, "᭮", "");
  L_Packet.trn_PutEarnHours(nStand, "ࠡ⪠", 0, 0);
  L_Packet.trn_PutEarnDays(nStand, "ࠡ⪠ୠ", 0, 0, 0);

  L_Packet.trn_PutString(nFeatures, "℥", Str.Item(_MIns.Type, ";", 2));

  nLongServ:=L_Packet.trn_PutNode(nFeatures, "㣠");
  L_Packet.trn_PutString(nLongServ, "᭮", "");
  L_Packet.trn_PutEarnHours(nLongServ, "ࠡ⪠", 0, 0);
  L_Packet.trn_PutEarnDays(nLongServ, "ࠡ⪠ୠ", 0, 0, 0);
(*   2010   ப 㣠
  L_Packet.trn_PutString(nLongServ, "᫥", ""); (*Int*)
*)
  L_Packet.trn_PutNumeric(nLongServ, "⠢", 0, 2);

(*20.12.2007 POLAK\Gina: CkeckXML ⠥    ࠢ묨, 訡 "襭  .  譨 "
  L_Packet.trn_PutString(nFeatures, "", _MIns.PostName);
  L_Packet.trn_PutString(nFeatures, "⬥⪠業騪", ""); (*|  *)
*)
 END {trn_PutMInsFeatures};

 PRIVATE PROCEDURE CorBasCA(trgSum, corSum: L_PRoll.tSum): L_PRoll.tSum;
 BEGIN
  IF trgSum # 0 THEN
   RETURN trgSum-corSum;
  ELSE
   RETURN trgSum;
  END;
 END {CorBasCA};

 PRIVATE PROCEDURE CorCABas(trgSum, corSum: L_PRoll.tSum): L_PRoll.tSum;
 BEGIN
  IF trgSum # 0 THEN
   RETURN corSum;
  ELSE
   RETURN 0;
  END;
 END {CorCABas};

 PRIVATE PROCEDURE PrepareOneMan(ManPerB, ManPerE: DATE);
  VAR
   MoneyStrNum : NUMERIC[0];
   MonthToIncl : SCAL[2][12];
   NeedMonth   : SCAL[2];
   P           : DATE;
   _Month      : L_DatTim.tMonth;
   QMonth      : tQMonth;
   PnsBase,
   OverPrt     : L_PRoll.tSum;
   Pns2,
   Sum1, Sum2  : L_PRoll.tSum[MaxPerAmo];
   ContrNum    : tContrNum;
   ContrDat    : LIKE(StaffLog.Date);
   _MCode      : LIKE(MCList.MCode);
   Prc1, Prc2  : NUMERIC[5];
   _Bas,
   _Pns1, _Pns2: L_PRoll.tSum;
   PerToExcl   : SCAL[2][12];
   StageNum    : NUMERIC[0];
   manPns1,  manPns2,
   manSum1,  manSum2: L_PRoll.tSum;
   ManIsLeave  : SCAL[2];
   tmpPFSum    : tPFSum;
   corSum      : LIKE(ManSFee.Object);
 BEGIN
  DEFAULT(Prt01);
  Prt01.Man     :=Man.Man;
  Prt01.Name    :=L_Packet.GetManInPFRFName(SYSDATE());
  Prt01.Packet  :=Packet.Packet;
  Prt01.NumInP  :=CurNumInP;
  Prt01.Category:=Intrm.Category;
  Prt01.Group   :=Intrm.Group;

  SETZERO(Sum1, Sum2, Pns2,
          manSum1, manSum2, manPns1, manPns2,
          MoneyStrNum, MonthToIncl,
          PerToExcl, StageNum);
  SETEMPTY(ContrNum, ContrDat);

  ManIsLeave:=1;
  SELECT(Staff, MyFirm, , L_Packet.PckMyFirm, Man.Man);
  WHILE OCCURE(Staff) DO
   IF GoodTSN(ManPerB, ManPerE, 1, 0) THEN
    ManIsLeave:=ManIsLeave & ~!Staff.EndDate;
    IF Staff.Contract = L_Staff.cnt_ContractorsAgreement THEN
     SELECT(StaffLog, TSN, , Staff.TSN);
     IF ~!ContrNum THEN
      ContrNum:=ContrNum+",";
     END;
     ContrNum:=ContrNum+StaffLog.Order;
     ContrDat:=Math.Min(ContrDat, StaffLog.Date);
    END;
   END;
   NEXT(Staff);
  END; (* WHILE OCCURE(Staff)... *)

  IF Packet.CorrType # L_Packet.ct_Cancel THEN
   P:=PerBMoney(ManPerB);
   WHILE P <= PerEMoney(ManPerE) DO
    _Month:=L_DatTim.MONTH(P);
    PROMPT(": "+GetManStrId(Man.Man)+" "+_Month);
    IF (Intrm.Category = GetManCategory(P)) &
       (Intrm.CntrType = GetManCntrType(P)) THEN
     IF IsSince2002() THEN
      tmpPFSum:=GetPFSum(P);
      IF Packet.Kind = L_Packet.knd_PF_SZV6_4 THEN
       QMonth:=_Month-L_DatTim.MONTH(PerB);
       IF SELECT(ManSFee, MyFirm, L_Packet.PckMyFirm, Man.Man, 1, P) THEN
        corSum:=0;
        IF Intrm.CntrType = L_Packet.cntrt_Basic THEN
         corSum:=SEARCH(CnTpP, CnTpP, Man.Man, L_Packet.cntrt_CA, P)*0.01;
         tmpPFSum[tp_PFIn]:=CorBasCA(tmpPFSum[tp_PFIn], corSum); (* ᮢ ⮦ ४뢠   *)
        END;
        SetQBMS(Prt01.Object,  QMonth, CorBasCA(ManSFee.Object, corSum));
        SetQBMS(pObject,       QMonth, CorBasCA(ManSFee.Object, corSum));
        SetQBMS(Prt01.Base,    QMonth, CorBasCA(L_SFee.GetCurrentSinglePartBase(L_SFee.p_PFIn), corSum));
        SetQBMS(pBase,         QMonth, CorBasCA(L_SFee.GetCurrentSinglePartBase(L_SFee.p_PFIn), corSum));
        IF  (ManSFee.Type = L_SFee.t_Normal) |
            (ManSFee.Type = L_SFee.t_woCtzn) |
            (ManSFee.Type = L_SFee.t_woCtzn_Commorancy) |
            (ManSFee.Type = L_SFee.t_woCtzn_TmpResidence) THEN
         IF (L_SFee.GetCurrentSinglePartBase(L_SFee.p_PFIn) = 0) & (corSum # 0) THEN
          OverPrt:=CorBasCA(ManSFee.OvrPrt[L_SFee.b_PFR], corSum); (*᫨   - ७ᨬ   㬬 ॢ襭 0102566 28.02.2014 17:41:45 SPATP\Bor.Polak*)
         ELSE
          OverPrt:=ManSFee.OvrPrt[L_SFee.b_PFR];
         END;
        ELSIF (ManSFee.Type = L_SFee.t_Invalid) | (ManSFee.Type = L_SFee.t_USNO) | (ManSFee.Type = L_SFee.t_ENVD) THEN
         OverPrt:=0;
        ELSE
         L_General.CallUs(0);
        END;
        SetQBMS(Prt01.OvrPrt,  QMonth, OverPrt);
        SetQBMS(pOvrPrt,       QMonth, OverPrt);
        SetQBMS(Prt01.BasPFA1, QMonth, L_SFee.GetCurrentSinglePartBase(L_SFee.p_PFA1));
        SetQBMS(Prt01.BasPFA2, QMonth, L_SFee.GetCurrentSinglePartBase(L_SFee.p_PFA2));
       END;
      END;
      _Pns1:=tmpPFSum[tp_PFAc];
      _Pns2:=tmpPFSum[tp_PFIn];
      INC(manPns1, _Pns1);
      INC(manPns2, _Pns2);
     ELSE
      NeedMonth:=0;
      SELECT(Staff, MyFirm, , L_Packet.PckMyFirm, Man.Man);
      WHILE OCCURE(Staff) DO
       IF GoodTSN(P, EMPTYOF(DATE), 0, 1) THEN
        NeedMonth:=1;
        GetMoney(P, Sum1[_Month], Sum2[_Month]);
        IF (Sum1[_Month] # 0) | (Sum2[_Month] # 0) | xIsWorking(P) THEN
         MonthToIncl[_Month]:=1;
        END;
       END;
       NEXT(Staff);
      END; (* WHILE OCCURE(Staff)... *)
      INC(manSum1, Sum1[_Month]);
      INC(manSum2, Sum2[_Month]);
      _Pns1:=0;
      _Pns2:=0;
      IF MonthToIncl[_Month] THEN
       INC(MoneyStrNum);
      END;
      IF    Packet.Kind = L_Packet.knd_PF_SZV3 THEN
       IF NeedMonth THEN
        _Bas :=GetXCalcCrd(L_STx.STx_GetTotAcCut(), P)+
               GetXCalcCrd(L_STx.STx_GetExlAcCut(), P);
        _Pns2:=GetXCalcCrd(L_STx.STx_GetTaxAcCut(L_STx.stxp_PFRF), P);
       ELSE
        SETZERO(_Bas, _Pns2);
       END;
       IF _Bas > 0 THEN
        ADD(ADV10, ADV10, , Packet.ExtNbr, _Month, Intrm.Group, Intrm.Category, IsCorrPacket(),
            ADV10.Quantity, 1);
       END;
       INC(Prt01.manBase, _Bas);
       INC(manPns2, _Pns2);
      ELSIF Packet.Kind = L_Packet.knd_PF_SZV1 THEN
       PnsBase:=Sum1[_Month]-Sum2[_Month];
       IF PnsBase # 0 THEN
        E_PRoll.GetPnsPrc(P, 0, Prc1, _MCode);
        E_PRoll.GetPnsPrc(P, 1, Prc2, _MCode);
        _Pns1:=PnsBase * Prc1;
        _Pns2:=PnsBase * Prc2;
        INC(manPns1, _Pns1);
        INC(manPns2, _Pns2);
       END;
      ELSE
       L_General.CallUs(0);
      END;
     END;
     Pns2[_Month]:=_Pns2;
     ADD(ADV10, ADV10, , Packet.ExtNbr, _Month, Intrm.Group, Intrm.Category, IsCorrPacket(),
         ADV10._Sum1, Sum1[_Month],
         ADV10._Sum2, Sum2[_Month],
         ADV10._Pns1,        _Pns1,
         ADV10._Pns2,        _Pns2);
    ELSE
     PerToExcl[_Month]:=1;
     IF Packet.Kind = L_Packet.knd_PF_SZV6_4 THEN
      IF ((Intrm.Category = GetManCategory(P)) &
          (Intrm.CntrType # GetManCntrType(P))) THEN
       IF SELECT(ManSFee, MyFirm, L_Packet.PckMyFirm, Man.Man, 1, P) THEN
        QMonth:=_Month-L_DatTim.MONTH(PerB);
        IF Intrm.CntrType = L_Packet.cntrt_CA THEN
         corSum:=(SEARCH(CnTpP, CnTpP, Man.Man, L_Packet.cntrt_CA, P) & SEARCH(CnTpP, CnTpP, Man.Man, L_Packet.cntrt_Basic, P))*0.01;
         IF corSum # 0 THEN
          SetQBMS(Prt01.Object,  QMonth, CorCABas(ManSFee.Object, corSum));
          SetQBMS(pObject,       QMonth, CorCABas(ManSFee.Object, corSum));
          SetQBMS(Prt01.Base,    QMonth, CorCABas(L_SFee.GetCurrentSinglePartBase(L_SFee.p_PFIn), corSum));
          SetQBMS(pBase,         QMonth, CorCABas(L_SFee.GetCurrentSinglePartBase(L_SFee.p_PFIn), corSum));

          IF (L_SFee.GetCurrentSinglePartBase(L_SFee.p_PFIn) = 0) THEN
           OverPrt:=CorCABas(ManSFee.OvrPrt[L_SFee.b_PFR], corSum); (*᫨   - ७ᨬ   㬬 ॢ襭 0102566 28.02.2014 17:41:45 SPATP\Bor.Polak*)
          ELSE
           OverPrt:=0;
          END;
          SetQBMS(Prt01.OvrPrt,  QMonth, OverPrt);
          SetQBMS(pOvrPrt,       QMonth, OverPrt);

          tmpPFSum:=GetPFSum(P);
          tmpPFSum[tp_PFIn]:=CorCABas(tmpPFSum[tp_PFIn], corSum); (* ᮢ ⮦ ४뢠   *)
          _Pns2:=tmpPFSum[tp_PFIn];
          _Pns1:=0;
          INC(manPns2, _Pns2);
          ADD(ADV10, ADV10, , Packet.ExtNbr, _Month, Intrm.Group, Intrm.Category, IsCorrPacket(),
              ADV10._Pns1,        _Pns1,
              ADV10._Pns2,        _Pns2);
         END;
        END;
       END;
      END;
     END;
    END; (* ,   ... *)
    P:=L_DatTim.NextPer(P);
   END; (* WHILE Period ... *)
  
   INC(pSum, manSum1-manSum2);
   INC(pPns, manPns1+manPns2);
   INC(pSum1, manSum1);
   INC(pSum2, manSum2);
   INC(pInc[tp_PFAc], manPns1);
   INC(pInc[tp_PFIn], manPns2);
   IF IsSince2010() THEN
    INC(pPaid[tp_PFIn], GetCurPaidFromInc(manPns2, tp_PFIn, Intrm.Category, Intrm.CntrType));
    INC(pPaid[tp_PFAc], GetCurPaidFromInc(manPns1, tp_PFAc, Intrm.Category, Intrm.CntrType));
   END;
 
   StageNum:=GetSpecStage(Intrm.Category, Intrm.CntrType, ManPerB, ManPerE, PerToExcl);
  END; (* IF Packet.CorrType # L_Packet.ct_Cancel ... *)
  IF IsSince2010() THEN
   IF IsCorrPacket() THEN
    IF SEARCH(TmpIP, Man, Man.Man, Intrm.Category, Intrm.CntrType) THEN
     PFSumINC(past_pInc,  TmpIP.OldInc);
     PFSumINC(past_pPaid, TmpIP.OldPaid);
     IF Packet.Kind # L_Packet.knd_PF_SPV1 THEN
       ADD(_MCor, Man, , Man.Man, Year, Quarter,
                         _MCor.AddPFIn, TmpIP.CurInc[tp_PFIn] - TmpIP.OldInc[tp_PFIn],
                         _MCor.AddPFAc, TmpIP.CurInc[tp_PFAc] - TmpIP.OldInc[tp_PFAc]);
     END;
    END;
   END;
  END;

  IF    (Packet.Kind = L_Packet.knd_PF_SZV6_4) |
        (Packet.Kind = L_Packet.knd_PF_SPV1) THEN
   SZVXx:=1;
  ELSIF (Packet.Kind = L_Packet.knd_PF_SZV6) |
        (Packet.Kind = L_Packet.knd_PF_SZV4) THEN
   IF SZVXx=0 THEN
    SZVXx:=NumOfSZV4(Intrm.Category, Intrm.CntrType);
   ELSE
    L_General.CallUs(SZVXx = NumOfSZV4(Intrm.Category, Intrm.CntrType));
   END;
  END;

  IF MoneyStrNum # 0 THEN
   INC(MoneyStrNum); (* + ப ""*)
  END;

  Prt01.ContrNum:=ContrNum;
  Prt01.ContrDat:=ContrDat;
  Prt01.IsLeave :=ManIsLeave;
  Prt01.ManPerB :=ManPerB;
  Prt01.ManPerE :=ManPerE;
  Prt01.manSum1 :=manSum1;
  Prt01.manSum2 :=manSum2;
  Prt01.manPns1 :=manPns1;
  Prt01.manPns2 :=manPns2;
  Prt01.Sum1    :=Sum1;
  Prt01.Sum2    :=Sum2;
  Prt01.Pns2    :=Pns2;
  Prt01.StageNum:=StageNum;
  Prt01.MonthToIncl:=MonthToIncl;
  Prt01.MoneyStrNum:=MoneyStrNum;
  Prt01.Months  :=Months;
  Prt01.Days    :=Days;
  INSERT(Prt01);
 END {PrepareOneMan};

 PRIVATE PROCEDURE MakeOneMan(nPack: L_XML.tNode);
  VAR
   D1, D2,
   _Period   : DATE;
   curMonth  : L_DatTim.tMonth;
   QMonth    : tQMonth;
   i         : NUMERIC[0];
   Dummy     : STRING[250];
   Address   : STRING[];
   Addr2     : STRING[][3];
   nDoc,
   nHeadOld,
   nPay,
   nIncome,
   nIncStr,
   nWork,
   nWrkPer,
   nWrkBas,
   nWrkLgt,
   nCntr     : L_XML.tNode;
   Surname,
   FirstName,
   Patronymic: STRING[];
 BEGIN
  CONFORM(Prt01, Man);

  ADD(ADV10, ADV10, , Packet.ExtNbr, 0, Prt01.Group, Prt01.Category, IsCorrPacket(),
      ADV10.Packets, CurNumInP = 2,
      ADV10.Items,               1,
      ADV10.DPItems, ~!Prt01.ContrNum);

  SETEMPTY(Address);
(* 0096074 07.02.2013 17:41:48 POLAK\Bor
  IF   (Packet.CorrType = L_Packet.ct_Cancel) |
       (Packet.Kind = L_Packet.knd_PF_SPV1) |
       (L_Packet.E_ManIns_NeedDwMA() = L_Packet.adr_None) THEN
   SETEMPTY(Address);
  ELSE
   IF (L_Packet.E_ManIns_NeedDwMA() = L_Packet.adr_OnlyReg) |
      ~L_Man.AccessManAdr(Man.Man, L_Packet.PrepareDate, L_Russia.at_DwMA) THEN
    L_Man.StrongAccessManAdr(Man.Man, L_Packet.PrepareDate, L_Russia.at_RgMA);
   END;
   Address:=L_Packet.GetAdrForPFR();
  END;
*)
  nDoc:=L_Packet.trn_PutAbstractDoc(nPack, trn_PckKind(), CurNumInP);
  IF    (Packet.Kind = L_Packet.knd_PF_SZV6_4) |
        (Packet.Kind = L_Packet.knd_PF_SZV6) |
        (Packet.Kind = L_Packet.knd_PF_SPV1) THEN
   IF    Packet.Kind = L_Packet.knd_PF_SPV1 THEN
    L_Packet.trn_PutString(nDoc, "", "-1");
   ELSIF Packet.Kind = L_Packet.knd_PF_SZV6 THEN
    L_Packet.trn_PutString(nDoc, "", "-6-"+SZVXx);
   ELSE
    L_General.CallUs(Packet.Kind = L_Packet.knd_PF_SZV6_4);
   END;
   L_Packet.trn_PutString(nDoc, "", L_Packet.FormType(Packet.DataType, Packet.CorrType));
   L_Packet.trn_PutString(nDoc, "樮멍", L_Packet.OwnNumInPFR);
   L_Packet.trn_PutString(nDoc, "⪮", L_Packet.OwnFirmName);
   L_Packet.trn_PutOwnFirmTaxNum(nDoc, "멍");
   L_Packet.trn_PutString(nDoc, "⥣ਨ", GetCategoryNick(Prt01.Category));
   IF IsCorrPacket() & (Packet.Kind # L_Packet.knd_PF_SPV1) THEN
    trn_intPutPer(nDoc, "멏ਮ", orgnYear, orgnQuarter);
    trn_PutPer(nDoc, "४㥬멎멏ਮ");
    IF (Packet.Kind = L_Packet.knd_PF_SZV6_4) THEN
     L_Packet.trn_PutString(nDoc, "樮멍४㥬ਮ", P_MyFirm.NumInPFR(L_Packet.PckMyFirm, PerE));
    END;
   ELSE
    trn_PutPer(nDoc, "멏ਮ");
   END;

   L_Packet.trn_PutString(nDoc, "客", L_Packet.SINumberToAnyOut(Man.SINumber));
   L_Packet.trn_PutFIO(nDoc, "", Prt01.Name);

   IF Packet.Kind = L_Packet.knd_PF_SZV6_4 THEN
    L_Packet.trn_PutString(nDoc, "", L_Str.PoolItem(L_Packet.cntrt_Pool, Intrm.CntrType));
   ELSE
    IF ~!Address THEN
     L_Packet.trn_PutAdr(nDoc, "ᇋ");
    END;
   END;
   IF Packet.CorrType # L_Packet.ct_Cancel THEN
    IF Packet.Kind = L_Packet.knd_PF_SZV6_4 THEN
     trn_PutIncIM(nDoc, Prt01.Object, Prt01.Base, Prt01.OvrPrt);

     FOR_EACH QMonth DO
      nIncStr:=L_Packet.trn_PutNode(nDoc, "㬬믫∢ࠦ");
      trn_PutQMonth(nIncStr, QMonth);
      L_Packet.trn_PutMoney(nIncStr, "㬬믫⏮27-1",    Prt01.BasPFA1[QMonth]);
      L_Packet.trn_PutMoney(nIncStr, "㬬믫⏮27-2-18", Prt01.BasPFA2[QMonth]);
     END;
    END; (* IF Packet.Kind = L_Packet.knd_PF_SZV6_4 ... *)

    trn_PutInsIncPaid(nDoc, "㬬ᮢ客",     Prt01.manPns2, GetCurPaidFromInc(Prt01.manPns2, tp_PFIn, Intrm.Category, Intrm.CntrType));
    trn_PutInsIncPaid(nDoc, "㬬ᮢ⥫", Prt01.manPns1, GetCurPaidFromInc(Prt01.manPns1, tp_PFAc, Intrm.Category, Intrm.CntrType));
   ELSE
    L_General.CallUs(!Address & (Prt01.manPns2 = 0) & (GetCurPaidFromInc(Prt01.manPns2, tp_PFIn, Intrm.Category, Intrm.CntrType) = 0) &
                                (Prt01.manPns1 = 0) & (GetCurPaidFromInc(Prt01.manPns1, tp_PFAc, Intrm.Category, Intrm.CntrType) = 0));
   END;
   IF Packet.Kind # L_Packet.knd_PF_SZV6_4 THEN
    L_Packet.trn_PutDate(nDoc, "⠇", L_Packet.PrepareDate);
   END;
   IF Packet.Kind = L_Packet.knd_PF_SPV1 THEN
    L_Packet.trn_PutDate(nDoc, "⠑⠢", Prt01.ManPerE);
   END;
  ELSIF Packet.Kind = L_Packet.knd_PF_SZV4 THEN


(* 17.04.2013 16:40:58 POLAK\Bor 0096401 .17 *)
   L_Packet.trn_PutString(nDoc, "", "-4-"+SZVXx);
   L_Packet.trn_PutString(nDoc, "", L_Str.PoolItem(L_Packet.dt_Pool, Packet.DataType));
(* CheckXML  CheckXML-UFA   ࠢ 16.05.2013 19:44:15 POLAK\Bor 0097391 *)


   L_Packet.trn_PutString(nDoc, "४஢", L_Str.PoolItem(L_Packet.ct_Pool, Packet.CorrType));
   L_Packet.trn_PutString(nDoc, "客", L_Packet.SINumberToAnyOut(Man.SINumber));
   L_Packet.trn_PutFIO(nDoc, "", Prt01.Name);
   IF ~!Address THEN
    L_Packet.trn_PutAdr(nDoc, "ᇋ");
   END;
   L_Packet.trn_PutOwnFirm(nDoc, "客⥫");
   L_Packet.trn_PutInt(nDoc, "멏ਮ", Year);
   L_Packet.trn_PutDate(nDoc, "⠇", L_Packet.PrepareDate);
   trn_PutTariff(nDoc, "客傧ᮢ", Prt01.Category);
   trn_PutInsPrem(nDoc, "᫥ᮢ᭮", Prt01.manPns2, Prt01.manPns1, 0);
   trn_PutInsPrem(nDoc, "᫥ᮢ", 0, 0, 0); (*???*)
   L_Packet.trn_PutEarnDays(nDoc, "쭨륋",        0, Prt01.Months[L_Packet.miat_Disability],  Prt01.Days[L_Packet.miat_Disability]);
   L_Packet.trn_PutEarnDays(nDoc, "⨢멎", 0, Prt01.Months[L_Packet.miat_UnpaidLeave], Prt01.Days[L_Packet.miat_UnpaidLeave]);
  ELSIF (Packet.Kind = L_Packet.knd_PF_SZV3) |
        (Packet.Kind = L_Packet.knd_PF_SZV1) THEN
   L_Packet.trn_PutString(nDoc, "", L_Packet.FormType(Packet.DataType, Packet.CorrType));

   nHeadOld:=L_Packet.trn_PutNode(nDoc, "刑");
   L_Packet.trn_PutString(nHeadOld, "客", L_Packet.SINumberToAnyOut(Man.SINumber));
   L_Packet.trn_PutFIO(nHeadOld, "", Prt01.Name);
   L_Packet.trn_PutOwnFirm(nHeadOld, "⮤⥫");
   trn_PutPer(nHeadOld, "멏ਮ");
   L_Packet.trn_PutDate(nHeadOld, "⠇", L_Packet.PrepareDate);
   trn_PutTariff(nHeadOld, "客傧ᮢ", Prt01.Category);

   IF ~!Prt01.ContrNum | ~!Prt01.ContrDat THEN
    nCntr:=L_Packet.trn_PutNode(nHeadOld, "");
    L_Packet.trn_PutString(nCntr, "", Prt01.ContrNum);
    L_Packet.trn_PutDate(nCntr, "⠇祭", Prt01.ContrDat);
    L_Packet.trn_PutString(nCntr, "믫",      L_Str.PoolItem("|", !Prt01.ContrDat));
    L_Packet.trn_PutString(nCntr, "믫", L_Str.PoolItem("|", !Prt01.ContrDat));
   END;
   L_Packet.trn_PutString(nHeadOld, "", "");

   nPay:=L_Packet.trn_PutNode(nDoc, "᫥륂");
   IF    Packet.Kind = L_Packet.knd_PF_SZV1 THEN
    L_Packet.trn_PutMoney(nPay, "될⮤⥫", Prt01.manPns2);
    L_Packet.trn_PutMoney(nPay, "될⭨",    Prt01.manPns1);
   ELSIF Packet.Kind = L_Packet.knd_PF_SZV3 THEN
    L_Packet.trn_PutMoney(nPay, "㬬ࠡ⪠砫", Prt01.manBase);
    L_Packet.trn_PutMoney(nPay, "㬬ᮢ砫",   Prt01.manPns2);
   END;

   nIncome:=L_Packet.trn_PutNode(nDoc, "ࠡ⮪");
   L_Packet.trn_PutInt(nIncome, "⢮", Prt01.MoneyStrNum);
   FOR_EACH curMonth DO
    IF Prt01.MonthToIncl[curMonth] THEN
     trn_PutIncStr(nIncome, "பࠡ⪠", curMonth, Prt01.Sum1[curMonth], Prt01.Sum2[curMonth]);
    END;
   END;
   IF Prt01.MoneyStrNum # 0 THEN
    trn_PutIncStr(nIncome, "பࠡ⪠", EMPTYOF(L_DatTim.tMonth), Prt01.manSum1, Prt01.manSum2);
   END;
  ELSE
   L_General.CallUs(0);
  END; (* Packet.Kind = ... *)

  SETEMPTY(D1, D2);
  IF Prt01.StageNum # 0 THEN
   i:=1;
   IF SELECT(_MIns, _MIns, mi_Stage, Man.Man, Intrm.Category, Intrm.CntrType) THEN
    D1:=_MIns.BegD;
    D2:=_MIns.EndD;
   END;
   IF (Packet.Kind = L_Packet.knd_PF_SZV6_4) |
      (Packet.Kind = L_Packet.knd_PF_SZV6) |
      (Packet.Kind = L_Packet.knd_PF_SPV1) THEN
    WHILE OCCURE(_MIns) DO
     nWrkPer:=L_Packet.trn_PutNode(nDoc, "⠦멏ਮ");
     L_Packet.trn_PutInt(nWrkPer, "ப", i);
     L_Packet.trn_PutDate(nWrkPer, "⠍砫ਮ", _MIns.BegD);
     L_Packet.trn_PutDate(nWrkPer, "⠊栏ਮ",  _MIns.EndD);
     IF SZVXx = 1 THEN
      IF L_Packet.IsOrdinaryType(_MIns.Type) THEN
       L_Packet.trn_PutInt(nWrkPer, "⢮죮呮⠢", 0);
      ELSE
       L_Packet.trn_PutInt(nWrkPer, "⢮죮呮⠢", 1);
       nWrkLgt:=L_Packet.trn_PutNode(nWrkPer, "죮멑⠦");
       L_Packet.trn_PutInt(nWrkLgt, "ப", 1);
       trn_PutMInsFeatures(nWrkLgt, "ᮡ⨓");
      END;
     END;
     INC(i);
     NEXT(_MIns);
    END; (* WHILE OCCURE(_MIns)... *)
   ELSE
    nWork:=L_Packet.trn_PutNode(nDoc, "᥏ਮ될");
    L_Packet.trn_PutInt(nWork, "⢮", Prt01.StageNum);

    WHILE OCCURE(_MIns) DO
     nWrkPer:=L_Packet.trn_PutNode(nWork, "ਮ");
     nWrkBas:=L_Packet.trn_PutNode(nWrkPer, "᭮ப");
     L_Packet.trn_PutInt(nWrkBas, "ப", i);
     L_Packet.trn_PutDate(nWrkBas, "⠍砫ਮ", _MIns.BegD);
     L_Packet.trn_PutDate(nWrkBas, "⠊栏ਮ",  _MIns.EndD);
     IF (Packet.Kind # L_Packet.knd_PF_SZV4) | (SZVXx # 2) THEN
      trn_PutMInsFeatures(nWrkBas, "ᮡ⨓");
     END;
     INC(i);
     NEXT(_MIns);
    END; (* WHILE OCCURE(_MIns)... *)
   END;
  END; (* IF Prt01.StageNum # 0 *)
  IF Packet.Kind = L_Packet.knd_PF_SZV6_4 THEN
   L_Packet.trn_PutDate(nDoc, "⠇", L_Packet.PrepareDate);
  END;

  L_Str.SplitManName(Prt01.Name, Surname, FirstName, Patronymic);
  IF    Packet.Kind = L_Packet.knd_PF_SZV6_4 THEN
   MAKEPART(R, SZV_6_4_1, CurNumInP, Surname, FirstName, Patronymic);
  ELSIF Packet.Kind = L_Packet.knd_PF_SZV6 THEN
   Str.Format(Addr2, Address, SZV_6_AddrLen, LEFT);
   IF    SZVXx = 1 THEN
    MAKEPART(R, SZV_6_1_1, CurNumInP);
    MAKEPART(R, SZV_6_1_2, Surname, Addr2[0], FirstName, Addr2[1], Patronymic, Addr2[2]);
   ELSE
    IF SZVX_2_Count=0 THEN
     MAKEPART(R, SZV_6_2_1, (CurNumInP DIV Max_SZVX_2_Count) + 2, GetCategoryNick(Prt01.Category), TotNumInP);
    END;
    MAKEPART(R, SZV_6_2_2, Surname, Addr2[0], D1, D2, FirstName, Addr2[1], Patronymic, Addr2[2]);
   END;
  ELSIF Packet.Kind = L_Packet.knd_PF_SPV1 THEN
   MAKEPART(R, SPV_1_1, CurNumInP, Surname, FirstName, Patronymic);
  ELSIF Packet.Kind = L_Packet.knd_PF_SZV4 THEN
   Str.Format(Addr2, Address, SZV_4_AddrLen, LEFT);
   IF    SZVXx = 1 THEN
    MAKEPART(R, SZV_4_X_1, CurNumInP);
    MAKEPART(R, SZV_4_1_2, , , Addr2[0], Addr2[1]);
   ELSE
    IF SZVX_2_Count=0 THEN
     MAKEPART(R, SZV_4_X_1, (CurNumInP DIV Max_SZVX_2_Count) + 2);
     MAKEPART(R, SZV_4_2_2);
    END;
    MAKEPART(R, SZV_4_2_3, D1, D2, Addr2[0], Addr2[1]);
   END;
  ELSE
   IF    Packet.Kind = L_Packet.knd_PF_SZV3 THEN
    MAKEPART(R, SZV_3_00_1, Surname, FirstName, Patronymic);
   ELSIF Packet.Kind = L_Packet.knd_PF_SZV1 THEN
    MAKEPART(R, SZV_1_00_1, Surname, FirstName, Patronymic);
   END;
   _Period:=PerBMoney(Prt01.ManPerB);
   WHILE _Period <= PerEMoney(Prt01.ManPerE) DO
    curMonth:=L_DatTim.MONTH(_Period);
    PROMPT(": "+GetManStrId(Man.Man)+" "+curMonth);
    IF Prt01.MonthToIncl[curMonth] THEN
     MAKEPART(R, SZV_X_X_2, L_DatTim.MonthStr(_Period, 0),
                            MoneyToTxt(Prt01.Sum1[curMonth]),
                            MoneyToTxt(Prt01.Sum2[curMonth]));
    ELSE
     MAKEPART(R, SZV_X_X_2, L_DatTim.MonthStr(_Period, 0));
    END;
    _Period:=L_DatTim.NextPer(_Period);
   END;
  
   IF !Prt01.ContrNum THEN
    MAKEPART(R, SZV_X_X_3, MoneyToTxt(Prt01.manSum1),
                           MoneyToTxt(Prt01.manSum2),
                           "", "", "");
   ELSE
    MAKEPART(R, SZV_X_X_3, MoneyToTxt(Prt01.manSum1),
                           MoneyToTxt(Prt01.manSum2),
                           Prt01.ContrNum, L_DatTim.DateStr(Prt01.ContrDat), "");
   END;
  END;

  IF (SZVXx # 2) & (Packet.CorrType # L_Packet.ct_Cancel) THEN
   i:=1;
   SELECT(_MIns, _MIns, , mi_Stage, Man.Man, Intrm.Category, Intrm.CntrType);
   WHILE OCCURE(_MIns) DO
    L_General.Assert(i <=MaxStageNum,
                     "⢮ ப  ⠦|ॢ蠥 ᨬ쭮 祭 "+
                     L_Str.IntStr(MaxStageNum)+"|᪮  "+Man.Man);
    MAKEPART(R, SZV_X_X_5, i, L_DatTim.DateStr(_MIns.BegD), L_DatTim.DateStr(_MIns.EndD), Str.Item(_MIns.Type, ";", 0), Str.Item(_MIns.Type, ";", 2));
    Dummy:=Str.Condense(Str.Item(_MIns.Type, ";", 1));
    IF ~!Dummy THEN
     MAKEPART(R, SZV_X_X_5, , , , Dummy);
    END;
 
    INC(i);
    NEXT(_MIns);
   END; (* WHILE OCCURE(_MIns)... *)
  END;

  INC(SZVX_2_Count);
  IF (SZVXx = 1) | (SZVXx = 0) THEN
   MAKEPART(R, SZV_X_X_6);
   FORMFEED(R);
  ELSE
   IF SZVX_2_Count = Max_SZVX_2_Count THEN
    Fill_SZV_X_2();
    SZVX_2_Count:=0;
   END;
  END;
  IF IsSince2010() THEN
   IF SEARCH(TmpIP, Man, Man.Man, Intrm.Category, Intrm.CntrType) THEN
    L_Packet.PutPckBodyAttr(PckBody.Packet, PckBody.SeqNbr, patt_CurInc[tp_PFIn],  MoneyToTxt(TmpIP.CurInc[tp_PFIn]));
    L_Packet.PutPckBodyAttr(PckBody.Packet, PckBody.SeqNbr, patt_CurInc[tp_PFAc],  MoneyToTxt(TmpIP.CurInc[tp_PFAc]));
    L_Packet.PutPckBodyAttr(PckBody.Packet, PckBody.SeqNbr, patt_CurPaid[tp_PFIn], MoneyToTxt(TmpIP.CurPaid[tp_PFIn]));
    L_Packet.PutPckBodyAttr(PckBody.Packet, PckBody.SeqNbr, patt_CurPaid[tp_PFAc], MoneyToTxt(TmpIP.CurPaid[tp_PFAc]));
    L_Packet.PutPckBodyAttr(PckBody.Packet, PckBody.SeqNbr, patt_PrvInc[tp_PFIn],  MoneyToTxt(TmpIP.PrvInc[tp_PFIn]));
    L_Packet.PutPckBodyAttr(PckBody.Packet, PckBody.SeqNbr, patt_PrvInc[tp_PFAc],  MoneyToTxt(TmpIP.PrvInc[tp_PFAc]));
    L_Packet.PutPckBodyAttr(PckBody.Packet, PckBody.SeqNbr, patt_PrvPaid[tp_PFIn], MoneyToTxt(TmpIP.PrvPaid[tp_PFIn]));
    L_Packet.PutPckBodyAttr(PckBody.Packet, PckBody.SeqNbr, patt_PrvPaid[tp_PFAc], MoneyToTxt(TmpIP.PrvPaid[tp_PFAc]));
   ELSE
    L_Packet.PutPckBodyAttr(PckBody.Packet, PckBody.SeqNbr, patt_CurInc[tp_PFIn],  "0");
    L_Packet.PutPckBodyAttr(PckBody.Packet, PckBody.SeqNbr, patt_CurInc[tp_PFAc],  "0");
    L_Packet.PutPckBodyAttr(PckBody.Packet, PckBody.SeqNbr, patt_CurPaid[tp_PFIn], "0");
    L_Packet.PutPckBodyAttr(PckBody.Packet, PckBody.SeqNbr, patt_CurPaid[tp_PFAc], "0");
    L_Packet.PutPckBodyAttr(PckBody.Packet, PckBody.SeqNbr, patt_PrvInc[tp_PFIn],  "0");
    L_Packet.PutPckBodyAttr(PckBody.Packet, PckBody.SeqNbr, patt_PrvInc[tp_PFAc],  "0");
    L_Packet.PutPckBodyAttr(PckBody.Packet, PckBody.SeqNbr, patt_PrvPaid[tp_PFIn], "0");
    L_Packet.PutPckBodyAttr(PckBody.Packet, PckBody.SeqNbr, patt_PrvPaid[tp_PFAc], "0");
   END;
  END;
 END {MakeOneMan};

 PRIVATE PROCEDURE trn_PckKind(): STRING[];
 BEGIN
  IF    Packet.Kind = L_Packet.knd_PF_SZV1   THEN RETURN "__-1";
  ELSIF Packet.Kind = L_Packet.knd_PF_SZV3   THEN RETURN "__-3";
  ELSIF Packet.Kind = L_Packet.knd_PF_SZV4   THEN RETURN "_-4-"+SZVXx;
  ELSIF Packet.Kind = L_Packet.knd_PF_SZV6   THEN RETURN "_______";
  ELSIF Packet.Kind = L_Packet.knd_PF_SPV1   THEN RETURN "_______";
  ELSIF Packet.Kind = L_Packet.knd_PF_ADV10  THEN RETURN "_";
  ELSIF Packet.Kind = L_Packet.knd_PF_ADV11  THEN RETURN "_";
  ELSIF Packet.Kind = L_Packet.knd_PF_ADV6_2 THEN RETURN "___";
  ELSIF Packet.Kind = L_Packet.knd_PF_SZV6_4 THEN RETURN "__________";
  ELSE
   L_General.CallUs(0);
  END;
 END {trn_PckKind};

 PRIVATE PROCEDURE GetPacketGroupFromAttr(trgPacket: LIKE(Packet.Packet)): L_Packet.tPacketGroup;
  VAR
   GroupStr: STRING[];
 BEGIN
  GroupStr:=L_Packet.GetPacketAttr(trgPacket, patt_Group);
  L_General.CallUs(~!GroupStr);
  RETURN STRTOFLD(GroupStr, NUMERIC);
 END {GetPacketGroupFromAttr};

 PRIVATE PROCEDURE GetPacketCategoryFromAttr(trgPacket: LIKE(Packet.Packet)): tCategory;
  VAR
   Result: tCategory;
 BEGIN
  Result:=L_Packet.GetPacketAttr(trgPacket, patt_Category);
  RETURN Result;
 END {GetPacketCategoryFromAttr};

 PRIVATE PROCEDURE GetPacketCntrTypeFromAttr(trgPacket: LIKE(Packet.Packet); trgMan: LIKE(Man.Man)): tCategory;
  VAR
   Result: tCategory;
 BEGIN
  TRY [RESTORE_CURSORS(RC_ON)]
   SEARCH(Packet, Packet, , trgPacket);
   IF Packet.PerB >= 01\01\2013 THEN
    Result:=L_Str.PositionInPool(L_Packet.cntrt_Pool, L_Packet.GetPacketAttr(trgPacket, patt_CntrType));
   ELSE
    SEARCH(Man, Man, , trgMan);
    Result:=GetManCntrType(Packet.PerE);
   END;
  EXCEPT
  END;
  RETURN Result;
 END {GetPacketCntrTypeFromAttr};

 PRIVATE PROCEDURE MakeOnePacket();
  VAR
   PerOfPay   : SCAL[2][12];
   pckCategory: tCategory;
   pckCntrType: L_Packet.tCntrType;
   ManPerB,
   ManPerE    : DATE;
   nPack,
   nInvH,
   nInvP,
   nTotPay,
   nInc       : L_XML.tNode;
 BEGIN
  APP.Get().NewPrompt("ନ஢.  "+Packet.ExtNbr);
  L_Packet.CheckExistTrnFiles();
  L_Packet.trn_OpenFiles();
  L_Packet.CheckPacketType();
  SETZERO(CurNumInP, TotNumInP, pSum, pPns, pSum1, pSum2, pInc, pPaid,
          past_pInc, past_pPaid, SZVXx,
          pObject, pBase, pOvrPrt);

  SELECT(Intrm, Packet, , Packet.Packet);
  pckCategory:=GetPacketCategoryFromAttr(Packet.Packet);
  pckCntrType:=Intrm.CntrType;

  SELECT(PckBody, Packet, , Packet.Packet);
  WHILE OCCURE(PckBody) DO
   PROMPT(": "+GetManStrId(PckBody.Man));
   INC(CurNumInP);
   L_General.Assert(PckBody.SeqNbr = CurNumInP, " 窥 襭 㬥");
   CONFORM(PckBody, Man);
   SEARCH(Intrm, Packet, , PckBody.Packet, PckBody.SeqNbr);
   PrepareOneMan(GetManPerB(), GetManPerE());
   NEXT(PckBody);
  END; (* WHILE OCCURE(PckBody) ... *)

  TotNumInP:=CurNumInP;

  nPack:=L_Packet.ext_trn_PutHead(L_Packet.ext_trnFileName(orgnPerE));
  IF (Packet.Kind = L_Packet.knd_PF_SZV6_4) |
     (Packet.Kind = L_Packet.knd_PF_SZV6) |
     (Packet.Kind = L_Packet.knd_PF_SPV1) THEN
   IF (Packet.Kind = L_Packet.knd_PF_SZV6_4) THEN
    nInvH:=L_Packet.trn_PutInventoryHead(nPack, "________", trn_PckKind(), TotNumInP);
   ELSIF (Packet.Kind = L_Packet.knd_PF_SPV1) |
         (Packet.Kind = L_Packet.knd_PF_SZV6) THEN
    nInvH:=L_Packet.trn_PutInventoryHead(nPack, "____", trn_PckKind(), TotNumInP);
   ELSE
    L_General.CallUs(0);
   END;
   L_Packet.trn_PutString(nInvH, "", L_Packet.FormType(Packet.DataType, Packet.CorrType));
   L_Packet.trn_PutString(nInvH, "⥣ਨ", GetCategoryNick(pckCategory));

   IF IsCorrPacket() THEN
    trn_intPutPer(nInvH, "멏ਮ", orgnYear, orgnQuarter);
    trn_PutPer(nInvH, "४㥬멎멏ਮ");
   ELSE
    trn_PutPer(nInvH, "멏ਮ");
   END;

   IF Packet.Kind = L_Packet.knd_PF_SZV6_4 THEN
    L_Packet.trn_PutString(nInvH, "", L_Str.PoolItem(L_Packet.cntrt_Pool, pckCntrType));
   END;
   IF Packet.CorrType # L_Packet.ct_Cancel THEN
    IF Packet.Kind = L_Packet.knd_PF_SZV6_4 THEN
(* 23.04.2013 11:42:00 POLAK\Bor 0096401 .26
     trn_PutIncIM(nInvH, pObject, pBase, pOvrPrt);
*)
     nInc:=L_Packet.trn_PutNode(nInvH, "㬬믫∢ࠦ㇋");
     trn_PutQMonth(nInc, TotQBMS);
     L_Packet.trn_PutMoney(nInc, "㬬믫ᥣ", pObject[TotQBMS]);
     L_Packet.trn_PutMoney(nInc, "㬬믫⍠᫥客륂덥ॢ騥", pBase[TotQBMS]);
     L_Packet.trn_PutMoney(nInc, "㬬믫⍠᫥客륂ॢ騥",   pOvrPrt[TotQBMS]);
    END;
    trn_PutInsIncPaid(nInvH, "㬬ᮢ客",     pInc[tp_PFIn], pPaid[tp_PFIn]);
    trn_PutInsIncPaid(nInvH, "㬬ᮢ⥫", pInc[tp_PFAc], pPaid[tp_PFAc]);
   ELSE
    L_General.CallUs(PFSumIsZERO(pInc) & PFSumIsZERO(pPaid));
   END;
  ELSE
   nInvH:=L_Packet.trn_PutInventoryHead(nPack, "_", trn_PckKind(), TotNumInP);
   IF Packet.Kind = L_Packet.knd_PF_SZV4 THEN
    nInvP:=L_Packet.trn_PutNode(nInvH, "窠4");
    L_Packet.trn_PutInt(nInvP, "멏ਮ", Year);
    trn_PutTariff(nInvP, "客傧ᮢ", pckCategory);
    IF SZVXx = 2 THEN
     L_Packet.trn_PutTerrCond(nInvP, "ਠ륓᫮", "", 0);
    END;
    L_Packet.trn_PutString(nInvP, "",      L_Str.PoolItem(L_Packet.dt_Pool, Packet.DataType));
    L_Packet.trn_PutString(nInvP, "४஢", L_Str.PoolItem(L_Packet.ct_Pool, Packet.CorrType));
    trn_PutInsPrem(nInvP, "⮣㬬ᮢ", pInc[tp_PFIn],  pInc[tp_PFAc], 0);
   ELSIF (Packet.Kind = L_Packet.knd_PF_SZV3) |
         (Packet.Kind = L_Packet.knd_PF_SZV1)   THEN
    nInvP:=L_Packet.trn_PutNode(nInvH, "窠刑");
    trn_PutPer(nInvP, "멏ਮ");
    L_Packet.trn_PutMoney(nInvP, "᫥ᥣ", pSum1);
    L_Packet.trn_PutMoney(nInvP, "᫥쭨", pSum2);
   ELSE
    L_General.CallUs(0);
   END;
  END;

  IF   (Packet.Kind = L_Packet.knd_PF_SZV6_4) |
       (Packet.Kind = L_Packet.knd_PF_SZV6) |
       (Packet.Kind = L_Packet.knd_PF_SPV1) THEN
   IF SZVXx = 1 THEN
    IF (Packet.Kind = L_Packet.knd_PF_SZV6_4) THEN
     MAKEPART(R, ADV6_X_1, "5", GetCategoryNick(pckCategory));
     MAKEPART(R, ADV6_5_1_1, (pckCntrType=L_Packet.cntrt_Basic), (pckCntrType=L_Packet.cntrt_CA));
     MAKEPART(R, ADV6_X_2, TotNumInP, "4");
     MAKEPART(R, ADV6_5_2_1, pObject[TotQBMS], pBase[TotQBMS], pOvrPrt[TotQBMS]);
    ELSE
     MAKEPART(R, ADV6_X_1, "3", GetCategoryNick(pckCategory));
     MAKEPART(R, ADV6_X_2, TotNumInP, "1");
    END;
    MAKEPART(R, ADV6_X_3, pInc[tp_PFIn], pPaid[tp_PFIn], pInc[tp_PFAc], pPaid[tp_PFAc]);
   END;
  ELSIF Packet.Kind = L_Packet.knd_PF_SZV4 THEN
   IF SZVXx = 1 THEN
    L_Packet.MakeADV61forSZV4x(TotNumInP, TotNumInP, Year, GetCategoryNick(pckCategory),
                               pInc[tp_PFIn], pInc[tp_PFAc]);
   ELSE
    L_Packet.MakeADV61forSZV4x((TotNumInP-1) DIV Max_SZVX_2_Count + 1,
                               TotNumInP, Year, GetCategoryNick(pckCategory),
                               pInc[tp_PFIn], pInc[tp_PFAc]);
   END;
  ELSE
   L_Packet.MakeADV61forSZV3(TotNumInP, PerByWord, pSum1, pSum2);
  END;

  FORMFEED(R);
  InitPrintAttr(R, Duplex, Off);
  IF (Packet.Kind = L_Packet.knd_PF_SZV6) & (SZVXx = 2) THEN
   SetPrintAttr(R, Orientation, Landscape);
  END;

  SZVX_2_Count:=0;
  CurNumInP:=1;
  FIRST(PckBody);
  WHILE OCCURE(PckBody) DO
   INC(CurNumInP);
   PROMPT(": "+GetManStrId(PckBody.Man));
   SEARCH(Prt01, Man, , PckBody.Man, PckBody.Packet);
   MakeOneMan(nPack);
   NEXT(PckBody);
  END; (* WHILE OCCURE(PckBody) ... *)
  Fill_SZV_X_2();

  IF IsSince2010() THEN
   Packet.Sums[ps_InInc] :=pInc[tp_PFIn]  - past_pInc[tp_PFIn];
   Packet.Sums[ps_InPaid]:=pPaid[tp_PFIn] - past_pPaid[tp_PFIn];
   Packet.Sums[ps_AcInc] :=pInc[tp_PFAc]  - past_pInc[tp_PFAc];
   Packet.Sums[ps_AcPaid]:=pPaid[tp_PFAc] - past_pPaid[tp_PFAc];
  ELSE
   Packet.Sums[0]:=pSum;
   Packet.Sums[1]:=pPns;
  END;
  REPLACE(Packet);
  IF ~IsSince2002() & (L_Env.Region = L_Russia.reg_50) THEN
   MAKEPART(R, PartX1, " 窨", Packet.ExtNbr, CurNumInP,
                       MoneyToTxt(ForX_ByPacket(00, "_Sum1")-ForX_ByPacket(00, "_Sum2")),
                       MoneyToTxt(ForX_ByPacket(01, "_Sum1")-ForX_ByPacket(01, "_Sum2")),
                       MoneyToTxt(ForX_ByPacket(02, "_Sum1")-ForX_ByPacket(02, "_Sum2")),
                       MoneyToTxt(ForX_ByPacket(03, "_Sum1")-ForX_ByPacket(03, "_Sum2")),
                       MoneyToTxt(ForX_ByPacket(04, "_Sum1")-ForX_ByPacket(04, "_Sum2")),
                       MoneyToTxt(ForX_ByPacket(05, "_Sum1")-ForX_ByPacket(05, "_Sum2")),
                       MoneyToTxt(ForX_ByPacket(06, "_Sum1")-ForX_ByPacket(06, "_Sum2")),
                       MoneyToTxt(ForX_ByPacket(07, "_Sum1")-ForX_ByPacket(07, "_Sum2")),
                       MoneyToTxt(ForX_ByPacket(08, "_Sum1")-ForX_ByPacket(08, "_Sum2")),
                       MoneyToTxt(ForX_ByPacket(09, "_Sum1")-ForX_ByPacket(09, "_Sum2")),
                       MoneyToTxt(ForX_ByPacket(10, "_Sum1")-ForX_ByPacket(10, "_Sum2")),
                       MoneyToTxt(ForX_ByPacket(11, "_Sum1")-ForX_ByPacket(11, "_Sum2")),
                       MoneyToTxt(ForX_ByPacket(12, "_Sum1")-ForX_ByPacket(12, "_Sum2")),
                       MoneyToTxt(ForX_ByPacket(12, "_Pns2")                          ));
  END;
  FORMFEED(R);
  InitPrintAttr(R, Duplex, Off);
  MAKEPART(R, NN1_3_00_1);
  FIRST(PckBody);
  WHILE OCCURE(PckBody) DO
   PROMPT("᮪ 客 : "+GetManStrId(PckBody.Man));
   CONFORM(PckBody, Man);
   MAKEPART(R, NN1_3_00_2);
   NEXT(PckBody);
  END; (* WHILE OCCURE(PckBody) ... *)
  MAKEPART(R, NN1_3_00_3);
  L_Packet.trn_CloseFiles(nPack);
  INC(RealPacketAmount);
 END {MakeOnePacket};

 PRIVATE PROCEDURE PrepareADV10Data(ByPrepare: SCAL[2]; Amount: NUMERIC[0]; trgCategory: tCategory;
                                    TrfSign: STRING[1]; VAR gPackets, gItems: NUMERIC[0]);
  VAR
   _Month     : SCAL[100];
   Months     : DATE[12+1];
   tmDue      : L_PRoll.tSum;
   Pay,
   SickPay,
   ChargedDue,
   TransferDue: L_PRoll.tSum[12+1];
   AverageNum : NUMERIC[0][12+1];
   Debts      : L_PRoll.tSum;
   Msg        : STRING[];
 BEGIN
  tmDue:=0;
  _Month:=0;
  IF ByPrepare THEN
   Msg:="";
  ELSE
   Msg:="|஢ઠ/४஢ |";
  END;
  REPEAT
   INC(_Month);
   Months[_Month]:=PackDATE(1, _Month-1, Year);
   IF ByPrepare THEN
    SELECT(ADV10, ADV10_AM, , trgCategory, _Month);
    Pay    [_Month]:=GetADV10BySelectForADV10("_Sum1");
    SickPay[_Month]:=GetADV10BySelectForADV10("_Sum2");
   ELSE
    Pay    [_Month]:=GetPckAttrAsNum(trgCategory+patt_Pay    +_Month);
    SickPay[_Month]:=GetPckAttrAsNum(trgCategory+patt_SickPay+_Month);
   END;
   IF ByPrepare & (Amount=1) THEN
    SELECT(ADV10, ADV10_M, , _Month);
    INC(tmDue, GetADV10BySelectForADV10("_Pns2"));
    ChargedDue [_Month]:=tmDue;
    TransferDue[_Month]:=tmDue;
    AverageNum [_Month]:=GetADV10BySelectForADV10("Quantity");
   ELSE
    ChargedDue [_Month]:=GetPckAttrAsNum(patt_ChargedDue +_Month);
    TransferDue[_Month]:=GetPckAttrAsNum(patt_TransferDue+_Month);
    AverageNum [_Month]:=GetPckAttrAsNum(patt_AverageNum +_Month);
   END;
  UNTIL _Month=12;
  Debts:=GetPckAttrAsNum(patt_Debts);

  STDFORM(L_StdFrm.sf_Choice(Msg +
                             "|⢮ 祪  室묨 㬥⠬ -3:           %#####%        " +
                             "|⢮ 室 㬥⮢ -3:                     %#####%        " +
                             "|   ⭮ ਮ           %############%        " +
                             "| ⥣ਨ %###########%                        ࠢ筮             " +
                             "|        ࠡ⮪  ..ᮡ।.     ᫥  ᫥" +
                             "|                        㤮.᫥.         ᮢ         " +
                             "|%#######% %##########% %###########%%####% %#% %##########% %##########%" +
                             "|%#######% %##########% %###########%%####% %#% %##########% %##########%" +
                             "|%#######% %##########% %###########%%####% %#% %##########% %##########%" +
                             "|%#######% %##########% %###########%%####% %#% %##########% %##########%" +
                             "|%#######% %##########% %###########%%####% %#% %##########% %##########%" +
                             "|%#######% %##########% %###########%%####% %#% %##########% %##########%" +
                             "|%#######% %##########% %###########%%####% %#% %##########% %##########%" +
                             "|%#######% %##########% %###########%%####% %#% %##########% %##########%" +
                             "|%#######% %##########% %###########%%####% %#% %##########% %##########%" +
                             "|%#######% %##########% %###########%%####% %#% %##########% %##########%" +
                             "|%#######% %##########% %###########%%####% %#% %##########% %##########%" +
                             "|%#######% %##########% %###########%%####% %#% %##########% %##########%",
                             "%RI" +
                             "%RI" +
                             "%RI" +
                             "%LNI" +
                             "%L<N.y>NI%RFI%RI%RI%NI%RI%RI" +
                             "%L<N.y>NI%RI%RI%RI%NI%RI%RI" +
                             "%L<N.y>NI%RI%RI%RI%NI%RI%RI" +
                             "%L<N.y>NI%RI%RI%RI%NI%RI%RI" +
                             "%L<N.y>NI%RI%RI%RI%NI%RI%RI" +
                             "%L<N.y>NI%RI%RI%RI%NI%RI%RI" +
                             "%L<N.y>NI%RI%RI%RI%NI%RI%RI" +
                             "%L<N.y>NI%RI%RI%RI%NI%RI%RI" +
                             "%L<N.y>NI%RI%RI%RI%NI%RI%RI" +
                             "%L<N.y>NI%RI%RI%RI%NI%RI%RI" +
                             "%L<N.y>NI%RI%RI%RI%NI%RI%RI" +
                             "%L<N.y>NI%RI%RI%RI%NI%RI%RI"),
          " -10 ",
          ,
          -1,
          gPackets,
          gItems,
          Debts,
          GetCategoryNick(trgCategory),
          Months[1],  Pay[1],  SickPay[1],  AverageNum[1],  TrfSign, ChargedDue[1],  TransferDue[1],
          Months[2],  Pay[2],  SickPay[2],  AverageNum[2],  TrfSign, ChargedDue[2],  TransferDue[2],
          Months[3],  Pay[3],  SickPay[3],  AverageNum[3],  TrfSign, ChargedDue[3],  TransferDue[3],
          Months[4],  Pay[4],  SickPay[4],  AverageNum[4],  TrfSign, ChargedDue[4],  TransferDue[4],
          Months[5],  Pay[5],  SickPay[5],  AverageNum[5],  TrfSign, ChargedDue[5],  TransferDue[5],
          Months[6],  Pay[6],  SickPay[6],  AverageNum[6],  TrfSign, ChargedDue[6],  TransferDue[6],
          Months[7],  Pay[7],  SickPay[7],  AverageNum[7],  TrfSign, ChargedDue[7],  TransferDue[7],
          Months[8],  Pay[8],  SickPay[8],  AverageNum[8],  TrfSign, ChargedDue[8],  TransferDue[8],
          Months[9],  Pay[9],  SickPay[9],  AverageNum[9],  TrfSign, ChargedDue[9],  TransferDue[9],
          Months[10], Pay[10], SickPay[10], AverageNum[10], TrfSign, ChargedDue[10], TransferDue[10],
          Months[11], Pay[11], SickPay[11], AverageNum[11], TrfSign, ChargedDue[11], TransferDue[11],
          Months[12], Pay[12], SickPay[12], AverageNum[12], TrfSign, ChargedDue[12], TransferDue[12]);

  PutNumToPckAttr(trgCategory+patt_Packets, gPackets);
  PutNumToPckAttr(trgCategory+patt_Items,   gItems);
  PutNumToPckAttr(patt_Debts,               Debts);
  _Month:=0;
  REPEAT
   INC(_Month);
   PutNumToPckAttr(trgCategory+patt_Pay    +_Month, Pay    [_Month]);
   PutNumToPckAttr(trgCategory+patt_SickPay+_Month, SickPay[_Month]);
   PutNumToPckAttr(patt_AverageNum +_Month,  AverageNum [_Month]);
   PutNumToPckAttr(patt_ChargedDue +_Month,  ChargedDue [_Month]);
   PutNumToPckAttr(patt_TransferDue +_Month, TransferDue[_Month]);
  UNTIL _Month=12;
 END {PrepareADV10Data};

 PRIVATE PROCEDURE GetTotalADV10Parm(_Attr: LIKE(PckAttr.Attr)): L_PRoll.tSum;
  VAR
   _Month: SCAL[100];
   RetVal: L_PRoll.tSum;
 BEGIN
  RetVal:=0;
  _Month:=0;
  REPEAT
   INC(_Month);
   INC(RetVal, GetPckAttrAsNum(_Attr+_Month));
  UNTIL _Month=12;
  RETURN RetVal;
 END {GetTotalADV10Parm};

 PRIVATE PROCEDURE MakeADV10();
  VAR
   curCategory: tCategory;
   Amount     : NUMERIC[0];
   _Month,
   MonthNum   : SCAL[12+1];
   gPackets,
   gItems     : NUMERIC[0];
   gPay,
   gmPay,
   gSickPay,
   gmSickPay,
   ttChargedDue,
   ttTransferDue,
   tmChargedDue,
   tmTransferDue,
   Debts      : L_PRoll.tSum;
   tQuantity  : NUMERIC[0];
   TrfSign    : STRING[1];
   nPack,
   nInvH,
   nDoc,
   nTotPay    : L_XML.tNode;
 BEGIN
  L_General.CallUs(SEARCH(Packet, Packet, PacketForADV1X));
  L_General.CallUs(PerE < L_SFee.TheStartingPoint);

  IF L_STx.E_ApplyRegressiveScale(PerB) THEN
   TrfSign:="";
  ELSE
   TrfSign:="";
  END;

  Amount:=0;
  FOR_EACH curCategory IN CategoryList() DO
   IF SELECT(ADV10, ADV10_AM) THEN
    IF SELECT(ADV10, ADV10_AM, curCategory) THEN
     INC(Amount);
     gPackets:=GetADV10BySelectForADV10("Packets");
     gItems  :=GetADV10BySelectForADV10("Items");
     PrepareADV10Data(1, Amount, curCategory, TrfSign, gPackets, gItems);
    END;
   ELSE
    gPackets:=GetPckAttrAsNum(curCategory+patt_Packets);
    gItems  :=GetPckAttrAsNum(curCategory+patt_Items);
    PrepareADV10Data(0, Amount, curCategory, TrfSign, gPackets, gItems);
    IF GetPckAttrAsNum(curCategory+patt_Packets) > 0 THEN
     INC(Amount);
    END;
   END;
  END; (* FOR_EACH curCategory ... *)

  L_Packet.trn_OpenFiles();
  nPack:=L_Packet.trn_PutHead();
  nInvH:=L_Packet.trn_PutInventoryHead(nPack, "_", trn_PckKind(), Amount);

  L_Packet.MakeADV61forADV10(Amount);

  FORMFEED(R);
  InitPrintAttr(R, Duplex, Off);

  Amount:=0;
  FOR_EACH curCategory IN CategoryList() DO
   gPackets:=GetPckAttrAsNum(curCategory+patt_Packets);
   gItems  :=GetPckAttrAsNum(curCategory+patt_Items);
   IF ~!gPackets & (gPackets # 0) THEN
    INC(Amount);
    IF Amount = 1 THEN
     ttChargedDue :=GetPckAttrAsNum(patt_ChargedDue +"12"); (*騬 ⮣*)
     ttTransferDue:=GetPckAttrAsNum(patt_TransferDue+"12");
     Debts        :=GetPckAttrAsNum(patt_Debts);
    ELSE
     ttChargedDue :=0;
     ttTransferDue:=0;
     Debts        :=0;
     TrfSign:="";
    END;
    gPay    :=GetTotalADV10Parm(curCategory+patt_Pay);
    gSickPay:=GetTotalADV10Parm(curCategory+patt_SickPay);

    nDoc:=L_Packet.trn_PutAbstractDoc(nPack, trn_PckKind(), Amount+1);
    L_Packet.trn_PutOwnFirm(nDoc, "客⥫");
    trn_PutPer(nDoc, "멏ਮ");
    L_Packet.trn_PutDate(nDoc, "⠇", L_Packet.PrepareDate);
    L_Packet.trn_PutInt(nDoc, "᫮祪", gPackets);
    L_Packet.trn_PutInt(nDoc, "᫮客勨", gItems);
    L_Packet.trn_PutMoney(nDoc, "쏮ᠬ", Debts);
    L_Packet.trn_PutString(nDoc, "⥣ਨ", GetCategoryNick(curCategory));
    nTotPay:=L_Packet.trn_PutNode(nDoc, "쇠ࠡ⮪室⥣ਨ");
    MonthNum:=12; (*ॡ   ப.  18181*)
    L_Packet.trn_PutInt(nTotPay, "⢮", MonthNum+1);

    MAKEPART(R, ADV10_3_00_1,
               L_Str.IntStr(Amount+1),
               L_Str.IntStr(gPackets), L_Str.IntStr(gItems),
               L_Str.IntStr(Debts)(**),
               GetCategoryNick(curCategory));
    _Month:=0;
    REPEAT
     INC(_Month);
     IF Amount = 1 THEN
      tmChargedDue :=GetPckAttrAsNum(patt_ChargedDue +_Month);
      tmTransferDue:=GetPckAttrAsNum(patt_TransferDue+_Month);
      tQuantity    :=GetPckAttrAsNum(patt_AverageNum +_Month);
     ELSE
      tQuantity:=0;
      SETZERO(tmChargedDue, tmTransferDue);
     END;
     SELECT(ADV10, ADV10_AM, , curCategory, _Month);
     gmPay    :=GetPckAttrAsNum(curCategory+patt_Pay    +_Month);
     gmSickPay:=GetPckAttrAsNum(curCategory+patt_SickPay+_Month);

     trn_PutPayStr(nTotPay, "ࠡ⮪室⥣ਨ", _Month-1,
                   gmPay, gmSickPay, tQuantity, TrfSign,
                   tmChargedDue, tmTransferDue);

     MAKEPART(R, ADV10_3_00_2,
                L_DatTim.MonthStr(PackDATE(1, _Month-1, Year), 0),
                MoneyToTxt(gmPay), MoneyToTxt(gmSickPay),
                L_Str.IntStr(tQuantity), TrfSign,
                MoneyToTxt(tmChargedDue), MoneyToTxt(tmTransferDue));
    UNTIL _Month = MonthNum;

    trn_PutPayStr(nTotPay, "ࠡ⮪室⥣ਨ", EMPTYOF(L_DatTim.tMonth),
                  gPay, gSickPay, 0, "",
                  ttChargedDue, ttTransferDue);

    MAKEPART(R, ADV10_3_00_3,
             MoneyToTxt(gPay), MoneyToTxt(gSickPay),
             MoneyToTxt(ttChargedDue), MoneyToTxt(ttTransferDue));
    FORMFEED(R);
   END;
  END; (* FOR_EACH curCategory ... *)
  SETEMPTY(pSum1, pSum2, pInc);
  L_Packet.trn_CloseFiles(nPack);
 END {MakeADV10};

 PRIVATE PROCEDURE MakeAttr(cat: tCategory;
                            adf: tAcntDataFraction;
                            ady: tAcntDataYear;
                            avp: L_Acnt.tAcntVectorPart): LIKE(PckAttr.Attr);
 BEGIN
  RETURN cat+L_Str.PoolItem(AcntDataFractionPool, adf)+
             L_Str.PoolItem(AcntDataYearPool, ady)+avp;
 END {MakeAttr};

 PRIVATE PROCEDURE get_AD(cat: tCategory;
                          adf: tAcntDataFraction;
                          ady: tAcntDataYear;
                          avp: L_Acnt.tAcntVectorPart): NUMERIC[2];
 BEGIN
  RETURN GetPckAttrAsNum(MakeAttr(cat, adf, ady, avp));
 END {get_AD};

 PRIVATE PROCEDURE add_AcntData(cat: tCategory;
                                Src: L_Acnt.tAcntVector;
                                adf: tAcntDataFraction;
                                ady: tAcntDataYear);
  VAR
   i: L_Acnt.tAcntVectorPart;
 BEGIN
  FOR_EACH i DO
   PutNumToPckAttr(MakeAttr(cat, adf, ady, i), Src[i]);
  END;
 END {add_AcntData};

 PRIVATE PROCEDURE get_AcntData(VAR Dst: L_Acnt.tAcntVector;
                                cat: tCategory;
                                adf: tAcntDataFraction;
                                ady: tAcntDataYear);
  VAR
   i: L_Acnt.tAcntVectorPart;
 BEGIN
  FOR_EACH i DO
   Dst[i]:=get_AD(cat, adf, ady, i);
  END;
 END {get_AcntData};

 PRIVATE PROCEDURE countADYEntries(cat: tCategory; avp: L_Acnt.tAcntVectorPart): NUMERIC[0];
 BEGIN
  RETURN
       ((get_AD(cat, adf_PFIn, ady_Previous, avp) # 0)|
        (get_AD(cat, adf_PFAc, ady_Previous, avp) # 0))+
       ((get_AD(cat, adf_PFIn, ady_Current,  avp) # 0)|
        (get_AD(cat, adf_PFAc, ady_Current,  avp) # 0))+
       ((get_AD(cat, adf_PFIn, ady_Next,     avp) # 0)|
        (get_AD(cat, adf_PFAc, ady_Next,     avp) # 0));
 END {countADYEntries};

 TYPE
  tAcntVector = NUMERIC[0][MAXOF(L_Acnt.tAcntVectorPart)+1]; (*祭  楫 㡫*)

 PRIVATE PROCEDURE CheckADV11Total(Prv, Cur, Nxt: tAcntVector; Name: STRING[]): SCAL[2];
  VAR
   Sum1,
   Sum2: L_XObj.tSum;
 BEGIN
  Sum1:=+ Prv[L_Acnt.avp_InSaldo]
        + Cur[L_Acnt.avp_InSaldo]
        + Cur[L_Acnt.avp_Credit]
        - Prv[L_Acnt.avp_Debit]
        - Cur[L_Acnt.avp_Debit];
  Sum2:=+ Prv[L_Acnt.avp_OutSaldo]
        + Cur[L_Acnt.avp_OutSaldo]
        + Nxt[L_Acnt.avp_OutSaldo];
  IF Sum1 # Sum2 THEN
   RETURN L_StdFrm.RedAlternative(" "+Name+":|'  砫 ਮ' + '᫥' - '㯫祭' ("+
                                  L_Packet.MoneyToIntTxt(Sum1)+")|"+
                                  "⢨⥫쭮  ࠢ '   ਮ' ("+
                                  L_Packet.MoneyToIntTxt(Sum2)+")?");
  ELSE
   RETURN 1;
  END;
 END {CheckADV11Total};

 PRIVATE PROCEDURE PrepareADV11Data(trgCategory: tCategory; TrfSign: STRING[1]; VAR gPackets, gItems: NUMERIC[0]);
  VAR
   xo_PFIn,
   xo_PFAc      : LIKE(XObject.XObject);
   PrvDummy_PFIn,
   PrvDummy_PFAc,
   CurDummy_PFIn,
   CurDummy_PFAc,
   NxtDummy_PFIn,
   NxtDummy_PFAc,
   TotDummy_PFIn,
   TotDummy_PFAc: tAcntVector;
   PrvYear,
   CurYear,
   NxtYear      : SCAL[1e4];
   _AcCut       : LIKE(AcCut.AcCut);
   Sum,
   _PFIn,
   _PFAc        : L_XObj.tSum;
   Msg          : STRING[];
 BEGIN
  SETEMPTY(xo_PFIn, xo_PFAc);
  IF (countADYEntries(trgCategory, L_Acnt.avp_InSaldo)  # 0) |
     (countADYEntries(trgCategory, L_Acnt.avp_Credit)   # 0) |
     (countADYEntries(trgCategory, L_Acnt.avp_Debit)    # 0) |
     (countADYEntries(trgCategory, L_Acnt.avp_OutSaldo) # 0) THEN
   Msg:="|஢ઠ/४஢ |";
   get_AcntData(PrvDummy_PFIn, trgCategory, adf_PFIn, ady_Previous);
   get_AcntData(CurDummy_PFIn, trgCategory, adf_PFIn, ady_Current);
   get_AcntData(NxtDummy_PFIn, trgCategory, adf_PFIn, ady_Next);
   get_AcntData(PrvDummy_PFAc, trgCategory, adf_PFAc, ady_Previous);
   get_AcntData(CurDummy_PFAc, trgCategory, adf_PFAc, ady_Current);
   get_AcntData(NxtDummy_PFAc, trgCategory, adf_PFAc, ady_Next);
  ELSE
   Msg:="";
   SETZERO(PrvDummy_PFIn, PrvDummy_PFAc,
           CurDummy_PFIn, CurDummy_PFAc,
           NxtDummy_PFIn, NxtDummy_PFAc);
   IF L_Pmnt.StandOnKnownContract(L_Packet.PckMyFirm, PerE, L_Pmnt.cf_PFIn) THEN
    xo_PFIn:=Contract.XObject;
   END;
   IF L_Pmnt.StandOnKnownContract(L_Packet.PckMyFirm, PerE, L_Pmnt.cf_PFAc) THEN
    xo_PFAc:=Contract.XObject;
   END;
   IF ~!xo_PFIn & ~!xo_PFAc THEN
    _AcCut:=L_AcCut.erkn_Get(SYSDATE(), L_AcCut.erkn_OnlineBalance);
    CurDummy_PFIn:=L_XObj.GetAcntVector(xo_PFIn,
                                        _AcCut,
                                        EMPTYOF(AcCut.AcCut),
                                        PerB, PerE);
    CurDummy_PFAc:=L_XObj.GetAcntVector(xo_PFAc,
                                        _AcCut,
                                        EMPTYOF(AcCut.AcCut),
                                        PerB, PerE);
    L_Acnt.av_ConvToExternal(CurDummy_PFIn);
    L_Acnt.av_ConvToExternal(CurDummy_PFAc);
   END;
   IF CurDummy_PFIn[L_Acnt.avp_InSaldo] > 0 THEN
    PrvDummy_PFIn[L_Acnt.avp_InSaldo]:=CurDummy_PFIn[L_Acnt.avp_InSaldo];
    CurDummy_PFIn[L_Acnt.avp_InSaldo]:=0;
    Sum:=Math.Min(PrvDummy_PFIn[L_Acnt.avp_InSaldo], CurDummy_PFIn[L_Acnt.avp_Debit]);
    INC(PrvDummy_PFIn[L_Acnt.avp_Debit], Sum);
    DEC(CurDummy_PFIn[L_Acnt.avp_Debit], Sum);
    IF PrvDummy_PFIn[L_Acnt.avp_Debit] < PrvDummy_PFIn[L_Acnt.avp_InSaldo] THEN
     Sum:=PrvDummy_PFIn[L_Acnt.avp_InSaldo]-PrvDummy_PFIn[L_Acnt.avp_Debit];
     INC(PrvDummy_PFIn[L_Acnt.avp_OutSaldo], Sum);
     DEC(CurDummy_PFIn[L_Acnt.avp_OutSaldo], Sum);
    END;
   END;
   IF CurDummy_PFAc[L_Acnt.avp_InSaldo] > 0 THEN
    PrvDummy_PFAc[L_Acnt.avp_InSaldo]:=CurDummy_PFAc[L_Acnt.avp_InSaldo];
    CurDummy_PFAc[L_Acnt.avp_InSaldo]:=0;
    Sum:=Math.Min(PrvDummy_PFAc[L_Acnt.avp_InSaldo], CurDummy_PFAc[L_Acnt.avp_Debit]);
    INC(PrvDummy_PFAc[L_Acnt.avp_Debit], Sum);
    DEC(CurDummy_PFAc[L_Acnt.avp_Debit], Sum);
    IF PrvDummy_PFAc[L_Acnt.avp_Debit] < PrvDummy_PFAc[L_Acnt.avp_InSaldo] THEN
     Sum:=PrvDummy_PFAc[L_Acnt.avp_InSaldo]-PrvDummy_PFAc[L_Acnt.avp_Debit];
     INC(PrvDummy_PFAc[L_Acnt.avp_OutSaldo], Sum);
     DEC(CurDummy_PFAc[L_Acnt.avp_OutSaldo], Sum);
    END;
   END;
   IF CurDummy_PFIn[L_Acnt.avp_OutSaldo] < 0 THEN
    NxtDummy_PFIn[L_Acnt.avp_OutSaldo]:=CurDummy_PFIn[L_Acnt.avp_OutSaldo];
    CurDummy_PFIn[L_Acnt.avp_OutSaldo]:=0;
   END;
   IF CurDummy_PFAc[L_Acnt.avp_OutSaldo] < 0 THEN
    NxtDummy_PFAc[L_Acnt.avp_OutSaldo]:=CurDummy_PFAc[L_Acnt.avp_OutSaldo];
    CurDummy_PFAc[L_Acnt.avp_OutSaldo]:=0;
   END;
  END;
  IF L_Packet.BuildMode = L_Packet.bm_byAll THEN
   SELECT(ADV10, ADV10_AM, , trgCategory);
   _PFIn:=GetADV10BySelectForADV10("_Pns2");
   _PFAc:=GetADV10BySelectForADV10("_Pns1");
   IF ~!xo_PFIn & ~!xo_PFAc THEN
    IF (_PFIn # CurDummy_PFIn[L_Acnt.avp_Credit]) | (_PFAc # CurDummy_PFAc[L_Acnt.avp_Credit]) THEN
     L_StdFrm.RedInform("!|"+
                        " ᮢ 㬬 ᫥   ࠬ ⮢     㬬  ᥬ 窠:|"+
                        "                          客   ⥫쭠 |"+
                        " ࠬ         "+FLDTOSTR(CurDummy_PFIn[L_Acnt.avp_Credit], "2-", 20)+" "+FLDTOSTR(CurDummy_PFAc[L_Acnt.avp_Credit], "2-", 20)+"|"+
                        "㬬  ᥬ 窠 "+FLDTOSTR(_PFIn, "2-", 20)+" "+FLDTOSTR(_PFAc, "2-", 20));
    END;
   END;
  END;
  CurYear:=Year;
  PrvYear:=CurYear-1;
  NxtYear:=CurYear+1;
  LOOP
   STDFORM(L_StdFrm.sf_Choice(Msg+
                              "|⢮ 祪  㬥⠬ -4-1  -4-2:        %#####%" +
                              "|᫮ 客 :                                %#####%" +
                              "| ⠢  ﭨ             %##########%" +
                              "|" +
                              "|  㯫   砫 ⭮ ਮ" +
                              "|" +
                              "|              客         ⥫  " +
                              "|%####% %##########################% %##########################%" +
                              "|%####% %##########################% %##########################%" +
                              "|"+
                              "|᫥   ⭮ ਮ" +
                              "|" +
                              "|  ..           客         ⥫  " +
                              "|  %#%  %##########################% %##########################%" +
                              "|" +
                              "|祭   ⭮ ਮ" +
                              "|" +
                              "|              客         ⥫  " +
                              "|%####% %##########################% %##########################%" +
                              "|%####% %##########################% %##########################%" +
                              "|" +
                              "|  㯫    ⭮ ਮ" +
                              "|" +
                              "|              客         ⥫  " +
                              "|%####% %##########################% %##########################%" +
                              "|%####% %##########################% %##########################%" +
                              "|%####% %##########################% %##########################%",
                              "%RI" +
                              "%RI" +
                              "%<D.N.y>I" +
                              "%RNI%RFI%RI" +
                              "%RNI%RI%RI" +
                              "%RNI%RI%RI" +
                              "%RNI%RI%RI" +
                              "%RNI%RI%RI" +
                              "%RNI%RI%RI" +
                              "%RNI%RI%RI" +
                              "%RNI%RI%RI"),
           " -11 ("+GetCategoryNick(trgCategory)+") ",
           ,
           -1,
           gPackets,
           gItems,
           L_Packet.ActualDate,
           PrvYear,
           PrvDummy_PFIn[L_Acnt.avp_InSaldo],
           PrvDummy_PFAc[L_Acnt.avp_InSaldo],
           CurYear,
           CurDummy_PFIn[L_Acnt.avp_InSaldo],
           CurDummy_PFAc[L_Acnt.avp_InSaldo],
           TrfSign,
           CurDummy_PFIn[L_Acnt.avp_Credit],
           CurDummy_PFAc[L_Acnt.avp_Credit],
           PrvYear,
           PrvDummy_PFIn[L_Acnt.avp_Debit],
           PrvDummy_PFAc[L_Acnt.avp_Debit],
           CurYear,
           CurDummy_PFIn[L_Acnt.avp_Debit],
           CurDummy_PFAc[L_Acnt.avp_Debit],
           PrvYear,
           PrvDummy_PFIn[L_Acnt.avp_OutSaldo],
           PrvDummy_PFAc[L_Acnt.avp_OutSaldo],
           CurYear,
           CurDummy_PFIn[L_Acnt.avp_OutSaldo],
           CurDummy_PFAc[L_Acnt.avp_OutSaldo],
           NxtYear,
           NxtDummy_PFIn[L_Acnt.avp_OutSaldo],
           NxtDummy_PFAc[L_Acnt.avp_OutSaldo]);
   IF CheckADV11Total(PrvDummy_PFIn, CurDummy_PFIn, NxtDummy_PFIn, "客 ") &
      CheckADV11Total(PrvDummy_PFAc, CurDummy_PFAc, NxtDummy_PFAc, "⥫쭠 ") THEN
    IF gPackets = 0 THEN
     IF L_StdFrm.RedAlternative(" 㫥 ⢮ 祪  ᢥﬨ  ⥣ਨ "+GetCategoryNick(trgCategory)+"|த?") THEN
      EXIT;
     END;
    ELSE
     EXIT;
    END;
   END;
  END;

  SETZERO(TotDummy_PFIn, TotDummy_PFAc);
  L_Acnt.av_Add(TotDummy_PFIn, PrvDummy_PFIn);
  L_Acnt.av_Add(TotDummy_PFAc, PrvDummy_PFAc);
  L_Acnt.av_Add(TotDummy_PFIn, CurDummy_PFIn);
  L_Acnt.av_Add(TotDummy_PFAc, CurDummy_PFAc);
  L_Acnt.av_Add(TotDummy_PFIn, NxtDummy_PFIn);
  L_Acnt.av_Add(TotDummy_PFAc, NxtDummy_PFAc);
  add_AcntData(trgCategory, PrvDummy_PFIn, adf_PFIn, ady_Previous);
  add_AcntData(trgCategory, PrvDummy_PFAc, adf_PFAc, ady_Previous);
  add_AcntData(trgCategory, CurDummy_PFIn, adf_PFIn, ady_Current);
  add_AcntData(trgCategory, CurDummy_PFAc, adf_PFAc, ady_Current);
  add_AcntData(trgCategory, NxtDummy_PFIn, adf_PFIn, ady_Next);
  add_AcntData(trgCategory, NxtDummy_PFAc, adf_PFAc, ady_Next);
  add_AcntData(trgCategory, TotDummy_PFIn, adf_PFIn, ady_Total);
  add_AcntData(trgCategory, TotDummy_PFAc, adf_PFAc, ady_Total);

  PutNumToPckAttr(trgCategory+patt_Packets, gPackets);
  PutNumToPckAttr(trgCategory+patt_Items,   gItems);
  PutDateToPckAttr(patt_ActualDate, L_Packet.ActualDate);
 END {PrepareADV11Data};

 PRIVATE PROCEDURE _trn_PutADYEntries(nParent: L_XML.tNode; NodeName: STRING[];
                                      cat: tCategory;
                                      ady: tAcntDataYear;
                                      avp: L_Acnt.tAcntVectorPart);
  VAR
   nSum   : L_XML.tNode;
   AD_PFIn,
   AD_PFAc: L_PRoll.tSum;
 BEGIN
  AD_PFIn:=get_AD(cat, adf_PFIn, ady, avp);
  AD_PFAc:=get_AD(cat, adf_PFAc, ady, avp);
  IF (AD_PFIn # 0) | (AD_PFAc # 0) | (ady = ady_Total) THEN
   nSum:=L_Packet.trn_PutNode(nParent, NodeName);
    L_Packet.trn_PutString(nSum, "ப", L_Str.PoolItem("|", ady = ady_Total));
    IF ady # ady_Total THEN
     L_Packet.trn_PutInt(nSum, "멏ਮ", Year+ady-ady_Current);
    END;
   trn_PutInsPrem(nSum, "客륂", AD_PFIn, AD_PFAc, 0);
  END;
 END {_trn_PutADYEntries};

 PRIVATE PROCEDURE trn_PutADYEntries(nParent: L_XML.tNode; NodeName: STRING[];
                                     cat: tCategory;
                                     avp: L_Acnt.tAcntVectorPart);
  VAR
   nSums: L_XML.tNode;
   count: NUMERIC[0];
 BEGIN
  nSums:=L_Packet.trn_PutNode(nParent, NodeName);
   count:=countADYEntries(cat, avp);
   IF count > 0 THEN
    INC(count);
   END;
   L_Packet.trn_PutInt(nSums, "⢮", count);
   _trn_PutADYEntries(nSums, "㬬ਮ", cat, ady_Previous, avp);
   _trn_PutADYEntries(nSums, "㬬ਮ", cat, ady_Current,  avp);
   _trn_PutADYEntries(nSums, "㬬ਮ", cat, ady_Next,     avp);
   IF count > 0 THEN
    _trn_PutADYEntries(nSums, "㬬ਮ", cat, ady_Total,    avp);
   END;
 END {trn_PutADYEntries};

 PRIVATE PROCEDURE MakeADV11();
  VAR
   curCategory: tCategory;
   Amount     : NUMERIC[0];
   gPackets,
   gItems     : NUMERIC[0];
   TrfSign    : STRING[1];
   av_Counter : L_Acnt.tAcntVector;
   nPack,
   nInvH,
   nDoc       : L_XML.tNode;
 BEGIN
  L_General.CallUs(SEARCH(Packet, Packet, PacketForADV1X));

  IF L_STx.E_ApplyRegressiveScale(PerB) THEN
   TrfSign:="";
  ELSE
   TrfSign:="";
  END;

  Amount:=0;
  FOR_EACH curCategory IN CategoryList() DO
   IF SELECT(ADV10, ADV10_AM) THEN
    IF SELECT(ADV10, ADV10_AM, curCategory) THEN
     INC(Amount);
     gPackets:=GetADV10BySelectForADV10("Packets");
     gItems  :=GetADV10BySelectForADV10("Items");
     PrepareADV11Data(curCategory, TrfSign, gPackets, gItems);
    END;
   ELSE
    INC(Amount);
    gPackets:=GetPckAttrAsNum(curCategory+patt_Packets);
    gItems  :=GetPckAttrAsNum(curCategory+patt_Items);
    PrepareADV11Data(curCategory, TrfSign, gPackets, gItems);
   END;
  END; (* FOR_EACH curCategory ... *)
  L_General.Assert(Amount <= 1,
                   "     ⥣ਨ ࠡ⭨");
 
  L_Packet.trn_OpenFiles();
  nPack:=L_Packet.trn_PutHead();
  nInvH:=L_Packet.trn_PutInventoryHead(nPack, "_", trn_PckKind(), Amount);

  L_Packet.MakeADV61forADV11();

  FORMFEED(R);
  InitPrintAttr(R, Duplex, Off);

  Amount:=0;
  FOR_EACH curCategory IN CategoryList() DO
   IF ~!L_Packet.GetPacketAttr(Packet.Packet, curCategory+patt_Packets) THEN
    gPackets:=GetPckAttrAsNum(curCategory+patt_Packets);
    gItems  :=GetPckAttrAsNum(curCategory+patt_Items);
    INC(Amount);
    nDoc:=L_Packet.trn_PutAbstractDoc(nPack, trn_PckKind(), Amount+1);
    L_Packet.trn_PutOwnFirm(nDoc, "客⥫");
    L_Packet.trn_PutInt(nDoc, "멏ਮ", Year);
    L_Packet.trn_PutDate(nDoc, "⠂", L_Packet.ActualDate);
    L_Packet.trn_PutString(nDoc, "-11", L_Str.PoolItem("|", PerE = L_DatTim.YearEnd(PerE)));
    L_Packet.trn_PutInt(nDoc, "᫮祪", gPackets);
    L_Packet.trn_PutInt(nDoc, "᫮客勨", gItems);
    trn_PutTariff(nDoc, "", curCategory);

    trn_PutADYEntries(nDoc, "썠砫", curCategory, L_Acnt.avp_InSaldo);

    L_Packet.trn_PutString(nDoc, "ਧ", TrfSign);
    trn_PutInsPrem(nDoc, "᫥ਮ", get_AD(curCategory, adf_PFIn, ady_Total, L_Acnt.avp_Credit),
                                               get_AD(curCategory, adf_PFAc, ady_Total, L_Acnt.avp_Credit),
                                               0);

    trn_PutADYEntries(nDoc, "⠇ਮ", curCategory, L_Acnt.avp_Debit);
    trn_PutADYEntries(nDoc, "썠", curCategory, L_Acnt.avp_OutSaldo);

    L_Packet.trn_PutDate(nDoc, "⠇", L_Packet.PrepareDate);

    MAKEPART(R, ADV11_4_00_1,
             L_Str.IntStr(Amount),
             L_Str.IntStr(gPackets), L_Str.IntStr(gItems),
             GetCategoryNick(curCategory),
             Year-1,
             MoneyToIntTxt(get_AD(curCategory, adf_PFIn, ady_Previous, L_Acnt.avp_InSaldo)),
             MoneyToIntTxt(get_AD(curCategory, adf_PFAc, ady_Previous, L_Acnt.avp_InSaldo)),
             Year,
             MoneyToIntTxt(get_AD(curCategory, adf_PFIn, ady_Current,  L_Acnt.avp_InSaldo)),
             MoneyToIntTxt(get_AD(curCategory, adf_PFAc, ady_Current,  L_Acnt.avp_InSaldo)),
             MoneyToIntTxt(get_AD(curCategory, adf_PFIn, ady_Total,    L_Acnt.avp_InSaldo)),
             MoneyToIntTxt(get_AD(curCategory, adf_PFAc, ady_Total,    L_Acnt.avp_InSaldo)),
             TrfSign,
             MoneyToIntTxt(get_AD(curCategory, adf_PFIn, ady_Total,    L_Acnt.avp_Credit)),
             MoneyToIntTxt(get_AD(curCategory, adf_PFAc, ady_Total,    L_Acnt.avp_Credit)),
             Year-1,
             MoneyToIntTxt(get_AD(curCategory, adf_PFIn, ady_Previous, L_Acnt.avp_Debit)),
             MoneyToIntTxt(get_AD(curCategory, adf_PFAc, ady_Previous, L_Acnt.avp_Debit)),
             Year,
             MoneyToIntTxt(get_AD(curCategory, adf_PFIn, ady_Current,  L_Acnt.avp_Debit)),
             MoneyToIntTxt(get_AD(curCategory, adf_PFAc, ady_Current,  L_Acnt.avp_Debit)),
             MoneyToIntTxt(get_AD(curCategory, adf_PFIn, ady_Total,    L_Acnt.avp_Debit)),
             MoneyToIntTxt(get_AD(curCategory, adf_PFAc, ady_Total,    L_Acnt.avp_Debit)),
             Year-1,
             MoneyToIntTxt(get_AD(curCategory, adf_PFIn, ady_Previous, L_Acnt.avp_OutSaldo)),
             MoneyToIntTxt(get_AD(curCategory, adf_PFAc, ady_Previous, L_Acnt.avp_OutSaldo)),
             Year,
             MoneyToIntTxt(get_AD(curCategory, adf_PFIn, ady_Current,  L_Acnt.avp_OutSaldo)),
             MoneyToIntTxt(get_AD(curCategory, adf_PFAc, ady_Current,  L_Acnt.avp_OutSaldo)),
             Year+1,
             MoneyToIntTxt(get_AD(curCategory, adf_PFIn, ady_Next,     L_Acnt.avp_OutSaldo)),
             MoneyToIntTxt(get_AD(curCategory, adf_PFAc, ady_Next,     L_Acnt.avp_OutSaldo)),
             MoneyToIntTxt(get_AD(curCategory, adf_PFIn, ady_Total,    L_Acnt.avp_OutSaldo)),
             MoneyToIntTxt(get_AD(curCategory, adf_PFAc, ady_Total,    L_Acnt.avp_OutSaldo)));
    FORMFEED(R);
   END;
  END; (* FOR_EACH curCategory ... *)

  SETEMPTY(pSum1, pSum2, pInc);
  L_Packet.trn_CloseFiles(nPack);
 END {MakeADV11};

 PRIVATE PROCEDURE AddPkIdx(trgCategory: tCategory; trgCntrType: L_Packet.tCntrType);
 BEGIN
  IF ~ADD(PkIdx, PkIdx, Packet.PerB, Packet.PerE, PckBody.Man, trgCategory, trgCntrType) |
      (PkIdx.DTStamp <= Packet.DTStamp) THEN
   L_General.CallUs(PkIdx.DTStamp # Packet.DTStamp); (* 0098850 .5.1 20.08.2013 15:53:54 POLAK\Bor *)
   PkIdx.Packet :=Packet.Packet;
   PkIdx.SeqNbr :=PckBody.SeqNbr;
   PkIdx.DTStamp:=Packet.DTStamp;
   REPLACE(PkIdx);
  END;
 END {AddPkIdx};

 PRIVATE PROCEDURE intMakePckIndex(Begin, Till: DATE; trgMan: LIKE(Man.Man));
  VAR
   prvPerB,
   prvPerE    : DATE;
   curCategory: tCategory;
 BEGIN
  APP.Get().NewPrompt(" ᤠ ᢥ");
  SETSEL(PkIdx, PkIdx); REMSEL(PkIdx);

  chkPkIdxMan   :=trgMan;
  chkPkIdxTill  :=Till;
  chkPkIdxMyFirm:=L_Packet.PckMyFirm;

  SAVE(Packet);
  SAVE(PckBody);
  prvPerE:=Till-1;
  prvPerB:=L_Packet.Get_PF_StdPerB(prvPerE);
  WHILE prvPerE > Begin DO
   PROMPT(L_DatTim.PeriodStr(prvPerB)+"-"+L_DatTim.PeriodStr(prvPerE));
   SETSEL(Packet, PacketEN, L_Packet.rcv_PensFund, prvPerB, prvPerE);
   FOR_EACH Packet DO
    IF ((Packet.Kind = L_Packet.knd_PF_SZV6_4) |
        (Packet.Kind = L_Packet.knd_PF_SZV6)   |
        (Packet.Kind = L_Packet.knd_PF_RSV1_6)) &
       L_Packet.IsValidPacket() THEN
     IF ~!trgMan THEN
      IF SEARCH(PckBody, Man, trgMan, Packet.Packet) THEN
       AddPkIdx(GetPacketCategoryFromAttr(Packet.Packet), GetPacketCntrTypeFromAttr(Packet.Packet, trgMan));
      END;
     ELSE
      curCategory:=GetPacketCategoryFromAttr(Packet.Packet);
      SETSEL(PckBody, Packet, Packet.Packet);
      FOR_EACH PckBody DO
       AddPkIdx(curCategory, GetPacketCntrTypeFromAttr(Packet.Packet, PckBody.Man));
      END; (* FOR_EACH PckBody *)
     END; (* IF ~!trgMan ... *)
    END; (* IF L_Packet.IsAcceptablePacket() ... *)
   END; (* FOR_EACH Packet *)
   L_Packet.Get_PF_PrvPer(prvPerB, prvPerE);
  END; (* WHILE prvPerB > ... *)
  RESTORE(PckBody);
  RESTORE(Packet);
 END {intMakePckIndex};

 PRIVATE PROCEDURE MakePckIndex(Till: DATE; trgMan: LIKE(Man.Man));
 BEGIN
  intMakePckIndex(01\01\2010, Till, trgMan);
 END {MakePckIndex};

 PRIVATE PROCEDURE GetPckBodyAttrAsSum(trgPacket: LIKE(PckBody.Packet);
                                       trgSeqNbr: LIKE(PckBody.SeqNbr);
                                       trgAttr  : LIKE(PckAttr.Attr)): L_XObj.tSum;
 BEGIN
  IF SEARCH(PckAttr, PckBody, trgPacket, trgSeqNbr, trgAttr) THEN
   RETURN STRTOFLD(PckAttr.Value, NUMERIC);
  ELSE
   RETURN 0;
  END;
 END {GetPckBodyAttrAsSum};

 PRIVATE PROCEDURE GetCurPckIdxPerIncPaid(VAR trgInc, trgPaid: tPFSum);
 BEGIN
  L_General.CallUs(~!L_Packet.GetPckBodyAttr(PkIdx.Packet, PkIdx.SeqNbr, patt_CurInc[tp_PFIn]));
  trgInc [tp_PFIn]:=GetPckBodyAttrAsSum(PkIdx.Packet, PkIdx.SeqNbr, patt_CurInc [tp_PFIn]);
  trgPaid[tp_PFIn]:=GetPckBodyAttrAsSum(PkIdx.Packet, PkIdx.SeqNbr, patt_CurPaid[tp_PFIn]);
  trgInc [tp_PFAc]:=GetPckBodyAttrAsSum(PkIdx.Packet, PkIdx.SeqNbr, patt_CurInc [tp_PFAc]);
  trgPaid[tp_PFAc]:=GetPckBodyAttrAsSum(PkIdx.Packet, PkIdx.SeqNbr, patt_CurPaid[tp_PFAc]);
 END {GetCurPckIdxPerIncPaid};

 PRIVATE PROCEDURE StandOnPkIdx(trgPerB,
                                trgPerE    : DATE;
                                trgCategory: tCategory;
                                trgCntrType: L_Packet.tCntrType;
                                trgMan     : LIKE(Man.Man)): SCAL[2];
 BEGIN
  L_General.CallUs(!chkPkIdxMan | (chkPkIdxMan = trgMan));
  L_General.CallUs(chkPkIdxTill > trgPerE);
  L_General.CallUs(chkPkIdxMyFirm = L_Packet.PckMyFirm);
  RETURN SEARCH(PkIdx, PkIdx, trgPerB, trgPerE, trgMan, trgCategory, trgCntrType);
 END {StandOnPkIdx};

 PRIVATE PROCEDURE PrepareCnTpP(trgMan: LIKE(Man.Man));
  VAR
   D,
   P: DATE;
 BEGIN
  SELECT(Staff, MyFirm, , L_Packet.PckMyFirm, trgMan);
  WHILE OCCURE(Staff) DO
   IF (Staff.BegDate <= PerE) & GoodTSN(PerB, PerE, 1, 1) THEN
    D:=Math.Max(PerB, Staff.BegDate);
    SETSEL(StaffLog, TSN, Staff.TSN);
    SRCINSEL(StaffLog, LE, , D);
    WHILE OCCURE(StaffLog) & (StaffLog.Date <= PerE) DO
     IF ~L_Staff.IsDischargeStaffLog() THEN
      P:=L_DatTim.Per(Math.Max(PerB, StaffLog.Date));
      WHILE (P<=PerE) & (P<=StaffLog.DateE) DO
       ADD(CnTpP, CnTpP, , Staff.Man, GetStaffCntrType(P), P);
       P:=L_DatTim.NextPer(P);
      END;
     END; (* IF ~L_Staff.IsDischargeStaffLog() ... *)
     NEXT(StaffLog);
    END; (* WHILE OCCURE(StaffLog) ... *)
   END;
   NEXT(Staff);
  END; (* WHILE OCCURE(Staff) ... *)
 END {PrepareCnTpP};

 PRIVATE PROCEDURE PrepareCnTpP_byPacket();
 BEGIN
  APP.Get().NewPrompt("  ஢");
  SELECT(PckBody, Packet, , Packet.Packet);
  WHILE OCCURE(PckBody) DO
   PrepareCnTpP(PckBody.Man);
   NEXT(PckBody);
  END; (* WHILE OCCURE(PckBody) ... *)
 END {PrepareCnTpP_byPacket};

 PRIVATE PROCEDURE PrepareCnTpP_byAll();
 BEGIN
  APP.Get().NewPrompt("  ஢");
  SETSEL(CnTpP, CnTpP); REMSEL(CnTpP);
  SELECT(Man, rsMan, , 1);
  WHILE OCCURE(Man) DO
   PrepareCnTpP(Man.Man);
   NEXT(Man);
  END; (* WHILE OCCURE(Man) ... *)
 END {PrepareCnTpP_byAll};

 PRIVATE PROCEDURE GetPerIncPaid(    trgPerB,
                                     trgPerE    : DATE;
                                     trgCategory: tCategory;
                                     trgCntrType: L_Packet.tCntrType;
                                     trgMan     : LIKE(Man.Man);
                                 VAR trgInc,
                                     trgPaid    : tPFSum);
 BEGIN
  IF StandOnPkIdx(trgPerB, trgPerE, trgCategory, trgCntrType, trgMan) THEN
   GetCurPckIdxPerIncPaid(trgInc, trgPaid);
  ELSE
   SETZERO(trgInc, trgPaid);
  END;
 END {GetPerIncPaid};

 PRIVATE PROCEDURE GetStdPerE(curPerB: DATE): DATE;
 BEGIN
  IF curPerB >= 01\01\2011 THEN
   RETURN L_DatTim.GetLastDateOfQuartal(curPerB);
  ELSE
   RETURN L_DatTim.GetLastDateOfQuartal(L_DatTim.GetLastDateOfQuartal(curPerB)+1);
  END;
 END {GetStdPerE};

 PRIVATE PROCEDURE GetNxtPer(curPerB: DATE; VAR nxtPerB, nxtPerE: DATE);
 BEGIN
  nxtPerB:=GetStdPerE(curPerB)+1;
  nxtPerE:=GetStdPerE(nxtPerB);
 END {GetNxtPer};

 PRIVATE PROCEDURE GetPrvPerIncPaid(trgCategory: tCategory;
                                    trgCntrType: L_Packet.tCntrType;
                                    trgMan: LIKE(Man.Man);
                                    VAR prvInc,
                                        prvPaid: tPFSum);
  VAR
   curInc,
   curPaid: tPFSum;
   prvPerB,
   prvPerE: DATE;
 BEGIN
  SETZERO(prvInc, prvPaid);
  prvPerB:=PerB;
  prvPerE:=PerE;
  WHILE prvPerB > 01\01\2010 DO
   L_Packet.Get_PF_PrvPer(prvPerB, prvPerE);
   GetPerIncPaid(prvPerB, prvPerE, trgCategory, trgCntrType, trgMan, curInc, curPaid);
   PFSumINC(prvInc,  curInc);
   PFSumINC(prvPaid, curPaid);
  END;
 END {GetPrvPerIncPaid};

 PRIVATE PROCEDURE intPrepareTmpIncPaidOneMan(trgCategory: tCategory;
                                              trgCntrType: L_Packet.tCntrType;
                                              curPerB,
                                              curPerE: DATE;
                                              VAR TotPrvInc,
                                                  TotPrvPaid,
                                                  TotCurInc,
                                                  TotOldPaid: tPFSum;
                                              WithOld: SCAL[2]);
  VAR
   HasPrv,
   HasCur,
   HasOld : SCAL[2];
   OldInc,
   OldPaid,
   PrvInc,
   PrvPaid,
   CurInc : tPFSum;
   P      : DATE;
 BEGIN
  GetPrvPerIncPaid(trgCategory, trgCntrType, Man.Man, PrvInc, PrvPaid);
  HasPrv:=~PFSumIsZERO(PFSumSUB(PrvInc, PrvPaid));

  IF WithOld THEN
   GetPerIncPaid(curPerB, GetStdPerE(curPerB), trgCategory, trgCntrType, Man.Man, OldInc, OldPaid); (*GetStdPerE() -  -1 0098528 31.07.2013 19:20:55 POLAK\Bor*)
  ELSE
   SETZERO(OldInc, OldPaid);
  END;

  CurInc:=intGetPFSumForPer(trgCategory, trgCntrType, curPerB, curPerE);
  HasCur:=~PFSumIsZERO(CurInc);
  HasOld:=~PFSumIsZERO(OldInc) | ~PFSumIsZERO(OldPaid);
  IF HasPrv | HasCur | HasOld THEN
   L_General.CLEAR("TmpIP");
   TmpIP.Man     :=Man.Man;
   TmpIP.Category:=trgCategory;
   TmpIP.CntrType:=trgCntrType;
   TmpIP.PrvOnly :=~HasCur;
   TmpIP.PrvInc  :=PrvInc;
   TmpIP.PrvPaid :=PrvPaid;
   TmpIP.CurInc  :=CurInc;
   TmpIP.OldInc  :=OldInc;
   TmpIP.OldPaid :=OldPaid;
   SETZERO(TmpIP.CurPaid);
   INSERT(TmpIP);
  END;
  PFSumINC(TotPrvInc,  PrvInc);
  PFSumINC(TotPrvPaid, PrvPaid);
  PFSumINC(TotCurInc,  CurInc);
  PFSumINC(TotOldPaid, OldPaid);
 END {intPrepareTmpIncPaidOneMan};

 PRIVATE PROCEDURE PrepareTmpIncPaid(VAR TotPrvInc, TotPrvPaid, TotCurInc: tPFSum);
  VAR
   Dummy: tPFSum;
   curCategory: tCategory;
   curCntrType: L_Packet.tCntrType;
 BEGIN
  APP.Get().NewPrompt(" ᫥  㯫祭 ");
  MakePckIndex(PerB, EMPTYOF(Man.Man));
  SETZERO(TotPrvInc, TotPrvPaid, TotCurInc);
  SELECT(Man, rsMan, , 1);
  WHILE OCCURE(Man) DO
   SAVE(Man);
   PROMPT(" "+Man.Man);
   SETZERO(Dummy);
   FOR_EACH curCategory IN CategoryList() DO
    FOR_EACH curCntrType DO
     intPrepareTmpIncPaidOneMan(curCategory, curCntrType, PerB, PerE, TotPrvInc, TotPrvPaid, TotCurInc, Dummy, 0);
    END;
   END;
   L_General.CallUs(PFSumIsZERO(Dummy));
   RESTORE(Man);
   NEXT(Man);
  END; (* WHILE OCCURE(Man) ... *)
 END {PrepareTmpIncPaid};

 PRIVATE PROCEDURE PrepareTmpIncPaidByPacket(VAR TotPrvInc, TotPrvPaid, TotCurInc, TotOldPaid: tPFSum);
  VAR
   curPerB,
   curPerE: DATE;
   curCategory: tCategory;
   curCntrType: L_Packet.tCntrType;
 BEGIN
  APP.Get().NewPrompt(" ᫥  㯫祭 ");
  CONFORM(Packet, PckBody);
  WHILE OCCURE(PckBody) DO
   PROMPT(" "+PckBody.Man);
   CONFORM(PckBody, Man);
   IF ~SELECT(TmpIP, Man, PckBody.Man) THEN (* ந஢  㣮 *)
    curPerB:=PerBMoney(GetManPerB());
    curPerE:=PerEMoney(GetManPerE());
    MakePckIndex(GetStdPerE(PerB)+1, PckBody.Man);
    FOR_EACH curCategory IN CategoryList() DO
     FOR_EACH curCntrType DO
      intPrepareTmpIncPaidOneMan(curCategory, curCntrType, curPerB, curPerE, TotPrvInc, TotPrvPaid, TotCurInc, TotOldPaid, 1);
     END;
    END;
   END;
   NEXT(PckBody);
  END; (* WHILE OCCURE(PckBody) ... *)
 END {PrepareTmpIncPaidByPacket};

 PRIVATE PROCEDURE PrepareTmpIncPaidByTmpCP(VAR TotPrvInc, TotPrvPaid, TotCurInc, TotOldPaid: tPFSum);
  VAR
   curPerB,
   curPerE: DATE;
   curCategory: tCategory;
   curCntrType: L_Packet.tCntrType;
 BEGIN
  APP.Get().NewPrompt(" ᫥  㯫祭 ");
  PROMPT(" "+TmpCP.Man);
  SEARCH(Man, Man, , TmpCP.Man);
  L_General.CallUs(~SELECT(TmpIP, Man, TmpCP.Man));
  MakePckIndex(GetStdPerE(PerB)+1, TmpCP.Man);
  FOR_EACH curCategory IN CategoryList() DO
   FOR_EACH curCntrType DO
    intPrepareTmpIncPaidOneMan(curCategory, curCntrType, TmpCP.PerB, TmpCP.PerE, TotPrvInc, TotPrvPaid, TotCurInc, TotOldPaid, 1);
   END;
  END;
 END {PrepareTmpIncPaidByTmpCP};

 PRIVATE PROCEDURE HasPaidDebts(): SCAL[2];
 BEGIN
  IF IsSince2010() THEN
   SELECT(TmpIP, Man, , Man.Man);
   WHILE OCCURE(TmpIP) DO
    IF ~PFSumIsZERO(TmpIP.CurPaid) | ~PFSumIsZERO(TmpIP.OldInc) | ~PFSumIsZERO(TmpIP.OldPaid) THEN
     RETURN 1;
    END;
    NEXT(TmpIP);
   END; (* WHILE OCCURE(TmpIP) ... *)
  END;
  RETURN 0;
 END {HasPaidDebts};

 PRIVATE PROCEDURE CalcOver(PrvOver, PrvInc, PrvPaid, CurInc, CurPaid: tPFSum): tPFSum;
  VAR
   CurOver: tPFSum;
 BEGIN
  SETZERO(CurOver);
  PFSumINC(CurOver, PrvOver);
  PFSumINC(CurOver, PrvPaid);
  PFSumINC(CurOver, CurPaid);
  PFSumDEC(CurOver, PrvInc);
  PFSumDEC(CurOver, CurInc);

  IF CurOver[tp_PFIn] < 0 THEN
   CurOver[tp_PFIn]:=0;
  END;
  IF CurOver[tp_PFAc] < 0 THEN
   CurOver[tp_PFAc]:=0;
  END;
  RETURN CurOver;
 END {CalcOver};

 PRIVATE PROCEDURE intGetUnPaidCoef(UnPaid, Paid: L_PRoll.tSum): tCoefIncPaidElm;
 BEGIN
  IF    UnPaid <= Paid THEN
   RETURN 1;
  ELSIF UnPaid # 0 THEN
   RETURN Paid / UnPaid;
  ELSE
   RETURN 0;
  END;
 END {intGetUnPaidCoef};

 PRIVATE PROCEDURE GetUnPaidCoef(UnPaid, Paid: tPFSum): tCoefIncPaid;
  VAR
   Result: tCoefIncPaid;
 BEGIN
  Result[tp_PFIn]:=intGetUnPaidCoef(UnPaid[tp_PFIn], Paid[tp_PFIn]);
  Result[tp_PFAc]:=intGetUnPaidCoef(UnPaid[tp_PFAc], Paid[tp_PFAc]);
  RETURN Result;
 END {GetUnPaidCoef};

 PRIVATE PROCEDURE DistributeTmpIPPaid(    trgPrvOnly: SCAL[2];
                                           IsPrvStage: SCAL[2];
                                           UnPaidToDistr: tPFSum;
                                       VAR TotPrvPaid,
                                           TotCurPaid: tPFSum);
  VAR
   CoefPaid      : tCoefIncPaid;
   curUnPaid,
   curPaid,
   totSumToDistr,
   totPaidToDistr: tPFSum;
   PFPart: tPFPart;
 BEGIN
  APP.Get().NewPrompt("। '祭'");
  CoefPaid:=GetUnPaidCoef(UnPaidToDistr, TotCurPaid);
  FOR_EACH PFPart DO
   totSumToDistr[PFPart]:=Math.Min(UnPaidToDistr[PFPart], TotCurPaid[PFPart]);
  END; (* FOR_EACH PFPart ... *)

  SELECT(TmpIP, PrvOnly, , trgPrvOnly);
  WHILE OCCURE(TmpIP) DO
   PROMPT(" "+TmpIP.Man);

   SETZERO(curUnPaid);
   PFSumINC(curUnPaid, TmpIP.PrvInc);
   PFSumDEC(curUnPaid, TmpIP.PrvPaid);
   IF ~IsPrvStage THEN
    PFSumINC(curUnPaid, TmpIP.CurInc);
    PFSumDEC(curUnPaid, TmpIP.CurPaid);
   END;
   curPaid:=GetPaidFromInc(curUnPaid, CoefPaid);
   PFSumINC(TmpIP.CurPaid, curPaid);
   REPLACE(TmpIP);

   PFSumDEC(TotCurPaid, curPaid);
   IF IsPrvStage THEN
    PFSumINC(TotPrvPaid, curPaid);
   END;
   PFSumDEC(totSumToDistr, curPaid);
   NEXT(TmpIP);
  END; (* WHILE OCCURE(TmpIP) ... *)

  IF ~PFSumIsZERO(totSumToDistr) THEN
   FIRST(TmpIP);
   WHILE OCCURE(TmpIP) & ~PFSumIsZERO(totSumToDistr) DO
    SETZERO(curUnPaid);
    PFSumINC(curUnPaid, TmpIP.PrvInc);
    PFSumDEC(curUnPaid, TmpIP.PrvPaid);
    IF ~IsPrvStage THEN
     PFSumINC(curUnPaid, TmpIP.CurInc);
     PFSumDEC(curUnPaid, TmpIP.CurPaid);
    END;
    FOR_EACH PFPart DO
     IF    ((totSumToDistr[PFPart] > 0) & (curUnPaid[PFPart] >= totSumToDistr[PFPart])) |
           ((totSumToDistr[PFPart] < 0) & (TmpIP.CurPaid[PFPart] >= (-totSumToDistr[PFPart]))) THEN
      INC(TmpIP.CurPaid[PFPart], totSumToDistr[PFPart]);
      REPLACE(TmpIP);
      DEC(TotCurPaid[PFPart], totSumToDistr[PFPart]);
      totSumToDistr[PFPart]:=0;
     END;
    END; (* FOR_EACH PFPart ... *)
    NEXT(TmpIP);
   END; (* WHILE OCCURE(TmpIP) ... *)
   L_General.CallUs(PFSumIsZERO(totSumToDistr));
  END;
 END {DistributeTmpIPPaid};

 PRIVATE PROCEDURE intCalculateCurPaidByPrvInc(    trgPrvOnly: SCAL[2];
                                               VAR TotPrvInc,
                                                   TotPrvPaid,
                                                   TotCurPaid: tPFSum);
  VAR
   PrvTotUnPaid: tPFSum;
 BEGIN
  IF ~PFSumIsZERO(TotCurPaid) THEN
   APP.Get().NewPrompt("祭   ਮ");
   SETZERO(PrvTotUnPaid);
   SELECT(TmpIP, PrvOnly, , trgPrvOnly);
   WHILE OCCURE(TmpIP) DO
    PROMPT(" "+TmpIP.Man);
    PFSumINC(PrvTotUnPaid, PFSumSUB(TmpIP.PrvInc, TmpIP.PrvPaid));
    NEXT(TmpIP);
   END; (* WHILE OCCURE(TmpIP) ... *)

   DistributeTmpIPPaid(trgPrvOnly, 1, PrvTotUnPaid, TotPrvPaid, TotCurPaid);
  END;
 END {intCalculateCurPaidByPrvInc};

 PRIVATE PROCEDURE CalculateCurPaid(TotPrvInc, TotPrvPaid, TotCurInc, TotCurPaid: tPFSum);
  VAR
   CurTotUnPaid: tPFSum;
 BEGIN
  IF (TotPrvPaid[tp_PFIn] < TotPrvInc[tp_PFIn]) |
     (TotPrvPaid[tp_PFAc] < TotPrvInc[tp_PFAc]) THEN
   intCalculateCurPaidByPrvInc(1, TotPrvInc, TotPrvPaid, TotCurPaid);
   intCalculateCurPaidByPrvInc(0, TotPrvInc, TotPrvPaid, TotCurPaid);
  END;

  IF (TotCurPaid[tp_PFIn] > 0) | (TotCurPaid[tp_PFAc] > 0) THEN
   SETZERO(CurTotUnPaid);
   PFSumINC(CurTotUnPaid, TotPrvInc);
   PFSumINC(CurTotUnPaid, TotCurInc);
   PFSumDEC(CurTotUnPaid, TotPrvPaid);

   DistributeTmpIPPaid(0, 0, CurTotUnPaid, TotPrvPaid, TotCurPaid);
  END;
  L_General.CallUs(PFSumIsZERO(TotCurPaid));
 END {CalculateCurPaid};

 PRIVATE PROCEDURE PreparePaidDataForAll(corrPrvOver: tPFSum);
  CONST
   ch_Ok        = 1;
   ch_Recalc    = 2;
  VAR
   curContract  : LIKE(Contract.Contract);
   xo_PFIn,
   xo_PFAc      : LIKE(XObject.XObject);
   CurDummy_PFIn,
   CurDummy_PFAc: L_Acnt.tAcntVector;
   obAcCut      : LIKE(AcCut.AcCut);
   PFIn,
   PFAc         : L_XObj.tSum;
   TotPrvOver,
   TotCurOver,
   TotPrvInc,
   tmpTotPrvPaid,
   TotPrvPaid,
   TotCurInc,
   TotCurPaid   : tPFSum;
   prvOverStr   : STRING[];
   Choice       : SCAL[3];
 BEGIN
  L_General.CallUs(L_Packet.BuildMode # L_Packet.bm_byPacket);
  IF IsSince2010() THEN
   PrepareTmpIncPaid(TotPrvInc, TotPrvPaid, TotCurInc);
   SETZERO(TotCurPaid);
 
   SETEMPTY(xo_PFIn, xo_PFAc);
   SETZERO(CurDummy_PFIn, CurDummy_PFAc);
   curContract:=L_Cntr.erkn_GetSoft(PerE, L_Cntr.erkn_TAF_PFIn, L_Packet.PckMyFirm);
   IF ~!curContract THEN
    SEARCH(Contract, Contract, , curContract);
    xo_PFIn:=Contract.XObject;
   END;
   curContract:=L_Cntr.erkn_GetSoft(PerE, L_Cntr.erkn_TAF_PFAc, L_Packet.PckMyFirm);
   IF ~!curContract THEN
    SEARCH(Contract, Contract, , curContract);
    xo_PFAc:=Contract.XObject;
   END;
   IF ~!xo_PFIn & ~!xo_PFAc THEN
    obAcCut:=L_AcCut.erkn_Get(SYSDATE(), L_AcCut.erkn_OnlineBalance);
    CurDummy_PFIn:=L_XObj.GetAcntVector(xo_PFIn,
                                        obAcCut,
                                        EMPTYOF(AcCut.AcCut),
                                        PerB, PerE);
    CurDummy_PFAc:=L_XObj.GetAcntVector(xo_PFAc,
                                        obAcCut,
                                        EMPTYOF(AcCut.AcCut),
                                        PerB, PerE);
    IF (TotCurInc[tp_PFIn] # CurDummy_PFIn[L_Acnt.avp_Credit]) |
       (TotCurInc[tp_PFAc] # CurDummy_PFAc[L_Acnt.avp_Credit]) THEN
     L_StdFrm.RedInform("!|"+
                        " ᮢ 㬬 ᫥   ࠬ ⮢     㬬  ᥬ 窠:|"+
                        "                          客   ⥫쭠 |"+
                        " ࠬ         "+FLDTOSTR(CurDummy_PFIn[L_Acnt.avp_Credit], "2-", 20)+" "+FLDTOSTR(CurDummy_PFAc[L_Acnt.avp_Credit], "2-", 20)+"|"+
                        "㬬  ᥬ 窠 "+FLDTOSTR(TotCurInc[tp_PFIn], "2-", 20)+" "+FLDTOSTR(TotCurInc[tp_PFAc], "2-", 20));
    END;
    TotCurPaid[tp_PFIn]:=CurDummy_PFIn[L_Acnt.avp_Debit];
    TotCurPaid[tp_PFAc]:=CurDummy_PFAc[L_Acnt.avp_Debit];
    TotPrvOver[tp_PFIn]:=CurDummy_PFIn[L_Acnt.avp_InSaldo];
    TotPrvOver[tp_PFAc]:=CurDummy_PFAc[L_Acnt.avp_InSaldo];
    IF ~IsSince2012() THEN
     TotCurPaid[tp_PFIn]:=Math.Round(TotCurPaid[tp_PFIn], 1);
     TotCurPaid[tp_PFAc]:=Math.Round(TotCurPaid[tp_PFAc], 1);
     TotPrvOver[tp_PFIn]:=Math.Round(TotPrvOver[tp_PFIn], 1);
     TotPrvOver[tp_PFAc]:=Math.Round(TotPrvOver[tp_PFAc], 1);
    END;
   ELSE
    TotPrvOver:=PFSumSUB(TotPrvPaid, TotPrvInc);
   END;

   prvOverStr:="";
   IF TotPrvOver[tp_PFIn] < 0 THEN
    TotPrvOver[tp_PFIn]:=0;
    prvOverStr:="%RNI";
   ELSE
    prvOverStr:="%RI";
   END;
   IF TotPrvOver[tp_PFAc] < 0 THEN
    TotPrvOver[tp_PFAc]:=0;
    INC(prvOverStr, "%RNI");
   ELSE
    INC(prvOverStr, "%RI");
   END;

   PFSumINC(TotPrvOver, corrPrvOver);

   LOOP
    Choice:=ch_Recalc; (* ९ ⥪饣 ਮ*)
    LOOP
     TotCurOver:=CalcOver(TotPrvOver, TotPrvInc, TotPrvPaid, TotCurInc, TotCurPaid);
     IF Choice=ch_Ok THEN
      EXIT; (*室 ⮫쪮 ᫥  ९ ⥪饣 ਮ TotCurOver*)
     ELSE
      L_General.CallUs(Choice=ch_Recalc);
     END;
 
     Choice:=STDFORM(L_StdFrm.sf_Choice_wAddBtns("| 砫 ⭮ ਮ ( 01.2010  " + L_DatTim.PeriodStr(PerB-1) + ")" +
                                                 "|" +
                                                 "|                       客         ⥫ " +
                                                 "|        %##############################%                             " +
                                                 "|        %##############################%                             " +
                                                 "|᫥   %##########################% %##########################%" +
                                                 "|祭    %##########################% %##########################%" +
                                                 "|" +
                                                 "|९  砫 ⭮ ਮ (" + L_DatTim.PeriodStr(PerB) + ")" +
                                                 "|(㢥稢 '')" +
                                                 "|" +
                                                 "|९   %##########################% %##########################%" +
                                                 "|" +
                                                 "|  ਮ ( " + L_DatTim.PeriodStr(PerB) + "  " + L_DatTim.PeriodStr(PerE) + ")" +
                                                 "|" +
                                                 "|᫥   %##########################% %##########################%" +
                                                 "|᫥ %##########################% %##########################%" +
                                                 "|" +
                                                 "|९   ⭮ ਮ (" + L_DatTim.PeriodStr(PerE) + ")" +
                                                 "|(㬥蠥 '')" +
                                                 "|" +
                                                 "|९   %##########################% %##########################%",
                                                 "%R<(஬   㬬, ॢ>M"+
                                                 "%R<। 稭 )>M"+
                                                 "%RNI%RNI" + "%RNI%RNI" + prvOverStr + "%RNI%RNI" + "%RI%RI" + "%RNI%RNI",
                                                 "%#############%",
                                                 "%< {} >B"),
                     "   ᫥  㯫祭 客  ",
                     ,
                     -1,
                     TotPrvInc [tp_PFIn],
                     TotPrvInc [tp_PFAc],
                     TotPrvPaid[tp_PFIn],
                     TotPrvPaid[tp_PFAc],
  
                     TotPrvOver[tp_PFIn],
                     TotPrvOver[tp_PFAc],
  
                     TotCurInc [tp_PFIn],
                     TotCurInc [tp_PFAc],
                     TotCurPaid[tp_PFIn],
                     TotCurPaid[tp_PFAc],
                     TotCurOver[tp_PFIn],
                     TotCurOver[tp_PFAc]);
    END; (* LOOP *)
    IF ~PFSumIsZERO(TotCurOver) THEN
     IF STDFORM(L_StdFrm.sf_Choice_wAddBtns("| ﭨ   ⭮ ਮ"+
                                            "| ९ 客 ᮢ"+
                                            "|(㬥蠥 '')"+
                                            "|"+
                                            "|                    客         ⥫  " +
                                            "|९ %##########################% %##########################%",
                                            "%RNI%RNI", "%#############%", "%< {}    >B"),
                " ९ 客 ᮢ ",
                CHOICE,
                -1,
                TotCurOver[tp_PFIn],
                TotCurOver[tp_PFAc]) = 1 THEN
      EXIT;
     END;
    ELSE
     EXIT;
    END;
   END; (* LOOP *)
   sprTotPrvInc :=TotPrvInc;
   sprTotPrvPaid:=TotPrvPaid;
   sprTotPrvOver:=TotPrvOver;
   sprTotCurInc :=TotCurInc;
   sprTotCurPaid:=TotCurPaid;
   sprTotCurOver:=TotCurOver;

   PFSumINC(TotCurPaid, TotPrvOver);
   PFSumDEC(TotCurPaid, TotCurOver);
   CalculateCurPaid(TotPrvInc, TotPrvPaid, TotCurInc, TotCurPaid);
  END; (* IF IsSince2010() ... *)
 END {PreparePaidDataForAll};

 PRIVATE PROCEDURE trn_PutInfAboutInf(nParent: L_XML.tNode; i: NUMERIC[0];
                                                            IsCorr: SCAL[2];
                                                            InfType: STRING[];
                                                            trgCategory: tCategory;
                                                            Sums: L_XObj.tSum[4];
                                                            NumOfMan: NUMERIC[0];
                                                            trnFN: STRING[];
                                                            NeedCopeck: SCAL[2]);
  VAR
   nPck: L_XML.tNode;
   trn_PutInsIncPaidProc,
   trn_PutProc           : PROC;
 BEGIN
  IF ~IsCorr THEN
   nPck:=L_Packet.trn_PutNode(nParent, "室呢");
   IF NeedCopeck THEN  trn_PutInsIncPaidProc:=PROCREF(trn_PutInsIncPaid);
   ELSE                trn_PutInsIncPaidProc:=PROCREF(trn_PutInsIncPaidInt);
   END;
  ELSE
   IF NeedCopeck THEN  trn_PutProc:=PROCREF(L_Packet.trn_PutMoney);
   ELSE                trn_PutProc:=PROCREF(L_Packet.trn_PutInt);
   END;
   nPck:=L_Packet.trn_PutNode(nParent, "४呢");
  END;
  L_Packet.trn_PutInt(nPck, "浪멍", i);
  L_Packet.trn_PutString(nPck, "பᢥ", InfType);
  IF ~!trgCategory THEN
   L_Packet.trn_PutString(nPck, "⥣ਨ", GetCategoryNick(trgCategory));
  END;
  IF ~IsCorr THEN
   trn_PutInsIncPaidProc(nPck, "㬬ᮢ客",     Sums[ps_InInc], Sums[ps_InPaid]);
   trn_PutInsIncPaidProc(nPck, "㬬ᮢ⥫", Sums[ps_AcInc], Sums[ps_AcPaid]);
  ELSE
   trn_PutProc(nPck, "᫥客",     Sums[ps_InInc]);
   trn_PutProc(nPck, "᫥⥫", Sums[ps_AcInc]);
   trn_PutProc(nPck, "㯫祭客",      Sums[ps_InPaid]);
   trn_PutProc(nPck, "㯫祭⥫",  Sums[ps_AcPaid]);
  END;
  L_Packet.trn_PutInt(nPck, "⢮", NumOfMan);
  IF ~!trnFN THEN
   L_Packet.trn_PutString(nPck, "", trnFN);
  END;
 END {trn_PutInfAboutInf};

 PRIVATE PROCEDURE CalcTotNumOfMan(): NUMERIC[0];
  VAR
   _Man  : LIKE(Man.Man);
   Result: NUMERIC[0];
 BEGIN
  Result:=0;
  SETEMPTY(_Man);
  SELECT(Prt01, Prt01);
  WHILE OCCURE(Prt01) DO
   IF (_Man # Prt01.Man) THEN
    _Man:=Prt01.Man;
    INC(Result);
   END;
   NEXT(Prt01);
  END; (* WHILE OCCURE(Prt01) ... *)
  RETURN Result;
 END {CalcTotNumOfMan};

 PRIVATE PROCEDURE MakeADV6_2();
  VAR
   IsCorr    : SCAL[2];
   i, j,
   Amount    : NUMERIC[0];
   iPackets,
   iItems,
   cPackets,
   cItems    : NUMERIC[0];
   TrfSign   : STRING[1];
   av_Counter: L_Acnt.tAcntVector;
   nPack,
   nInvH,
   nDoc,
   nPck      : L_XML.tNode;
   gSums,
   tSums     : L_XObj.tSum[4];
   NumOfMan,
   tNumOfMan : NUMERIC[0];
 BEGIN
  L_General.CallUs(SEARCH(Packet, Packet, PacketForADV1X));
  SAVE(Packet);
  SELECT(ADV10, Corr, , 0);
  iPackets:=GetADV10BySelectForADV10("Packets");
  SELECT(ADV10, Corr, , 1);
  cPackets:=GetADV10BySelectForADV10("Packets");

  L_Packet.trn_OpenFiles();
  nPack:=L_Packet.trn_PutHead();
  nInvH:=L_Packet.trn_PutInventoryHead(nPack, "____", trn_PckKind(), 1);

  nDoc:=L_Packet.trn_PutAbstractDoc(nPack, trn_PckKind(), 2);
  L_Packet.trn_PutOwnFirm(nDoc, "客⥫");
  trn_PutPer(nDoc, "멏ਮ");
  L_Packet.trn_PutInt(nDoc, "᫮室叠祪", iPackets);
  L_Packet.trn_PutInt(nDoc, "᫮४叠祪", cPackets);
  L_Packet.trn_PutDate(nDoc, "⠇", L_Packet.PrepareDate);
  tNumOfMan:=CalcTotNumOfMan();

  MAKEPART(R, ADV6_2_1, iPackets, cPackets);

  FOR_EACH IsCorr DO
   SETZERO(tSums, i, j, NumOfMan);
   IF SELECT(ADV10, Corr, IsCorr) THEN
    WHILE OCCURE(ADV10) DO
     SETZERO(gSums);
     NARROWSEL(ADV10, Category);
     WHILE OCCURE(ADV10) DO
      NARROWSEL(ADV10, _Packet);
      L_General.CallUs(AccessPacket(ADV10._Packet));
      INC(i);
      INC(j);
      NumOfMan:=GetADV10BySelectForADV10("Items");
      trn_PutInfAboutInf(nDoc, j, IsCorr, " ", ADV10.Category, Packet.Sums, NumOfMan, L_Packet.GetTransportFileName(), IsSince2011());
      INC(gSums[ps_InInc],  Packet.Sums[ps_InInc]);
      INC(gSums[ps_AcInc],  Packet.Sums[ps_AcInc]);
      INC(gSums[ps_InPaid], Packet.Sums[ps_InPaid]);
      INC(gSums[ps_AcPaid], Packet.Sums[ps_AcPaid]);
      INC(tSums[ps_InInc],  Packet.Sums[ps_InInc]);
      INC(tSums[ps_AcInc],  Packet.Sums[ps_AcInc]);
      INC(tSums[ps_InPaid], Packet.Sums[ps_InPaid]);
      INC(tSums[ps_AcPaid], Packet.Sums[ps_AcPaid]);
      MAKEPART(R, ADV6_2_3, i, GetCategoryNick(ADV10.Category), NumOfMan);
      NEXTINEXTENDEDSEL(ADV10, _Packet);
     END;
     FIRST(ADV10);
     IF i > 0 THEN
      INC(j);
      trn_PutInfAboutInf(nDoc, j, IsCorr, " ", ADV10.Category, gSums, GetADV10BySelectForADV10("Items"), "", IsSince2011());
     END;
     NEXTINEXTENDEDSEL(ADV10, Category);
    END;
    FIRST(ADV10);
    INC(j);
    IF IsCorr THEN
     NumOfMan:=GetADV10BySelectForADV10("Items");
    ELSE
     NumOfMan:=tNumOfMan;
    END;
    trn_PutInfAboutInf(nDoc, j, IsCorr, " ", EMPTYOF(tCategory), tSums, NumOfMan, "", IsSince2012());
   END;
   IF ~IsCorr THEN
    MAKEPART(R, ADV6_2_2, tSums[ps_InInc], tSums[ps_InPaid], tSums[ps_AcInc], tSums[ps_AcPaid], NumOfMan);
    L_General.CallUs((tSums[ps_InInc] = sprTotCurInc[tp_PFIn]) & (tSums[ps_AcInc] = sprTotCurInc[tp_PFAc]));
   ELSE
    L_General.CallUs((tSums[ps_InPaid] <= 0) & (tSums[ps_AcPaid] <= 0));
    MAKEPART(R, ADV6_2_4, tSums[ps_InInc], tSums[ps_InPaid], tSums[ps_AcInc], tSums[ps_AcPaid], NumOfMan);
   END;
  END; (* FOR_EACH IsCorr ... *)

  SETEMPTY(pSum1, pSum2, pInc);
  RESTORE(Packet);
  L_Packet.trn_CloseFiles(nPack);
 END {MakeADV6_2};

 PRIVATE PROCEDURE CreatePkIdx();
 BEGIN
  L_AFM.MakeMultipleIndex("PkIdx", "PerB    : DATE;"+
                                   "PerE    : DATE;"+
                                   "Man     : LIKE(Man.Man);"+
                                   "Category: "+GET_TYPE_SPEC(tCategory).Name+";"+
                                   "CntrType: "+GET_TYPE_SPEC(L_Packet.tCntrType).Name+";"+
                                   "Packet  : LIKE(Packet.Packet);"+
                                   "SeqNbr  : LIKE(PckBody.SeqNbr);"+
                                   "DTStamp : LIKE(Packet.DTStamp)",
                          "PkIdx: PerB, PerE, Man, Category, CntrType;"+
                          "Man: Man, Category, CntrType, PerB, PerE");
 END {CreatePkIdx};

 PRIVATE PROCEDURE CreateCnTpP();
 BEGIN
  CREATE_TABLE(CnTpP);
  CREATE_FIELD(CnTpP, Man,      LIKE(Man.Man));
  CREATE_FIELD(CnTpP, P,        DATE);
  CREATE_FIELD(CnTpP, CntrType, L_Packet.tCntrType);

  CREATE_INDEX(CnTpP, CnTpP, UNIQUE, , , Man, CntrType, P);
  CREATE_INDEX_AND_LINK(CnTpP, Man, UNIQUE, Man, Man, USER, , , Man, P, CntrType);
  SET_VERSION_OF_TABLE(CnTpP, 0000);
  L_AFM.CreateTemp("CnTpP");
 END {CreateCnTpP};

 PRIVATE PROCEDURE InitServices(trgPerB, trgPerE: DATE; Msg: STRING[]);
 BEGIN
  RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;

  IF ~!Msg THEN
   L_StdFrm.Question(Msg+"| | ਮ  "+L_DatTim.DateStr(trgPerB)+"  "+L_DatTim.DateStr(trgPerE));
  END;

  SETZERO(Days, Months);

  SetDateParms(trgPerB, trgPerE);

  L_Tax.Tax2001_InitCodes(PerB);

  SETZERO(RealPacketAmount);
  SETEMPTY(PacketForADV1X);

  PrepareMsForMoney();
  SETZERO(aAmount);

  CREATE_TABLE(Prt01);
  CREATE_FIELD(Prt01, Man,      LIKE(Man.Man));
  CREATE_FIELD(Prt01, Name,     LIKE(Man.Name));
  CREATE_FIELD(Prt01, Packet,   LIKE(Packet.Packet));
  CREATE_FIELD(Prt01, NumInP,   NUMERIC[0]);
  CREATE_FIELD(Prt01, Category, tCategory);
  CREATE_FIELD(Prt01, Group,    L_Packet.tPacketGroup);
  CREATE_FIELD(Prt01, ContrNum, tContrNum);
  CREATE_FIELD(Prt01, ContrDat, LIKE(StaffLog.Date));
  CREATE_FIELD(Prt01, IsLeave,  SCAL[2]);
  CREATE_FIELD(Prt01, ManPerB,  DATE);
  CREATE_FIELD(Prt01, ManPerE,  DATE);

  CREATE_FIELD(Prt01, Sum1, L_PRoll.tSum[MaxPerAmo]);
  CREATE_FIELD(Prt01, Sum2, L_PRoll.tSum[MaxPerAmo]);
  CREATE_FIELD(Prt01, Pns2, L_PRoll.tSum[MaxPerAmo]);

  IF IsSince2010() THEN
   CREATE_FIELD(Prt01, Object,  tQuartalByMonthSum, , "0");
   CREATE_FIELD(Prt01, Base,    tQuartalByMonthSum, , "0");
   CREATE_FIELD(Prt01, OvrPrt,  tQuartalByMonthSum, , "0");
   CREATE_FIELD(Prt01, BasPFA1, tQuartalByMonthSum, , "0");
   CREATE_FIELD(Prt01, BasPFA2, tQuartalByMonthSum, , "0");
  ELSIF L_Packet.Get_PF_PacketKind(PerB, PerE, L_Packet.dt_Basic, L_Packet.ct_None) = L_Packet.knd_PF_SZV3 THEN
   CREATE_FIELD(Prt01, manBase, L_PRoll.tSum, , "0");
  END;
  CREATE_FIELD(Prt01, manPns1, L_PRoll.tSum);
  CREATE_FIELD(Prt01, manPns2, L_PRoll.tSum);
  CREATE_FIELD(Prt01, manSum1, L_PRoll.tSum);
  CREATE_FIELD(Prt01, manSum2, L_PRoll.tSum);
  CREATE_FIELD(Prt01, Months,  tAddTypeLen);
  CREATE_FIELD(Prt01, Days,    tAddTypeLen);

  CREATE_FIELD(Prt01, StageNum, NUMERIC[0]);
  CREATE_FIELD(Prt01, MonthToIncl, SCAL[2][12]);

  CREATE_FIELD(Prt01, MoneyStrNum, NUMERIC[0]);

  CREATE_INDEX_AND_LINK(Prt01, Man, UNIQUE, Man, Man, USER, "", "", Man, Packet);
  CREATE_INDEX_AND_LINK(Prt01, Packet, UNIQUE, Packet, Packet, USER, "", "", Packet, NumInP);
  CREATE_INDEX(Prt01, Prt01, UNIQUE, "", "", Name, Man, Packet);
  SET_VERSION_OF_TABLE(Prt01, 0000);
  L_AFM.CreateTemp("Prt01");

  CREATE_TABLE(ADV10);
  CREATE_FIELD(ADV10, _Packet,  LIKE(Packet.ExtNbr));
  CREATE_FIELD(ADV10, _Month,   SCAL[12+1]);
  CREATE_FIELD(ADV10, Group,    L_Packet.tPacketGroup);
  CREATE_FIELD(ADV10, Category, tCategory);
  CREATE_FIELD(ADV10, Corr,     SCAL[2]);
  CREATE_FIELD(ADV10, _Sum1,    L_PRoll.tSum, , "0");
  CREATE_FIELD(ADV10, _Sum2,    L_PRoll.tSum, , "0");
  CREATE_FIELD(ADV10, _Pns1,    L_PRoll.tSum, , "0");
  CREATE_FIELD(ADV10, _Pns2,    L_PRoll.tSum, , "0");
  CREATE_FIELD(ADV10, Quantity, NUMERIC[0], , "0");
  CREATE_FIELD(ADV10, Packets,  NUMERIC[0], , "0");
  CREATE_FIELD(ADV10, Items,    NUMERIC[0], , "0");
  CREATE_FIELD(ADV10, DPItems,  NUMERIC[0], , "0");
  CREATE_INDEX(ADV10, ADV10,    UNIQUE, , , _Packet, _Month, Group, Category, Corr);
  CREATE_INDEX(ADV10, ADV10_M,  PLURAL, , , _Month);
  CREATE_INDEX(ADV10, ADV10_AM, PLURAL, , , Category, _Month);
  CREATE_INDEX(ADV10, Corr, PLURAL, , , Corr, Category, _Packet);
  SET_VERSION_OF_TABLE(ADV10, 0000);
  L_AFM.CreateTemp("ADV10");

  CREATE_TABLE(_MIns);
  CREATE_FIELD(_MIns, Numb,     SCAL[4]);
  CREATE_FIELD(_MIns, Man,      LIKE(Man.Man));
  CREATE_FIELD(_MIns, Category, tCategory);
  CREATE_FIELD(_MIns, CntrType, L_Packet.tCntrType);
  CREATE_FIELD(_MIns, BegD,     DATE);
  CREATE_FIELD(_MIns, EndD,     DATE);
  CREATE_FIELD(_MIns, PostName, LIKE(Post.Name));
  CREATE_FIELD(_MIns, Type,     L_Packet.tMInsType);
  CREATE_INDEX(_MIns, _MIns, PLURAL, , , Numb, Man, Category, CntrType, BegD, EndD, Type);
  SET_VERSION_OF_TABLE(_MIns, 0000);
  L_AFM.CreateTemp("_MIns");

  CREATE_TABLE(StfLg);
  CREATE_FIELD(StfLg, Numb, SCAL[2]);
  CREATE_FIELD(StfLg, TSN, LIKE(Staff.TSN));
  CREATE_FIELD(StfLg, DateB, DATE);
  CREATE_FIELD(StfLg, DateE, DATE);
  CREATE_FIELD(StfLg, Contract, LIKE(Staff.Contract));
  CREATE_FIELD(StfLg, CntrType, L_Packet.tCntrType);
  CREATE_FIELD(StfLg, PnsAttr,  LIKE(Officer.PnsAttr));

  CREATE_INDEX(StfLg, StfLg, PLURAL, , , CntrType, Numb, DateB, Contract, TSN);
  SET_VERSION_OF_TABLE(StfLg, 0001);
  L_AFM.CreateTemp("StfLg");

  CREATE_TABLE(Prb01);
  CREATE_FIELD(Prb01, Man, LIKE(Man.Man));
  CREATE_FIELD(Prb01, Problem, STRING[200]);
  CREATE_FIELD(Prb01, Error, SCAL[2]);

  CREATE_INDEX(Prb01, Prb01, UNIQUE, , , Error, Man, Problem);
  CREATE_INDEX(Prb01, Man,   PLURAL, , , Man);
  SET_VERSION_OF_TABLE(Prb01, 0001);
  L_AFM.CreateTemp("Prb01");

  CREATE_TABLE(Intrm);
  CREATE_FIELD(Intrm, Category, tCategory);
  CREATE_FIELD(Intrm, CntrType, L_Packet.tCntrType);
  CREATE_FIELD(Intrm, Group,    L_Packet.tPacketGroup);
  CREATE_FIELD(Intrm, PckKind,  LIKE(Packet.Kind));
  CREATE_FIELD(Intrm, DataType, LIKE(Packet.DataType));
  CREATE_FIELD(Intrm, CorrType, LIKE(Packet.CorrType));
  CREATE_FIELD(Intrm, Separate, SCAL[100]);
  CREATE_FIELD(Intrm, Man,      LIKE(Man.Man));
  CREATE_FIELD(Intrm, Name,     LIKE(Man.Name));
  CREATE_FIELD(Intrm, ManPerE,  DATE);
  CREATE_FIELD(Intrm, Packet,   LIKE(Packet.Packet));
  CREATE_FIELD(Intrm, SeqNbr,   LIKE(PckBody.SeqNbr));

  CREATE_INDEX(Intrm, Intrm, UNIQUE, , , Category, CntrType, Group, PckKind, DataType, CorrType, Separate, Name, Man);
  CREATE_INDEX_AND_LINK(Intrm, Man,    UNIQUE, Man, Man, USER, , , Man, Packet);
  CREATE_INDEX_AND_LINK(Intrm, Packet, UNIQUE, PckBody, Packet, USER, , , Packet, SeqNbr);
  SET_VERSION_OF_TABLE(Intrm, 0000);
  L_AFM.CreateTemp("Intrm");

  L_AFM.MakeMultipleIndex("TmpIP", "Man     : LIKE(Man.Man);" +
                                   "Category: "+GET_TYPE_SPEC(tCategory).Name +";"+
                                   "CntrType: "+GET_TYPE_SPEC(L_Packet.tCntrType).Name +";"+
                                   "PrvOnly : SCAL[2];" +
                                   "PrvPaid : "+GET_TYPE_SPEC(tPFSum).Name +";"+
                                   "PrvInc  : "+GET_TYPE_SPEC(tPFSum).Name +";"+
                                   "CurPaid : "+GET_TYPE_SPEC(tPFSum).Name +";"+
                                   "CurInc  : "+GET_TYPE_SPEC(tPFSum).Name +";"+
                                   "OldPaid : "+GET_TYPE_SPEC(tPFSum).Name +";"+
                                   "OldInc  : "+GET_TYPE_SPEC(tPFSum).Name,
                          "Man: Man, Category, CntrType;"+
                          "PrvOnly: PrvOnly, Man, Category, CntrType;"+
                          "CntrType: CntrType, Man");
  CreatePkIdx();
  CreateCnTpP();
 END {InitServices};

 PRIVATE PROCEDURE ClearServices(Full: SCAL[2]);
 BEGIN
  SETSEL(Prt01, Man);    REMSEL(Prt01);
  SETSEL(Prb01, Man);    REMSEL(Prb01);
  IF Full THEN
   SETSEL(StfLg, StfLg);  REMSEL(StfLg);
   SETSEL(_MIns, _MIns);  REMSEL(_MIns);
   SETSEL(Intrm, Intrm);  REMSEL(Intrm);
   SETSEL(CnTpP, CnTpP);  REMSEL(Intrm);
  END;
  SETSEL(TmpIP, Man);    REMSEL(TmpIP);
  SETSEL(PkIdx, PkIdx);  REMSEL(PkIdx); chkPkIdxTill:=MINOF(DATE);
 END {ClearServices};

 PRIVATE PROCEDURE DeInitServices();
 BEGIN
  L_AFM.AF_PurgeTemp("Prt01");
  L_AFM.AF_PurgeTemp("Prb01");
  L_AFM.AF_PurgeTemp("ADV10");
  L_AFM.AF_PurgeTemp("StfLg");
  L_AFM.AF_PurgeTemp("_MIns");
  L_AFM.AF_PurgeTemp("Intrm");
  L_AFM.AF_PurgeTemp("TmpIP");
  L_AFM.AF_PurgeTemp("PkIdx");
 END {DeInitServices};

 PRIVATE PROCEDURE ForX_ByPacket(_Month: SCAL[13]; Field: STRING[]): L_PRoll.tSum;
  VAR
   R: L_PRoll.tSum;
 BEGIN
  SAVE(ADV10);
  IF _Month = 12 THEN
   SELECT(ADV10, ADV10);
   R:=GetADV10ByPacket(Packet.ExtNbr, Field);
  ELSE
   SELECT(ADV10, ADV10, , Packet.ExtNbr, _Month);
   R:=_GetADV10BySelect(Field);
  END;
  RESTORE(ADV10);
  RETURN R;
 END {ForX_ByPacket};

 PRIVATE PROCEDURE ForX_Total(_Month: SCAL[13]; Field: STRING[]): L_PRoll.tSum;
  VAR
   R: L_PRoll.tSum;
 BEGIN
  SAVE(ADV10);
  IF _Month = 12 THEN
   SELECT(ADV10, ADV10);
   R:=GetADV10Total(Field);
  ELSE
   SELECT(ADV10, ADV10_M, , _Month);
   R:=_GetADV10BySelect(Field);
  END;
  RESTORE(ADV10);
  RETURN R;
 END {ForX_Total};

(*
$P{ R_PrtTop:
L_Packet.OwnFirmName, L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
PerB, L, "D.N.y"
L_Packet.ActualDate, L, "D.N.y"
@
########################################################################################################### ########## #####
============================================================================================================================
|                     ⮪ ନ஢ 㠫 ᢥ  ਮ ##########  ##########                     |
|--------------------------------------------------------------------------------------------------------------------------|
}
*)


(*
$P{ R_PrtTop_03_00:
@
|                                        |        | | | |- |  ࠡ⮪|   .. |  ᫥|           |
|                                      |   | |ᢥ|| |     室|६.|ᮢ |           |
|----------------------------------------|--------|-------|----|----|------|-----------|-----------|-----------|-----------|
}
*)

(*
$P{ R_PrtTop_04_00:
@
|                                        |        | | | |- |  客|⥫| |           |
|                                      |   | |ᢥ|| |      |      |     |           |
|----------------------------------------|--------|-------|----|----|------|-----------|-----------|-----------|-----------|
}
*)

(*
$P{ R_PrtTop_06_00:
PerB-1, L, "N.y"
sprTotPrvInc [tp_PFIn], R, "2-"
sprTotPrvInc [tp_PFAc], R, "2-"
sprTotPrvPaid[tp_PFIn], R, "2-"
sprTotPrvPaid[tp_PFAc], R, "2-"
PerB, L, "N.y"
sprTotPrvOver[tp_PFIn], R, "2-"
sprTotPrvOver[tp_PFAc], R, "2-"
PerB, L, "N.y"
PerE, L, "N.y"
sprTotCurInc [tp_PFIn], R, "2-"
sprTotCurInc [tp_PFAc], R, "2-"
sprTotCurPaid[tp_PFIn], R, "2-"
sprTotCurPaid[tp_PFAc], R, "2-"
PerE, L, "N.y"
sprTotCurOver[tp_PFIn], R, "2-"
sprTotCurOver[tp_PFAc], R, "2-"
@
|  ᫥  ᫥ 客                   |    客     |  ⥫쭠   |
|--------------------------------------------------------------------------|-----------------------|-----------------------|
| 砫 ⭮ ਮ ( 01.2010  #######)               ᫥|#######################|#######################|
|                                                                  祭|#######################|#######################|
|--------------------------------------------------------------------------|-----------------------|-----------------------|
|९  砫 ⭮ ਮ (#######) (㢥稢 '')  |#######################|#######################|
|--------------------------------------------------------------------------|-----------------------|-----------------------|
|  ਮ ( #######  #######)                        ᫥|#######################|#######################|
|                                                               ᫥|#######################|#######################|
|--------------------------------------------------------------------------|-----------------------|-----------------------|
|९   ⭮ ਮ (#######) (㬥蠥 '')     |#######################|#######################|
|==========================================================================================================================|
|                                        |        | | | |- |    客     |  ⥫쭠   |
|                                      |   | |ᢥ|| |-----------------------|-----------------------|
|                                        |        |       |    |    |      |  ᫥|   祭|  ᫥|   祭|
|----------------------------------------|--------|-------|----|----|------|-----------|-----------|-----------|-----------|
}
*)

(*
$P{ R_PrtLine:
?, L, ""
Packet.ExtNbr, L, ""
Prt01.NumInP, R, "0"
L_Str.PoolItem(L_Packet.dt_Pool, Packet.DataType), L, ""
L_Str.PoolItem(L_Packet.ct_Pool, Packet.CorrType), L, ""
GetCategoryNick(Prt01.Category), L, ""
?, R, "2-"
?, R, "2-"
?, R, "2-"
?, R, "2-"
@
|########################################|########|#######|####|####|######|###########|###########|###########|###########|
}
*)

(*
$P{ R_PrtLineProblem:
L_Man.Man_ManAsStr()+" "+Man.Name, L, ""
?, L, ""
?, R, "2-"
?, R, "2-"
?, R, "2-"
?, R, "2-"
@
|########################################|        |       |    |    |######|###########|###########|###########|###########|
}
*)

(*
$P{ R_PrtBot:
@
=(c) Polak==================================================================================================================}
*)

 PRIVATE PROCEDURE IsPacketForADV1X(): SCAL[2];
 BEGIN
  RETURN (Packet.Kind = L_Packet.knd_PF_ADV10) |
         (Packet.Kind = L_Packet.knd_PF_ADV11) |
         (Packet.Kind = L_Packet.knd_PF_ADV6_2);
 END {IsPacketForADV1X};

 PRIVATE PROCEDURE PrintPrt01();
  VAR
   ManStr  : STRING[];
   _Man    : LIKE(Man.Man);
   SubTitle: STRING[];
 BEGIN
  MAKEPART(R_Prt, R_PrtTop);
  IF    IsSince2010() THEN
   MAKEPART(R_Prt, R_PrtTop_06_00);
  ELSIF IsSince2002() THEN
   MAKEPART(R_Prt, R_PrtTop_04_00);
  ELSE
   MAKEPART(R_Prt, R_PrtTop_03_00);
  END;

  SELECT(Prb01, Prb01, , 0);
  WHILE OCCURE(Prb01) DO
   SEARCH(Man, Man, , Prb01.Man);
   MAKEPART(R_Prt, R_PrtLineProblem, Prb01.Problem);
   NEXT(Prb01);
  END; (* WHILE OCCURE(Prb01) ... *)

  SETEMPTY(_Man);
  SELECT(Prt01, Prt01);
  WHILE OCCURE(Prt01) DO
   IF _Man # Prt01.Man THEN
    SEARCH(Man, Man, , Prt01.Man);
    ManStr:=L_Man.Man_ManAsStr()+" "+Man.Name;
   ELSE
    ManStr:="";
   END;
   SEARCH(Intrm, Man, , Prt01.Man, Prt01.Packet);
   CONFORM(Prt01, Packet);
   IF    IsSince2010() THEN
    MAKEPART(R_Prt, R_PrtLine, ManStr, Prt01.manPns2, GetCurPaidFromInc(Prt01.manPns2, tp_PFIn, Intrm.Category, Intrm.CntrType),
                                       Prt01.manPns1, GetCurPaidFromInc(Prt01.manPns1, tp_PFAc, Intrm.Category, Intrm.CntrType));
   ELSIF IsSince2002() THEN
    MAKEPART(R_Prt, R_PrtLine, ManStr, Prt01.manPns2, Prt01.manPns1);
   ELSIF IsSince2001() THEN
    MAKEPART(R_Prt, R_PrtLine, ManStr, Prt01.manBase, Prt01.manSum2, Prt01.manPns2);
   ELSE
    MAKEPART(R_Prt, R_PrtLine, ManStr, Prt01.manSum1, Prt01.manSum2, Prt01.manPns2);
   END;
   _Man:=Prt01.Man;
   NEXT(Prt01);
  END; (* WHILE OCCURE(Prt01) ... *)
  MAKEPART(R_Prt, R_PrtBot);
 END {PrintPrt01};

 PRIVATE PROCEDURE CheckPrb01();
  CONST
   ErrLen = 73;
   RepName = "BdMIn";
  VAR
   ManStr,
   ErrStr   : STRING[];
   ErrStrArr: STRING[ErrLen][10];
 BEGIN
  IF SELECT(Prb01, Prb01, 1) THEN
   OPENREP(R_Prb, L_General.NameConnection(RepName), Create);
   MAKEPART(R_Prb, PrbTop, RepName);
   WHILE OCCURE(Prb01) DO
    SEARCH(Man, Man, , Prb01.Man);
    ManStr:=L_Man.Man_ManAsStr()+" "+Man.Name;
    Str.Format(ErrStrArr, Prb01.Problem, ErrLen, LEFT);
    FOR_EACH ErrStr IN ErrStrArr DO
     MAKEPART(R_Prb, PrbLine, ManStr, ErrStr);
     ManStr:="";
    END;
    NEXT(Prb01);
   END; (* WHILE OCCURE(Prb01) ... *)
   MAKEPART(R_Prb, PrbBot);
   CLOSEREP(R_Prb);
   L_General.HaltAndSurveyLastReport(EMPTYOF(Exc_Root));
  END;
 END {CheckPrb01};

 PRIVATE PROCEDURE MakeAll();
  VAR
   packetDataType: LIKE(Packet.DataType);
   packetCorrType: LIKE(Packet.CorrType);
   NumTot        : NUMERIC[0];
 BEGIN
  SETZERO(NumTot);

  SELECT(Packet, PacketDS, , L_Packet.rcv_PensFund, L_Packet.DTStamp);
  WHILE OCCURE(Packet) DO
   IF (Packet.Packet # PacketForADV1X) & (Packet.PerB = PerB) THEN
    MakeOnePacket();
    INC(NumTot, CurNumInP);
   END;
   NEXT(Packet);
  END; (* WHILE OCCURE(Packet) ... *)

  CheckPrb01();

  IF NeedConsolidated THEN
   IF    IsSince2010() THEN
    MakeADV6_2();
   ELSIF IsSince2002() THEN
    MakeADV11();
   ELSE
    MakeADV10();
   END;

   L_General.CallUs(~!PacketForADV1X & SEARCH(Packet, Packet, PacketForADV1X));
   OPENREP(R_Prt, L_Packet.PacketPrtFullName(), Create, FontProperty, "/U /B /I");

   IF ~IsSince2010() THEN
    OPENREP(R_Consolidated, L_Packet.PacketZapFullName(), Create, FontProperty, "/U /B /I");
    MAKEPART(R_Consolidated, NN2_x_00_1);
    MAKEPART(R_Consolidated, NN2_4_00_2);
    MAKEPART(R_Consolidated, NN2_x_00_3);
    SELECT(ADV10, ADV10);
    WHILE OCCURE(ADV10) DO
     NARROWSEL(ADV10, _Packet);
     SAVE(Packet);
     L_General.CallUs(AccessPacket(ADV10._Packet));
     packetDataType:=Packet.DataType;
     packetCorrType:=Packet.CorrType;
     RESTORE(Packet);
     IF IsSince2002() THEN
      MAKEPART(R_Consolidated, NN2_x_00_4,
               L_Str.PoolItem(L_Packet.dt_Pool, packetDataType),
               L_Str.PoolItem(L_Packet.ct_Pool, packetCorrType),
               MoneyToTxt(GetADV10ByPacket(ADV10._Packet, "_Pns2")),
               MoneyToTxt(GetADV10ByPacket(ADV10._Packet, "_Pns1")));
     ELSE
      MAKEPART(R_Consolidated, NN2_x_00_4,
               L_Str.PoolItem(L_Packet.dt_Pool, packetDataType),
               L_Str.PoolItem(L_Packet.ct_Pool, packetCorrType),
               MoneyToTxt(GetADV10ByPacket(ADV10._Packet, "_Sum1")),
               MoneyToTxt(GetADV10ByPacket(ADV10._Packet, "_Sum2")),
               MoneyToTxt(GetADV10ByPacket(ADV10._Packet, "_Pns2")));
     END;
     NEXTINEXTENDEDSEL(ADV10, _Packet);
    END; (* WHILE OCCURE(ADV10) ... *)
    IF IsSince2002() THEN
     MAKEPART(R_Consolidated, NN2_4_00_5);
    ELSE
     MAKEPART(R_Consolidated, NN2_3_00_5);
    END;
    IF ~IsSince2002() & (L_Env.Region = L_Russia.reg_50) THEN
     FORMFEED(R_Consolidated);
     MAKEPART(R_Consolidated, PartX1, "⢮ 祪", RealPacketAmount, (aAmount+NumTot), 
               MoneyToTxt(ForX_Total(00, "_Sum1") - ForX_Total(00, "_Sum2")),
               MoneyToTxt(ForX_Total(01, "_Sum1") - ForX_Total(01, "_Sum2")),
               MoneyToTxt(ForX_Total(02, "_Sum1") - ForX_Total(02, "_Sum2")),
               MoneyToTxt(ForX_Total(03, "_Sum1") - ForX_Total(03, "_Sum2")),
               MoneyToTxt(ForX_Total(04, "_Sum1") - ForX_Total(04, "_Sum2")),
               MoneyToTxt(ForX_Total(05, "_Sum1") - ForX_Total(05, "_Sum2")),
               MoneyToTxt(ForX_Total(06, "_Sum1") - ForX_Total(06, "_Sum2")),
               MoneyToTxt(ForX_Total(07, "_Sum1") - ForX_Total(07, "_Sum2")),
               MoneyToTxt(ForX_Total(08, "_Sum1") - ForX_Total(08, "_Sum2")),
               MoneyToTxt(ForX_Total(09, "_Sum1") - ForX_Total(09, "_Sum2")),
               MoneyToTxt(ForX_Total(10, "_Sum1") - ForX_Total(10, "_Sum2")),
               MoneyToTxt(ForX_Total(11, "_Sum1") - ForX_Total(11, "_Sum2")),
               MoneyToTxt(ForX_Total(12, "_Sum1") - ForX_Total(12, "_Sum2")),
               MoneyToTxt(ForX_Total(12, "_Pns2")                         ));
    END;
    L_Packet.SetTimeStampByTheStamp("R_Consolidated"); CLOSEREP(R_Consolidated);
   END; (* IF ~IsSince2010() ... *)

   PrintPrt01();
   L_Packet.SetTimeStampByTheStamp("R_Prt");          CLOSEREP(R_Prt);
  END; (* IF NeedConsolidated ... *)
 END {MakeAll};

 PRIVATE PROCEDURE CheckForPensPacket();
 BEGIN
  IF IsForPensPacket() & ~IsCorrPacket() THEN
   IF L_Packet.HasDonePacketInYear(Man.Man, Packet.Kind, Packet.DataType, Packet.MyFirm, PerB) THEN
    L_StdFrm.Choice(" "+L_Str.IntStr(L_DatTim.YEAR(PerB))+"   "+Man.Man+" 㦥     祭 ᨨ");
   END;
  END;
 END {CheckForPensPacket};

 PRIVATE PROCEDURE ConvertType(VAR _DataType: LIKE(Packet.DataType); VAR _CorrType: LIKE(Packet.CorrType));
  VAR
   NeedCorr: L_Packet.tNeedCorr;
 BEGIN
  NeedCorr:=E_ManIns_NeedMakeKORR();
  IF NeedCorr # L_Packet.minc_No THEN
   IF L_Packet.HasDonePacketInYear(Man.Man, L_Packet.Get_PF_PacketKind(PerB, PerE, _DataType, _CorrType), L_Packet.dt_ForPens, L_Packet.PckMyFirm, PerB) THEN
    IF NeedCorr = L_Packet.minc_ForPens THEN
     _DataType:=L_Packet.dt_ForPens;
    END;
    _CorrType:=L_Packet.ct_Corr;
   END;
  END;
 END {ConvertType};

 PRIVATE PROCEDURE InsPrb01(Msg: STRING[]; IsError: SCAL[2]);
 BEGIN
  ADD(Prb01, Prb01, , IsError, Man.Man, Msg);
 END {InsPrb01};

 PRIVATE PROCEDURE IntrmPutOneMan(trgCategory: tCategory;
                                  trgCntrType: L_Packet.tCntrType;
                                  trgGroup: L_Packet.tPacketGroup;
                                  ManPerB, ManPerE: DATE);
  VAR
   curDataType: LIKE(Packet.DataType);
   curCorrType: LIKE(Packet.CorrType);
 BEGIN
  IF ~!trgGroup THEN
   IF L_Packet.BuildMode = L_Packet.bm_byPacket THEN
    curDataType:=Packet.DataType;
    curCorrType:=Packet.CorrType;
   ELSE
    curDataType:=L_Packet.dt_Basic;
    curCorrType:=L_Packet.ct_None;
   END;

   L_General.CallUs(~!trgCategory);
   DEFAULT(Intrm);
   Intrm.Category:=trgCategory;
   Intrm.CntrType:=trgCntrType;
   Intrm.Group   :=trgGroup;
   Intrm.Man     :=Man.Man;
   Intrm.Name    :=L_Packet.GetManInPFRFName(SYSDATE());
   Intrm.Separate:=L_Packet.E_ManIns_NeedSeparateMan(ManPerB, ManPerE, trgGroup);
   IF L_Packet.BuildMode = L_Packet.bm_byPacket THEN
    Intrm.PckKind :=Packet.Kind;
    CheckForPensPacket();
    Intrm.DataType:=Packet.DataType;
    Intrm.CorrType:=Packet.CorrType;
    Intrm.ManPerE :=ManPerE;
   ELSE
    Intrm.PckKind :=L_Packet.Get_PF_PacketKind(PerB, PerE, L_Packet.dt_Basic, L_Packet.ct_None);
    Intrm.DataType:=L_Packet.dt_Basic;
    Intrm.CorrType:=L_Packet.ct_None;
    ConvertType(Intrm.DataType, Intrm.CorrType);
    SETEMPTY(Intrm.ManPerE);
   END;
   INSERT(Intrm);
  END;
 END {IntrmPutOneMan};

 PRIVATE PROCEDURE NeedManInIntrm(ManPerB, ManPerE: DATE; VAR PerOfPay: SCAL[2][12]): SCAL[2];
  VAR
   Result: SCAL[2];
 BEGIN
  Result:=0;
  IF WorkInPer(ManPerB, ManPerE, PerOfPay) THEN
   Result:=1;
  ELSE
   Result:=HasPaidDebts();
   IF Result & IsSince2011() THEN
    IF HasExcludedTSN(ManPerB) THEN
     L_Prop.PositionOnProperty(P_Staff.P_ExcludedTSNForPF);
     L_General.Error("  "+Man.Man+" "+Man.Name+"| 㯫 ᮢ  ⭮ ਮ|"+
                     "    ਬ ᢮⢠ ࠡ⭨|"+Property.Property+"'"+Property.Name+"' (⠡ "+Staff.TSN+")");
    END; (* IF HasExcludedTSN( ... *)
   END; (* IF Result & ... *)
  END; (* IF ~Result ... *)
  RETURN Result;
 END {NeedManInIntrm};

 PRIVATE PROCEDURE PutManInIntrm(ManPerB, ManPerE: DATE);
  VAR
   curCategory: tCategory;
   curCntrType: L_Packet.tCntrType;
   PerOfPay   : SCAL[2][12];
   prvCorrType: LIKE(Packet.CorrType);
   curGroup,
   prvGroup   : L_Packet.tPacketGroup;
   NeedBasic,
   NeedCancel : SCAL[2];
 BEGIN
  PROMPT(" "+L_Man.Man_ManAsStr());
  IF NeedManInIntrm(ManPerB, ManPerE, PerOfPay) THEN
   IF ~!Man.SINumber THEN
    L_Russia.CheckSINumber(Man.SINumber, 0);
    FOR_EACH curCategory IN CategoryList() DO
     FOR_EACH curCntrType DO
      IF ManHasCategoryAndCntrType(curCategory, curCntrType, ManPerB, ManPerE) THEN
       curGroup:=GetPacketGroupForMan(curCategory, curCntrType, ManPerB, ManPerE, PerOfPay);
       IntrmPutOneMan(curCategory, curCntrType, curGroup, ManPerB, ManPerE);
      ELSE
       SETEMPTY(curGroup);
      END;
      IF (L_Packet.BuildMode = L_Packet.bm_byPacket) & IsSince2010() THEN
       IF StandOnPkIdx(ManPerB, GetStdPerE(ManPerB), curCategory, curCntrType, Man.Man) THEN
        SAVE(Packet);
        SEARCH(Packet, Packet, , PkIdx.Packet);
        prvCorrType:=Packet.CorrType;
        RESTORE(Packet);
       ELSE
        SETEMPTY(prvCorrType);
       END;
       NeedBasic:=~!curGroup & IsCorrPacket() & (!prvCorrType | (prvCorrType = L_Packet.ct_Cancel));
       NeedCancel:=!curGroup & (~!prvCorrType & (prvCorrType # L_Packet.ct_Cancel));
       L_General.CallUs(~NeedBasic | ~NeedCancel);
       IF NeedCancel THEN
        IntrmPutOneMan(curCategory, curCntrType, pg_Main, ManPerB, ManPerE);
        Intrm.CorrType:=L_Packet.ct_Cancel;
        REPLACE(Intrm);
       END;
       IF NeedBasic THEN
        L_StdFrm.Inform("㦭 室 ᢥ "+Man.Man+" "+L_DatTim.PeriodStr(ManPerB)+" "+L_DatTim.PeriodStr(ManPerE)+" "+GetCategoryNick(curCategory));
       END;
      END;
     END; (* FOR_EACH curCntrType ... *)
    END; (* FOR_EACH curCategory ... *)
   ELSIF IsInsuredInPF_InPer(ManPerB, ManPerE) THEN
    IF L_SFee.ManHasADV1() THEN
     InsPrb01(" ,   -1", 1);
    ELSE
     InsPrb01(" ", 1);
    END;
   END;
  END; (* IF NeedManInIntrm(( ... *)
  IF HasExcludedTSN(ManPerB) THEN
   InsPrb01("᪫祭   ᢥ", 0);
  END;
 END {PutManInIntrm};

 PRIVATE PROCEDURE BuildPackets();
  VAR
   PacketSize: NUMERIC[0];
 BEGIN
  PacketSize:=P_OwnData.ODPacketSize(L_Packet.PrepareDate);
  SELECT(Intrm, Intrm);
  WHILE OCCURE(Intrm) DO
   NARROWSEL(Intrm, Category, CntrType, Group, PckKind, DataType, CorrType, Separate);
   CurNumInP:=0;
   WHILE OCCURE(Intrm) DO
    PROMPT("⮢ ⮢ "+ Intrm.Man);
    CurNumInP:=(CurNumInP MOD PacketSize)+1;
    INC(CurPacket, CurNumInP = 1);
    SetPckBodyByIntrm(CurPacket);
    NEXT(Intrm);
   END;
   NEXTINEXTENDEDSEL(Intrm, Category, CntrType, Group, PckKind, DataType, CorrType, Separate);
  END;
 END {BuildPackets};

 PRIVATE PROCEDURE MakeByPacket();
 BEGIN
  IF SELECT(PckBody, Packet, Packet.Packet) THEN
   L_General.Assert(~IsPacketForADV1X(), "       ⨯ "+L_Str.PoolItem(L_Packet.knd_Pool, Packet.Kind));
  END;
  WHILE OCCURE(PckBody) DO
   IF ~SELECT(Intrm, Man, PckBody.Man) THEN (*  㦥 㯮  㣮 -ࠧ*)
    MakePckIndex(L_DatTim.NextPer(GetStdPerE(Packet.PerB)), PckBody.Man);
    CONFORM(PckBody, Man);
    PutManInIntrm(GetManPerB(), GetManPerE());
   END;
   NEXT(PckBody);
  END; (* WHILE OCCURE(PckBody) ... *)
 END {MakeByPacket};

 PRIVATE PROCEDURE PrepareGroup();
 BEGIN
  APP.Get().NewPrompt(" ");
  SELECT(Man, rsMan, , 1);
  WHILE OCCURE(Man) DO
   PutManInIntrm(PerB, PerE);
   NEXT(Man);
  END; (* WHILE OCCURE(Man)... *)
 END {PrepareGroup};

 PRIVATE PROCEDURE CheckPer();
  VAR
   Strong : SCAL[2];
   ErrStr : STRING[];
   curPerE: DATE;
 BEGIN
  Strong:=(L_Packet.BuildMode = L_Packet.bm_byAll) | (L_Packet.BuildMode = L_Packet.bm_byPacket);

  IF L_Packet.BuildMode = L_Packet.bm_byPacket THEN
   curPerE:=MINOF(DATE);
   SELECT(PckBody, Packet, , Packet.Packet);
   WHILE OCCURE(PckBody) DO
    curPerE:=Math.Max(curPerE, PerEMoney(GetManPerE()));
    NEXT(PckBody);
   END; (* WHILE OCCURE(PckBody) ... *)
   curPerE:=Math.Min(curPerE, PerE);
  ELSE
   curPerE:=PerE;
  END;

  ErrStr:="";
  IF IsSince2010() THEN
   IF ~L_SFee.SFeeIsCalculatedInProperConsecution(L_DatTim.Per(curPerE)) THEN
    ErrStr:=" 믮  客 ᮢ  "+L_DatTim.PeriodStr(curPerE);
   END;
  ELSE
   IF ~L_APtm.MonthIsClosed(curPerE, L_APtm.system_Salary) THEN
    ErrStr:=L_DatTim.PeriodStr(curPerE) + "     ௫";
   END;
  END;
  IF ~!ErrStr THEN
   IF Strong THEN
    L_General.Assert_wReferToAdmin(0, ErrStr);
   ELSE
    L_StdFrm.Choice(ErrStr);
   END;
  END;
 END {CheckPer};

 PRIVATE PROCEDURE InsDefPFPacket(trgExtNbr: LIKE(Packet.ExtNbr); trgDataType: LIKE(Packet.DataType); trgCorrType: LIKE(Packet.CorrType));
 BEGIN
  IF ADV11After2009 THEN
   L_Packet.InsPFPacket(L_Packet.knd_PF_ADV11, trgExtNbr, PerB, PerE, trgDataType, trgCorrType);
  ELSE
   L_Packet.InsPFPacket(L_Packet.Get_PF_PacketKind(PerB, PerE, trgDataType, trgCorrType), trgExtNbr, PerB, PerE, trgDataType, trgCorrType);
  END;
 END {InsDefPFPacket};

 PRIVATE PROCEDURE PrepareForAll();
 BEGIN
  IF NeedConsolidated THEN
   SAVE(Packet);
   InsDefPFPacket(E_ManIns_ExtNbrForADV(), L_Packet.dt_None, L_Packet.ct_None);
   PacketForADV1X:=Packet.Packet;
   RESTORE(Packet);

   IF L_Packet.BuildMode = L_Packet.bm_byPacket THEN
    IF IsPacketForADV1X() THEN
     SELECT(PckAttr, PckBody, , Packet.Packet, EMPTYOF(PckAttr.SeqNbr));
     WHILE OCCURE(PckAttr) DO
      SAVE(PckAttr);
      PckAttr.Packet:=PacketForADV1X;
      INSERT(PckAttr);
      RESTORE(PckAttr);
      NEXT(PckAttr);
     END; (* WHILE OCCURE(PckAttr) ... *)
    END;
   END;
  ELSE
   DEC(CurPacket); (* ନ㥬 ᢮  -  ⢮   *)
  END; (* IF NeedConsolidated *)
 END {PrepareForAll};

 PRIVATE PROCEDURE SetDateParms(trgPerB, trgPerE: DATE);
 BEGIN
  PerB:=trgPerB;
  PerE:=trgPerE;

  L_DatTim.CheckWMIntvl(PerB, PerE);

  Year:=L_DatTim.YEAR(PerE);
  L_General.Assert(Year = L_DatTim.YEAR(PerB), "ਮ ᢥ    । ");
  PerAmount:=(L_DatTim.YEAR(PerE)-L_DatTim.YEAR(PerB))*12+L_DatTim.MONTH(PerE)-L_DatTim.MONTH(PerB)+1;
 END {SetDateParms};

 PRIVATE PROCEDURE SetPerByWord(WithOrigin: SCAL[2]);
  VAR
   QSign: STRING[4];
   bQ,
   eQ   : SCAL[4];
 BEGIN
  IF IsSince2001() THEN
   IF    IsSince2014() THEN
    bQ:=L_DatTim.QUARTAL(PerB);
    eQ:=L_DatTim.QUARTAL(PerE);
   ELSIF IsSince2011() THEN
    bQ:=L_DatTim.QUARTAL(PerB);
    eQ:=L_DatTim.QUARTAL(PerE);
   ELSIF IsSince2010() THEN
    bQ:=L_DatTim.QUARTAL(PerB);
    eQ:=L_DatTim.QUARTAL(PerE);
    IF (eQ = 0) | (eQ = 2) THEN
     INC(eQ);
    END;
   ELSIF IsSince2002() THEN
    bQ:=0; eQ:=3;
   ELSE
    bQ:=L_DatTim.QUARTAL(PerB);
    eQ:=L_DatTim.QUARTAL(PerE);
   END;

   SETEMPTY(Quarter);
   IF    IsSince2014() THEN
    IF    (bQ = 0) & (eQ = 0) THEN Quarter:=3;
    ELSIF (bQ = 0) & (eQ = 1) THEN Quarter:=6;
    ELSIF (bQ = 0) & (eQ = 2) THEN Quarter:=9;
    ELSIF (bQ = 0) & (eQ = 3) THEN Quarter:=0;
    END;
    IF !Quarter | (PerB # L_DatTim.YearBeg(PerB)) |
       ((PerE # L_DatTim.GetLastDateOfQuartal(PerE)) &
        ((L_Packet.BuildMode # L_Packet.bm_byPacket) | ~IsForPensPacket())) THEN
     L_General.Error(" "+Year+"     ਮ  砫    ⠫");
    END;
   ELSIF IsSince2011() THEN
    IF    (bQ = 0) & (eQ = 0) THEN Quarter:=1;
    ELSIF (bQ = 1) & (eQ = 1) THEN Quarter:=2;
    ELSIF (bQ = 2) & (eQ = 2) THEN Quarter:=3;
    ELSIF (bQ = 3) & (eQ = 3) THEN Quarter:=4;
    END;
    IF !Quarter | (PerB # L_DatTim.GetFirstDateOfQuartal(PerB)) |
       ((PerE # L_DatTim.GetLastDateOfQuartal(PerE)) &
        ((L_Packet.BuildMode # L_Packet.bm_byPacket) | ~IsForPensPacket())) THEN
     L_General.Error(" "+Year+"   ਮ   ⠫");
    END;
   ELSIF IsSince2010() THEN
    IF    (bQ = 0) & (eQ = 1) THEN Quarter:=1;
    ELSIF (bQ = 2) & (eQ = 3) THEN Quarter:=2;
    END;
    IF !Quarter | (PerB # L_DatTim.GetFirstDateOfQuartal(PerB)) |
       ((PerE # L_DatTim.GetLastDateOfQuartal(PerE)) &
        ((L_Packet.BuildMode # L_Packet.bm_byPacket) | ~IsForPensPacket())) THEN
     L_General.Error(" "+Year+"   ਮ   㣮");
    END;
   ELSE
    L_General.Assert((PerB = L_DatTim.YearBeg(PerB)) & (PerE = L_DatTim.YearEnd(PerE)), " "+Year+"   ਮ   楫 ");
    IF    bQ = 0 THEN    IF    eQ = 0 THEN Quarter:=5;
                         ELSIF eQ = 1 THEN Quarter:=2;
                         ELSIF eQ = 2 THEN Quarter:=1;
                         ELSE              Quarter:=0;
                         END;
    ELSIF bQ = 1 THEN    IF    eQ = 1 THEN Quarter:=6;
                         ELSIF eQ = 2 THEN Quarter:=3;
                         ELSE              Quarter:=9;
                         END;
    ELSIF bQ = 2 THEN    IF    eQ = 2 THEN Quarter:=7;
                         ELSE              Quarter:=4;
                         END;
    ELSE                                   Quarter:=8;
    END;
   END;
   IF    IsSince2014() THEN
    PerByWord:="() ["+  L_Str.PoolItem("3|6|9|0", eQ)+"]    "+Year;
   ELSIF IsSince2011() THEN
    PerByWord:="I ⠫ ["+  L_Str.PoolItem(" |X", eQ=0)+"] "+
               "I 㣮 ["+L_Str.PoolItem(" |X", eQ=1)+"] "+
               "9 楢 ["+  L_Str.PoolItem(" |X", eQ=2)+"] "+
               " ["+        L_Str.PoolItem(" |X", eQ=3)+"] ୮  "+Year;
   ELSIF IsSince2010() THEN
    PerByWord:="2010   㣮 ["+L_Str.PoolItem(" |X", eQ=1)+"]"+
                              "  ["+L_Str.PoolItem(" |X", eQ=3)+"]";
   ELSIF IsSince2002() THEN
    PerByWord:=Year+" ";
   ELSE
    QSign:="    ";
    WHILE bQ < eQ DO
     QSign[bQ]:="X";
     INC(bQ);
    END;
    PerByWord:="I["   + QSign[0] + "] " +
               "II["  + QSign[1] + "] " +
               "III[" + QSign[2] + "] " +
               "IV["  + QSign[3] + "] " +
               "⠫ " + Year + "";
   END;
  ELSE
   IF    (PerAmount = 12) | (PerAmount > 06) THEN
    Quarter:=0;
    PerByWord:=FLDTOSTR(PerE, " y ");
   ELSIF (PerAmount = 06) | (PerAmount > 03) THEN
    IF L_DatTim.QUARTAL(PerE) > 1 THEN
     Quarter:=4;
     PerByWord:=FLDTOSTR(PerE, "2 㣮 y ");
    ELSE
     Quarter:=2;
     PerByWord:=FLDTOSTR(PerE, "1 㣮 y ");
    END;
   ELSE
    Quarter:=L_DatTim.QUARTAL(PerE)+5;
    PerByWord:=L_DatTim.FullQuartStr(PerE, 3);
   END;
   PerByWord:=PerByWord+ "( ਮ "+L_Str.IntStr(Quarter)+")";
  END;
  IF WithOrigin THEN
   orgnPerByWord:=PerByWord;
   orgnPerE:=PerE;
   orgnYear:=Year;
   orgnQuarter:=Quarter;
  END;
 END {SetPerByWord};

 PRIVATE PROCEDURE GetActualDate(byPacket: SCAL[2]): DATE;
  VAR
   ManPerE,
   _ActualDate: DATE;
 BEGIN
  _ActualDate:=PerE;
  IF byPacket THEN
   L_General.Assert(ACCESS(Packet), " । ⥪騩 ");
   IF IsPacketForADV1X() THEN
    _ActualDate:=GetPckAttrAsDate(patt_ActualDate);
    IF !_ActualDate THEN
     _ActualDate:=PerE;
    END;
   ELSE
    CONFORM(Packet, PckBody);
    WHILE OCCURE(PckBody) DO
     ManPerE:=GetManPerE();
     IF ManPerE > _ActualDate THEN
      _ActualDate:=ManPerE;
     END;
     NEXT(PckBody);
    END; (* WHILE OCCURE(PckBody) ... *)
   END;
   RETURN _ActualDate;
  ELSE
   RETURN PerE;
  END;
 END {GetActualDate};

(*- PFrIP Begin---------------------------------------------------------------------------------------------*)

(*
$P{ PFrIP_Top:
?, L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
?, L, ""
Man.Name+"      : "+L_Packet.SINumberToAnyOut(Man.SINumber), C, ""
@
######################################################################################################################## ########## #####
=#####===================================================================================================================================
|#######################################################################################################################################|
|                                  ᫥  㯫祭 客   2010  2013                                |
|---------------------------------------------------------------------------------------------------------------------------------------|
|||ਮ         |   客   客    | 客   ⥫  |  |⠬              |
|- |  |               |-----------------------------------------|-----------------------------------------|       |                   |
| |  |               |    ᫥|     祭|    |    ᫥|     祭|    |       |                   |
}
*)


(*
$P{ PFrIP_Dlm:
@
|----|--|---------------|-------------|-------------|-------------|-------------|-------------|-------------|-------|-------------------|
}
*)

(*
$P{ PFrIP_Line:
GetCategoryNick(GetPacketCategoryFromAttr(Packet.Packet)), L, ""
GetPacketCntrTypeFromAttr(Packet.Packet, Man.Man), L, "|"
TMnIP.PerB, L, "N.y"
TMnIP.PerE, L, "N.y"
TMnIP.curInc[tp_PFIn], R, "2-"
TMnIP.curPaid[tp_PFIn], R, "2-"
?, R, "2-"
TMnIP.curInc[tp_PFAc], R, "2-"
TMnIP.curPaid[tp_PFAc], R, "2-"
?, R, "2-"
Packet.Packet, L, ""
L_Packet.PacketDTStampStr(), L, ""
@
|####|##|#######-#######|#############|#############|#############|#############|#############|#############|#######|###################|
}
*)

(*
$P{ PFrIP_Bot:
@
=(c) Polak===============================================================================================================================
}
*)

 PUBLIC PROCEDURE PFrIP();
  CONST
   RepName = "PFrIP";
  VAR
   curPerB,
   curPerE    : DATE;
   curPacket  : LIKE(Packet.Packet);
   curCategory: tCategory;
   curInc,
   curPaid,
   totUnPaid  : tPFSum;
 BEGIN
  APP.Get().NewPrompt("("+RepName+")");
  RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
  L_General.Assert(ACCESS(Man), " 㪠 ");
  ADV11After2009:=0;

  L_AFM.MakeMultipleIndex("TMnIP", "MyFirm  : LIKE(MyFirm.MyFirm);"+
                                   "Category: "+GET_TYPE_SPEC(tCategory).Name+";"+
                                   "CntrType: "+GET_TYPE_SPEC(L_Packet.tCntrType).Name+";"+
                                   "PerB: DATE;"+
                                   "PerE: DATE;"+
                                   "Packet: LIKE(Packet.Packet);"+
                                   "curInc:"+GET_TYPE_SPEC(tPFSum).Name+";"+
                                   "curPaid:"+GET_TYPE_SPEC(tPFSum).Name,
                          "TMnIP: MyFirm, Category, CntrType, PerB, PerE");
  CreatePkIdx();
  curPerB:=L_DatTim.Per(SYSDATE());

  SELECT(MyFirm, MyFirm);
  WHILE OCCURE(MyFirm) DO
   IF (MyFirm.MyFirm # P_Firm.mf_Fict) & (MyFirm.Till >= 01\01\2010) THEN
    L_Packet.PckMyFirm:=MyFirm.MyFirm;

    MakePckIndex(curPerB, Man.Man);
    SELECT(PkIdx, PkIdx);
    WHILE OCCURE(PkIdx) & (PkIdx.PerB < 01\01\2014) DO
     PerB:=PkIdx.PerB;
     DEFAULT(TMnIP);
     TMnIP.MyFirm  :=MyFirm.MyFirm;
     TMnIP.Category:=PkIdx.Category;
     TMnIP.CntrType:=PkIdx.CntrType;
     TMnIP.PerB:=PkIdx.PerB;
     TMnIP.PerE:=PkIdx.PerE;
     TMnIP.Packet:=PkIdx.Packet;
     GetCurPckIdxPerIncPaid(TMnIP.curInc, TMnIP.curPaid);
     INSERT(TMnIP);
     NEXT(PkIdx);
    END; (* WHILE OCCURE(PkIdx) ... *)
   END; (* IF (MyFirm.MyFirm # P_Firm.mf_Fict) & ... *)
   NEXT(MyFirm);
  END; (* WHILE OCCURE(MyFirm) ... *)

  OPENREP(R, L_General.NameConnection(RepName), Create);
  L_XDoc.sl_Init(" ᢥ");
  SELECT(TMnIP, TMnIP);
  WHILE OCCURE(TMnIP) DO
   MAKEPART(R, PFrIP_Top, P_Firm.MyFirmName(TMnIP.MyFirm, SYSDATE()), RepName);
   NARROWSEL(TMnIP, MyFirm);
   WHILE OCCURE(TMnIP) DO
    SETZERO(totUnPaid);
    MAKEPART(R, PFrIP_Dlm);
    NARROWSEL(TMnIP, Category, CntrType);
    FOR_EACH TMnIP DO
     SetDateParms(TMnIP.PerB, TMnIP.PerE);
     SEARCH(Packet, Packet, , TMnIP.Packet);
     PFSumINC(totUnPaid, TMnIP.curInc);
     PFSumDEC(totUnPaid, TMnIP.curPaid);
     MAKEPART(R, PFrIP_Line, totUnPaid[tp_PFIn], totUnPaid[tp_PFAc]);
     L_XDoc.sl_AddItem(L_XDoc.XDocId(L_XDoc.xdt_Packet, L_XDoc.EmptyXDocKind, Packet.Packet),
                       Str.Align(GetCategoryNick(TMnIP.Category), 4, LEFT)+" "+
                       Str.Align(L_Str.PoolItem(L_Packet.knd_Pool, Packet.Kind), 7, LEFT)+" "+
                       L_DatTim.PeriodStr(Packet.PerB)+"-"+L_DatTim.PeriodStr(Packet.PerE)+" "+
                       Str.Align(Packet.ExtNbr, 8, LEFT)+" "+
                       Packet.Packet+" "+
                       L_Packet.PacketDTStampStr() + " " +
                       L_Str.PoolItem(L_Packet.st_ShortPool, Packet.Status)+" "+
                       Str.Slice(L_Str.PoolItem(L_Packet.dt_Pool, Packet.DataType), 0, 3)+" "+
                       Str.Slice(L_Str.PoolItem(L_Packet.ct_Pool, Packet.CorrType), 0, 3));
    END; (* FOR_EACH TMnIP *)
    NEXTINEXTENDEDSEL(TMnIP, Category, CntrType);
   END; (* WHILE OCCURE(TMnIP) *)
   MAKEPART(R, PFrIP_Bot);
   NEXTINEXTENDEDSEL(TMnIP, MyFirm);
  END; (* WHILE OCCURE(TMnIP) *)

  CLOSEREP(R);
  L_AFM.AF_PurgeTemp("TMnIP");
  L_XDoc.sl_Done()
 END {PFrIP};

(*
$P{ PFCh_Top:
P_Firm.MyFirmName(TMnCh.MyFirm, SYSDATE()), L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
?, L, ""
?, L, "N.y"
?, C, ""
@
############################################################################################################################## ########## #####
=#####=========================================================================================================================================
|                宦  ᫥묨 客묨 ᠬ    ।묨   ᢥﬨ  01.2010  #######                 |
|#############################################################################################################################################|
|---------------------------------------------------------------------------------------------------------------------------------------------|
|ਮ         |   |||   客   客    | 客   ⥫  |  |⠬              |
|               |     |- |  |-----------------------------------------|-----------------------------------------|       |                   |
|               |     | |  |    ᫥|  |      |    ᫥|  |      |       |                   |
}
*)


(*
$P{ PFCh_Dlm:
@
|---------------|-----|----|--|-------------|-------------|-------------|-------------|-------------|-------------|-------|-------------------|
}
*)

(*
$P{ PFCh_Line:
TMnCh.PerB, L, "N.y"
TMnCh.PerE, L, "N.y"
TMnCh.Man, L, ""
GetCategoryNick(TMnCh.Category), L, ""
TMnCh.CntrType, L, "|"
TMnCh.realInc[tp_PFIn], R, "2-"
TMnCh.pfrInc[tp_PFIn], R, "2-"
TMnCh.realInc[tp_PFIn]-TMnCh.pfrInc[tp_PFIn], R, "2-"
TMnCh.realInc[tp_PFAc], R, "2-"
TMnCh.pfrInc[tp_PFAc], R, "2-"
TMnCh.realInc[tp_PFAc]-TMnCh.pfrInc[tp_PFAc], R, "2-"
?, L, ""
?, L, ""
@
|#######-#######|#####|####|##|#############|#############|#############|#############|#############|#############|#######|###################|
}
*)

(*
$P{ PFCh_Bot:
@
=(c) Polak=====================================================================================================================================
}
*)

 PRIVATE PROCEDURE CreateTMnCh();
 BEGIN
  CREATE_TABLE(TMnCh);
  CREATE_FIELD(TMnCh, MyFirm,   LIKE(MyFirm.MyFirm));
  CREATE_FIELD(TMnCh, Man,      LIKE(Man.Man));
  CREATE_FIELD(TMnCh, Category, tCategory);
  CREATE_FIELD(TMnCh, CntrType, L_Packet.tCntrType);
  CREATE_FIELD(TMnCh, PerB,     DATE);
  CREATE_FIELD(TMnCh, PerE,     DATE);
  CREATE_FIELD(TMnCh, Packet,   LIKE(Packet.Packet));
  CREATE_FIELD(TMnCh, pfrInc,   tPFSum, , "0");
  CREATE_FIELD(TMnCh, realInc,  tPFSum, , "0");

  CREATE_INDEX(TMnCh, TMnCh, UNIQUE, , , MyFirm, PerB, PerE, Man, Category, CntrType);
  SET_VERSION_OF_TABLE(TMnCh, 0000);
  L_AFM.CreateTemp("TMnCh");
 END {CreateTMnCh};

 PRIVATE PROCEDURE MakeSelManSFeeTMnCh(From, Till: DATE);
  VAR
   curPerB,
   curPerE: DATE;
   curMan : LIKE(Man.Man);
 BEGIN
  TRY [RESTORE_CURSORS(RC_ON)]
   PROMPT(ManSFee.MyFirm+" "+ManSFee.Man);
   curMan:=ManSFee.Man;
   curPerE:=Till-1;
   curPerB:=L_Packet.Get_PF_StdPerB(curPerE);
   WHILE curPerB >= From DO
    IF curPerE > 01\01\2014 THEN
     SetDateParms(L_DatTim.GetFirstDateOfQuartal(curPerE), curPerE);
    ELSE
     SetDateParms(curPerB, curPerE);
    END;
    SETSEL(CnTpP, CnTpP); REMSEL(CnTpP);
    PrepareCnTpP(curMan);
    SRCINSEL(ManSFee, GE, , PerB);
    WHILE OCCURE(ManSFee) & (ManSFee.Period < PerE) DO
     CONFORM(ManSFee, Man);
     IF IsSince2014() THEN
      ADD(TMnCh, TMnCh, , ManSFee.MyFirm, curPerB, curPerE, ManSFee.Man,
                          EMPTYOF(tCategory),
                          EMPTYOF(L_Packet.tCntrType),
                          TMnCh.realInc[tp_PFIn], ManSFee.Fee[L_SFee.p_PFIn],
                          TMnCh.realInc[tp_PFAc], ManSFee.Fee[L_SFee.p_PFAc]);
     ELSE
      ADD(TMnCh, TMnCh, , ManSFee.MyFirm, curPerB, curPerE, ManSFee.Man,
                          GetMSFeeTypeCategory(ManSFee.Period, ManSFee.Type),
                          GetManCntrType(ManSFee.Period),
                          TMnCh.realInc[tp_PFIn], ManSFee.Fee[L_SFee.p_PFIn],
                          TMnCh.realInc[tp_PFAc], ManSFee.Fee[L_SFee.p_PFAc]);
     END;
     NEXT(ManSFee);
    END; (* WHILE OCCURE(ManSFee) *)
    L_Packet.Get_PF_PrvPer(curPerB, curPerE);
   END; (* WHILE curPerB > From ... *)
  EXCEPT
  END;
 END {MakeSelManSFeeTMnCh};

 PRIVATE PROCEDURE intPFCh(RepName: STRING[]; trgMan: LIKE(Man.Man));
  VAR
   Till,
   StartD : DATE;
   pfrInc,
   pfrPaid: tPFSum;
 BEGIN
  RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
  APP.Get().NewPrompt(RepName);
  ADV11After2009:=0;
  CreateTMnCh();
  CreatePkIdx();
  CreateCnTpP();
  Till:=L_DatTim.GetFirstDateOfQuartal(SYSDATE());

  SELECT(MyFirm, MyFirm);
  WHILE OCCURE(MyFirm) DO
   IF (MyFirm.MyFirm # P_Firm.mf_Fict) THEN
    L_Packet.PckMyFirm:=MyFirm.MyFirm;
    StartD:=L_Packet.Get_PF_ProgressiveTotalPersAcc_Start();

    MakePckIndex(Till, trgMan);
    SELECT(PkIdx, PkIdx);
    WHILE OCCURE(PkIdx) DO
     PROMPT(L_DatTim.PeriodStr(PkIdx.PerB)+" - "+L_DatTim.PeriodStr(PkIdx.PerE));
     NARROWSEL(PkIdx, PerB, PerE);
     IF PkIdx.PerB >= StartD THEN
      SetDateParms(PkIdx.PerB, PkIdx.PerE);
      FOR_EACH PkIdx DO
       GetCurPckIdxPerIncPaid(pfrInc, pfrPaid);
       ADD(TMnCh, TMnCh, , L_Packet.PckMyFirm, PkIdx.PerB, PkIdx.PerE, PkIdx.Man,
                           PkIdx.Category, PkIdx.CntrType,
                           TMnCh.pfrInc[tp_PFIn],  pfrInc[tp_PFIn],
                           TMnCh.pfrInc[tp_PFAc],  pfrInc[tp_PFAc]);
       L_General.CallUs(!TMnCh.Packet);
       TMnCh.Packet :=PkIdx.Packet;
       REPLACE(TMnCh);
      END; (* FOR_EACH PkIdx *)
     END; (* IF PkIdx.PerB >= StartD ... *)
     NEXTINEXTENDEDSEL(PkIdx, PerB, PerE);
    END; (* WHILE OCCURE(PkIdx) ... *)

    IF ~!trgMan THEN
     IF SELECT(ManSFee, Actual, 1, MyFirm.MyFirm, trgMan) THEN
      MakeSelManSFeeTMnCh(StartD, Till);
     END;
    ELSE
     SELECT(ManSFee, Actual, , 1, MyFirm.MyFirm);
     WHILE OCCURE(ManSFee) DO
      NARROWSEL(ManSFee, Man);
      MakeSelManSFeeTMnCh(StartD, Till);
      NEXTINEXTENDEDSEL(ManSFee, Man);
     END; (* WHILE OCCURE(ManSFee) *)
    END; (* IF ~!trgMan ... *)
   END; (* IF (MyFirm.MyFirm # P_Firm.mf_Fict) ...*)
   NEXT(MyFirm);
  END; (* WHILE OCCURE(MyFirm) ... *)

  OPENREP(R, L_General.NameConnection(RepName), Create);
  SELECT(TMnCh, TMnCh);
  WHILE OCCURE(TMnCh) DO
   NARROWSEL(TMnCh, MyFirm);
   IF ~!trgMan THEN
    MAKEPART(R, PFCh_Top, RepName, L_DatTim.PrevPer(Till), ": "+Man.Name);
   ELSE
    MAKEPART(R, PFCh_Top, RepName, L_DatTim.PrevPer(Till), "( )");
   END;
   WHILE OCCURE(TMnCh) DO
    NARROWSEL(TMnCh, PerB, PerE);
    SetDateParms(TMnCh.PerB, TMnCh.PerE);
    WHILE OCCURE(TMnCh) DO
     NARROWSEL(TMnCh, Man);
     WHILE OCCURE(TMnCh) DO
      IF ~PFSumIsZERO(PFSumSUB(TMnCh.pfrInc, TMnCh.realInc)) THEN
       MAKEPART(R, PFCh_Dlm);
       IF ~!TMnCh.Packet THEN
        SEARCH(Packet, Packet, , TMnCh.Packet);
        MAKEPART(R, PFCh_Line, Packet.Packet, L_Packet.PacketDTStampStr());
       ELSE
        MAKEPART(R, PFCh_Line);
       END;
      END;
      NEXT(TMnCh);
     END; (* WHILE OCCURE(TMnCh) *)
     NEXTINEXTENDEDSEL(TMnCh, Man);
    END; (* WHILE OCCURE(TMnCh) *)
    NEXTINEXTENDEDSEL(TMnCh, PerB, PerE);
   END; (* WHILE OCCURE(TMnCh) *)
   MAKEPART(R, PFCh_Bot);
   NEXTINEXTENDEDSEL(TMnCh, MyFirm);
  END; (* WHILE OCCURE(TMnCh) *)
  CLOSEREP(R);
  L_AFM.AF_PurgeTemp("TMnCh");
  L_AFM.AF_PurgeTemp("PkIdx");
  L_General.SurveyLastReport();
 END {intPFCh};

 PUBLIC PROCEDURE PFChA();
  CONST
   RepName = "PFChA";
 BEGIN
  intPFCh(RepName, EMPTYOF(Man.Man));
 END {PFChA};

 PUBLIC PROCEDURE PFChM();
  CONST
   RepName = "PFChM";
 BEGIN
  L_General.Assert(ACCESS(Man), " 㪠 ");
  intPFCh(RepName, Man.Man);
 END {PFChM};

(*- PFrIP End-----------------------------------------------------------------------------------------------*)

 PRIVATE PROCEDURE CheckPrvUnDonePackets();
  CONST
   Begin = 01\01\2013; (*15.07.2013 16:18:52 POLAK\Bor. 0098251    01.2010,   ᯮ墠⨫*)
  VAR
   prvPerB,
   prvPerE    : DATE;
   curCategory: tCategory;
 BEGIN
  APP.Get().NewPrompt("஢ઠ ᤠ ⮢");
  SAVE(Packet);
  prvPerB:=PerB;
  prvPerE:=PerE;
  WHILE prvPerB > Begin DO
   L_Packet.Get_PF_PrvPer(prvPerB, prvPerE);
   PROMPT(L_DatTim.PeriodStr(prvPerB)+"-"+L_DatTim.PeriodStr(prvPerE));
   L_Packet.CheckUnDonePacketsStrong(L_Packet.Get_PF_PacketKind(prvPerB, prvPerE, L_Packet.dt_Basic, L_Packet.ct_None),
                                     prvPerB, prvPerE, L_Packet.dt_Basic, L_Packet.ct_None);
  END; (* WHILE prvPerB > ... *)
  RESTORE(Packet);
 END {CheckPrvUnDonePackets};

 PUBLIC PROCEDURE SingleManIns();
  VAR
   Dummy: SCAL[2];
   nPack: L_XML.tNode;
 BEGIN
  RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
  L_General.Assert(ACCESS(Man), " ⠭ 䨧᪮ ");
  ADV11After2009:=0;
  TRY [ABORT_AFTER(AA_ON)]
   InitServices(Memo.ud_fr(), Memo.ud_ut(), "ନ஢ ᢥ  | | - " + FLDTOSTR(Man.Man, "0", 6) + " " + Man.Name);
   CurPacket:=L_Packet.trn_Init(GetActualDate(0), L_Packet.bm_bySingle, L_Packet.part_Manins,
                                L_Packet.Get_PF_PacketKind(PerB, PerE, L_Packet.dt_Basic, L_Packet.ct_None));
   CheckPer();
   SetPerByWord(1);
   InsDefPFPacket(CurPacket, L_Packet.dt_Basic, L_Packet.ct_None);
   CurNumInP     :=0001;
   TotNumInP     :=CurNumInP;
   L_Packet.trn_OpenFiles();
   nPack:=L_Packet.trn_PutHead();

   L_Packet.MakeProjectPrt();
   PrepareCnTpP(Man.Man);
   PrepareMsForMoney();
   PutManInIntrm(PerB, PerE);

   IF SELECT(Intrm, Intrm) THEN
    SetPckBodyByIntrm(CurPacket);
    WHILE OCCURE(Intrm) DO
     PROMPT("⮢ ⮢ "+ Intrm.Man);
     SETZERO(pSum, pPns, pSum1, pSum2, pInc, pPaid, SZVXx, pObject, pBase, pOvrPrt);
     NARROWSEL(Intrm, Category, CntrType, Group, PckKind, DataType, CorrType, Separate);
     WHILE OCCURE(Intrm) DO
      CurNumInP:=0;
      PrepareOneMan(PerB, PerE);
      CheckPrb01();
      SZVX_2_Count:=0;
      MakeOneMan(nPack);
      Fill_SZV_X_2();
      ClearServices(0);
      NEXT(Intrm);
     END;
     NEXTINEXTENDEDSEL(Intrm, Category, CntrType, Group, PckKind, DataType, CorrType, Separate);
    END;

    L_Packet.trn_CloseFiles(nPack);
    DeInitServices();
   ELSE
    CheckPrb01();
    L_StdFrm.BlueHalt(" 室   ᢥ");
   END;
  EXCEPT
  END;
  Dummy:=L_Packet.ChoosePacket(L_Packet.Get_PF_PacketKind(PerB, PerE, L_Packet.dt_Basic, L_Packet.ct_None),
                               PerB, PerE,
                               L_Packet.dt_Basic, L_Packet.ct_None);
  L_General.SurveyLastReport();
 END {SingleManIns};

 PUBLIC PROCEDURE CalcNumOfInsMen(trgMyFirm: LIKE(MyFirm.MyFirm); trgPerB, trgPerE: DATE): NUMERIC[0];
  VAR
   Till,
   lastPerB,
   lastPerE: DATE;
   Result  : NUMERIC[0];
 BEGIN
  APP.Get().NewPrompt(" ⢠ ");
  TRY [ABORT_AFTER(AA_ON)]
   RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
   L_Packet.PckMyFirm:=trgMyFirm;
   Till:=L_DatTim.NextPer(trgPerE);
   lastPerE:=trgPerE;
   lastPerB:=L_Packet.Get_PF_StdPerB(lastPerE);
   SELECT(Packet, PacketKn, , L_Packet.rcv_PensFund, L_Packet.knd_PF_ADV6_2, lastPerB, lastPerE);
   WHILE OCCURE(Packet) & ~L_Packet.IsValidPacket() DO
    NEXT(Packet);
   END; (* WHILE OCCURE(Packet) ... *)
   IF ~OCCURE(Packet) THEN
    SETEMPTY(Result);
   ELSE
    Result:=0;
    CreatePkIdx();
    intMakePckIndex(trgPerB, Till, EMPTYOF(Man.Man));
    SELECT(PkIdx, Man);
    WHILE OCCURE(PkIdx) DO
     L_General.CallUs((PkIdx.PerB >= trgPerB) & (PkIdx.PerE <= trgPerE));
     INC(Result);
     NARROWSEL(PkIdx, Man, Category);
     NEXTINEXTENDEDSEL(PkIdx, Man, Category);
    END; (* WHILE OCCURE(PkIdx) ... *)
   END;
  EXCEPT
  END;
  RETURN Result;
 END {CalcNumOfInsMen};

 PRIVATE PROCEDURE intManPeriodE(ViewOnly: SCAL[2]);
  VAR
   ManPerE: DATE;
 BEGIN
  L_General.Assert(ACCESS(PckBody), " । ப ");
  CONFORM(PckBody, Packet);
  CONFORM(PckBody, Man);
  ManPerE:=GetPckBodyManPerE();
  STDFORM(L_StdFrm.sf_Choice("|  %#####% %########################################%" +
                             "|" +
                             "| 砭 ਮ ᢥ            %##########%" ,
                             "%NI%NI%<D.N.y>"+L_Str.PoolItem("I|NI", ViewOnly)),
          " ࠭祭 ਮ ",
          ,
          -1,
          PckBody.Man,
          Man.Name,
          ManPerE);
  IF ~ViewOnly THEN
   PutManPerE(ManPerE);
  END;
 END {intManPeriodE};

 PUBLIC PROCEDURE EditManPeriodE();
 BEGIN
  intManPeriodE(0);
 END {EditManPeriodE};

 PUBLIC PROCEDURE ViewManPeriodE();
 BEGIN
  intManPeriodE(1);
 END {ViewManPeriodE};

 PRIVATE PROCEDURE intManPaid(ViewOnly: SCAL[2]);
  VAR
   curPerB,
   curPerE: DATE;
   PFPart : tPFPart;
   curInc,
   trgPaid: tPFSum;
 BEGIN
  L_General.Assert(ACCESS(PckBody), " । ப ");
  CONFORM(PckBody, Packet);
  CONFORM(PckBody, Man);
  L_General.Assert(Packet.Kind = L_Packet.knd_PF_SPV1, "ਬ ⮫쪮  祪  ଥ -1");
  L_Packet.PckMyFirm:=Packet.MyFirm;
  PerB:=Packet.PerB;
  PerE:=Packet.PerE;
  curInc:=GetPFSumForPer(PerBMoney(GetManPerB()), PerEMoney(GetManPerE()));
  FOR_EACH PFPart DO
   trgPaid[PFPart]:=STRTOFLD(L_Packet.GetPckBodyAttr(PckBody.Packet, PckBody.SeqNbr, patt_CurPaid[PFPart]), NUMERIC);
  END;
  STDFORM(L_StdFrm.sf_Choice("|  %#####% %####################################################%" +
                             "||" +
                             "⮥ 祭  砥,    ᠬ " +
                             "|  (㯫祭   ꥬ)" +
                             "|                           客   ⥫  " +
                             "|᫥ (ࠢ筮) %####################% %####################%" +
                             "|祭              %####################% %####################%",
                             "%NI%NI%RNI%RNI"+L_Str.PoolItem("%RYI|%RNYI", ViewOnly)+L_Str.PoolItem("%RYI|%RNYI", ViewOnly)),
          " '祭'   ਮ ",
          ,
          -1,
          PckBody.Man,
          Man.Name,
          curInc[tp_PFIn],  curInc[tp_PFAc],
          trgPaid[tp_PFIn], trgPaid[tp_PFAc]);
  IF ~ViewOnly THEN
   FOR_EACH PFPart DO
    L_Packet.PutPckBodyAttr(PckBody.Packet, PckBody.SeqNbr, patt_CurPaid[PFPart], FLDTOSTR(trgPaid[PFPart]));
   END;
  END;
 END {intManPaid};

 PUBLIC PROCEDURE EditManPaid();
 BEGIN
  intManPaid(0);
 END {EditManPaid};

 PUBLIC PROCEDURE ViewManPaid();
 BEGIN
  intManPaid(1);
 END {ViewManPaid};

 PRIVATE PROCEDURE intMakeManIns();
 BEGIN
  BuildPackets();
  MakeAll();
  DeInitServices();
  L_Packet.ShowMakedPackets();
 END {intMakeManIns};

 PUBLIC PROCEDURE InitialAll();
  VAR
   curKind: LIKE(Packet.Kind);
   Msg: STRING[];
   i  : NUMERIC[0];
   TotPrvOver,
   TotCurOver,
   TotPrvInc,
   TotPrvPaid,
   TotCurInc,
   TotCurPaid,
   TotOldPaid: tPFSum;
 BEGIN
  L_General.CallUs(0);
  ADV11After2009:=0;
  NeedConsolidated:=1;
  InitServices(Memo.ud_fr(), Memo.ud_ut(), "ࢮ砫쭮 ନ஢ ᢥ  ");
  curKind:=L_Packet.Get_PF_PacketKind(PerB, PerE, L_Packet.dt_Basic, L_Packet.ct_None);

  APP.Get().NewPrompt(L_Str.PoolItem(L_Packet.knd_Pool, curKind));

  CurPacket:=L_Packet.trn_Init(GetActualDate(0), L_Packet.bm_byAll, L_Packet.part_Manins, curKind);
  CheckPer();
  SetPerByWord(1);
  L_Packet.CheckExistingPacketsStrong(curKind, PerB, PerE, L_Packet.dt_Basic, L_Packet.ct_None);
  IF PerB = 01\01\2013 THEN (*23.04.2013 19:53:29 POLAK\Bor 0097154 .4*)
   L_Packet.CheckExistingPacketsStrong(L_Packet.knd_PF_SZV6, PerB, PerE, L_Packet.dt_Basic, L_Packet.ct_None);
  END;
  CheckPrvUnDonePackets();

  PrepareForAll();

  IF IsSince2010() THEN
   SETZERO(TotCurOver);
   L_AFM.MakeIndex("TmpCP", "PerB: DATE;"+
                            "PerE: DATE;"+
                            "Packet: LIKE(Packet.Packet)");
   SELECT(Packet, PckDTSKn, , L_Packet.rcv_PensFund, L_Packet.SampleDTStamp);
   WHILE OCCURE(Packet) DO
    IF (Packet.Status = L_Packet.st_Prepared) & (Packet.MyFirm = L_Packet.PckMyFirm) &
       (Packet.PerB >= 01\01\2010) & (Packet.PerE < Memo.ud_fr()) &
       ((Packet.Kind = L_Packet.knd_PF_SZV6_4) |
        (Packet.Kind = L_Packet.knd_PF_SZV6))  THEN
     L_General.Assert(IsCorrPacket(), "-ࠧ "+Packet.Packet+"    '室'");
     ADD(TmpCP, TmpCP, , Packet.PerB, Packet.PerE, Packet.Packet);
    END;
    NEXT(Packet);
   END; (* WHILE OCCURE(Packet) ... *)

   IF SELECT(TmpCP, TmpCP) THEN
    L_Packet.BuildMode:=L_Packet.bm_byPacket;
    NeedConsolidated:=0;

    Msg:="";
    WHILE OCCURE(TmpCP) DO
     i:=0;
     SELECT(PckBody, Packet, , TmpCP.Packet);
     WHILE OCCURE(PckBody) DO
      INC(i);
      NEXT(PckBody);
     END; (* WHILE OCCURE(PckBody) ... *)
     Msg:=Msg+"|"+L_DatTim.PeriodStr(TmpCP.PerB)+"-"+L_DatTim.PeriodStr(TmpCP.PerE)+"  : "+TmpCP.Packet+"  :"+Str.Align(L_Str.IntStr(i), 4, RIGHT);
     NEXT(TmpCP);
    END; (* WHILE OCCURE(TmpCP) ... *)
    L_StdFrm.Question(" ନ஢ ४騥 ᢥ  ⠬-ࠧ栬:|"+Msg);
  
    SETZERO(TotPrvOver);
    SELECT(TmpCP, TmpCP);
    WHILE OCCURE(TmpCP) DO
     SetDateParms(TmpCP.PerB, TmpCP.PerE);
     SETSEL(CnTpP, CnTpP); REMSEL(CnTpP);

     SETZERO(TotPrvInc, TotPrvPaid, TotCurInc, TotOldPaid);
     NARROWSEL(TmpCP, PerB, PerE);
     WHILE OCCURE(TmpCP) DO
      SEARCH(Packet, Packet, , TmpCP.Packet);
      SetPerByWord(0); (*0100116 13.11.2013 18:28:20 POLAK\Bor*)
      PrepareCnTpP_byPacket();
      L_Packet.SetSamplePacketDone();
      PrepareTmpIncPaidByPacket(TotPrvInc, TotPrvPaid, TotCurInc, TotOldPaid);
      NEXT(TmpCP);
     END; (* WHILE OCCURE(TmpCP) *)
  
     TotCurOver:=CalcOver(TotPrvOver, TotPrvInc, TotPrvPaid, TotCurInc, TotOldPaid);
     TotCurPaid:=TotOldPaid;
     PFSumINC(TotCurPaid, TotPrvOver);
     PFSumDEC(TotCurPaid, TotCurOver);
     TotPrvOver:=TotCurOver;
     CalculateCurPaid(TotPrvInc, TotPrvPaid, TotCurInc, TotCurPaid);
  
     FIRST(TmpCP);
     WHILE OCCURE(TmpCP) DO
      SEARCH(Packet, Packet, , TmpCP.Packet);
      MakeByPacket();
      NEXT(TmpCP);
     END; (* WHILE OCCURE(TmpCP) *)
  
     BuildPackets();
     MakeAll();
     ClearServices(1);
     NEXTINEXTENDEDSEL(TmpCP, PerB, PerE);
    END; (* WHILE OCCURE(TmpCP) *)

    IF ~PFSumIsZERO(TotCurOver) THEN
     L_StdFrm.Inform(" ४஢ ᢥ 㬥襭 ''  ࠧ"+
                     "|客     : "+Str.Align(MoneyToTxt(TotCurOver[tp_PFIn]), 12, RIGHT)+
                     "|⥫쭠 : "+Str.Align(MoneyToTxt(TotCurOver[tp_PFAc]), 12, RIGHT)+
                     "|७ᥭ  砫 ⭮ ਮ"+
                     "|. '९  "+L_DatTim.PeriodStr(PerB)+"'");
    END;

    L_Packet.BuildMode:=L_Packet.bm_byAll;
    NeedConsolidated:=1;
    SetDateParms(Memo.ud_fr(), Memo.ud_ut());
    SetPerByWord(0);
   END; (* IF SELECT(TmpCP, TmpCP) ... *)
   IF IsSince2013() THEN
    PrepareCnTpP_byAll();
   END;
   PreparePaidDataForAll(TotCurOver);
  END; (* IF IsSince2010() ... *)

  PrepareGroup();
  intMakeManIns();
 END {InitialAll};

 PUBLIC PROCEDURE ByCurrentPacket();
  VAR
   dmyCurPaid,
   TotPrvInc,
   TotPrvPaid,
   TotCurInc,
   TotCurPaid: tPFSum;
   nxtPerB,
   nxtPerE   : DATE;
 BEGIN
  L_General.Assert(ACCESS(Packet), " । ");
  ADV11After2009:=(Packet.PerB >= 01\01\2010) & (Packet.Kind = L_Packet.knd_PF_ADV11);
  IF (Packet.Kind # L_Packet.knd_PF_SPV1) & (Packet.PerB >= 01\01\2010) & ~ADV11After2009 THEN
   L_General.Error("ࢮ砫쭮 ନ஢ ᢥ    ४஢ । ਮ"+
                   '|믮  "F10 - ᮭ - ௫ - ⮣ -|ᮭ஢    -|ନ஢ ᢥ  ⠦  ᫥   ᥬ  ਮ"');
  ELSE
   NeedConsolidated:=(Packet.Kind # L_Packet.knd_PF_SPV1);
   InitServices(Packet.PerB, Packet.PerE, "ନ஢ ᢥ    ⥪饩 窥");
 
   L_Packet.SetSamplePacketDone();
   SAVE(Packet);
   CurPacket:=L_Packet.trn_Init(GetActualDate(1), L_Packet.bm_byPacket, L_Packet.part_Manins, Packet.Kind);
   CheckPer();

   PrepareForAll();
   RESTORE(Packet);

   PrepareCnTpP_byPacket();

   IF IsSince2010() THEN
    L_General.CallUs(Packet.Kind = L_Packet.knd_PF_SPV1);
    SETZERO(TotPrvInc, TotPrvPaid, TotCurInc, TotCurPaid, TotCurPaid, dmyCurPaid);

    IF (Packet.Kind = L_Packet.knd_PF_SPV1) & IsCorrPacket() THEN
     GetNxtPer(PerB, nxtPerB, nxtPerE);
     SetDateParms(nxtPerB, nxtPerE);
     SetPerByWord(1);
     SetDateParms(Packet.PerB, Packet.PerE);
     SetPerByWord(0);
    ELSE
     SetPerByWord(1);
    END;

    PrepareTmpIncPaidByPacket(TotPrvInc, TotPrvPaid, TotCurInc, dmyCurPaid);

    IF L_Packet.HasExistingPackets(L_Packet.Get_PF_PacketKind(PerB, PerE, L_Packet.dt_Basic, L_Packet.ct_None),
                                   PerB, GetStdPerE(PerB), L_Packet.dt_Basic, L_Packet.ct_None) THEN
     SELECT(TmpIP, Man);
     WHILE OCCURE(TmpIP) DO
      PROMPT("। '祭' "+TmpIP.Man);
      TmpIP.CurPaid:=TmpIP.OldPaid;
      REPLACE(TmpIP);
      NEXT(TmpIP);
     END; (* WHILE OCCURE(TmpIP) ... *)
    ELSE
     (*  100% .0086581. 13.07.2011 18:34:19 AK1375\Bor.Polak *)
     SELECT(TmpIP, Man);
     WHILE OCCURE(TmpIP) DO
      PROMPT("। '祭' "+TmpIP.Man);
      PFSumINC(TmpIP.CurPaid, TmpIP.CurInc);
      PFSumINC(TmpIP.CurPaid, TmpIP.PrvInc);
      PFSumDEC(TmpIP.CurPaid, TmpIP.PrvPaid);
      REPLACE(TmpIP);
      NEXT(TmpIP);
     END; (* WHILE OCCURE(TmpIP) ... *)
    END;
   ELSE
    SetPerByWord(1);
   END; (* IF IsSince2010() ... *)
   MakeByPacket();
 
   intMakeManIns();
  END;
 END {ByCurrentPacket};

 PUBLIC PROCEDURE MakeCorrPacket(trgPerB, trgPerE: DATE; trgCurPacket: LIKE(Packet.Packet)): NUMERIC[0];
  VAR
   curKind: LIKE(Packet.Kind);
   TotPrvOver,
   TotCurOver,
   TotPrvInc,
   TotPrvPaid,
   TotCurInc,
   TotCurPaid,
   TotOldPaid: tPFSum;
 BEGIN
  ADV11After2009:=0;
  NeedConsolidated:=0;
  InitServices(trgPerB, trgPerE, "");

  APP.Get().NewPrompt("४騥 ᢥ");

  SetPerByWord(1);

  CurPacket:=trgCurPacket;

  L_General.CallUs(IsSince2010());

  SETZERO(TotCurOver);
  L_Packet.BuildMode:=L_Packet.bm_byPacket;

  L_General.CallUs(OCCURE(TmpCP));

  SETZERO(TotPrvOver);
  SELECT(TmpCP, TmpCP);
  WHILE OCCURE(TmpCP) & (TmpCP.PerE < 01\01\2014) DO
   SetDateParms(TmpCP.PerB, TmpCP.PerE);
   SETSEL(CnTpP, CnTpP); REMSEL(CnTpP);
   NARROWSEL(TmpCP, PerB, PerE);

   TRY [ABORT_AFTER(AA_ON)]
    curKind:=L_Packet.Get_PF_PacketKind(TmpCP.PerB, TmpCP.PerE, L_Packet.dt_Basic, L_Packet.ct_None);
    PROMPT(L_Str.PoolItem(L_Packet.knd_Pool, curKind)+" "+L_DatTim.PeriodStr(TmpCP.PerB)+"-"+L_DatTim.PeriodStr(TmpCP.PerE));
 
    DEFAULT(Packet);
    L_Packet.InsSamplePFPacket(curKind, TmpCP.PerB, TmpCP.PerE, L_Packet.dt_None, L_Packet.ct_Corr);
 
    SetPerByWord(0); (*0100116 13.11.2013 18:28:20 POLAK\Bor*)
    SETZERO(TotPrvInc, TotPrvPaid, TotCurInc, TotOldPaid);
    WHILE OCCURE(TmpCP) DO
     DEFAULT(PckBody);
     PckBody.Packet:=Packet.Packet;
     PckBody.Man:=TmpCP.Man;
     INSERT(PckBody);
 
     PrepareCnTpP(TmpCP.Man);
     PrepareTmpIncPaidByTmpCP(TotPrvInc, TotPrvPaid, TotCurInc, TotOldPaid);
     NEXT(TmpCP);
    END; (* WHILE OCCURE(TmpCP) *)
 
    TotCurOver:=CalcOver(TotPrvOver, TotPrvInc, TotPrvPaid, TotCurInc, TotOldPaid);
    TotCurPaid:=TotOldPaid;
    PFSumINC(TotCurPaid, TotPrvOver);
    PFSumDEC(TotCurPaid, TotCurOver);
    TotPrvOver:=TotCurOver;
    CalculateCurPaid(TotPrvInc, TotPrvPaid, TotCurInc, TotCurPaid);
 
    FIRST(TmpCP);
    WHILE OCCURE(TmpCP) DO
     MakePckIndex(L_DatTim.NextPer(GetStdPerE(TmpCP.PerB)), TmpCP.Man);
     SEARCH(Man, Man, , TmpCP.Man);
     PutManInIntrm(TmpCP.PerB, TmpCP.PerE);
     NEXT(TmpCP);
    END; (* WHILE OCCURE(TmpCP) *)
  
   EXCEPT
   END; (* TRY *)

   BuildPackets();
   MakeAll();
   ClearServices(1);
   NEXTINEXTENDEDSEL(TmpCP, PerB, PerE);
  END; (* WHILE OCCURE(TmpCP) *)

  IF ~PFSumIsZERO(TotCurOver) THEN
   L_StdFrm.Inform(" ४஢ ᢥ 㬥襭 ''  ࠧ"+
                   "|客     : "+Str.Align(MoneyToTxt(TotCurOver[tp_PFIn]), 12, RIGHT)+
                   "|⥫쭠 : "+Str.Align(MoneyToTxt(TotCurOver[tp_PFAc]), 12, RIGHT)+
                   "|७ᥭ  砫 ⭮ ਮ"+
                   "|. '९  "+L_DatTim.PeriodStr(PerB)+"'");
  END;
  RETURN CurPacket;
 END {MakeCorrPacket};

END.
