(*
%Copyright   (c) Polak Computer System
%Author      14.05.1998 13:11:44 SAN
%Purpose     ࠢ 䨪樥 ᪫᪨ 㬥⮢
%Type        control
%Specific    SYS
%Modified    19.09.2014 18:23:08 POLAK\Bor
*)

 MODULE MDoc [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT L_General, L_DatTim, L_Events, L_MDoc, L_APtm, L_Fuel, L_MSO, L_XDoc, L_CI,
        L_Way, L_Pmnt, L_Staff, L_StdFrm, L_MathR, L_PDoc, L_Acnt, L_DBD,
        L_Str, L_AFM, L_Car, L_Card, L_XDR, L_Rpr, L_Russia, MDocP_MO, L_Dest,
        P_Man, P_Firm, P_Cntr, Str, Math, Memo, E_Stock, E_Pmnt, L_Env,
        L_XObj, P_MDoc, L_CUC, L_SES, L_BarCode, E_Prop, L_EC, L_Prop, L_IsSData,
        L_Print, L_Cntr, L_Stock, L_WDO, P_Storage, P_OwnData, P_Officer, P_Math, L_AR,
        L_AcsPnt, L_JDoc, L_Man, L_qs, E_Rpr;

 PRIVATE TYPE
  tMDocStorageEquipping = SCAL[4];

 PRIVATE CONST
  mse_NoAcMthL    = 0;
  mse_NoStorage   = 1;
  mse_Only1       = 2;
  mse_Both        = 3;

  SrcNbr_Without = "/";
  SrcNbr_Order   = "";

  Hint_SaveInPrepared = "६ 㬥  ࠭  ﭨ '⮢'";

 PRIVATE VAR
  _s                  : NUMERIC[0];
  NeedSetRWayF,
  RWayFHasChanged     : SCAL[2];
  MDocStorageEquipping: tMDocStorageEquipping;

 PRIVATE PROCEDURE IsBuildByGasStan(): SCAL[2];
 BEGIN
  RETURN L_WDO.GetEnvVarValue("MDocSource") = "GasStan";
 END {IsBuildByGasStan};

 PRIVATE PROCEDURE IsBuildDocByBCS(): SCAL[2];
 BEGIN
  RETURN L_WDO.GetEnvVarValue("UsingBCS") = "True";
 END {IsBuildDocByBCS};

 PRIVATE PROCEDURE CheckMCurPer(Stream: SCAL[2]);
  VAR
   Kinds: SCAL[2][MAXOF(Math.MathKind)+1];
 BEGIN
  Memo.gl_SetCurDate(MDoc.Date);
  IF L_MDoc.IsMDoc_woMath(MDoc.MDocKind) THEN
   IF ~Stream THEN
    L_APtm.ANYSystem_CheckClcPer(L_APtm.system_Payments);
   END;
  ELSE
   IF MDoc.MDocKind # L_MDoc.md_DDA THEN
    SETZERO(Kinds);
    CONFORM(MDoc, MDocList);
    WHILE OCCURE(MDocList) DO
     L_MDoc.soByMDL_Math();
     IF ~Kinds[Math.MathKind] THEN
      L_MathR.CheckMDocProceedAllowed(Math.MathKind);
      IF ~Stream THEN
       L_MathR.ChMClcPer(Math.MathKind);
      END;
      Kinds[Math.MathKind]:=1;
     END;
     NEXT(MDocList);
    END; (* WHILE OCCURE(MDocList) ... *)
   END;
  END;
 END {CheckMCurPer};

 PRIVATE PROCEDURE SimpleProceed();
 BEGIN
  IF AcMth.DGroup(*???*) = L_MDoc.md_DDA THEN
   L_General.Error("⨬ ᠭ 樨    㬥");
  ELSE
   MDocStorageEquipping:=Math.Max(mse_NoStorage, MDocStorageEquipping);
   IF (AcMthL.Origin1 = L_Acnt.amo_MathByStr ) | (AcMthL.Origin2 = L_Acnt.amo_MathByStr ) THEN
    MDocStorageEquipping:=Math.Max(mse_Only1, MDocStorageEquipping);
   END;
   IF (AcMthL.Origin1 = L_Acnt.amo_MathByStr2) | (AcMthL.Origin2 = L_Acnt.amo_MathByStr2) THEN
    MDocStorageEquipping:=Math.Max(mse_Both, MDocStorageEquipping);
   END;
   IF !AcMthL.Rule THEN
    L_Acnt.MakeStandartCir(_s, L_Acnt.cs_MDoc);
   ELSE
    ^AcMthL.Rule();
   END;
  END;
 END {SimpleProceed};

 PRIVATE PROCEDURE ExecKAMth(P          : DATE;
                             trgMDocKind: LIKE(MDoc.MDocKind);
                             trgDGroup  : LIKE(DGroup.DGroup));
 BEGIN
  IF L_XObj.E_DoSecondSide(P) THEN
   L_XDR.XDocId:=L_XDoc.curXDocId(L_XDoc.xdt_ACalc);
   IF    trgDGroup = L_MDoc.DG_Amr THEN
    CalcAcnWear();
    CalcTaxWear();
   ELSIF trgDGroup = L_MDoc.DG_Use THEN
    AcnInUse();
    TaxInUse();
   END;
  ELSE
   L_XDR.XDocId:=L_XDoc.XDocId(L_XDoc.xdt_MDoc, trgMDocKind, EMPTYOF(L_XDoc.tXDoc));
   L_Acnt.ExecAcMth(P, trgDGroup, MathKAGL.Dest, Math.MathType,
                    L_MathR.mm_New, 0,
                    PROCREF(SimpleProceed), EMPTYOF(PROC));
  END;
  SETEMPTY(L_XDR.XDocId);
 END {ExecKAMth};

 PRIVATE PROCEDURE ExecMth();
  VAR
   _MathType: LIKE(MathType.MathType);
 BEGIN
  IF L_Pmnt.IsVATMDocToKeepInBook() & ~L_MDoc.IsMDoc_wJDocOnly() THEN
   IF L_MDoc.IsMDoc_woMath(MDocKind.MDocKind) THEN
    SETEMPTY(_MathType);
   ELSE
    _MathType:=Math.MathType;
   END;
   IF L_MDoc.KeyAssetsMDoc(MDoc.MDocKind) & L_XObj.E_DoSecondSide(MDoc.Date) & ~L_XDR.XDocRepDo() THEN (*0104761 09.09.2014 20:24:16 POLAK\Bor*)
    L_XDR.XDocId:=L_XDoc.curXDocId(L_XDoc.xdt_ACalc);
   ELSE
    L_XDR.XDocId:=MDoc.XDocId;
   END;
   L_Acnt.ExecAcMth(L_DatTim.Per(MDoc.Date), MDocKind.DGroup, MDoc.Dest, _MathType,
                    MDocList.MMode, 0,
                    PROCREF(SimpleProceed), EMPTYOF(PROC));
   SETEMPTY(L_XDR.XDocId);
  END;
 END {ExecMth};

 PRIVATE PROCEDURE NeedCUCopy(): SCAL[2];
  VAR
   Result: SCAL[2];
 BEGIN
  SAVE(MDoc);
  CONFORM(Math, CarUnit);
  CONFORM(MDocList, MDoc);
  CONFORM(MDoc, MDocKind);
  Result:=(MDocKind.wCUCopy & (MDocList.MMode # L_MathR.mm_MnfctOper) & (MDoc.Date >= CarUnit.SNDate)) |
          (MDoc.MDocKind = L_MDoc.md_DDA) |
          (OCCURE(MDocLCU) & L_CUC.IsInitialSetting() & (MDoc.Date + 1 = CarUnit.SNDate));
  RESTORE(MDoc);
  RETURN Result;
 END {NeedCUCopy};

 PRIVATE PROCEDURE ApplyCUCopy();
  VAR
   CUCopyCnt: NUMERIC[0];
   _Required: NUMERIC[2];
   dfnOpKind: L_CUC.tOpKind;
 BEGIN
  IF ~!MDocList.Math & (MDoc.Status = L_MDoc.st_Passed) THEN
   APP.Get().NewPrompt("ப " + MDocList.MDLNbr + " ஢ઠ ஢");
   CONFORM(MDocList, MDocLCU);
   IF NeedCUCopy() THEN
    CUCopyCnt:=0;
    WHILE OCCURE(MDocLCU) DO
     PROMPT(MDocLCU.CUCopy);
     CONFORM(MDocLCU, CUCopy);
     L_General.Assert(CUCopy.Math = MDocList.Math,
                      " "+ MDocLCU.CUCopy + "  ⭮   " + MDocList.Math);

     dfnOpKind:=L_MDoc.E_DefineMDocLCU_OpKind();
     IF ~!dfnOpKind & (dfnOpKind # MDocLCU.OpKind) THEN
      L_General.Error(" " + MDocLCU.CUCopy + ": ᫥ 㪠 '" +
                      L_Str.PoolItem(L_CUC.ok_Pool, dfnOpKind) + "'  '" +
                      L_Str.PoolItem(L_CUC.ok_Pool, MDocLCU.OpKind) + "'");
     END;
     INC(CUCopyCnt, L_CUC.AmountInSingleCopy());
     NEXT(MDocLCU);
    END;
    PROMPT();
    _Required:=L_MDoc.GetMDocListCir2();
    L_General.Assert(CUCopyCnt = _Required,
                     " " + MDocList.Math +
                     "||ॡ " + L_Str.IntStr(_Required) + " ஢, 㪠 " + L_Str.IntStr(CUCopyCnt));
   ELSE
    L_General.Assert(~OCCURE(MDocLCU), " " + MDocList.Math + "||  ॡ");
   END;
  END;
 END {ApplyCUCopy};

 PRIVATE PROCEDURE PrintMDocListCUCopies();
 BEGIN
  CONFORM(MDocList, MDocLCU);
  WHILE OCCURE(MDocLCU) DO
   CONFORM(MDocLCU, CUCopy);
   PROMPT(" ஢. ப " + MDocLCU.MDLNbr + ": " + MDocLCU.CUCopy);
   PrintMDocListCUCopy();
   NEXT(MDocLCU);
  END; (* WHILE OCCURE(MDocLCU)... *)
 END {PrintMDocListCUCopies};

 PRIVATE PROCEDURE ParseCUCopies(p: PROC; wCheckNeedPrintCUCLabels: SCAL[2]): SCAL[2];
  VAR
   Result: SCAL[2];
 BEGIN
  SETZERO(Result);
  CONFORM(MDoc, MDocList);
  WHILE OCCURE(MDocList) DO
   CONFORM(MDocList, MDocLCU);
   WHILE OCCURE(MDocLCU) DO
    PROMPT(" ஢. ப " + MDocLCU.MDLNbr + ": " + MDocLCU.CUCopy);
    IF wCheckNeedPrintCUCLabels & ~Result & L_CUC.E_NeedPrintLabel(MDocLCU.CUCopy, MDocLCU.OpKind) THEN
     Result:=1;
    END;
    CONFORM(MDocLCU, CUCopy);
    p();
    NEXT(MDocLCU);
   END; (* WHILE OCCURE(MDocLCU)... *)
   NEXT(MDocList);
  END; (* WHILE OCCURE(MDocLCU) ... *)
  RETURN Result;
 END {ParseCUCopies};

 PRIVATE PROCEDURE E_CUCLabelReciever(): STRING[];
  VAR
   Local : PROC;
   Result: STRING[];
 BEGIN
  Result:=FLDTOSTR(L_Str.ShortName(Man.Name), "", 33, "L")+" ("+Staff.TSN+")";
  Local:=PROCREF(E_Stock.CUCLabelReciever);
  IF ~!Local THEN
   Result:=Local(Result);
  END;
  RETURN Result;
 END {E_CUCLabelReciever};

 PRIVATE PROCEDURE PrintMDocCUCopies(): SCAL[2];
  VAR
   Result: SCAL[2];
 BEGIN
  SETZERO(Result);
  IF SELECT(MDocLCU, MDoc, MDoc.MDocKind, MDoc.MDoc) THEN
   TopOfMDocCUCopies();
   Result:=ParseCUCopies(PROCREF(PrintMDocCUCopy), 1);
   BotOfMDocCUCopies();
  END;
  RETURN Result;
 END {PrintMDocCUCopies};

 PRIVATE PROCEDURE PrintLabels(PrintCUCLabels: SCAL[2]);
  VAR
   Dummy: SCAL[2];
 BEGIN
  IF PrintCUCLabels THEN
   PrintLabelsTop();
   Dummy:=ParseCUCopies(PROCREF(PrintLabel), 0);
   PrintLabelsBot();
  END;
 END {PrintLabels};

 PRIVATE PROCEDURE PasteAll(OnDate: DATE);
 BEGIN
  TRY [EXCEPTION_HANDLING(EXCEPTION_HANDLING_OFF)]
   PASTE(^(L_Card.GetCardName(L_Card.t_MDT, L_DatTim.Per(OnDate))));
   PASTE(^(L_Card.GetCardName(L_Card.t_MDC, L_DatTim.Per(OnDate))));
  EXCEPT
  ON Exc: Exc_RunTime DO
   IF Exc.ErrorCode # 191(*⪠ ୮ PASTE*) THEN
    RAISE();
   END;
  ON Exc: Exc_Root DO
   IF MDoc.MDocKind # L_MDoc.md_DDA THEN
    RAISE();
   END;
  END;
 END {PasteAll};

 PRIVATE PROCEDURE CheckCstDclr();
  VAR
   MustHas: SCAL[2];
 BEGIN
  MustHas:=L_Pmnt.E_MDocListMustHasCstDclr();
  L_General.Assert(MustHas = ~!MDocList.CstDclr,
                   L_Str.PoolItem(" |", MustHas) +
                   "  㪠 ⠬ |" +
                   "ப " + MDocList.MDLNbr);
 END {CheckCstDclr};

 PRIVATE PROCEDURE E_ExecBeforeClientPart();
  VAR
   Local: PROC;
 BEGIN
  Local:=PROCREF(ExecBeforeClientPart);
  IF ~!Local THEN
   Local();
  END;
 END {E_ExecBeforeClientPart};

 PRIVATE PROCEDURE CheckMayInsertRefDoc(RefDocRequired: SCAL[2]);
 BEGIN
  IF RefDocRequired THEN
   IF !RTI.Get().CurZone.Fields("MDoc_SingleRefDoc") THEN
    L_General.Error("  ॡ 㪠 易 㬥,|" +
                    "   ।஢ 㬥   .||" +
                    "᫨  㢥७  ࠢ쭮 ᢮ ⢨, |" +
                    "   ᯮ 㣮  ࠭.");
   END;
  END;
 END {CheckMayInsertRefDoc};

 PRIVATE PROCEDURE GetSingleRefDocC(trgXDocId: L_XDoc.tXDocId): STRING[];
  VAR
   Result: STRING[];
 BEGIN
  Result:=" ";
  IF ~!trgXDocId & (L_XDoc.ExtractXDocType(trgXDocId) = L_XDoc.xdt_RprS) THEN
   L_XDoc.PositionOnXDoc(trgXDocId);
   CONFORM(RprS, CUCopy);
   Result:=L_Str.PoolItem(L_Rpr.rot_Pool_Short, RprS.RprObjT)
           + " " + RprS.RprObjId
           + " " + CUCopy.Serial;
  END;
  RETURN Result;
 END {GetSingleRefDocC};

 PRIVATE PROCEDURE GetSingleRefDocT_ByMDocStorage(): L_XDoc.tXDocType;
  VAR
   Result,
   XDocType_Strg1,
   XDocType_Strg2: L_XDoc.tXDocType;
 BEGIN
  SETEMPTY(XDocType_Strg2);
  XDocType_Strg1:=L_MathR.E_GetSingleRefToXDocType(MDoc.Date, MDoc.MDocKind, MDoc.Storage);
  Result        :=XDocType_Strg1;
  IF MDoc.MDocKind = L_MDoc.md_MSP THEN
   XDocType_Strg2:=L_MathR.E_GetSingleRefToXDocType(MDoc.Date, MDoc.MDocKind, MDoc.Storage2);
  END;
  IF ~!XDocType_Strg1 & ~!XDocType_Strg2 THEN
   L_General.Error("  㪠  ,   ॡ 뫪  㣮 㬥.||" +
                   "᫨  㢥७  ࠢ쭮 ᢮ ⢨,|"+
                   "  ");
  END;
  IF !Result THEN
   Result:=XDocType_Strg2;
  END;
  RETURN Result;
 END {GetSingleRefDocT_ByMDocStorage};

 PRIVATE PROCEDURE GetSingleRefXDocId(): L_XDoc.tXDocId;
  VAR
   i          : NUMERIC[0];
   Result,
   trgXDocId  : L_XDoc.tXDocId;
   trgRefToXDC: L_XDoc.tXDocCollection;
 BEGIN
  SETEMPTY(Result);
  trgRefToXDC:=L_XDoc.GetAllRefToXDC(L_XDoc.curXDocId(L_XDoc.xdt_MDoc));
  i:=0;
  LOOP
   trgXDocId:=L_XDoc.xdc_Item(trgRefToXDC, i);
   IF !trgXDocId THEN
    EXIT;
   END;
   IF (L_XDoc.ExtractXDocType(trgXDocId) = L_XDoc.xdt_RWayS) | (L_XDoc.ExtractXDocType(trgXDocId) = L_XDoc.xdt_RprS) THEN
    L_General.CallUs(!Result);
    Result:=trgXDocId;
   END;
   INC(i);
  END; (* LOOP *)

  RETURN Result;
 END {GetSingleRefXDocId};

 PRIVATE PROCEDURE GetSingleRefDoc(VAR RefXDocType: L_XDoc.tXDocType;
                                   VAR RefXDocKind: L_XDoc.tXDocKind;
                                   VAR RefXDoc    : L_XDoc.tXDoc;
                                   VAR RefXDocC   : STRING[];
                                       Strong     : SCAL[2]);
  VAR
   trgRefToXDocId: L_XDoc.tXDocId;
   mdcRefXDocType,
   trgRefXDocType: L_XDoc.tXDocType;
   mdcRefXDocKind,
   trgRefXDocKind: L_XDoc.tXDocKind;
   trgRefXDoc    : L_XDoc.tXDoc;
   trgRefXDocC   : STRING[];
 BEGIN
  SETEMPTY(trgRefToXDocId, trgRefXDocType, trgRefXDocKind, trgRefXDoc);

  mdcRefXDocType:=GetSingleRefDocT_ByMDocStorage();
  mdcRefXDocKind:=L_XDoc.EmptyXDocKind;
  IF ~!mdcRefXDocType THEN
   trgRefToXDocId:=GetSingleRefXDocId();
   IF ~!trgRefToXDocId THEN
    L_XDoc.DecodeXDocId(trgRefToXDocId, trgRefXDocType, trgRefXDocKind, trgRefXDoc);
    IF (trgRefXDocType # mdcRefXDocType) | (trgRefXDocKind # mdcRefXDocKind) THEN
     L_General.Assert(~Strong, " 㣮 ⨯ 易 㬥.");
     SETEMPTY(trgRefXDocType, trgRefXDocKind, trgRefXDoc);
    END;
   ELSE
    L_General.Assert(~Strong, " 㪠 易 㬥");
    trgRefXDocType:=mdcRefXDocType;
    trgRefXDocKind:=mdcRefXDocKind;
   END;
  END;

  trgRefXDocC:=GetSingleRefDocC(trgRefToXDocId);

  RefXDocType:=trgRefXDocType;
  RefXDocKind:=trgRefXDocKind;
  RefXDoc    :=trgRefXDoc;
  RefXDocC   :=trgRefXDocC;
 END {GetSingleRefDoc};

 PRIVATE PROCEDURE intGetSingleRefDocT(Strong: SCAL[2]): L_XDoc.tXDocType;
  VAR
   Result     : L_XDoc.tXDocType;
   RefXDocKind: L_XDoc.tXDocKind;
   RefXDoc    : L_XDoc.tXDoc;
   RefXDocC   : STRING[];
 BEGIN
  GetSingleRefDoc(Result, RefXDocKind, RefXDoc, RefXDocC, Strong);
  RETURN Result;
 END {intGetSingleRefDocT};

 PRIVATE PROCEDURE GetSingleRefDocT(): L_XDoc.tXDocType;
 BEGIN
  RETURN intGetSingleRefDocT(0);
 END {GetSingleRefDocT};

 PRIVATE PROCEDURE IsAcceptableMDocForCheckMathCompliance(): SCAL[2];
  VAR
   Result: SCAL[2];
 BEGIN
  Result:=0;
  IF MDoc.Status # L_MDoc.st_Canceled THEN
   IF MDoc.MDocKind = L_MDoc.md_MSP THEN
    Result:=GetSingleRefDocT() = L_XDoc.xdt_RprS;
   ELSE
    Result:=MDoc.MDocKind = L_MDoc.md_NOV;
   END;
  END;
  RETURN Result;
 END {IsAcceptableMDocForCheckMathCompliance};

 PRIVATE PROCEDURE CheckMathMarkG();
  VAR
   Msg    : STRING[];
   trgMark: LIKE(Mark.Mark);
 BEGIN
  IF IsAcceptableMDocForCheckMathCompliance() THEN
   TRY [RESTORE_CURSORS(RC_ON)]
    SETEMPTY(trgMark);
    IF MDoc.MDocKind = L_MDoc.md_NOV THEN
     L_Car.AccessMark(MDoc.BoxNbr, MDoc.Date);
     trgMark:=Mark.Mark;
    ELSE
     L_MDoc.curRefToXDoc_PositionOn(L_XDoc.xdt_RprS);
     IF L_Rpr.IsRprS_w_Car() THEN
      L_Rpr.AccessMark(MDoc.Date);
      trgMark:=Mark.Mark;
     END;
    END;
    IF ~!trgMark THEN
     SEARCH(Mark, Mark, , trgMark);
     CONFORM(MDoc, MDocList);
     WHILE OCCURE(MDocList) DO
      IF SELECT(MathMrkG, Math, MDocList.Math) THEN
       LOOP
        IF ~OCCURE(MathMrkG) THEN
         Msg:="  " + MDocList.Math + "  祭 ᮢ⨬ 㯯 ப|ઠ " + Mark.Mark + " '" + Mark.Name + "'  室     ";
         IF MDoc.Status = L_MDoc.st_Prepared THEN
          L_StdFrm.Choice(Msg);
          EXIT;
         ELSE
          L_General.Error(Msg + L_StdFrm.HR() + Hint_SaveInPrepared);
         END;
        ELSE
         SEARCH(MarkG, MarkG, , MathMrkG.MarkG);
         IF L_DatTim.IsActive(MDoc.Date, MarkG.Begin, MarkG.Till) &
            SEARCH(MarkGM, MMGT, Mark.Mark, L_Way.mgt_MathCompatibility, MathMrkG.MarkG) THEN
          EXIT;
         END;
        END;
        NEXT(MathMrkG);
       END; (* LOOP ... *)
      END; (* IF SELECT(MathMrkG, Math, MDocList.Math) *)
      NEXT(MDocList);
     END; (* WHILE OCCURE(MDocList) ... *)
    END; (* IF ~!trgMark...*)
   EXCEPT
   END; (* TRY *)
  END;
 END {CheckMathMarkG};

 PRIVATE PROCEDURE CheckMathIssueAllowance();
  VAR
   trgSort      : LIKE(Sort.Sort);
   trgLimit     : L_XObj.tQnt;
   trgPeriodType: P_Math.tIAPeriodType;
 BEGIN
  TRY [RESTORE_CURSORS(RC_ON)]
   CONFORM(MDoc, MDocList);
   WHILE OCCURE(MDocList) DO
    P_Math.GetIssueAllowance(MDoc.TSN, MDoc.Date, trgSort, trgLimit, trgPeriodType);
    IF ~!trgLimit THEN
     TRY [RESTORE_CURSORS(RC_ON)]
      CHANGESEL(MDocList, Math, , MDocList.Math);
     EXCEPT
     END; (* TRY *)
    END;
    NEXT(MDocList);
   END; (* WHILE OCCURE(MDocList) ... *)
  EXCEPT
  END; (* TRY *)
 END {CheckMathIssueAllowance};

 PUBLIC PROCEDURE CheckMDocList();
  VAR
   ContractSingleMath: LIKE(Math.Math);
   S                 : STRING[];
 BEGIN
  IF ~L_MDoc.IsMDoc_woMath(MDoc.MDocKind) THEN
   IF ~!MDoc.Contract THEN
    ContractSingleMath:=P_Cntr.GetCntrProSoft(MDoc.Contract, MDoc.Date,
                                              P_Cntr.P_SingleMath);
   ELSE
    SETEMPTY(ContractSingleMath);
   END;
   CONFORM(MDoc, MDocKind);
   CONFORM(MDoc, MDocList);
   WHILE OCCURE(MDocList) DO
    IF ~!ContractSingleMath &
       (MDocList.Math # ContractSingleMath) &
       (MDocList.Math # E_Pmnt.MathForPayment(MDoc.Date)) THEN
     L_General.Error("  ᯥ஢ '⢥ । ' -  " + ContractSingleMath +
                     ".|| ப " + MDocList.MDLNbr + " 㪠  " + MDocList.Math);
    END;
    L_MDoc.soByMDL_Math();
    IF (Math.MathKind # L_MathR.mathk_KeyAs) & (MDoc.Date >= Math.NoBuy) THEN
     IF  (L_MDoc.IsExternalMDocKind() & (L_MDoc.getMDocListMathFlowType() = L_MDoc.mft_Debit)) |
         (MDoc.MDocKind = L_MDoc.md_ZMC) THEN
      L_General.Assert_wReferToAdmin(MDoc.Status # L_MDoc.st_Passed,
                                     "  " + Math.Math + " ४饭 㯪  " +
                                     L_DatTim.DateStr(Math.NoBuy) +
                                     L_StdFrm.HR() +
                                     Hint_SaveInPrepared);
     ELSIF MDoc.MDocKind = L_MDoc.md_IsS THEN
      L_StdFrm.Choice("  " + Math.Math + " ४饭 㯪  " + L_DatTim.DateStr(Math.NoBuy) +
                      "||" +
                      " ࠧ, ⢨⥫쭮   ⮨ ।  த");

     END;
    END; (* L_MDoc.IsExternalMDocKind() & ... *)
    ApplyCUCopy();
    NEXT(MDocList);
   END; (* WHILE OCCURE(MDocList) ... *)
  END;
 END {CheckMDocList};

 PRIVATE PROCEDURE CheckMDocTSN();
  VAR
   dmyThrough: STRING[];
 BEGIN
  IF MDoc.Status = L_MDoc.st_Passed THEN
   CONFORM(MDoc, MDocKind);
   IF MDocKind.Activity | MDocKind.wCUCopy THEN
    IF ~L_APtm.IsOG() THEN
     L_General.Assert(L_Env.RealTSN(MDoc.TSN), "   㪠 ॠ ࠡ⭨");
    END;
    CONFORM(MDoc, Staff);
    L_Staff.PosToStaffLog(Staff.TSN, MDoc.Date, 1);
    IF ~L_Staff.InOrder(MDoc.Date) THEN
     L_StdFrm.Choice("⭨ "+MDoc.TSN+" 㢮  "+L_DatTim.DateStr(MDoc.Date));
    END;
   END;
  END; (* IF MDoc.Status = L_MDoc.st_Passed ... *)
 END {CheckMDocTSN};

 PRIVATE PROCEDURE CheckStorageAuthorization(_Storage: LIKE(MDoc.Storage));
  VAR
   Dummy                            : P_Officer.tStorages;
   _WriteOffFromAdvanceHolderAllowed: SCAL[2];
 BEGIN
  IF ~!_Storage THEN
   L_General.Assert(SEARCH(Storage, Storage, _Storage), "   ࠭ " + _Storage);
   IF Storage.Type = L_Stock.st_AdvHolder THEN
    L_Stock.GetAuthorizedStoragesOfCurrentUser(Dummy, _WriteOffFromAdvanceHolderAllowed);
    L_General.Assert(_WriteOffFromAdvanceHolderAllowed, "   ࠧ襭  ᯨᠭ  ");
   ELSE
    L_Stock.CheckIsAuthorizedStorage(_Storage);
   END;
  END;
 END {CheckStorageAuthorization};

 PRIVATE PROCEDURE CheckMModeToOfficerCompliance(IsDefinitelyInUse: SCAL[2]);
 BEGIN
  IF ~IsDefinitelyInUse THEN
   IsDefinitelyInUse:=(MDocList.MMode = L_MathR.mm_NewInAccountability) |
                      (MDocList.MMode = L_MathR.mm_UsedInAccountability);
  END;
  IF Officer.RspMAsst = L_Staff.rspma_Accountability THEN
   IF ~IsDefinitelyInUse THEN
    L_StdFrm.Choice(" ࠡ祬  ।ᬮ७ 뤠  .| 뤠   ?");
   END;
  ELSE
   L_General.Assert(~IsDefinitelyInUse, " ࠡ祬   ।ᬮ७ 뤠  ");
  END;
 END {CheckMModeToOfficerCompliance};

 PRIVATE PROCEDURE CheckDistributionInUse();
 BEGIN
  IF L_Events.IsAfterEditInsertEvents(MODE) THEN
   CONFORM(MDocList, Math);
   IF Math.MathType # L_MathR.mtyp_Cloth THEN
    CONFORM(MDoc, Dest);
    IF (MDoc.MDocKind = L_MDoc.md_TOV) & ~L_MDoc.IsMDocToWriteOffFromAdvanceHolder() &
       (Dest.Type = L_Acnt.dt_Credit) THEN
     CONFORM(MDoc, Officer);
     CheckMModeToOfficerCompliance(0);
    ELSIF L_MDoc.IsMDocToTransferBetweenAdvanceHolders() THEN
     IF Dest.Type THEN
      SELECT(Staff, Storage, , MDoc.Storage);
     ELSE
      SELECT(Staff, Storage, , MDoc.Storage2);
     END;
     HISTCONF(MDoc.Date, Staff, Officer);
     CheckMModeToOfficerCompliance(1);
    END;
   END;
  END;
 END {CheckDistributionInUse};

 PRIVATE PROCEDURE CheckKeyAssNum();
 BEGIN
  IF Math.MathKind = L_MathR.mathk_KeyAs THEN
   L_General.Assert(MDocList.Qnt <= 1, "  "+Math.Math+" 㪠 ⢮ > 1|⢥    ");
  END;
 END {CheckKeyAssNum};

 PRIVATE PROCEDURE CheckMDocStorageEquipping();
 BEGIN
  IF (_s = +1) THEN
   IF    MDocStorageEquipping = mse_NoStorage THEN
    L_General.Assert(!MDoc.Storage, L_MDoc.GetMDocStrNbr()+"| ࠭   ");
   ELSIF MDocStorageEquipping = mse_Only1 THEN
    L_General.Assert(!MDoc.Storage2, L_MDoc.GetMDocStrNbr()+"|2   ");
   END;
  END;
 END {CheckMDocStorageEquipping};

 PRIVATE PROCEDURE CheckVATMDocBuildByMDocAllowed();
 BEGIN
  L_General.AssertInSupportMode(0, "饭 ନ஢  ।⢥  ");
 END {CheckVATMDocBuildByMDocAllowed};

 PRIVATE PROCEDURE ProceedRWayS(trgDone: SCAL[2]; Strong: SCAL[2]);
  VAR
   sav_gl_cd: DATE;
 BEGIN
  sav_gl_cd:=Memo.gl_cd();
  TRY [RESTORE_CURSORS(RC_ON)]
   TOOLTIP(L_Str.PoolItem("⪠|ࠡ⪠", trgDone)+" 易  "+RWayS.RWayS);
   GRANT_ALL_RIGHTS();
   IF trgDone THEN
    CALL(RWayS, L_Events.md_StreamMakeDone);
   ELSE
    CALL(RWayS, L_Events.md_StreamMakeUnDone);
   END;
  EXCEPT
  ON Exc: Exc_Raise DO
   IF Strong THEN
    RAISE();
   ELSE
    L_StdFrm.RedInform(" 㤠 "+L_Str.PoolItem("⪠|ࠡ", trgDone)+" 易  "+RWayS.RWayS+L_StdFrm.HR()+Exc.Description);
   END;
  FINALLY
   Memo.gl_SetCurDate(sav_gl_cd);
  END; (* TRY *)
 END {ProceedRWayS};

 PRIVATE PROCEDURE Proceed(_Done: LIKE(MDoc.Done); Stream, HardRWayFSupport, SetRWF: SCAL[2]);
 BEGIN
  Memo.gl_SetCurDate(MDoc.Date);
  APP.Get().NewPrompt(L_MDoc.GetMDocStrNbr()+" "+L_Str.PoolItem("⪠|ࠡ⪠", _Done));
  L_General.SetConcurrentMode();
  IF MDoc.MDocKind # L_MDoc.md_DDA THEN
   IF _Done THEN
    L_AcsPnt.PassAccessPoint(0000014);
   ELSE
    L_AcsPnt.PassAccessPoint(0000013);
   END;
  END;
  IF (_s # 0) & _Done THEN
   IF MDoc.Date > L_DatTim.MonthEnd(SYSDATE()) THEN
    IF ~Stream THEN
     L_StdFrm.Inform("ਮ 㬥   㯨. 㬥 ⠭ ࠡ⠭");
    END;
    RETURN;
   END;
   L_MDoc.CheckChainMDocDone();
  END;
  IF (_s=0) | (MDoc.Done # _Done) THEN
   L_General.Assert(MDoc.convId = L_MDoc.convertionId,
                    " 믮  .   ");
   RWayFHasChanged:=0;
   NeedSetRWayF:=((_s = - 1) & SetRWF) | ((_s = +1) & (MDoc.doneRWF # 1));
   IF MDoc.Status = L_MDoc.st_Passed THEN
    IF ~L_MDoc.KeyAssetsMDoc(MDoc.MDocKind) THEN
     CONFORM(MDoc, MDocKind);
     CONFORM(MDoc, Staff);
     PasteAll(MDoc.Date);
     MDocStorageEquipping:=mse_NoAcMthL;
     CONFORM(MDoc, MDocList);
     WHILE OCCURE(MDocList) DO
      IF ~L_MDoc.IsMDoc_woMath(MDoc.MDocKind) THEN
       L_MDoc.soByMDL_Math();
       IF _Done THEN
        CheckCstDclr();
        CheckKeyAssNum();
       END;
      END;
      E_ExecBeforeClientPart();
      ExecMth();
      NEXT(MDocList);
     END; (* WHILE OCCURE(MDocList ... *)
     CheckMDocStorageEquipping();
     IF L_Acnt.E_DoXDocApr(L_DatTim.Per(MDoc.Date), L_MDoc.GetMDocSource(MDoc.MDocKind), L_XDoc.curXDocId(L_XDoc.xdt_MDoc)) THEN
      IF    (_s < 0) THEN
       L_Acnt.RollbackXDoc(MDoc.XDocId);
      ELSIF (_s > 0) THEN
       L_JDoc.XDoc_ProceedAnnexJDoc(_s, L_XDoc.xdt_MDoc);
       L_Acnt.RenXDocApr(MDoc.XDocId);
      ELSIF (_s = 0) THEN
       L_General.Assert(MDoc.Done, " ।⥫쭮 ࠡ  ");
       L_XDR.XDocAprToEntryList(L_XDoc.xdt_MDoc);
      END;
     ELSE
      IF    (_s < 0) THEN
       L_JDoc.XDoc_ProceedAnnexJDoc(_s, L_XDoc.xdt_MDoc);
      ELSIF (_s > 0) THEN
       L_JDoc.XDoc_ProceedAnnexJDoc(_s, L_XDoc.xdt_MDoc);
      ELSIF (_s = 0) THEN
       L_JDoc.XDoc_ProceedAnnexJDoc(_s, L_XDoc.xdt_MDoc);
      END;
     END;
    ELSIF (MDoc.MDocKind # L_MDoc.md_ASO) THEN
     CONFORM(MDoc, MDocKind);
     CONFORM(MDoc, MDocList);
     WHILE OCCURE(MDocList) DO
      CONFORM(MDocList, Math);
      L_Acnt.SelectOperatingAcMthL(L_DatTim.Per(MDoc.Date), MDocKind.DGroup, MDoc.Dest, Math.MathType, MDocList.MMode, 0);
      L_MathR.ResetMathDone_AP(Math.Math, L_DatTim.Per(MDoc.Date));
      NEXT(MDocList);
     END; (* WHILE OCCURE(MDocList)... *)
    END; (* IF ~KeyAssets(MDoc.MDocKind) ... *)
   ELSE
    L_JDoc.XDoc_ProceedAnnexJDoc(_s, L_XDoc.xdt_MDoc);
    L_Acnt.RenXDocApr(MDoc.XDocId);
   END; (* IF MDoc.Status = L_MDoc.st_Passed...*)

   IF _s # 0 THEN
    MDoc.Done   :=_Done;
    IF _s = +1 THEN
     IF (MDoc.DoneDTS = L_XDoc.max_DoneDTS) | !MDoc.DoneDTS(*0053330*) THEN
      MDoc.DoneDTS:=L_XDoc.GetSysDTS();
     END;
    END;
    IF RWayFHasChanged | (HardRWayFSupport & !MDoc.doneRWF) THEN
     L_General.CallUs(NeedSetRWayF);
     L_General.CallUs(MDoc.doneRWF # _Done);
     IF _Done THEN
      MDoc.doneRWF:=RWayFHasChanged;
     ELSIF HardRWayFSupport THEN
      MDoc.doneRWF:=0;
     ELSE
      SETEMPTY(MDoc.doneRWF);
     END;
     L_General.CallUs(((L_Fuel.FlAcntLev(MDoc.Date) = L_Fuel.fal_RefuelOperator)|
                      (L_Fuel.FlAcntLev(MDoc.Date) = L_Fuel.fal_RfOpOffline   )) &
                      (GetSingleRefDocT() = L_XDoc.xdt_RWayS));
     L_MDoc.curRefToXDoc_PositionOn(L_XDoc.xdt_RWayS);
     IF RWayS.Status>=L_Way.rwsStat_Taken THEN
      IF HardRWayFSupport THEN
       CALL(RWayChn.AfterRefMDocModify());
      ELSE
       L_General.Assert(~RWayS.Done, "⥢     ࠡ⠭");
      END;
      IF (_s = +1) & (RWayS.Status = L_Way.rwsStat_Rated) & ~Stream THEN
       ProceedRWayS(1, 0);
      END;
     END; (* IF RWayS.Status>=L_Way.rwsStat_Taken ... *)
    ELSIF NeedSetRWayF THEN
     MDoc.doneRWF:=0;
    END;
    REPLACE(MDoc);
   END;
  END;
 END {Proceed};

 PRIVATE PROCEDURE CheckIfIsSent(_Action: LIKE(XDocJrn.Action));
 BEGIN
  IF L_XDoc.XDocIsSent(L_XDoc.xdt_MDoc, MDoc.MDocKind, MDoc.MDoc) THEN
   IF ~L_General.TestExecution_IsRunning() THEN
    IF    MDoc.MDocKind = L_MDoc.md_VhS THEN
     IF _Action = L_XDoc.action_Edit THEN
      L_StdFrm.Choice("㬥 ࠢ. த?");
     ELSE
      L_General.Assert(_Action = L_XDoc.action_Reprint,
                       "  ন");
     END;
    ELSE
     L_General.Assert_wReferToAdmin(0, "㬥 ࠢ.");
    END;
   END; (* ~L_General.TestExecution_IsRunning() *)
  END;
 END {CheckIfIsSent};

 PRIVATE PROCEDURE AcceptableOperation(_Operation: STRING[]);
 BEGIN
  IF L_XDoc.ExtractXDocType(L_XDoc.GetBaseOnXDocId(MDoc.XDocId)) = L_XDoc.xdt_FlRec THEN
   L_General.Error("饭 " + _Operation+ " 㬥,|" +
                   "ନ஢  ᭮ ࠢ筮 ");
  END;
 END {AcceptableOperation};

 PRIVATE PROCEDURE E_MDocListOrderOnPaper(_MDocKind: LIKE(MDocKind.MDocKind)): SCAL[2];
  VAR
   default: SCAL[2];
   local  : PROC;
 BEGIN
  default:=(_MDocKind = L_MDoc.md_TOV) | (_MDocKind = L_MDoc.md_NOV);
  local:=PROCREF(E_Stock.MDocListOrderOnPaper);
  IF ~!local THEN
   default:=local(_MDocKind, default);
  END;
  RETURN default;
 END {E_MDocListOrderOnPaper};

 PRIVATE PROCEDURE intPrint(Stream, Preview: SCAL[2]; Template: STRING[]);
  VAR
   NeedSurvey     : SCAL[2];
   _Status        : LIKE(MDoc.Status);
   Copies         : NUMERIC[0];
   PrpResult      : L_MSO.PrpResultType;
   PrintCUCLabels,
   MDocPrinterType: SCAL[2];
 BEGIN
  CheckMCurPer(Stream);

  AcceptableOperation("");
  NeedSurvey:=1;
  TRY
   IF    MDoc.Status = L_MDoc.st_Canceled THEN
    IF ~Preview THEN
     IF L_MDoc.E_MDocPrinterType(MDoc.Date) = L_MDoc.mdpt_Normal THEN
      L_Print.PrintCancelledXDoc(L_XDoc.curXDocId(L_XDoc.xdt_MDoc));
     END;
    ELSE
     L_General.Error("㬥 㫨஢");
    END;
   ELSE
    CONFORM(MDoc, MDocKind);
    L_General.Assert((MDoc.Status # L_MDoc.st_Prepared) | MDocKind.PrpPrint,
                     " ⮢ " + MDocKind.Sign + " 饭");
    IF ~Preview THEN
     CheckIfIsSent(L_XDoc.action_Reprint);
     PrpResult:=L_MSO.PrpResult_Original;
    ELSE
     PrpResult:=L_MSO.PrpResult_Preview;
    END;
    _s:=0;

    IF L_MDoc.KeyAssetsMDoc(MDoc.MDocKind) THEN
     _Status:=MDoc.Status;
     MDoc.Status:=L_MDoc.st_Passed; (*⮡   뢥 ଠ ஢*)
     REPLACE(MDoc);
    END; (* IF L_MDoc.KeyAssetsMDoc ... *)

    IF ~!Template THEN
     MDocP_MO.MakeDoc(Template, PrpResult);
     NeedSurvey:=0;
    ELSE
     MDocPrinterType:=L_MDoc.E_MDocPrinterType(MDoc.Date);
     IF MDocPrinterType = L_MDoc.mdpt_TM THEN
      PASTE(MDocP_tm);
     ELSE
      PASTE(MDocP_xx);
     END;

     Copies:=L_MDoc.E_MDocCopiesCount(PrpResult);
     WHILE Copies > 0 DO
      CONFORM(MDoc, Firm);
      CONFORM(MDoc, Alower);
      CONFORM(MDoc, Car);
      CONFORM(MDoc, Staff, Man);
      CONFORM(MDoc, Dest);
      Open(Preview);
      Top();
      IF E_MDocListOrderOnPaper(MDoc.MDocKind) = 0 THEN
       SELECT(MDocList, MDoc, , MDoc.MDocKind, MDoc.MDoc);
      ELSE
       SELECT(MDocList, MDLMath, , MDoc.MDocKind, MDoc.MDoc);
      END;
      WHILE OCCURE(MDocList) DO
       CONFORM(MDocList, Math);
       Line();
       IF MDocPrinterType = L_MDoc.mdpt_TM THEN
        PrintMDocListCUCopies();
       END;
       NEXT(MDocList);
      END; (* WHILE *)
      Bot();
      PrintCUCLabels:=PrintMDocCUCopies();
      PrintLabels(PrintCUCLabels);
      Close();
      DEC(Copies);
     END; (* WHILE Copies ... *)
    END;
    L_General.RaiseLockReleaseException();
   END;
  EXCEPT
  ON Exc: Exc_Root DO
   L_General.CheckIsLockReleaseException(Exc);
   IF NeedSurvey & Preview THEN
    L_General.SurveyLastReport();
   END;
  END;
 END {intPrint};

 PRIVATE PROCEDURE SetAccessDataModeForSinglePrint();
 BEGIN
  RTI.Get().TryBlock.AccessDataMode  :=adm_SOFT;
  TABLE.Get("XCalc"  ).AccessDataMode:=adm_RIDGE;
  TABLE.Get("XApport").AccessDataMode:=adm_RIDGE;
  TABLE.Get("XODone" ).AccessDataMode:=adm_RIDGE;
 END {SetAccessDataModeForSinglePrint};

 PUBLIC PROCEDURE SinglePrint();
 BEGIN
  SetAccessDataModeForSinglePrint();
  L_MDoc.AccessMDoc();
  intPrint(0, 0, MDocP_MO.E_MDocP_MO_GetFullTemplateName());
 END {SinglePrint};

 PUBLIC PROCEDURE StreamPrint();
 BEGIN
  L_MDoc.AccessMDoc();
  intPrint(1, 0, MDocP_MO.E_MDocP_MO_GetFullTemplateName());
 END {StreamPrint};

 PUBLIC PROCEDURE SinglePrePrint();
 BEGIN
  SetAccessDataModeForSinglePrint();
  L_MDoc.AccessMDoc();
  intPrint(0, 1, MDocP_MO.E_MDocP_MO_GetFullTemplateName());
 END {SinglePrePrint};

 PRIVATE PROCEDURE BadCopyCnt(): SCAL[2];
  (*
   室 ਮ -     ᭮  㤥 ࠢ ୠ.
    ।⢥ ᫥ 䨪樨  ਢ  
    ୠ. 03.12.2002 12:16:40 POLAK\SAN
  *)
  VAR
   _CopyCnt: NUMERIC[0];
 BEGIN
  _CopyCnt:=MDoc.CopyCnt;
  SELECT(XDocJrn, XDocJrn, , L_XDoc.xdt_MDoc, MDoc.MDocKind, MDoc.MDoc);
  WHILE OCCURE(XDocJrn) DO
   IF XDocJrn.Action = L_XDoc.action_Reprint THEN
    DEC(_CopyCnt);
   END;
   NEXT(XDocJrn);
  END; (* WHILE OCCURE(XDocJrn) ... *)
  RETURN _CopyCnt <= 0;
 END {BadCopyCnt};

 PRIVATE PROCEDURE MakeUnprinted(Force: SCAL[2]);
 BEGIN
  IF Force |
     L_XDoc.XDocIsPrinted(L_XDoc.xdt_MDoc, MDoc.MDocKind, MDoc.MDoc) |
     BadCopyCnt() THEN
   INC(MDoc.CopyCnt);
   REPLACE(MDoc);
  END;
 END {MakeUnprinted};

 PRIVATE PROCEDURE intRePrint(Stream: SCAL[2]);
 BEGIN
  MakeUnprinted(0);
  L_XDoc.XDocJrn_Mark(L_XDoc.xdt_MDoc, MDoc.MDocKind, MDoc.MDoc, L_XDoc.action_Reprint);
  IF ~Stream THEN
   LIKEMENU(CALL, "MDoc.SinglePrint()");
  END;
 END {intRePrint};

 PUBLIC PROCEDURE SingleRePrint();
 BEGIN
  L_MDoc.AccessMDoc();
  CheckIsOwnMDoc();
  CheckIfIsSent(L_XDoc.action_Reprint);
  CheckMCurPer(0);
  intRePrint(0);
 END {SingleRePrint};

 PUBLIC PROCEDURE StreamRePrint();
 BEGIN
  L_MDoc.AccessMDoc();
  CheckIsOwnMDoc();
  CheckIfIsSent(L_XDoc.action_Reprint);
  CheckMCurPer(1);
  intRePrint(1);
 END {StreamRePrint};

 PRIVATE PROCEDURE Send(Stream: SCAL[2]; Template: STRING[]);
  VAR
   Local: PROC;
 BEGIN
  TRY [ABORT_AFTER(AA_ON)]
   _s:=0;
   CheckIfIsSent(L_XDoc.action_Sent);
   L_MDoc.CheckPassed();
   Local:=PROCREF(E_Stock.SendMDoc);
   IF ~!Local THEN
    Local(Stream, Template);
   ELSE
    L_General.Error("ࠢ   ॠ");
   END;
   IF L_General.TestExecution_IsRunning() THEN
    L_General.Error(" ⮢ ᯮ ࠢ ");
   END;
  EXCEPT
  END;
  L_XDoc.XDocJrn_Mark(L_XDoc.xdt_MDoc, MDoc.MDocKind, MDoc.MDoc, L_XDoc.action_Sent);
 END {Send};

 PUBLIC PROCEDURE SingleSending();
 BEGIN
  L_MDoc.AccessMDoc();
  Send(0, MDocP_MO.E_MDocP_MO_GetFullTemplateName());
 END {SingleSending};

 PUBLIC PROCEDURE StreamSending();
 BEGIN
  L_MDoc.AccessMDoc();
  Send(1, MDocP_MO.E_MDocP_MO_GetFullTemplateName());
 END {StreamSending};

 PRIVATE PROCEDURE intPrintCopy(Stream: SCAL[2]);
  VAR
   Local: PROC;
 BEGIN
  TRY
   IF (MDoc.MDocKind # L_MDoc.md_DPr) THEN
    L_General.Assert(L_XDoc.XDocIsVerifiedCC(L_XDoc.xdt_MDoc, MDoc.MDocKind, MDoc.MDoc),
                     "  믮 ᫥ ⢥ত  㬥");
   END;
   Local:=PROCREF(E_Stock.PrintCopy);
   L_General.Assert(~!Local, "⮢   襬 ஥  ॠ");
   L_General.Assert(Local(Stream), "஡  ⮢ ");
   L_General.RaiseLockReleaseException();
  EXCEPT
  ON Exc: Exc_Root DO
   L_General.CheckIsLockReleaseException(Exc);
  END;
  L_XDoc.XDocJrn_Mark(L_XDoc.xdt_MDoc, MDoc.MDocKind, MDoc.MDoc, L_XDoc.action_PrintCopy);
 END {intPrintCopy};

 PUBLIC PROCEDURE SinglePrintCopy();
 BEGIN
  L_MDoc.AccessMDoc();
  intPrintCopy(0);
 END {SinglePrintCopy};

 PUBLIC PROCEDURE StreamPrintCopy();
 BEGIN
  L_MDoc.AccessMDoc();
  intPrintCopy(1);
 END {StreamPrintCopy};

 PRIVATE PROCEDURE PrintAuthority(Preview: SCAL[2]);
 BEGIN
  IF Preview THEN
   MDocP_MO.MakeDoc("MDocAtrn", L_MSO.PrpResult_Preview);
  ELSE
   MDocP_MO.MakeDoc("MDocAtrn", L_MSO.PrpResult_Original);
  END;
 END {PrintAuthority};

 PRIVATE PROCEDURE E_ExecClientCheckBoxNbr(_BoxNbr: LIKE(MDoc.BoxNbr); D : DATE);
  VAR
   Local: PROC;
 BEGIN
  Local:=PROCREF(E_Stock.ExecClientCheckBoxNbr);
  IF ~!Local THEN
   Local(_BoxNbr, D);
  END;
 END {E_ExecClientCheckBoxNbr};

 PRIVATE PROCEDURE CompleteAllMDocLCU(ModifingDateOnly: SCAL[2]);
 BEGIN
  APP.Get().NewPrompt("ࠡ⪠ ஢");
  SELECT(MDocLCU, MDoc, , MDoc.MDocKind, MDoc.MDoc);
  WHILE OCCURE(MDocLCU) DO
   PROMPT(MDocLCU.CUCopy);
   L_CUC.CompleteMDocLCU(ModifingDateOnly);
   NEXT(MDocLCU);
  END; (* WHILE OCCURE(MDocLCU) ... *)
 END {CompleteAllMDocLCU};

 PRIVATE PROCEDURE FindSimilarMDoc();
  VAR
   tFirm    : LIKE(MDoc.Firm);
   tSrcDate : LIKE(MDoc.SrcDate);
   tMDoc    : LIKE(MDoc.MDoc);
 BEGIN
  APP.Get().NewPrompt("  ");
  IF (~!MDoc.SrcNbr & (MDoc.SrcNbr # SrcNbr_Without) & (MDoc.SrcNbr # SrcNbr_Order)) & ~!MDoc.SrcDate & ~!MDoc.Firm THEN
   SAVE(MDocKind);
   CONFORM(MDoc, MDocKind);
   IF L_MDoc.IsPrchMDocKind()             &
      (MDocKind.MDocKind # L_MDoc.md_DPr) &
      (MDocKind.MDocKind # L_MDoc.md_DPk) &
      (MDocKind.MDocKind # L_MDoc.md_NDk) &
      (MDocKind.MDocKind # L_MDoc.md_NlO)   THEN
    tFirm   :=MDoc.Firm;
    tSrcDate:=MDoc.SrcDate;
    tMDoc   :=MDoc.MDoc;
    SAVE(MDoc);
    CHANGESEL(MDoc, MDKSrcN, , MDoc.MDocKind, MDoc.SrcNbr);
    FIRST(MDoc);
    WHILE OCCURE(MDoc) DO
     PROMPT(MDoc.MDoc);
     IF (MDoc.MDoc # tMDoc)        &
        (tFirm = MDoc.Firm)        &
        (tSrcDate  = MDoc.SrcDate)    THEN
      L_StdFrm.Choice(Str.Align(" " + L_MDoc.MDocStr(MDoc.MDocKind, MDoc.MDoc) + "  묨 ४⠬:", 48, LEFT) +
                      "||" +
                      Str.Align("室 : " + MDoc.SrcNbr, 48, LEFT) +
                      "|" +
                      Str.Align("室  : " + L_DatTim.DateStr(MDoc.SrcDate), 48, LEFT));
     END;
     NEXT(MDoc);
    END; (* WHILE OCCURE(MDoc) ... *)
    RESTORE(MDoc);
   END;
   RESTORE(MDocKind);
  END;
 END {FindSimilarMDoc};

 PRIVATE PROCEDURE CheckPrevDefMDocDest(): SCAL[2];
 BEGIN
  RETURN (MDoc.Dest = L_MDoc.E_DefMDocDest(MDoc.Date));
 END {CheckPrevDefMDocDest};

 PRIVATE PROCEDURE CheckPrevDefMDocCostItem(): SCAL[2];
 BEGIN
  RETURN (MDoc.CostItem = L_MDoc.E_DefMDocCostItem());
 END {CheckPrevDefMDocCostItem};

 PRIVATE PROCEDURE CheckPrevDefValue(Proc: PROC): SCAL[2];
  VAR
   prvBoxNbr: LIKE(MDoc.BoxNbr);
   Result: SCAL[2];
 BEGIN
  prvBoxNbr:=GE_PVALUE(MDoc.BoxNbr);
  IF ~!prvBoxNbr THEN
   TRY
    MDoc.BoxNbr:=prvBoxNbr;
    REPLACE(MDoc);
    CONFORM(MDoc, Car);
    Result:=Proc();
    L_General.RaiseLockReleaseException();
   EXCEPT
   ON Exc: Exc_Root DO
    L_General.CheckIsLockReleaseException(Exc);
   END;
  ELSE
   Result:=0;
  END;
  RETURN Result
 END {CheckPrevDefValue};

 PRIVATE PROCEDURE intGetMDocTSN(VAR trgTSN       : LIKE(Staff.TSN);
                                 VAR trgModifiable: SCAL[2]);
 BEGIN
  SETEMPTY(trgTSN);
  trgModifiable:=0;
  IF ~!MDoc.Storage THEN
   CONFORM(MDoc, Storage);
   IF Storage.Type = L_Stock.st_AdvHolder THEN
    IF ~!RTI.Get().CurZone.Fields("MDoc.Storage2") THEN
     TRY
      trgTSN:=L_MDoc.curUSER2MDocTSN(0);
     EXCEPT
     ELSE
     END;
    ELSE
     SAVE(Staff);
     SELECT(Staff, Storage, , Storage.Storage);
     trgTSN:=Staff.TSN;
     RESTORE(Staff);
    END;
   END;
  END;
  IF !trgTSN THEN
   IF GetSingleRefDocT() = L_XDoc.xdt_RWayS THEN
    IF ~!L_MDoc.curRefToXDoc_GetId() THEN
     L_MDoc.curRefToXDoc_PositionOn(L_XDoc.xdt_RWayS);
     IF L_Env.RealTSN(RWayS.TSN) THEN
      trgTSN       :=RWayS.TSN;
      trgModifiable:=~P_Storage.IsFuelStation(L_Stock.MDocStorage());
     END;
    END;
   END;
  END;
 END {intGetMDocTSN};

 PRIVATE PROCEDURE SetMDocTSNFieldModifiable();
  VAR
   trgTSN       : LIKE(Staff.TSN);
   trgModifiable: SCAL[2];
 BEGIN
  IF ~!L_WDO.cField("MDoc.TSN") THEN
   intGetMDocTSN(trgTSN, trgModifiable);
   L_WDO.cField("MDoc.TSN").Modifiable:=!trgTSN | trgModifiable;
  END;
 END {SetMDocTSNFieldModifiable};

 PRIVATE PROCEDURE GetMDocTSN(): LIKE(Staff.TSN);
  VAR
   Dummy : SCAL[2];
   trgTSN: LIKE(Staff.TSN);
 BEGIN
  intGetMDocTSN(trgTSN, Dummy);
  RETURN trgTSN;
 END {GetMDocTSN};

 PRIVATE PROCEDURE SetMDocTSN();
  VAR
   trgTSN: LIKE(Staff.TSN);
 BEGIN
  trgTSN:=GetMDocTSN();
  IF ~!trgTSN THEN
   IF ~!MDoc.TSN & (MDoc.TSN # trgTSN) THEN
    L_StdFrm.Choice("  ࠡ⭨ 㤥 ");
   END;
   MDoc.TSN:=trgTSN;
   REPLACE(MDoc);
  END;

  SetMDocTSNFieldModifiable();
 END {SetMDocTSN};

 PRIVATE PROCEDURE MDoc_BoxNbr_OnSuccessfulChange();
  VAR
   defDest    : LIKE(Dest.Dest);
   defCostItem: LIKE(CostItem.CostItem);
   RefToXDocId: L_XDoc.tXDocId;
 BEGIN
  IF ~!MDoc.BoxNbr THEN
   IF MDoc.MDocKind # L_MDoc.md_DDA THEN
    L_General.Assert(L_Env.RealBoxNbr(MDoc.BoxNbr), " ᪠ ⮫쪮  ॠ쭮 ");
   END;
   L_Car.CheckAdaptability(MDoc.BoxNbr, MDoc.Date, MDoc.MDocKind = L_MDoc.md_ViP);
   E_ExecClientCheckBoxNbr(MDoc.BoxNbr, MDoc.Date);
   RefToXDocId:=L_MDoc.curRefToXDoc_GetId();
   IF ~!RefToXDocId THEN
    L_XDoc.rf_Remove(L_XDoc.xdt_MDoc, RefToXDocId, L_XDoc.rft_RefTo);
    IF ~!L_WDO.cField("MDoc_SingleRefDoc") THEN
     SETEMPTY(L_WDO.cField("MDoc_SingleRefDoc").Value);
     L_WDO.cField("MDoc_SingleRefDocC").Value:=GetSingleRefDocC(EMPTYOF(L_XDoc.tXDocId));
    END;
   END;
   CONFORM(MDoc, Car);
   defDest:=L_MDoc.E_DefMDocDest(MDoc.Date);
   IF ~!defDest & (!MDoc.Dest | CheckPrevDefValue(PROCREF(CheckPrevDefMDocDest))) THEN
    MDoc.Dest:=defDest;
   END;
   defCostItem:=L_MDoc.E_DefMDocCostItem();
   IF ~!defCostItem & (!MDoc.CostItem | CheckPrevDefValue(PROCREF(CheckPrevDefMDocCostItem))) THEN
    MDoc.CostItem:=defCostItem;
   END;
   IF (MDoc.MDocKind = L_MDoc.md_NOV) &
      P_Storage.IsFuelStation(MDoc.Storage) &
      (GetSingleRefDocT() = L_XDoc.xdt_RWayS) THEN
    SetMDocTSN();
    CONFORM(MDoc, Storage);
    IF Storage.MyFirm # L_Car.GetCarMyFirm(MDoc.BoxNbr, MDoc.Date) THEN
     MDoc.Storage:=L_Stock.GetFuelStorage(L_Car.GetCarMyFirm(MDoc.BoxNbr, MDoc.Date));
    END;
   END;
   REPLACE(MDoc);
  END;
  CompleteAllMDocLCU(0);
 END {MDoc_BoxNbr_OnSuccessfulChange};

 PUBLIC PROCEDURE SetNewBilCURate(wReCalcIsSData: SCAL[2]);
  VAR
   newUsd,
   oldUsd     : NUMERIC[4];
   FinExtra   : NUMERIC[3];
   dummyBillCU: FLOAT;
 BEGIN
  IF P_MDoc.HasMDocPro(MDoc.MDocKind, MDoc.MDoc, P_MDoc.P_BilCURate) THEN
   L_IsSData.GetCurrencyAttr(oldUsd, FinExtra, dummyBillCU);
  ELSE
   SETEMPTY(oldUsd);
   FinExtra:=3.0;
  END;
  newUsd:=P_OwnData.USDRate(MDoc.Date);
  IF (~wReCalcIsSData & ~!oldUsd & (newUsd # oldUsd)) |
     (wReCalcIsSData & (newUsd # oldUsd)) THEN
   L_StdFrm.Question("    (USD):||" +
                     "  " + FLDTOSTR(oldUsd, "4.", 7) + "|" +
                     "   " + FLDTOSTR(newUsd, "4.", 7) + "||" +
                     "㤥 믮  ⭮  " + L_Str.PoolItem("|   ⠢ ", wReCalcIsSData));
   L_IsSData.SaveBillCU(MDoc.MDocKind, MDoc.MDoc, newUsd, FinExtra, 1);
  END;
 END {SetNewBilCURate};

 PUBLIC PROCEDURE UpdateBilCURate();
 BEGIN
  IF    SELECT(IsSData, MDoc, MDoc.MDocKind, MDoc.MDoc) THEN
   SetNewBilCURate(1);
   TRY
    CALL(IsSData.extReCalc(0));
    CALL(IsSData.Save());
    L_MDoc.SetMDocTotals(RTI.Get().CurWindow.Name);
   EXCEPT
   ON Exc: Exc_Root DO
    L_StdFrm.RedInform(" 㤠 믮  㬬  ⠢ ." +
                       L_StdFrm.THR("稭") + Exc.MsgOriginalText + L_StdFrm.HR() +
                       " 믮 楤 ନ஢ ");
   END; (* TRY *)
  ELSIF P_MDoc.HasMDocPro(MDoc.MDocKind, MDoc.MDoc, P_MDoc.P_BilCURate) THEN
   SetNewBilCURate(0);
  END;
 END {UpdateBilCURate};

 PRIVATE PROCEDURE MDoc_Date_OnSuccessfulChange();
 BEGIN
  L_General.Assert(~!MDoc.Date, " 㬥    ⮩");
  IF ~!MDoc.BoxNbr THEN
   L_Car.CheckAdaptability(MDoc.BoxNbr, MDoc.Date, MDoc.MDocKind = L_MDoc.md_ViP);
   E_ExecClientCheckBoxNbr(MDoc.BoxNbr, MDoc.Date);
  END;
  CompleteAllMDocLCU(1);
  CONFORM(MDoc, MDocList);
  WHILE OCCURE(MDocList) DO
   MDocList.Date:=MDoc.Date;
   REPLACE(MDocList);
   NEXT(MDocList);
  END; (* WHILE OCCURE(MDocList) ... *)

  UpdateBilCURate();
 END {MDoc_Date_OnSuccessfulChange};

 PRIVATE PROCEDURE CheckPDocMDoc(Strong: SCAL[2]);
  CONST
   ErrMsg = " ࠡ⠭   뫪  ⥪騩 ";
  VAR
   Checked: SCAL[2];
 BEGIN
  Checked:=0;
  SAVE(PDocMDoc);
  IF SELECT(PDocMDoc, MDoc, MDoc.MDocKind, MDoc.MDoc) THEN
   SAVE(PDoc);
   REPEAT
    CONFORM(PDocMDoc, PDoc);
    IF (PDoc.Status = L_PDoc.st_Passed) & PDoc.Done THEN
     IF Strong THEN
      L_General.Error(ErrMsg);
     ELSE
      L_StdFrm.Question(ErrMsg);
     END;
     Checked:=1;
    END;
   UNTIL Checked | ~NEXT(PDocMDoc);
   RESTORE(PDoc);
  END;
  RESTORE(PDocMDoc);
 END {CheckPDocMDoc};

 PRIVATE PROCEDURE SetMDocStaffOfCurrentUser();
 BEGIN
  IF !MDoc.TSN THEN
   TRY
    MDoc.TSN:=L_MDoc.curUSER2MDocTSN(1);
    REPLACE(MDoc);
   EXCEPT
   ELSE
   END;
  END;
 END {SetMDocStaffOfCurrentUser};

 PRIVATE PROCEDURE MDocDestChange(prvDest, newDest: LIKE(Dest.Dest));
 BEGIN
  L_General.CallUs(newDest = MDoc.Dest);
  IF ~!prvDest THEN
   CheckPDocMDoc(1);
  END;
  SELECT(PDocMDoc, MDoc, , MDoc.MDocKind, MDoc.MDoc);
  WHILE OCCURE(PDocMDoc) DO
   PDocMDoc.Dest:=MDoc.Dest;
   REPLACE(PDocMDoc);
   NEXT(PDocMDoc);
  END; (* WHILE OCCURE(PDocMDoc) ... *)
 END {MDocDestChange};

 PRIVATE PROCEDURE MDoc_Dest_OnSuccessfulChange();
 BEGIN
  L_General.Assert(L_Acnt.E_RealDest(MDoc.Dest), "   㪠 ॠ  樨");
  SetMDocStaffOfCurrentUser();
  MDocDestChange(GE_PVALUE(MDoc.Dest), MDoc.Dest);
  IF !MDoc.CostItem THEN
   MDoc.CostItem:=L_MDoc.E_DefMDocCostItem();
   REPLACE(MDoc);
  END;
 END {MDoc_Dest_OnSuccessfulChange};

 PRIVATE PROCEDURE MDoc_Firm_OnSuccessfulChange();
 BEGIN
 END {MDoc_Firm_OnSuccessfulChange};

 PUBLIC PROCEDURE SetSingleRefDocFieldAttr();
  VAR
   Visible: SCAL[2];
 BEGIN
  IF ~!L_WDO.cField("MDoc_SingleRefDocT") THEN
   Visible:=~!GetSingleRefDocT();
   L_WDO.cField("SRF_Title"         ).Visible   :=Visible;
   L_WDO.cField("MDoc_SingleRefDocC").Visible   :=Visible;
   L_WDO.cField("MDoc_SingleRefDocT").Visible   :=Visible;
   L_WDO.cField("MDoc_SingleRefDocK").Visible   :=0;
   L_WDO.cField("MDoc_SingleRefDoc" ).Visible   :=Visible;
   L_WDO.cField("MDoc_SingleRefDoc" ).Modifiable:=Visible & ~IsBuildDocByBCS();
  END;
 END {SetSingleRefDocFieldAttr};

 PRIVATE PROCEDURE intSetSingleRefDocVars(RefXDocType: L_XDoc.tXDocType;
                                          RefXDocKind: L_XDoc.tXDocKind;
                                          RefXDoc    : L_XDoc.tXDoc;
                                          RefXDocC   : STRING[]);
 BEGIN
  IF ~!L_WDO.cField("MDoc_SingleRefDocT") THEN
   L_WDO.cField("MDoc_SingleRefDocT").Value:=RefXDocType;
   L_WDO.cField("MDoc_SingleRefDocK").Value:=RefXDocKind;
   L_WDO.cField("MDoc_SingleRefDoc" ).Value:=RefXDoc;
   L_WDO.cField("MDoc_SingleRefDocC").Value:=RefXDocC;
  END;
 END {intSetSingleRefDocVars};

 PRIVATE PROCEDURE SetSingleRefDocVars(Strong: SCAL[2]);
  VAR
   RefXDocType: L_XDoc.tXDocType;
   RefXDocKind: L_XDoc.tXDocKind;
   RefXDoc    : L_XDoc.tXDoc;
   RefXDocC   : STRING[];
 BEGIN
  GetSingleRefDoc(RefXDocType, RefXDocKind, RefXDoc, RefXDocC, Strong);
  intSetSingleRefDocVars(RefXDocType, RefXDocKind, RefXDoc, RefXDocC);
 END {SetSingleRefDocVars};

 PRIVATE PROCEDURE SetEmptySingleRefDocVars();
 BEGIN
  intSetSingleRefDocVars(EMPTYOF(L_XDoc.tXDocType), EMPTYOF(L_XDoc.tXDocKind), EMPTYOF(L_XDoc.tXDoc), EMPTYOF(STRING[]));
 END {SetEmptySingleRefDocVars};

 PRIVATE PROCEDURE E_IsOperationalRWayS(): SCAL[2];
  VAR
   Local  : PROC;
   default: SCAL[2];
 BEGIN
  L_General.Assert(RWayS.Status # L_Way.rwsStat_Ordered, "ࠢ    ﭨ '" + L_Str.PoolItem(L_Way.rwsStat_Pool, RWayS.Status) + "' ");
  default:=1;
  IF L_Way.CarBegRWSLev(RWayS.BoxNbr, RWayS.Date) & P_Storage.IsFuelStation(L_Stock.MDocStorage()) THEN
   IF L_Fuel.FlAcntLev(MDoc.Date) = L_Fuel.fal_RfOpOffline THEN
    (* 04.12.2008 10:51:26 POLAK\San: , ᥣ  (0066913) *)
   ELSE
    default:=(RWayS.Status = L_Way.rwsStat_Given) &
             ((RWayS.Date = SYSDATE()) | (RWayS.Date = SYSDATE()-1) &
             (P_OwnData.DspRepTime(SYSDATE()) > SYSTIME()));
   END;
  END;
  Local:=PROCREF(E_Stock.IsOperationalRWayS);
  IF ~!Local THEN
   RETURN Local(default);
  END;
  RETURN default;
 END {E_IsOperationalRWayS};

 PRIVATE CONST
  acspnt_BackDateMDoc_wOperationalRWaySModification = 0000021;

 PRIVATE PROCEDURE AllowedBackDateMDoc_wOperationalRWaySModification(): SCAL[2];
 BEGIN
  RETURN L_AcsPnt.MayPassAccessPoint(acspnt_BackDateMDoc_wOperationalRWaySModification);
 END {AllowedBackDateMDoc_wOperationalRWaySModification};

 PRIVATE PROCEDURE IsDebitMSP(trgStorage, trgStorage2: LIKE(Storage.Storage)): SCAL[2];
  VAR
   mft   : L_MDoc.tMathFlowType;
   Result: SCAL[2];
 BEGIN
  Result:=0;
  IF MDoc.MDocKind = L_MDoc.md_MSP THEN
   mft   :=L_Rpr.GetRprSMDocListMathFlowType(trgStorage, trgStorage2);
   Result:=~!mft & (mft = L_MDoc.mft_Debit);
  END;
  RETURN Result;
 END {IsDebitMSP};

 PRIVATE PROCEDURE CheckMDocModificationRequiredBCS(BCSRequired: SCAL[2]);
 BEGIN
  IF BCSRequired & ~IsBuildDocByBCS() & ~IsBuildByGasStan() THEN
   L_AcsPnt.PassAccessPoint(0000063);
  END;
 END {CheckMDocModificationRequiredBCS};

 PUBLIC PROCEDURE CheckRefToXDocModificationLegality(After: SCAL[2]);
  VAR
   Msg             : STRING[];
   curBoxNbr       : LIKE(Car.BoxNbr);
   trgStorage,
   trgStorage2     : LIKE(Storage.Storage);
   RprObjIdSerial  : LIKE(CUCopy.Serial);
   trgRefToXDocId  : L_XDoc.tXDocId;
   trgSingleRefDocT: L_XDoc.tXDocType;
 BEGIN
  trgSingleRefDocT:=intGetSingleRefDocT(1);
  trgRefToXDocId:=GetSingleRefXDocId();
  IF    trgSingleRefDocT = L_XDoc.xdt_RWayS THEN
   IF ~!trgRefToXDocId THEN
    L_XDoc.PositionOnXDoc(trgRefToXDocId);
    IF After THEN
     L_General.Assert(L_DatTim.Per(MDoc.Date)=L_DatTim.Per(RWayS.Date), "ਮ   ᮮ⢥ ਮ ⥢ ");
     L_General.Assert(MDoc.BoxNbr = RWayS.BoxNbr, " 믨ᠭ  㣮 ");
     IF (MDoc.Status = L_MDoc.st_Passed) & L_Stock.IsFuelStationMDoc() & L_Env.RealTSN(RWayS.TSN) THEN
      L_General.Assert(MDoc.TSN = RWayS.TSN, " 믨ᠭ  㣮 ࠡ⭨");
     END;
    END;
    P_Firm.CheckMyFirmEQ(MDoc.MyFirm, L_MDoc.MDocStr(MDoc.MDocKind, MDoc.MDoc), L_Way.GetRWaySMyFirm(), " "+RWayS.RWayS);
    IF ~E_IsOperationalRWayS() THEN
     L_AcsPnt.PassAccessPoint_wExplanation(acspnt_BackDateMDoc_wOperationalRWaySModification,
                                           "  㬥  ᫮.|"+
                                           "    믮 ⮫쪮 |"+
                                           "뤠 'ᥣ' ⥢ .");
    END;
   END; (* IF ~!trgRefToXDocId *)
  ELSIF trgSingleRefDocT = L_XDoc.xdt_RprS THEN
   IF ~!trgRefToXDocId THEN
    L_XDoc.PositionOnXDoc(trgRefToXDocId);
    IF L_Rpr.IsRprS_w_Car() THEN
     curBoxNbr:=RprS.RprObjId;
     IF !MDoc.BoxNbr THEN
      MDoc.BoxNbr:=curBoxNbr;
      REPLACE(MDoc);
     ELSIF MDoc.BoxNbr # curBoxNbr THEN
      L_General.CallUs(0);
     END;
    END;
    L_Rpr.CheckAcceptableRprSStatusForBuildMDoc(RprS.Status);
    IF After THEN
     IF MDoc.Status # L_MDoc.st_Canceled THEN
      IF L_Rpr.IsRprS_w_CarBlock() | L_Rpr.IsRprS_w_Math() THEN
       SETEMPTY(Msg);
       L_Rpr.AccessOrigin();
       RprObjIdSerial:=CUCopy.Serial;
       L_Rpr.GetRprStorage(trgStorage, trgStorage2);
       CONFORM(MDoc, MDocList);
       WHILE OCCURE(MDocList) DO
        IF MDocList.MMode = L_MathR.mm_InBadRepair THEN
         IF    MDoc.MDocKind = L_MDoc.md_ViP THEN
          IF MDocList.Math = Math.Math THEN
           Msg:=" " + L_MDoc.MDocKindNick(MDoc.MDocKind, 1) + "     " + MDocList.Math +
                "  ﭨ '" + L_MathR.MModeStr(MDocList.MMode) + "',|" +
                "  ꥪ⮬ ६ (㪠  )";
          END;
          IF !Msg & L_Rpr.IsRprS_w_CarBlock() THEN
           CONFORM(MDocList, MDocLCU);
           WHILE OCCURE(MDocLCU) DO
            IF MDocLCU.CUCopy = RprS.CUCopy THEN
             CONFORM(MDocLCU, CUCopy);
             Msg:=" " + L_MDoc.MDocKindNick(MDoc.MDocKind, 1) + "    ॣ  " + CUCopy.Serial +
                  "  ﭨ '" + L_MathR.MModeStr(MDocList.MMode) + "',|" +
                  "  ꥪ⮬ ६ (㪠  )";
            END;
            NEXT(MDocLCU);
           END;
          END;
         ELSIF (MDoc.MDocKind = L_MDoc.md_TOV) | (MDoc.MDocKind = L_MDoc.md_NOV) | IsDebitMSP(trgStorage, trgStorage2) THEN
          IF MDocList.Math # Math.Math THEN
           Msg:=" " + L_MDoc.MDocKindNick(MDoc.MDocKind, 1) + " 㪠  " + MDocList.Math + "  ﭨ '" + L_MathR.MModeStr(MDocList.MMode) + "',|" +
                "   ꥪ⮬ ६|" +
                "(  㪠  "+Math.Math+")";
          END;
          IF !Msg & L_Rpr.IsRprS_w_CarBlock() THEN
           CONFORM(MDocList, MDocLCU);
           WHILE OCCURE(MDocLCU) DO
            IF MDocLCU.CUCopy # RprS.CUCopy THEN
             CONFORM(MDocLCU, CUCopy);
             Msg:=" " + L_MDoc.MDocKindNick(MDoc.MDocKind, 1) + " 㪠 ॣ  " + CUCopy.Serial + "  ﭨ '" + L_MathR.MModeStr(MDocList.MMode) + "',|" +
                  "   ꥪ⮬ ६|" +
                  "(  㪠 ॣ  " + RprObjIdSerial + ")";
            END;
            NEXT(MDocLCU);
           END;
          END;
         END; (* IF MDoc.MDocKind = L_MDoc.md_ViP...*)
         IF ~!Msg THEN
          L_General.Error(Msg);
         END;
        END; (* IF MDocList.MMode = L_MathR.mm_InBadRepair...*)
        NEXT(MDocList);
       END; (* WHILE OCCURE(MDocList) ... *)
      END; (* IF L_Rpr.IsRprS_w_CarBlock() | L_Rpr.IsRprS_w_Math()...*)
     END; (* IF MDoc.Status # L_MDoc.st_Canceled...*)
 
     L_Rpr.CheckMDocListMathMovementByRprS(RprS.RprS);
 
    END; (* IF After &...*)
   END; (* IF ~!trgRefToXDocId...*)
  END;

  IF ~!trgSingleRefDocT & After & !trgRefToXDocId THEN
   L_General.CallUs(0);
  END;
 END {CheckRefToXDocModificationLegality};

 PRIVATE PROCEDURE asMDoc_RefDoc_OnSuccessfulChange(newRefDoc: L_XDoc.tXDoc);
  VAR
   Fields           : FORM_FIELDS;
   defDest          : LIKE(Dest.Dest);
   defCostItem      : LIKE(CostItem.CostItem);
   defAlower        : LIKE(Alower.Alower);
   prvRefToXDocId   : L_XDoc.tXDocId;
   curSingleRefDocT : L_XDoc.tXDocType;
   curSingleRefDocK : L_XDoc.tXDocKind;
   curSingleRefDocId: L_XDoc.tXDocId;
 BEGIN
  prvRefToXDocId:=L_MDoc.curRefToXDoc_GetId();
  IF ~!prvRefToXDocId THEN
   IF !MDoc.doneRWF & (L_XDoc.ExtractXDocType(prvRefToXDocId) = L_XDoc.xdt_RWayS) THEN
    L_XDoc.PositionOnXDoc(prvRefToXDocId);
    IF RWayS.Status >= L_Way.rwsStat_Taken THEN
     CALL(RWayChn.AfterRefMDocModify());
    END;
   END;
   L_XDoc.rf_Remove(L_XDoc.xdt_MDoc, prvRefToXDocId, L_XDoc.rft_RefTo);
  END;
  SE_INTEGRITY(1);

  IF ~!newRefDoc THEN
   Fields:=RTI.Get().CurZone.Fields;
   curSingleRefDocT :=Fields("MDoc_SingleRefDocT").Value;
   curSingleRefDocK :=Fields("MDoc_SingleRefDocK").Value;
   curSingleRefDocId:=L_XDoc.XDocId(curSingleRefDocT, curSingleRefDocK, newRefDoc);
   L_XDoc.rf_Insert(L_XDoc.xdt_MDoc, curSingleRefDocId, L_XDoc.rft_RefTo);
   L_MDoc.curRefToXDoc_PositionOn(curSingleRefDocT);
   IF    curSingleRefDocT = L_XDoc.xdt_RWayS THEN
    L_General.Assert(~!MDoc.BoxNbr, "ࠦ      ।");
    L_General.Assert(RWayS.BoxNbr = MDoc.BoxNbr, "⥢  뤠  㣮 ");
   ELSIF curSingleRefDocT = L_XDoc.xdt_RprS THEN
    L_Rpr.CheckAcceptableRprSStatusForBuildMDoc(RprS.Status);
    IF !MDoc.BoxNbr THEN
     IF ~!Fields("MDoc.BoxNbr") & L_Rpr.IsRprS_w_Car() THEN
      L_General.Error("ࠦ      ।");
     END;
    ELSE
     CONFORM(MDoc, Car);
     L_General.Assert(RprS.CUCopy = Car.CUCopy, "    ଫ   " + MDoc.BoxNbr);
    END;
   ELSE
    L_General.CallUs(0);
   END;

   L_WDO.cField("MDoc_SingleRefDocC").Value:=GetSingleRefDocC(curSingleRefDocId);

   SetMDocTSN();

   CONFORM(MDoc, Car);
   IF !MDoc.Dest THEN
    defDest:=L_MDoc.E_DefMDocDest(MDoc.Date);
    IF ~!defDest THEN
     MDoc.Dest:=defDest;
    END;
   END;
   IF !MDoc.CostItem THEN
    defCostItem:=L_MDoc.E_DefMDocCostItem();
    IF ~!defCostItem THEN
     MDoc.CostItem:=defCostItem;
    END;
   END;
   defAlower:=L_MDoc.E_DefaultAlower(MDoc.Date);
   IF ~!defAlower THEN
    MDoc.Alower:=defAlower;
   END;
   REPLACE(MDoc);
  END;
 END {asMDoc_RefDoc_OnSuccessfulChange};

 PRIVATE PROCEDURE MDoc_MDoc_Note_OnSuccessfulChange();
  VAR
   i         : NUMERIC[0];
   Result    : STRING[];
   PropArr   : STRING[][10];
   trgPropRow: LIKE(MDocPro.PropRow);
 BEGIN
  SELECT(MDocPro, MDoc, , MDoc.MDocKind, MDoc.MDoc, P_MDoc.P_Note);
  REMSEL(MDocPro);

  Str.Format(PropArr, RTI.Get().CurZone.ActiveField.Value, Str.MaxLength(MDocPro.Value), NONE);

  trgPropRow:=1;
  i         :=0;
  WHILE i <= HIGH(PropArr) DO
   IF ~!PropArr[i] THEN
    P_MDoc.InsMDocPro(MDoc.MDocKind,
                      MDoc.MDoc,
                      P_MDoc.P_Note,
                      trgPropRow,
                      PropArr[i]);
    CALL(ObjPro.UpdateVal2Show("MDocPro"));
    INC(trgPropRow);
   END;
   INC(i);
  END; (* WHILE j <= HIGH(PropArr)...*)
 END {MDoc_MDoc_Note_OnSuccessfulChange};

 PRIVATE PROCEDURE MDoc_MDoc_SingleRefDoc_OnSuccessfulChange();
 BEGIN
  asMDoc_RefDoc_OnSuccessfulChange(RTI.Get().CurZone.ActiveField.Value);
 END {MDoc_MDoc_SingleRefDoc_OnSuccessfulChange};

 PRIVATE PROCEDURE MDoc_MDoc_Through_OnSuccessfulChange();
 BEGIN
  P_MDoc.SetMDocPro(MDoc.MDocKind, MDoc.MDoc, P_MDoc.P_Through, RTI.Get().CurZone.ActiveField.Value);
 END {MDoc_MDoc_Through_OnSuccessfulChange};

 PRIVATE PROCEDURE MDoc_TSN_OnSuccessfulChange();
 BEGIN
 END {MDoc_TSN_OnSuccessfulChange};

 PRIVATE PROCEDURE Control_MDoc_PayDate(Set: SCAL[2]);
  VAR
   _PayDuration: LIKE(CntrPro.Value);
   _Date       : DATE;
 BEGIN
  IF ~!MDoc.SrcDate THEN
   _Date:=MDoc.SrcDate;
   IF MDoc.MDocKind = L_MDoc.md_Dvr THEN
    L_General.Assert(MDoc.SrcDate <= MDoc.PayDate, "ப ⢨ ७     室 ");
   ELSE
    IF (MDoc.Status = L_MDoc.st_Passed) & L_Pmnt.E_IsMayBePaidMDoc() & ~!MDoc.Contract THEN
     _PayDuration:=P_Cntr.GetCntrProSoft(MDoc.Contract, MDoc.SrcDate, P_Cntr.P_PaymentDay);
     IF ~!_PayDuration THEN
      _Date:=L_Pmnt.GetMDocPayDate(STRTOFLD(_PayDuration, FLOAT));
      IF ~Set & ~!MDoc.PayDate & (MDoc.PayDate # _Date) THEN
 
       L_StdFrm.Choice("ப   ⮣    "+L_DatTim.DateStr(_Date)+
                       "|( ᢮  'ப ⥦')");
      END;
     END;
    END;
   END;
   IF Set THEN
    MDoc.PayDate:=_Date;
    REPLACE(MDoc);
   END;
  END;
 END {Control_MDoc_PayDate};

 PRIVATE PROCEDURE MDoc_SrcNbr_OnSuccessfulChange();
 BEGIN
  FindSimilarMDoc();
 END {MDoc_SrcNbr_OnSuccessfulChange};

 PRIVATE PROCEDURE MDoc_Contract_OnSuccessfulChange();
  VAR
   Msg         : STRING[];
   prvCostItem,
   snglCostItem: LIKE(CostItem.CostItem);
   prvDest,
   snglDest    : LIKE(Dest.Dest);
 BEGIN
  L_General.Assert(~!MDoc.Contract, "   ⠢ ");
  CONFORM(MDoc, Contract);
  L_General.Assert(Contract.Leaf, "ᯮ짮 蠡 ஢ ⨬");
  CONFORM(MDoc, MDocKind);
  IF MDoc.MDocKind # L_MDoc.md_VPC THEN
   IF L_MDoc.IsExternalMDocKind() & ((Contract.Type = L_Cntr.ct_Sell) # L_Pmnt.E_IsSellMDoc()) THEN
    IF L_Pmnt.E_IsSellMDoc() THEN
     Msg:=" ଫ 室騩    㯪";
    ELSE
     Msg:=" ଫ 室騩    த";
    END;
    IF MDoc.MDocKind = L_MDoc.md_VAU THEN
     L_StdFrm.Choice(Msg);
    ELSE
     L_StdFrm.CrucialChoice(Msg + "||筮  砥  ⮢  ॡ ⮩",
                            L_APtm.g_Acnt);
    END;
   END;
  END;
  snglDest:=P_Cntr.GetSingleDest(MDoc.Contract, MDoc.Date);
  IF ~!snglDest & (snglDest # MDoc.Dest) THEN
   IF ~!MDoc.Dest THEN
    L_StdFrm.Question("㤥   樨");
   END;
   prvDest:=MDoc.Dest;
   MDoc.Dest:=snglDest;
   REPLACE(MDoc);
   MDocDestChange(prvDest, MDoc.Dest);
  END;
  prvCostItem:=MDoc.CostItem;
  IF ~!GE_PVALUE(MDoc.Contract) THEN
   SELECT(XDocRef, bXDocId, , L_XDoc.curXDocId(L_XDoc.xdt_MDoc));
   WHILE OCCURE(XDocRef) DO
    IF XDocRef.RefType # L_XDoc.rft_wRelTo THEN
     L_General.Error("騩  ନ஢  ᭮ 㣨 㬥⮢");
    END;
    NEXT(XDocRef);
   END; (* WHILE OCCURE(XDocRef) *)
   L_MDoc.SupportMDocContractChange(GE_PVALUE(MDoc.Contract), MDoc.Contract);
   IF MDoc.CostItem = P_Cntr.GetSingleCostItem(GE_PVALUE(MDoc.Contract), MDoc.Date) THEN
    SETEMPTY(MDoc.CostItem);
    REPLACE(MDoc);
   END;
  END;
  snglCostItem:=P_Cntr.GetSingleCostItem(MDoc.Contract, MDoc.Date);
  IF L_MDoc.E_MayModifyMDocCostItem() & ~!snglCostItem & (MDoc.CostItem # snglCostItem) THEN
   IF ~!prvCostItem THEN
    L_StdFrm.Question("㤥  ");
   END;
   MDoc.CostItem:=snglCostItem;
   REPLACE(MDoc);
  END;
  CONFORM(MDoc, Contract);
  MDoc.Firm:=Contract.Firm;
  REPLACE(MDoc);
  SetMDocStaffOfCurrentUser();
  FindSimilarMDoc();
  Control_MDoc_PayDate(1);
 END {MDoc_Contract_OnSuccessfulChange};

 PRIVATE PROCEDURE MDoc_Alower_OnSuccessfulChange();
 BEGIN
 END {MDoc_Alower_OnSuccessfulChange};

 PUBLIC PROCEDURE TransferAllFromInUse();
  CONST
   ws_Empty = 0;
   ws_Zero  = 1;
   ws_AsIs  = 2;
  VAR
   curSum    : L_XObj.tSum;
   curQnt    : L_XObj.tQnt;
   curStorage: LIKE(Storage.Storage);
   WithSum   : SCAL[3];
   curMMode  : LIKE(MDocList.MMode);
 BEGIN
  APP.Get().NewPrompt("  ");
  CALL(MDocList.RemAllMDocList());
  curStorage:=MDoc.Storage;
  IF MDoc.MDocKind = L_MDoc.md_MSP THEN
   L_General.Assert(~!MDoc.Dest, "室   ' 樨'");
   CONFORM(MDoc, Dest);
   IF Dest.Type = L_Acnt.dt_Debit THEN
    curStorage:=MDoc.Storage2;
   END;
  END;
  IF !curStorage |
     (SEARCH(Storage, Storage, curStorage) & (Storage.Type # L_Stock.st_AdvHolder)) THEN
   L_General.Assert(~!MDoc.TSN, " 㪠  ⠡,   ⭮ ");
   curStorage:=L_Stock.Obtain_AdvHolderStorage(MDoc.TSN, MDoc.Date);
  END;

  IF MDoc.MDocKind = L_MDoc.md_ViP THEN
   IF L_StdFrm.Alternative("  ⮨  ?") THEN
    WithSum:=ws_AsIs;
   ELSE
    WithSum:=ws_Empty;
   END;
  ELSE
   WithSum:=ws_Zero;
  END;
  SEARCH(Storage, Storage, , curStorage);
  L_General.Assert(Storage.Type = L_Stock.st_AdvHolder,
                   "楤 '  '   ਬ ⮫쪮    ");

  SELECT(mItem, Storage, , curStorage);
  WHILE OCCURE(mItem) DO
   PROMPT(mItem.Math);
   IF WithSum = ws_AsIs THEN
    SAVE(mItem);
    L_MathR.CountUpMath(mItem.Math, L_DatTim.Per(MDoc.Date));
    RESTORE(mItem);
   END;
   CONFORM(mItem, XObject);
   CONFORM(XObject, XCalc);
   WHILE OCCURE(XCalc) DO
    SAVE(XCalc);
    L_XObj.GetOutRSaldo(XCalc.AcCut, L_DatTim.Per(MDoc.Date), curSum, curQnt);
    IF curQnt # 0 THEN
     IF   WithSum = ws_Empty THEN
      curSum:=0; (*14.06.2006 18:55:29 POLAK\Bor 0051586   SETEMPTY -   ᮮ⢥ ஢ப  ࠭ 㬥*)
     ELSIF WithSum = ws_Zero THEN
      curSum:=0;
     ELSIF WithSum = ws_AsIs THEN
      (* as is *);
     ELSE
      L_General.CallUs(0);
     END;
     IF MDoc.MDocKind = L_MDoc.md_ViP THEN
      curMMode:=L_MathR.mm_NewInAccountability;
     ELSE
      curMMode:=L_MathR.mm_New;
     END;
     L_MDoc.InsMDocList(mItem.Math, curMMode, "", curQnt, curSum, 0);
    END;
    RESTORE(XCalc);
    NARROWSEL(XCalc, AcCut);
    NEXTINEXTENDEDSEL(XCalc, AcCut);
   END; (* WHILE OCCURE(XCalc) ... *)
   NEXT(mItem);
  END; (* WHILE OCCURE(mItem) ... *)
 END {TransferAllFromInUse};

 PRIVATE PROCEDURE IsMDocListWithSum(): SCAL[2];
  VAR
   Fields: FORM_FIELDS;
 BEGIN
  Fields:=RTI.Get().CurWindow.Zones(1).Fields;
  RETURN ~!Fields("MDocListSum") | ~!Fields("MDocList.Sum");
 END {IsMDocListWithSum};

 PUBLIC PROCEDURE TransferAllFromStorage();
  VAR
   curSum    : L_XObj.tSum;
   curQnt    : L_XObj.tQnt;
   curStorage: LIKE(Storage.Storage);
   WithSum   : SCAL[2];
   curMMode  : LIKE(MDocList.MMode);
 BEGIN
  APP.Get().NewPrompt("  ");
  CALL(MDocList.RemAllMDocList());

  curStorage:=MDoc.Storage;
  IF MDoc.MDocKind = L_MDoc.md_MSP THEN
   L_General.Assert(~!MDoc.Dest, "室   ' 樨'");
   CONFORM(MDoc, Dest);
   IF Dest.Type = L_Acnt.dt_Debit THEN
    curStorage:=MDoc.Storage2;
   END;
  END;

  L_General.Assert(~!curStorage, "室 㪠 ");
  SEARCH(Storage, Storage, , curStorage);
  L_General.Assert(Storage.Type = L_Stock.st_Stock,
                   "楤 '  '   ਬ ⮫쪮   '᪫'");

  WithSum:=IsMDocListWithSum();

  L_MathR.amm_Init(MDoc.Date);

  SELECT(mItem, Storage, , curStorage);
  WHILE OCCURE(mItem) DO
   PROMPT(mItem.Math);
   IF WithSum THEN
    SAVE(mItem);
    L_MathR.CountUpMath(mItem.Math, L_DatTim.Per(MDoc.Date));
    RESTORE(mItem);
   END;

   CONFORM(mItem, Math);
   CONFORM(mItem, XObject);
   CONFORM(XObject, XCalc);
   WHILE OCCURE(XCalc) DO
    SAVE(XCalc);
    L_XObj.GetOutRSaldo(XCalc.AcCut, L_DatTim.Per(MDoc.Date), curSum, curQnt);
    IF curQnt # 0 THEN
     curMMode:=L_MathR.amm_GetMMode(Math.MathType, XCalc.AcCut);
     IF !curMMode THEN
      L_General.Error("  "+Math.Math+"  ⪨  ࠧ१ "+XCalc.AcCut+",|  ᠭ  奬      "+Math.MathType);
     END;
     IF WithSum THEN
      L_MDoc.InsMDocList(mItem.Math, curMMode, "", curQnt, curSum, 0);
     ELSE
      L_MDoc.InsMDocList(mItem.Math, curMMode, "", curQnt,      0, 0);
     END;
     IF NeedCUCopy() THEN
      cu_AutoAssign_GetFree(1);
     END;
    END;
    RESTORE(XCalc);
    NARROWSEL(XCalc, AcCut);
    NEXTINEXTENDEDSEL(XCalc, AcCut);
   END; (* WHILE OCCURE(XCalc) ... *)
   NEXT(mItem);
  END; (* WHILE OCCURE(mItem) ... *)
  L_Pmnt.FillMDocListCstDclr(1);
  L_MDoc.SetMDocTotals(RTI.Get().CurWindow.Name);
 END {TransferAllFromStorage};

 PRIVATE PROCEDURE intMDocStatus_OnSetAsPassed();
 BEGIN
  Control_MDoc_PayDate(1);
 END {intMDocStatus_OnSetAsPassed};

 PUBLIC PROCEDURE SetMDocStatusAsPassed();
 BEGIN
  MDoc.Status:=L_MDoc.st_Passed;
  REPLACE(MDoc);
  intMDocStatus_OnSetAsPassed();
 END {SetMDocStatusAsPassed};

 PRIVATE PROCEDURE KAMDocOrder(_MDocKind: LIKE(MDoc.MDocKind)): SCAL[4];
 BEGIN
  IF    L_MDoc.md_asAPr(_MDocKind) THEN  RETURN 0;
  ELSIF L_MDoc.md_asASp(_MDocKind) THEN  RETURN 2;
  ELSE                                   RETURN 1;
  END;
 END {KAMDocOrder};

 PRIVATE PROCEDURE CheckKeyAssOrder();
  VAR
   curOrder,
   chkOrder   : SCAL[3];
   curMDocKind: LIKE(MDoc.MDocKind);
   curMDoc    : LIKE(MDoc.MDoc);
   curDate    : LIKE(MDoc.Date);
   Msg        : STRING[];
 BEGIN
  IF MDoc.Status # L_MDoc.st_Canceled THEN
   curMDocKind:=MDoc.MDocKind;
   curMDoc    :=MDoc.MDoc;
   curDate    :=MDoc.Date;
   curOrder   :=KAMDocOrder(MDoc.MDocKind);
   SAVE(MDoc);
   SAVE(MDocList);
   SETSEL(MDocList, MDoc, MDoc.MDocKind, MDoc.MDoc);
   FOR_EACH MDocList DO
    Msg:="४ 冷 ᫥ ⮢  " + MDocList.Math + ":||";
    SETSEL(MDocList, Math, MDocList.Math);
    FOR_EACH MDocList DO
     IF ((MDocList.MDocKind#curMDocKind) | (MDocList.MDoc#curMDoc)) &
        L_MDoc.KeyAssetsMDoc(MDocList.MDocKind) THEN
      CONFORM(MDocList, MDoc);
      IF MDoc.Status # L_MDoc.st_Canceled THEN
       L_General.Assert(MDoc.Date # curDate, Msg+"    ⮢   "+MDocList.Math+"   |. "+L_MDoc.MDocStr(MDoc.MDocKind, MDoc.MDoc));
       chkOrder:=KAMDocOrder(MDoc.MDocKind);
       IF    (MDoc.Date < curDate) & (chkOrder > curOrder) THEN
        L_General.Error(Msg + "㬥 " + L_MDoc.GetMDocStrNbr() + "  ࠭ ⥪饣");
       ELSIF (MDoc.Date > curDate) & (chkOrder < curOrder) THEN
        L_General.Error(Msg + "㬥 " + L_MDoc.GetMDocStrNbr() + "   ⥪饣");
       ELSIF (chkOrder = curOrder) & (curOrder # 1) & ((MDoc.MDocKind # curMDocKind) | (MDoc.MDoc # curMDoc)) THEN
        L_General.Error(Msg + "  㬥 " + L_MDoc.GetMDocStrNbr());
       END;
      END;
     END;
    END; (* FOR_EACH MDocList *)
   END; (* FOR_EACH MDocList *)
   RESTORE(MDocList);
   RESTORE(MDoc);
  END; (* MDoc.Status # L_MDoc.st_Canceled ... *)
 END {CheckKeyAssOrder};

 PRIVATE PROCEDURE CheckKAMathTSN(CheckCurTSN: SCAL[2]);
  VAR
   _TSN   : LIKE(MDoc.TSN);
   _Math,
   CurMath: LIKE(MDocList.Math);
   _Date: LIKE(MDoc.Date);
 BEGIN
  _Date:=MDoc.Date;
  SETEMPTY(_TSN);
  SAVE(MDoc);
  CONFORM(MDoc, MDocList);
  WHILE OCCURE(MDocList) DO
   SAVE(MDocList);
   CurMath:=MDocList.Math;
   L_General.Assert(L_MDoc.PosToLastKeyAssChangeResponsibleMDoc(MDocList.Math, _Date-1),
                    "ꥪ     ᯫ (" + CurMath + ")");
   IF !_TSN THEN
    _TSN:=MDoc.TSN;
    _Math:=CurMath;
   ELSE
    L_General.Assert(_TSN = MDoc.TSN,
                     " " + L_DatTim.DateStr(_Date) +
                     "  ꥪ ⢥ ࠧ ࠡ⭨|" +
                     "( " + _Math + " - ⠡ " + _TSN +
                     ",  " + CurMath + " - ⠡ " + MDoc.TSN + ")");
   END;
   RESTORE(MDocList);
   NEXT(MDocList);
  END; (* WHILE OCCURE(MDocList) ... *)
  RESTORE(MDoc);
  IF CheckCurTSN & ~!_TSN THEN
   L_General.Assert(_TSN = MDoc.TSN, " "+_Math+" ᫨  㣨 ࠡ⭨ ("+_TSN+")");
  END;
 END {CheckKAMathTSN};

 PUBLIC PROCEDURE TransferKeyAssFromTSN();
  VAR
   curTSN : LIKE(MDoc.TSN);
   curDate: LIKE(MDoc.Date);
   curMath: LIKE(MDocList.Math);
 BEGIN
  IF SELECT(MDocList, MDoc, MDoc.MDocKind, MDoc.MDoc) THEN
   L_StdFrm.Choice("  ꥪ  㤠");
   TRY [INTEGRITY(INTEGRITY_ON)]
    REMSEL(MDocList);
   EXCEPT
   END;
  END;
  SETEMPTY(curTSN);
  STDFORM(L_StdFrm.sf_Choice("|  , ९  ⠡ %#####%|", "%I"), , , -1, curTSN);

  APP.Get().NewPrompt("   ࠡ⭨ "+curTSN);
  L_AFM.MakeIndex("_KAMD", "Math: LIKE(MDocList.Math)");

  curDate:=MDoc.Date;
  SAVE(MDoc);

  SELECT(MDoc, TSN, , curTSN);
  WHILE OCCURE(MDoc) DO
   NARROWSEL(MDoc, MDocKind);
   IF L_MDoc.KeyAssetsMDoc(MDoc.MDocKind) & ~L_MDoc.md_asASp(MDoc.MDocKind) THEN
    WHILE OCCURE(MDoc) DO
     PROMPT(L_MDoc.GetMDocStrNbr());
     IF MDoc.Status # L_MDoc.st_Canceled THEN
      SAVE(MDoc);
      CONFORM(MDoc, MDocList);
      WHILE OCCURE(MDocList) DO
       IF ~SEARCH(_KAMD, _KAMD, MDocList.Math) THEN
        curMath:=MDocList.Math;
        SAVE(MDocList);
        IF L_MDoc.PosToLastKeyAssChangeResponsibleMDoc(MDocList.Math, curDate-1) &
           ~L_MDoc.md_asASp(MDoc.MDocKind) & (MDoc.TSN = curTSN) THEN
         _KAMD.Math:=curMath;
         INSERT(_KAMD);
        END;
        RESTORE(MDocList);
       END;
       NEXT(MDocList);
      END; (* WHILE OCCURE(MDocList) ... *)
      RESTORE(MDoc);
     END;
     NEXT(MDoc);
    END; (* WHILE OCCURE(MDoc) ... *)
   END;
   NEXTINEXTENDEDSEL(MDoc, MDocKind);
  END; (* WHILE OCCURE(MDoc) ... *)
  PROMPT("");
  RESTORE(MDoc);
  L_General.Assert(SELECT(_KAMD, _KAMD), " ࠡ⭨ "+curTSN+"  ꥪ⮢   ।| "+L_DatTim.DateStr(MDoc.Date));
  WHILE OCCURE(_KAMD) DO
   L_MDoc.InsMDocList(_KAMD.Math, L_MathR.mm_New, L_MDoc.E_DefaultVATMode(MDoc.Date, _KAMD.Math), 0, 0, 0);
   NEXT(_KAMD);
  END; (* WHILE OCCURE(_KAMD) ... *)
  L_AFM.AF_PurgeTemp("_KAMD");
 END {TransferKeyAssFromTSN};

 PRIVATE PROCEDURE cu_aa_Prepare();
 BEGIN
  L_General.Assert(ACCESS(MDocList),
                   " ⠭ ⥪ ப ");
  L_General.Assert(~SELECT(MDocLCU, MDoc, MDocList.MDocKind, MDocList.MDoc, MDocList.MDLNbr),
                   "  ப  㦥 㪠  ");
 END {cu_aa_Prepare};

 PRIVATE PROCEDURE cu_aa_ShowAmnt(): STRING[];
 BEGIN
  RETURN "| |(ॡ㥬 ⢮ " + L_Str.IntStr(MDocList.Qnt) + " .)";
 END {cu_aa_ShowAmnt};

 PRIVATE PROCEDURE cu_AutoAssign_GetFree(Silent: SCAL[2]);
  VAR
   NeedAmount : NUMERIC[0];
   InProcCnt  : NUMERIC[0];
   curCUCnd   : L_CUC.tCondition;
   curOpKnd   : L_CUC.tOpKind;
   Msg        : STRING[];
   _CUCopy    : LIKE(CUCopy.CUCopy);
   curStorage : LIKE(Storage.Storage);
   curStrgName: LIKE(Storage.Name);
 BEGIN
  cu_aa_Prepare();
  APP.Get().NewPrompt(" ஢:  "+MDocList.Math+" "+L_MathR.MModeStr(MDocList.MMode));
  NeedAmount:=MDocList.Qnt;
  curCUCnd:=L_CUC.MMode2Condition(MDocList.MMode);

  curOpKnd:=L_MDoc.E_DefineMDocLCU_OpKind();
  IF !curOpKnd THEN
   IF    MDocList.MMode = L_MathR.mm_New THEN
    curOpKnd:=L_CUC.ok_Setting;
   ELSIF MDocList.MMode = L_MathR.mm_Restored THEN
    curOpKnd:=L_CUC.ok_Setting;
   ELSIF MDocList.MMode = L_MathR.mm_Used THEN
    curOpKnd:=L_CUC.ok_Setting;
   ELSIF MDocList.MMode = L_MathR.mm_InBadRepair THEN
    curOpKnd:=L_CUC.ok_toCR1;
   ELSIF (MDocList.MMode = L_MathR.mm_Nonserviceable  ) |
         (MDocList.MMode = L_MathR.mm_ToBeReclamaition) THEN
    curOpKnd:=L_CUC.ok_Retire;
   END;
  END;
  L_General.Assert(~!curCUCnd & ~!curOpKnd, " 㪠 ०  (" + L_MathR.MModeStr(MDocList.MMode) + ")|" +
                  " ஢ ");
  curStorage:=L_CUC.GetMDocListStorageForCUC(0, curOpKnd);
  L_General.Assert(~!curStorage, " ।  ࠭,  ண ॡ  ." +
                                 "|| ஢  ⮫쪮  ६饭    ࠭.");
  L_Stock.PositionOnStorage(curStorage);
  curStrgName:=curStorage+' "'+Storage.Name+'"';
  IF ~Silent THEN
   L_StdFrm.Choice("   ᫠ |  "+curStrgName+cu_aa_ShowAmnt());
  END;
  InProcCnt:=0;
  SETSEL(CUCopy, Math, MDocList.Math, EMPTYOF(DATE));
  LAST(CUCopy);
  WHILE OCCURE(CUCopy) & (NeedAmount > 0) DO
   PROMPT(CUCopy.CUCopy);
   IF L_CUC.AccessLastMDocLCU(CUCopy.CUCopy) & (MDocLCU.Date <= MDocList.Date) &
      L_CUC.IsCUAtStock(MDocLCU.OpKind) &
      (curStorage = L_CUC.GetCurMDocLCUStorage()) &
      (L_CUC.GetLastCUCondition(CUCopy.CUCopy) = curCUCnd) THEN
    IF ~SELECT(MDocLCU, CUCopy, CUCopy.CUCopy, L_MDoc.st_Prepared) THEN
     _CUCopy:=CUCopy.CUCopy;
     L_CUC.InsMDocLCU(CUCopy.CUCopy, MDocList.MDLNbr, curOpKnd);
     SETSEL(CUCopy, Math, MDocList.Math, EMPTYOF(DATE));
     SRCINSEL(CUCopy, LT, , _CUCopy);
     DEC(NeedAmount);
    ELSE
     INC(InProcCnt);
     PREV(CUCopy);
    END;
   ELSE
    PREV(CUCopy);
   END;
  END; (* WHILE OCCURE(CUCopy)... *)
  IF NeedAmount > 0 THEN
   Msg:="  "+curStrgName+"| ॡ㥬 ⢠ ஢";
   IF InProcCnt > 0 THEN
    Msg:=Msg + "| |( ࠡ⠭ 㬥  " + L_Str.IntStr(InProcCnt) + " !)";
   END;
   L_General.Error(Msg);
  END;
 END {cu_AutoAssign_GetFree};

 PRIVATE PROCEDURE cu_AutoAssign_GetNew(trgOpKind: L_CUC.tOpKind);
  VAR
   Msg       : STRING[];
   NeedAmount: NUMERIC[0];
   dfnOpKind : L_CUC.tOpKind;
 BEGIN
  cu_aa_Prepare();
  dfnOpKind:=L_MDoc.E_DefineMDocLCU_OpKind();
  IF ~!dfnOpKind & (trgOpKind # dfnOpKind) THEN
   L_General.Error(" 㪠  '" + L_Str.PoolItem(L_CUC.ok_Pool, trgOpKind) + "'" +
                   "|᪠ ⮫쪮  '" + L_Str.PoolItem(L_CUC.ok_Pool, dfnOpKind) + "'");
  END;
  IF    trgOpKind = L_CUC.ok_Accpt THEN
   APP.Get().NewPrompt("  ஢");
   Msg:="  ";
  ELSIF trgOpKind = L_CUC.ok_Fixup THEN
   APP.Get().NewPrompt(" ⠭ ॣ⮢");
   Msg:="ନ 䨪 ⠭ ॣ⮢| |" +
        "(ᮧ  ஢  ⠭ ॣ⮢)";
  ELSE
   L_General.CallUs(0);
  END;

  NeedAmount:=MDocList.Qnt;
  L_StdFrm.Choice(Msg + cu_aa_ShowAmnt());
  WHILE NeedAmount > 0 DO
   DEFAULT(CUCopy);
   CUCopy.Math  :=MDocList.Math;
   INSERT(CUCopy);
   CUCopy.Serial:=L_CUC.GetDefaultSerial(CUCopy.CUCopy);
   L_General.Assert((MDocList.MMode = L_MathR.mm_New) |
                    (MDocList.MMode = L_MathR.mm_Restored) |
                    (MDocList.MMode = L_MathR.mm_Nonserviceable) |
                    (MDocList.MMode = L_MathR.mm_ToBeReclamaition),
                    " 㪠 ०  (" + L_MathR.MModeStr(MDocList.MMode) + ")|" +
                    "ଫ   ");
   REPLACE(CUCopy);
   PROMPT(CUCopy.CUCopy);
   L_CUC.InsMDocLCU(CUCopy.CUCopy, MDocList.MDLNbr, trgOpKind);
   DEC(NeedAmount);
  END; (* WHILE NeedAmount > 0 ... *)
 END {cu_AutoAssign_GetNew};

 PRIVATE PROCEDURE cu_AutoAssign_GetFixed();
  VAR
   NeedAmount: NUMERIC[0];
 BEGIN
  cu_aa_Prepare();
  L_StdFrm.Choice("ନ ⠭  ࠭ 䨪஢ ஢| |" +
                  "(ॣ ᥭ   )" + cu_aa_ShowAmnt());
  NeedAmount:=MDocList.Qnt;
  SAVE(MDocLCU);
  SELECT(MDocLCU, BoxNbr, , MDoc.BoxNbr, L_MDoc.st_Passed);
  WHILE OCCURE(MDocLCU) DO
   NARROWSEL(MDocLCU, CUCopy);
   LAST(MDocLCU);
   IF MDocLCU.OpKind = L_CUC.ok_Fixup THEN
    SAVE(MDocLCU);
    L_CUC.InsMDocLCU(MDocLCU.CUCopy, MDocList.MDLNbr, L_CUC.ok_Setting);
    DEC(NeedAmount);
    RESTORE(MDocLCU);
   END;
   NEXTINEXTENDEDSEL(MDocLCU, CUCopy);
  END; (* WHILE OCCURE(MDocLCU) ... *)
  RESTORE(MDocLCU);
  L_General.Assert(NeedAmount = 0, " ⮬   ⠪ ⢠ ࠭ 䨪஢ ஢");
 END {cu_AutoAssign_GetFixed};

 PRIVATE PROCEDURE intSetMDocListSumExpression(Force: SCAL[2]);
  VAR
   MDLSumFieldTitle,
   MDLSumField     : FORM_FIELD;
 BEGIN
  MDLSumField     :=RTI.Get().CurWindow.Zones(1).Fields("MDocListSum");
  MDLSumFieldTitle:=RTI.Get().CurWindow.Zones(0).Fields("MDocListSum_1_Title");
  IF ~!MDLSumField THEN
   IF Force | (MDLSumField.Expression # "MDocList.Sum") THEN
    MDLSumFieldTitle.Value:="";
    MDLSumField.Expression:="MDocList.Sum";
   ELSE
    MDLSumFieldTitle.Value:="";
    MDLSumField.Expression:="MDocList.Sum+MDocList.VAT";
   END;
  END;
 END {intSetMDocListSumExpression};

 PUBLIC PROCEDURE SetMDocListSumExpression();
 BEGIN
  L_MDoc.AccessMDoc();
  intSetMDocListSumExpression(0);
 END {SetMDocListSumExpression};

 PUBLIC PROCEDURE GasStan_InitializePermanent();
 BEGIN
  (*祣  *)
 END {GasStan_InitializePermanent};

 PUBLIC PROCEDURE SetAnnexSign();
  VAR
   trgField: FORM_FIELD;
 BEGIN
  trgField:=RTI.Get().CurWindow.Zones(0).Fields("Dest.Name");
  IF ~!trgField THEN
   IF ~!L_XDoc.GetAnnexXDocId(L_XDoc.curXDocId(L_XDoc.xdt_MDoc)) THEN
    trgField.Color:=FORM_FIELD.Color_Field1;
   ELSE
    trgField.Color:=FORM_FIELD.Color_Field4;
   END;
  END;
 END {SetAnnexSign};

 PRIVATE CONST
  m_OnReposition   = 0;
  m_OnBeforeEdit   = 1;
  m_OnBeforeInsert = 2;
 
 PRIVATE PROCEDURE SetMDocAllFieldAttr(CurMode: SCAL[3]);
  VAR
   Fields        : FORM_FIELDS;
   Modifiable,
   NeedEditSrcNbr: SCAL[2];
 BEGIN
  Fields:=RTI.Get().CurZone.Fields;
  IF MDoc.MDocKind = L_MDoc.md_NOV THEN
   Modifiable:=~IsBuildDocByBCS();
   Fields("MDoc.Date").Modifiable  :=Modifiable;
   Fields("MDoc.BoxNbr").Modifiable:=Modifiable;
  END;

  SetMDocTSNFieldModifiable();

  IF ~!Fields("MDoc.Storage") THEN
   Modifiable:=0;
   CONFORM(MDoc, MDocKind);
   IF L_MDoc.IsMDocKind_wAnyStorage() THEN
    Modifiable:=!MDoc.Storage | !L_Stock.GetSingleAuthorizedStorage();
   END;
   Fields("MDoc.Storage").Modifiable:=Modifiable;
  END;

  SetSingleRefDocFieldAttr();

  NeedEditSrcNbr:=((L_MDoc.E_FillMDocSrcNbr() # L_MDoc.fmdsn_YesAndNotAllowEdit) &
                   (L_MDoc.E_FillMDocSrcNbr() # L_MDoc.fmdsn_NoAndNotAllowEdit)) |
                  ((CurMode = m_OnBeforeEdit) & L_General.IsAdmin() & L_MDoc.E_ResetMDocNumberingFromYearBeg(SYSDATE()));

  IF ~!Fields("MDoc.SrcNbr") THEN
   Fields("MDoc.SrcNbr").Modifiable:=NeedEditSrcNbr;
   Fields("MDoc.SrcNbr").First     :=NeedEditSrcNbr;
  END;
  IF ~!Fields("MDoc.CostItem") THEN
   Fields("MDoc.CostItem").Modifiable:=L_MDoc.E_MayModifyMDocCostItem();
   IF ~!Fields("MDoc.Contract") THEN
    Fields("MDoc.Contract").First:=~NeedEditSrcNbr;
   END;
  ELSE
   IF ~!Fields("MDoc.Dest") THEN
    Fields("MDoc.Dest").First:=~NeedEditSrcNbr;
   END;
  END;
  IF L_WDO.GetEnvVarValue("trgPrc") = "Copy" THEN
   Fields("MDoc.Date").First:=1;
  END;
  SetAnnexSign();
 END {SetMDocAllFieldAttr};

 PRIVATE PROCEDURE DifferentUserMDoc(): STRING[];
 BEGIN
  SETSEL(XDocJrn, XDocJrn, L_XDoc.xdt_MDoc, MDoc.MDocKind, MDoc.MDoc);
  IF LAST(XDocJrn) & (XDocJrn.AcsObj # L_General.curUSER) THEN
   L_General.CallUs(SEARCH(AcsObj, AcsObj, XDocJrn.AcsObj));
   RETURN "᫥  '" + L_Str.PoolItem(L_XDoc.action_Pool, XDocJrn.Action) + "'," +
          "|믮 " + L_AR.GetAcsObjManName();
  ELSE
   RETURN "";
  END;
 END {DifferentUserMDoc};

 PRIVATE PROCEDURE CheckIsOwnMDoc();
  VAR
   DiffUser: STRING[];
 BEGIN
  ACCESS(MDoc);
  CheckStorageAuthorization(MDoc.Storage);
  IF (~!MDoc.Storage & (MDoc.Status # L_MDoc.st_Prepared)) THEN
   IF P_Storage.IsOnLine(MDoc.Storage, SYSDATE()) THEN
    DiffUser:=DifferentUserMDoc();
    IF ~!DiffUser THEN
     L_AcsPnt.PassAccessPoint_wExplanation(0000036, DiffUser);
    END;
   END;
  END;
 END {CheckIsOwnMDoc};

 PRIVATE PROCEDURE IsStandartRulesZMC(): SCAL[2];
 BEGIN
  CONFORM(MDoc, MDocList);
  WHILE OCCURE(MDocList) DO
   IF ~P_Math.HasActualMathPro(MDocList.Math, MDoc.Date, P_Math.P_Remainders) THEN
    RETURN 0;
   END;
   NEXT(MDocList);
  END; (* WHILE OCCURE(MDocList) ... *)
  RETURN 1;
 END {IsStandartRulesZMC};

 PRIVATE PROCEDURE CheckIsOwnStdZMC();
  VAR
   DiffUser: STRING[];
 BEGIN
  L_General.Assert(IsStandartRulesZMC(), "   稩 䨪樨     ⠭ ⮢");
  DiffUser:=DifferentUserMDoc();
  L_General.Assert(!DiffUser, "   稩 䨪樨 , ଫ 㣨 짮⥫"+L_StdFrm.HR()+DiffUser);
 END {CheckIsOwnZMC};

 PRIVATE PROCEDURE CheckIsSpecifiedVATMDoc();
 BEGIN
  IF L_XDoc.XDocWasAutoBuild(L_XDoc.xdt_MDoc, MDoc.MDocKind, MDoc.MDoc) THEN
   L_General.Assert(~L_Pmnt.IsVATMDocKind(MDoc.MDocKind) |
                    (L_Pmnt.E_StageOfBuildingVATMDoc(MDoc.Date, MDoc.MDocKind, MDoc.Dest) # L_Pmnt.sbvmd_Offline),
                    "饭 䨪 , ନ஢ ⮬᪨");
  END;
 END {CheckIsSpecifiedVATMDoc};

 PRIVATE PROCEDURE MDoc_PassModificationAccessPoint();
  CONST
   acspnt_AllZMC_Modification = 0000054;
   acspnt_StdZMC_Modification = 0000056;
 BEGIN
  CONFORM(MDoc, MDocKind);
  IF L_MDoc.IsInternalMDocKind() THEN
   IF    MDocKind.MDocKind = L_MDoc.md_ZMC THEN
    IF ~L_AcsPnt.MayPassAccessPoint(acspnt_AllZMC_Modification) &
       L_AcsPnt.MayPassAccessPoint(acspnt_StdZMC_Modification) THEN
     CheckIsOwnStdZMC();
     L_AcsPnt.PassAccessPoint(acspnt_StdZMC_Modification);
    ELSE
     L_AcsPnt.PassAccessPoint(acspnt_AllZMC_Modification);
    END;
   ELSIF L_Stock.IsFuelStationMDoc() THEN
    L_AcsPnt.PassAccessPoint(0000004);
   ELSIF MDocKind.MDocKind # L_MDoc.md_DDA THEN
    L_AcsPnt.PassAccessPoint(L_Stock.acspnt_InternalMDocModification);
   END;
  ELSE
   L_AcsPnt.PassAccessPoint(L_Stock.acspnt_ExternalMDocModification);
  END;
 END {MDoc_PassModificationAccessPoint};

 PRIVATE PROCEDURE FillMDocListDefaultCstDclr();
 BEGIN
  IF L_Pmnt.MDocKind_wCstDclr(MDoc.MDocKind, MDoc.Date) THEN
   CONFORM(MDoc, MDocList);
   WHILE OCCURE(MDocList) DO
    IF !MDocList.CstDclr &
       L_Pmnt.E_MDocListMustHasCstDclr() &
       P_Math.IsDomesticManufacture(MDocList.Math, MDocList.Date) THEN
     MDocList.CstDclr:=L_Pmnt.CstDclr_DomesticManufacture;
     REPLACE(MDocList);
     FIXALTERING();
    END;
    NEXT(MDocList);
   END; (* WHILE OCCURE(MDocList) ... *)
  END;
 END {FillMDocListDefaultCstDclr};

 PRIVATE PROCEDURE MDoc_OnBeforeEdIns(OnInsert: SCAL[2]);
 BEGIN
  IF ~!L_WDO.cField("MDoc.Firm") THEN
   L_WDO.cField("MDoc.Firm").OnSuccessfulChange:=1;
  END;
 END {MDoc_OnBeforeEdIns};

 PRIVATE PROCEDURE MDoc_OnBeforeEdit();
 BEGIN
  APP.Get().NewPrompt(L_MDoc.GetMDocStrNbr()+" : ⨥");
  MDoc_PassModificationAccessPoint();
  MDoc_OnBeforeEdIns(0);
  CheckIsOwnMDoc();
  CheckIfIsSent(L_XDoc.action_Edit);
  CheckIsSpecifiedVATMDoc();
  AcceptableOperation("䨪");
  MakeUnprinted(0);
  L_XDoc.XDocJrn_Start(L_XDoc.xdt_MDoc, MDoc.MDocKind, MDoc.MDoc, L_XDoc.action_Edit);
  CheckRefToXDocModificationLegality(0);
  CheckMDocModificationRequiredBCS(~!GetSingleRefDocT_ByMDocStorage());
  IF (MDoc.Status = L_MDoc.st_Passed) & ~MDoc.Done & (MDoc.doneRWF = 1) THEN
   L_StdFrm.Choice("㬥 室  ﭨ ' ࠡ⠭'" +
                   "|᫥ , ந  ᯥ樠 ᫮" +
                   "|( 䨪樨  )." +
                   "|" +
                   "|।⥫쭮 㤥 믮 ࠡ⪠ ⮣ 㬥");
   CALL(MDoc.InternalSingleMakeDone());
  END;
  L_MDoc.MDoc_OnAnyModification(-1, L_MDoc.np_Yes, 0);
  CONFORM(MDoc, MDocKind);

  FillMDocListDefaultCstDclr();

  IF ~!L_WDO.GetEnvVarValue("FixAltering") THEN
   FIXALTERING();
  END;

  SetMDocAllFieldAttr(m_OnBeforeEdit);
  IF IsBuildDocByBCS() THEN
   LIKEMENU(View, ". 1");
  END;
 END {MDoc_OnBeforeEdit};

 PRIVATE PROCEDURE CheckMDocSrcDate();
  VAR
   React: NUMERIC[0];
   NeedReplaceSrcDate: SCAL[2];
   Msg: STRING[];
 BEGIN
  NeedReplaceSrcDate:=0;
  IF ~!RTI.Get().CurZone.Fields("MDoc.SrcDate") THEN
   Msg:="";
   IF    MDoc.SrcDate < MDoc.Date THEN
    Msg:="室    㬥!";
   ELSIF L_DatTim.Per(MDoc.SrcDate) > L_DatTim.NextPer(MDoc.Date) THEN
    Msg:="室    㬥  祬  ";
   END;
   IF ~!Msg THEN
    React:=STDFORM(L_StdFrm.PartForm("%< ⬥ >X" +
                                     "%< {}⠭ 室  ࠢ  㬥 >DB" +
                                     "%< {}믮 >B" +
                                     "@" +
                                     Msg +
                                     "|"+
                                     "|%##########%  %################################################%  %###########%"),
                                     "",
                                     CHOICE,
                                     1);
    NeedReplaceSrcDate:=React = 1;
   END;
  ELSE
   NeedReplaceSrcDate:=1;
  END;
  IF NeedReplaceSrcDate THEN
   MDoc.SrcDate:=MDoc.Date;
   REPLACE(MDoc);
  END;
 END {CheckMDocSrcDate};

 PRIVATE PROCEDURE CheckStorageConsistency();
 BEGIN
  IF    ~!MDoc.Storage THEN
   CONFORM(MDoc, MDocKind);
   CONFORM(MDoc, Storage);
   L_General.Assert(L_MDoc.IsInternalMDocKind() | (Storage.Type # L_Stock.st_AdvHolder),
                    "饭 ᯮ짮  '⭮ '  譨 㬥");
   IF ~!MDoc.Storage2 THEN
    IF ~L_General.IsPolakSpecific() THEN
     L_General.Assert(MDoc.Storage # MDoc.Storage2, "    ("+MDoc.Storage+")");
    END;
    CONFORM(MDoc, Storage2);
    L_General.Assert((Storage.Type = L_Stock.st_AdvHolder) = (Storage2.Type = L_Stock.st_AdvHolder),
                     "⨬ ⠭  ࠭");
   END;
  ELSIF ~!MDoc.Storage2 THEN
   L_StdFrm.WrongDB("  ᭮  ࠭");
  END;
 END {CheckStorageConsistency};

 PRIVATE PROCEDURE CheckFuelOutput();
  VAR
   Msg      : STRING[];
   trgBoxNbr: LIKE(Car.BoxNbr);
 BEGIN
  IF L_Fuel.E_OutputFuelThroughMDoc(MDoc.Date) & IsAcceptableMDocForCheckMathCompliance() THEN
   APP.Get().NewPrompt("஢ઠ ᪠ ⥯த⮢");
   SETEMPTY(trgBoxNbr);
   IF MDoc.MDocKind = L_MDoc.md_NOV THEN
    trgBoxNbr:=MDoc.BoxNbr;
   ELSE
    L_MDoc.curRefToXDoc_PositionOn(L_XDoc.xdt_RprS);
    IF L_Rpr.IsRprS_w_Car() THEN
     L_Rpr.AccessOrigin();
     trgBoxNbr:=Car.BoxNbr;
    END;
   END;

   IF ~!trgBoxNbr THEN
    SELECT(MDocList, MDoc, , MDoc.MDocKind, MDoc.MDoc);
    WHILE OCCURE(MDocList) DO
     PROMPT(MDocList.Math);
     L_Fuel.CheckMathIsMarkFuel(MDoc.Date, MDocList.Math, trgBoxNbr, Msg);
     IF ~!Msg THEN
      IF MDoc.Status = L_MDoc.st_Prepared THEN
       L_StdFrm.Choice(Msg);
      ELSE
       L_General.Error(Msg + L_StdFrm.HR() + Hint_SaveInPrepared);
      END;
     END;
     NEXT(MDocList);
    END; (* WHILE OCCURE(MDocList) ... *)
   END; (* IF ~!trgBoxNbr...*)
  END;
 END {CheckFuelOutput};

 PUBLIC PROCEDURE FillMDocListRussianCstDclr();
  VAR
   _CstDclr: LIKE(CstDclr.CstDclr);
 BEGIN
  L_General.Assert((MDoc.MDocKind = L_MDoc.md_VSF) | (MDoc.MDocKind = L_MDoc.md_RPk),
                   "⨬ ਬ '   ᨨ'   ⥪"+
                   L_StdFrm.HR()+
                   "ᯮ 'ᮢ  '| 㪠   ப  ");
  _CstDclr:=L_Pmnt.CstDclr_DomesticManufacture;
  IF ~SEARCH(CstDclr, CstDclr, _CstDclr) THEN
   _CstDclr:=L_Pmnt.CstDclr_DomesticManufacture;
   L_General.Error(" ࠢ筨 ' 樨'     " + _CstDclr);
  END;
  CONFORM(MDoc, MDocList);
  WHILE OCCURE(MDocList) DO
   IF ~!MDocList.Math THEN
    CONFORM(MDocList, Math);
    IF !MDocList.CstDclr & L_Pmnt.E_MDocListMustHasCstDclr() THEN
     MDocList.CstDclr:=_CstDclr;
     REPLACE(MDocList);
    END;
   END;
   NEXT(MDocList);
  END; (* WHILE OCCURE(MDocList) ... *)
 END {FillMDocListRussianCstDclr};

 PUBLIC PROCEDURE FillMDocListCstDclr();
 BEGIN
  L_Pmnt.FillMDocListCstDclr(0)
 END {FillMDocListCstDclr};

 PRIVATE PROCEDURE CheckMDocListVATMode();
  VAR
   CI_VATMode: LIKE(MDocList.VATMode);
 BEGIN
  IF L_General.IsPolakSpecific() & ~!MDoc.CostItem THEN
   IF (L_MDoc.CalculateVAT() # L_MDoc.cvat_Impossible) & L_MDoc.IsAvailableVATMode() THEN
    CI_VATMode:=L_MDoc.GetVATModeForCostItem(MDoc.CostItem, MDoc.Date);
    CONFORM(MDoc, MDocList);
    WHILE OCCURE(MDocList) DO
     IF P_Math.GetSpecialAttitudeToVAT(MDocList.Math, MDoc.Date) # P_Math.satVAT_TaxFree THEN
      L_General.Assert(MDocList.VATMode = CI_VATMode,
                       "ப  " + MDocList.MDLNbr + ":||㪠 ᯮᮡ   '"+L_Str.PoolItem(L_MDoc.Get_vatm_Pool(0), MDocList.VATMode)+
                       "' ⫨砥| ।   '"+ L_Str.PoolItem(L_MDoc.Get_vatm_Pool(0), CI_VATMode)+"'");
     END;
     NEXT(MDocList);
    END; (* WHILE OCCURE(MDocList) ... *)
   END;
  END;
 END {CheckMDocListVATMode};

 PRIVATE PROCEDURE MDoc_OnAfterEditInsert();
 BEGIN
  APP.Get().NewPrompt(L_MDoc.GetMDocStrNbr() + " : ࠭");
  MDoc_PassModificationAccessPoint();
  IF MDoc.Status # L_MDoc.st_Canceled THEN
   CheckMDocTSN();
   CheckMDocSrcDate();
   CheckMCurPer(0);
   CheckMDocListVATMode();
   IF MDoc.Dest = L_Dest.erkn_GetSoft(MDoc.Date, L_Dest.erkn_FuelStationMovement) THEN
    L_General.Assert(!MDoc.CostItem, "    ⮯    ॡ 㪠  室  室");
   END;
   IF ~!MDoc.Contract THEN
    IF ~!MDoc.CostItem THEN
     L_General.Assert(P_Cntr.IsAllowedCostItem(MDoc.Contract, MDoc.Date, MDoc.CostItem),
                      "  " + MDoc.Contract + "  ⮫쪮   室  室");
    END;
    IF ~!MDoc.Dest & ~L_Pmnt.IsVATMDocKind(MDoc.MDocKind) THEN
     L_General.Assert(P_Cntr.IsAllowedDest(MDoc.Contract, MDoc.Date, MDoc.Dest),
                      "  " + MDoc.Contract + "  ⮫쪮   権");
    END;
   END; (* IF ~!MDoc.Contract ... *)
   IF ~!MDoc.CostItem THEN
    L_CI.CheckRequiredCostItem(MDoc.CostItem, 1, EMPTYOF(L_CI.tCIKType));
   END;
   CheckStorageConsistency();
   CONFORM(MDoc, Staff);
   L_Staff.PosToStaffLog(Staff.TSN, MDoc.Date, 1);
   CONFORM(StaffLog, Officer);
   CONFORM(MDoc, Dest);
   CheckMDocList();
   CheckMathMarkG();
   CONFORM(MDoc, MDocList);
   IF    ~OCCURE(MDocList) THEN
    L_StdFrm.Choice("⮩ 㬥?");
   ELSIF L_MDoc.KeyAssetsMDoc(MDoc.MDocKind) (*㬥  *) THEN
    IF L_MDoc.md_asAPr(MDoc.MDocKind) THEN
     L_MDoc.CheckMDocKAGroup();
    END;
    CheckKeyAssOrder();
    IF    (MDoc.MDocKind = L_MDoc.md_ASO) THEN
     CheckKAMathTSN(0);
    ELSIF (MDoc.MDocKind = L_MDoc.md_ASp) | (MDoc.MDocKind = L_MDoc.md_AVb) THEN
     CheckKAMathTSN(1);
    END;
   END;
   IF MDoc.MDocKind = L_MDoc.md_RPk THEN
    FillMDocListRussianCstDclr();
   ELSE
    FillMDocListDefaultCstDclr();
   END;
   CheckFuelOutput();
   L_General.Assert(~L_Cntr.IsFictiveContract(MDoc.Contract) |
                    (MDoc.MDocKind = L_MDoc.md_Dvr)       |
                    (MDoc.MDocKind = L_MDoc.md_Spc)       |
                    (MDoc.MDocKind = L_MDoc.md_PCh)       |
                    (MDoc.MDocKind = L_MDoc.md_RCh),
                    "⨬ 㪠뢠 䨪⨢ ");
   Control_MDoc_PayDate(0);

   L_DBD.CheckOwnersValidity("MDoc");
  END; (* IF MDoc.Status # L_MDoc.st_Canceled ... *)

  IF L_Pmnt.IsVATMDocKind(MDoc.MDocKind) THEN
   MDoc.WFPeriod:=L_Pmnt.SpecialVATMDocClcPer(MDoc.Date);
   REPLACE(MDoc);
  END;

  L_MDoc.MDoc_OnAnyModification(+1, L_MDoc.np_Try, 0);
  CheckRefToXDocModificationLegality(1);
  L_XDoc.XDocJrn_Stop(L_XDoc.xdt_MDoc, MDoc.MDocKind, MDoc.MDoc);
  IF IsBuildDocByBCS() & (L_BarCode.GetBCSRegime() = L_BarCode.BCSr_Disconnect) THEN
   L_BarCode.SetBCSRegime(L_BarCode.BCSr_OnLine);
  END;

  IF IsBuildByGasStan() THEN
   L_General.Assert(MDoc.Status = L_MDoc.st_Prepared, "㬥, ନ஢  ,|" +
                                                      "   ﭨ '⮢'");
   CALL(GasStan.CheckMDoc());
   LIKEMENU(CALL, "GasStan.MDocAfterInsert(" + MDoc.RECORDID + ")");
  ELSE
   IF (L_MDoc.PrintMDocImmediately() # L_MDoc.mdkip_No) &
      ((MDoc.Status = L_MDoc.st_Passed) |
       (L_MDoc.KeyAssetsMDoc(MDoc.MDocKind) & (MDoc.Status = L_MDoc.st_Prepared))) THEN
    intRePrint(0); (* ⠬ LIKEMENU *)
   END;
  END;
 END {MDoc_OnAfterEditInsert};

 PRIVATE PROCEDURE GoToDependentMDocs();
  VAR
   DependentMDocs: L_XDoc.tXDocCollection;
 BEGIN
  DependentMDocs:=L_MDoc.GetDependentMDocXDC();
  IF ~!DependentMDocs THEN
   IF STDFORM(" , ନ஢  ᭮ ⥪饣| 室  ⮦ ஢||"+
              L_StdFrm.DrawButton("믮", 10, "X")+" "+L_StdFrm.DrawButton("३  易 㬥⠬", 35, "DB"),
             ,
             INFORM) = 1 THEN
    IF L_XDoc.xdc_Count(DependentMDocs) = 1 THEN
     L_XDoc.PositionInVideoSystem(L_XDoc.pm_StandOnly, L_XDoc.xdc_Item(DependentMDocs, 0), "");
    ELSE
     LIKEMENU(CALL, "XDoc.LinkedXDocsList()");
    END;
   END;
  END;
 END {GoToDependentMDocs};

 PRIVATE PROCEDURE MDoc_OnAfterEdit();
 BEGIN
  IF (MDoc.Status = L_MDoc.st_Passed) & (GE_PVALUE(MDoc.Status) # MDoc.Status) THEN
   MDoc.DoneDTS:=L_XDoc.GetSysDTS();
   REPLACE(MDoc);
  END;
  MDoc_OnAfterEditInsert();
  GoToDependentMDocs();
 END {MDoc_OnAfterEdit};

 PRIVATE PROCEDURE MDoc_OnAfterInsert();
 BEGIN
  MDoc.DoneDTS:=L_XDoc.GetSysDTS();
  REPLACE(MDoc);
  MDoc_OnAfterEditInsert();
 END {MDoc_OnAfterInsert};

 PRIVATE PROCEDURE StandartOnBeforeInsertMDoc(trgDate: DATE);
 BEGIN
  IF !trgDate THEN
   trgDate:=Memo.ud_cd();
   IF ~!MDoc.Storage & P_Storage.IsOnLine(MDoc.Storage, SYSDATE()) & (trgDate # SYSDATE()) THEN
    L_StdFrm.Choice(" 㬥  ᮢ  ⥬");
   END;
  END;
  MDoc.Date   :=trgDate;
  MDoc.SrcDate:=MDoc.Date;
  MDoc.PayDate:=MDoc.Date;
  IF MDoc.MDocKind = L_MDoc.md_ASO THEN
   MDoc.Dest:=L_Acnt.E_FictDest();
  ELSE
   MDoc.Dest:=L_WDO.GetEnvVarValue("trgDest");
  END;
  REPLACE(MDoc);
 END {StandartOnBeforeInsertMDoc};


 PRIVATE PROCEDURE pbsm_StandOnCounterContract(trgDate: DATE);
  VAR
   curSrcNbr  : LIKE(Contract.SrcNbr);
   trgMyFirm  : LIKE(Contract.MyFirm);
   trgFirm    : LIKE(Contract.Firm);
   trgContract: LIKE(Contract.Contract);
   Msg      : STRING[];
 BEGIN
  trgMyFirm:=P_Firm.GetMyFirmOfFirm(Contract.Firm);
  trgFirm  :=P_Firm.fomf(Contract.MyFirm);
  SETEMPTY(trgContract);
  curSrcNbr:=Contract.SrcNbr;
  IF ~!curSrcNbr THEN
   SELECT(Contract, SrcNbr, , curSrcNbr);
   LOOP
    IF ~OCCURE(Contract) THEN
     EXIT;
    END;
    IF (Contract.Leaf = 1) & (Contract.MyFirm = trgMyFirm) & (Contract.Firm = trgFirm) &
       L_DatTim.IsActive(trgDate, Contract.Begin, Contract.Till) THEN
     trgContract:=Contract.Contract;
     EXIT;
    END;
    NEXT(Contract);
   END; (* LOOP *)
  END;
  IF !trgContract THEN
   IF ~!curSrcNbr THEN
    Msg:="  ''   室 ஬ '" + curSrcNbr + "'.";
   ELSE
    Msg:=" ( 㬥,  ண  )   室 ." ;
   END;
   Msg:=L_StdFrm.sf_Choice(Msg +
        "||    ࠣ⮬ " + trgFirm + " ('' " + trgMyFirm + "): %#######%", "%I");
   LOOP
    IF STDFORM(Msg, " 롮   ⮢ 筮 㬥 ", , 1, trgContract) THEN
     IF SEARCH(Contract, Contract, trgContract) THEN
      IF (Contract.Leaf = 1) & (Contract.MyFirm = trgMyFirm) & (Contract.Firm = trgFirm) &
         L_DatTim.IsActive(trgDate, Contract.Begin, Contract.Till) THEN
       EXIT;
      ELSE
       L_StdFrm.RedInform("室   饣   㪠묨 ਡ⠬");
      END;
     ELSE
      L_StdFrm.RedInform("  ");
     END;
    END;
   END; (* LOOP *)
  END;
 END {pbsm_StandOnCounterContract};

 PRIVATE PROCEDURE MDoc_AnyStorage_OnSuccessfulChange();
  VAR
   Fields          : FORM_FIELDS;
   trgRefToXDocType: L_XDoc.tXDocType;
 BEGIN
  CompleteAllMDocLCU(0);
  trgRefToXDocType:=GetSingleRefDocT_ByMDocStorage();
  CheckMayInsertRefDoc(~!trgRefToXDocType);
  CheckMDocModificationRequiredBCS(~!trgRefToXDocType);
  Fields:=RTI.Get().CurZone.Fields;
  IF ~!Fields("MDoc_SingleRefDocT") THEN
   IF ~!Fields("MDoc_SingleRefDoc").Value & (trgRefToXDocType # Fields("MDoc_SingleRefDocT").Value) THEN
    L_General.Error("  ⭮襭  㬥 '"+L_Str.PoolItem(L_XDoc.ref_FullNames, Math.Min(trgRefToXDocType, Fields("MDoc_SingleRefDocT").Value))+"'");
   END;
   Fields("MDoc_SingleRefDocT").Value:=trgRefToXDocType;
   IF !Fields("MDoc_SingleRefDocT").Value THEN
    SETEMPTY(Fields("MDoc_SingleRefDocK").Value);
   ELSE
    Fields("MDoc_SingleRefDocK").Value:=L_XDoc.EmptyXDocKind;
   END;
  END;
  SetSingleRefDocVars(0);
 END {MDoc_AnyStorage_OnSuccessfulChange};

 PRIVATE PROCEDURE intMDoc_Storage_OnSuccessfulChange();
 BEGIN
  CheckStorageAuthorization(L_MDoc.MDocStorage());
  MDoc_AnyStorage_OnSuccessfulChange();
  SetMDocTSN();
 END {intMDoc_Storage_OnSuccessfulChange};

 PRIVATE PROCEDURE PrepareBySrcMDoc();
  VAR
   srcMDocKind: LIKE(MDocKind.MDocKind);
   srcMDoc    : LIKE(MDoc.MDoc);
   srcSrcNbr  : LIKE(MDoc.SrcNbr);
   srcSrcDate : LIKE(MDoc.SrcDate);
   srcDate    : LIKE(MDoc.Date);
   srcPayDate : LIKE(MDoc.PayDate);
   srcDest    : LIKE(MDoc.Dest);
   srcContract: LIKE(MDoc.Contract);
   srcCostItem: LIKE(MDoc.CostItem);
   srcRI      : LIKE(MDoc.RECORDID);
 BEGIN
  srcMDocKind:=L_Str.PoolItem(L_WDO.GetInsertionSource(), 0);
  IF  ~!srcMDocKind THEN
   srcMDoc   :=L_Str.PoolItem(L_WDO.GetInsertionSource(), 1);
   APP.Get().NewPrompt("  㬥");
   REPLACE(MDoc);
   SAVE(MDoc);
   SEARCH(MDoc, MDoc, , srcMDocKind, srcMDoc);
   srcSrcNbr  :=MDoc.SrcNbr;
   srcSrcDate :=MDoc.SrcDate;
   srcDate    :=MDoc.Date;
   srcPayDate :=MDoc.PayDate;
   srcDest    :=MDoc.Dest;
   srcContract:=MDoc.Contract;
   srcCostItem:=MDoc.CostItem;
   srcRI      :=MDoc.RECORDID;
   RESTORE(MDoc);

   MDoc.SrcDate:=srcSrcDate;
   MDoc.Date   :=srcDate;
   MDoc.PayDate:=srcPayDate;
   IF    L_WDO.GetEnvVarValue("trgPrc") = "Copy" THEN
    IF ~!srcCostItem THEN
     MDoc.CostItem:=srcCostItem;
    END;
    MDoc.Dest:=srcDest;
    IF ~!srcContract THEN
     MDoc.Contract:=srcContract;
     REPLACE(MDoc);
     MDoc_Contract_OnSuccessfulChange();
    END;
    REPLACE(MDoc);
   ELSIF L_WDO.GetEnvVarValue("trgPrc") = "Counter" THEN
    MDoc.SrcNbr :=srcSrcNbr;
    IF ~!srcContract THEN
     SEARCH(Contract, Contract, , srcContract);
     pbsm_StandOnCounterContract(MDoc.Date);
     MDoc.Contract:=Contract.Contract;
     REPLACE(MDoc);
     MDoc_Contract_OnSuccessfulChange();
     MDoc.Dest    :=L_MDoc.E_DefMDocDest(MDoc.Date);
     MDoc.CostItem:=L_MDoc.E_DefMDocCostItem();
    END;
   ELSE
    L_General.CallUs(0);
   END;
   SetMDocStaffOfCurrentUser();
 
   L_Prop.CopyProRecords("MDoc", srcRI, MDoc.RECORDID);
 
   SELECT(MDocList, MDoc, , srcMDocKind, srcMDoc);
   WHILE OCCURE(MDocList) DO
    PROMPT(MDocList.MDLNbr);
    SAVE(MDocList);
    L_MDoc.InsMDocList(MDocList.Math, MDocList.MMode, L_MDoc.E_DefaultVATMode(MDoc.Date, MDocList.Math),
                       MDocList.Qnt, MDocList.Sum, MDocList.VAT);
    RESTORE(MDocList);
    NEXT(MDocList);
   END; (* WHILE OCCURE(MDocList)... *)
  END; (* IF  ~!srcMDocKind *)
 END {PrepareBySrcMDoc};

 PRIVATE PROCEDURE SetMDocStorage2_ByRprS();
  VAR
   Msg        : STRING[];
   Local      : PROC;
   qsResult   : L_qs.tQSearchResult;
   trgStorage2: LIKE(Storage.Storage);
 BEGIN
  IF !MDoc.Storage | ~P_Storage.IsRepair(MDoc.Storage, MDoc.Date) THEN
   Local:=PROCREF(E_Rpr.GetMDocStorageByRprS);
   IF ~!Local THEN
    MDoc.Storage2:=Local();
   ELSE
    L_Stock.GetAnyStoringTypeStorage_Ext(MDoc.Date, P_Firm.DefineMyFirm(), L_Stock.storingType_Repair, trgStorage2, qsResult, Msg);
    IF    qsResult = L_qs.qsr_None THEN
     L_General.Error(Msg);
    ELSIF qsResult = L_qs.qsr_Several THEN
     TOOLTIP(Msg);
    ELSIF qsResult = L_qs.qsr_Unique THEN
     MDoc.Storage2:=trgStorage2;
    END;
   END;
  END;
 END {SetMDocStorage2_ByRprS};

 PRIVATE PROCEDURE MDoc_OnBeforeInsert();
  VAR
   Fields     : FORM_FIELDS;
   trgDate    : DATE;
   trgMath    : LIKE(Math.Math);
   trgStorage : LIKE(Storage.Storage);
   dflXDocType,
   trgXDocType: L_XDoc.tXDocType;
 BEGIN
  L_General.Assert(L_MDoc.IsRequiredMDocKind(MDoc.MDocKind, SYSDATE()) # L_MDoc.mdkrq_Disabled, "  "+L_MDoc.MDocKindNick(MDoc.MDocKind, 1)+"   ਬ"+L_StdFrm.HR()+"ᯮ   㬥⮢");
  SetEmptySingleRefDocVars();

  MDoc_OnBeforeEdIns(1);
  L_General.CallUs(MDoc.MyFirm = P_Firm.mf_Fict);
  TRY
   MDoc.mfNbr:=APP.Get().MyConnection.Number * 500;
   REPLACE(MDoc);
  EXCEPT
  ON Exc: Exc_RunTime DO
   IF L_General.IsUniquenessViolationException(Exc) THEN
    SETEMPTY(MDoc.mfNbr);
    REPLACE(MDoc);
   ELSE
    RAISE();
   END;
  END;
  MakeUnprinted(1);
  CONFORM(MDoc, MDocKind);
  IF    IsBuildByGasStan() THEN
   MDoc.Status:=L_MDoc.st_Prepared;
  ELSIF MDocKind.DfStatus = L_MDoc.st_Passed THEN
   MDoc.Status:=L_MDoc.st_Passed;
  ELSE
   MDoc.Status:=L_MDoc.st_Prepared;
  END;
  MDoc.DoneDTS:=L_XDoc.max_DoneDTS;
  MDoc.XDocId :=L_XDoc.curXDocId(L_XDoc.xdt_MDoc);
  MDoc.convId :=L_MDoc.convertionId;
  REPLACE(MDoc);

  trgDate   :=L_Prop.GetDateFromStr(L_WDO.GetEnvVarValue("trgDate"), 0);
  IF L_MDoc.IsMDocKind_wAnyStorage() THEN
   trgStorage:=L_Stock.DefaultStorage();
  ELSE
   SETEMPTY(trgStorage);
  END;

  dflXDocType:=L_MathR.E_GetSingleRefToXDocType(MDoc.Date, MDoc.MDocKind, trgStorage);
  SETEMPTY(trgXDocType);
  IF IsBuildDocByBCS() THEN
   trgXDocType:=L_XDoc.ExtractXDocType(L_XDoc.ref_XDocId);
   IF    ~!trgXDocType & (trgXDocType = L_XDoc.xdt_RWayS) THEN
    L_XDoc.PositionOnXDoc(L_XDoc.ref_XDocId);
    trgDate:=RWayS.Date;
   ELSIF (trgXDocType = L_XDoc.xdt_Command) | (trgXDocType = L_XDoc.xdt_Contract) THEN
    SETEMPTY(trgXDocType);
   END;
  END;
  StandartOnBeforeInsertMDoc(trgDate);

  IF L_MDoc.IsMDocKind_wAnyStorage() THEN
   IF ~!trgStorage & ~!trgXDocType & !L_WDO.cField("MDoc.Storage2") THEN
    IF    !dflXDocType THEN
     TOOLTIP(" ⠭   㬮砭|" +
             " ᪠ 뫪  㬥  '" + L_XDoc.Ref_FullName(trgXDocType) + "'|" +
             "   ⠢ ");
     SETEMPTY(trgStorage);
    ELSIF trgXDocType # dflXDocType THEN
     TOOLTIP(" ⠭   㬮砭 뫪|" +
             " ⮫쪮  㬥  '" + L_XDoc.Ref_FullName(dflXDocType) + "'|" +
             "   ⠢ ");
     SETEMPTY(trgStorage);
    END;
   END;
   IF ~!trgStorage THEN
    MDoc.Storage:=trgStorage;
    REPLACE(MDoc);
    intMDoc_Storage_OnSuccessfulChange();
   END
  END;

  IF (trgXDocType = L_XDoc.xdt_RWayS) | (trgXDocType = L_XDoc.xdt_RprS) THEN
   IF    trgXDocType = L_XDoc.xdt_RWayS THEN
    L_General.CallUs(MDoc.MDocKind = L_MDoc.md_NOV);
    L_XDoc.PositionOnXDoc(L_XDoc.ref_XDocId);
    MDoc.BoxNbr  :=RWayS.BoxNbr;
    REPLACE(MDoc);
    MDoc_BoxNbr_OnSuccessfulChange();
   ELSIF trgXDocType = L_XDoc.xdt_RprS THEN
    L_General.CallUs(MDoc.MDocKind = L_MDoc.md_MSP);
    L_XDoc.PositionOnXDoc(L_XDoc.ref_XDocId);
    SetMDocStorage2_ByRprS();
   END;

   Fields:=RTI.Get().CurZone.Fields;
   L_XDoc.DecodeXDocId(L_XDoc.ref_XDocId, Fields("MDoc_SingleRefDocT").Value, Fields("MDoc_SingleRefDocK").Value, Fields("MDoc_SingleRefDoc").Value);
   asMDoc_RefDoc_OnSuccessfulChange(Fields("MDoc_SingleRefDoc").Value);
  END;

  trgMath:=L_WDO.GetEnvVarValue("trgMath");
  IF ~!trgMath THEN
   L_MDoc.InsMDocList(trgMath,
                      L_MathR.mm_New,
                      "",
                      STRTOFLD(L_WDO.GetEnvVarValue("trgQnt"), NUMERIC),
                      0,
                      0);
   FIXALTERING();
  END;

  PrepareBySrcMDoc();

  L_XDoc.XDocJrn_Start(L_XDoc.xdt_MDoc, MDoc.MDocKind, MDoc.MDoc, L_XDoc.action_Insert);

  CheckMCurPer(0);
  CheckMayInsertRefDoc(~!L_MathR.E_GetSingleRefToXDocType(MDoc.Date, MDoc.MDocKind, MDoc.Storage));

  SetSingleRefDocVars(0);

  SetMDocAllFieldAttr(m_OnBeforeInsert);
 END {MDoc_OnBeforeInsert};

 PRIVATE PROCEDURE MDoc_OnBeforeDelete();
 BEGIN
  L_General.Assert(MDoc.Status = L_MDoc.st_Canceled,
                   " 㬥 饭. ᯮ '㫨஢'");
  L_General.Assert(ISPROGRAMMER(), "㬥 㤠  ");
  L_General.PrgsOnly();
  L_MDoc.extRemove_MDoc(0);
 END {MDoc_OnBeforeDelete};

 PRIVATE PROCEDURE MDoc_SrcDate_OnSuccessfulChange();
 BEGIN
  FindSimilarMDoc();
  Control_MDoc_PayDate(1);
 END {MDoc_SrcDate_OnSuccessfulChange};

 PRIVATE PROCEDURE MDoc_Status_OnSuccessfulChange();
 BEGIN
  IF    GE_PVALUE() = L_MDoc.st_Canceled THEN
   L_StdFrm.Choice("  ⬥ 㫨஢ 㬥?");
   CONFORM(MDoc, MDocList);
   WHILE OCCURE(MDocList) DO
    IF ~!MDocList.CstDclr THEN
     SETEMPTY(MDocList.CstDclr);
     REPLACE(MDocList);
    END;
    NEXT(MDocList);
   END; (* WHILE OCCURE(MDocList) ... *)
  ELSIF MDoc.Status = L_MDoc.st_Canceled THEN
   L_StdFrm.Choice("  㫨஢ 㬥?");
   CheckPDocMDoc(0);
   IF ~!L_XDoc.GetAllDependentXDC(L_XDoc.curXDocId(L_XDoc.xdt_MDoc)) THEN
    L_StdFrm.Choice(" 易 㬥");
   END;
  ELSIF MDoc.Status = L_MDoc.st_Passed THEN
   intMDocStatus_OnSetAsPassed();
  END;
  CompleteAllMDocLCU(0);
 END {MDoc_Status_OnSuccessfulChange};

 PRIVATE PROCEDURE GetSubwindowName(trgMDocKind: LIKE(MDocKind.MDocKind)): STRING[];
 BEGIN
  L_General.Assert(SEARCH(MDocKind, MDocKind, trgMDocKind),
                   " ࠢ筨  ⮢ 㬥⮢|    " + trgMDocKind + " " + L_MDoc.MDocKindNick(trgMDocKind, 1));
  IF    L_MDoc.KeyAssetsMDoc(MDocKind.MDocKind) THEN
   IF MDocKind.MDocKind = L_MDoc.md_APc THEN RETURN "MD22E";
   ELSE                                      RETURN "MDocKAE";
   END;
  ELSIF MDocKind.MDocKind = L_MDoc.md_NOV THEN RETURN "MD03EM";
  ELSIF MDocKind.MDocKind = L_MDoc.md_TOV THEN RETURN "MD02E";
  ELSIF MDocKind.MDocKind = L_MDoc.md_NPr THEN RETURN "MD011E";
  ELSIF MDocKind.MDocKind = L_MDoc.md_DDA THEN RETURN "MD16E";
  ELSIF MDocKind.MDocKind = L_MDoc.md_RNR THEN RETURN "MD58E";
  ELSIF MDocKind.MDocKind = L_MDoc.md_MSP THEN RETURN "MD60E";
  ELSIF MDocKind.MDocKind = L_MDoc.md_ViP THEN RETURN "MD61E";
  ELSIF MDocKind.MDocKind = L_MDoc.md_VPC THEN RETURN "MD62E";
  ELSIF MDocKind.MDocKind = L_MDoc.md_RPU THEN RETURN "MD67E";
  ELSIF MDocKind.MDocKind = L_MDoc.md_RPN THEN RETURN "MD68E";
  ELSIF MDocKind.MDocKind = L_MDoc.md_RSZ THEN RETURN "MD69E";
  ELSIF MDocKind.MDocKind = L_MDoc.md_TCh THEN RETURN "MD70E";
  ELSIF MDocKind.MDocKind = L_MDoc.md_ZMC THEN RETURN "MD72E";
  ELSE
   IF L_MDoc.IsExternalMDocKind()         |
      (MDocKind.MDocKind = L_MDoc.md_SpB) |
      (MDocKind.MDocKind = L_MDoc.md_Spc) |
      (MDocKind.MDocKind = L_MDoc.md_Nrd) THEN
    RETURN "MDocEIE";
   ELSE
    L_General.CallUs(0);
   END;
  END;
 END {GetSubwindowName};

 PRIVATE PROCEDURE MDoc_OnSubWinEvents();
 BEGIN
  ACCESS(MDocKind);
  RTI.Get().CurZone.HasVariousSubwindows :=1;
  RTI.Get().CurZone.SubwindowOriginalName:=GetSubwindowName(MDocKind.MDocKind);
  RTI.Get().CurZone.SubwindowAssignedName:=RTI.Get().CurZone.SubwindowOriginalName;
 END {MDoc_OnSubWinEvents};

 PRIVATE PROCEDURE MDoc_MDoc_SingleRefDoc_OnBeforeAsk();
  VAR
   Fields  : FORM_FIELDS;
   OwnerWin: STRING[];
 BEGIN
  Fields:=RTI.Get().CurZone.Fields;
  IF    Fields("MDoc_SingleRefDocT").Value = L_XDoc.xdt_RWayS THEN
   L_General.Assert(~!MDoc.BoxNbr, "ࠦ      ।");
   OwnerWin:=L_Str.PoolItem("Beg1|RWayS", (L_Fuel.FlAcntLev(MDoc.Date) = L_Fuel.fal_RfOpOffline) | AllowedBackDateMDoc_wOperationalRWaySModification());
  ELSIF Fields("MDoc_SingleRefDocT").Value = L_XDoc.xdt_RprS THEN
   OwnerWin:="RprS";
  ELSE
   L_General.CallUs(0);
  END;
  Fields("MDoc_SingleRefDoc").OwnerWindowOriginalName:=OwnerWin;
  Fields("MDoc_SingleRefDoc").OwnerZoneNumber        :=1;
 END {MDoc_MDoc_SingleRefDoc_OnBeforeAsk};

 PRIVATE PROCEDURE MDoc_Storage_OnSuccessfulChange();
 BEGIN
  intMDoc_Storage_OnSuccessfulChange();
  SetSingleRefDocFieldAttr();
 END {MDoc_Storage_OnSuccessfulChange};

 PRIVATE PROCEDURE MDoc_Storage2_OnSuccessfulChange();
 BEGIN
  IF ~!MDoc.Storage2 THEN
(* 19.10.2005 13:51:56 POLAK\San - . 0046281
   CheckStorageAuthorization(MDoc.Storage2);
*)
   L_Stock.CheckIsSelectableStorage(MDoc.Storage2);
  END;
  MDoc_AnyStorage_OnSuccessfulChange();
  SetSingleRefDocFieldAttr();
 END {MDoc_Storage2_OnSuccessfulChange};

 PRIVATE PROCEDURE MDoc_Storage2_OnAskPhase1();
 BEGIN
  IF ~!MDoc.Storage2 THEN
   SEARCH(Storage, Storage, , MDoc.Storage2);
   L_WDO.PositionInOwnerZoneOfActiveField("Storage");
  END;
 END {MDoc_Storage2_OnAskPhase1};

 PRIVATE PROCEDURE MDoc_Storage2_OnAskPhase2();
 BEGIN
  MDoc.Storage2:=Storage.Storage;
  REPLACE(MDoc);
 END {MDoc_Storage2_OnAskPhase2};

 PRIVATE PROCEDURE ap1_SetRefDocPosition(_XDocType : L_XDoc.tXDocType;
                                         SearchRes : SCAL[2]);
 BEGIN
  IF SearchRes THEN
   SE_WZD_POSITION(RTI.Get().TrgWindow.Name, RTI.Get().TrgZone.Number, ^(L_XDoc.Ref_FileName(_XDocType)));
  END;
 END {ap1_SetRefDocPosition};

 PRIVATE PROCEDURE MDoc_MDoc_SingleRefDoc_OnAskPhase1();
  VAR
   Fields: FORM_FIELDS;
 BEGIN
  Fields:=RTI.Get().CurZone.Fields;
  IF ~!Fields("MDoc_SingleRefDocT") THEN
   IF    Fields("MDoc_SingleRefDocT").Value = L_XDoc.xdt_RWayS THEN
    IF ~!Fields("MDoc_SingleRefDoc").Value THEN
     IF AllowedBackDateMDoc_wOperationalRWaySModification() THEN
      SEARCH(RWayS, RWayS,  , Fields("MDoc_SingleRefDoc").Value);
     ELSE
      SEARCH(RWayS, sRWayS, , L_Way.rwsStat_Given, Fields("MDoc_SingleRefDoc").Value);
     END;
    ELSE
     IF AllowedBackDateMDoc_wOperationalRWaySModification() THEN
      SETSEL(RWayS, BoxNbr, MDoc.BoxNbr);
      SRCINSEL(RWayS, GE, , MDoc.Date);
     ELSE
      IF ~SELECT(RWayS, sBoxNbr, L_Way.rwsStat_Given, MDoc.BoxNbr, MDoc.Date) THEN
       SELECT(RWayS, sBoxNbr, , L_Way.rwsStat_Given, MDoc.BoxNbr);
      END;
     END;
    END;
    ap1_SetRefDocPosition(L_XDoc.xdt_RWayS, OCCURE(RWayS));
   ELSIF Fields("MDoc_SingleRefDocT").Value = L_XDoc.xdt_RprS THEN
    IF    ~!Fields("MDoc_SingleRefDoc").Value THEN
     ap1_SetRefDocPosition(L_XDoc.xdt_RprS, SEARCH(RprS, RprS, Fields("MDoc_SingleRefDoc").Value));
    ELSIF ~!MDoc.BoxNbr THEN
     CONFORM(MDoc, Car);
     SETSEL(RprS, CUCopy, Car.CUCopy);
     ap1_SetRefDocPosition(L_XDoc.xdt_RprS, LAST(RprS));
    END;
   END;
  END;
 END {MDoc_MDoc_SingleRefDoc_OnAskPhase1};

 PRIVATE PROCEDURE MDoc_MDoc_SingleRefDoc_OnAskPhase2();
  VAR
   _XDoc : L_XDoc.tXDoc;
   Fields: FORM_FIELDS;
 BEGIN
  Fields:=RTI.Get().CurZone.Fields;
  IF ~!Fields("MDoc_SingleRefDocT") THEN
   IF    Fields("MDoc_SingleRefDocT").Value = L_XDoc.xdt_RWayS THEN
    L_General.Assert(ACCESS(RWayS), " ⠭ ⥢ ");
    _XDoc:=RWayS.RWayS;
   ELSIF Fields("MDoc_SingleRefDocT").Value = L_XDoc.xdt_RprS THEN
    L_General.Assert(ACCESS(RprS), " ⠭ ६ ");
    _XDoc:=RprS.RprS;
   END;
   Fields("MDoc_SingleRefDoc").Value:=_XDoc;
  END;
 END {MDoc_MDoc_SingleRefDoc_OnAskPhase2};

 PRIVATE PROCEDURE intBuildAddDoc(Silent: SCAL[2]);
  VAR
   dstMDocKind: LIKE(MDocKind.MDocKind);
 BEGIN
  dstMDocKind:=L_Pmnt.GetAddMDocKind(PROCREF(L_Pmnt.IsAcceptableAddMDocKind), "ନ஢ 㬥");
  IF L_Pmnt.IsVATMDocKind(dstMDocKind) THEN
   L_Pmnt.Build_VATMDocs(Silent, L_Pmnt.sbvmd_Online);
  ELSE
   L_Pmnt.Build_MDoc(dstMDocKind, Silent, 0);
  END;
 END {intBuildAddDoc};

 PUBLIC PROCEDURE BuildAddDoc();
 BEGIN
  L_MDoc.AccessMDoc();
  intBuildAddDoc(0);
 END {BuildAddDoc};

 PUBLIC PROCEDURE BuildAddDocSilent();
 BEGIN
  L_MDoc.AccessMDoc();
  intBuildAddDoc(1);
 END {BuildAddDocSilent};

 PUBLIC PROCEDURE RemAddDoc();
  VAR
   dstMDocKind: LIKE(MDocKind.MDocKind);
 BEGIN
  L_MDoc.AccessMDoc();
  dstMDocKind:=L_Pmnt.GetAddMDocKind(PROCREF(L_Pmnt.IsAcceptableAddMDocKind), " 㬥");
  IF L_Pmnt.IsVATMDocKind(dstMDocKind) THEN
   L_Pmnt.RemoveGeneratedVATMDocs(L_Pmnt.sbvmd_Online, L_XDoc.xdt_MDoc, MDoc.MDocKind, MDoc.MDoc);
  ELSE
   L_Pmnt.ConfirmRemovingDocs(0,
      L_Pmnt.RemoveGeneratedMDocs(1, L_Pmnt.sbvmd_Online, dstMDocKind, L_XDoc.xdt_MDoc, MDoc.MDocKind, MDoc.MDoc));
  END;
 END {RemAddDoc};

 PRIVATE PROCEDURE IsMFullAtOnce(): SCAL[2];
 BEGIN
  RETURN (KAGroup.AcnDprM=L_MathR.DprM_FullAtOnce) | (KAGroup.TaxDprM=L_MathR.DprM_FullAtOnce);
 END {IsMFullAtOnce};

 PRIVATE PROCEDURE IsMInUse(): SCAL[2];
 BEGIN
  RETURN (KAGroup.AcnDprM=L_MathR.DprM_InUse) | (KAGroup.TaxDprM=L_MathR.DprM_InUse);
 END {IsMInUse};

 PRIVATE PROCEDURE CalcAmort(CurP, ActualP: DATE; Phase: SCAL[3]);
 BEGIN
  IF SRCINSEL(_MDat, LT, ActualP) & ((Phase = 2) | ~L_MDoc.md_asASp(_MDat.MDocKind)) THEN

   IF ((KAGroup.AcnDprM # L_MathR.DprM_NoAmort) | (KAGroup.TaxDprM # L_MathR.DprM_NoAmort)) &
      ((Phase = 1) |
       ((CurP >= 01\01\2002) & (IsMFullAtOnce() | IsMInUse()))) THEN

    SetAmortPhase(Phase);

    SETSEL(MathKAGL, Math, Math.Math);
    L_General.Assert(SRCINSEL(MathKAGL, LT, ActualP), "ꥪ "+Math.Math+"| 宦  㯯 த | "+L_DatTim.DateStr(ActualP));
    MDocStorageEquipping:=mse_NoAcMthL;
    IF (Phase = 1) THEN
     ExecKAMth(CurP, L_MDoc.md_Amr, L_MDoc.DG_Amr);
    ELSE
     IF IsMFullAtOnce() THEN
      ExecKAMth(CurP, L_MDoc.md_Amr, L_MDoc.DG_Amr);
     END;
     IF IsMInUse()      THEN
      ExecKAMth(CurP, L_MDoc.md_Amr, L_MDoc.DG_Use);
     END;
    END;
    CheckMDocStorageEquipping();
   END;
  END;
 END {CalcAmort};

 PRIVATE PROCEDURE CheckRWaySDone(PerB, PerE: DATE);
 BEGIN
  IF PerB < L_DatTim.Per(SYSDATE()) THEN
   APP.Get().NewPrompt("஢ઠ ");
   SELECT(CarLog, Math, , Math.Math);
   WHILE OCCURE(CarLog) DO
    SETSEL(RWayS, BoxNbr, CarLog.BoxNbr);
    SRCINSEL(RWayS, GE, , Math.Max(CarLog.Date,  PerB));
    WHILE OCCURE(RWayS) & (RWayS.Date<=Math.Min(CarLog.DateE, PerE)) DO
     PROMPT(L_DatTim.DateStr(RWayS.Date));
     IF ~RWayS.Done & (RWayS.Status >= L_Way.rwsStat_Taken) THEN
      L_StdFrm.Choice(" ࠡ⠭ :|ਬ "+RWayS.RWayS+"  "+L_DatTim.DateStr(RWayS.Date));
      RETURN;
     END;
     NEXT(RWayS);
    END; (* WHILE OCCURE(RWayS) ... *)
    NEXT(CarLog);
   END; (* WHILE OCCURE(CarLog) ... *)
  END;
 END {CheckRWaySDone};

 PRIVATE PROCEDURE CheckCarLink(D: DATE);
 BEGIN
  IF L_MathR.PosToCarLog(Math.Math, D) THEN
   L_General.Assert(KAGLog.IsCar,  " "+Math.Math+"    ᮯ⠢   "+L_DatTim.DateStr(D)+"|. . "+CarLog.BoxNbr);
  ELSE
   L_General.Assert(~KAGLog.IsCar, " "+Math.Math+"   ᮯ⠢   "+L_DatTim.DateStr(D)+",|  㪠  ᠭ      ");
  END;
 END {CheckCarLink};

 PRIVATE PROCEDURE CheckMDocWithMathKAGL();
 BEGIN
  IF (MDoc.MDocKind = L_MDoc.md_APc) |
     ((MDoc.Date >= 01\01\2005) & (MDoc.MDocKind = L_MDoc.md_ADo)) THEN
   SAVE(MathKAGL);
   HISTCONF(L_DatTim.MonthEnd(MDoc.Date), Math, MathKAGL);
   L_General.Assert(OCCURE(MathKAGL) & (MathKAGL.Date >= L_DatTim.Per(MDoc.Date)), "..  "+L_MDoc.MDocStr(MDoc.MDocKind, MDoc.MDoc)+" ।  ⮨ ꥪ  "+Math.Math+",|  ४⭮  ⨧樨 室  "+L_DatTim.PeriodStr(MDoc.Date)+"|ନ  宦 ⮣   㯯 த ꥪ⮢,| ஬ 㪠  ४஢ ,| ⮫쪮  ॣ, ᫨   ");
   RESTORE(MathKAGL);
  END;
 END {CheckMDocWithMathKAGL};

 PUBLIC PROCEDURE MCMForKeyAssets();
  VAR
   APrDate,
   ActualDate: DATE;
 BEGIN
  IF L_Env.KeyAssAcntLev(Memo.gl_mb()) THEN
   L_AFM.MakeIndex("_MDat", "Date    : LIKE(MDoc.Date);"+
                            "MDocKind: LIKE(MDoc.MDocKind);"+
                            "MDoc    : LIKE(MDoc.MDoc);"+
                            "MDLNbr  : LIKE(MDocList.MDLNbr)");
   SAVE(Math);

   L_MathR.MathPrompt("");
   SETSEL(MDocList, Math, Math.Math);
   FOR_EACH MDocList DO
    IF MDocList.Date > Memo.gl_me() THEN
     EXIT;
    ELSIF L_MDoc.KeyAssetsMDoc(MDocList.MDocKind) THEN
     CONFORM(MDocList, MDoc);
     IF MDoc.Status = L_MDoc.st_Passed THEN
      L_General.Assert(MDoc.Done, " ࠡ⠭ "+L_XDoc.extXDocStr(MDoc.XDocId, L_XDoc.xdast_wDate));
      _MDat.Date    :=MDoc.Date;
      _MDat.MDocKind:=MDoc.MDocKind;
      _MDat.MDoc    :=MDoc.MDoc;
      _MDat.MDLNbr  :=MDocList.MDLNbr;
      INSERT(_MDat);
     END;
    END;
   END; (* FOR_EACH MDocList *)
 
   SETSEL(_MDat, _MDat);
   IF LAST(_MDat) & ((_MDat.Date>=Memo.gl_mb()) | ~L_MDoc.md_asASp(_MDat.MDocKind)) THEN
    CheckRWaySDone(Memo.gl_mb(), Memo.gl_me());
    _s:=+1;
    PasteAll(Memo.gl_mb());
    FIRST(_MDat);
    L_General.Assert(L_MDoc.md_asAPr(_MDat.MDocKind), "   ⮢  |    ᯫ.| "+Math.Math);
    APrDate   :=_MDat.Date;
    ActualDate:=Math.Max(Memo.gl_mb()-1, APrDate);
    L_MathR.PosToKAG(Math.Math, ActualDate);
    CheckCarLink(ActualDate);

    CalcAmort(Memo.gl_mb(), Memo.gl_mb(), 1);

    SRCINSEL(_MDat, GE, , Memo.gl_mb());
    WHILE OCCURE(_MDat) DO
     IF _MDat.MDocKind # L_MDoc.md_ASO THEN
      SEARCH(MDocList, MDoc, , _MDat.MDocKind, _MDat.MDoc, _MDat.MDLNbr);
      CONFORM(MDocList, MDoc);
      CONFORM(MDoc, MDocKind);
      CheckMDocWithMathKAGL();
      MDocStorageEquipping:=mse_NoAcMthL;
      ExecMth();
      CheckMDocStorageEquipping();
     END;
     NEXT(_MDat);
    END; (* WHILE OCCURE(_MDat)... *)

    IF APrDate <= Memo.gl_me() THEN
     L_MathR.PosToKAG(Math.Math, Memo.gl_me());
     CalcAmort(Memo.gl_mb(), Memo.gl_me()+1, 2);
    END;
   END;
   RESTORE(Math);
   L_AFM.AF_PurgeTemp("_MDat");
  END; (* IF L_Env.KeyAssAcntLev(Memo.gl_mb()) ... *)
 END {MCMForKeyAssets};

 PRIVATE PROCEDURE StoreInRWayF(_FuelTake: LIKE(RWayF.FuelTake);
                                _FuelRet : LIKE(RWayF.FuelRet));
 BEGIN
  IF NeedSetRWayF THEN
   RWayFHasChanged:=1;
   L_General.CallUs(((_FuelTake = 0) # (_FuelRet = 0)) | (_FuelTake = 0));
   IF ~!L_MDoc.curRefToXDoc_GetId() THEN
    L_MDoc.curRefToXDoc_PositionOn(L_XDoc.xdt_RWayS);
   ELSE
    L_General.Error(" 㪠  ⥢ ");
   END;
   IF RWayS.Done THEN
    ProceedRWayS(0, 1);
   END;
   ADD(RWayF, RWayS, , RWayS.RWayS, MDocList.Math,
       RWayF.FuelTake, _s*_FuelTake,
       RWayF.FuelRet , _s*_FuelRet );
   IF (RWayF.FuelTake = 0) & (RWayF.FuelRet = 0) & (RWayF.RemExit = 0) & (!RWayF.RemEntr | (RWayF.RemEntr = 0)) THEN
    REMOVE(RWayF);
   END;
  END;
 END {StoreInRWayF};

 PRIVATE PROCEDURE _StandOnXDoc(_XDocId: L_XDoc.tXDocId);
 BEGIN
  L_General.Assert(L_XDoc.ExtractXDocType(_XDocId)=L_XDoc.xdt_MDoc, " ⮢ 㬥!");
  L_General.Assert(L_XDoc.StandOnXDoc(_XDocId), " ⠭ 㬥");
 END {_StandOnXDoc};

 PRIVATE PROCEDURE SaveAndPurgePropertyMkBill();
 BEGIN
  L_AFM.MakeMultipleIndex("_MDPr", "Math : LIKE(Math.Math);" +
                                   "Value: LIKE(MDocPro.Value)",
                                   "_MDPr: Math");

  SELECT(MDocPro, MDoc, , MDoc.MDocKind, MDoc.MDoc, E_Prop.P_MkBill);
  WHILE OCCURE(MDocPro) DO
   IF SEARCH(MDocList, MDoc, MDoc.MDocKind, MDoc.MDoc, MDocPro.PropRow) THEN
    _MDPr.Math :=MDocList.Math;
    _MDPr.Value:=MDocPro.Value;
    INSERT(_MDPr);
   END;
   REMOVE(MDocPro);
  END; (* WHILE OCCURE(MDocPro) ... *)
 END {SaveAndPurgePropertyMkBill};

 PRIVATE PROCEDURE RestorePropertyMkBill();
  VAR
   Message: STRING[];
 BEGIN
  Message:="";
  CONFORM(MDoc, MDocList);
  IF SELECT(_MDPr, _MDPr) THEN
   WHILE OCCURE(MDocList) DO
    MDocPro.MDocKind:=MDocList.MDocKind;
    MDocPro.MDoc    :=MDocList.MDoc;
    MDocPro.PropRow :=MDocList.MDLNbr;
    MDocPro.Property:=E_Prop.P_MkBill;
    IF SEARCH(_MDPr, _MDPr, MDocList.Math) THEN
     MDocPro.Value:=_MDPr.Value;
    ELSE
     MDocPro.Value:="";
     CONFORM(MDocList, Math);
     Message:=Message + Str.Align(MDocList.MDLNbr + " "  + MDocList.Math +
                                  " " + Math.Name, 56, LEFT) + "|";
    END;
    INSERT(MDocPro);
    NEXT(MDocList);
   END; (* WHILE OCCURE(MDocList) ... *)
   IF ~!Message THEN
    L_StdFrm.Inform(" 㪠 ᢮⢮ "+L_Str.IntStr(E_Prop.P_MkBill)+",  ᫥ ப 㬥:|"
                    + Message);
   END;
  END;
  L_AFM.AF_PurgeTemp("_MDPr");
 END {RestorePropertyMkBill};

 PRIVATE PROCEDURE SaveCUCopy();
 BEGIN
  L_AFM.MakeIndex("_MDCU", "Math   : LIKE(Math.Math);"       +
                           "MDLNbr : LIKE(MDocList.MDLNbr);" +
                           "CUCopy : LIKE(MDocLCU.CUCopy); " +
                           "OpKind : LIKE(MDocLCU.OpKind); " +
                           "BoxNbr : LIKE(MDocLCU.BoxNbr); " +
                           "Date   : LIKE(MDocLCU.Date);   " +
                           "Status : LIKE(MDocLCU.Status); " +
                           "PassDTS: LIKE(MDocLCU.PassDTS);" +
                           "Storage: LIKE(MDocLCU.Storage);");
  CONFORM(MDoc, MDocList);
  WHILE OCCURE(MDocList) DO
   CONFORM(MDocList, MDocLCU);
   WHILE OCCURE(MDocLCU) DO
    _MDCU.Math   :=MDocList.Math;
    _MDCU.MDLNbr :=MDocList.MDLNbr;
    _MDCU.CUCopy :=MDocLCU.CUCopy;
    _MDCU.OpKind :=MDocLCU.OpKind;
    _MDCU.BoxNbr :=MDocLCU.BoxNbr;
    _MDCU.Date   :=MDocLCU.Date;
    _MDCU.Status :=MDocLCU.Status;
    _MDCU.PassDTS:=MDocLCU.PassDTS;
    _MDCU.Storage:=MDocLCU.Storage;
    INSERT(_MDCU);
    NEXT(MDocLCU);
   END; (* WHILE OCCURE(MDocLCU) ... *)
   NEXT(MDocList);
  END; (* WHILE OCCURE(MDocList) ... *)
 END {SaveCUCopy};

 PRIVATE PROCEDURE SaveCstDclr();
 BEGIN
  L_AFM.MakeIndex("_MDCD", "Math   : LIKE(Math.Math);"       +
                           "MDLNbr : LIKE(MDocList.MDLNbr);" +
                           "CstDclr: LIKE(CstDclr.CstDclr)");
  CONFORM(MDoc, MDocList);
  WHILE OCCURE(MDocList) DO
   IF ~!MDocList.CstDclr THEN
    _MDCD.Math   :=MDocList.Math;
    _MDCD.MDLNbr :=MDocList.MDLNbr;
    _MDCD.CstDclr:=MDocList.CstDclr;
    INSERT(_MDCD);
   END;
   NEXT(MDocList);
  END; (* WHILE OCCURE(MDocList) ... *)
 END {SaveCstDclr};

 PRIVATE PROCEDURE RestoreCUCopy();
  VAR
   SpareMDCU: STRING[];
   i,
   _Required: NUMERIC[0];
 BEGIN
  SELECT(MDocList, MDoc, , MDoc.MDocKind, MDoc.MDoc);
  CONFORM(MDoc, MDocKind);
  WHILE OCCURE(MDocList) DO
   CONFORM(MDocList, Math);
   IF NeedCUCopy() THEN
    _Required:=L_MDoc.GetMDocListCir2();
   ELSE
    _Required:=0;
   END;
   i:=0;
   SELECT(_MDCU, _MDCU, , MDocList.Math);
   WHILE OCCURE(_MDCU) & (i # _Required) DO
    MDocLCU.MDocKind:=MDocList.MDocKind;
    MDocLCU.MDoc    :=MDocList.MDoc;
    MDocLCU.MDLNbr  :=MDocList.MDLNbr;
    MDocLCU.CUCopy  :=_MDCU.CUCopy;
    MDocLCU.OpKind  :=_MDCU.OpKind;
    MDocLCU.BoxNbr  :=_MDCU.BoxNbr;
    MDocLCU.Date    :=_MDCU.Date;
    MDocLCU.Status  :=_MDCU.Status;
    MDocLCU.PassDTS :=_MDCU.PassDTS;
    MDocLCU.Storage :=_MDCU.Storage;
    INSERT(MDocLCU);
    L_CUC.CompleteMDocLCU(0);
    INC(i);
    REMOVE(_MDCU);
   END; (* WHILE OCCURE(_MDCU) ... *)
   IF i # _Required THEN
    L_StdFrm.Inform(" 墠⠥ " + L_Str.IntStr(_Required-i) +
                    " ᪨ ஢  ꥪ  " +  MDocList.MDLNbr);
   END;
   NEXT(MDocList);
  END; (* WHILE OCCURE(MDocList) ... *)
  SpareMDCU:="";
  SELECT(_MDCU, _MDCU);
  IF OCCURE(_MDCU) THEN
   WHILE OCCURE(_MDCU) DO
    IF ~!SpareMDCU THEN
     SpareMDCU:=SpareMDCU + ", ";
    END;
    SpareMDCU:=SpareMDCU + _MDCU.CUCopy;
    NEXT(_MDCU);
   END; (* WHILE OCCURE(_MDCU) ... *)
   SpareMDCU:='᮪ "譨" ᪨ ஢:|' + SpareMDCU;
   L_StdFrm.Inform(SpareMDCU);
  END;
  L_AFM.AF_PurgeTemp("_MDCU");
 END {RestoreCUCopy};

 PRIVATE PROCEDURE RestoreCstDclr();
 BEGIN
  SELECT(MDocList, MDoc, , MDoc.MDocKind, MDoc.MDoc);
  WHILE OCCURE(MDocList) DO
   IF SELECT(_MDCD, _MDCD, MDocList.Math) THEN
    CONFORM(MDocList, Math);
    IF ~!MDocList.CstDclr & (MDocList.CstDclr # _MDCD.CstDclr) THEN
     L_StdFrm.Inform(" ꥪ  " + MDocList.MDLNbr + "   室 " +
                     " ਢ 㬥  ᮢ");
    END;
    MDocList.CstDclr:=_MDCD.CstDclr;
    REPLACE(MDocList);
    CheckCstDclr();
    REMOVE(_MDCD);
   END;
   NEXT(MDocList);
  END; (* WHILE OCCURE(MDocList) ... *)
  L_AFM.AF_PurgeTemp("_MDCD");
 END {RestoreCstDclr};

 PRIVATE PROCEDURE MakeCorrespondIsSData();
  CONST
   dummyMDoc = 9999999;
  VAR
   Message       : STRING[];
   trgMDocKind   : LIKE(MDocKind.MDocKind);
   trgMDoc       : LIKE(MDoc.MDoc);
   trgISDMDLNbr  : LIKE(IsSData.MDLNbr);
   MDocHasIsSData: SCAL[2];
 BEGIN
  MDocHasIsSData:=0;
  trgMDocKind   :=MDoc.MDocKind;
  trgMDoc       :=MDoc.MDoc;
  SAVE(MDoc);
  L_General.CallUs(~SEARCH(MDoc, MDoc, trgMDocKind, dummyMDoc));
  SE_INTEGRITY(0);
  WHILE SELECT(IsSData, MDoc, trgMDocKind, trgMDoc) DO
   MDocHasIsSData:=1;

   IsSData.MDoc  :=dummyMDoc;
   REPLACE(IsSData);
  END; (* WHILE OCCURE(IsSData) ... *)

  IF MDocHasIsSData THEN
   SELECT(MDocList, MDoc, , trgMDocKind, trgMDoc);
   WHILE OCCURE(MDocList) DO
    SETEMPTY(trgISDMDLNbr);
    SELECT(IsSData, MDoc, , trgMDocKind, dummyMDoc);
    WHILE OCCURE(IsSData) & !trgISDMDLNbr DO
     NARROWSEL(IsSData, MDLNbr);
     IF IsSData.Math = MDocList.Math THEN
      trgISDMDLNbr:=IsSData.MDLNbr;
      WHILE SELECT(IsSData, MDoc, trgMDocKind, dummyMDoc, trgISDMDLNbr) DO
       IsSData.MDocKind:=trgMDocKind;
       IsSData.MDoc    :=trgMDoc;
       IsSData.MDLNbr  :=MDocList.MDLNbr;
       REPLACE(IsSData);
      END; (* WHILE OCCURE(IsSData) ... *)
     END;
     NEXTINEXTENDEDSEL(IsSData, MDLNbr);
    END; (* WHILE OCCURE(IsSData) ... *)
    NEXT(MDocList);
   END; (* WHILE OCCURE(MDocList) ... *)
   RESTORE(MDoc);
 
   IF SELECT(IsSData, MDoc, trgMDocKind, dummyMDoc) THEN
    REMSEL(IsSData);
   END;
   SE_INTEGRITY(1);
 
   SETEMPTY(Message);
   CONFORM(MDoc, MDocList);
   WHILE OCCURE(MDocList) DO
    IF ~SELECT(IsSData, MDoc, MDocList.MDocKind, MDocList.MDoc, MDocList.MDLNbr) THEN
     CONFORM(MDocList, Math);
     Message:=Message + Str.Align(MDocList.MDLNbr + " "  + MDocList.Math + " " + Math.Name, 80, LEFT) + "|";
    END;
    NEXT(MDocList);
   END; (* WHILE OCCURE(MDocList) ... *)
 
   IF ~!Message THEN
    L_StdFrm.Inform("᫥ ਢ  ᮮ⢥⢨   ⠢ |" +
                    " ᫥ ப 㬥:||" + Message + "||" +
                    "室 믮 楤 ନ஢ ");
   END;
  ELSE
   SE_INTEGRITY(1);
   RESTORE(MDoc);
  END;
 END {MakeCorrespondIsSData};

 PUBLIC PROCEDURE MakeCorrespond();
 VAR
  cur_MDoc    : LIKE(MDoc.MDoc);
  cur_MDocKind: LIKE(MDoc.MDocKind);
  cur_MDocDate: LIKE(MDoc.Date);
  cur_MDocDest: LIKE(MDoc.Dest);
  Total       : LIKE(MDoc.Total);
 BEGIN
  L_MDoc.AccessMDoc();
  IF L_General.IsPolakSpecific() THEN
   SaveAndPurgePropertyMkBill();
  END;
  IF SELECT(MDocLCU, MDoc, MDoc.MDocKind, MDoc.MDoc) THEN
   L_StdFrm.Inform("㬥 筨 ᮤন 뫪  ");
  END;
  SaveCUCopy();
  IF MDoc.MDocKind = L_MDoc.md_VSF THEN
   SaveCstDclr();
  END;
  IF SELECT(MDocList, MDoc, MDoc.MDocKind, MDoc.MDoc) THEN
   TRY [INTEGRITY(INTEGRITY_ON)]
    REMSEL(MDocList);
   EXCEPT
   END;
  END;
  cur_MDoc    :=MDoc.MDoc;
  cur_MDocKind:=MDoc.MDocKind;
  cur_MDocDate:=MDoc.Date;
  cur_MDocDest:=MDoc.Dest;
  SAVE(MDoc);

  _StandOnXDoc(L_XDoc.LinkedXDocsMenu(L_XDoc.XDocId(L_XDoc.xdt_MDoc,
                                                    MDoc.MDocKind,
                                                    MDoc.MDoc)));
  L_General.Assert(cur_MDocDest = MDoc.Dest, " 権   묨");
  L_StdFrm.Choice("祭  ⥪饣 ⮢୮ 㬥 㤥 |" +
                  "ᮮ⢥騬 筥  " + L_MDoc.GetMDocStrNbr());
  CONFORM(MDoc, MDocList);
  WHILE OCCURE(MDocList) DO
   IF ~L_Pmnt.IsVATMDocKind(cur_MDocKind) | L_Pmnt.IsAcptToVATMDocList() THEN
    SAVE(MDocList);
    MDocList.MDocKind:=cur_MDocKind;
    MDocList.MDoc    :=cur_MDoc;
    MDocList.Date    :=cur_MDocDate;
    IF ~L_Pmnt.MDocKind_wCstDclr(cur_MDocKind, cur_MDocDate) THEN
     SETEMPTY(MDocList.CstDclr);
    END;
    INSERT(MDocList);
    RESTORE(MDocList);
   END;
   NEXT(MDocList);
  END; (* WHILE OCCURE(MDocList) ... *)
  Total:=MDoc.Total;

  RESTORE(MDoc);
  RestoreCUCopy();
  IF MDoc.MDocKind = L_MDoc.md_VSF THEN
   RestoreCstDclr();
  ELSE
   L_Pmnt.FillMDocListCstDclr(1);
  END;
  IF L_General.IsPolakSpecific() THEN
   RestorePropertyMkBill();
  END;

  MakeCorrespondIsSData();

  MDoc.Total:=Total;
  REPLACE(MDoc);
  L_MDoc.SetMDocTotals(RTI.Get().CurWindow.Name);
 END {MakeCorrespond};

 PUBLIC PROCEDURE MakeProtocol();
 BEGIN
  L_MDoc.AccessMDoc();
  APP.Get().NewPrompt(L_MDoc.GetMDocStrNbr()+" : ⮪ ࠡ⪨");
  L_XDR.sl_Init("奬 権");
  L_XDR.InitEntryList();
  L_XDR.PrepareEntryList(L_XDoc.xdt_MDoc, EMPTYOF(DATE), 0);
  L_XDR.OutEntryList(L_XDoc.xdt_MDoc);
  L_XDR.DeInitEntryList();
  L_XDR.sl_Done();
 END {MakeProtocol};

 PRIVATE PROCEDURE SetCUCopyVars();
  VAR
   trgMath  : LIKE(Math.Math);
   trgSerial: LIKE(CUCopy.Serial);
 BEGIN
  SETEMPTY(trgMath, trgSerial);
  IF ~!MDoc.CUCopy THEN
   CONFORM(MDoc, CUCopy);
   trgMath  :=CUCopy.Math;
   trgSerial:=CUCopy.Serial;
  END;
  IF ~!L_WDO.cField("CUCopyMath") THEN
   L_WDO.cField("CUCopyMath").Value:=trgMath;
  END;
  IF ~!L_WDO.cField("CUCopySerial") THEN
   L_WDO.cField("CUCopySerial").Value:=trgSerial;
  END;
 END {SetCUCopyVars};

 PRIVATE PROCEDURE CondSetFieldValue(FieldName, FieldValue: STRING[]);
 BEGIN
  IF ~!L_WDO.cField(FieldName) THEN
   L_WDO.cField(FieldName).Value:=FieldValue;
  END;
 END {CondSetFieldValue};

 PRIVATE PROCEDURE AnyMDoc_OnReposition();
 BEGIN
  CONFORM(MDoc, MDocKind);
  CondSetFieldValue("MDoc_Through",     P_MDoc.GetMDocProSoft(MDoc.MDocKind, MDoc.MDoc, P_MDoc.P_Through));
  CondSetFieldValue("MDoc_Note",        P_MDoc.GetNote(MDoc.MDocKind, MDoc.MDoc));
  CondSetFieldValue("MDoc_ServiceNote", L_Str.PoolItem(P_MDoc.sv_Pool, P_MDoc.HasActualMDocPro(MDoc.MDocKind, MDoc.MDoc, P_MDoc.P_ServiceNote)));

  SetCUCopyVars();
  SetSingleRefDocVars(0);
  SetMDocAllFieldAttr(m_OnReposition);
  L_MDoc.SetMDocTotals(RTI.Get().CurWindow.Name);
 END {AnyMDoc_OnReposition};

 PRIVATE PROCEDURE MDoc_OnReposition();
 BEGIN
  AnyMDoc_OnReposition();
 END {MDoc_OnReposition};

 PRIVATE PROCEDURE MD03EM_0_OnReposition();
 BEGIN
  AnyMDoc_OnReposition();
 END {MD03EM_0_OnReposition};

 PRIVATE PROCEDURE MD02E_0_OnReposition();
 BEGIN
  AnyMDoc_OnReposition();
 END {MD02E_0_OnReposition};

 PRIVATE PROCEDURE MD60E_0_OnReposition();
 BEGIN
  AnyMDoc_OnReposition();
 END {MD60E_0_OnReposition};

 PRIVATE PROCEDURE FillMDocCUCopy(   _XDocId : L_XDoc.tXDocId;
                                     _CopyCnt: L_XDoc.tCopyCnt;
                                 VAR _Message: STRING[]);
   VAR
   _XDocType : L_XDoc.tXDocType;
   _XDocKind : L_XDoc.tXDocKind;
   _CUCopy   : L_XDoc.tXDoc;
 BEGIN
  L_XDoc.DecodeXDocId(_XDocId, _XDocType, _XDocKind, _CUCopy);
  IF _XDocType = L_XDoc.xdt_CUCopy THEN
   MDoc.CUCopy:=_CUCopy;
   REPLACE(MDoc);
   HALT(0);
  ELSE
   L_General.Error("롮   ਩ ஬ ");
  END;
 END {FillMDocCUCopy};

 PRIVATE PROCEDURE GetRequiredTypeXDocIdByBC(Title: STRING[]): L_XDoc.tXDocId;
 BEGIN
  RETURN L_XDoc.GetRequiredTypeXDocIdByBC(Title, EMPTYOF(L_XDoc.tXDocType), 0);
 END {GetRequiredTypeXDocIdByBC};

 PUBLIC PROCEDURE intInsertMDoc_byBCS();
 BEGIN
  LIKEMENU(Ins, "@ UsingBCS=True");
 END {intInsertMDoc_byBCS};

 PUBLIC PROCEDURE InsertMDoc_byBCS();
  VAR
   trgMDocKind: LIKE(MDocKind.MDocKind);
   trgXDocId  : L_XDoc.tXDocId;
   trgXDocType: L_XDoc.tXDocType;
   trgXDocKind: L_XDoc.tXDocKind;
   trgXDoc    : L_XDoc.tXDoc;
 BEGIN
  trgXDocId:=GetRequiredTypeXDocIdByBC("ନ஢  㬥");
  IF ~!trgXDocId THEN
   L_XDoc.DecodeXDocId(trgXDocId, trgXDocType, trgXDocKind, trgXDoc);
   IF    trgXDocType = L_XDoc.xdt_RWayS THEN
    trgMDocKind:=L_MDoc.md_NOV;
   ELSIF trgXDocType = L_XDoc.xdt_RprS THEN
    trgMDocKind:=L_MDoc.md_MSP;
   ELSIF trgXDocType = L_XDoc.xdt_Command THEN
    IF    trgXDoc = L_XDoc.cmd_BuildGasStanTOV THEN
     trgMDocKind:=L_MDoc.md_TOV;
    ELSIF trgXDoc = L_XDoc.cmd_BuildGasStanMSP THEN
     trgMDocKind:=L_MDoc.md_MSP;
    ELSIF trgXDoc = L_XDoc.cmd_BuildGasStanTCh THEN
     trgMDocKind:=L_MDoc.md_TCh;
    ELSE
     L_General.Error(" ࠢ騩  " + trgXDocId);
    END;
   ELSE
    L_General.Error("   ⮬᪮ ନ஢  ");
   END;
   L_XDoc.ref_XDocId:=trgXDocId;
   L_General.Assert(SEARCH(MDocKind, MDocKind, trgMDocKind), " ࠢ筨  ⮢ 㬥⮢     " +
                                                             trgMDocKind + " " + L_MDoc.MDocKindNick(trgMDocKind, 1));
   L_XDoc.PositionInVideoSystem(L_XDoc.pm_StandOnly, L_XDoc.XDocKindId(L_XDoc.xdt_MDoc, trgMDocKind), "MDoc.intInsertMDoc_byBCS()");
  END;
 END {InsertMDoc_byBCS};

 PUBLIC PROCEDURE intEditMDoc_byBCS();
 BEGIN
  LIKEMENU(Edit, "@ UsingBCS=True");
 END {intEditMDoc_byBCS};

 PUBLIC PROCEDURE EditMDoc_byBCS();
  VAR
   refXDocType,
   lnkXDocType : L_XDoc.tXDocType;
   refXDocKind,
   lnkXDocKind : L_XDoc.tXDocKind;
   refXDoc,
   lnkXDoc     : L_XDoc.tXDoc;
   refXDocId,
   lnkXDocId   : L_XDoc.tXDocId;
   LinkedXDC   : L_XDoc.tXDocCollection;
   List        : STRING[];
   XDCItem,
   MDocAmnt    : NUMERIC[0];
 BEGIN
  refXDocId:=GetRequiredTypeXDocIdByBC("஢ 㬥");
  L_XDoc.DecodeXDocId(refXDocId, refXDocType, refXDocKind, refXDoc);
  IF (refXDocType = L_XDoc.xdt_RWayS) | (refXDocType = L_XDoc.xdt_RprS) THEN
   SETZERO(MDocAmnt);
   SETEMPTY(LinkedXDC, List);
   SELECT(XDocRef, rXDocId, , refXDocId);
   WHILE OCCURE(XDocRef) DO
    L_XDoc.DecodeXDocId(XDocRef.bXDocId, lnkXDocType, lnkXDocKind, lnkXDoc);
    IF lnkXDocType = L_XDoc.xdt_MDoc THEN
     LinkedXDC:=LinkedXDC + "|" + XDocRef.bXDocId;
     List     :=List      + "|" + L_MDoc.MDocStr(lnkXDocKind, lnkXDoc);
     INC(MDocAmnt);
    END;
    NEXT(XDocRef);
   END; (*WHILE OCCURE(XDocRef) *)

   IF    MDocAmnt = 0 THEN
    L_General.Error(" " + L_XDoc.XDocStr(refXDocId) + "   ନ஢ ᪫᪨ 㬥⮢");
   ELSIF MDocAmnt = 1 THEN
    XDCItem:=0;
   ELSE
    XDCItem:=L_StdFrm.ShowListAsMenu(List, "ନ஢ 㬥");
   END;
   L_XDoc.PositionInVideoSystem(L_XDoc.pm_StandOnly, L_XDoc.xdc_Item(LinkedXDC, XDCItem), "MDoc.intEditMDoc_byBCS()");
  END; (* IF (refXDocType = L_XDoc.xdt_RWayS) &...*)
 END {EditMDoc_byBCS};

 PRIVATE PROCEDURE ProceedFollowingMDocs(_Done, Stream: SCAL[2]);
 BEGIN
  IF L_MDoc.E_NeedMDocProceedQueueControl(MDoc.Date) THEN
   APP.Get().NewPrompt(L_MDoc.GetMDocStrNbr());
   L_MDoc.fmdc_ProceedMDoc(_Done, Stream);
  ELSIF Stream THEN
   IF _Done THEN
    InternalStreamMakeDone();
   ELSE
    InternalStreamMakeUnDone();
   END;
  ELSE
   IF _Done THEN
    InternalSingleMakeDone();
   ELSE
    InternalSingleMakeUnDone();
   END;
  END; (* L_MDoc.E_NeedMDocProceedQueueControl(MDoc.Date) ... *)
 END {ProceedFollowingMDocs};

 PRIVATE PROCEDURE Alower_OnInitializeWindow();
 BEGIN
  L_WDO.iEvents      (1, "");
  L_WDO.iMayBeEmpty  (1, "Alower.Till");
  L_WDO.iProgs       (1, "MDoc");
 END {Alower_OnInitializeWindow};

 PRIVATE PROCEDURE SetECMDocKind(): L_XDoc.tXDocKindId;
  CONST
   xdknLength = 32;
  VAR
   Ids        : L_XDoc.tXDocKindId[64];
   i          : NUMERIC[0];
   List       : STRING[];
   _Dir       : LIKE(MDocKind.Dir);
 BEGIN
  CONFORM(MDoc, MDocKind);
  _Dir:=MDocKind.Dir;
  SETEMPTY(Ids);
  List:="";
  i:=0;
  SELECT(MDocKind, MDocKind);
  WHILE OCCURE(MDocKind) DO
   IF ((MDocKind.Dir = L_MDoc.mdd_Ingoing) &
       (L_Pmnt.IsAcptMDocKind(MDocKind.MDocKind) | L_Pmnt.IsMayBePaidMDocKind(MDocKind.MDocKind))) |
       L_MDoc.KeyAssetsMDoc(MDocKind.MDocKind) THEN
    Ids[i]:=L_XDoc.XDocKindId(L_XDoc.xdt_MDoc, MDocKind.MDocKind);
    List:=List + MDocKind.MDocKind + " "
               + Str.Align(MDocKind.SName, xdknLength, LEFT) + " "
               + MDocKind.Sign + "|";
    INC(i);
   END;
   NEXT(MDocKind);
  END; (* WHILE OCCURE(MDocKind) ... *)

  L_General.Assert(i > 0,
                   " ।ᬮ७ 稥 㬥 ࠧ");
  i:=L_StdFrm.ShowListAsMenu(List, "㬥  ᯨ᪮ ꥪ⮢  ஢");
  RETURN Ids[i];
 END {SetECMDocKind};

 PRIVATE PROCEDURE intCopyMDocList(SampleMDocId, DstMDocId: L_XDoc.tXDocId);
  VAR
   Has,
   WithSum   : SCAL[2];
   curSum    : LIKE(MDocList.Sum);
   curQnt    : LIKE(MDocList.Qnt);
   curVAT    : LIKE(MDocList.VAT);
   curVATMode: LIKE(MDocList.VATMode);
 BEGIN
  WithSum:=IsMDocListWithSum();
  L_XDoc.PositionOnXDoc(SampleMDocId);
  CONFORM(MDoc, MDocList);
  L_General.Assert(OCCURE(MDocList), "   ப 㬥");
  Has:=0;
  L_XDoc.PositionOnXDoc(DstMDocId);
  WHILE OCCURE(MDocList) DO
   CONFORM(MDocList, Math);
   IF ~L_MDoc.KeyAssetsMDoc(MDoc.MDocKind) | (Math.MathKind = L_MathR.mathk_KeyAs) THEN
    SAVE(MDocList);
    SETZERO(curSum, curQnt, curVAT);
    SETEMPTY(curVATMode);
    IF WithSum THEN
     curSum:=MDocList.Sum;
    END;
    IF ~L_MDoc.KeyAssetsMDoc(MDoc.MDocKind) THEN
     curQnt:=MDocList.Qnt;
    END;
    IF L_MDoc.CalculateVAT() # L_MDoc.cvat_Impossible THEN
     curVAT:=MDocList.VAT;
     IF L_MDoc.IsAvailableVATMode() THEN
      curVATMode:=MDocList.VATMode;
     END;
    END;
    L_MDoc.InsMDocList(MDocList.Math, MDocList.MMode, curVATMode, curQnt, curSum, curVAT); (* DstMDoc*)
    Has:=1;
    RESTORE(MDocList);
   END;
   NEXT(MDocList);
  END; (* WHILE OCCURE(MDocList) ... *)
  L_General.Assert(Has, " ꥪ⮢   ࠭ ");
 END {intCopyMDocList};

 PUBLIC PROCEDURE CopyMDocListFromOtherMDoc();
 BEGIN
  L_XDoc.PositionInVideoSystem(L_XDoc.pm_WaitUserChoice, SetECMDocKind(), "MDoc 191");
 END {CopyMDocListFromOtherMDoc};

 PUBLIC PROCEDURE intFillByCompositionSet();
  VAR
   trgXDocType: L_XDoc.tXDocType;
   dmyXDocKind: L_XDoc.tXDocKind;
   trgMath    : LIKE(Math.Math);
   Idx        : NUMERIC[0];
   arrMath    : LIKE(Math.Math)           [P_Math.cs_Amount];
   arrAmount  : NUMERIC[0]                [P_Math.cs_Amount];
   arrType    : P_Math.tCompositionSetType[P_Math.cs_Amount];
 BEGIN
  IF ~!L_XDoc.ref_XDocId THEN
   L_XDoc.DecodeXDocId(L_XDoc.ref_XDocId, trgXDocType, dmyXDocKind, trgMath);
   L_General.CallUs((trgXDocType = L_XDoc.xdt_Math));
   IF P_Math.HasActualMathPro(trgMath, MDoc.Date, P_Math.P_CompositionSet) THEN
    P_Math.Decode_CompositionSet(MathPro.Value, arrMath, arrAmount, arrType);
   ELSE
    L_General.Error("  " + trgMath + "  㪠 ⠢ ");
   END;
   Idx:=0;
   WHILE (Idx < P_Math.cs_Amount) & ~!arrMath[Idx] DO
    L_General.Assert(SEARCH(Math, Math, arrMath[Idx]),
                     "訡  ᠭ : ୮ 祭 " + arrMath[Idx]);
    L_MDoc.InsMDocList(Math.Math, L_MathR.mm_New, EMPTYOF(MDocList.VATMode), arrAmount[Idx], 0, 0);
    INC(Idx);
   END; (* FOR_EACH ...*)
  END;
 END {intFillByCompositionSet};

 PUBLIC PROCEDURE FillByCompositionSet();
 BEGIN
  L_XDoc.PositionInVideoSystem(L_XDoc.pm_WaitUserChoice,
                               L_XDoc.XDocKindId(L_XDoc.xdt_Math, L_XDoc.EmptyXDocKind),
                               "MDoc.intFillByCompositionSet()");
 END {FillByCompositionSet};

 PRIVATE PROCEDURE SetECXDocKind(): L_XDoc.tXDocKindId;
  CONST
   xdknLength = 32;
  VAR
   Ids : L_XDoc.tXDocKindId[64];
   i   : NUMERIC[0];
   List: STRING[];
   _Dir: LIKE(MDocKind.Dir);
 BEGIN
  CONFORM(MDoc, MDocKind);
  _Dir:=MDocKind.Dir;
  SETEMPTY(Ids);
  List:="";
  i:=0;
  SELECT(MDocKind, MDocKind);
  WHILE OCCURE(MDocKind) DO
   IF (MDocKind.Dir = _Dir) &
      (L_Pmnt.IsAcptMDocKind(MDocKind.MDocKind) | L_Pmnt.IsMayBePaidMDocKind(MDocKind.MDocKind)) THEN
    Ids[i]:=L_XDoc.XDocKindId(L_XDoc.xdt_MDoc, MDocKind.MDocKind);
    List:=List + MDocKind.MDocKind + " "
               + Str.Align(MDocKind.SName, xdknLength, LEFT) + " "
               + MDocKind.Sign + "|";
    INC(i);
   END;
   NEXT(MDocKind);
  END; (* WHILE OCCURE(MDocKind) ... *)

  L_General.Assert(i > 0,
                   " ।ᬮ७ 稥 㬥 ࠧ");
  i:=L_StdFrm.ShowListAsMenu(List, "㬥  ᯨ᪮ ꥪ⮢  ।");
  RETURN Ids[i];
 END {SetECXDocKind};

 PRIVATE PROCEDURE intShareExtraCharge(Title: STRING[]; SampleMDocId, DstMDocId: L_XDoc.tXDocId);
  VAR
   sSum,
   sVAT,
   rstSum,
   rstVAT,
   curSum,
   curVAT,
   maxSum,
   maxVAT,
   totVAT,
   totForSum,
   totForVAT      : L_XObj.tSum;
   Count          : NUMERIC[0];
   dstVATMode     : LIKE(MDocList.VATMode);
   dstMDocDate    : DATE;
   dstVATPossible : SCAL[2];
   maxMDLNbrForSum,
   maxMDLNbrForVAT: LIKE(MDocList.MDLNbr);
 BEGIN
  L_XDoc.PositionOnXDoc(DstMDocId);
  dstVATPossible:=(L_MDoc.CalculateVAT() # L_MDoc.cvat_Impossible);
  dstMDocDate   :=MDoc.Date;

  L_XDoc.PositionOnXDoc(SampleMDocId);
  SETZERO(totForSum, totForVAT, totVAT);
  CONFORM(MDoc, MDocList);
  L_General.Assert(OCCURE(MDocList), "   ப 㬥");
  Count:=0;
  WHILE OCCURE(MDocList) DO
   INC(totForSum, MDocList.Sum+MDocList.VAT);
   IF P_Math.GetSpecialAttitudeToVAT(MDocList.Math, dstMDocDate) # P_Math.satVAT_TaxFree THEN
    INC(totForVAT, MDocList.Sum+MDocList.VAT);
    INC(totVAT, MDocList.VAT);
   END;
   INC(Count);
   NEXT(MDocList);
  END; (* WHILE OCCURE(MDocList) ... *)

  L_General.Assert(totForSum # 0, " 㫥 㬬  室 㬥 । ");

  sSum:=0;
  sVAT:=0;
  LOOP
   STDFORM(L_StdFrm.PartForm("%NI%NI%RNI"+
                             "%RI" +
                             L_Str.PoolItem("%RNI|%RI", dstVATPossible) +
                             "%< ⬥     >X"  +
                             "%< । >DB" +
                             "@" +
                             "| 室                    㬬"+
                             "|%###########% %##########% %##############%"+
                             "|"+
                             "|।"+
                             "|  㬬                          " +
                             "|%##############%           %##############%" +
                             "|" +
                             "|   %##############%     %##############%"),
                             " "+Title+" ",
                             ,
                             -1,
                             L_MDoc.MDocStr(MDoc.MDocKind, MDoc.MDoc),
                             MDoc.Date,
                             MDoc.Total,
                             sSum,
                             sVAT);
   IF (sSum = 0) & (sVAT = 0) THEN
    RETURN;
   ELSE
    IF    (totVAT = 0) & (sVAT # 0) THEN
     L_StdFrm.RedInform("  㫥 㬬 , ।  ");
    ELSIF sSum < sVAT THEN
     IF L_StdFrm.RedAlternative("  㬬?") THEN
      EXIT;
     END;
    ELSE
     EXIT;
    END;
   END;
  END; (* LOOP *)

  L_XDoc.PositionOnXDoc(DstMDocId);
  rstSum:=sSum;
  rstVAT:=sVAT;
  maxSum:=0; maxMDLNbrForSum:=0;
  maxVAT:=0; maxMDLNbrForVAT:=0;

  FIRST(MDocList); (*MDocList -  SampleMDoc*)
  WHILE OCCURE(MDocList) & (Count>0) DO
   SAVE(MDocList);
   curSum:=sSum*(MDocList.Sum+MDocList.VAT)/totForSum;
   DEC(rstSum, curSum);
   dstVATMode:=EMPTYOF(MDocList.VATMode);
   curVAT:=0;
   IF L_MDoc.MDocListVATPossible() THEN
    curVAT:=sVAT*(MDocList.Sum+MDocList.VAT)/totForVAT;
    DEC(rstVAT, curVAT);
    IF L_MDoc.IsAvailableVATModeMDocKind(MDoc.MDocKind) THEN
     IF ~!MDocList.VATMode THEN
      dstVATMode:=MDocList.VATMode;
     ELSE
      dstVATMode:=L_MDoc.E_DefaultVATMode(MDoc.Date, MDocList.Math);
     END;
    END;
   END;
   L_MDoc.InsMDocList(MDocList.Math, MDocList.MMode, dstVATMode, 0, curSum, curVAT); (* DstMDoc*)

   IF Math.Abs(maxSum) < Math.Abs(MDocList.Sum) THEN
    maxSum:=MDocList.Sum;
    maxMDLNbrForSum:=MDocList.MDLNbr;
   END;
   IF Math.Abs(maxVAT) < Math.Abs(MDocList.VAT) THEN
    maxVAT:=MDocList.VAT;
    maxMDLNbrForVAT:=MDocList.MDLNbr;
   END;
   RESTORE(MDocList);
   NEXT(MDocList);
   DEC(Count);
  END; (* WHILE OCCURE(MDocList) ... *)

  SETSEL(MDocList, MDoc, MDoc.MDocKind, MDoc.MDoc);
  IF rstSum # 0 THEN
   SRCINSEL(MDocList, EQ, , maxMDLNbrForSum);
   INC(MDocList.Sum, rstSum);
   REPLACE(MDocList);
   INC(MDoc.Total, rstSum);
   REPLACE(MDoc);
  END;
  IF rstVAT # 0 THEN
   SRCINSEL(MDocList, EQ, , maxMDLNbrForVAT);
   INC(MDocList.VAT, rstVAT);
   REPLACE(MDocList);
   INC(MDoc.Total, rstVAT);
   REPLACE(MDoc);
  END;
  CALL(MDocList.RenumerateMDocList());
  L_MDoc.SetMDocTotals(RTI.Get().CurWindow.Name);
 END {intShareExtraCharge};

 PUBLIC PROCEDURE ShareExtraCharge_byCurrentMDoc();
 BEGIN
  intShareExtraCharge("業", L_XDoc.curXDocId(L_XDoc.xdt_MDoc), L_XDoc.curXDocId(L_XDoc.xdt_MDoc));
 END {ShareExtraCharge_byCurrentMDoc};

 PUBLIC PROCEDURE ShareExtraCharge_byOtherMDoc();
 BEGIN
  L_XDoc.PositionInVideoSystem(L_XDoc.pm_WaitUserChoice, SetECXDocKind(), "MDoc 193");
 END {ShareExtraCharge_byOtherMDoc};

 PRIVATE PROCEDURE MDoc_CUCopy_OnSuccessfulChange();
 BEGIN
  SetCUCopyVars();
 END {MDoc_CUCopy_OnSuccessfulChange};

 PRIVATE PROCEDURE OnConformToWindowForGasStan(_MDocKind: LIKE(MDocKind.MDocKind));
  VAR
   WinName: STRING[];
 BEGIN
  RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
  WinName:=GetSubwindowName(_MDocKind);

  SELECT(MDoc, MDoc, , _MDocKind);
  SE_WWD_CURSOR(WinName, MDoc);
  SE_WZD_CURSOR(WinName, 0, MDoc);
 END {OnConformToWindowForGasStan};

 PRIVATE PROCEDURE MD02E_OnConformToWindow();
 BEGIN
  OnConformToWindowForGasStan(L_MDoc.md_TOV);
 END {MD02E_OnConformToWindow};

 PRIVATE PROCEDURE MD03EM_OnConformToWindow();
 BEGIN
  OnConformToWindowForGasStan(L_MDoc.md_NOV);
 END {MD03EM_OnConformToWindow};

 PRIVATE PROCEDURE MD60E_OnConformToWindow();
 BEGIN
  OnConformToWindowForGasStan(L_MDoc.md_MSP);
 END {MD60E_OnConformToWindow};

 PRIVATE PROCEDURE MD62E_OnConformToWindow();
 BEGIN
  OnConformToWindowForGasStan(L_MDoc.md_VPC);
 END {MD62E_OnConformToWindow};

 PRIVATE PROCEDURE MD70E_OnConformToWindow();
 BEGIN
  OnConformToWindowForGasStan(L_MDoc.md_TCh);
 END {MD70E_OnConformToWindow};

 PUBLIC PROCEDURE StreamMakeDone();
 BEGIN
  CheckMCurPer(1);
  ProceedFollowingMDocs(1, 1);
 END {StreamMakeDone};

 PUBLIC PROCEDURE StreamMakeUnDone();
 BEGIN
  CheckMCurPer(1);
  ProceedFollowingMDocs(0, 1);
 END {StreamMakeUnDone};

 PUBLIC PROCEDURE SingleMakeDone();
 BEGIN
  L_MDoc.AccessMDoc();
  CheckMCurPer(0);
  ProceedFollowingMDocs(1, 0);
 END {SingleMakeDone};

 PUBLIC PROCEDURE SingleMakeUnDone();
 BEGIN
  L_MDoc.AccessMDoc();
  CheckMCurPer(0);
  ProceedFollowingMDocs(0, 0);
 END {SingleMakeUnDone};

 PUBLIC PROCEDURE InternalStreamMakeDone();
 BEGIN
  _s:=+1; Proceed(1, 1, 0, 1);
 END {InternalStreamMakeDone};

 PUBLIC PROCEDURE InternalStreamMakeUnDone();
 BEGIN
  _s:=-1; Proceed(0, 1, 0, 0);
 END {InternalStreamMakeUnDone};

 PUBLIC PROCEDURE InternalSingleMakeDone();
 BEGIN
  _s:=+1; Proceed(1, 0, 1, 1);
 END {InternalSingleMakeDone};

 PUBLIC PROCEDURE InternalSingleMakeUnDone();
 BEGIN
  _s:=-1; Proceed(0, 0, 0, 1);
 END {InternalSingleMakeUnDone};

 PUBLIC PROCEDURE InternalMakeProtocol();
 BEGIN
  _s:=0; Proceed(1, 0, 0, 0);
 END {InternalMakeProtocol};

 PUBLIC PROCEDURE MakeCopy();
  VAR
   trgMDocKind: LIKE(MDocKind.MDocKind);
 BEGIN
  L_MDoc.AccessMDoc();
  trgMDocKind:=MDoc.MDocKind;
  IF  P_Firm.E_wMultipleMyFirm(SYSDATE()) & P_Firm.IsOwnFirm(MDoc.Firm) THEN
   IF    MDoc.MDocKind = L_MDoc.md_IsS THEN trgMDocKind:=L_MDoc.md_VhS;
   ELSIF MDoc.MDocKind = L_MDoc.md_ISA THEN trgMDocKind:=L_MDoc.md_VhA;
   END;
  END;
  IF trgMDocKind # MDoc.MDocKind THEN
   IF L_StdFrm.ShowListAsMenu("⮢  㬥|⮢  㬥 ' ࣠樨'",
      " ⮢  㬥 ") = 0 THEN
    trgMDocKind:=MDoc.MDocKind;
   END;
  ELSE
   IF MDoc.MDocKind = L_MDoc.md_VhA THEN
    IF P_Cntr.GetBalanceType(MDoc.Contract, MDoc.Date) = P_Cntr.ctbt_ByDeal THEN
     L_StdFrm.Choice("         ᤥ.||, ᫥ ନ ");
    END;
   ELSIF L_Pmnt.IsVATMDocKind(MDoc.MDocKind) THEN
    L_General.Error("⮢  " + L_MDoc.MDocKindNick(MDoc.MDocKind, 1) + " 饭");
   END;
  END;
  IF trgMDocKind = MDoc.MDocKind THEN
   L_WDO.LaunchInsertBySource(MDoc.MDocKind + "|" + MDoc.MDoc, " trgPrc=Copy");
  ELSE
   SEARCH(MDocKind, MDocKind, , trgMDocKind);
   SE_WZD_CURSOR(RTI.Get().CurWindow.Name, 2, MDocKind);
   L_WDO.LaunchInsertBySource(MDoc.MDocKind + "|" + MDoc.MDoc, " trgPrc=Counter");
  END;
 END {MakeCopy};

 PRIVATE CONST
  fltN_MDocStorage = " 㬥     ⥪饬 ";
  fltN_DfltStorage = " 㬥    㬮砭";
  fltV_DlftStorage = "(MDoc.Storage=L_Stock.defaultStorage)";

 PRIVATE PROCEDURE MDoc_RenovateFilters();
 BEGIN
  IF L_Stock.dsAssigned THEN
   L_WDO.AddFilter(RTI.Get().CurZone.Filters, fltN_DfltStorage, fltV_DlftStorage, 1);
   L_WDO.SoftRemoveFilter(RTI.Get().CurZone.Filters, fltN_MDocStorage);
  ELSE
   L_WDO.SoftRemoveFilter(RTI.Get().CurZone.Filters, fltN_DfltStorage);
   TRY
    TABLE.Get("MDoc").AccessDataMode:=adm_SOFT;
    IF ACCESS(MDoc) THEN
     L_WDO.AddFilter(RTI.Get().CurZone.Filters, fltN_MDocStorage, "(MDoc.Storage=" + L_Str.IntStr(MDoc.Storage) + ")", 0);
    ELSE
     L_WDO.SoftRemoveFilter(RTI.Get().CurZone.Filters, fltN_MDocStorage);
    END;
   EXCEPT
   END;
  END;
 END {MDoc_RenovateFilters};

 PUBLIC PROCEDURE scs_RenovateFilters_MDocEI_1();
 BEGIN
  MDoc_RenovateFilters();
 END {scs_RenovateFilters_MDocEI_1};

 PUBLIC PROCEDURE scs_RenovateFilters_MDoc_DO_1();
 BEGIN
  MDoc_RenovateFilters();
 END {scs_RenovateFilters_MDoc_DO_1};

 PUBLIC PROCEDURE scs_RenovateFilters_MDoc_OC_1();
 BEGIN
  MDoc_RenovateFilters();
 END {scs_RenovateFilters_MDoc_OC_1};

 PRIVATE PROCEDURE MDoc_PutFilters(VAR Filters: STRING[]);
 BEGIN
  IF L_Stock.dsAssigned THEN
   L_WDO.PutNewFilter(Filters, fltN_DfltStorage, fltV_DlftStorage, 1);
  END;
 END {MDoc_PutFilters};

 PUBLIC PROCEDURE scs_GetFilters_MDocEI_1(VAR Filters: STRING[]);
 BEGIN
  MDoc_PutFilters(Filters);
 END {scs_GetFilters_MDocEI_1};

 PUBLIC PROCEDURE scs_GetFilters_MDoc_DO_1(VAR Filters: STRING[]);
 BEGIN
  MDoc_PutFilters(Filters);
 END {scs_GetFilters_MDoc_DO_1};

 PUBLIC PROCEDURE scs_GetFilters_MDoc_OC_1(VAR Filters: STRING[]);
 BEGIN
  MDoc_PutFilters(Filters);
 END {scs_GetFilters_MDoc_OC_1};

 PRIVATE PROCEDURE MDoc_GetNarrowing(VAR NarrowingDescriptions: STRING[]);
 BEGIN
  NarrowingDescriptions:=" 㬥  ﭨ '⮢'" +
                         "|஢,   ࠡ⠭ ⮢ 㬥";
 END {MDoc_GetNarrowing};

 PRIVATE PROCEDURE MDoc_SetNarrowing(SelectChoice: NUMERIC[0]);
 BEGIN
  ACCESS(MDocKind);
  IF SelectChoice = 1 THEN
   SELECT(MDoc, MDKStat, , MDocKind.MDocKind, L_MDoc.st_Prepared);
  ELSIF SelectChoice = 2 THEN
   SELECT(MDoc, MDKStat, , MDocKind.MDocKind, L_MDoc.st_Passed, 0);
  END;
 END {MDoc_SetNarrowing};

 PUBLIC PROCEDURE scs_GetNarrowing_MDocEI_1(VAR NarrowingDescriptions: STRING[]);
 BEGIN
  MDoc_GetNarrowing(NarrowingDescriptions);
 END {scs_GetNarrowing_MDocEI_1};

 PUBLIC PROCEDURE scs_GetNarrowing_MDoc_DO_1(VAR NarrowingDescriptions: STRING[]);
 BEGIN
  MDoc_GetNarrowing(NarrowingDescriptions);
 END {scs_GetNarrowing_MDoc_DO_1};

 PUBLIC PROCEDURE scs_GetNarrowing_MDoc_OC_1(VAR NarrowingDescriptions: STRING[]);
 BEGIN
  MDoc_GetNarrowing(NarrowingDescriptions);
 END {scs_GetNarrowing_MDoc_OC_1};

 PUBLIC PROCEDURE scs_SetNarrowing_MDocEI_1(SelectChoice: NUMERIC[0]);
 BEGIN
  MDoc_SetNarrowing(SelectChoice);
 END {scs_SetNarrowing_MDocEI_1};

 PUBLIC PROCEDURE scs_SetNarrowing_MDoc_DO_1(SelectChoice: NUMERIC[0]);
 BEGIN
  MDoc_SetNarrowing(SelectChoice);
 END {scs_SetNarrowing_MDoc_DO_1};

 PUBLIC PROCEDURE scs_SetNarrowing_MDoc_OC_1(SelectChoice: NUMERIC[0]);
 BEGIN
  MDoc_SetNarrowing(SelectChoice);
 END {scs_SetNarrowing_MDoc_OC_1};

 PRIVATE PROCEDURE AnyMDoc_SetFlagFirst(FlagFirst: SCAL[2]);
 BEGIN
  IF    ~!L_WDO.iField(0, "MDoc.Contract") THEN L_WDO.iField(0, ["MDoc.Contract"]).First:=FlagFirst;
  ELSIF ~!L_WDO.iField(0, "MDoc.BoxNbr")   THEN L_WDO.iField(0, ["MDoc.BoxNbr"]  ).First:=FlagFirst;
  ELSIF ~!L_WDO.iField(0, "MDoc.Dest")     THEN L_WDO.iField(0, ["MDoc.Dest"]    ).First:=FlagFirst;
  END;
 END {AnyMDoc_SetFlagFirst};

 PRIVATE PROCEDURE intAnyMDoc_OnInitializeWindow(wSubWindow: SCAL[2]; ItsKeyAssMDoc: SCAL[2]);
 BEGIN
  L_WDO.iEvents      (0, [L_WDO.e_OnAnyModification, L_WDO.e_OnReposition]);
  IF ~!L_WDO.iField(0, "MDoc_SingleRefDoc") THEN
   L_WDO.iField       (0, "MDoc_SingleRefDocT").Format:=L_XDoc.ref_ShortNames;
   L_WDO.iField       (0, "MDoc_SingleRefDoc").OnBeforeAsk:=1;
   L_WDO.iField       (0, "MDoc_SingleRefDoc").AskMode:=1;
   L_WDO.iScsChange   (0, ["MDoc_SingleRefDoc"]);
   L_WDO.iUnmodifiable(0, ["SRF_Title", "MDoc_SingleRefDocK", "MDoc_SingleRefDocT", "MDoc_SingleRefDocC"]);
   L_WDO.iField       (0, "SRF_Title").Value:="᭮";
  END;
  IF ~!L_WDO.iField(0, "MDoc.Total") THEN
   L_WDO.iField(0, "MDoc.Total").Modifiable:=0;
  END;

  AnyMDoc_SetFlagFirst(1);

  L_WDO.iField       (0, "MDoc.Status").Format:=L_MDoc.st_Pool;

  IF ~!L_WDO.iField(0, "MDoc.BoxNbr") THEN
   L_WDO.iScsChange   (0, ["MDoc.BoxNbr"]);
  END;

  IF ~!L_WDO.iField(0, "MDoc.Storage") THEN
   L_WDO.iScsChange   (0, ["MDoc.Storage"]);
   IF ~!L_WDO.iField(0, "Storage.Type") THEN
    L_WDO.iField(0, "Storage.Type").Format:=L_Stock.st_Pool_SH;
   END;
   IF ~!L_WDO.iField(0, "MDoc.Storage2") THEN
    L_WDO.iField       (0, "MDoc.Storage2").AskMode:=FORM_FIELD.AskMode_Manual;
    L_WDO.iField       (0, "MDoc.Storage2").OwnerWindowOriginalName:="Storage";
    L_WDO.iField       (0, "MDoc.Storage2").OwnerZoneNumber:=1;
    IF ~!L_WDO.iField(0, "Storage2.Type") THEN
     L_WDO.iField(0, "Storage2.Type").Format:=L_Stock.st_Pool_SH;
    END;
    L_WDO.iScsChange   (0, ["MDoc.Storage2"]);
    L_WDO.iMayBeEmpty  (0, ["MDoc.Storage2"]);
    IF ItsKeyAssMDoc THEN
     L_WDO.iMayBeEmpty  (0, ["MDoc.Storage"]);
    END;
   ELSE
    L_WDO.iMayBeEmpty  (0, ["MDoc.Storage"]);
   END;
  END;

  L_WDO.iScsChange   (0, ["MDoc.TSN", "MDoc.Status", "MDoc.Date"]);
  IF ~!L_WDO.iField(0, "MDoc.Dest")     THEN
   L_WDO.iScsChange   (0, ["MDoc.Dest"]);
  END;

  IF ~!L_WDO.iField(0, "MDoc.Alower") THEN
   L_WDO.iScsChange   (0, ["MDoc.Alower"]);
  END;

  L_WDO.iUnmodifiable(0, ["MDoc.SrcNbr", "MDoc.CopyCnt", "MDoc.MDoc", "MDoc.MDocKind"]);
  IF ~!L_WDO.iField(0, "MDoc.CostItem") THEN
   L_WDO.iMayBeEmpty(0, ["MDoc.CostItem"]);
  END;
  IF ~!L_WDO.iField(0, "MDoc_Note") THEN
   L_WDO.iScsChange   (0, ["MDoc_Note"]);
   L_WDO.iMayBeEmpty  (0, ["MDoc_Note"]);
  END;
  IF ~!L_WDO.iField(0, "MDoc_ServiceNote") THEN
   L_WDO.iUnmodifiable(0, ["MDoc_ServiceNote"]);
  END;

  IF ~!L_WDO.iField(0, "MDoc_Through") THEN
   L_WDO.iScsChange   (0, ["MDoc_Through"]);
   L_WDO.iMayBeEmpty  (0, ["MDoc_Through"]);
  END;

  IF    ~!L_WDO.iField(0, "MDoc.Contract") THEN
   L_WDO.iScsChange   (0, ["MDoc.Contract"]);
   L_WDO.iUnmodifiable(0, ["MDoc.Firm"]);
  ELSIF ~!L_WDO.iField(0, "MDoc.Firm") THEN
   L_WDO.iScsChange   (0, ["MDoc.Firm"]);
  END;

  IF ~!L_WDO.iField(0, "MDocListSum_1_Title") THEN
   L_WDO.iUnmodifiable(0, ["MDocListSum_1_Title"]);
   intSetMDocListSumExpression(1);
  END;

  IF wSubWindow THEN
   L_WDO.iEvents      (1, [L_WDO.e_OnAnyModification, L_WDO.e_OnAfterDelete, L_WDO.e_OnSetSubwindow]);
  ELSE
   L_WDO.iEvents      (1, [L_WDO.e_OnAnyModification, L_WDO.e_OnAfterDelete]);
  END;
  IF ItsKeyAssMDoc THEN
   L_WDO.iField       (1, "MDocList.Math").OwnerWindowOriginalName:="Math01";
  ELSE
   L_WDO.iField       (1, "MDocList.Math").OwnerWindowOriginalName:="Math";
  END;
  L_WDO.iField       (1, "MDocList.Math").OwnerZoneNumber:=1;
  L_WDO.iField       (1, "MDocList.Math").First:=1;
  IF ~!L_WDO.iField(1, "MDocList.Qnt") THEN
   L_WDO.iField       (1, "MDocList.Qnt").Last:=1;
  END;
  L_WDO.iScsChange   (1, ["MDocList.Math"]);
  IF ~!L_WDO.iField(1, "MDocList.MMode") THEN
   L_WDO.iScsChange   (1, ["MDocList.MMode"]);
  END;
  IF ItsKeyAssMDoc THEN
   L_General.CallUs(L_WDO.iZone(2).MasterTable.Name = "MDocPro");
   L_WDO.iEvents      (2, [L_WDO.e_OnSetSubwindow]);
   L_WDO.iProgs       (2, "ObjPro");
  END;
 END {intAnyMDoc_OnInitializeWindow};

 PRIVATE PROCEDURE AnyMDoc_OnInitializeWindow(wSubWindow: SCAL[2]);
 BEGIN
  intAnyMDoc_OnInitializeWindow(wSubWindow, 0);
 END {AnyMDoc_OnInitializeWindow};

 PRIVATE PROCEDURE KeyAssMDoc_OnInitializeWindow();
 BEGIN
  intAnyMDoc_OnInitializeWindow(0, 1);
 END {KeyAssMDoc_OnInitializeWindow};

 PRIVATE PROCEDURE MDocKAE_OnInitializeWindow();
 BEGIN
  KeyAssMDoc_OnInitializeWindow();
  L_WDO.iWindow().OnOpenWindow:=1;
 END {MDocKAE_OnInitializeWindow};

 PRIVATE PROCEDURE MDocEIE_OnOpenWindow();
 BEGIN
  L_General.Assert(ACCESS(MDocKind), " ⠭  ");
  L_WDO.iWindow().Title:=MDocKind.SName;
 END {MDocEIE_OnOpenWindow};

 PRIVATE PROCEDURE MDocKAE_OnOpenWindow();
  VAR
   DestVisible,
   FirmVisible,
   Storage2Visible: SCAL[2];
 BEGIN
  L_General.Assert(ACCESS(MDocKind), " ⠭  ");
  L_WDO.iWindow().Title:=MDocKind.SName;

  DestVisible:=(MDocKind.MDocKind # L_MDoc.md_ASO);
  L_WDO.iField(0, "v_Dest_Title").Visible:=DestVisible;
  L_WDO.iField(0, "MDoc.Dest").Visible:=DestVisible;
  L_WDO.iField(0, "Dest.Name").Visible:=DestVisible;

  FirmVisible:=(MDocKind.MDocKind = L_MDoc.md_ADo) | (MDocKind.MDocKind = L_MDoc.md_AVb);
  L_WDO.iField(0, "v_Firm_Title").Visible:=FirmVisible;
  L_WDO.iField(0, "MDoc.Firm").Visible:=FirmVisible;
  L_WDO.iField(0, "Firm.Name").Visible:=FirmVisible;

  Storage2Visible:=(MDocKind.MDocKind = L_MDoc.md_ASO) | (MDocKind.MDocKind = L_MDoc.md_APP);
  L_WDO.iField(0, "v_Storage2_Title").Visible:=Storage2Visible;
  L_WDO.iField(0, "MDoc.Storage2").Visible:=Storage2Visible;
  L_WDO.iField(0, "Storage2.Type").Visible:=Storage2Visible;
  L_WDO.iField(0, "Storage2.Name").Visible:=Storage2Visible;

  IF (RTI.Get().CurProcess.Kind = FORM_PROCESS.Kind_Edit) | (RTI.Get().CurProcess.Kind = FORM_PROCESS.Kind_Insert) THEN
   IF (MDocKind.MDocKind = L_MDoc.md_ASO) | (MDocKind.MDocKind = L_MDoc.md_APP) THEN
    RTI.Get().CurProcess.ReplaceContexts("Transfer_AllKA");
   ELSE
    RTI.Get().CurProcess.ReplaceContexts("EdInsKeyAssMDoc");
   END;
  END;
 END {MDocKAE_OnOpenWindow};

 PRIVATE PROCEDURE MDocEI_OnInitializeWindow();
 BEGIN
  L_WDO.iEvents      (1, [L_WDO.e_OnSetSubwindow]);
  L_WDO.iZone        (1).Narrowing:="MDoc.MDocKind=MDocKind.MDocKind";
  L_WDO.iField       (1, "MDoc.MDoc").ReverseSorting:=1;
  L_WDO.iZone        (2).ViewOnly:=1;
  L_WDO.iZone        (2).PermanentFilter:="MDocKind.imTD#0";
 END {MDocEI_OnInitializeWindow};

 PRIVATE PROCEDURE MDoc_DO_OnInitializeWindow();
 BEGIN
  L_WDO.iWindow().MNUFileName:="MDoc";
  L_WDO.iEvents      (1, [L_WDO.e_OnSetSubwindow]);
  L_WDO.iZone        (1).Narrowing:="MDoc.MDocKind=MDocKind.MDocKind";
  L_WDO.iField       (1, "MDoc.MDoc").ReverseSorting:=1;
  L_WDO.iZone        (2).ViewOnly:=1;
  L_WDO.iZone        (2).PermanentFilter:="MDocKind.imDO#0";
 END {MDoc_DO_OnInitializeWindow};

 PRIVATE PROCEDURE MDoc_OC_OnInitializeWindow();
 BEGIN
  L_WDO.iWindow().MNUFileName:="MDoc";
  L_WDO.iEvents      (1, [L_WDO.e_OnSetSubwindow]);
  L_WDO.iZone        (1).Narrowing:="MDoc.MDocKind=MDocKind.MDocKind";
  L_WDO.iField       (1, "MDoc.MDoc").ReverseSorting:=1;
  L_WDO.iZone        (2).ViewOnly:=1;
  L_WDO.iZone        (2).PermanentFilter:="MDocKind.imOC#0";
 END {MDoc_OC_OnInitializeWindow};

 PRIVATE PROCEDURE MDocEIE_OnInitializeWindow();
 BEGIN
  AnyMDoc_OnInitializeWindow(1);
  L_WDO.iWindow().MNUFileName:="MDOCEI";
  L_WDO.iWindow().OnOpenWindow:=1;
  L_WDO.iUnmodifiable(0, ["v_MDocTotalNetto", "v_MDocTotalVAT", "v_MDocTotal"]);
 END {MDocEIE_OnInitializeWindow};

 PRIVATE PROCEDURE MD22E_OnInitializeWindow();
 BEGIN
  KeyAssMDoc_OnInitializeWindow();
 END {MD22E_OnInitializeWindow};

 PRIVATE PROCEDURE MD02E_OnInitializeWindow();
 BEGIN
  AnyMDoc_OnInitializeWindow(1);
 END {MD02E_OnInitializeWindow};

 PRIVATE PROCEDURE MD03EM_OnInitializeWindow();
 BEGIN
  AnyMDoc_OnInitializeWindow(0);
 END {MD03EM_OnInitializeWindow};

 PRIVATE PROCEDURE MD011E_OnInitializeWindow();
 BEGIN
  AnyMDoc_OnInitializeWindow(1);
 END {MD011E_OnInitializeWindow};

 PRIVATE PROCEDURE MD16E_OnInitializeWindow();
 BEGIN
  AnyMDoc_OnInitializeWindow(0);
 END {MD16E_OnInitializeWindow};

 PRIVATE PROCEDURE MD60E_OnInitializeWindow();
 BEGIN
  AnyMDoc_OnInitializeWindow(1);
 END {MD60E_OnInitializeWindow};

 PRIVATE PROCEDURE MD61E_OnInitializeWindow();
 BEGIN
  AnyMDoc_OnInitializeWindow(1);
  L_WDO.iMayBeEmpty  (0, ["MDoc.BoxNbr"]);

  AnyMDoc_SetFlagFirst(0);
  L_WDO.iField(0, ["MDoc.Dest"]).First:=1
 END {MD61E_OnInitializeWindow};

 PRIVATE PROCEDURE MD62E_OnInitializeWindow();
 BEGIN
  AnyMDoc_OnInitializeWindow(0);
 END {MD62E_OnInitializeWindow};

 PRIVATE PROCEDURE MD70E_OnInitializeWindow();
 BEGIN
  AnyMDoc_OnInitializeWindow(1);
 END {MD70E_OnInitializeWindow};

 PRIVATE PROCEDURE MD72E_OnInitializeWindow();
 BEGIN
  AnyMDoc_OnInitializeWindow(0);
 END {MD72E_OnInitializeWindow};

 PRIVATE PROCEDURE MD61EE_OnInitializeWindow();
 BEGIN
  L_WDO.iEvents      (0, [L_WDO.e_OnAnyModification, L_WDO.e_OnAfterDelete]);
  L_WDO.iField       (0, "MDocList.Math").OwnerWindowOriginalName:="Math";
  L_WDO.iField       (0, "MDocList.Math").OwnerZoneNumber:=1;
  L_WDO.iScsChange   (0, ["MDocList.Math", "MDocList.MMode"]);
 END {MD61EE_OnInitializeWindow};

 PUBLIC PROCEDURE Fill_P6025();
 BEGIN
  P_MDoc.SetDefault_PcBkData();
 END {Fill_P6025};

 PRIVATE PROCEDURE MDocPro_0_OnReposition();
 BEGIN
  CALL(ObjPro.UpdateCurObjectVal2Show("MDoc", "MDocPro"));
 END {MDocPro_0_OnReposition};

 PUBLIC PROCEDURE FillPartnerAgentAllData();
 BEGIN
  P_MDoc.pa_GetDataFromFirmPro(0);
 END {FillPartnerAgentAllData};

 PUBLIC PROCEDURE FillPartnerAgentDocGiveS();
 BEGIN
  P_MDoc.pa_GetDataFromFirmPro(1);
 END {FillPartnerAgentDocGiveS};

 PUBLIC PROCEDURE BuildVATMDocs();
 BEGIN
  L_MDoc.AccessMDoc();
  CheckVATMDocBuildByMDocAllowed();
  L_General.Assert(MDoc.Date < L_DatTim.Per(SYSDATE()),
                   "  ᯥ樠묨 㬥⠬   "+
                   "| ⮫쪮  襤訥 ਮ");
  L_Pmnt.Build_VATMDocs(0, L_Pmnt.sbvmd_Offline);
 END {BuildVATMDocs};

 PUBLIC PROCEDURE RemoveVATMDocs();
 BEGIN
  L_MDoc.AccessMDoc();
  CheckVATMDocBuildByMDocAllowed();
  L_Pmnt.RemoveGeneratedVATMDocs(L_Pmnt.sbvmd_Offline, L_XDoc.xdt_MDoc, MDoc.MDocKind, MDoc.MDoc);
 END {RemoveVATMDocs};

 PUBLIC PROCEDURE SingleRePrint_OtherForm();
 BEGIN
  L_MDoc.AccessMDoc();
  intPrint(0, 0, MDocP_MO.E_MDocP_MO_GetOtherFormFullTemplateName());
 END {SingleRePrint_OtherForm};

 PUBLIC PROCEDURE SinglePrePrint_OtherForm();
 BEGIN
  L_MDoc.AccessMDoc();
  intPrint(0, 1, MDocP_MO.E_MDocP_MO_GetOtherFormFullTemplateName());
 END {SinglePrePrint_OtherForm};

 PUBLIC PROCEDURE SingleSending_OtherForm();
 BEGIN
  L_MDoc.AccessMDoc();
  Send(0, MDocP_MO.E_MDocP_MO_GetOtherFormFullTemplateName());
 END {SingleSending_OtherForm};

 PUBLIC PROCEDURE ShowFollowingMDocs();
 BEGIN
  L_MDoc.AccessMDoc();
  L_MDoc.fmdc_CheckIsSignificantMDoc();
  L_MDoc.fmdc_Init();
  L_MDoc.fmdc_MakeList(0);
  L_MDoc.fmdc_Show();
 END {ShowFollowingMDocs};

 PUBLIC PROCEDURE ChangeOnDatePos();
 BEGIN
  L_MDoc.AccessMDoc();
  L_MDoc.fmdc_CheckIsSignificantMDoc();
  L_MDoc.fmdc_ChangeOnDatePos();
 END {ChangeOnDatePos};

 PRIVATE PROCEDURE intShowNeighborFollowingMDocs(Next: SCAL[2]);
  VAR
   ngbXDocId: L_XDoc.tXDocId;
   First    : SCAL[2];
 BEGIN
  L_MDoc.AccessMDoc();

  L_AFM.MakeIndex("_NgbM", "Date   : DATE;"+
                           "Queue  : "+GET_TYPE_SPEC(L_MDoc.fmdc_tQueue).Name+";"+
                           "DoneDTS: LIKE(MDoc.DoneDTS);"+
                           "XDocId :"+GET_TYPE_SPEC(L_XDoc.tXDocId).Name+";"+
                           "Math   : LIKE(Math.Math)");

  L_XDoc.sl_Init(L_Str.PoolItem("।騥|᫥騥", Next)+" ");
  SELECT(MDocList, MDLMath, , MDoc.MDocKind, MDoc.MDoc);
  WHILE OCCURE(MDocList) DO
   NARROWSEL(MDocList, Math);
   ngbXDocId:=L_MDoc.fmdc_GetNeighborMDoc(MDocList.Math, Next);
   IF ~!ngbXDocId THEN
    SAVE(MDoc);
    L_XDoc.PositionOnXDoc(ngbXDocId);
    ADD(_NgbM, _NgbM, , MDoc.Date, L_MDoc.fmdc_GetQueue(), MDoc.DoneDTS, MDoc.XDocId, MDocList.Math);
    RESTORE(MDoc);
   END;
   NEXTINEXTENDEDSEL(MDocList, Math);
  END; (* WHILE OCCURE(MDocList) *)

  SELECT(_NgbM, _NgbM);
  WHILE OCCURE(_NgbM) DO
   NARROWSEL(_NgbM, Date, Queue, DoneDTS, XDocId);
   L_XDoc.PositionOnXDoc(_NgbM.XDocId);
   First:=1;
   FOR_EACH _NgbM DO
    SEARCH(Math, Math, , _NgbM.Math);
    IF First THEN
     L_XDoc.sl_AddItem(_NgbM.XDocId, L_MDoc.GetMDocStrNbr()+" "+L_Str.PoolItem("-|",MDoc.Done)+" ("+L_Str.DTSStr(MDoc.DoneDTS)+"):   "+Math.Math+" "+Str.Align(Math.Name, 30, LEFT));
     First:=0;
    ELSE
     L_XDoc.sl_AddItem(_NgbM.XDocId, Str.Align('', 56, CENTRE)+" "+Math.Math+" "+Str.Align(Math.Name, 30, LEFT));
    END;
   END; (* FOR_EACH _NgbM *)
   NEXTINEXTENDEDSEL(_NgbM, Date, Queue, DoneDTS, XDocId)
  END; (* WHILE OCCURE(_NgbM) *)

  L_XDoc.sl_Show();
  L_XDoc.PositionInVideoSystem(L_XDoc.pm_StandOnly, L_XDoc.pvs_XDocId, "");
 END {intShowNeighborFollowingMDocs};

 PUBLIC PROCEDURE ShowNextFollowingMDocs();
 BEGIN
  intShowNeighborFollowingMDocs(1);
 END {ShowNextFollowingMDocs};

 PUBLIC PROCEDURE ShowPrevFollowingMDocs();
 BEGIN
  intShowNeighborFollowingMDocs(0);
 END {ShowPrevFollowingMDocs};

BEGIN
 IF    L_Events.IsInternalEvents(MODE) THEN
  ^(L_Events.GetInternalEventHandlerName(MODE))();
 ELSIF L_Events.IsSubWinEvents(MODE) THEN
  MDoc_OnSubWinEvents();
 ELSE
  L_MDoc.AccessMDoc();
  IF    (MODE = 142) THEN
   PrintAuthority(1);
  ELSIF (MODE = 143) THEN
   PrintAuthority(0);
  ELSIF (MODE = 152) THEN (*   㬥 ॣ    ⢨ "⠭" *)
   cu_AutoAssign_GetFree(0);
  ELSIF (MODE = 153) THEN (* ନ   ॣ⮢    㬥  ⢨ "ਥ" *)
   cu_AutoAssign_GetNew(L_CUC.ok_Accpt);
  ELSIF (MODE = 154) THEN (* ନ   ॣ⮢    㬥  ⢨ "" *)
   cu_AutoAssign_GetNew(L_CUC.ok_Fixup);
  ELSIF (MODE = 155) THEN (*   㬥 ॣ    ⢨ "⠭" *)
   cu_AutoAssign_GetFixed();
  ELSIF MODE = 183 THEN
   IF RTI.Get().CurZone.Fields("MDoc.SrcNbr").Modifiable THEN
    IF ~!MDoc.SrcNbr & (MDoc.SrcNbr # SrcNbr_Without) THEN
     L_StdFrm.Choice("室  㦥 . ⢨⥫쭮 ' '?");
    END;
    MDoc.SrcNbr:=SrcNbr_Without;
    REPLACE(MDoc);
   ELSE
    L_General.Error("室    䨪樨");
   END;
  ELSIF MODE = 184 THEN
   IF RTI.Get().CurZone.Fields("MDoc.SrcNbr").Modifiable THEN
    IF ~!MDoc.SrcNbr & (MDoc.SrcNbr # SrcNbr_Order) THEN
     L_StdFrm.Choice("室  㦥 . ⢨⥫쭮 ''?");
    END;
    MDoc.SrcNbr:=SrcNbr_Order;
    REPLACE(MDoc);
   ELSE
    L_General.Error("室    䨪樨");
   END;
  ELSIF MODE = 191 THEN
   intCopyMDocList(L_XDoc.ref_XDocId, L_XDoc.curXDocId(L_XDoc.xdt_MDoc));
  ELSIF MODE = 192 THEN
   L_XDoc.DoByBarCode("롮  ", PROCREF(FillMDocCUCopy), 1);
  ELSIF MODE = 193 THEN
   intShareExtraCharge("業", L_XDoc.ref_XDocId, L_XDoc.curXDocId(L_XDoc.xdt_MDoc));
  ELSE
   L_General.BadMode(MODE);
  END;
 END;
END.
